// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2020 The go-netbox Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package dcim

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewDcimInterfacesListParams creates a new DcimInterfacesListParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDcimInterfacesListParams() *DcimInterfacesListParams {
	return &DcimInterfacesListParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDcimInterfacesListParamsWithTimeout creates a new DcimInterfacesListParams object
// with the ability to set a timeout on a request.
func NewDcimInterfacesListParamsWithTimeout(timeout time.Duration) *DcimInterfacesListParams {
	return &DcimInterfacesListParams{
		timeout: timeout,
	}
}

// NewDcimInterfacesListParamsWithContext creates a new DcimInterfacesListParams object
// with the ability to set a context for a request.
func NewDcimInterfacesListParamsWithContext(ctx context.Context) *DcimInterfacesListParams {
	return &DcimInterfacesListParams{
		Context: ctx,
	}
}

// NewDcimInterfacesListParamsWithHTTPClient creates a new DcimInterfacesListParams object
// with the ability to set a custom HTTPClient for a request.
func NewDcimInterfacesListParamsWithHTTPClient(client *http.Client) *DcimInterfacesListParams {
	return &DcimInterfacesListParams{
		HTTPClient: client,
	}
}

/* DcimInterfacesListParams contains all the parameters to send to the API endpoint
   for the dcim interfaces list operation.

   Typically these are written to a http.Request.
*/
type DcimInterfacesListParams struct {

	// BridgeID.
	BridgeID *string

	// BridgeIDn.
	BridgeIDn *string

	// Cabled.
	Cabled *string

	// Connected.
	Connected *string

	// Created.
	Created *string

	// CreatedGte.
	CreatedGte *string

	// CreatedLte.
	CreatedLte *string

	// Description.
	Description *string

	// DescriptionIc.
	DescriptionIc *string

	// DescriptionIe.
	DescriptionIe *string

	// DescriptionIew.
	DescriptionIew *string

	// DescriptionIsw.
	DescriptionIsw *string

	// Descriptionn.
	Descriptionn *string

	// DescriptionNic.
	DescriptionNic *string

	// DescriptionNie.
	DescriptionNie *string

	// DescriptionNiew.
	DescriptionNiew *string

	// DescriptionNisw.
	DescriptionNisw *string

	// Device.
	Device *string

	// DeviceID.
	DeviceID *string

	// Duplex.
	Duplex *string

	// Duplexn.
	Duplexn *string

	// Enabled.
	Enabled *string

	// ID.
	ID *string

	// IDGt.
	IDGt *string

	// IDGte.
	IDGte *string

	// IDLt.
	IDLt *string

	// IDLte.
	IDLte *string

	// IDn.
	IDn *string

	// Kind.
	Kind *string

	// Label.
	Label *string

	// LabelIc.
	LabelIc *string

	// LabelIe.
	LabelIe *string

	// LabelIew.
	LabelIew *string

	// LabelIsw.
	LabelIsw *string

	// Labeln.
	Labeln *string

	// LabelNic.
	LabelNic *string

	// LabelNie.
	LabelNie *string

	// LabelNiew.
	LabelNiew *string

	// LabelNisw.
	LabelNisw *string

	// LagID.
	LagID *string

	// LagIDn.
	LagIDn *string

	// LastUpdated.
	LastUpdated *string

	// LastUpdatedGte.
	LastUpdatedGte *string

	// LastUpdatedLte.
	LastUpdatedLte *string

	/* Limit.

	   Number of results to return per page.
	*/
	Limit *int64

	// Location.
	Location *string

	// Locationn.
	Locationn *string

	// LocationID.
	LocationID *string

	// LocationIDn.
	LocationIDn *string

	// MacAddress.
	MacAddress *string

	// MacAddressIc.
	MacAddressIc *string

	// MacAddressIe.
	MacAddressIe *string

	// MacAddressIew.
	MacAddressIew *string

	// MacAddressIsw.
	MacAddressIsw *string

	// MacAddressn.
	MacAddressn *string

	// MacAddressNic.
	MacAddressNic *string

	// MacAddressNie.
	MacAddressNie *string

	// MacAddressNiew.
	MacAddressNiew *string

	// MacAddressNisw.
	MacAddressNisw *string

	// MgmtOnly.
	MgmtOnly *string

	// Mode.
	Mode *string

	// Moden.
	Moden *string

	// ModuleID.
	ModuleID *string

	// ModuleIDn.
	ModuleIDn *string

	// Mtu.
	Mtu *string

	// MtuGt.
	MtuGt *string

	// MtuGte.
	MtuGte *string

	// MtuLt.
	MtuLt *string

	// MtuLte.
	MtuLte *string

	// Mtun.
	Mtun *string

	// Name.
	Name *string

	// NameIc.
	NameIc *string

	// NameIe.
	NameIe *string

	// NameIew.
	NameIew *string

	// NameIsw.
	NameIsw *string

	// Namen.
	Namen *string

	// NameNic.
	NameNic *string

	// NameNie.
	NameNie *string

	// NameNiew.
	NameNiew *string

	// NameNisw.
	NameNisw *string

	/* Offset.

	   The initial index from which to return the results.
	*/
	Offset *int64

	// ParentID.
	ParentID *string

	// ParentIDn.
	ParentIDn *string

	// Q.
	Q *string

	// Region.
	Region *string

	// Regionn.
	Regionn *string

	// RegionID.
	RegionID *string

	// RegionIDn.
	RegionIDn *string

	// RfChannel.
	RfChannel *string

	// RfChanneln.
	RfChanneln *string

	// RfChannelFrequency.
	RfChannelFrequency *string

	// RfChannelFrequencyGt.
	RfChannelFrequencyGt *string

	// RfChannelFrequencyGte.
	RfChannelFrequencyGte *string

	// RfChannelFrequencyLt.
	RfChannelFrequencyLt *string

	// RfChannelFrequencyLte.
	RfChannelFrequencyLte *string

	// RfChannelFrequencyn.
	RfChannelFrequencyn *string

	// RfChannelWidth.
	RfChannelWidth *string

	// RfChannelWidthGt.
	RfChannelWidthGt *string

	// RfChannelWidthGte.
	RfChannelWidthGte *string

	// RfChannelWidthLt.
	RfChannelWidthLt *string

	// RfChannelWidthLte.
	RfChannelWidthLte *string

	// RfChannelWidthn.
	RfChannelWidthn *string

	// RfRole.
	RfRole *string

	// RfRolen.
	RfRolen *string

	// Site.
	Site *string

	// Siten.
	Siten *string

	// SiteGroup.
	SiteGroup *string

	// SiteGroupn.
	SiteGroupn *string

	// SiteGroupID.
	SiteGroupID *string

	// SiteGroupIDn.
	SiteGroupIDn *string

	// SiteID.
	SiteID *string

	// SiteIDn.
	SiteIDn *string

	// Speed.
	Speed *string

	// SpeedGt.
	SpeedGt *string

	// SpeedGte.
	SpeedGte *string

	// SpeedLt.
	SpeedLt *string

	// SpeedLte.
	SpeedLte *string

	// Speedn.
	Speedn *string

	// Tag.
	Tag *string

	// Tagn.
	Tagn *string

	// TxPower.
	TxPower *string

	// TxPowerGt.
	TxPowerGt *string

	// TxPowerGte.
	TxPowerGte *string

	// TxPowerLt.
	TxPowerLt *string

	// TxPowerLte.
	TxPowerLte *string

	// TxPowern.
	TxPowern *string

	// Type.
	Type *string

	// Typen.
	Typen *string

	// VirtualChassis.
	VirtualChassis *string

	// VirtualChassisn.
	VirtualChassisn *string

	// VirtualChassisID.
	VirtualChassisID *string

	// VirtualChassisIDn.
	VirtualChassisIDn *string

	// Vlan.
	Vlan *string

	// VlanID.
	VlanID *string

	// Vrf.
	Vrf *string

	// Vrfn.
	Vrfn *string

	// VrfID.
	VrfID *string

	// VrfIDn.
	VrfIDn *string

	// Wwn.
	Wwn *string

	// WwnIc.
	WwnIc *string

	// WwnIe.
	WwnIe *string

	// WwnIew.
	WwnIew *string

	// WwnIsw.
	WwnIsw *string

	// Wwnn.
	Wwnn *string

	// WwnNic.
	WwnNic *string

	// WwnNie.
	WwnNie *string

	// WwnNiew.
	WwnNiew *string

	// WwnNisw.
	WwnNisw *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the dcim interfaces list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DcimInterfacesListParams) WithDefaults() *DcimInterfacesListParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the dcim interfaces list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DcimInterfacesListParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithTimeout(timeout time.Duration) *DcimInterfacesListParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithContext(ctx context.Context) *DcimInterfacesListParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithHTTPClient(client *http.Client) *DcimInterfacesListParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBridgeID adds the bridgeID to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithBridgeID(bridgeID *string) *DcimInterfacesListParams {
	o.SetBridgeID(bridgeID)
	return o
}

// SetBridgeID adds the bridgeId to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetBridgeID(bridgeID *string) {
	o.BridgeID = bridgeID
}

// WithBridgeIDn adds the bridgeIDn to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithBridgeIDn(bridgeIDn *string) *DcimInterfacesListParams {
	o.SetBridgeIDn(bridgeIDn)
	return o
}

// SetBridgeIDn adds the bridgeIdN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetBridgeIDn(bridgeIDn *string) {
	o.BridgeIDn = bridgeIDn
}

// WithCabled adds the cabled to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithCabled(cabled *string) *DcimInterfacesListParams {
	o.SetCabled(cabled)
	return o
}

// SetCabled adds the cabled to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetCabled(cabled *string) {
	o.Cabled = cabled
}

// WithConnected adds the connected to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithConnected(connected *string) *DcimInterfacesListParams {
	o.SetConnected(connected)
	return o
}

// SetConnected adds the connected to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetConnected(connected *string) {
	o.Connected = connected
}

// WithCreated adds the created to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithCreated(created *string) *DcimInterfacesListParams {
	o.SetCreated(created)
	return o
}

// SetCreated adds the created to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetCreated(created *string) {
	o.Created = created
}

// WithCreatedGte adds the createdGte to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithCreatedGte(createdGte *string) *DcimInterfacesListParams {
	o.SetCreatedGte(createdGte)
	return o
}

// SetCreatedGte adds the createdGte to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetCreatedGte(createdGte *string) {
	o.CreatedGte = createdGte
}

// WithCreatedLte adds the createdLte to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithCreatedLte(createdLte *string) *DcimInterfacesListParams {
	o.SetCreatedLte(createdLte)
	return o
}

// SetCreatedLte adds the createdLte to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetCreatedLte(createdLte *string) {
	o.CreatedLte = createdLte
}

// WithDescription adds the description to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithDescription(description *string) *DcimInterfacesListParams {
	o.SetDescription(description)
	return o
}

// SetDescription adds the description to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetDescription(description *string) {
	o.Description = description
}

// WithDescriptionIc adds the descriptionIc to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithDescriptionIc(descriptionIc *string) *DcimInterfacesListParams {
	o.SetDescriptionIc(descriptionIc)
	return o
}

// SetDescriptionIc adds the descriptionIc to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetDescriptionIc(descriptionIc *string) {
	o.DescriptionIc = descriptionIc
}

// WithDescriptionIe adds the descriptionIe to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithDescriptionIe(descriptionIe *string) *DcimInterfacesListParams {
	o.SetDescriptionIe(descriptionIe)
	return o
}

// SetDescriptionIe adds the descriptionIe to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetDescriptionIe(descriptionIe *string) {
	o.DescriptionIe = descriptionIe
}

// WithDescriptionIew adds the descriptionIew to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithDescriptionIew(descriptionIew *string) *DcimInterfacesListParams {
	o.SetDescriptionIew(descriptionIew)
	return o
}

// SetDescriptionIew adds the descriptionIew to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetDescriptionIew(descriptionIew *string) {
	o.DescriptionIew = descriptionIew
}

// WithDescriptionIsw adds the descriptionIsw to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithDescriptionIsw(descriptionIsw *string) *DcimInterfacesListParams {
	o.SetDescriptionIsw(descriptionIsw)
	return o
}

// SetDescriptionIsw adds the descriptionIsw to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetDescriptionIsw(descriptionIsw *string) {
	o.DescriptionIsw = descriptionIsw
}

// WithDescriptionn adds the descriptionn to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithDescriptionn(descriptionn *string) *DcimInterfacesListParams {
	o.SetDescriptionn(descriptionn)
	return o
}

// SetDescriptionn adds the descriptionN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetDescriptionn(descriptionn *string) {
	o.Descriptionn = descriptionn
}

// WithDescriptionNic adds the descriptionNic to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithDescriptionNic(descriptionNic *string) *DcimInterfacesListParams {
	o.SetDescriptionNic(descriptionNic)
	return o
}

// SetDescriptionNic adds the descriptionNic to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetDescriptionNic(descriptionNic *string) {
	o.DescriptionNic = descriptionNic
}

// WithDescriptionNie adds the descriptionNie to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithDescriptionNie(descriptionNie *string) *DcimInterfacesListParams {
	o.SetDescriptionNie(descriptionNie)
	return o
}

// SetDescriptionNie adds the descriptionNie to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetDescriptionNie(descriptionNie *string) {
	o.DescriptionNie = descriptionNie
}

// WithDescriptionNiew adds the descriptionNiew to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithDescriptionNiew(descriptionNiew *string) *DcimInterfacesListParams {
	o.SetDescriptionNiew(descriptionNiew)
	return o
}

// SetDescriptionNiew adds the descriptionNiew to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetDescriptionNiew(descriptionNiew *string) {
	o.DescriptionNiew = descriptionNiew
}

// WithDescriptionNisw adds the descriptionNisw to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithDescriptionNisw(descriptionNisw *string) *DcimInterfacesListParams {
	o.SetDescriptionNisw(descriptionNisw)
	return o
}

// SetDescriptionNisw adds the descriptionNisw to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetDescriptionNisw(descriptionNisw *string) {
	o.DescriptionNisw = descriptionNisw
}

// WithDevice adds the device to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithDevice(device *string) *DcimInterfacesListParams {
	o.SetDevice(device)
	return o
}

// SetDevice adds the device to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetDevice(device *string) {
	o.Device = device
}

// WithDeviceID adds the deviceID to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithDeviceID(deviceID *string) *DcimInterfacesListParams {
	o.SetDeviceID(deviceID)
	return o
}

// SetDeviceID adds the deviceId to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetDeviceID(deviceID *string) {
	o.DeviceID = deviceID
}

// WithDuplex adds the duplex to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithDuplex(duplex *string) *DcimInterfacesListParams {
	o.SetDuplex(duplex)
	return o
}

// SetDuplex adds the duplex to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetDuplex(duplex *string) {
	o.Duplex = duplex
}

// WithDuplexn adds the duplexn to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithDuplexn(duplexn *string) *DcimInterfacesListParams {
	o.SetDuplexn(duplexn)
	return o
}

// SetDuplexn adds the duplexN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetDuplexn(duplexn *string) {
	o.Duplexn = duplexn
}

// WithEnabled adds the enabled to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithEnabled(enabled *string) *DcimInterfacesListParams {
	o.SetEnabled(enabled)
	return o
}

// SetEnabled adds the enabled to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetEnabled(enabled *string) {
	o.Enabled = enabled
}

// WithID adds the id to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithID(id *string) *DcimInterfacesListParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetID(id *string) {
	o.ID = id
}

// WithIDGt adds the iDGt to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithIDGt(iDGt *string) *DcimInterfacesListParams {
	o.SetIDGt(iDGt)
	return o
}

// SetIDGt adds the idGt to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetIDGt(iDGt *string) {
	o.IDGt = iDGt
}

// WithIDGte adds the iDGte to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithIDGte(iDGte *string) *DcimInterfacesListParams {
	o.SetIDGte(iDGte)
	return o
}

// SetIDGte adds the idGte to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetIDGte(iDGte *string) {
	o.IDGte = iDGte
}

// WithIDLt adds the iDLt to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithIDLt(iDLt *string) *DcimInterfacesListParams {
	o.SetIDLt(iDLt)
	return o
}

// SetIDLt adds the idLt to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetIDLt(iDLt *string) {
	o.IDLt = iDLt
}

// WithIDLte adds the iDLte to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithIDLte(iDLte *string) *DcimInterfacesListParams {
	o.SetIDLte(iDLte)
	return o
}

// SetIDLte adds the idLte to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetIDLte(iDLte *string) {
	o.IDLte = iDLte
}

// WithIDn adds the iDn to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithIDn(iDn *string) *DcimInterfacesListParams {
	o.SetIDn(iDn)
	return o
}

// SetIDn adds the idN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetIDn(iDn *string) {
	o.IDn = iDn
}

// WithKind adds the kind to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithKind(kind *string) *DcimInterfacesListParams {
	o.SetKind(kind)
	return o
}

// SetKind adds the kind to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetKind(kind *string) {
	o.Kind = kind
}

// WithLabel adds the label to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithLabel(label *string) *DcimInterfacesListParams {
	o.SetLabel(label)
	return o
}

// SetLabel adds the label to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetLabel(label *string) {
	o.Label = label
}

// WithLabelIc adds the labelIc to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithLabelIc(labelIc *string) *DcimInterfacesListParams {
	o.SetLabelIc(labelIc)
	return o
}

// SetLabelIc adds the labelIc to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetLabelIc(labelIc *string) {
	o.LabelIc = labelIc
}

// WithLabelIe adds the labelIe to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithLabelIe(labelIe *string) *DcimInterfacesListParams {
	o.SetLabelIe(labelIe)
	return o
}

// SetLabelIe adds the labelIe to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetLabelIe(labelIe *string) {
	o.LabelIe = labelIe
}

// WithLabelIew adds the labelIew to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithLabelIew(labelIew *string) *DcimInterfacesListParams {
	o.SetLabelIew(labelIew)
	return o
}

// SetLabelIew adds the labelIew to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetLabelIew(labelIew *string) {
	o.LabelIew = labelIew
}

// WithLabelIsw adds the labelIsw to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithLabelIsw(labelIsw *string) *DcimInterfacesListParams {
	o.SetLabelIsw(labelIsw)
	return o
}

// SetLabelIsw adds the labelIsw to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetLabelIsw(labelIsw *string) {
	o.LabelIsw = labelIsw
}

// WithLabeln adds the labeln to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithLabeln(labeln *string) *DcimInterfacesListParams {
	o.SetLabeln(labeln)
	return o
}

// SetLabeln adds the labelN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetLabeln(labeln *string) {
	o.Labeln = labeln
}

// WithLabelNic adds the labelNic to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithLabelNic(labelNic *string) *DcimInterfacesListParams {
	o.SetLabelNic(labelNic)
	return o
}

// SetLabelNic adds the labelNic to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetLabelNic(labelNic *string) {
	o.LabelNic = labelNic
}

// WithLabelNie adds the labelNie to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithLabelNie(labelNie *string) *DcimInterfacesListParams {
	o.SetLabelNie(labelNie)
	return o
}

// SetLabelNie adds the labelNie to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetLabelNie(labelNie *string) {
	o.LabelNie = labelNie
}

// WithLabelNiew adds the labelNiew to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithLabelNiew(labelNiew *string) *DcimInterfacesListParams {
	o.SetLabelNiew(labelNiew)
	return o
}

// SetLabelNiew adds the labelNiew to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetLabelNiew(labelNiew *string) {
	o.LabelNiew = labelNiew
}

// WithLabelNisw adds the labelNisw to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithLabelNisw(labelNisw *string) *DcimInterfacesListParams {
	o.SetLabelNisw(labelNisw)
	return o
}

// SetLabelNisw adds the labelNisw to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetLabelNisw(labelNisw *string) {
	o.LabelNisw = labelNisw
}

// WithLagID adds the lagID to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithLagID(lagID *string) *DcimInterfacesListParams {
	o.SetLagID(lagID)
	return o
}

// SetLagID adds the lagId to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetLagID(lagID *string) {
	o.LagID = lagID
}

// WithLagIDn adds the lagIDn to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithLagIDn(lagIDn *string) *DcimInterfacesListParams {
	o.SetLagIDn(lagIDn)
	return o
}

// SetLagIDn adds the lagIdN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetLagIDn(lagIDn *string) {
	o.LagIDn = lagIDn
}

// WithLastUpdated adds the lastUpdated to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithLastUpdated(lastUpdated *string) *DcimInterfacesListParams {
	o.SetLastUpdated(lastUpdated)
	return o
}

// SetLastUpdated adds the lastUpdated to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetLastUpdated(lastUpdated *string) {
	o.LastUpdated = lastUpdated
}

// WithLastUpdatedGte adds the lastUpdatedGte to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithLastUpdatedGte(lastUpdatedGte *string) *DcimInterfacesListParams {
	o.SetLastUpdatedGte(lastUpdatedGte)
	return o
}

// SetLastUpdatedGte adds the lastUpdatedGte to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetLastUpdatedGte(lastUpdatedGte *string) {
	o.LastUpdatedGte = lastUpdatedGte
}

// WithLastUpdatedLte adds the lastUpdatedLte to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithLastUpdatedLte(lastUpdatedLte *string) *DcimInterfacesListParams {
	o.SetLastUpdatedLte(lastUpdatedLte)
	return o
}

// SetLastUpdatedLte adds the lastUpdatedLte to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetLastUpdatedLte(lastUpdatedLte *string) {
	o.LastUpdatedLte = lastUpdatedLte
}

// WithLimit adds the limit to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithLimit(limit *int64) *DcimInterfacesListParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithLocation adds the location to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithLocation(location *string) *DcimInterfacesListParams {
	o.SetLocation(location)
	return o
}

// SetLocation adds the location to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetLocation(location *string) {
	o.Location = location
}

// WithLocationn adds the locationn to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithLocationn(locationn *string) *DcimInterfacesListParams {
	o.SetLocationn(locationn)
	return o
}

// SetLocationn adds the locationN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetLocationn(locationn *string) {
	o.Locationn = locationn
}

// WithLocationID adds the locationID to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithLocationID(locationID *string) *DcimInterfacesListParams {
	o.SetLocationID(locationID)
	return o
}

// SetLocationID adds the locationId to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetLocationID(locationID *string) {
	o.LocationID = locationID
}

// WithLocationIDn adds the locationIDn to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithLocationIDn(locationIDn *string) *DcimInterfacesListParams {
	o.SetLocationIDn(locationIDn)
	return o
}

// SetLocationIDn adds the locationIdN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetLocationIDn(locationIDn *string) {
	o.LocationIDn = locationIDn
}

// WithMacAddress adds the macAddress to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithMacAddress(macAddress *string) *DcimInterfacesListParams {
	o.SetMacAddress(macAddress)
	return o
}

// SetMacAddress adds the macAddress to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetMacAddress(macAddress *string) {
	o.MacAddress = macAddress
}

// WithMacAddressIc adds the macAddressIc to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithMacAddressIc(macAddressIc *string) *DcimInterfacesListParams {
	o.SetMacAddressIc(macAddressIc)
	return o
}

// SetMacAddressIc adds the macAddressIc to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetMacAddressIc(macAddressIc *string) {
	o.MacAddressIc = macAddressIc
}

// WithMacAddressIe adds the macAddressIe to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithMacAddressIe(macAddressIe *string) *DcimInterfacesListParams {
	o.SetMacAddressIe(macAddressIe)
	return o
}

// SetMacAddressIe adds the macAddressIe to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetMacAddressIe(macAddressIe *string) {
	o.MacAddressIe = macAddressIe
}

// WithMacAddressIew adds the macAddressIew to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithMacAddressIew(macAddressIew *string) *DcimInterfacesListParams {
	o.SetMacAddressIew(macAddressIew)
	return o
}

// SetMacAddressIew adds the macAddressIew to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetMacAddressIew(macAddressIew *string) {
	o.MacAddressIew = macAddressIew
}

// WithMacAddressIsw adds the macAddressIsw to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithMacAddressIsw(macAddressIsw *string) *DcimInterfacesListParams {
	o.SetMacAddressIsw(macAddressIsw)
	return o
}

// SetMacAddressIsw adds the macAddressIsw to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetMacAddressIsw(macAddressIsw *string) {
	o.MacAddressIsw = macAddressIsw
}

// WithMacAddressn adds the macAddressn to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithMacAddressn(macAddressn *string) *DcimInterfacesListParams {
	o.SetMacAddressn(macAddressn)
	return o
}

// SetMacAddressn adds the macAddressN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetMacAddressn(macAddressn *string) {
	o.MacAddressn = macAddressn
}

// WithMacAddressNic adds the macAddressNic to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithMacAddressNic(macAddressNic *string) *DcimInterfacesListParams {
	o.SetMacAddressNic(macAddressNic)
	return o
}

// SetMacAddressNic adds the macAddressNic to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetMacAddressNic(macAddressNic *string) {
	o.MacAddressNic = macAddressNic
}

// WithMacAddressNie adds the macAddressNie to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithMacAddressNie(macAddressNie *string) *DcimInterfacesListParams {
	o.SetMacAddressNie(macAddressNie)
	return o
}

// SetMacAddressNie adds the macAddressNie to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetMacAddressNie(macAddressNie *string) {
	o.MacAddressNie = macAddressNie
}

// WithMacAddressNiew adds the macAddressNiew to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithMacAddressNiew(macAddressNiew *string) *DcimInterfacesListParams {
	o.SetMacAddressNiew(macAddressNiew)
	return o
}

// SetMacAddressNiew adds the macAddressNiew to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetMacAddressNiew(macAddressNiew *string) {
	o.MacAddressNiew = macAddressNiew
}

// WithMacAddressNisw adds the macAddressNisw to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithMacAddressNisw(macAddressNisw *string) *DcimInterfacesListParams {
	o.SetMacAddressNisw(macAddressNisw)
	return o
}

// SetMacAddressNisw adds the macAddressNisw to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetMacAddressNisw(macAddressNisw *string) {
	o.MacAddressNisw = macAddressNisw
}

// WithMgmtOnly adds the mgmtOnly to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithMgmtOnly(mgmtOnly *string) *DcimInterfacesListParams {
	o.SetMgmtOnly(mgmtOnly)
	return o
}

// SetMgmtOnly adds the mgmtOnly to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetMgmtOnly(mgmtOnly *string) {
	o.MgmtOnly = mgmtOnly
}

// WithMode adds the mode to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithMode(mode *string) *DcimInterfacesListParams {
	o.SetMode(mode)
	return o
}

// SetMode adds the mode to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetMode(mode *string) {
	o.Mode = mode
}

// WithModen adds the moden to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithModen(moden *string) *DcimInterfacesListParams {
	o.SetModen(moden)
	return o
}

// SetModen adds the modeN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetModen(moden *string) {
	o.Moden = moden
}

// WithModuleID adds the moduleID to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithModuleID(moduleID *string) *DcimInterfacesListParams {
	o.SetModuleID(moduleID)
	return o
}

// SetModuleID adds the moduleId to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetModuleID(moduleID *string) {
	o.ModuleID = moduleID
}

// WithModuleIDn adds the moduleIDn to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithModuleIDn(moduleIDn *string) *DcimInterfacesListParams {
	o.SetModuleIDn(moduleIDn)
	return o
}

// SetModuleIDn adds the moduleIdN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetModuleIDn(moduleIDn *string) {
	o.ModuleIDn = moduleIDn
}

// WithMtu adds the mtu to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithMtu(mtu *string) *DcimInterfacesListParams {
	o.SetMtu(mtu)
	return o
}

// SetMtu adds the mtu to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetMtu(mtu *string) {
	o.Mtu = mtu
}

// WithMtuGt adds the mtuGt to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithMtuGt(mtuGt *string) *DcimInterfacesListParams {
	o.SetMtuGt(mtuGt)
	return o
}

// SetMtuGt adds the mtuGt to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetMtuGt(mtuGt *string) {
	o.MtuGt = mtuGt
}

// WithMtuGte adds the mtuGte to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithMtuGte(mtuGte *string) *DcimInterfacesListParams {
	o.SetMtuGte(mtuGte)
	return o
}

// SetMtuGte adds the mtuGte to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetMtuGte(mtuGte *string) {
	o.MtuGte = mtuGte
}

// WithMtuLt adds the mtuLt to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithMtuLt(mtuLt *string) *DcimInterfacesListParams {
	o.SetMtuLt(mtuLt)
	return o
}

// SetMtuLt adds the mtuLt to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetMtuLt(mtuLt *string) {
	o.MtuLt = mtuLt
}

// WithMtuLte adds the mtuLte to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithMtuLte(mtuLte *string) *DcimInterfacesListParams {
	o.SetMtuLte(mtuLte)
	return o
}

// SetMtuLte adds the mtuLte to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetMtuLte(mtuLte *string) {
	o.MtuLte = mtuLte
}

// WithMtun adds the mtun to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithMtun(mtun *string) *DcimInterfacesListParams {
	o.SetMtun(mtun)
	return o
}

// SetMtun adds the mtuN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetMtun(mtun *string) {
	o.Mtun = mtun
}

// WithName adds the name to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithName(name *string) *DcimInterfacesListParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetName(name *string) {
	o.Name = name
}

// WithNameIc adds the nameIc to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithNameIc(nameIc *string) *DcimInterfacesListParams {
	o.SetNameIc(nameIc)
	return o
}

// SetNameIc adds the nameIc to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetNameIc(nameIc *string) {
	o.NameIc = nameIc
}

// WithNameIe adds the nameIe to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithNameIe(nameIe *string) *DcimInterfacesListParams {
	o.SetNameIe(nameIe)
	return o
}

// SetNameIe adds the nameIe to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetNameIe(nameIe *string) {
	o.NameIe = nameIe
}

// WithNameIew adds the nameIew to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithNameIew(nameIew *string) *DcimInterfacesListParams {
	o.SetNameIew(nameIew)
	return o
}

// SetNameIew adds the nameIew to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetNameIew(nameIew *string) {
	o.NameIew = nameIew
}

// WithNameIsw adds the nameIsw to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithNameIsw(nameIsw *string) *DcimInterfacesListParams {
	o.SetNameIsw(nameIsw)
	return o
}

// SetNameIsw adds the nameIsw to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetNameIsw(nameIsw *string) {
	o.NameIsw = nameIsw
}

// WithNamen adds the namen to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithNamen(namen *string) *DcimInterfacesListParams {
	o.SetNamen(namen)
	return o
}

// SetNamen adds the nameN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetNamen(namen *string) {
	o.Namen = namen
}

// WithNameNic adds the nameNic to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithNameNic(nameNic *string) *DcimInterfacesListParams {
	o.SetNameNic(nameNic)
	return o
}

// SetNameNic adds the nameNic to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetNameNic(nameNic *string) {
	o.NameNic = nameNic
}

// WithNameNie adds the nameNie to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithNameNie(nameNie *string) *DcimInterfacesListParams {
	o.SetNameNie(nameNie)
	return o
}

// SetNameNie adds the nameNie to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetNameNie(nameNie *string) {
	o.NameNie = nameNie
}

// WithNameNiew adds the nameNiew to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithNameNiew(nameNiew *string) *DcimInterfacesListParams {
	o.SetNameNiew(nameNiew)
	return o
}

// SetNameNiew adds the nameNiew to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetNameNiew(nameNiew *string) {
	o.NameNiew = nameNiew
}

// WithNameNisw adds the nameNisw to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithNameNisw(nameNisw *string) *DcimInterfacesListParams {
	o.SetNameNisw(nameNisw)
	return o
}

// SetNameNisw adds the nameNisw to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetNameNisw(nameNisw *string) {
	o.NameNisw = nameNisw
}

// WithOffset adds the offset to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithOffset(offset *int64) *DcimInterfacesListParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithParentID adds the parentID to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithParentID(parentID *string) *DcimInterfacesListParams {
	o.SetParentID(parentID)
	return o
}

// SetParentID adds the parentId to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetParentID(parentID *string) {
	o.ParentID = parentID
}

// WithParentIDn adds the parentIDn to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithParentIDn(parentIDn *string) *DcimInterfacesListParams {
	o.SetParentIDn(parentIDn)
	return o
}

// SetParentIDn adds the parentIdN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetParentIDn(parentIDn *string) {
	o.ParentIDn = parentIDn
}

// WithQ adds the q to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithQ(q *string) *DcimInterfacesListParams {
	o.SetQ(q)
	return o
}

// SetQ adds the q to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetQ(q *string) {
	o.Q = q
}

// WithRegion adds the region to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithRegion(region *string) *DcimInterfacesListParams {
	o.SetRegion(region)
	return o
}

// SetRegion adds the region to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetRegion(region *string) {
	o.Region = region
}

// WithRegionn adds the regionn to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithRegionn(regionn *string) *DcimInterfacesListParams {
	o.SetRegionn(regionn)
	return o
}

// SetRegionn adds the regionN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetRegionn(regionn *string) {
	o.Regionn = regionn
}

// WithRegionID adds the regionID to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithRegionID(regionID *string) *DcimInterfacesListParams {
	o.SetRegionID(regionID)
	return o
}

// SetRegionID adds the regionId to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetRegionID(regionID *string) {
	o.RegionID = regionID
}

// WithRegionIDn adds the regionIDn to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithRegionIDn(regionIDn *string) *DcimInterfacesListParams {
	o.SetRegionIDn(regionIDn)
	return o
}

// SetRegionIDn adds the regionIdN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetRegionIDn(regionIDn *string) {
	o.RegionIDn = regionIDn
}

// WithRfChannel adds the rfChannel to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithRfChannel(rfChannel *string) *DcimInterfacesListParams {
	o.SetRfChannel(rfChannel)
	return o
}

// SetRfChannel adds the rfChannel to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetRfChannel(rfChannel *string) {
	o.RfChannel = rfChannel
}

// WithRfChanneln adds the rfChanneln to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithRfChanneln(rfChanneln *string) *DcimInterfacesListParams {
	o.SetRfChanneln(rfChanneln)
	return o
}

// SetRfChanneln adds the rfChannelN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetRfChanneln(rfChanneln *string) {
	o.RfChanneln = rfChanneln
}

// WithRfChannelFrequency adds the rfChannelFrequency to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithRfChannelFrequency(rfChannelFrequency *string) *DcimInterfacesListParams {
	o.SetRfChannelFrequency(rfChannelFrequency)
	return o
}

// SetRfChannelFrequency adds the rfChannelFrequency to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetRfChannelFrequency(rfChannelFrequency *string) {
	o.RfChannelFrequency = rfChannelFrequency
}

// WithRfChannelFrequencyGt adds the rfChannelFrequencyGt to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithRfChannelFrequencyGt(rfChannelFrequencyGt *string) *DcimInterfacesListParams {
	o.SetRfChannelFrequencyGt(rfChannelFrequencyGt)
	return o
}

// SetRfChannelFrequencyGt adds the rfChannelFrequencyGt to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetRfChannelFrequencyGt(rfChannelFrequencyGt *string) {
	o.RfChannelFrequencyGt = rfChannelFrequencyGt
}

// WithRfChannelFrequencyGte adds the rfChannelFrequencyGte to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithRfChannelFrequencyGte(rfChannelFrequencyGte *string) *DcimInterfacesListParams {
	o.SetRfChannelFrequencyGte(rfChannelFrequencyGte)
	return o
}

// SetRfChannelFrequencyGte adds the rfChannelFrequencyGte to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetRfChannelFrequencyGte(rfChannelFrequencyGte *string) {
	o.RfChannelFrequencyGte = rfChannelFrequencyGte
}

// WithRfChannelFrequencyLt adds the rfChannelFrequencyLt to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithRfChannelFrequencyLt(rfChannelFrequencyLt *string) *DcimInterfacesListParams {
	o.SetRfChannelFrequencyLt(rfChannelFrequencyLt)
	return o
}

// SetRfChannelFrequencyLt adds the rfChannelFrequencyLt to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetRfChannelFrequencyLt(rfChannelFrequencyLt *string) {
	o.RfChannelFrequencyLt = rfChannelFrequencyLt
}

// WithRfChannelFrequencyLte adds the rfChannelFrequencyLte to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithRfChannelFrequencyLte(rfChannelFrequencyLte *string) *DcimInterfacesListParams {
	o.SetRfChannelFrequencyLte(rfChannelFrequencyLte)
	return o
}

// SetRfChannelFrequencyLte adds the rfChannelFrequencyLte to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetRfChannelFrequencyLte(rfChannelFrequencyLte *string) {
	o.RfChannelFrequencyLte = rfChannelFrequencyLte
}

// WithRfChannelFrequencyn adds the rfChannelFrequencyn to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithRfChannelFrequencyn(rfChannelFrequencyn *string) *DcimInterfacesListParams {
	o.SetRfChannelFrequencyn(rfChannelFrequencyn)
	return o
}

// SetRfChannelFrequencyn adds the rfChannelFrequencyN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetRfChannelFrequencyn(rfChannelFrequencyn *string) {
	o.RfChannelFrequencyn = rfChannelFrequencyn
}

// WithRfChannelWidth adds the rfChannelWidth to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithRfChannelWidth(rfChannelWidth *string) *DcimInterfacesListParams {
	o.SetRfChannelWidth(rfChannelWidth)
	return o
}

// SetRfChannelWidth adds the rfChannelWidth to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetRfChannelWidth(rfChannelWidth *string) {
	o.RfChannelWidth = rfChannelWidth
}

// WithRfChannelWidthGt adds the rfChannelWidthGt to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithRfChannelWidthGt(rfChannelWidthGt *string) *DcimInterfacesListParams {
	o.SetRfChannelWidthGt(rfChannelWidthGt)
	return o
}

// SetRfChannelWidthGt adds the rfChannelWidthGt to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetRfChannelWidthGt(rfChannelWidthGt *string) {
	o.RfChannelWidthGt = rfChannelWidthGt
}

// WithRfChannelWidthGte adds the rfChannelWidthGte to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithRfChannelWidthGte(rfChannelWidthGte *string) *DcimInterfacesListParams {
	o.SetRfChannelWidthGte(rfChannelWidthGte)
	return o
}

// SetRfChannelWidthGte adds the rfChannelWidthGte to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetRfChannelWidthGte(rfChannelWidthGte *string) {
	o.RfChannelWidthGte = rfChannelWidthGte
}

// WithRfChannelWidthLt adds the rfChannelWidthLt to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithRfChannelWidthLt(rfChannelWidthLt *string) *DcimInterfacesListParams {
	o.SetRfChannelWidthLt(rfChannelWidthLt)
	return o
}

// SetRfChannelWidthLt adds the rfChannelWidthLt to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetRfChannelWidthLt(rfChannelWidthLt *string) {
	o.RfChannelWidthLt = rfChannelWidthLt
}

// WithRfChannelWidthLte adds the rfChannelWidthLte to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithRfChannelWidthLte(rfChannelWidthLte *string) *DcimInterfacesListParams {
	o.SetRfChannelWidthLte(rfChannelWidthLte)
	return o
}

// SetRfChannelWidthLte adds the rfChannelWidthLte to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetRfChannelWidthLte(rfChannelWidthLte *string) {
	o.RfChannelWidthLte = rfChannelWidthLte
}

// WithRfChannelWidthn adds the rfChannelWidthn to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithRfChannelWidthn(rfChannelWidthn *string) *DcimInterfacesListParams {
	o.SetRfChannelWidthn(rfChannelWidthn)
	return o
}

// SetRfChannelWidthn adds the rfChannelWidthN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetRfChannelWidthn(rfChannelWidthn *string) {
	o.RfChannelWidthn = rfChannelWidthn
}

// WithRfRole adds the rfRole to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithRfRole(rfRole *string) *DcimInterfacesListParams {
	o.SetRfRole(rfRole)
	return o
}

// SetRfRole adds the rfRole to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetRfRole(rfRole *string) {
	o.RfRole = rfRole
}

// WithRfRolen adds the rfRolen to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithRfRolen(rfRolen *string) *DcimInterfacesListParams {
	o.SetRfRolen(rfRolen)
	return o
}

// SetRfRolen adds the rfRoleN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetRfRolen(rfRolen *string) {
	o.RfRolen = rfRolen
}

// WithSite adds the site to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithSite(site *string) *DcimInterfacesListParams {
	o.SetSite(site)
	return o
}

// SetSite adds the site to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetSite(site *string) {
	o.Site = site
}

// WithSiten adds the siten to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithSiten(siten *string) *DcimInterfacesListParams {
	o.SetSiten(siten)
	return o
}

// SetSiten adds the siteN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetSiten(siten *string) {
	o.Siten = siten
}

// WithSiteGroup adds the siteGroup to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithSiteGroup(siteGroup *string) *DcimInterfacesListParams {
	o.SetSiteGroup(siteGroup)
	return o
}

// SetSiteGroup adds the siteGroup to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetSiteGroup(siteGroup *string) {
	o.SiteGroup = siteGroup
}

// WithSiteGroupn adds the siteGroupn to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithSiteGroupn(siteGroupn *string) *DcimInterfacesListParams {
	o.SetSiteGroupn(siteGroupn)
	return o
}

// SetSiteGroupn adds the siteGroupN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetSiteGroupn(siteGroupn *string) {
	o.SiteGroupn = siteGroupn
}

// WithSiteGroupID adds the siteGroupID to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithSiteGroupID(siteGroupID *string) *DcimInterfacesListParams {
	o.SetSiteGroupID(siteGroupID)
	return o
}

// SetSiteGroupID adds the siteGroupId to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetSiteGroupID(siteGroupID *string) {
	o.SiteGroupID = siteGroupID
}

// WithSiteGroupIDn adds the siteGroupIDn to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithSiteGroupIDn(siteGroupIDn *string) *DcimInterfacesListParams {
	o.SetSiteGroupIDn(siteGroupIDn)
	return o
}

// SetSiteGroupIDn adds the siteGroupIdN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetSiteGroupIDn(siteGroupIDn *string) {
	o.SiteGroupIDn = siteGroupIDn
}

// WithSiteID adds the siteID to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithSiteID(siteID *string) *DcimInterfacesListParams {
	o.SetSiteID(siteID)
	return o
}

// SetSiteID adds the siteId to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetSiteID(siteID *string) {
	o.SiteID = siteID
}

// WithSiteIDn adds the siteIDn to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithSiteIDn(siteIDn *string) *DcimInterfacesListParams {
	o.SetSiteIDn(siteIDn)
	return o
}

// SetSiteIDn adds the siteIdN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetSiteIDn(siteIDn *string) {
	o.SiteIDn = siteIDn
}

// WithSpeed adds the speed to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithSpeed(speed *string) *DcimInterfacesListParams {
	o.SetSpeed(speed)
	return o
}

// SetSpeed adds the speed to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetSpeed(speed *string) {
	o.Speed = speed
}

// WithSpeedGt adds the speedGt to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithSpeedGt(speedGt *string) *DcimInterfacesListParams {
	o.SetSpeedGt(speedGt)
	return o
}

// SetSpeedGt adds the speedGt to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetSpeedGt(speedGt *string) {
	o.SpeedGt = speedGt
}

// WithSpeedGte adds the speedGte to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithSpeedGte(speedGte *string) *DcimInterfacesListParams {
	o.SetSpeedGte(speedGte)
	return o
}

// SetSpeedGte adds the speedGte to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetSpeedGte(speedGte *string) {
	o.SpeedGte = speedGte
}

// WithSpeedLt adds the speedLt to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithSpeedLt(speedLt *string) *DcimInterfacesListParams {
	o.SetSpeedLt(speedLt)
	return o
}

// SetSpeedLt adds the speedLt to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetSpeedLt(speedLt *string) {
	o.SpeedLt = speedLt
}

// WithSpeedLte adds the speedLte to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithSpeedLte(speedLte *string) *DcimInterfacesListParams {
	o.SetSpeedLte(speedLte)
	return o
}

// SetSpeedLte adds the speedLte to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetSpeedLte(speedLte *string) {
	o.SpeedLte = speedLte
}

// WithSpeedn adds the speedn to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithSpeedn(speedn *string) *DcimInterfacesListParams {
	o.SetSpeedn(speedn)
	return o
}

// SetSpeedn adds the speedN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetSpeedn(speedn *string) {
	o.Speedn = speedn
}

// WithTag adds the tag to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithTag(tag *string) *DcimInterfacesListParams {
	o.SetTag(tag)
	return o
}

// SetTag adds the tag to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetTag(tag *string) {
	o.Tag = tag
}

// WithTagn adds the tagn to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithTagn(tagn *string) *DcimInterfacesListParams {
	o.SetTagn(tagn)
	return o
}

// SetTagn adds the tagN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetTagn(tagn *string) {
	o.Tagn = tagn
}

// WithTxPower adds the txPower to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithTxPower(txPower *string) *DcimInterfacesListParams {
	o.SetTxPower(txPower)
	return o
}

// SetTxPower adds the txPower to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetTxPower(txPower *string) {
	o.TxPower = txPower
}

// WithTxPowerGt adds the txPowerGt to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithTxPowerGt(txPowerGt *string) *DcimInterfacesListParams {
	o.SetTxPowerGt(txPowerGt)
	return o
}

// SetTxPowerGt adds the txPowerGt to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetTxPowerGt(txPowerGt *string) {
	o.TxPowerGt = txPowerGt
}

// WithTxPowerGte adds the txPowerGte to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithTxPowerGte(txPowerGte *string) *DcimInterfacesListParams {
	o.SetTxPowerGte(txPowerGte)
	return o
}

// SetTxPowerGte adds the txPowerGte to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetTxPowerGte(txPowerGte *string) {
	o.TxPowerGte = txPowerGte
}

// WithTxPowerLt adds the txPowerLt to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithTxPowerLt(txPowerLt *string) *DcimInterfacesListParams {
	o.SetTxPowerLt(txPowerLt)
	return o
}

// SetTxPowerLt adds the txPowerLt to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetTxPowerLt(txPowerLt *string) {
	o.TxPowerLt = txPowerLt
}

// WithTxPowerLte adds the txPowerLte to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithTxPowerLte(txPowerLte *string) *DcimInterfacesListParams {
	o.SetTxPowerLte(txPowerLte)
	return o
}

// SetTxPowerLte adds the txPowerLte to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetTxPowerLte(txPowerLte *string) {
	o.TxPowerLte = txPowerLte
}

// WithTxPowern adds the txPowern to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithTxPowern(txPowern *string) *DcimInterfacesListParams {
	o.SetTxPowern(txPowern)
	return o
}

// SetTxPowern adds the txPowerN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetTxPowern(txPowern *string) {
	o.TxPowern = txPowern
}

// WithType adds the typeVar to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithType(typeVar *string) *DcimInterfacesListParams {
	o.SetType(typeVar)
	return o
}

// SetType adds the type to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetType(typeVar *string) {
	o.Type = typeVar
}

// WithTypen adds the typen to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithTypen(typen *string) *DcimInterfacesListParams {
	o.SetTypen(typen)
	return o
}

// SetTypen adds the typeN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetTypen(typen *string) {
	o.Typen = typen
}

// WithVirtualChassis adds the virtualChassis to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithVirtualChassis(virtualChassis *string) *DcimInterfacesListParams {
	o.SetVirtualChassis(virtualChassis)
	return o
}

// SetVirtualChassis adds the virtualChassis to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetVirtualChassis(virtualChassis *string) {
	o.VirtualChassis = virtualChassis
}

// WithVirtualChassisn adds the virtualChassisn to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithVirtualChassisn(virtualChassisn *string) *DcimInterfacesListParams {
	o.SetVirtualChassisn(virtualChassisn)
	return o
}

// SetVirtualChassisn adds the virtualChassisN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetVirtualChassisn(virtualChassisn *string) {
	o.VirtualChassisn = virtualChassisn
}

// WithVirtualChassisID adds the virtualChassisID to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithVirtualChassisID(virtualChassisID *string) *DcimInterfacesListParams {
	o.SetVirtualChassisID(virtualChassisID)
	return o
}

// SetVirtualChassisID adds the virtualChassisId to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetVirtualChassisID(virtualChassisID *string) {
	o.VirtualChassisID = virtualChassisID
}

// WithVirtualChassisIDn adds the virtualChassisIDn to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithVirtualChassisIDn(virtualChassisIDn *string) *DcimInterfacesListParams {
	o.SetVirtualChassisIDn(virtualChassisIDn)
	return o
}

// SetVirtualChassisIDn adds the virtualChassisIdN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetVirtualChassisIDn(virtualChassisIDn *string) {
	o.VirtualChassisIDn = virtualChassisIDn
}

// WithVlan adds the vlan to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithVlan(vlan *string) *DcimInterfacesListParams {
	o.SetVlan(vlan)
	return o
}

// SetVlan adds the vlan to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetVlan(vlan *string) {
	o.Vlan = vlan
}

// WithVlanID adds the vlanID to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithVlanID(vlanID *string) *DcimInterfacesListParams {
	o.SetVlanID(vlanID)
	return o
}

// SetVlanID adds the vlanId to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetVlanID(vlanID *string) {
	o.VlanID = vlanID
}

// WithVrf adds the vrf to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithVrf(vrf *string) *DcimInterfacesListParams {
	o.SetVrf(vrf)
	return o
}

// SetVrf adds the vrf to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetVrf(vrf *string) {
	o.Vrf = vrf
}

// WithVrfn adds the vrfn to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithVrfn(vrfn *string) *DcimInterfacesListParams {
	o.SetVrfn(vrfn)
	return o
}

// SetVrfn adds the vrfN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetVrfn(vrfn *string) {
	o.Vrfn = vrfn
}

// WithVrfID adds the vrfID to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithVrfID(vrfID *string) *DcimInterfacesListParams {
	o.SetVrfID(vrfID)
	return o
}

// SetVrfID adds the vrfId to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetVrfID(vrfID *string) {
	o.VrfID = vrfID
}

// WithVrfIDn adds the vrfIDn to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithVrfIDn(vrfIDn *string) *DcimInterfacesListParams {
	o.SetVrfIDn(vrfIDn)
	return o
}

// SetVrfIDn adds the vrfIdN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetVrfIDn(vrfIDn *string) {
	o.VrfIDn = vrfIDn
}

// WithWwn adds the wwn to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithWwn(wwn *string) *DcimInterfacesListParams {
	o.SetWwn(wwn)
	return o
}

// SetWwn adds the wwn to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetWwn(wwn *string) {
	o.Wwn = wwn
}

// WithWwnIc adds the wwnIc to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithWwnIc(wwnIc *string) *DcimInterfacesListParams {
	o.SetWwnIc(wwnIc)
	return o
}

// SetWwnIc adds the wwnIc to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetWwnIc(wwnIc *string) {
	o.WwnIc = wwnIc
}

// WithWwnIe adds the wwnIe to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithWwnIe(wwnIe *string) *DcimInterfacesListParams {
	o.SetWwnIe(wwnIe)
	return o
}

// SetWwnIe adds the wwnIe to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetWwnIe(wwnIe *string) {
	o.WwnIe = wwnIe
}

// WithWwnIew adds the wwnIew to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithWwnIew(wwnIew *string) *DcimInterfacesListParams {
	o.SetWwnIew(wwnIew)
	return o
}

// SetWwnIew adds the wwnIew to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetWwnIew(wwnIew *string) {
	o.WwnIew = wwnIew
}

// WithWwnIsw adds the wwnIsw to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithWwnIsw(wwnIsw *string) *DcimInterfacesListParams {
	o.SetWwnIsw(wwnIsw)
	return o
}

// SetWwnIsw adds the wwnIsw to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetWwnIsw(wwnIsw *string) {
	o.WwnIsw = wwnIsw
}

// WithWwnn adds the wwnn to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithWwnn(wwnn *string) *DcimInterfacesListParams {
	o.SetWwnn(wwnn)
	return o
}

// SetWwnn adds the wwnN to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetWwnn(wwnn *string) {
	o.Wwnn = wwnn
}

// WithWwnNic adds the wwnNic to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithWwnNic(wwnNic *string) *DcimInterfacesListParams {
	o.SetWwnNic(wwnNic)
	return o
}

// SetWwnNic adds the wwnNic to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetWwnNic(wwnNic *string) {
	o.WwnNic = wwnNic
}

// WithWwnNie adds the wwnNie to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithWwnNie(wwnNie *string) *DcimInterfacesListParams {
	o.SetWwnNie(wwnNie)
	return o
}

// SetWwnNie adds the wwnNie to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetWwnNie(wwnNie *string) {
	o.WwnNie = wwnNie
}

// WithWwnNiew adds the wwnNiew to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithWwnNiew(wwnNiew *string) *DcimInterfacesListParams {
	o.SetWwnNiew(wwnNiew)
	return o
}

// SetWwnNiew adds the wwnNiew to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetWwnNiew(wwnNiew *string) {
	o.WwnNiew = wwnNiew
}

// WithWwnNisw adds the wwnNisw to the dcim interfaces list params
func (o *DcimInterfacesListParams) WithWwnNisw(wwnNisw *string) *DcimInterfacesListParams {
	o.SetWwnNisw(wwnNisw)
	return o
}

// SetWwnNisw adds the wwnNisw to the dcim interfaces list params
func (o *DcimInterfacesListParams) SetWwnNisw(wwnNisw *string) {
	o.WwnNisw = wwnNisw
}

// WriteToRequest writes these params to a swagger request
func (o *DcimInterfacesListParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.BridgeID != nil {

		// query param bridge_id
		var qrBridgeID string

		if o.BridgeID != nil {
			qrBridgeID = *o.BridgeID
		}
		qBridgeID := qrBridgeID
		if qBridgeID != "" {

			if err := r.SetQueryParam("bridge_id", qBridgeID); err != nil {
				return err
			}
		}
	}

	if o.BridgeIDn != nil {

		// query param bridge_id__n
		var qrBridgeIDn string

		if o.BridgeIDn != nil {
			qrBridgeIDn = *o.BridgeIDn
		}
		qBridgeIDn := qrBridgeIDn
		if qBridgeIDn != "" {

			if err := r.SetQueryParam("bridge_id__n", qBridgeIDn); err != nil {
				return err
			}
		}
	}

	if o.Cabled != nil {

		// query param cabled
		var qrCabled string

		if o.Cabled != nil {
			qrCabled = *o.Cabled
		}
		qCabled := qrCabled
		if qCabled != "" {

			if err := r.SetQueryParam("cabled", qCabled); err != nil {
				return err
			}
		}
	}

	if o.Connected != nil {

		// query param connected
		var qrConnected string

		if o.Connected != nil {
			qrConnected = *o.Connected
		}
		qConnected := qrConnected
		if qConnected != "" {

			if err := r.SetQueryParam("connected", qConnected); err != nil {
				return err
			}
		}
	}

	if o.Created != nil {

		// query param created
		var qrCreated string

		if o.Created != nil {
			qrCreated = *o.Created
		}
		qCreated := qrCreated
		if qCreated != "" {

			if err := r.SetQueryParam("created", qCreated); err != nil {
				return err
			}
		}
	}

	if o.CreatedGte != nil {

		// query param created__gte
		var qrCreatedGte string

		if o.CreatedGte != nil {
			qrCreatedGte = *o.CreatedGte
		}
		qCreatedGte := qrCreatedGte
		if qCreatedGte != "" {

			if err := r.SetQueryParam("created__gte", qCreatedGte); err != nil {
				return err
			}
		}
	}

	if o.CreatedLte != nil {

		// query param created__lte
		var qrCreatedLte string

		if o.CreatedLte != nil {
			qrCreatedLte = *o.CreatedLte
		}
		qCreatedLte := qrCreatedLte
		if qCreatedLte != "" {

			if err := r.SetQueryParam("created__lte", qCreatedLte); err != nil {
				return err
			}
		}
	}

	if o.Description != nil {

		// query param description
		var qrDescription string

		if o.Description != nil {
			qrDescription = *o.Description
		}
		qDescription := qrDescription
		if qDescription != "" {

			if err := r.SetQueryParam("description", qDescription); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIc != nil {

		// query param description__ic
		var qrDescriptionIc string

		if o.DescriptionIc != nil {
			qrDescriptionIc = *o.DescriptionIc
		}
		qDescriptionIc := qrDescriptionIc
		if qDescriptionIc != "" {

			if err := r.SetQueryParam("description__ic", qDescriptionIc); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIe != nil {

		// query param description__ie
		var qrDescriptionIe string

		if o.DescriptionIe != nil {
			qrDescriptionIe = *o.DescriptionIe
		}
		qDescriptionIe := qrDescriptionIe
		if qDescriptionIe != "" {

			if err := r.SetQueryParam("description__ie", qDescriptionIe); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIew != nil {

		// query param description__iew
		var qrDescriptionIew string

		if o.DescriptionIew != nil {
			qrDescriptionIew = *o.DescriptionIew
		}
		qDescriptionIew := qrDescriptionIew
		if qDescriptionIew != "" {

			if err := r.SetQueryParam("description__iew", qDescriptionIew); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIsw != nil {

		// query param description__isw
		var qrDescriptionIsw string

		if o.DescriptionIsw != nil {
			qrDescriptionIsw = *o.DescriptionIsw
		}
		qDescriptionIsw := qrDescriptionIsw
		if qDescriptionIsw != "" {

			if err := r.SetQueryParam("description__isw", qDescriptionIsw); err != nil {
				return err
			}
		}
	}

	if o.Descriptionn != nil {

		// query param description__n
		var qrDescriptionn string

		if o.Descriptionn != nil {
			qrDescriptionn = *o.Descriptionn
		}
		qDescriptionn := qrDescriptionn
		if qDescriptionn != "" {

			if err := r.SetQueryParam("description__n", qDescriptionn); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNic != nil {

		// query param description__nic
		var qrDescriptionNic string

		if o.DescriptionNic != nil {
			qrDescriptionNic = *o.DescriptionNic
		}
		qDescriptionNic := qrDescriptionNic
		if qDescriptionNic != "" {

			if err := r.SetQueryParam("description__nic", qDescriptionNic); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNie != nil {

		// query param description__nie
		var qrDescriptionNie string

		if o.DescriptionNie != nil {
			qrDescriptionNie = *o.DescriptionNie
		}
		qDescriptionNie := qrDescriptionNie
		if qDescriptionNie != "" {

			if err := r.SetQueryParam("description__nie", qDescriptionNie); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNiew != nil {

		// query param description__niew
		var qrDescriptionNiew string

		if o.DescriptionNiew != nil {
			qrDescriptionNiew = *o.DescriptionNiew
		}
		qDescriptionNiew := qrDescriptionNiew
		if qDescriptionNiew != "" {

			if err := r.SetQueryParam("description__niew", qDescriptionNiew); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNisw != nil {

		// query param description__nisw
		var qrDescriptionNisw string

		if o.DescriptionNisw != nil {
			qrDescriptionNisw = *o.DescriptionNisw
		}
		qDescriptionNisw := qrDescriptionNisw
		if qDescriptionNisw != "" {

			if err := r.SetQueryParam("description__nisw", qDescriptionNisw); err != nil {
				return err
			}
		}
	}

	if o.Device != nil {

		// query param device
		var qrDevice string

		if o.Device != nil {
			qrDevice = *o.Device
		}
		qDevice := qrDevice
		if qDevice != "" {

			if err := r.SetQueryParam("device", qDevice); err != nil {
				return err
			}
		}
	}

	if o.DeviceID != nil {

		// query param device_id
		var qrDeviceID string

		if o.DeviceID != nil {
			qrDeviceID = *o.DeviceID
		}
		qDeviceID := qrDeviceID
		if qDeviceID != "" {

			if err := r.SetQueryParam("device_id", qDeviceID); err != nil {
				return err
			}
		}
	}

	if o.Duplex != nil {

		// query param duplex
		var qrDuplex string

		if o.Duplex != nil {
			qrDuplex = *o.Duplex
		}
		qDuplex := qrDuplex
		if qDuplex != "" {

			if err := r.SetQueryParam("duplex", qDuplex); err != nil {
				return err
			}
		}
	}

	if o.Duplexn != nil {

		// query param duplex__n
		var qrDuplexn string

		if o.Duplexn != nil {
			qrDuplexn = *o.Duplexn
		}
		qDuplexn := qrDuplexn
		if qDuplexn != "" {

			if err := r.SetQueryParam("duplex__n", qDuplexn); err != nil {
				return err
			}
		}
	}

	if o.Enabled != nil {

		// query param enabled
		var qrEnabled string

		if o.Enabled != nil {
			qrEnabled = *o.Enabled
		}
		qEnabled := qrEnabled
		if qEnabled != "" {

			if err := r.SetQueryParam("enabled", qEnabled); err != nil {
				return err
			}
		}
	}

	if o.ID != nil {

		// query param id
		var qrID string

		if o.ID != nil {
			qrID = *o.ID
		}
		qID := qrID
		if qID != "" {

			if err := r.SetQueryParam("id", qID); err != nil {
				return err
			}
		}
	}

	if o.IDGt != nil {

		// query param id__gt
		var qrIDGt string

		if o.IDGt != nil {
			qrIDGt = *o.IDGt
		}
		qIDGt := qrIDGt
		if qIDGt != "" {

			if err := r.SetQueryParam("id__gt", qIDGt); err != nil {
				return err
			}
		}
	}

	if o.IDGte != nil {

		// query param id__gte
		var qrIDGte string

		if o.IDGte != nil {
			qrIDGte = *o.IDGte
		}
		qIDGte := qrIDGte
		if qIDGte != "" {

			if err := r.SetQueryParam("id__gte", qIDGte); err != nil {
				return err
			}
		}
	}

	if o.IDLt != nil {

		// query param id__lt
		var qrIDLt string

		if o.IDLt != nil {
			qrIDLt = *o.IDLt
		}
		qIDLt := qrIDLt
		if qIDLt != "" {

			if err := r.SetQueryParam("id__lt", qIDLt); err != nil {
				return err
			}
		}
	}

	if o.IDLte != nil {

		// query param id__lte
		var qrIDLte string

		if o.IDLte != nil {
			qrIDLte = *o.IDLte
		}
		qIDLte := qrIDLte
		if qIDLte != "" {

			if err := r.SetQueryParam("id__lte", qIDLte); err != nil {
				return err
			}
		}
	}

	if o.IDn != nil {

		// query param id__n
		var qrIDn string

		if o.IDn != nil {
			qrIDn = *o.IDn
		}
		qIDn := qrIDn
		if qIDn != "" {

			if err := r.SetQueryParam("id__n", qIDn); err != nil {
				return err
			}
		}
	}

	if o.Kind != nil {

		// query param kind
		var qrKind string

		if o.Kind != nil {
			qrKind = *o.Kind
		}
		qKind := qrKind
		if qKind != "" {

			if err := r.SetQueryParam("kind", qKind); err != nil {
				return err
			}
		}
	}

	if o.Label != nil {

		// query param label
		var qrLabel string

		if o.Label != nil {
			qrLabel = *o.Label
		}
		qLabel := qrLabel
		if qLabel != "" {

			if err := r.SetQueryParam("label", qLabel); err != nil {
				return err
			}
		}
	}

	if o.LabelIc != nil {

		// query param label__ic
		var qrLabelIc string

		if o.LabelIc != nil {
			qrLabelIc = *o.LabelIc
		}
		qLabelIc := qrLabelIc
		if qLabelIc != "" {

			if err := r.SetQueryParam("label__ic", qLabelIc); err != nil {
				return err
			}
		}
	}

	if o.LabelIe != nil {

		// query param label__ie
		var qrLabelIe string

		if o.LabelIe != nil {
			qrLabelIe = *o.LabelIe
		}
		qLabelIe := qrLabelIe
		if qLabelIe != "" {

			if err := r.SetQueryParam("label__ie", qLabelIe); err != nil {
				return err
			}
		}
	}

	if o.LabelIew != nil {

		// query param label__iew
		var qrLabelIew string

		if o.LabelIew != nil {
			qrLabelIew = *o.LabelIew
		}
		qLabelIew := qrLabelIew
		if qLabelIew != "" {

			if err := r.SetQueryParam("label__iew", qLabelIew); err != nil {
				return err
			}
		}
	}

	if o.LabelIsw != nil {

		// query param label__isw
		var qrLabelIsw string

		if o.LabelIsw != nil {
			qrLabelIsw = *o.LabelIsw
		}
		qLabelIsw := qrLabelIsw
		if qLabelIsw != "" {

			if err := r.SetQueryParam("label__isw", qLabelIsw); err != nil {
				return err
			}
		}
	}

	if o.Labeln != nil {

		// query param label__n
		var qrLabeln string

		if o.Labeln != nil {
			qrLabeln = *o.Labeln
		}
		qLabeln := qrLabeln
		if qLabeln != "" {

			if err := r.SetQueryParam("label__n", qLabeln); err != nil {
				return err
			}
		}
	}

	if o.LabelNic != nil {

		// query param label__nic
		var qrLabelNic string

		if o.LabelNic != nil {
			qrLabelNic = *o.LabelNic
		}
		qLabelNic := qrLabelNic
		if qLabelNic != "" {

			if err := r.SetQueryParam("label__nic", qLabelNic); err != nil {
				return err
			}
		}
	}

	if o.LabelNie != nil {

		// query param label__nie
		var qrLabelNie string

		if o.LabelNie != nil {
			qrLabelNie = *o.LabelNie
		}
		qLabelNie := qrLabelNie
		if qLabelNie != "" {

			if err := r.SetQueryParam("label__nie", qLabelNie); err != nil {
				return err
			}
		}
	}

	if o.LabelNiew != nil {

		// query param label__niew
		var qrLabelNiew string

		if o.LabelNiew != nil {
			qrLabelNiew = *o.LabelNiew
		}
		qLabelNiew := qrLabelNiew
		if qLabelNiew != "" {

			if err := r.SetQueryParam("label__niew", qLabelNiew); err != nil {
				return err
			}
		}
	}

	if o.LabelNisw != nil {

		// query param label__nisw
		var qrLabelNisw string

		if o.LabelNisw != nil {
			qrLabelNisw = *o.LabelNisw
		}
		qLabelNisw := qrLabelNisw
		if qLabelNisw != "" {

			if err := r.SetQueryParam("label__nisw", qLabelNisw); err != nil {
				return err
			}
		}
	}

	if o.LagID != nil {

		// query param lag_id
		var qrLagID string

		if o.LagID != nil {
			qrLagID = *o.LagID
		}
		qLagID := qrLagID
		if qLagID != "" {

			if err := r.SetQueryParam("lag_id", qLagID); err != nil {
				return err
			}
		}
	}

	if o.LagIDn != nil {

		// query param lag_id__n
		var qrLagIDn string

		if o.LagIDn != nil {
			qrLagIDn = *o.LagIDn
		}
		qLagIDn := qrLagIDn
		if qLagIDn != "" {

			if err := r.SetQueryParam("lag_id__n", qLagIDn); err != nil {
				return err
			}
		}
	}

	if o.LastUpdated != nil {

		// query param last_updated
		var qrLastUpdated string

		if o.LastUpdated != nil {
			qrLastUpdated = *o.LastUpdated
		}
		qLastUpdated := qrLastUpdated
		if qLastUpdated != "" {

			if err := r.SetQueryParam("last_updated", qLastUpdated); err != nil {
				return err
			}
		}
	}

	if o.LastUpdatedGte != nil {

		// query param last_updated__gte
		var qrLastUpdatedGte string

		if o.LastUpdatedGte != nil {
			qrLastUpdatedGte = *o.LastUpdatedGte
		}
		qLastUpdatedGte := qrLastUpdatedGte
		if qLastUpdatedGte != "" {

			if err := r.SetQueryParam("last_updated__gte", qLastUpdatedGte); err != nil {
				return err
			}
		}
	}

	if o.LastUpdatedLte != nil {

		// query param last_updated__lte
		var qrLastUpdatedLte string

		if o.LastUpdatedLte != nil {
			qrLastUpdatedLte = *o.LastUpdatedLte
		}
		qLastUpdatedLte := qrLastUpdatedLte
		if qLastUpdatedLte != "" {

			if err := r.SetQueryParam("last_updated__lte", qLastUpdatedLte); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Location != nil {

		// query param location
		var qrLocation string

		if o.Location != nil {
			qrLocation = *o.Location
		}
		qLocation := qrLocation
		if qLocation != "" {

			if err := r.SetQueryParam("location", qLocation); err != nil {
				return err
			}
		}
	}

	if o.Locationn != nil {

		// query param location__n
		var qrLocationn string

		if o.Locationn != nil {
			qrLocationn = *o.Locationn
		}
		qLocationn := qrLocationn
		if qLocationn != "" {

			if err := r.SetQueryParam("location__n", qLocationn); err != nil {
				return err
			}
		}
	}

	if o.LocationID != nil {

		// query param location_id
		var qrLocationID string

		if o.LocationID != nil {
			qrLocationID = *o.LocationID
		}
		qLocationID := qrLocationID
		if qLocationID != "" {

			if err := r.SetQueryParam("location_id", qLocationID); err != nil {
				return err
			}
		}
	}

	if o.LocationIDn != nil {

		// query param location_id__n
		var qrLocationIDn string

		if o.LocationIDn != nil {
			qrLocationIDn = *o.LocationIDn
		}
		qLocationIDn := qrLocationIDn
		if qLocationIDn != "" {

			if err := r.SetQueryParam("location_id__n", qLocationIDn); err != nil {
				return err
			}
		}
	}

	if o.MacAddress != nil {

		// query param mac_address
		var qrMacAddress string

		if o.MacAddress != nil {
			qrMacAddress = *o.MacAddress
		}
		qMacAddress := qrMacAddress
		if qMacAddress != "" {

			if err := r.SetQueryParam("mac_address", qMacAddress); err != nil {
				return err
			}
		}
	}

	if o.MacAddressIc != nil {

		// query param mac_address__ic
		var qrMacAddressIc string

		if o.MacAddressIc != nil {
			qrMacAddressIc = *o.MacAddressIc
		}
		qMacAddressIc := qrMacAddressIc
		if qMacAddressIc != "" {

			if err := r.SetQueryParam("mac_address__ic", qMacAddressIc); err != nil {
				return err
			}
		}
	}

	if o.MacAddressIe != nil {

		// query param mac_address__ie
		var qrMacAddressIe string

		if o.MacAddressIe != nil {
			qrMacAddressIe = *o.MacAddressIe
		}
		qMacAddressIe := qrMacAddressIe
		if qMacAddressIe != "" {

			if err := r.SetQueryParam("mac_address__ie", qMacAddressIe); err != nil {
				return err
			}
		}
	}

	if o.MacAddressIew != nil {

		// query param mac_address__iew
		var qrMacAddressIew string

		if o.MacAddressIew != nil {
			qrMacAddressIew = *o.MacAddressIew
		}
		qMacAddressIew := qrMacAddressIew
		if qMacAddressIew != "" {

			if err := r.SetQueryParam("mac_address__iew", qMacAddressIew); err != nil {
				return err
			}
		}
	}

	if o.MacAddressIsw != nil {

		// query param mac_address__isw
		var qrMacAddressIsw string

		if o.MacAddressIsw != nil {
			qrMacAddressIsw = *o.MacAddressIsw
		}
		qMacAddressIsw := qrMacAddressIsw
		if qMacAddressIsw != "" {

			if err := r.SetQueryParam("mac_address__isw", qMacAddressIsw); err != nil {
				return err
			}
		}
	}

	if o.MacAddressn != nil {

		// query param mac_address__n
		var qrMacAddressn string

		if o.MacAddressn != nil {
			qrMacAddressn = *o.MacAddressn
		}
		qMacAddressn := qrMacAddressn
		if qMacAddressn != "" {

			if err := r.SetQueryParam("mac_address__n", qMacAddressn); err != nil {
				return err
			}
		}
	}

	if o.MacAddressNic != nil {

		// query param mac_address__nic
		var qrMacAddressNic string

		if o.MacAddressNic != nil {
			qrMacAddressNic = *o.MacAddressNic
		}
		qMacAddressNic := qrMacAddressNic
		if qMacAddressNic != "" {

			if err := r.SetQueryParam("mac_address__nic", qMacAddressNic); err != nil {
				return err
			}
		}
	}

	if o.MacAddressNie != nil {

		// query param mac_address__nie
		var qrMacAddressNie string

		if o.MacAddressNie != nil {
			qrMacAddressNie = *o.MacAddressNie
		}
		qMacAddressNie := qrMacAddressNie
		if qMacAddressNie != "" {

			if err := r.SetQueryParam("mac_address__nie", qMacAddressNie); err != nil {
				return err
			}
		}
	}

	if o.MacAddressNiew != nil {

		// query param mac_address__niew
		var qrMacAddressNiew string

		if o.MacAddressNiew != nil {
			qrMacAddressNiew = *o.MacAddressNiew
		}
		qMacAddressNiew := qrMacAddressNiew
		if qMacAddressNiew != "" {

			if err := r.SetQueryParam("mac_address__niew", qMacAddressNiew); err != nil {
				return err
			}
		}
	}

	if o.MacAddressNisw != nil {

		// query param mac_address__nisw
		var qrMacAddressNisw string

		if o.MacAddressNisw != nil {
			qrMacAddressNisw = *o.MacAddressNisw
		}
		qMacAddressNisw := qrMacAddressNisw
		if qMacAddressNisw != "" {

			if err := r.SetQueryParam("mac_address__nisw", qMacAddressNisw); err != nil {
				return err
			}
		}
	}

	if o.MgmtOnly != nil {

		// query param mgmt_only
		var qrMgmtOnly string

		if o.MgmtOnly != nil {
			qrMgmtOnly = *o.MgmtOnly
		}
		qMgmtOnly := qrMgmtOnly
		if qMgmtOnly != "" {

			if err := r.SetQueryParam("mgmt_only", qMgmtOnly); err != nil {
				return err
			}
		}
	}

	if o.Mode != nil {

		// query param mode
		var qrMode string

		if o.Mode != nil {
			qrMode = *o.Mode
		}
		qMode := qrMode
		if qMode != "" {

			if err := r.SetQueryParam("mode", qMode); err != nil {
				return err
			}
		}
	}

	if o.Moden != nil {

		// query param mode__n
		var qrModen string

		if o.Moden != nil {
			qrModen = *o.Moden
		}
		qModen := qrModen
		if qModen != "" {

			if err := r.SetQueryParam("mode__n", qModen); err != nil {
				return err
			}
		}
	}

	if o.ModuleID != nil {

		// query param module_id
		var qrModuleID string

		if o.ModuleID != nil {
			qrModuleID = *o.ModuleID
		}
		qModuleID := qrModuleID
		if qModuleID != "" {

			if err := r.SetQueryParam("module_id", qModuleID); err != nil {
				return err
			}
		}
	}

	if o.ModuleIDn != nil {

		// query param module_id__n
		var qrModuleIDn string

		if o.ModuleIDn != nil {
			qrModuleIDn = *o.ModuleIDn
		}
		qModuleIDn := qrModuleIDn
		if qModuleIDn != "" {

			if err := r.SetQueryParam("module_id__n", qModuleIDn); err != nil {
				return err
			}
		}
	}

	if o.Mtu != nil {

		// query param mtu
		var qrMtu string

		if o.Mtu != nil {
			qrMtu = *o.Mtu
		}
		qMtu := qrMtu
		if qMtu != "" {

			if err := r.SetQueryParam("mtu", qMtu); err != nil {
				return err
			}
		}
	}

	if o.MtuGt != nil {

		// query param mtu__gt
		var qrMtuGt string

		if o.MtuGt != nil {
			qrMtuGt = *o.MtuGt
		}
		qMtuGt := qrMtuGt
		if qMtuGt != "" {

			if err := r.SetQueryParam("mtu__gt", qMtuGt); err != nil {
				return err
			}
		}
	}

	if o.MtuGte != nil {

		// query param mtu__gte
		var qrMtuGte string

		if o.MtuGte != nil {
			qrMtuGte = *o.MtuGte
		}
		qMtuGte := qrMtuGte
		if qMtuGte != "" {

			if err := r.SetQueryParam("mtu__gte", qMtuGte); err != nil {
				return err
			}
		}
	}

	if o.MtuLt != nil {

		// query param mtu__lt
		var qrMtuLt string

		if o.MtuLt != nil {
			qrMtuLt = *o.MtuLt
		}
		qMtuLt := qrMtuLt
		if qMtuLt != "" {

			if err := r.SetQueryParam("mtu__lt", qMtuLt); err != nil {
				return err
			}
		}
	}

	if o.MtuLte != nil {

		// query param mtu__lte
		var qrMtuLte string

		if o.MtuLte != nil {
			qrMtuLte = *o.MtuLte
		}
		qMtuLte := qrMtuLte
		if qMtuLte != "" {

			if err := r.SetQueryParam("mtu__lte", qMtuLte); err != nil {
				return err
			}
		}
	}

	if o.Mtun != nil {

		// query param mtu__n
		var qrMtun string

		if o.Mtun != nil {
			qrMtun = *o.Mtun
		}
		qMtun := qrMtun
		if qMtun != "" {

			if err := r.SetQueryParam("mtu__n", qMtun); err != nil {
				return err
			}
		}
	}

	if o.Name != nil {

		// query param name
		var qrName string

		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.NameIc != nil {

		// query param name__ic
		var qrNameIc string

		if o.NameIc != nil {
			qrNameIc = *o.NameIc
		}
		qNameIc := qrNameIc
		if qNameIc != "" {

			if err := r.SetQueryParam("name__ic", qNameIc); err != nil {
				return err
			}
		}
	}

	if o.NameIe != nil {

		// query param name__ie
		var qrNameIe string

		if o.NameIe != nil {
			qrNameIe = *o.NameIe
		}
		qNameIe := qrNameIe
		if qNameIe != "" {

			if err := r.SetQueryParam("name__ie", qNameIe); err != nil {
				return err
			}
		}
	}

	if o.NameIew != nil {

		// query param name__iew
		var qrNameIew string

		if o.NameIew != nil {
			qrNameIew = *o.NameIew
		}
		qNameIew := qrNameIew
		if qNameIew != "" {

			if err := r.SetQueryParam("name__iew", qNameIew); err != nil {
				return err
			}
		}
	}

	if o.NameIsw != nil {

		// query param name__isw
		var qrNameIsw string

		if o.NameIsw != nil {
			qrNameIsw = *o.NameIsw
		}
		qNameIsw := qrNameIsw
		if qNameIsw != "" {

			if err := r.SetQueryParam("name__isw", qNameIsw); err != nil {
				return err
			}
		}
	}

	if o.Namen != nil {

		// query param name__n
		var qrNamen string

		if o.Namen != nil {
			qrNamen = *o.Namen
		}
		qNamen := qrNamen
		if qNamen != "" {

			if err := r.SetQueryParam("name__n", qNamen); err != nil {
				return err
			}
		}
	}

	if o.NameNic != nil {

		// query param name__nic
		var qrNameNic string

		if o.NameNic != nil {
			qrNameNic = *o.NameNic
		}
		qNameNic := qrNameNic
		if qNameNic != "" {

			if err := r.SetQueryParam("name__nic", qNameNic); err != nil {
				return err
			}
		}
	}

	if o.NameNie != nil {

		// query param name__nie
		var qrNameNie string

		if o.NameNie != nil {
			qrNameNie = *o.NameNie
		}
		qNameNie := qrNameNie
		if qNameNie != "" {

			if err := r.SetQueryParam("name__nie", qNameNie); err != nil {
				return err
			}
		}
	}

	if o.NameNiew != nil {

		// query param name__niew
		var qrNameNiew string

		if o.NameNiew != nil {
			qrNameNiew = *o.NameNiew
		}
		qNameNiew := qrNameNiew
		if qNameNiew != "" {

			if err := r.SetQueryParam("name__niew", qNameNiew); err != nil {
				return err
			}
		}
	}

	if o.NameNisw != nil {

		// query param name__nisw
		var qrNameNisw string

		if o.NameNisw != nil {
			qrNameNisw = *o.NameNisw
		}
		qNameNisw := qrNameNisw
		if qNameNisw != "" {

			if err := r.SetQueryParam("name__nisw", qNameNisw); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if o.ParentID != nil {

		// query param parent_id
		var qrParentID string

		if o.ParentID != nil {
			qrParentID = *o.ParentID
		}
		qParentID := qrParentID
		if qParentID != "" {

			if err := r.SetQueryParam("parent_id", qParentID); err != nil {
				return err
			}
		}
	}

	if o.ParentIDn != nil {

		// query param parent_id__n
		var qrParentIDn string

		if o.ParentIDn != nil {
			qrParentIDn = *o.ParentIDn
		}
		qParentIDn := qrParentIDn
		if qParentIDn != "" {

			if err := r.SetQueryParam("parent_id__n", qParentIDn); err != nil {
				return err
			}
		}
	}

	if o.Q != nil {

		// query param q
		var qrQ string

		if o.Q != nil {
			qrQ = *o.Q
		}
		qQ := qrQ
		if qQ != "" {

			if err := r.SetQueryParam("q", qQ); err != nil {
				return err
			}
		}
	}

	if o.Region != nil {

		// query param region
		var qrRegion string

		if o.Region != nil {
			qrRegion = *o.Region
		}
		qRegion := qrRegion
		if qRegion != "" {

			if err := r.SetQueryParam("region", qRegion); err != nil {
				return err
			}
		}
	}

	if o.Regionn != nil {

		// query param region__n
		var qrRegionn string

		if o.Regionn != nil {
			qrRegionn = *o.Regionn
		}
		qRegionn := qrRegionn
		if qRegionn != "" {

			if err := r.SetQueryParam("region__n", qRegionn); err != nil {
				return err
			}
		}
	}

	if o.RegionID != nil {

		// query param region_id
		var qrRegionID string

		if o.RegionID != nil {
			qrRegionID = *o.RegionID
		}
		qRegionID := qrRegionID
		if qRegionID != "" {

			if err := r.SetQueryParam("region_id", qRegionID); err != nil {
				return err
			}
		}
	}

	if o.RegionIDn != nil {

		// query param region_id__n
		var qrRegionIDn string

		if o.RegionIDn != nil {
			qrRegionIDn = *o.RegionIDn
		}
		qRegionIDn := qrRegionIDn
		if qRegionIDn != "" {

			if err := r.SetQueryParam("region_id__n", qRegionIDn); err != nil {
				return err
			}
		}
	}

	if o.RfChannel != nil {

		// query param rf_channel
		var qrRfChannel string

		if o.RfChannel != nil {
			qrRfChannel = *o.RfChannel
		}
		qRfChannel := qrRfChannel
		if qRfChannel != "" {

			if err := r.SetQueryParam("rf_channel", qRfChannel); err != nil {
				return err
			}
		}
	}

	if o.RfChanneln != nil {

		// query param rf_channel__n
		var qrRfChanneln string

		if o.RfChanneln != nil {
			qrRfChanneln = *o.RfChanneln
		}
		qRfChanneln := qrRfChanneln
		if qRfChanneln != "" {

			if err := r.SetQueryParam("rf_channel__n", qRfChanneln); err != nil {
				return err
			}
		}
	}

	if o.RfChannelFrequency != nil {

		// query param rf_channel_frequency
		var qrRfChannelFrequency string

		if o.RfChannelFrequency != nil {
			qrRfChannelFrequency = *o.RfChannelFrequency
		}
		qRfChannelFrequency := qrRfChannelFrequency
		if qRfChannelFrequency != "" {

			if err := r.SetQueryParam("rf_channel_frequency", qRfChannelFrequency); err != nil {
				return err
			}
		}
	}

	if o.RfChannelFrequencyGt != nil {

		// query param rf_channel_frequency__gt
		var qrRfChannelFrequencyGt string

		if o.RfChannelFrequencyGt != nil {
			qrRfChannelFrequencyGt = *o.RfChannelFrequencyGt
		}
		qRfChannelFrequencyGt := qrRfChannelFrequencyGt
		if qRfChannelFrequencyGt != "" {

			if err := r.SetQueryParam("rf_channel_frequency__gt", qRfChannelFrequencyGt); err != nil {
				return err
			}
		}
	}

	if o.RfChannelFrequencyGte != nil {

		// query param rf_channel_frequency__gte
		var qrRfChannelFrequencyGte string

		if o.RfChannelFrequencyGte != nil {
			qrRfChannelFrequencyGte = *o.RfChannelFrequencyGte
		}
		qRfChannelFrequencyGte := qrRfChannelFrequencyGte
		if qRfChannelFrequencyGte != "" {

			if err := r.SetQueryParam("rf_channel_frequency__gte", qRfChannelFrequencyGte); err != nil {
				return err
			}
		}
	}

	if o.RfChannelFrequencyLt != nil {

		// query param rf_channel_frequency__lt
		var qrRfChannelFrequencyLt string

		if o.RfChannelFrequencyLt != nil {
			qrRfChannelFrequencyLt = *o.RfChannelFrequencyLt
		}
		qRfChannelFrequencyLt := qrRfChannelFrequencyLt
		if qRfChannelFrequencyLt != "" {

			if err := r.SetQueryParam("rf_channel_frequency__lt", qRfChannelFrequencyLt); err != nil {
				return err
			}
		}
	}

	if o.RfChannelFrequencyLte != nil {

		// query param rf_channel_frequency__lte
		var qrRfChannelFrequencyLte string

		if o.RfChannelFrequencyLte != nil {
			qrRfChannelFrequencyLte = *o.RfChannelFrequencyLte
		}
		qRfChannelFrequencyLte := qrRfChannelFrequencyLte
		if qRfChannelFrequencyLte != "" {

			if err := r.SetQueryParam("rf_channel_frequency__lte", qRfChannelFrequencyLte); err != nil {
				return err
			}
		}
	}

	if o.RfChannelFrequencyn != nil {

		// query param rf_channel_frequency__n
		var qrRfChannelFrequencyn string

		if o.RfChannelFrequencyn != nil {
			qrRfChannelFrequencyn = *o.RfChannelFrequencyn
		}
		qRfChannelFrequencyn := qrRfChannelFrequencyn
		if qRfChannelFrequencyn != "" {

			if err := r.SetQueryParam("rf_channel_frequency__n", qRfChannelFrequencyn); err != nil {
				return err
			}
		}
	}

	if o.RfChannelWidth != nil {

		// query param rf_channel_width
		var qrRfChannelWidth string

		if o.RfChannelWidth != nil {
			qrRfChannelWidth = *o.RfChannelWidth
		}
		qRfChannelWidth := qrRfChannelWidth
		if qRfChannelWidth != "" {

			if err := r.SetQueryParam("rf_channel_width", qRfChannelWidth); err != nil {
				return err
			}
		}
	}

	if o.RfChannelWidthGt != nil {

		// query param rf_channel_width__gt
		var qrRfChannelWidthGt string

		if o.RfChannelWidthGt != nil {
			qrRfChannelWidthGt = *o.RfChannelWidthGt
		}
		qRfChannelWidthGt := qrRfChannelWidthGt
		if qRfChannelWidthGt != "" {

			if err := r.SetQueryParam("rf_channel_width__gt", qRfChannelWidthGt); err != nil {
				return err
			}
		}
	}

	if o.RfChannelWidthGte != nil {

		// query param rf_channel_width__gte
		var qrRfChannelWidthGte string

		if o.RfChannelWidthGte != nil {
			qrRfChannelWidthGte = *o.RfChannelWidthGte
		}
		qRfChannelWidthGte := qrRfChannelWidthGte
		if qRfChannelWidthGte != "" {

			if err := r.SetQueryParam("rf_channel_width__gte", qRfChannelWidthGte); err != nil {
				return err
			}
		}
	}

	if o.RfChannelWidthLt != nil {

		// query param rf_channel_width__lt
		var qrRfChannelWidthLt string

		if o.RfChannelWidthLt != nil {
			qrRfChannelWidthLt = *o.RfChannelWidthLt
		}
		qRfChannelWidthLt := qrRfChannelWidthLt
		if qRfChannelWidthLt != "" {

			if err := r.SetQueryParam("rf_channel_width__lt", qRfChannelWidthLt); err != nil {
				return err
			}
		}
	}

	if o.RfChannelWidthLte != nil {

		// query param rf_channel_width__lte
		var qrRfChannelWidthLte string

		if o.RfChannelWidthLte != nil {
			qrRfChannelWidthLte = *o.RfChannelWidthLte
		}
		qRfChannelWidthLte := qrRfChannelWidthLte
		if qRfChannelWidthLte != "" {

			if err := r.SetQueryParam("rf_channel_width__lte", qRfChannelWidthLte); err != nil {
				return err
			}
		}
	}

	if o.RfChannelWidthn != nil {

		// query param rf_channel_width__n
		var qrRfChannelWidthn string

		if o.RfChannelWidthn != nil {
			qrRfChannelWidthn = *o.RfChannelWidthn
		}
		qRfChannelWidthn := qrRfChannelWidthn
		if qRfChannelWidthn != "" {

			if err := r.SetQueryParam("rf_channel_width__n", qRfChannelWidthn); err != nil {
				return err
			}
		}
	}

	if o.RfRole != nil {

		// query param rf_role
		var qrRfRole string

		if o.RfRole != nil {
			qrRfRole = *o.RfRole
		}
		qRfRole := qrRfRole
		if qRfRole != "" {

			if err := r.SetQueryParam("rf_role", qRfRole); err != nil {
				return err
			}
		}
	}

	if o.RfRolen != nil {

		// query param rf_role__n
		var qrRfRolen string

		if o.RfRolen != nil {
			qrRfRolen = *o.RfRolen
		}
		qRfRolen := qrRfRolen
		if qRfRolen != "" {

			if err := r.SetQueryParam("rf_role__n", qRfRolen); err != nil {
				return err
			}
		}
	}

	if o.Site != nil {

		// query param site
		var qrSite string

		if o.Site != nil {
			qrSite = *o.Site
		}
		qSite := qrSite
		if qSite != "" {

			if err := r.SetQueryParam("site", qSite); err != nil {
				return err
			}
		}
	}

	if o.Siten != nil {

		// query param site__n
		var qrSiten string

		if o.Siten != nil {
			qrSiten = *o.Siten
		}
		qSiten := qrSiten
		if qSiten != "" {

			if err := r.SetQueryParam("site__n", qSiten); err != nil {
				return err
			}
		}
	}

	if o.SiteGroup != nil {

		// query param site_group
		var qrSiteGroup string

		if o.SiteGroup != nil {
			qrSiteGroup = *o.SiteGroup
		}
		qSiteGroup := qrSiteGroup
		if qSiteGroup != "" {

			if err := r.SetQueryParam("site_group", qSiteGroup); err != nil {
				return err
			}
		}
	}

	if o.SiteGroupn != nil {

		// query param site_group__n
		var qrSiteGroupn string

		if o.SiteGroupn != nil {
			qrSiteGroupn = *o.SiteGroupn
		}
		qSiteGroupn := qrSiteGroupn
		if qSiteGroupn != "" {

			if err := r.SetQueryParam("site_group__n", qSiteGroupn); err != nil {
				return err
			}
		}
	}

	if o.SiteGroupID != nil {

		// query param site_group_id
		var qrSiteGroupID string

		if o.SiteGroupID != nil {
			qrSiteGroupID = *o.SiteGroupID
		}
		qSiteGroupID := qrSiteGroupID
		if qSiteGroupID != "" {

			if err := r.SetQueryParam("site_group_id", qSiteGroupID); err != nil {
				return err
			}
		}
	}

	if o.SiteGroupIDn != nil {

		// query param site_group_id__n
		var qrSiteGroupIDn string

		if o.SiteGroupIDn != nil {
			qrSiteGroupIDn = *o.SiteGroupIDn
		}
		qSiteGroupIDn := qrSiteGroupIDn
		if qSiteGroupIDn != "" {

			if err := r.SetQueryParam("site_group_id__n", qSiteGroupIDn); err != nil {
				return err
			}
		}
	}

	if o.SiteID != nil {

		// query param site_id
		var qrSiteID string

		if o.SiteID != nil {
			qrSiteID = *o.SiteID
		}
		qSiteID := qrSiteID
		if qSiteID != "" {

			if err := r.SetQueryParam("site_id", qSiteID); err != nil {
				return err
			}
		}
	}

	if o.SiteIDn != nil {

		// query param site_id__n
		var qrSiteIDn string

		if o.SiteIDn != nil {
			qrSiteIDn = *o.SiteIDn
		}
		qSiteIDn := qrSiteIDn
		if qSiteIDn != "" {

			if err := r.SetQueryParam("site_id__n", qSiteIDn); err != nil {
				return err
			}
		}
	}

	if o.Speed != nil {

		// query param speed
		var qrSpeed string

		if o.Speed != nil {
			qrSpeed = *o.Speed
		}
		qSpeed := qrSpeed
		if qSpeed != "" {

			if err := r.SetQueryParam("speed", qSpeed); err != nil {
				return err
			}
		}
	}

	if o.SpeedGt != nil {

		// query param speed__gt
		var qrSpeedGt string

		if o.SpeedGt != nil {
			qrSpeedGt = *o.SpeedGt
		}
		qSpeedGt := qrSpeedGt
		if qSpeedGt != "" {

			if err := r.SetQueryParam("speed__gt", qSpeedGt); err != nil {
				return err
			}
		}
	}

	if o.SpeedGte != nil {

		// query param speed__gte
		var qrSpeedGte string

		if o.SpeedGte != nil {
			qrSpeedGte = *o.SpeedGte
		}
		qSpeedGte := qrSpeedGte
		if qSpeedGte != "" {

			if err := r.SetQueryParam("speed__gte", qSpeedGte); err != nil {
				return err
			}
		}
	}

	if o.SpeedLt != nil {

		// query param speed__lt
		var qrSpeedLt string

		if o.SpeedLt != nil {
			qrSpeedLt = *o.SpeedLt
		}
		qSpeedLt := qrSpeedLt
		if qSpeedLt != "" {

			if err := r.SetQueryParam("speed__lt", qSpeedLt); err != nil {
				return err
			}
		}
	}

	if o.SpeedLte != nil {

		// query param speed__lte
		var qrSpeedLte string

		if o.SpeedLte != nil {
			qrSpeedLte = *o.SpeedLte
		}
		qSpeedLte := qrSpeedLte
		if qSpeedLte != "" {

			if err := r.SetQueryParam("speed__lte", qSpeedLte); err != nil {
				return err
			}
		}
	}

	if o.Speedn != nil {

		// query param speed__n
		var qrSpeedn string

		if o.Speedn != nil {
			qrSpeedn = *o.Speedn
		}
		qSpeedn := qrSpeedn
		if qSpeedn != "" {

			if err := r.SetQueryParam("speed__n", qSpeedn); err != nil {
				return err
			}
		}
	}

	if o.Tag != nil {

		// query param tag
		var qrTag string

		if o.Tag != nil {
			qrTag = *o.Tag
		}
		qTag := qrTag
		if qTag != "" {

			if err := r.SetQueryParam("tag", qTag); err != nil {
				return err
			}
		}
	}

	if o.Tagn != nil {

		// query param tag__n
		var qrTagn string

		if o.Tagn != nil {
			qrTagn = *o.Tagn
		}
		qTagn := qrTagn
		if qTagn != "" {

			if err := r.SetQueryParam("tag__n", qTagn); err != nil {
				return err
			}
		}
	}

	if o.TxPower != nil {

		// query param tx_power
		var qrTxPower string

		if o.TxPower != nil {
			qrTxPower = *o.TxPower
		}
		qTxPower := qrTxPower
		if qTxPower != "" {

			if err := r.SetQueryParam("tx_power", qTxPower); err != nil {
				return err
			}
		}
	}

	if o.TxPowerGt != nil {

		// query param tx_power__gt
		var qrTxPowerGt string

		if o.TxPowerGt != nil {
			qrTxPowerGt = *o.TxPowerGt
		}
		qTxPowerGt := qrTxPowerGt
		if qTxPowerGt != "" {

			if err := r.SetQueryParam("tx_power__gt", qTxPowerGt); err != nil {
				return err
			}
		}
	}

	if o.TxPowerGte != nil {

		// query param tx_power__gte
		var qrTxPowerGte string

		if o.TxPowerGte != nil {
			qrTxPowerGte = *o.TxPowerGte
		}
		qTxPowerGte := qrTxPowerGte
		if qTxPowerGte != "" {

			if err := r.SetQueryParam("tx_power__gte", qTxPowerGte); err != nil {
				return err
			}
		}
	}

	if o.TxPowerLt != nil {

		// query param tx_power__lt
		var qrTxPowerLt string

		if o.TxPowerLt != nil {
			qrTxPowerLt = *o.TxPowerLt
		}
		qTxPowerLt := qrTxPowerLt
		if qTxPowerLt != "" {

			if err := r.SetQueryParam("tx_power__lt", qTxPowerLt); err != nil {
				return err
			}
		}
	}

	if o.TxPowerLte != nil {

		// query param tx_power__lte
		var qrTxPowerLte string

		if o.TxPowerLte != nil {
			qrTxPowerLte = *o.TxPowerLte
		}
		qTxPowerLte := qrTxPowerLte
		if qTxPowerLte != "" {

			if err := r.SetQueryParam("tx_power__lte", qTxPowerLte); err != nil {
				return err
			}
		}
	}

	if o.TxPowern != nil {

		// query param tx_power__n
		var qrTxPowern string

		if o.TxPowern != nil {
			qrTxPowern = *o.TxPowern
		}
		qTxPowern := qrTxPowern
		if qTxPowern != "" {

			if err := r.SetQueryParam("tx_power__n", qTxPowern); err != nil {
				return err
			}
		}
	}

	if o.Type != nil {

		// query param type
		var qrType string

		if o.Type != nil {
			qrType = *o.Type
		}
		qType := qrType
		if qType != "" {

			if err := r.SetQueryParam("type", qType); err != nil {
				return err
			}
		}
	}

	if o.Typen != nil {

		// query param type__n
		var qrTypen string

		if o.Typen != nil {
			qrTypen = *o.Typen
		}
		qTypen := qrTypen
		if qTypen != "" {

			if err := r.SetQueryParam("type__n", qTypen); err != nil {
				return err
			}
		}
	}

	if o.VirtualChassis != nil {

		// query param virtual_chassis
		var qrVirtualChassis string

		if o.VirtualChassis != nil {
			qrVirtualChassis = *o.VirtualChassis
		}
		qVirtualChassis := qrVirtualChassis
		if qVirtualChassis != "" {

			if err := r.SetQueryParam("virtual_chassis", qVirtualChassis); err != nil {
				return err
			}
		}
	}

	if o.VirtualChassisn != nil {

		// query param virtual_chassis__n
		var qrVirtualChassisn string

		if o.VirtualChassisn != nil {
			qrVirtualChassisn = *o.VirtualChassisn
		}
		qVirtualChassisn := qrVirtualChassisn
		if qVirtualChassisn != "" {

			if err := r.SetQueryParam("virtual_chassis__n", qVirtualChassisn); err != nil {
				return err
			}
		}
	}

	if o.VirtualChassisID != nil {

		// query param virtual_chassis_id
		var qrVirtualChassisID string

		if o.VirtualChassisID != nil {
			qrVirtualChassisID = *o.VirtualChassisID
		}
		qVirtualChassisID := qrVirtualChassisID
		if qVirtualChassisID != "" {

			if err := r.SetQueryParam("virtual_chassis_id", qVirtualChassisID); err != nil {
				return err
			}
		}
	}

	if o.VirtualChassisIDn != nil {

		// query param virtual_chassis_id__n
		var qrVirtualChassisIDn string

		if o.VirtualChassisIDn != nil {
			qrVirtualChassisIDn = *o.VirtualChassisIDn
		}
		qVirtualChassisIDn := qrVirtualChassisIDn
		if qVirtualChassisIDn != "" {

			if err := r.SetQueryParam("virtual_chassis_id__n", qVirtualChassisIDn); err != nil {
				return err
			}
		}
	}

	if o.Vlan != nil {

		// query param vlan
		var qrVlan string

		if o.Vlan != nil {
			qrVlan = *o.Vlan
		}
		qVlan := qrVlan
		if qVlan != "" {

			if err := r.SetQueryParam("vlan", qVlan); err != nil {
				return err
			}
		}
	}

	if o.VlanID != nil {

		// query param vlan_id
		var qrVlanID string

		if o.VlanID != nil {
			qrVlanID = *o.VlanID
		}
		qVlanID := qrVlanID
		if qVlanID != "" {

			if err := r.SetQueryParam("vlan_id", qVlanID); err != nil {
				return err
			}
		}
	}

	if o.Vrf != nil {

		// query param vrf
		var qrVrf string

		if o.Vrf != nil {
			qrVrf = *o.Vrf
		}
		qVrf := qrVrf
		if qVrf != "" {

			if err := r.SetQueryParam("vrf", qVrf); err != nil {
				return err
			}
		}
	}

	if o.Vrfn != nil {

		// query param vrf__n
		var qrVrfn string

		if o.Vrfn != nil {
			qrVrfn = *o.Vrfn
		}
		qVrfn := qrVrfn
		if qVrfn != "" {

			if err := r.SetQueryParam("vrf__n", qVrfn); err != nil {
				return err
			}
		}
	}

	if o.VrfID != nil {

		// query param vrf_id
		var qrVrfID string

		if o.VrfID != nil {
			qrVrfID = *o.VrfID
		}
		qVrfID := qrVrfID
		if qVrfID != "" {

			if err := r.SetQueryParam("vrf_id", qVrfID); err != nil {
				return err
			}
		}
	}

	if o.VrfIDn != nil {

		// query param vrf_id__n
		var qrVrfIDn string

		if o.VrfIDn != nil {
			qrVrfIDn = *o.VrfIDn
		}
		qVrfIDn := qrVrfIDn
		if qVrfIDn != "" {

			if err := r.SetQueryParam("vrf_id__n", qVrfIDn); err != nil {
				return err
			}
		}
	}

	if o.Wwn != nil {

		// query param wwn
		var qrWwn string

		if o.Wwn != nil {
			qrWwn = *o.Wwn
		}
		qWwn := qrWwn
		if qWwn != "" {

			if err := r.SetQueryParam("wwn", qWwn); err != nil {
				return err
			}
		}
	}

	if o.WwnIc != nil {

		// query param wwn__ic
		var qrWwnIc string

		if o.WwnIc != nil {
			qrWwnIc = *o.WwnIc
		}
		qWwnIc := qrWwnIc
		if qWwnIc != "" {

			if err := r.SetQueryParam("wwn__ic", qWwnIc); err != nil {
				return err
			}
		}
	}

	if o.WwnIe != nil {

		// query param wwn__ie
		var qrWwnIe string

		if o.WwnIe != nil {
			qrWwnIe = *o.WwnIe
		}
		qWwnIe := qrWwnIe
		if qWwnIe != "" {

			if err := r.SetQueryParam("wwn__ie", qWwnIe); err != nil {
				return err
			}
		}
	}

	if o.WwnIew != nil {

		// query param wwn__iew
		var qrWwnIew string

		if o.WwnIew != nil {
			qrWwnIew = *o.WwnIew
		}
		qWwnIew := qrWwnIew
		if qWwnIew != "" {

			if err := r.SetQueryParam("wwn__iew", qWwnIew); err != nil {
				return err
			}
		}
	}

	if o.WwnIsw != nil {

		// query param wwn__isw
		var qrWwnIsw string

		if o.WwnIsw != nil {
			qrWwnIsw = *o.WwnIsw
		}
		qWwnIsw := qrWwnIsw
		if qWwnIsw != "" {

			if err := r.SetQueryParam("wwn__isw", qWwnIsw); err != nil {
				return err
			}
		}
	}

	if o.Wwnn != nil {

		// query param wwn__n
		var qrWwnn string

		if o.Wwnn != nil {
			qrWwnn = *o.Wwnn
		}
		qWwnn := qrWwnn
		if qWwnn != "" {

			if err := r.SetQueryParam("wwn__n", qWwnn); err != nil {
				return err
			}
		}
	}

	if o.WwnNic != nil {

		// query param wwn__nic
		var qrWwnNic string

		if o.WwnNic != nil {
			qrWwnNic = *o.WwnNic
		}
		qWwnNic := qrWwnNic
		if qWwnNic != "" {

			if err := r.SetQueryParam("wwn__nic", qWwnNic); err != nil {
				return err
			}
		}
	}

	if o.WwnNie != nil {

		// query param wwn__nie
		var qrWwnNie string

		if o.WwnNie != nil {
			qrWwnNie = *o.WwnNie
		}
		qWwnNie := qrWwnNie
		if qWwnNie != "" {

			if err := r.SetQueryParam("wwn__nie", qWwnNie); err != nil {
				return err
			}
		}
	}

	if o.WwnNiew != nil {

		// query param wwn__niew
		var qrWwnNiew string

		if o.WwnNiew != nil {
			qrWwnNiew = *o.WwnNiew
		}
		qWwnNiew := qrWwnNiew
		if qWwnNiew != "" {

			if err := r.SetQueryParam("wwn__niew", qWwnNiew); err != nil {
				return err
			}
		}
	}

	if o.WwnNisw != nil {

		// query param wwn__nisw
		var qrWwnNisw string

		if o.WwnNisw != nil {
			qrWwnNisw = *o.WwnNisw
		}
		qWwnNisw := qrWwnNisw
		if qWwnNisw != "" {

			if err := r.SetQueryParam("wwn__nisw", qWwnNisw); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
