// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2020 The go-netbox Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package dcim

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewDcimInventoryItemTemplatesListParams creates a new DcimInventoryItemTemplatesListParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDcimInventoryItemTemplatesListParams() *DcimInventoryItemTemplatesListParams {
	return &DcimInventoryItemTemplatesListParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDcimInventoryItemTemplatesListParamsWithTimeout creates a new DcimInventoryItemTemplatesListParams object
// with the ability to set a timeout on a request.
func NewDcimInventoryItemTemplatesListParamsWithTimeout(timeout time.Duration) *DcimInventoryItemTemplatesListParams {
	return &DcimInventoryItemTemplatesListParams{
		timeout: timeout,
	}
}

// NewDcimInventoryItemTemplatesListParamsWithContext creates a new DcimInventoryItemTemplatesListParams object
// with the ability to set a context for a request.
func NewDcimInventoryItemTemplatesListParamsWithContext(ctx context.Context) *DcimInventoryItemTemplatesListParams {
	return &DcimInventoryItemTemplatesListParams{
		Context: ctx,
	}
}

// NewDcimInventoryItemTemplatesListParamsWithHTTPClient creates a new DcimInventoryItemTemplatesListParams object
// with the ability to set a custom HTTPClient for a request.
func NewDcimInventoryItemTemplatesListParamsWithHTTPClient(client *http.Client) *DcimInventoryItemTemplatesListParams {
	return &DcimInventoryItemTemplatesListParams{
		HTTPClient: client,
	}
}

/* DcimInventoryItemTemplatesListParams contains all the parameters to send to the API endpoint
   for the dcim inventory item templates list operation.

   Typically these are written to a http.Request.
*/
type DcimInventoryItemTemplatesListParams struct {

	// ComponentID.
	ComponentID *string

	// ComponentIDGt.
	ComponentIDGt *string

	// ComponentIDGte.
	ComponentIDGte *string

	// ComponentIDLt.
	ComponentIDLt *string

	// ComponentIDLte.
	ComponentIDLte *string

	// ComponentIDn.
	ComponentIDn *string

	// ComponentType.
	ComponentType *string

	// ComponentTypen.
	ComponentTypen *string

	// Created.
	Created *string

	// CreatedGte.
	CreatedGte *string

	// CreatedLte.
	CreatedLte *string

	// DevicetypeID.
	DevicetypeID *string

	// DevicetypeIDn.
	DevicetypeIDn *string

	// ID.
	ID *string

	// IDGt.
	IDGt *string

	// IDGte.
	IDGte *string

	// IDLt.
	IDLt *string

	// IDLte.
	IDLte *string

	// IDn.
	IDn *string

	// Label.
	Label *string

	// LabelIc.
	LabelIc *string

	// LabelIe.
	LabelIe *string

	// LabelIew.
	LabelIew *string

	// LabelIsw.
	LabelIsw *string

	// Labeln.
	Labeln *string

	// LabelNic.
	LabelNic *string

	// LabelNie.
	LabelNie *string

	// LabelNiew.
	LabelNiew *string

	// LabelNisw.
	LabelNisw *string

	// LastUpdated.
	LastUpdated *string

	// LastUpdatedGte.
	LastUpdatedGte *string

	// LastUpdatedLte.
	LastUpdatedLte *string

	/* Limit.

	   Number of results to return per page.
	*/
	Limit *int64

	// Manufacturer.
	Manufacturer *string

	// Manufacturern.
	Manufacturern *string

	// ManufacturerID.
	ManufacturerID *string

	// ManufacturerIDn.
	ManufacturerIDn *string

	// Name.
	Name *string

	// NameIc.
	NameIc *string

	// NameIe.
	NameIe *string

	// NameIew.
	NameIew *string

	// NameIsw.
	NameIsw *string

	// Namen.
	Namen *string

	// NameNic.
	NameNic *string

	// NameNie.
	NameNie *string

	// NameNiew.
	NameNiew *string

	// NameNisw.
	NameNisw *string

	/* Offset.

	   The initial index from which to return the results.
	*/
	Offset *int64

	// ParentID.
	ParentID *string

	// ParentIDn.
	ParentIDn *string

	// PartID.
	PartID *string

	// PartIDIc.
	PartIDIc *string

	// PartIDIe.
	PartIDIe *string

	// PartIDIew.
	PartIDIew *string

	// PartIDIsw.
	PartIDIsw *string

	// PartIDn.
	PartIDn *string

	// PartIDNic.
	PartIDNic *string

	// PartIDNie.
	PartIDNie *string

	// PartIDNiew.
	PartIDNiew *string

	// PartIDNisw.
	PartIDNisw *string

	// Q.
	Q *string

	// Role.
	Role *string

	// Rolen.
	Rolen *string

	// RoleID.
	RoleID *string

	// RoleIDn.
	RoleIDn *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the dcim inventory item templates list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DcimInventoryItemTemplatesListParams) WithDefaults() *DcimInventoryItemTemplatesListParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the dcim inventory item templates list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DcimInventoryItemTemplatesListParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithTimeout(timeout time.Duration) *DcimInventoryItemTemplatesListParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithContext(ctx context.Context) *DcimInventoryItemTemplatesListParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithHTTPClient(client *http.Client) *DcimInventoryItemTemplatesListParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithComponentID adds the componentID to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithComponentID(componentID *string) *DcimInventoryItemTemplatesListParams {
	o.SetComponentID(componentID)
	return o
}

// SetComponentID adds the componentId to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetComponentID(componentID *string) {
	o.ComponentID = componentID
}

// WithComponentIDGt adds the componentIDGt to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithComponentIDGt(componentIDGt *string) *DcimInventoryItemTemplatesListParams {
	o.SetComponentIDGt(componentIDGt)
	return o
}

// SetComponentIDGt adds the componentIdGt to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetComponentIDGt(componentIDGt *string) {
	o.ComponentIDGt = componentIDGt
}

// WithComponentIDGte adds the componentIDGte to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithComponentIDGte(componentIDGte *string) *DcimInventoryItemTemplatesListParams {
	o.SetComponentIDGte(componentIDGte)
	return o
}

// SetComponentIDGte adds the componentIdGte to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetComponentIDGte(componentIDGte *string) {
	o.ComponentIDGte = componentIDGte
}

// WithComponentIDLt adds the componentIDLt to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithComponentIDLt(componentIDLt *string) *DcimInventoryItemTemplatesListParams {
	o.SetComponentIDLt(componentIDLt)
	return o
}

// SetComponentIDLt adds the componentIdLt to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetComponentIDLt(componentIDLt *string) {
	o.ComponentIDLt = componentIDLt
}

// WithComponentIDLte adds the componentIDLte to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithComponentIDLte(componentIDLte *string) *DcimInventoryItemTemplatesListParams {
	o.SetComponentIDLte(componentIDLte)
	return o
}

// SetComponentIDLte adds the componentIdLte to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetComponentIDLte(componentIDLte *string) {
	o.ComponentIDLte = componentIDLte
}

// WithComponentIDn adds the componentIDn to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithComponentIDn(componentIDn *string) *DcimInventoryItemTemplatesListParams {
	o.SetComponentIDn(componentIDn)
	return o
}

// SetComponentIDn adds the componentIdN to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetComponentIDn(componentIDn *string) {
	o.ComponentIDn = componentIDn
}

// WithComponentType adds the componentType to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithComponentType(componentType *string) *DcimInventoryItemTemplatesListParams {
	o.SetComponentType(componentType)
	return o
}

// SetComponentType adds the componentType to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetComponentType(componentType *string) {
	o.ComponentType = componentType
}

// WithComponentTypen adds the componentTypen to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithComponentTypen(componentTypen *string) *DcimInventoryItemTemplatesListParams {
	o.SetComponentTypen(componentTypen)
	return o
}

// SetComponentTypen adds the componentTypeN to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetComponentTypen(componentTypen *string) {
	o.ComponentTypen = componentTypen
}

// WithCreated adds the created to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithCreated(created *string) *DcimInventoryItemTemplatesListParams {
	o.SetCreated(created)
	return o
}

// SetCreated adds the created to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetCreated(created *string) {
	o.Created = created
}

// WithCreatedGte adds the createdGte to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithCreatedGte(createdGte *string) *DcimInventoryItemTemplatesListParams {
	o.SetCreatedGte(createdGte)
	return o
}

// SetCreatedGte adds the createdGte to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetCreatedGte(createdGte *string) {
	o.CreatedGte = createdGte
}

// WithCreatedLte adds the createdLte to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithCreatedLte(createdLte *string) *DcimInventoryItemTemplatesListParams {
	o.SetCreatedLte(createdLte)
	return o
}

// SetCreatedLte adds the createdLte to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetCreatedLte(createdLte *string) {
	o.CreatedLte = createdLte
}

// WithDevicetypeID adds the devicetypeID to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithDevicetypeID(devicetypeID *string) *DcimInventoryItemTemplatesListParams {
	o.SetDevicetypeID(devicetypeID)
	return o
}

// SetDevicetypeID adds the devicetypeId to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetDevicetypeID(devicetypeID *string) {
	o.DevicetypeID = devicetypeID
}

// WithDevicetypeIDn adds the devicetypeIDn to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithDevicetypeIDn(devicetypeIDn *string) *DcimInventoryItemTemplatesListParams {
	o.SetDevicetypeIDn(devicetypeIDn)
	return o
}

// SetDevicetypeIDn adds the devicetypeIdN to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetDevicetypeIDn(devicetypeIDn *string) {
	o.DevicetypeIDn = devicetypeIDn
}

// WithID adds the id to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithID(id *string) *DcimInventoryItemTemplatesListParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetID(id *string) {
	o.ID = id
}

// WithIDGt adds the iDGt to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithIDGt(iDGt *string) *DcimInventoryItemTemplatesListParams {
	o.SetIDGt(iDGt)
	return o
}

// SetIDGt adds the idGt to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetIDGt(iDGt *string) {
	o.IDGt = iDGt
}

// WithIDGte adds the iDGte to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithIDGte(iDGte *string) *DcimInventoryItemTemplatesListParams {
	o.SetIDGte(iDGte)
	return o
}

// SetIDGte adds the idGte to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetIDGte(iDGte *string) {
	o.IDGte = iDGte
}

// WithIDLt adds the iDLt to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithIDLt(iDLt *string) *DcimInventoryItemTemplatesListParams {
	o.SetIDLt(iDLt)
	return o
}

// SetIDLt adds the idLt to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetIDLt(iDLt *string) {
	o.IDLt = iDLt
}

// WithIDLte adds the iDLte to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithIDLte(iDLte *string) *DcimInventoryItemTemplatesListParams {
	o.SetIDLte(iDLte)
	return o
}

// SetIDLte adds the idLte to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetIDLte(iDLte *string) {
	o.IDLte = iDLte
}

// WithIDn adds the iDn to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithIDn(iDn *string) *DcimInventoryItemTemplatesListParams {
	o.SetIDn(iDn)
	return o
}

// SetIDn adds the idN to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetIDn(iDn *string) {
	o.IDn = iDn
}

// WithLabel adds the label to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithLabel(label *string) *DcimInventoryItemTemplatesListParams {
	o.SetLabel(label)
	return o
}

// SetLabel adds the label to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetLabel(label *string) {
	o.Label = label
}

// WithLabelIc adds the labelIc to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithLabelIc(labelIc *string) *DcimInventoryItemTemplatesListParams {
	o.SetLabelIc(labelIc)
	return o
}

// SetLabelIc adds the labelIc to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetLabelIc(labelIc *string) {
	o.LabelIc = labelIc
}

// WithLabelIe adds the labelIe to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithLabelIe(labelIe *string) *DcimInventoryItemTemplatesListParams {
	o.SetLabelIe(labelIe)
	return o
}

// SetLabelIe adds the labelIe to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetLabelIe(labelIe *string) {
	o.LabelIe = labelIe
}

// WithLabelIew adds the labelIew to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithLabelIew(labelIew *string) *DcimInventoryItemTemplatesListParams {
	o.SetLabelIew(labelIew)
	return o
}

// SetLabelIew adds the labelIew to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetLabelIew(labelIew *string) {
	o.LabelIew = labelIew
}

// WithLabelIsw adds the labelIsw to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithLabelIsw(labelIsw *string) *DcimInventoryItemTemplatesListParams {
	o.SetLabelIsw(labelIsw)
	return o
}

// SetLabelIsw adds the labelIsw to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetLabelIsw(labelIsw *string) {
	o.LabelIsw = labelIsw
}

// WithLabeln adds the labeln to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithLabeln(labeln *string) *DcimInventoryItemTemplatesListParams {
	o.SetLabeln(labeln)
	return o
}

// SetLabeln adds the labelN to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetLabeln(labeln *string) {
	o.Labeln = labeln
}

// WithLabelNic adds the labelNic to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithLabelNic(labelNic *string) *DcimInventoryItemTemplatesListParams {
	o.SetLabelNic(labelNic)
	return o
}

// SetLabelNic adds the labelNic to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetLabelNic(labelNic *string) {
	o.LabelNic = labelNic
}

// WithLabelNie adds the labelNie to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithLabelNie(labelNie *string) *DcimInventoryItemTemplatesListParams {
	o.SetLabelNie(labelNie)
	return o
}

// SetLabelNie adds the labelNie to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetLabelNie(labelNie *string) {
	o.LabelNie = labelNie
}

// WithLabelNiew adds the labelNiew to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithLabelNiew(labelNiew *string) *DcimInventoryItemTemplatesListParams {
	o.SetLabelNiew(labelNiew)
	return o
}

// SetLabelNiew adds the labelNiew to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetLabelNiew(labelNiew *string) {
	o.LabelNiew = labelNiew
}

// WithLabelNisw adds the labelNisw to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithLabelNisw(labelNisw *string) *DcimInventoryItemTemplatesListParams {
	o.SetLabelNisw(labelNisw)
	return o
}

// SetLabelNisw adds the labelNisw to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetLabelNisw(labelNisw *string) {
	o.LabelNisw = labelNisw
}

// WithLastUpdated adds the lastUpdated to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithLastUpdated(lastUpdated *string) *DcimInventoryItemTemplatesListParams {
	o.SetLastUpdated(lastUpdated)
	return o
}

// SetLastUpdated adds the lastUpdated to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetLastUpdated(lastUpdated *string) {
	o.LastUpdated = lastUpdated
}

// WithLastUpdatedGte adds the lastUpdatedGte to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithLastUpdatedGte(lastUpdatedGte *string) *DcimInventoryItemTemplatesListParams {
	o.SetLastUpdatedGte(lastUpdatedGte)
	return o
}

// SetLastUpdatedGte adds the lastUpdatedGte to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetLastUpdatedGte(lastUpdatedGte *string) {
	o.LastUpdatedGte = lastUpdatedGte
}

// WithLastUpdatedLte adds the lastUpdatedLte to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithLastUpdatedLte(lastUpdatedLte *string) *DcimInventoryItemTemplatesListParams {
	o.SetLastUpdatedLte(lastUpdatedLte)
	return o
}

// SetLastUpdatedLte adds the lastUpdatedLte to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetLastUpdatedLte(lastUpdatedLte *string) {
	o.LastUpdatedLte = lastUpdatedLte
}

// WithLimit adds the limit to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithLimit(limit *int64) *DcimInventoryItemTemplatesListParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithManufacturer adds the manufacturer to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithManufacturer(manufacturer *string) *DcimInventoryItemTemplatesListParams {
	o.SetManufacturer(manufacturer)
	return o
}

// SetManufacturer adds the manufacturer to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetManufacturer(manufacturer *string) {
	o.Manufacturer = manufacturer
}

// WithManufacturern adds the manufacturern to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithManufacturern(manufacturern *string) *DcimInventoryItemTemplatesListParams {
	o.SetManufacturern(manufacturern)
	return o
}

// SetManufacturern adds the manufacturerN to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetManufacturern(manufacturern *string) {
	o.Manufacturern = manufacturern
}

// WithManufacturerID adds the manufacturerID to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithManufacturerID(manufacturerID *string) *DcimInventoryItemTemplatesListParams {
	o.SetManufacturerID(manufacturerID)
	return o
}

// SetManufacturerID adds the manufacturerId to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetManufacturerID(manufacturerID *string) {
	o.ManufacturerID = manufacturerID
}

// WithManufacturerIDn adds the manufacturerIDn to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithManufacturerIDn(manufacturerIDn *string) *DcimInventoryItemTemplatesListParams {
	o.SetManufacturerIDn(manufacturerIDn)
	return o
}

// SetManufacturerIDn adds the manufacturerIdN to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetManufacturerIDn(manufacturerIDn *string) {
	o.ManufacturerIDn = manufacturerIDn
}

// WithName adds the name to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithName(name *string) *DcimInventoryItemTemplatesListParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetName(name *string) {
	o.Name = name
}

// WithNameIc adds the nameIc to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithNameIc(nameIc *string) *DcimInventoryItemTemplatesListParams {
	o.SetNameIc(nameIc)
	return o
}

// SetNameIc adds the nameIc to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetNameIc(nameIc *string) {
	o.NameIc = nameIc
}

// WithNameIe adds the nameIe to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithNameIe(nameIe *string) *DcimInventoryItemTemplatesListParams {
	o.SetNameIe(nameIe)
	return o
}

// SetNameIe adds the nameIe to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetNameIe(nameIe *string) {
	o.NameIe = nameIe
}

// WithNameIew adds the nameIew to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithNameIew(nameIew *string) *DcimInventoryItemTemplatesListParams {
	o.SetNameIew(nameIew)
	return o
}

// SetNameIew adds the nameIew to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetNameIew(nameIew *string) {
	o.NameIew = nameIew
}

// WithNameIsw adds the nameIsw to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithNameIsw(nameIsw *string) *DcimInventoryItemTemplatesListParams {
	o.SetNameIsw(nameIsw)
	return o
}

// SetNameIsw adds the nameIsw to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetNameIsw(nameIsw *string) {
	o.NameIsw = nameIsw
}

// WithNamen adds the namen to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithNamen(namen *string) *DcimInventoryItemTemplatesListParams {
	o.SetNamen(namen)
	return o
}

// SetNamen adds the nameN to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetNamen(namen *string) {
	o.Namen = namen
}

// WithNameNic adds the nameNic to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithNameNic(nameNic *string) *DcimInventoryItemTemplatesListParams {
	o.SetNameNic(nameNic)
	return o
}

// SetNameNic adds the nameNic to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetNameNic(nameNic *string) {
	o.NameNic = nameNic
}

// WithNameNie adds the nameNie to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithNameNie(nameNie *string) *DcimInventoryItemTemplatesListParams {
	o.SetNameNie(nameNie)
	return o
}

// SetNameNie adds the nameNie to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetNameNie(nameNie *string) {
	o.NameNie = nameNie
}

// WithNameNiew adds the nameNiew to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithNameNiew(nameNiew *string) *DcimInventoryItemTemplatesListParams {
	o.SetNameNiew(nameNiew)
	return o
}

// SetNameNiew adds the nameNiew to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetNameNiew(nameNiew *string) {
	o.NameNiew = nameNiew
}

// WithNameNisw adds the nameNisw to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithNameNisw(nameNisw *string) *DcimInventoryItemTemplatesListParams {
	o.SetNameNisw(nameNisw)
	return o
}

// SetNameNisw adds the nameNisw to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetNameNisw(nameNisw *string) {
	o.NameNisw = nameNisw
}

// WithOffset adds the offset to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithOffset(offset *int64) *DcimInventoryItemTemplatesListParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithParentID adds the parentID to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithParentID(parentID *string) *DcimInventoryItemTemplatesListParams {
	o.SetParentID(parentID)
	return o
}

// SetParentID adds the parentId to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetParentID(parentID *string) {
	o.ParentID = parentID
}

// WithParentIDn adds the parentIDn to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithParentIDn(parentIDn *string) *DcimInventoryItemTemplatesListParams {
	o.SetParentIDn(parentIDn)
	return o
}

// SetParentIDn adds the parentIdN to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetParentIDn(parentIDn *string) {
	o.ParentIDn = parentIDn
}

// WithPartID adds the partID to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithPartID(partID *string) *DcimInventoryItemTemplatesListParams {
	o.SetPartID(partID)
	return o
}

// SetPartID adds the partId to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetPartID(partID *string) {
	o.PartID = partID
}

// WithPartIDIc adds the partIDIc to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithPartIDIc(partIDIc *string) *DcimInventoryItemTemplatesListParams {
	o.SetPartIDIc(partIDIc)
	return o
}

// SetPartIDIc adds the partIdIc to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetPartIDIc(partIDIc *string) {
	o.PartIDIc = partIDIc
}

// WithPartIDIe adds the partIDIe to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithPartIDIe(partIDIe *string) *DcimInventoryItemTemplatesListParams {
	o.SetPartIDIe(partIDIe)
	return o
}

// SetPartIDIe adds the partIdIe to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetPartIDIe(partIDIe *string) {
	o.PartIDIe = partIDIe
}

// WithPartIDIew adds the partIDIew to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithPartIDIew(partIDIew *string) *DcimInventoryItemTemplatesListParams {
	o.SetPartIDIew(partIDIew)
	return o
}

// SetPartIDIew adds the partIdIew to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetPartIDIew(partIDIew *string) {
	o.PartIDIew = partIDIew
}

// WithPartIDIsw adds the partIDIsw to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithPartIDIsw(partIDIsw *string) *DcimInventoryItemTemplatesListParams {
	o.SetPartIDIsw(partIDIsw)
	return o
}

// SetPartIDIsw adds the partIdIsw to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetPartIDIsw(partIDIsw *string) {
	o.PartIDIsw = partIDIsw
}

// WithPartIDn adds the partIDn to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithPartIDn(partIDn *string) *DcimInventoryItemTemplatesListParams {
	o.SetPartIDn(partIDn)
	return o
}

// SetPartIDn adds the partIdN to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetPartIDn(partIDn *string) {
	o.PartIDn = partIDn
}

// WithPartIDNic adds the partIDNic to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithPartIDNic(partIDNic *string) *DcimInventoryItemTemplatesListParams {
	o.SetPartIDNic(partIDNic)
	return o
}

// SetPartIDNic adds the partIdNic to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetPartIDNic(partIDNic *string) {
	o.PartIDNic = partIDNic
}

// WithPartIDNie adds the partIDNie to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithPartIDNie(partIDNie *string) *DcimInventoryItemTemplatesListParams {
	o.SetPartIDNie(partIDNie)
	return o
}

// SetPartIDNie adds the partIdNie to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetPartIDNie(partIDNie *string) {
	o.PartIDNie = partIDNie
}

// WithPartIDNiew adds the partIDNiew to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithPartIDNiew(partIDNiew *string) *DcimInventoryItemTemplatesListParams {
	o.SetPartIDNiew(partIDNiew)
	return o
}

// SetPartIDNiew adds the partIdNiew to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetPartIDNiew(partIDNiew *string) {
	o.PartIDNiew = partIDNiew
}

// WithPartIDNisw adds the partIDNisw to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithPartIDNisw(partIDNisw *string) *DcimInventoryItemTemplatesListParams {
	o.SetPartIDNisw(partIDNisw)
	return o
}

// SetPartIDNisw adds the partIdNisw to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetPartIDNisw(partIDNisw *string) {
	o.PartIDNisw = partIDNisw
}

// WithQ adds the q to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithQ(q *string) *DcimInventoryItemTemplatesListParams {
	o.SetQ(q)
	return o
}

// SetQ adds the q to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetQ(q *string) {
	o.Q = q
}

// WithRole adds the role to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithRole(role *string) *DcimInventoryItemTemplatesListParams {
	o.SetRole(role)
	return o
}

// SetRole adds the role to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetRole(role *string) {
	o.Role = role
}

// WithRolen adds the rolen to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithRolen(rolen *string) *DcimInventoryItemTemplatesListParams {
	o.SetRolen(rolen)
	return o
}

// SetRolen adds the roleN to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetRolen(rolen *string) {
	o.Rolen = rolen
}

// WithRoleID adds the roleID to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithRoleID(roleID *string) *DcimInventoryItemTemplatesListParams {
	o.SetRoleID(roleID)
	return o
}

// SetRoleID adds the roleId to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetRoleID(roleID *string) {
	o.RoleID = roleID
}

// WithRoleIDn adds the roleIDn to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) WithRoleIDn(roleIDn *string) *DcimInventoryItemTemplatesListParams {
	o.SetRoleIDn(roleIDn)
	return o
}

// SetRoleIDn adds the roleIdN to the dcim inventory item templates list params
func (o *DcimInventoryItemTemplatesListParams) SetRoleIDn(roleIDn *string) {
	o.RoleIDn = roleIDn
}

// WriteToRequest writes these params to a swagger request
func (o *DcimInventoryItemTemplatesListParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.ComponentID != nil {

		// query param component_id
		var qrComponentID string

		if o.ComponentID != nil {
			qrComponentID = *o.ComponentID
		}
		qComponentID := qrComponentID
		if qComponentID != "" {

			if err := r.SetQueryParam("component_id", qComponentID); err != nil {
				return err
			}
		}
	}

	if o.ComponentIDGt != nil {

		// query param component_id__gt
		var qrComponentIDGt string

		if o.ComponentIDGt != nil {
			qrComponentIDGt = *o.ComponentIDGt
		}
		qComponentIDGt := qrComponentIDGt
		if qComponentIDGt != "" {

			if err := r.SetQueryParam("component_id__gt", qComponentIDGt); err != nil {
				return err
			}
		}
	}

	if o.ComponentIDGte != nil {

		// query param component_id__gte
		var qrComponentIDGte string

		if o.ComponentIDGte != nil {
			qrComponentIDGte = *o.ComponentIDGte
		}
		qComponentIDGte := qrComponentIDGte
		if qComponentIDGte != "" {

			if err := r.SetQueryParam("component_id__gte", qComponentIDGte); err != nil {
				return err
			}
		}
	}

	if o.ComponentIDLt != nil {

		// query param component_id__lt
		var qrComponentIDLt string

		if o.ComponentIDLt != nil {
			qrComponentIDLt = *o.ComponentIDLt
		}
		qComponentIDLt := qrComponentIDLt
		if qComponentIDLt != "" {

			if err := r.SetQueryParam("component_id__lt", qComponentIDLt); err != nil {
				return err
			}
		}
	}

	if o.ComponentIDLte != nil {

		// query param component_id__lte
		var qrComponentIDLte string

		if o.ComponentIDLte != nil {
			qrComponentIDLte = *o.ComponentIDLte
		}
		qComponentIDLte := qrComponentIDLte
		if qComponentIDLte != "" {

			if err := r.SetQueryParam("component_id__lte", qComponentIDLte); err != nil {
				return err
			}
		}
	}

	if o.ComponentIDn != nil {

		// query param component_id__n
		var qrComponentIDn string

		if o.ComponentIDn != nil {
			qrComponentIDn = *o.ComponentIDn
		}
		qComponentIDn := qrComponentIDn
		if qComponentIDn != "" {

			if err := r.SetQueryParam("component_id__n", qComponentIDn); err != nil {
				return err
			}
		}
	}

	if o.ComponentType != nil {

		// query param component_type
		var qrComponentType string

		if o.ComponentType != nil {
			qrComponentType = *o.ComponentType
		}
		qComponentType := qrComponentType
		if qComponentType != "" {

			if err := r.SetQueryParam("component_type", qComponentType); err != nil {
				return err
			}
		}
	}

	if o.ComponentTypen != nil {

		// query param component_type__n
		var qrComponentTypen string

		if o.ComponentTypen != nil {
			qrComponentTypen = *o.ComponentTypen
		}
		qComponentTypen := qrComponentTypen
		if qComponentTypen != "" {

			if err := r.SetQueryParam("component_type__n", qComponentTypen); err != nil {
				return err
			}
		}
	}

	if o.Created != nil {

		// query param created
		var qrCreated string

		if o.Created != nil {
			qrCreated = *o.Created
		}
		qCreated := qrCreated
		if qCreated != "" {

			if err := r.SetQueryParam("created", qCreated); err != nil {
				return err
			}
		}
	}

	if o.CreatedGte != nil {

		// query param created__gte
		var qrCreatedGte string

		if o.CreatedGte != nil {
			qrCreatedGte = *o.CreatedGte
		}
		qCreatedGte := qrCreatedGte
		if qCreatedGte != "" {

			if err := r.SetQueryParam("created__gte", qCreatedGte); err != nil {
				return err
			}
		}
	}

	if o.CreatedLte != nil {

		// query param created__lte
		var qrCreatedLte string

		if o.CreatedLte != nil {
			qrCreatedLte = *o.CreatedLte
		}
		qCreatedLte := qrCreatedLte
		if qCreatedLte != "" {

			if err := r.SetQueryParam("created__lte", qCreatedLte); err != nil {
				return err
			}
		}
	}

	if o.DevicetypeID != nil {

		// query param devicetype_id
		var qrDevicetypeID string

		if o.DevicetypeID != nil {
			qrDevicetypeID = *o.DevicetypeID
		}
		qDevicetypeID := qrDevicetypeID
		if qDevicetypeID != "" {

			if err := r.SetQueryParam("devicetype_id", qDevicetypeID); err != nil {
				return err
			}
		}
	}

	if o.DevicetypeIDn != nil {

		// query param devicetype_id__n
		var qrDevicetypeIDn string

		if o.DevicetypeIDn != nil {
			qrDevicetypeIDn = *o.DevicetypeIDn
		}
		qDevicetypeIDn := qrDevicetypeIDn
		if qDevicetypeIDn != "" {

			if err := r.SetQueryParam("devicetype_id__n", qDevicetypeIDn); err != nil {
				return err
			}
		}
	}

	if o.ID != nil {

		// query param id
		var qrID string

		if o.ID != nil {
			qrID = *o.ID
		}
		qID := qrID
		if qID != "" {

			if err := r.SetQueryParam("id", qID); err != nil {
				return err
			}
		}
	}

	if o.IDGt != nil {

		// query param id__gt
		var qrIDGt string

		if o.IDGt != nil {
			qrIDGt = *o.IDGt
		}
		qIDGt := qrIDGt
		if qIDGt != "" {

			if err := r.SetQueryParam("id__gt", qIDGt); err != nil {
				return err
			}
		}
	}

	if o.IDGte != nil {

		// query param id__gte
		var qrIDGte string

		if o.IDGte != nil {
			qrIDGte = *o.IDGte
		}
		qIDGte := qrIDGte
		if qIDGte != "" {

			if err := r.SetQueryParam("id__gte", qIDGte); err != nil {
				return err
			}
		}
	}

	if o.IDLt != nil {

		// query param id__lt
		var qrIDLt string

		if o.IDLt != nil {
			qrIDLt = *o.IDLt
		}
		qIDLt := qrIDLt
		if qIDLt != "" {

			if err := r.SetQueryParam("id__lt", qIDLt); err != nil {
				return err
			}
		}
	}

	if o.IDLte != nil {

		// query param id__lte
		var qrIDLte string

		if o.IDLte != nil {
			qrIDLte = *o.IDLte
		}
		qIDLte := qrIDLte
		if qIDLte != "" {

			if err := r.SetQueryParam("id__lte", qIDLte); err != nil {
				return err
			}
		}
	}

	if o.IDn != nil {

		// query param id__n
		var qrIDn string

		if o.IDn != nil {
			qrIDn = *o.IDn
		}
		qIDn := qrIDn
		if qIDn != "" {

			if err := r.SetQueryParam("id__n", qIDn); err != nil {
				return err
			}
		}
	}

	if o.Label != nil {

		// query param label
		var qrLabel string

		if o.Label != nil {
			qrLabel = *o.Label
		}
		qLabel := qrLabel
		if qLabel != "" {

			if err := r.SetQueryParam("label", qLabel); err != nil {
				return err
			}
		}
	}

	if o.LabelIc != nil {

		// query param label__ic
		var qrLabelIc string

		if o.LabelIc != nil {
			qrLabelIc = *o.LabelIc
		}
		qLabelIc := qrLabelIc
		if qLabelIc != "" {

			if err := r.SetQueryParam("label__ic", qLabelIc); err != nil {
				return err
			}
		}
	}

	if o.LabelIe != nil {

		// query param label__ie
		var qrLabelIe string

		if o.LabelIe != nil {
			qrLabelIe = *o.LabelIe
		}
		qLabelIe := qrLabelIe
		if qLabelIe != "" {

			if err := r.SetQueryParam("label__ie", qLabelIe); err != nil {
				return err
			}
		}
	}

	if o.LabelIew != nil {

		// query param label__iew
		var qrLabelIew string

		if o.LabelIew != nil {
			qrLabelIew = *o.LabelIew
		}
		qLabelIew := qrLabelIew
		if qLabelIew != "" {

			if err := r.SetQueryParam("label__iew", qLabelIew); err != nil {
				return err
			}
		}
	}

	if o.LabelIsw != nil {

		// query param label__isw
		var qrLabelIsw string

		if o.LabelIsw != nil {
			qrLabelIsw = *o.LabelIsw
		}
		qLabelIsw := qrLabelIsw
		if qLabelIsw != "" {

			if err := r.SetQueryParam("label__isw", qLabelIsw); err != nil {
				return err
			}
		}
	}

	if o.Labeln != nil {

		// query param label__n
		var qrLabeln string

		if o.Labeln != nil {
			qrLabeln = *o.Labeln
		}
		qLabeln := qrLabeln
		if qLabeln != "" {

			if err := r.SetQueryParam("label__n", qLabeln); err != nil {
				return err
			}
		}
	}

	if o.LabelNic != nil {

		// query param label__nic
		var qrLabelNic string

		if o.LabelNic != nil {
			qrLabelNic = *o.LabelNic
		}
		qLabelNic := qrLabelNic
		if qLabelNic != "" {

			if err := r.SetQueryParam("label__nic", qLabelNic); err != nil {
				return err
			}
		}
	}

	if o.LabelNie != nil {

		// query param label__nie
		var qrLabelNie string

		if o.LabelNie != nil {
			qrLabelNie = *o.LabelNie
		}
		qLabelNie := qrLabelNie
		if qLabelNie != "" {

			if err := r.SetQueryParam("label__nie", qLabelNie); err != nil {
				return err
			}
		}
	}

	if o.LabelNiew != nil {

		// query param label__niew
		var qrLabelNiew string

		if o.LabelNiew != nil {
			qrLabelNiew = *o.LabelNiew
		}
		qLabelNiew := qrLabelNiew
		if qLabelNiew != "" {

			if err := r.SetQueryParam("label__niew", qLabelNiew); err != nil {
				return err
			}
		}
	}

	if o.LabelNisw != nil {

		// query param label__nisw
		var qrLabelNisw string

		if o.LabelNisw != nil {
			qrLabelNisw = *o.LabelNisw
		}
		qLabelNisw := qrLabelNisw
		if qLabelNisw != "" {

			if err := r.SetQueryParam("label__nisw", qLabelNisw); err != nil {
				return err
			}
		}
	}

	if o.LastUpdated != nil {

		// query param last_updated
		var qrLastUpdated string

		if o.LastUpdated != nil {
			qrLastUpdated = *o.LastUpdated
		}
		qLastUpdated := qrLastUpdated
		if qLastUpdated != "" {

			if err := r.SetQueryParam("last_updated", qLastUpdated); err != nil {
				return err
			}
		}
	}

	if o.LastUpdatedGte != nil {

		// query param last_updated__gte
		var qrLastUpdatedGte string

		if o.LastUpdatedGte != nil {
			qrLastUpdatedGte = *o.LastUpdatedGte
		}
		qLastUpdatedGte := qrLastUpdatedGte
		if qLastUpdatedGte != "" {

			if err := r.SetQueryParam("last_updated__gte", qLastUpdatedGte); err != nil {
				return err
			}
		}
	}

	if o.LastUpdatedLte != nil {

		// query param last_updated__lte
		var qrLastUpdatedLte string

		if o.LastUpdatedLte != nil {
			qrLastUpdatedLte = *o.LastUpdatedLte
		}
		qLastUpdatedLte := qrLastUpdatedLte
		if qLastUpdatedLte != "" {

			if err := r.SetQueryParam("last_updated__lte", qLastUpdatedLte); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Manufacturer != nil {

		// query param manufacturer
		var qrManufacturer string

		if o.Manufacturer != nil {
			qrManufacturer = *o.Manufacturer
		}
		qManufacturer := qrManufacturer
		if qManufacturer != "" {

			if err := r.SetQueryParam("manufacturer", qManufacturer); err != nil {
				return err
			}
		}
	}

	if o.Manufacturern != nil {

		// query param manufacturer__n
		var qrManufacturern string

		if o.Manufacturern != nil {
			qrManufacturern = *o.Manufacturern
		}
		qManufacturern := qrManufacturern
		if qManufacturern != "" {

			if err := r.SetQueryParam("manufacturer__n", qManufacturern); err != nil {
				return err
			}
		}
	}

	if o.ManufacturerID != nil {

		// query param manufacturer_id
		var qrManufacturerID string

		if o.ManufacturerID != nil {
			qrManufacturerID = *o.ManufacturerID
		}
		qManufacturerID := qrManufacturerID
		if qManufacturerID != "" {

			if err := r.SetQueryParam("manufacturer_id", qManufacturerID); err != nil {
				return err
			}
		}
	}

	if o.ManufacturerIDn != nil {

		// query param manufacturer_id__n
		var qrManufacturerIDn string

		if o.ManufacturerIDn != nil {
			qrManufacturerIDn = *o.ManufacturerIDn
		}
		qManufacturerIDn := qrManufacturerIDn
		if qManufacturerIDn != "" {

			if err := r.SetQueryParam("manufacturer_id__n", qManufacturerIDn); err != nil {
				return err
			}
		}
	}

	if o.Name != nil {

		// query param name
		var qrName string

		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.NameIc != nil {

		// query param name__ic
		var qrNameIc string

		if o.NameIc != nil {
			qrNameIc = *o.NameIc
		}
		qNameIc := qrNameIc
		if qNameIc != "" {

			if err := r.SetQueryParam("name__ic", qNameIc); err != nil {
				return err
			}
		}
	}

	if o.NameIe != nil {

		// query param name__ie
		var qrNameIe string

		if o.NameIe != nil {
			qrNameIe = *o.NameIe
		}
		qNameIe := qrNameIe
		if qNameIe != "" {

			if err := r.SetQueryParam("name__ie", qNameIe); err != nil {
				return err
			}
		}
	}

	if o.NameIew != nil {

		// query param name__iew
		var qrNameIew string

		if o.NameIew != nil {
			qrNameIew = *o.NameIew
		}
		qNameIew := qrNameIew
		if qNameIew != "" {

			if err := r.SetQueryParam("name__iew", qNameIew); err != nil {
				return err
			}
		}
	}

	if o.NameIsw != nil {

		// query param name__isw
		var qrNameIsw string

		if o.NameIsw != nil {
			qrNameIsw = *o.NameIsw
		}
		qNameIsw := qrNameIsw
		if qNameIsw != "" {

			if err := r.SetQueryParam("name__isw", qNameIsw); err != nil {
				return err
			}
		}
	}

	if o.Namen != nil {

		// query param name__n
		var qrNamen string

		if o.Namen != nil {
			qrNamen = *o.Namen
		}
		qNamen := qrNamen
		if qNamen != "" {

			if err := r.SetQueryParam("name__n", qNamen); err != nil {
				return err
			}
		}
	}

	if o.NameNic != nil {

		// query param name__nic
		var qrNameNic string

		if o.NameNic != nil {
			qrNameNic = *o.NameNic
		}
		qNameNic := qrNameNic
		if qNameNic != "" {

			if err := r.SetQueryParam("name__nic", qNameNic); err != nil {
				return err
			}
		}
	}

	if o.NameNie != nil {

		// query param name__nie
		var qrNameNie string

		if o.NameNie != nil {
			qrNameNie = *o.NameNie
		}
		qNameNie := qrNameNie
		if qNameNie != "" {

			if err := r.SetQueryParam("name__nie", qNameNie); err != nil {
				return err
			}
		}
	}

	if o.NameNiew != nil {

		// query param name__niew
		var qrNameNiew string

		if o.NameNiew != nil {
			qrNameNiew = *o.NameNiew
		}
		qNameNiew := qrNameNiew
		if qNameNiew != "" {

			if err := r.SetQueryParam("name__niew", qNameNiew); err != nil {
				return err
			}
		}
	}

	if o.NameNisw != nil {

		// query param name__nisw
		var qrNameNisw string

		if o.NameNisw != nil {
			qrNameNisw = *o.NameNisw
		}
		qNameNisw := qrNameNisw
		if qNameNisw != "" {

			if err := r.SetQueryParam("name__nisw", qNameNisw); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if o.ParentID != nil {

		// query param parent_id
		var qrParentID string

		if o.ParentID != nil {
			qrParentID = *o.ParentID
		}
		qParentID := qrParentID
		if qParentID != "" {

			if err := r.SetQueryParam("parent_id", qParentID); err != nil {
				return err
			}
		}
	}

	if o.ParentIDn != nil {

		// query param parent_id__n
		var qrParentIDn string

		if o.ParentIDn != nil {
			qrParentIDn = *o.ParentIDn
		}
		qParentIDn := qrParentIDn
		if qParentIDn != "" {

			if err := r.SetQueryParam("parent_id__n", qParentIDn); err != nil {
				return err
			}
		}
	}

	if o.PartID != nil {

		// query param part_id
		var qrPartID string

		if o.PartID != nil {
			qrPartID = *o.PartID
		}
		qPartID := qrPartID
		if qPartID != "" {

			if err := r.SetQueryParam("part_id", qPartID); err != nil {
				return err
			}
		}
	}

	if o.PartIDIc != nil {

		// query param part_id__ic
		var qrPartIDIc string

		if o.PartIDIc != nil {
			qrPartIDIc = *o.PartIDIc
		}
		qPartIDIc := qrPartIDIc
		if qPartIDIc != "" {

			if err := r.SetQueryParam("part_id__ic", qPartIDIc); err != nil {
				return err
			}
		}
	}

	if o.PartIDIe != nil {

		// query param part_id__ie
		var qrPartIDIe string

		if o.PartIDIe != nil {
			qrPartIDIe = *o.PartIDIe
		}
		qPartIDIe := qrPartIDIe
		if qPartIDIe != "" {

			if err := r.SetQueryParam("part_id__ie", qPartIDIe); err != nil {
				return err
			}
		}
	}

	if o.PartIDIew != nil {

		// query param part_id__iew
		var qrPartIDIew string

		if o.PartIDIew != nil {
			qrPartIDIew = *o.PartIDIew
		}
		qPartIDIew := qrPartIDIew
		if qPartIDIew != "" {

			if err := r.SetQueryParam("part_id__iew", qPartIDIew); err != nil {
				return err
			}
		}
	}

	if o.PartIDIsw != nil {

		// query param part_id__isw
		var qrPartIDIsw string

		if o.PartIDIsw != nil {
			qrPartIDIsw = *o.PartIDIsw
		}
		qPartIDIsw := qrPartIDIsw
		if qPartIDIsw != "" {

			if err := r.SetQueryParam("part_id__isw", qPartIDIsw); err != nil {
				return err
			}
		}
	}

	if o.PartIDn != nil {

		// query param part_id__n
		var qrPartIDn string

		if o.PartIDn != nil {
			qrPartIDn = *o.PartIDn
		}
		qPartIDn := qrPartIDn
		if qPartIDn != "" {

			if err := r.SetQueryParam("part_id__n", qPartIDn); err != nil {
				return err
			}
		}
	}

	if o.PartIDNic != nil {

		// query param part_id__nic
		var qrPartIDNic string

		if o.PartIDNic != nil {
			qrPartIDNic = *o.PartIDNic
		}
		qPartIDNic := qrPartIDNic
		if qPartIDNic != "" {

			if err := r.SetQueryParam("part_id__nic", qPartIDNic); err != nil {
				return err
			}
		}
	}

	if o.PartIDNie != nil {

		// query param part_id__nie
		var qrPartIDNie string

		if o.PartIDNie != nil {
			qrPartIDNie = *o.PartIDNie
		}
		qPartIDNie := qrPartIDNie
		if qPartIDNie != "" {

			if err := r.SetQueryParam("part_id__nie", qPartIDNie); err != nil {
				return err
			}
		}
	}

	if o.PartIDNiew != nil {

		// query param part_id__niew
		var qrPartIDNiew string

		if o.PartIDNiew != nil {
			qrPartIDNiew = *o.PartIDNiew
		}
		qPartIDNiew := qrPartIDNiew
		if qPartIDNiew != "" {

			if err := r.SetQueryParam("part_id__niew", qPartIDNiew); err != nil {
				return err
			}
		}
	}

	if o.PartIDNisw != nil {

		// query param part_id__nisw
		var qrPartIDNisw string

		if o.PartIDNisw != nil {
			qrPartIDNisw = *o.PartIDNisw
		}
		qPartIDNisw := qrPartIDNisw
		if qPartIDNisw != "" {

			if err := r.SetQueryParam("part_id__nisw", qPartIDNisw); err != nil {
				return err
			}
		}
	}

	if o.Q != nil {

		// query param q
		var qrQ string

		if o.Q != nil {
			qrQ = *o.Q
		}
		qQ := qrQ
		if qQ != "" {

			if err := r.SetQueryParam("q", qQ); err != nil {
				return err
			}
		}
	}

	if o.Role != nil {

		// query param role
		var qrRole string

		if o.Role != nil {
			qrRole = *o.Role
		}
		qRole := qrRole
		if qRole != "" {

			if err := r.SetQueryParam("role", qRole); err != nil {
				return err
			}
		}
	}

	if o.Rolen != nil {

		// query param role__n
		var qrRolen string

		if o.Rolen != nil {
			qrRolen = *o.Rolen
		}
		qRolen := qrRolen
		if qRolen != "" {

			if err := r.SetQueryParam("role__n", qRolen); err != nil {
				return err
			}
		}
	}

	if o.RoleID != nil {

		// query param role_id
		var qrRoleID string

		if o.RoleID != nil {
			qrRoleID = *o.RoleID
		}
		qRoleID := qrRoleID
		if qRoleID != "" {

			if err := r.SetQueryParam("role_id", qRoleID); err != nil {
				return err
			}
		}
	}

	if o.RoleIDn != nil {

		// query param role_id__n
		var qrRoleIDn string

		if o.RoleIDn != nil {
			qrRoleIDn = *o.RoleIDn
		}
		qRoleIDn := qrRoleIDn
		if qRoleIDn != "" {

			if err := r.SetQueryParam("role_id__n", qRoleIDn); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
