// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2020 The go-netbox Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package dcim

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewDcimInventoryItemsListParams creates a new DcimInventoryItemsListParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDcimInventoryItemsListParams() *DcimInventoryItemsListParams {
	return &DcimInventoryItemsListParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDcimInventoryItemsListParamsWithTimeout creates a new DcimInventoryItemsListParams object
// with the ability to set a timeout on a request.
func NewDcimInventoryItemsListParamsWithTimeout(timeout time.Duration) *DcimInventoryItemsListParams {
	return &DcimInventoryItemsListParams{
		timeout: timeout,
	}
}

// NewDcimInventoryItemsListParamsWithContext creates a new DcimInventoryItemsListParams object
// with the ability to set a context for a request.
func NewDcimInventoryItemsListParamsWithContext(ctx context.Context) *DcimInventoryItemsListParams {
	return &DcimInventoryItemsListParams{
		Context: ctx,
	}
}

// NewDcimInventoryItemsListParamsWithHTTPClient creates a new DcimInventoryItemsListParams object
// with the ability to set a custom HTTPClient for a request.
func NewDcimInventoryItemsListParamsWithHTTPClient(client *http.Client) *DcimInventoryItemsListParams {
	return &DcimInventoryItemsListParams{
		HTTPClient: client,
	}
}

/* DcimInventoryItemsListParams contains all the parameters to send to the API endpoint
   for the dcim inventory items list operation.

   Typically these are written to a http.Request.
*/
type DcimInventoryItemsListParams struct {

	// AssetTag.
	AssetTag *string

	// AssetTagIc.
	AssetTagIc *string

	// AssetTagIe.
	AssetTagIe *string

	// AssetTagIew.
	AssetTagIew *string

	// AssetTagIsw.
	AssetTagIsw *string

	// AssetTagn.
	AssetTagn *string

	// AssetTagNic.
	AssetTagNic *string

	// AssetTagNie.
	AssetTagNie *string

	// AssetTagNiew.
	AssetTagNiew *string

	// AssetTagNisw.
	AssetTagNisw *string

	// ComponentID.
	ComponentID *string

	// ComponentIDGt.
	ComponentIDGt *string

	// ComponentIDGte.
	ComponentIDGte *string

	// ComponentIDLt.
	ComponentIDLt *string

	// ComponentIDLte.
	ComponentIDLte *string

	// ComponentIDn.
	ComponentIDn *string

	// ComponentType.
	ComponentType *string

	// ComponentTypen.
	ComponentTypen *string

	// Created.
	Created *string

	// CreatedGte.
	CreatedGte *string

	// CreatedLte.
	CreatedLte *string

	// Device.
	Device *string

	// Devicen.
	Devicen *string

	// DeviceID.
	DeviceID *string

	// DeviceIDn.
	DeviceIDn *string

	// Discovered.
	Discovered *string

	// ID.
	ID *string

	// IDGt.
	IDGt *string

	// IDGte.
	IDGte *string

	// IDLt.
	IDLt *string

	// IDLte.
	IDLte *string

	// IDn.
	IDn *string

	// Label.
	Label *string

	// LabelIc.
	LabelIc *string

	// LabelIe.
	LabelIe *string

	// LabelIew.
	LabelIew *string

	// LabelIsw.
	LabelIsw *string

	// Labeln.
	Labeln *string

	// LabelNic.
	LabelNic *string

	// LabelNie.
	LabelNie *string

	// LabelNiew.
	LabelNiew *string

	// LabelNisw.
	LabelNisw *string

	// LastUpdated.
	LastUpdated *string

	// LastUpdatedGte.
	LastUpdatedGte *string

	// LastUpdatedLte.
	LastUpdatedLte *string

	/* Limit.

	   Number of results to return per page.
	*/
	Limit *int64

	// Location.
	Location *string

	// Locationn.
	Locationn *string

	// LocationID.
	LocationID *string

	// LocationIDn.
	LocationIDn *string

	// Manufacturer.
	Manufacturer *string

	// Manufacturern.
	Manufacturern *string

	// ManufacturerID.
	ManufacturerID *string

	// ManufacturerIDn.
	ManufacturerIDn *string

	// Name.
	Name *string

	// NameIc.
	NameIc *string

	// NameIe.
	NameIe *string

	// NameIew.
	NameIew *string

	// NameIsw.
	NameIsw *string

	// Namen.
	Namen *string

	// NameNic.
	NameNic *string

	// NameNie.
	NameNie *string

	// NameNiew.
	NameNiew *string

	// NameNisw.
	NameNisw *string

	/* Offset.

	   The initial index from which to return the results.
	*/
	Offset *int64

	// ParentID.
	ParentID *string

	// ParentIDn.
	ParentIDn *string

	// PartID.
	PartID *string

	// PartIDIc.
	PartIDIc *string

	// PartIDIe.
	PartIDIe *string

	// PartIDIew.
	PartIDIew *string

	// PartIDIsw.
	PartIDIsw *string

	// PartIDn.
	PartIDn *string

	// PartIDNic.
	PartIDNic *string

	// PartIDNie.
	PartIDNie *string

	// PartIDNiew.
	PartIDNiew *string

	// PartIDNisw.
	PartIDNisw *string

	// Q.
	Q *string

	// Region.
	Region *string

	// Regionn.
	Regionn *string

	// RegionID.
	RegionID *string

	// RegionIDn.
	RegionIDn *string

	// Role.
	Role *string

	// Rolen.
	Rolen *string

	// RoleID.
	RoleID *string

	// RoleIDn.
	RoleIDn *string

	// Serial.
	Serial *string

	// Site.
	Site *string

	// Siten.
	Siten *string

	// SiteGroup.
	SiteGroup *string

	// SiteGroupn.
	SiteGroupn *string

	// SiteGroupID.
	SiteGroupID *string

	// SiteGroupIDn.
	SiteGroupIDn *string

	// SiteID.
	SiteID *string

	// SiteIDn.
	SiteIDn *string

	// Tag.
	Tag *string

	// Tagn.
	Tagn *string

	// VirtualChassis.
	VirtualChassis *string

	// VirtualChassisn.
	VirtualChassisn *string

	// VirtualChassisID.
	VirtualChassisID *string

	// VirtualChassisIDn.
	VirtualChassisIDn *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the dcim inventory items list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DcimInventoryItemsListParams) WithDefaults() *DcimInventoryItemsListParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the dcim inventory items list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DcimInventoryItemsListParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithTimeout(timeout time.Duration) *DcimInventoryItemsListParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithContext(ctx context.Context) *DcimInventoryItemsListParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithHTTPClient(client *http.Client) *DcimInventoryItemsListParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAssetTag adds the assetTag to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithAssetTag(assetTag *string) *DcimInventoryItemsListParams {
	o.SetAssetTag(assetTag)
	return o
}

// SetAssetTag adds the assetTag to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetAssetTag(assetTag *string) {
	o.AssetTag = assetTag
}

// WithAssetTagIc adds the assetTagIc to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithAssetTagIc(assetTagIc *string) *DcimInventoryItemsListParams {
	o.SetAssetTagIc(assetTagIc)
	return o
}

// SetAssetTagIc adds the assetTagIc to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetAssetTagIc(assetTagIc *string) {
	o.AssetTagIc = assetTagIc
}

// WithAssetTagIe adds the assetTagIe to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithAssetTagIe(assetTagIe *string) *DcimInventoryItemsListParams {
	o.SetAssetTagIe(assetTagIe)
	return o
}

// SetAssetTagIe adds the assetTagIe to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetAssetTagIe(assetTagIe *string) {
	o.AssetTagIe = assetTagIe
}

// WithAssetTagIew adds the assetTagIew to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithAssetTagIew(assetTagIew *string) *DcimInventoryItemsListParams {
	o.SetAssetTagIew(assetTagIew)
	return o
}

// SetAssetTagIew adds the assetTagIew to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetAssetTagIew(assetTagIew *string) {
	o.AssetTagIew = assetTagIew
}

// WithAssetTagIsw adds the assetTagIsw to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithAssetTagIsw(assetTagIsw *string) *DcimInventoryItemsListParams {
	o.SetAssetTagIsw(assetTagIsw)
	return o
}

// SetAssetTagIsw adds the assetTagIsw to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetAssetTagIsw(assetTagIsw *string) {
	o.AssetTagIsw = assetTagIsw
}

// WithAssetTagn adds the assetTagn to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithAssetTagn(assetTagn *string) *DcimInventoryItemsListParams {
	o.SetAssetTagn(assetTagn)
	return o
}

// SetAssetTagn adds the assetTagN to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetAssetTagn(assetTagn *string) {
	o.AssetTagn = assetTagn
}

// WithAssetTagNic adds the assetTagNic to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithAssetTagNic(assetTagNic *string) *DcimInventoryItemsListParams {
	o.SetAssetTagNic(assetTagNic)
	return o
}

// SetAssetTagNic adds the assetTagNic to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetAssetTagNic(assetTagNic *string) {
	o.AssetTagNic = assetTagNic
}

// WithAssetTagNie adds the assetTagNie to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithAssetTagNie(assetTagNie *string) *DcimInventoryItemsListParams {
	o.SetAssetTagNie(assetTagNie)
	return o
}

// SetAssetTagNie adds the assetTagNie to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetAssetTagNie(assetTagNie *string) {
	o.AssetTagNie = assetTagNie
}

// WithAssetTagNiew adds the assetTagNiew to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithAssetTagNiew(assetTagNiew *string) *DcimInventoryItemsListParams {
	o.SetAssetTagNiew(assetTagNiew)
	return o
}

// SetAssetTagNiew adds the assetTagNiew to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetAssetTagNiew(assetTagNiew *string) {
	o.AssetTagNiew = assetTagNiew
}

// WithAssetTagNisw adds the assetTagNisw to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithAssetTagNisw(assetTagNisw *string) *DcimInventoryItemsListParams {
	o.SetAssetTagNisw(assetTagNisw)
	return o
}

// SetAssetTagNisw adds the assetTagNisw to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetAssetTagNisw(assetTagNisw *string) {
	o.AssetTagNisw = assetTagNisw
}

// WithComponentID adds the componentID to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithComponentID(componentID *string) *DcimInventoryItemsListParams {
	o.SetComponentID(componentID)
	return o
}

// SetComponentID adds the componentId to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetComponentID(componentID *string) {
	o.ComponentID = componentID
}

// WithComponentIDGt adds the componentIDGt to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithComponentIDGt(componentIDGt *string) *DcimInventoryItemsListParams {
	o.SetComponentIDGt(componentIDGt)
	return o
}

// SetComponentIDGt adds the componentIdGt to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetComponentIDGt(componentIDGt *string) {
	o.ComponentIDGt = componentIDGt
}

// WithComponentIDGte adds the componentIDGte to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithComponentIDGte(componentIDGte *string) *DcimInventoryItemsListParams {
	o.SetComponentIDGte(componentIDGte)
	return o
}

// SetComponentIDGte adds the componentIdGte to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetComponentIDGte(componentIDGte *string) {
	o.ComponentIDGte = componentIDGte
}

// WithComponentIDLt adds the componentIDLt to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithComponentIDLt(componentIDLt *string) *DcimInventoryItemsListParams {
	o.SetComponentIDLt(componentIDLt)
	return o
}

// SetComponentIDLt adds the componentIdLt to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetComponentIDLt(componentIDLt *string) {
	o.ComponentIDLt = componentIDLt
}

// WithComponentIDLte adds the componentIDLte to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithComponentIDLte(componentIDLte *string) *DcimInventoryItemsListParams {
	o.SetComponentIDLte(componentIDLte)
	return o
}

// SetComponentIDLte adds the componentIdLte to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetComponentIDLte(componentIDLte *string) {
	o.ComponentIDLte = componentIDLte
}

// WithComponentIDn adds the componentIDn to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithComponentIDn(componentIDn *string) *DcimInventoryItemsListParams {
	o.SetComponentIDn(componentIDn)
	return o
}

// SetComponentIDn adds the componentIdN to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetComponentIDn(componentIDn *string) {
	o.ComponentIDn = componentIDn
}

// WithComponentType adds the componentType to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithComponentType(componentType *string) *DcimInventoryItemsListParams {
	o.SetComponentType(componentType)
	return o
}

// SetComponentType adds the componentType to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetComponentType(componentType *string) {
	o.ComponentType = componentType
}

// WithComponentTypen adds the componentTypen to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithComponentTypen(componentTypen *string) *DcimInventoryItemsListParams {
	o.SetComponentTypen(componentTypen)
	return o
}

// SetComponentTypen adds the componentTypeN to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetComponentTypen(componentTypen *string) {
	o.ComponentTypen = componentTypen
}

// WithCreated adds the created to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithCreated(created *string) *DcimInventoryItemsListParams {
	o.SetCreated(created)
	return o
}

// SetCreated adds the created to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetCreated(created *string) {
	o.Created = created
}

// WithCreatedGte adds the createdGte to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithCreatedGte(createdGte *string) *DcimInventoryItemsListParams {
	o.SetCreatedGte(createdGte)
	return o
}

// SetCreatedGte adds the createdGte to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetCreatedGte(createdGte *string) {
	o.CreatedGte = createdGte
}

// WithCreatedLte adds the createdLte to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithCreatedLte(createdLte *string) *DcimInventoryItemsListParams {
	o.SetCreatedLte(createdLte)
	return o
}

// SetCreatedLte adds the createdLte to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetCreatedLte(createdLte *string) {
	o.CreatedLte = createdLte
}

// WithDevice adds the device to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithDevice(device *string) *DcimInventoryItemsListParams {
	o.SetDevice(device)
	return o
}

// SetDevice adds the device to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetDevice(device *string) {
	o.Device = device
}

// WithDevicen adds the devicen to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithDevicen(devicen *string) *DcimInventoryItemsListParams {
	o.SetDevicen(devicen)
	return o
}

// SetDevicen adds the deviceN to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetDevicen(devicen *string) {
	o.Devicen = devicen
}

// WithDeviceID adds the deviceID to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithDeviceID(deviceID *string) *DcimInventoryItemsListParams {
	o.SetDeviceID(deviceID)
	return o
}

// SetDeviceID adds the deviceId to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetDeviceID(deviceID *string) {
	o.DeviceID = deviceID
}

// WithDeviceIDn adds the deviceIDn to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithDeviceIDn(deviceIDn *string) *DcimInventoryItemsListParams {
	o.SetDeviceIDn(deviceIDn)
	return o
}

// SetDeviceIDn adds the deviceIdN to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetDeviceIDn(deviceIDn *string) {
	o.DeviceIDn = deviceIDn
}

// WithDiscovered adds the discovered to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithDiscovered(discovered *string) *DcimInventoryItemsListParams {
	o.SetDiscovered(discovered)
	return o
}

// SetDiscovered adds the discovered to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetDiscovered(discovered *string) {
	o.Discovered = discovered
}

// WithID adds the id to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithID(id *string) *DcimInventoryItemsListParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetID(id *string) {
	o.ID = id
}

// WithIDGt adds the iDGt to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithIDGt(iDGt *string) *DcimInventoryItemsListParams {
	o.SetIDGt(iDGt)
	return o
}

// SetIDGt adds the idGt to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetIDGt(iDGt *string) {
	o.IDGt = iDGt
}

// WithIDGte adds the iDGte to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithIDGte(iDGte *string) *DcimInventoryItemsListParams {
	o.SetIDGte(iDGte)
	return o
}

// SetIDGte adds the idGte to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetIDGte(iDGte *string) {
	o.IDGte = iDGte
}

// WithIDLt adds the iDLt to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithIDLt(iDLt *string) *DcimInventoryItemsListParams {
	o.SetIDLt(iDLt)
	return o
}

// SetIDLt adds the idLt to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetIDLt(iDLt *string) {
	o.IDLt = iDLt
}

// WithIDLte adds the iDLte to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithIDLte(iDLte *string) *DcimInventoryItemsListParams {
	o.SetIDLte(iDLte)
	return o
}

// SetIDLte adds the idLte to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetIDLte(iDLte *string) {
	o.IDLte = iDLte
}

// WithIDn adds the iDn to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithIDn(iDn *string) *DcimInventoryItemsListParams {
	o.SetIDn(iDn)
	return o
}

// SetIDn adds the idN to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetIDn(iDn *string) {
	o.IDn = iDn
}

// WithLabel adds the label to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithLabel(label *string) *DcimInventoryItemsListParams {
	o.SetLabel(label)
	return o
}

// SetLabel adds the label to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetLabel(label *string) {
	o.Label = label
}

// WithLabelIc adds the labelIc to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithLabelIc(labelIc *string) *DcimInventoryItemsListParams {
	o.SetLabelIc(labelIc)
	return o
}

// SetLabelIc adds the labelIc to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetLabelIc(labelIc *string) {
	o.LabelIc = labelIc
}

// WithLabelIe adds the labelIe to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithLabelIe(labelIe *string) *DcimInventoryItemsListParams {
	o.SetLabelIe(labelIe)
	return o
}

// SetLabelIe adds the labelIe to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetLabelIe(labelIe *string) {
	o.LabelIe = labelIe
}

// WithLabelIew adds the labelIew to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithLabelIew(labelIew *string) *DcimInventoryItemsListParams {
	o.SetLabelIew(labelIew)
	return o
}

// SetLabelIew adds the labelIew to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetLabelIew(labelIew *string) {
	o.LabelIew = labelIew
}

// WithLabelIsw adds the labelIsw to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithLabelIsw(labelIsw *string) *DcimInventoryItemsListParams {
	o.SetLabelIsw(labelIsw)
	return o
}

// SetLabelIsw adds the labelIsw to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetLabelIsw(labelIsw *string) {
	o.LabelIsw = labelIsw
}

// WithLabeln adds the labeln to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithLabeln(labeln *string) *DcimInventoryItemsListParams {
	o.SetLabeln(labeln)
	return o
}

// SetLabeln adds the labelN to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetLabeln(labeln *string) {
	o.Labeln = labeln
}

// WithLabelNic adds the labelNic to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithLabelNic(labelNic *string) *DcimInventoryItemsListParams {
	o.SetLabelNic(labelNic)
	return o
}

// SetLabelNic adds the labelNic to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetLabelNic(labelNic *string) {
	o.LabelNic = labelNic
}

// WithLabelNie adds the labelNie to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithLabelNie(labelNie *string) *DcimInventoryItemsListParams {
	o.SetLabelNie(labelNie)
	return o
}

// SetLabelNie adds the labelNie to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetLabelNie(labelNie *string) {
	o.LabelNie = labelNie
}

// WithLabelNiew adds the labelNiew to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithLabelNiew(labelNiew *string) *DcimInventoryItemsListParams {
	o.SetLabelNiew(labelNiew)
	return o
}

// SetLabelNiew adds the labelNiew to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetLabelNiew(labelNiew *string) {
	o.LabelNiew = labelNiew
}

// WithLabelNisw adds the labelNisw to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithLabelNisw(labelNisw *string) *DcimInventoryItemsListParams {
	o.SetLabelNisw(labelNisw)
	return o
}

// SetLabelNisw adds the labelNisw to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetLabelNisw(labelNisw *string) {
	o.LabelNisw = labelNisw
}

// WithLastUpdated adds the lastUpdated to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithLastUpdated(lastUpdated *string) *DcimInventoryItemsListParams {
	o.SetLastUpdated(lastUpdated)
	return o
}

// SetLastUpdated adds the lastUpdated to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetLastUpdated(lastUpdated *string) {
	o.LastUpdated = lastUpdated
}

// WithLastUpdatedGte adds the lastUpdatedGte to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithLastUpdatedGte(lastUpdatedGte *string) *DcimInventoryItemsListParams {
	o.SetLastUpdatedGte(lastUpdatedGte)
	return o
}

// SetLastUpdatedGte adds the lastUpdatedGte to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetLastUpdatedGte(lastUpdatedGte *string) {
	o.LastUpdatedGte = lastUpdatedGte
}

// WithLastUpdatedLte adds the lastUpdatedLte to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithLastUpdatedLte(lastUpdatedLte *string) *DcimInventoryItemsListParams {
	o.SetLastUpdatedLte(lastUpdatedLte)
	return o
}

// SetLastUpdatedLte adds the lastUpdatedLte to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetLastUpdatedLte(lastUpdatedLte *string) {
	o.LastUpdatedLte = lastUpdatedLte
}

// WithLimit adds the limit to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithLimit(limit *int64) *DcimInventoryItemsListParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithLocation adds the location to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithLocation(location *string) *DcimInventoryItemsListParams {
	o.SetLocation(location)
	return o
}

// SetLocation adds the location to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetLocation(location *string) {
	o.Location = location
}

// WithLocationn adds the locationn to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithLocationn(locationn *string) *DcimInventoryItemsListParams {
	o.SetLocationn(locationn)
	return o
}

// SetLocationn adds the locationN to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetLocationn(locationn *string) {
	o.Locationn = locationn
}

// WithLocationID adds the locationID to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithLocationID(locationID *string) *DcimInventoryItemsListParams {
	o.SetLocationID(locationID)
	return o
}

// SetLocationID adds the locationId to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetLocationID(locationID *string) {
	o.LocationID = locationID
}

// WithLocationIDn adds the locationIDn to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithLocationIDn(locationIDn *string) *DcimInventoryItemsListParams {
	o.SetLocationIDn(locationIDn)
	return o
}

// SetLocationIDn adds the locationIdN to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetLocationIDn(locationIDn *string) {
	o.LocationIDn = locationIDn
}

// WithManufacturer adds the manufacturer to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithManufacturer(manufacturer *string) *DcimInventoryItemsListParams {
	o.SetManufacturer(manufacturer)
	return o
}

// SetManufacturer adds the manufacturer to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetManufacturer(manufacturer *string) {
	o.Manufacturer = manufacturer
}

// WithManufacturern adds the manufacturern to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithManufacturern(manufacturern *string) *DcimInventoryItemsListParams {
	o.SetManufacturern(manufacturern)
	return o
}

// SetManufacturern adds the manufacturerN to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetManufacturern(manufacturern *string) {
	o.Manufacturern = manufacturern
}

// WithManufacturerID adds the manufacturerID to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithManufacturerID(manufacturerID *string) *DcimInventoryItemsListParams {
	o.SetManufacturerID(manufacturerID)
	return o
}

// SetManufacturerID adds the manufacturerId to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetManufacturerID(manufacturerID *string) {
	o.ManufacturerID = manufacturerID
}

// WithManufacturerIDn adds the manufacturerIDn to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithManufacturerIDn(manufacturerIDn *string) *DcimInventoryItemsListParams {
	o.SetManufacturerIDn(manufacturerIDn)
	return o
}

// SetManufacturerIDn adds the manufacturerIdN to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetManufacturerIDn(manufacturerIDn *string) {
	o.ManufacturerIDn = manufacturerIDn
}

// WithName adds the name to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithName(name *string) *DcimInventoryItemsListParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetName(name *string) {
	o.Name = name
}

// WithNameIc adds the nameIc to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithNameIc(nameIc *string) *DcimInventoryItemsListParams {
	o.SetNameIc(nameIc)
	return o
}

// SetNameIc adds the nameIc to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetNameIc(nameIc *string) {
	o.NameIc = nameIc
}

// WithNameIe adds the nameIe to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithNameIe(nameIe *string) *DcimInventoryItemsListParams {
	o.SetNameIe(nameIe)
	return o
}

// SetNameIe adds the nameIe to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetNameIe(nameIe *string) {
	o.NameIe = nameIe
}

// WithNameIew adds the nameIew to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithNameIew(nameIew *string) *DcimInventoryItemsListParams {
	o.SetNameIew(nameIew)
	return o
}

// SetNameIew adds the nameIew to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetNameIew(nameIew *string) {
	o.NameIew = nameIew
}

// WithNameIsw adds the nameIsw to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithNameIsw(nameIsw *string) *DcimInventoryItemsListParams {
	o.SetNameIsw(nameIsw)
	return o
}

// SetNameIsw adds the nameIsw to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetNameIsw(nameIsw *string) {
	o.NameIsw = nameIsw
}

// WithNamen adds the namen to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithNamen(namen *string) *DcimInventoryItemsListParams {
	o.SetNamen(namen)
	return o
}

// SetNamen adds the nameN to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetNamen(namen *string) {
	o.Namen = namen
}

// WithNameNic adds the nameNic to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithNameNic(nameNic *string) *DcimInventoryItemsListParams {
	o.SetNameNic(nameNic)
	return o
}

// SetNameNic adds the nameNic to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetNameNic(nameNic *string) {
	o.NameNic = nameNic
}

// WithNameNie adds the nameNie to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithNameNie(nameNie *string) *DcimInventoryItemsListParams {
	o.SetNameNie(nameNie)
	return o
}

// SetNameNie adds the nameNie to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetNameNie(nameNie *string) {
	o.NameNie = nameNie
}

// WithNameNiew adds the nameNiew to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithNameNiew(nameNiew *string) *DcimInventoryItemsListParams {
	o.SetNameNiew(nameNiew)
	return o
}

// SetNameNiew adds the nameNiew to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetNameNiew(nameNiew *string) {
	o.NameNiew = nameNiew
}

// WithNameNisw adds the nameNisw to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithNameNisw(nameNisw *string) *DcimInventoryItemsListParams {
	o.SetNameNisw(nameNisw)
	return o
}

// SetNameNisw adds the nameNisw to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetNameNisw(nameNisw *string) {
	o.NameNisw = nameNisw
}

// WithOffset adds the offset to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithOffset(offset *int64) *DcimInventoryItemsListParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithParentID adds the parentID to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithParentID(parentID *string) *DcimInventoryItemsListParams {
	o.SetParentID(parentID)
	return o
}

// SetParentID adds the parentId to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetParentID(parentID *string) {
	o.ParentID = parentID
}

// WithParentIDn adds the parentIDn to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithParentIDn(parentIDn *string) *DcimInventoryItemsListParams {
	o.SetParentIDn(parentIDn)
	return o
}

// SetParentIDn adds the parentIdN to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetParentIDn(parentIDn *string) {
	o.ParentIDn = parentIDn
}

// WithPartID adds the partID to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithPartID(partID *string) *DcimInventoryItemsListParams {
	o.SetPartID(partID)
	return o
}

// SetPartID adds the partId to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetPartID(partID *string) {
	o.PartID = partID
}

// WithPartIDIc adds the partIDIc to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithPartIDIc(partIDIc *string) *DcimInventoryItemsListParams {
	o.SetPartIDIc(partIDIc)
	return o
}

// SetPartIDIc adds the partIdIc to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetPartIDIc(partIDIc *string) {
	o.PartIDIc = partIDIc
}

// WithPartIDIe adds the partIDIe to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithPartIDIe(partIDIe *string) *DcimInventoryItemsListParams {
	o.SetPartIDIe(partIDIe)
	return o
}

// SetPartIDIe adds the partIdIe to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetPartIDIe(partIDIe *string) {
	o.PartIDIe = partIDIe
}

// WithPartIDIew adds the partIDIew to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithPartIDIew(partIDIew *string) *DcimInventoryItemsListParams {
	o.SetPartIDIew(partIDIew)
	return o
}

// SetPartIDIew adds the partIdIew to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetPartIDIew(partIDIew *string) {
	o.PartIDIew = partIDIew
}

// WithPartIDIsw adds the partIDIsw to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithPartIDIsw(partIDIsw *string) *DcimInventoryItemsListParams {
	o.SetPartIDIsw(partIDIsw)
	return o
}

// SetPartIDIsw adds the partIdIsw to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetPartIDIsw(partIDIsw *string) {
	o.PartIDIsw = partIDIsw
}

// WithPartIDn adds the partIDn to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithPartIDn(partIDn *string) *DcimInventoryItemsListParams {
	o.SetPartIDn(partIDn)
	return o
}

// SetPartIDn adds the partIdN to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetPartIDn(partIDn *string) {
	o.PartIDn = partIDn
}

// WithPartIDNic adds the partIDNic to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithPartIDNic(partIDNic *string) *DcimInventoryItemsListParams {
	o.SetPartIDNic(partIDNic)
	return o
}

// SetPartIDNic adds the partIdNic to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetPartIDNic(partIDNic *string) {
	o.PartIDNic = partIDNic
}

// WithPartIDNie adds the partIDNie to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithPartIDNie(partIDNie *string) *DcimInventoryItemsListParams {
	o.SetPartIDNie(partIDNie)
	return o
}

// SetPartIDNie adds the partIdNie to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetPartIDNie(partIDNie *string) {
	o.PartIDNie = partIDNie
}

// WithPartIDNiew adds the partIDNiew to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithPartIDNiew(partIDNiew *string) *DcimInventoryItemsListParams {
	o.SetPartIDNiew(partIDNiew)
	return o
}

// SetPartIDNiew adds the partIdNiew to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetPartIDNiew(partIDNiew *string) {
	o.PartIDNiew = partIDNiew
}

// WithPartIDNisw adds the partIDNisw to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithPartIDNisw(partIDNisw *string) *DcimInventoryItemsListParams {
	o.SetPartIDNisw(partIDNisw)
	return o
}

// SetPartIDNisw adds the partIdNisw to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetPartIDNisw(partIDNisw *string) {
	o.PartIDNisw = partIDNisw
}

// WithQ adds the q to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithQ(q *string) *DcimInventoryItemsListParams {
	o.SetQ(q)
	return o
}

// SetQ adds the q to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetQ(q *string) {
	o.Q = q
}

// WithRegion adds the region to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithRegion(region *string) *DcimInventoryItemsListParams {
	o.SetRegion(region)
	return o
}

// SetRegion adds the region to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetRegion(region *string) {
	o.Region = region
}

// WithRegionn adds the regionn to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithRegionn(regionn *string) *DcimInventoryItemsListParams {
	o.SetRegionn(regionn)
	return o
}

// SetRegionn adds the regionN to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetRegionn(regionn *string) {
	o.Regionn = regionn
}

// WithRegionID adds the regionID to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithRegionID(regionID *string) *DcimInventoryItemsListParams {
	o.SetRegionID(regionID)
	return o
}

// SetRegionID adds the regionId to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetRegionID(regionID *string) {
	o.RegionID = regionID
}

// WithRegionIDn adds the regionIDn to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithRegionIDn(regionIDn *string) *DcimInventoryItemsListParams {
	o.SetRegionIDn(regionIDn)
	return o
}

// SetRegionIDn adds the regionIdN to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetRegionIDn(regionIDn *string) {
	o.RegionIDn = regionIDn
}

// WithRole adds the role to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithRole(role *string) *DcimInventoryItemsListParams {
	o.SetRole(role)
	return o
}

// SetRole adds the role to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetRole(role *string) {
	o.Role = role
}

// WithRolen adds the rolen to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithRolen(rolen *string) *DcimInventoryItemsListParams {
	o.SetRolen(rolen)
	return o
}

// SetRolen adds the roleN to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetRolen(rolen *string) {
	o.Rolen = rolen
}

// WithRoleID adds the roleID to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithRoleID(roleID *string) *DcimInventoryItemsListParams {
	o.SetRoleID(roleID)
	return o
}

// SetRoleID adds the roleId to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetRoleID(roleID *string) {
	o.RoleID = roleID
}

// WithRoleIDn adds the roleIDn to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithRoleIDn(roleIDn *string) *DcimInventoryItemsListParams {
	o.SetRoleIDn(roleIDn)
	return o
}

// SetRoleIDn adds the roleIdN to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetRoleIDn(roleIDn *string) {
	o.RoleIDn = roleIDn
}

// WithSerial adds the serial to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithSerial(serial *string) *DcimInventoryItemsListParams {
	o.SetSerial(serial)
	return o
}

// SetSerial adds the serial to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetSerial(serial *string) {
	o.Serial = serial
}

// WithSite adds the site to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithSite(site *string) *DcimInventoryItemsListParams {
	o.SetSite(site)
	return o
}

// SetSite adds the site to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetSite(site *string) {
	o.Site = site
}

// WithSiten adds the siten to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithSiten(siten *string) *DcimInventoryItemsListParams {
	o.SetSiten(siten)
	return o
}

// SetSiten adds the siteN to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetSiten(siten *string) {
	o.Siten = siten
}

// WithSiteGroup adds the siteGroup to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithSiteGroup(siteGroup *string) *DcimInventoryItemsListParams {
	o.SetSiteGroup(siteGroup)
	return o
}

// SetSiteGroup adds the siteGroup to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetSiteGroup(siteGroup *string) {
	o.SiteGroup = siteGroup
}

// WithSiteGroupn adds the siteGroupn to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithSiteGroupn(siteGroupn *string) *DcimInventoryItemsListParams {
	o.SetSiteGroupn(siteGroupn)
	return o
}

// SetSiteGroupn adds the siteGroupN to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetSiteGroupn(siteGroupn *string) {
	o.SiteGroupn = siteGroupn
}

// WithSiteGroupID adds the siteGroupID to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithSiteGroupID(siteGroupID *string) *DcimInventoryItemsListParams {
	o.SetSiteGroupID(siteGroupID)
	return o
}

// SetSiteGroupID adds the siteGroupId to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetSiteGroupID(siteGroupID *string) {
	o.SiteGroupID = siteGroupID
}

// WithSiteGroupIDn adds the siteGroupIDn to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithSiteGroupIDn(siteGroupIDn *string) *DcimInventoryItemsListParams {
	o.SetSiteGroupIDn(siteGroupIDn)
	return o
}

// SetSiteGroupIDn adds the siteGroupIdN to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetSiteGroupIDn(siteGroupIDn *string) {
	o.SiteGroupIDn = siteGroupIDn
}

// WithSiteID adds the siteID to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithSiteID(siteID *string) *DcimInventoryItemsListParams {
	o.SetSiteID(siteID)
	return o
}

// SetSiteID adds the siteId to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetSiteID(siteID *string) {
	o.SiteID = siteID
}

// WithSiteIDn adds the siteIDn to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithSiteIDn(siteIDn *string) *DcimInventoryItemsListParams {
	o.SetSiteIDn(siteIDn)
	return o
}

// SetSiteIDn adds the siteIdN to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetSiteIDn(siteIDn *string) {
	o.SiteIDn = siteIDn
}

// WithTag adds the tag to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithTag(tag *string) *DcimInventoryItemsListParams {
	o.SetTag(tag)
	return o
}

// SetTag adds the tag to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetTag(tag *string) {
	o.Tag = tag
}

// WithTagn adds the tagn to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithTagn(tagn *string) *DcimInventoryItemsListParams {
	o.SetTagn(tagn)
	return o
}

// SetTagn adds the tagN to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetTagn(tagn *string) {
	o.Tagn = tagn
}

// WithVirtualChassis adds the virtualChassis to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithVirtualChassis(virtualChassis *string) *DcimInventoryItemsListParams {
	o.SetVirtualChassis(virtualChassis)
	return o
}

// SetVirtualChassis adds the virtualChassis to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetVirtualChassis(virtualChassis *string) {
	o.VirtualChassis = virtualChassis
}

// WithVirtualChassisn adds the virtualChassisn to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithVirtualChassisn(virtualChassisn *string) *DcimInventoryItemsListParams {
	o.SetVirtualChassisn(virtualChassisn)
	return o
}

// SetVirtualChassisn adds the virtualChassisN to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetVirtualChassisn(virtualChassisn *string) {
	o.VirtualChassisn = virtualChassisn
}

// WithVirtualChassisID adds the virtualChassisID to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithVirtualChassisID(virtualChassisID *string) *DcimInventoryItemsListParams {
	o.SetVirtualChassisID(virtualChassisID)
	return o
}

// SetVirtualChassisID adds the virtualChassisId to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetVirtualChassisID(virtualChassisID *string) {
	o.VirtualChassisID = virtualChassisID
}

// WithVirtualChassisIDn adds the virtualChassisIDn to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) WithVirtualChassisIDn(virtualChassisIDn *string) *DcimInventoryItemsListParams {
	o.SetVirtualChassisIDn(virtualChassisIDn)
	return o
}

// SetVirtualChassisIDn adds the virtualChassisIdN to the dcim inventory items list params
func (o *DcimInventoryItemsListParams) SetVirtualChassisIDn(virtualChassisIDn *string) {
	o.VirtualChassisIDn = virtualChassisIDn
}

// WriteToRequest writes these params to a swagger request
func (o *DcimInventoryItemsListParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AssetTag != nil {

		// query param asset_tag
		var qrAssetTag string

		if o.AssetTag != nil {
			qrAssetTag = *o.AssetTag
		}
		qAssetTag := qrAssetTag
		if qAssetTag != "" {

			if err := r.SetQueryParam("asset_tag", qAssetTag); err != nil {
				return err
			}
		}
	}

	if o.AssetTagIc != nil {

		// query param asset_tag__ic
		var qrAssetTagIc string

		if o.AssetTagIc != nil {
			qrAssetTagIc = *o.AssetTagIc
		}
		qAssetTagIc := qrAssetTagIc
		if qAssetTagIc != "" {

			if err := r.SetQueryParam("asset_tag__ic", qAssetTagIc); err != nil {
				return err
			}
		}
	}

	if o.AssetTagIe != nil {

		// query param asset_tag__ie
		var qrAssetTagIe string

		if o.AssetTagIe != nil {
			qrAssetTagIe = *o.AssetTagIe
		}
		qAssetTagIe := qrAssetTagIe
		if qAssetTagIe != "" {

			if err := r.SetQueryParam("asset_tag__ie", qAssetTagIe); err != nil {
				return err
			}
		}
	}

	if o.AssetTagIew != nil {

		// query param asset_tag__iew
		var qrAssetTagIew string

		if o.AssetTagIew != nil {
			qrAssetTagIew = *o.AssetTagIew
		}
		qAssetTagIew := qrAssetTagIew
		if qAssetTagIew != "" {

			if err := r.SetQueryParam("asset_tag__iew", qAssetTagIew); err != nil {
				return err
			}
		}
	}

	if o.AssetTagIsw != nil {

		// query param asset_tag__isw
		var qrAssetTagIsw string

		if o.AssetTagIsw != nil {
			qrAssetTagIsw = *o.AssetTagIsw
		}
		qAssetTagIsw := qrAssetTagIsw
		if qAssetTagIsw != "" {

			if err := r.SetQueryParam("asset_tag__isw", qAssetTagIsw); err != nil {
				return err
			}
		}
	}

	if o.AssetTagn != nil {

		// query param asset_tag__n
		var qrAssetTagn string

		if o.AssetTagn != nil {
			qrAssetTagn = *o.AssetTagn
		}
		qAssetTagn := qrAssetTagn
		if qAssetTagn != "" {

			if err := r.SetQueryParam("asset_tag__n", qAssetTagn); err != nil {
				return err
			}
		}
	}

	if o.AssetTagNic != nil {

		// query param asset_tag__nic
		var qrAssetTagNic string

		if o.AssetTagNic != nil {
			qrAssetTagNic = *o.AssetTagNic
		}
		qAssetTagNic := qrAssetTagNic
		if qAssetTagNic != "" {

			if err := r.SetQueryParam("asset_tag__nic", qAssetTagNic); err != nil {
				return err
			}
		}
	}

	if o.AssetTagNie != nil {

		// query param asset_tag__nie
		var qrAssetTagNie string

		if o.AssetTagNie != nil {
			qrAssetTagNie = *o.AssetTagNie
		}
		qAssetTagNie := qrAssetTagNie
		if qAssetTagNie != "" {

			if err := r.SetQueryParam("asset_tag__nie", qAssetTagNie); err != nil {
				return err
			}
		}
	}

	if o.AssetTagNiew != nil {

		// query param asset_tag__niew
		var qrAssetTagNiew string

		if o.AssetTagNiew != nil {
			qrAssetTagNiew = *o.AssetTagNiew
		}
		qAssetTagNiew := qrAssetTagNiew
		if qAssetTagNiew != "" {

			if err := r.SetQueryParam("asset_tag__niew", qAssetTagNiew); err != nil {
				return err
			}
		}
	}

	if o.AssetTagNisw != nil {

		// query param asset_tag__nisw
		var qrAssetTagNisw string

		if o.AssetTagNisw != nil {
			qrAssetTagNisw = *o.AssetTagNisw
		}
		qAssetTagNisw := qrAssetTagNisw
		if qAssetTagNisw != "" {

			if err := r.SetQueryParam("asset_tag__nisw", qAssetTagNisw); err != nil {
				return err
			}
		}
	}

	if o.ComponentID != nil {

		// query param component_id
		var qrComponentID string

		if o.ComponentID != nil {
			qrComponentID = *o.ComponentID
		}
		qComponentID := qrComponentID
		if qComponentID != "" {

			if err := r.SetQueryParam("component_id", qComponentID); err != nil {
				return err
			}
		}
	}

	if o.ComponentIDGt != nil {

		// query param component_id__gt
		var qrComponentIDGt string

		if o.ComponentIDGt != nil {
			qrComponentIDGt = *o.ComponentIDGt
		}
		qComponentIDGt := qrComponentIDGt
		if qComponentIDGt != "" {

			if err := r.SetQueryParam("component_id__gt", qComponentIDGt); err != nil {
				return err
			}
		}
	}

	if o.ComponentIDGte != nil {

		// query param component_id__gte
		var qrComponentIDGte string

		if o.ComponentIDGte != nil {
			qrComponentIDGte = *o.ComponentIDGte
		}
		qComponentIDGte := qrComponentIDGte
		if qComponentIDGte != "" {

			if err := r.SetQueryParam("component_id__gte", qComponentIDGte); err != nil {
				return err
			}
		}
	}

	if o.ComponentIDLt != nil {

		// query param component_id__lt
		var qrComponentIDLt string

		if o.ComponentIDLt != nil {
			qrComponentIDLt = *o.ComponentIDLt
		}
		qComponentIDLt := qrComponentIDLt
		if qComponentIDLt != "" {

			if err := r.SetQueryParam("component_id__lt", qComponentIDLt); err != nil {
				return err
			}
		}
	}

	if o.ComponentIDLte != nil {

		// query param component_id__lte
		var qrComponentIDLte string

		if o.ComponentIDLte != nil {
			qrComponentIDLte = *o.ComponentIDLte
		}
		qComponentIDLte := qrComponentIDLte
		if qComponentIDLte != "" {

			if err := r.SetQueryParam("component_id__lte", qComponentIDLte); err != nil {
				return err
			}
		}
	}

	if o.ComponentIDn != nil {

		// query param component_id__n
		var qrComponentIDn string

		if o.ComponentIDn != nil {
			qrComponentIDn = *o.ComponentIDn
		}
		qComponentIDn := qrComponentIDn
		if qComponentIDn != "" {

			if err := r.SetQueryParam("component_id__n", qComponentIDn); err != nil {
				return err
			}
		}
	}

	if o.ComponentType != nil {

		// query param component_type
		var qrComponentType string

		if o.ComponentType != nil {
			qrComponentType = *o.ComponentType
		}
		qComponentType := qrComponentType
		if qComponentType != "" {

			if err := r.SetQueryParam("component_type", qComponentType); err != nil {
				return err
			}
		}
	}

	if o.ComponentTypen != nil {

		// query param component_type__n
		var qrComponentTypen string

		if o.ComponentTypen != nil {
			qrComponentTypen = *o.ComponentTypen
		}
		qComponentTypen := qrComponentTypen
		if qComponentTypen != "" {

			if err := r.SetQueryParam("component_type__n", qComponentTypen); err != nil {
				return err
			}
		}
	}

	if o.Created != nil {

		// query param created
		var qrCreated string

		if o.Created != nil {
			qrCreated = *o.Created
		}
		qCreated := qrCreated
		if qCreated != "" {

			if err := r.SetQueryParam("created", qCreated); err != nil {
				return err
			}
		}
	}

	if o.CreatedGte != nil {

		// query param created__gte
		var qrCreatedGte string

		if o.CreatedGte != nil {
			qrCreatedGte = *o.CreatedGte
		}
		qCreatedGte := qrCreatedGte
		if qCreatedGte != "" {

			if err := r.SetQueryParam("created__gte", qCreatedGte); err != nil {
				return err
			}
		}
	}

	if o.CreatedLte != nil {

		// query param created__lte
		var qrCreatedLte string

		if o.CreatedLte != nil {
			qrCreatedLte = *o.CreatedLte
		}
		qCreatedLte := qrCreatedLte
		if qCreatedLte != "" {

			if err := r.SetQueryParam("created__lte", qCreatedLte); err != nil {
				return err
			}
		}
	}

	if o.Device != nil {

		// query param device
		var qrDevice string

		if o.Device != nil {
			qrDevice = *o.Device
		}
		qDevice := qrDevice
		if qDevice != "" {

			if err := r.SetQueryParam("device", qDevice); err != nil {
				return err
			}
		}
	}

	if o.Devicen != nil {

		// query param device__n
		var qrDevicen string

		if o.Devicen != nil {
			qrDevicen = *o.Devicen
		}
		qDevicen := qrDevicen
		if qDevicen != "" {

			if err := r.SetQueryParam("device__n", qDevicen); err != nil {
				return err
			}
		}
	}

	if o.DeviceID != nil {

		// query param device_id
		var qrDeviceID string

		if o.DeviceID != nil {
			qrDeviceID = *o.DeviceID
		}
		qDeviceID := qrDeviceID
		if qDeviceID != "" {

			if err := r.SetQueryParam("device_id", qDeviceID); err != nil {
				return err
			}
		}
	}

	if o.DeviceIDn != nil {

		// query param device_id__n
		var qrDeviceIDn string

		if o.DeviceIDn != nil {
			qrDeviceIDn = *o.DeviceIDn
		}
		qDeviceIDn := qrDeviceIDn
		if qDeviceIDn != "" {

			if err := r.SetQueryParam("device_id__n", qDeviceIDn); err != nil {
				return err
			}
		}
	}

	if o.Discovered != nil {

		// query param discovered
		var qrDiscovered string

		if o.Discovered != nil {
			qrDiscovered = *o.Discovered
		}
		qDiscovered := qrDiscovered
		if qDiscovered != "" {

			if err := r.SetQueryParam("discovered", qDiscovered); err != nil {
				return err
			}
		}
	}

	if o.ID != nil {

		// query param id
		var qrID string

		if o.ID != nil {
			qrID = *o.ID
		}
		qID := qrID
		if qID != "" {

			if err := r.SetQueryParam("id", qID); err != nil {
				return err
			}
		}
	}

	if o.IDGt != nil {

		// query param id__gt
		var qrIDGt string

		if o.IDGt != nil {
			qrIDGt = *o.IDGt
		}
		qIDGt := qrIDGt
		if qIDGt != "" {

			if err := r.SetQueryParam("id__gt", qIDGt); err != nil {
				return err
			}
		}
	}

	if o.IDGte != nil {

		// query param id__gte
		var qrIDGte string

		if o.IDGte != nil {
			qrIDGte = *o.IDGte
		}
		qIDGte := qrIDGte
		if qIDGte != "" {

			if err := r.SetQueryParam("id__gte", qIDGte); err != nil {
				return err
			}
		}
	}

	if o.IDLt != nil {

		// query param id__lt
		var qrIDLt string

		if o.IDLt != nil {
			qrIDLt = *o.IDLt
		}
		qIDLt := qrIDLt
		if qIDLt != "" {

			if err := r.SetQueryParam("id__lt", qIDLt); err != nil {
				return err
			}
		}
	}

	if o.IDLte != nil {

		// query param id__lte
		var qrIDLte string

		if o.IDLte != nil {
			qrIDLte = *o.IDLte
		}
		qIDLte := qrIDLte
		if qIDLte != "" {

			if err := r.SetQueryParam("id__lte", qIDLte); err != nil {
				return err
			}
		}
	}

	if o.IDn != nil {

		// query param id__n
		var qrIDn string

		if o.IDn != nil {
			qrIDn = *o.IDn
		}
		qIDn := qrIDn
		if qIDn != "" {

			if err := r.SetQueryParam("id__n", qIDn); err != nil {
				return err
			}
		}
	}

	if o.Label != nil {

		// query param label
		var qrLabel string

		if o.Label != nil {
			qrLabel = *o.Label
		}
		qLabel := qrLabel
		if qLabel != "" {

			if err := r.SetQueryParam("label", qLabel); err != nil {
				return err
			}
		}
	}

	if o.LabelIc != nil {

		// query param label__ic
		var qrLabelIc string

		if o.LabelIc != nil {
			qrLabelIc = *o.LabelIc
		}
		qLabelIc := qrLabelIc
		if qLabelIc != "" {

			if err := r.SetQueryParam("label__ic", qLabelIc); err != nil {
				return err
			}
		}
	}

	if o.LabelIe != nil {

		// query param label__ie
		var qrLabelIe string

		if o.LabelIe != nil {
			qrLabelIe = *o.LabelIe
		}
		qLabelIe := qrLabelIe
		if qLabelIe != "" {

			if err := r.SetQueryParam("label__ie", qLabelIe); err != nil {
				return err
			}
		}
	}

	if o.LabelIew != nil {

		// query param label__iew
		var qrLabelIew string

		if o.LabelIew != nil {
			qrLabelIew = *o.LabelIew
		}
		qLabelIew := qrLabelIew
		if qLabelIew != "" {

			if err := r.SetQueryParam("label__iew", qLabelIew); err != nil {
				return err
			}
		}
	}

	if o.LabelIsw != nil {

		// query param label__isw
		var qrLabelIsw string

		if o.LabelIsw != nil {
			qrLabelIsw = *o.LabelIsw
		}
		qLabelIsw := qrLabelIsw
		if qLabelIsw != "" {

			if err := r.SetQueryParam("label__isw", qLabelIsw); err != nil {
				return err
			}
		}
	}

	if o.Labeln != nil {

		// query param label__n
		var qrLabeln string

		if o.Labeln != nil {
			qrLabeln = *o.Labeln
		}
		qLabeln := qrLabeln
		if qLabeln != "" {

			if err := r.SetQueryParam("label__n", qLabeln); err != nil {
				return err
			}
		}
	}

	if o.LabelNic != nil {

		// query param label__nic
		var qrLabelNic string

		if o.LabelNic != nil {
			qrLabelNic = *o.LabelNic
		}
		qLabelNic := qrLabelNic
		if qLabelNic != "" {

			if err := r.SetQueryParam("label__nic", qLabelNic); err != nil {
				return err
			}
		}
	}

	if o.LabelNie != nil {

		// query param label__nie
		var qrLabelNie string

		if o.LabelNie != nil {
			qrLabelNie = *o.LabelNie
		}
		qLabelNie := qrLabelNie
		if qLabelNie != "" {

			if err := r.SetQueryParam("label__nie", qLabelNie); err != nil {
				return err
			}
		}
	}

	if o.LabelNiew != nil {

		// query param label__niew
		var qrLabelNiew string

		if o.LabelNiew != nil {
			qrLabelNiew = *o.LabelNiew
		}
		qLabelNiew := qrLabelNiew
		if qLabelNiew != "" {

			if err := r.SetQueryParam("label__niew", qLabelNiew); err != nil {
				return err
			}
		}
	}

	if o.LabelNisw != nil {

		// query param label__nisw
		var qrLabelNisw string

		if o.LabelNisw != nil {
			qrLabelNisw = *o.LabelNisw
		}
		qLabelNisw := qrLabelNisw
		if qLabelNisw != "" {

			if err := r.SetQueryParam("label__nisw", qLabelNisw); err != nil {
				return err
			}
		}
	}

	if o.LastUpdated != nil {

		// query param last_updated
		var qrLastUpdated string

		if o.LastUpdated != nil {
			qrLastUpdated = *o.LastUpdated
		}
		qLastUpdated := qrLastUpdated
		if qLastUpdated != "" {

			if err := r.SetQueryParam("last_updated", qLastUpdated); err != nil {
				return err
			}
		}
	}

	if o.LastUpdatedGte != nil {

		// query param last_updated__gte
		var qrLastUpdatedGte string

		if o.LastUpdatedGte != nil {
			qrLastUpdatedGte = *o.LastUpdatedGte
		}
		qLastUpdatedGte := qrLastUpdatedGte
		if qLastUpdatedGte != "" {

			if err := r.SetQueryParam("last_updated__gte", qLastUpdatedGte); err != nil {
				return err
			}
		}
	}

	if o.LastUpdatedLte != nil {

		// query param last_updated__lte
		var qrLastUpdatedLte string

		if o.LastUpdatedLte != nil {
			qrLastUpdatedLte = *o.LastUpdatedLte
		}
		qLastUpdatedLte := qrLastUpdatedLte
		if qLastUpdatedLte != "" {

			if err := r.SetQueryParam("last_updated__lte", qLastUpdatedLte); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Location != nil {

		// query param location
		var qrLocation string

		if o.Location != nil {
			qrLocation = *o.Location
		}
		qLocation := qrLocation
		if qLocation != "" {

			if err := r.SetQueryParam("location", qLocation); err != nil {
				return err
			}
		}
	}

	if o.Locationn != nil {

		// query param location__n
		var qrLocationn string

		if o.Locationn != nil {
			qrLocationn = *o.Locationn
		}
		qLocationn := qrLocationn
		if qLocationn != "" {

			if err := r.SetQueryParam("location__n", qLocationn); err != nil {
				return err
			}
		}
	}

	if o.LocationID != nil {

		// query param location_id
		var qrLocationID string

		if o.LocationID != nil {
			qrLocationID = *o.LocationID
		}
		qLocationID := qrLocationID
		if qLocationID != "" {

			if err := r.SetQueryParam("location_id", qLocationID); err != nil {
				return err
			}
		}
	}

	if o.LocationIDn != nil {

		// query param location_id__n
		var qrLocationIDn string

		if o.LocationIDn != nil {
			qrLocationIDn = *o.LocationIDn
		}
		qLocationIDn := qrLocationIDn
		if qLocationIDn != "" {

			if err := r.SetQueryParam("location_id__n", qLocationIDn); err != nil {
				return err
			}
		}
	}

	if o.Manufacturer != nil {

		// query param manufacturer
		var qrManufacturer string

		if o.Manufacturer != nil {
			qrManufacturer = *o.Manufacturer
		}
		qManufacturer := qrManufacturer
		if qManufacturer != "" {

			if err := r.SetQueryParam("manufacturer", qManufacturer); err != nil {
				return err
			}
		}
	}

	if o.Manufacturern != nil {

		// query param manufacturer__n
		var qrManufacturern string

		if o.Manufacturern != nil {
			qrManufacturern = *o.Manufacturern
		}
		qManufacturern := qrManufacturern
		if qManufacturern != "" {

			if err := r.SetQueryParam("manufacturer__n", qManufacturern); err != nil {
				return err
			}
		}
	}

	if o.ManufacturerID != nil {

		// query param manufacturer_id
		var qrManufacturerID string

		if o.ManufacturerID != nil {
			qrManufacturerID = *o.ManufacturerID
		}
		qManufacturerID := qrManufacturerID
		if qManufacturerID != "" {

			if err := r.SetQueryParam("manufacturer_id", qManufacturerID); err != nil {
				return err
			}
		}
	}

	if o.ManufacturerIDn != nil {

		// query param manufacturer_id__n
		var qrManufacturerIDn string

		if o.ManufacturerIDn != nil {
			qrManufacturerIDn = *o.ManufacturerIDn
		}
		qManufacturerIDn := qrManufacturerIDn
		if qManufacturerIDn != "" {

			if err := r.SetQueryParam("manufacturer_id__n", qManufacturerIDn); err != nil {
				return err
			}
		}
	}

	if o.Name != nil {

		// query param name
		var qrName string

		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.NameIc != nil {

		// query param name__ic
		var qrNameIc string

		if o.NameIc != nil {
			qrNameIc = *o.NameIc
		}
		qNameIc := qrNameIc
		if qNameIc != "" {

			if err := r.SetQueryParam("name__ic", qNameIc); err != nil {
				return err
			}
		}
	}

	if o.NameIe != nil {

		// query param name__ie
		var qrNameIe string

		if o.NameIe != nil {
			qrNameIe = *o.NameIe
		}
		qNameIe := qrNameIe
		if qNameIe != "" {

			if err := r.SetQueryParam("name__ie", qNameIe); err != nil {
				return err
			}
		}
	}

	if o.NameIew != nil {

		// query param name__iew
		var qrNameIew string

		if o.NameIew != nil {
			qrNameIew = *o.NameIew
		}
		qNameIew := qrNameIew
		if qNameIew != "" {

			if err := r.SetQueryParam("name__iew", qNameIew); err != nil {
				return err
			}
		}
	}

	if o.NameIsw != nil {

		// query param name__isw
		var qrNameIsw string

		if o.NameIsw != nil {
			qrNameIsw = *o.NameIsw
		}
		qNameIsw := qrNameIsw
		if qNameIsw != "" {

			if err := r.SetQueryParam("name__isw", qNameIsw); err != nil {
				return err
			}
		}
	}

	if o.Namen != nil {

		// query param name__n
		var qrNamen string

		if o.Namen != nil {
			qrNamen = *o.Namen
		}
		qNamen := qrNamen
		if qNamen != "" {

			if err := r.SetQueryParam("name__n", qNamen); err != nil {
				return err
			}
		}
	}

	if o.NameNic != nil {

		// query param name__nic
		var qrNameNic string

		if o.NameNic != nil {
			qrNameNic = *o.NameNic
		}
		qNameNic := qrNameNic
		if qNameNic != "" {

			if err := r.SetQueryParam("name__nic", qNameNic); err != nil {
				return err
			}
		}
	}

	if o.NameNie != nil {

		// query param name__nie
		var qrNameNie string

		if o.NameNie != nil {
			qrNameNie = *o.NameNie
		}
		qNameNie := qrNameNie
		if qNameNie != "" {

			if err := r.SetQueryParam("name__nie", qNameNie); err != nil {
				return err
			}
		}
	}

	if o.NameNiew != nil {

		// query param name__niew
		var qrNameNiew string

		if o.NameNiew != nil {
			qrNameNiew = *o.NameNiew
		}
		qNameNiew := qrNameNiew
		if qNameNiew != "" {

			if err := r.SetQueryParam("name__niew", qNameNiew); err != nil {
				return err
			}
		}
	}

	if o.NameNisw != nil {

		// query param name__nisw
		var qrNameNisw string

		if o.NameNisw != nil {
			qrNameNisw = *o.NameNisw
		}
		qNameNisw := qrNameNisw
		if qNameNisw != "" {

			if err := r.SetQueryParam("name__nisw", qNameNisw); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if o.ParentID != nil {

		// query param parent_id
		var qrParentID string

		if o.ParentID != nil {
			qrParentID = *o.ParentID
		}
		qParentID := qrParentID
		if qParentID != "" {

			if err := r.SetQueryParam("parent_id", qParentID); err != nil {
				return err
			}
		}
	}

	if o.ParentIDn != nil {

		// query param parent_id__n
		var qrParentIDn string

		if o.ParentIDn != nil {
			qrParentIDn = *o.ParentIDn
		}
		qParentIDn := qrParentIDn
		if qParentIDn != "" {

			if err := r.SetQueryParam("parent_id__n", qParentIDn); err != nil {
				return err
			}
		}
	}

	if o.PartID != nil {

		// query param part_id
		var qrPartID string

		if o.PartID != nil {
			qrPartID = *o.PartID
		}
		qPartID := qrPartID
		if qPartID != "" {

			if err := r.SetQueryParam("part_id", qPartID); err != nil {
				return err
			}
		}
	}

	if o.PartIDIc != nil {

		// query param part_id__ic
		var qrPartIDIc string

		if o.PartIDIc != nil {
			qrPartIDIc = *o.PartIDIc
		}
		qPartIDIc := qrPartIDIc
		if qPartIDIc != "" {

			if err := r.SetQueryParam("part_id__ic", qPartIDIc); err != nil {
				return err
			}
		}
	}

	if o.PartIDIe != nil {

		// query param part_id__ie
		var qrPartIDIe string

		if o.PartIDIe != nil {
			qrPartIDIe = *o.PartIDIe
		}
		qPartIDIe := qrPartIDIe
		if qPartIDIe != "" {

			if err := r.SetQueryParam("part_id__ie", qPartIDIe); err != nil {
				return err
			}
		}
	}

	if o.PartIDIew != nil {

		// query param part_id__iew
		var qrPartIDIew string

		if o.PartIDIew != nil {
			qrPartIDIew = *o.PartIDIew
		}
		qPartIDIew := qrPartIDIew
		if qPartIDIew != "" {

			if err := r.SetQueryParam("part_id__iew", qPartIDIew); err != nil {
				return err
			}
		}
	}

	if o.PartIDIsw != nil {

		// query param part_id__isw
		var qrPartIDIsw string

		if o.PartIDIsw != nil {
			qrPartIDIsw = *o.PartIDIsw
		}
		qPartIDIsw := qrPartIDIsw
		if qPartIDIsw != "" {

			if err := r.SetQueryParam("part_id__isw", qPartIDIsw); err != nil {
				return err
			}
		}
	}

	if o.PartIDn != nil {

		// query param part_id__n
		var qrPartIDn string

		if o.PartIDn != nil {
			qrPartIDn = *o.PartIDn
		}
		qPartIDn := qrPartIDn
		if qPartIDn != "" {

			if err := r.SetQueryParam("part_id__n", qPartIDn); err != nil {
				return err
			}
		}
	}

	if o.PartIDNic != nil {

		// query param part_id__nic
		var qrPartIDNic string

		if o.PartIDNic != nil {
			qrPartIDNic = *o.PartIDNic
		}
		qPartIDNic := qrPartIDNic
		if qPartIDNic != "" {

			if err := r.SetQueryParam("part_id__nic", qPartIDNic); err != nil {
				return err
			}
		}
	}

	if o.PartIDNie != nil {

		// query param part_id__nie
		var qrPartIDNie string

		if o.PartIDNie != nil {
			qrPartIDNie = *o.PartIDNie
		}
		qPartIDNie := qrPartIDNie
		if qPartIDNie != "" {

			if err := r.SetQueryParam("part_id__nie", qPartIDNie); err != nil {
				return err
			}
		}
	}

	if o.PartIDNiew != nil {

		// query param part_id__niew
		var qrPartIDNiew string

		if o.PartIDNiew != nil {
			qrPartIDNiew = *o.PartIDNiew
		}
		qPartIDNiew := qrPartIDNiew
		if qPartIDNiew != "" {

			if err := r.SetQueryParam("part_id__niew", qPartIDNiew); err != nil {
				return err
			}
		}
	}

	if o.PartIDNisw != nil {

		// query param part_id__nisw
		var qrPartIDNisw string

		if o.PartIDNisw != nil {
			qrPartIDNisw = *o.PartIDNisw
		}
		qPartIDNisw := qrPartIDNisw
		if qPartIDNisw != "" {

			if err := r.SetQueryParam("part_id__nisw", qPartIDNisw); err != nil {
				return err
			}
		}
	}

	if o.Q != nil {

		// query param q
		var qrQ string

		if o.Q != nil {
			qrQ = *o.Q
		}
		qQ := qrQ
		if qQ != "" {

			if err := r.SetQueryParam("q", qQ); err != nil {
				return err
			}
		}
	}

	if o.Region != nil {

		// query param region
		var qrRegion string

		if o.Region != nil {
			qrRegion = *o.Region
		}
		qRegion := qrRegion
		if qRegion != "" {

			if err := r.SetQueryParam("region", qRegion); err != nil {
				return err
			}
		}
	}

	if o.Regionn != nil {

		// query param region__n
		var qrRegionn string

		if o.Regionn != nil {
			qrRegionn = *o.Regionn
		}
		qRegionn := qrRegionn
		if qRegionn != "" {

			if err := r.SetQueryParam("region__n", qRegionn); err != nil {
				return err
			}
		}
	}

	if o.RegionID != nil {

		// query param region_id
		var qrRegionID string

		if o.RegionID != nil {
			qrRegionID = *o.RegionID
		}
		qRegionID := qrRegionID
		if qRegionID != "" {

			if err := r.SetQueryParam("region_id", qRegionID); err != nil {
				return err
			}
		}
	}

	if o.RegionIDn != nil {

		// query param region_id__n
		var qrRegionIDn string

		if o.RegionIDn != nil {
			qrRegionIDn = *o.RegionIDn
		}
		qRegionIDn := qrRegionIDn
		if qRegionIDn != "" {

			if err := r.SetQueryParam("region_id__n", qRegionIDn); err != nil {
				return err
			}
		}
	}

	if o.Role != nil {

		// query param role
		var qrRole string

		if o.Role != nil {
			qrRole = *o.Role
		}
		qRole := qrRole
		if qRole != "" {

			if err := r.SetQueryParam("role", qRole); err != nil {
				return err
			}
		}
	}

	if o.Rolen != nil {

		// query param role__n
		var qrRolen string

		if o.Rolen != nil {
			qrRolen = *o.Rolen
		}
		qRolen := qrRolen
		if qRolen != "" {

			if err := r.SetQueryParam("role__n", qRolen); err != nil {
				return err
			}
		}
	}

	if o.RoleID != nil {

		// query param role_id
		var qrRoleID string

		if o.RoleID != nil {
			qrRoleID = *o.RoleID
		}
		qRoleID := qrRoleID
		if qRoleID != "" {

			if err := r.SetQueryParam("role_id", qRoleID); err != nil {
				return err
			}
		}
	}

	if o.RoleIDn != nil {

		// query param role_id__n
		var qrRoleIDn string

		if o.RoleIDn != nil {
			qrRoleIDn = *o.RoleIDn
		}
		qRoleIDn := qrRoleIDn
		if qRoleIDn != "" {

			if err := r.SetQueryParam("role_id__n", qRoleIDn); err != nil {
				return err
			}
		}
	}

	if o.Serial != nil {

		// query param serial
		var qrSerial string

		if o.Serial != nil {
			qrSerial = *o.Serial
		}
		qSerial := qrSerial
		if qSerial != "" {

			if err := r.SetQueryParam("serial", qSerial); err != nil {
				return err
			}
		}
	}

	if o.Site != nil {

		// query param site
		var qrSite string

		if o.Site != nil {
			qrSite = *o.Site
		}
		qSite := qrSite
		if qSite != "" {

			if err := r.SetQueryParam("site", qSite); err != nil {
				return err
			}
		}
	}

	if o.Siten != nil {

		// query param site__n
		var qrSiten string

		if o.Siten != nil {
			qrSiten = *o.Siten
		}
		qSiten := qrSiten
		if qSiten != "" {

			if err := r.SetQueryParam("site__n", qSiten); err != nil {
				return err
			}
		}
	}

	if o.SiteGroup != nil {

		// query param site_group
		var qrSiteGroup string

		if o.SiteGroup != nil {
			qrSiteGroup = *o.SiteGroup
		}
		qSiteGroup := qrSiteGroup
		if qSiteGroup != "" {

			if err := r.SetQueryParam("site_group", qSiteGroup); err != nil {
				return err
			}
		}
	}

	if o.SiteGroupn != nil {

		// query param site_group__n
		var qrSiteGroupn string

		if o.SiteGroupn != nil {
			qrSiteGroupn = *o.SiteGroupn
		}
		qSiteGroupn := qrSiteGroupn
		if qSiteGroupn != "" {

			if err := r.SetQueryParam("site_group__n", qSiteGroupn); err != nil {
				return err
			}
		}
	}

	if o.SiteGroupID != nil {

		// query param site_group_id
		var qrSiteGroupID string

		if o.SiteGroupID != nil {
			qrSiteGroupID = *o.SiteGroupID
		}
		qSiteGroupID := qrSiteGroupID
		if qSiteGroupID != "" {

			if err := r.SetQueryParam("site_group_id", qSiteGroupID); err != nil {
				return err
			}
		}
	}

	if o.SiteGroupIDn != nil {

		// query param site_group_id__n
		var qrSiteGroupIDn string

		if o.SiteGroupIDn != nil {
			qrSiteGroupIDn = *o.SiteGroupIDn
		}
		qSiteGroupIDn := qrSiteGroupIDn
		if qSiteGroupIDn != "" {

			if err := r.SetQueryParam("site_group_id__n", qSiteGroupIDn); err != nil {
				return err
			}
		}
	}

	if o.SiteID != nil {

		// query param site_id
		var qrSiteID string

		if o.SiteID != nil {
			qrSiteID = *o.SiteID
		}
		qSiteID := qrSiteID
		if qSiteID != "" {

			if err := r.SetQueryParam("site_id", qSiteID); err != nil {
				return err
			}
		}
	}

	if o.SiteIDn != nil {

		// query param site_id__n
		var qrSiteIDn string

		if o.SiteIDn != nil {
			qrSiteIDn = *o.SiteIDn
		}
		qSiteIDn := qrSiteIDn
		if qSiteIDn != "" {

			if err := r.SetQueryParam("site_id__n", qSiteIDn); err != nil {
				return err
			}
		}
	}

	if o.Tag != nil {

		// query param tag
		var qrTag string

		if o.Tag != nil {
			qrTag = *o.Tag
		}
		qTag := qrTag
		if qTag != "" {

			if err := r.SetQueryParam("tag", qTag); err != nil {
				return err
			}
		}
	}

	if o.Tagn != nil {

		// query param tag__n
		var qrTagn string

		if o.Tagn != nil {
			qrTagn = *o.Tagn
		}
		qTagn := qrTagn
		if qTagn != "" {

			if err := r.SetQueryParam("tag__n", qTagn); err != nil {
				return err
			}
		}
	}

	if o.VirtualChassis != nil {

		// query param virtual_chassis
		var qrVirtualChassis string

		if o.VirtualChassis != nil {
			qrVirtualChassis = *o.VirtualChassis
		}
		qVirtualChassis := qrVirtualChassis
		if qVirtualChassis != "" {

			if err := r.SetQueryParam("virtual_chassis", qVirtualChassis); err != nil {
				return err
			}
		}
	}

	if o.VirtualChassisn != nil {

		// query param virtual_chassis__n
		var qrVirtualChassisn string

		if o.VirtualChassisn != nil {
			qrVirtualChassisn = *o.VirtualChassisn
		}
		qVirtualChassisn := qrVirtualChassisn
		if qVirtualChassisn != "" {

			if err := r.SetQueryParam("virtual_chassis__n", qVirtualChassisn); err != nil {
				return err
			}
		}
	}

	if o.VirtualChassisID != nil {

		// query param virtual_chassis_id
		var qrVirtualChassisID string

		if o.VirtualChassisID != nil {
			qrVirtualChassisID = *o.VirtualChassisID
		}
		qVirtualChassisID := qrVirtualChassisID
		if qVirtualChassisID != "" {

			if err := r.SetQueryParam("virtual_chassis_id", qVirtualChassisID); err != nil {
				return err
			}
		}
	}

	if o.VirtualChassisIDn != nil {

		// query param virtual_chassis_id__n
		var qrVirtualChassisIDn string

		if o.VirtualChassisIDn != nil {
			qrVirtualChassisIDn = *o.VirtualChassisIDn
		}
		qVirtualChassisIDn := qrVirtualChassisIDn
		if qVirtualChassisIDn != "" {

			if err := r.SetQueryParam("virtual_chassis_id__n", qVirtualChassisIDn); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
