// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2020 The go-netbox Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package dcim

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewDcimModuleTypesListParams creates a new DcimModuleTypesListParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDcimModuleTypesListParams() *DcimModuleTypesListParams {
	return &DcimModuleTypesListParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDcimModuleTypesListParamsWithTimeout creates a new DcimModuleTypesListParams object
// with the ability to set a timeout on a request.
func NewDcimModuleTypesListParamsWithTimeout(timeout time.Duration) *DcimModuleTypesListParams {
	return &DcimModuleTypesListParams{
		timeout: timeout,
	}
}

// NewDcimModuleTypesListParamsWithContext creates a new DcimModuleTypesListParams object
// with the ability to set a context for a request.
func NewDcimModuleTypesListParamsWithContext(ctx context.Context) *DcimModuleTypesListParams {
	return &DcimModuleTypesListParams{
		Context: ctx,
	}
}

// NewDcimModuleTypesListParamsWithHTTPClient creates a new DcimModuleTypesListParams object
// with the ability to set a custom HTTPClient for a request.
func NewDcimModuleTypesListParamsWithHTTPClient(client *http.Client) *DcimModuleTypesListParams {
	return &DcimModuleTypesListParams{
		HTTPClient: client,
	}
}

/* DcimModuleTypesListParams contains all the parameters to send to the API endpoint
   for the dcim module types list operation.

   Typically these are written to a http.Request.
*/
type DcimModuleTypesListParams struct {

	// ConsolePorts.
	ConsolePorts *string

	// ConsoleServerPorts.
	ConsoleServerPorts *string

	// Created.
	Created *string

	// CreatedGte.
	CreatedGte *string

	// CreatedLte.
	CreatedLte *string

	// ID.
	ID *string

	// IDGt.
	IDGt *string

	// IDGte.
	IDGte *string

	// IDLt.
	IDLt *string

	// IDLte.
	IDLte *string

	// IDn.
	IDn *string

	// Interfaces.
	Interfaces *string

	// LastUpdated.
	LastUpdated *string

	// LastUpdatedGte.
	LastUpdatedGte *string

	// LastUpdatedLte.
	LastUpdatedLte *string

	/* Limit.

	   Number of results to return per page.
	*/
	Limit *int64

	// Manufacturer.
	Manufacturer *string

	// Manufacturern.
	Manufacturern *string

	// ManufacturerID.
	ManufacturerID *string

	// ManufacturerIDn.
	ManufacturerIDn *string

	// Model.
	Model *string

	// ModelIc.
	ModelIc *string

	// ModelIe.
	ModelIe *string

	// ModelIew.
	ModelIew *string

	// ModelIsw.
	ModelIsw *string

	// Modeln.
	Modeln *string

	// ModelNic.
	ModelNic *string

	// ModelNie.
	ModelNie *string

	// ModelNiew.
	ModelNiew *string

	// ModelNisw.
	ModelNisw *string

	/* Offset.

	   The initial index from which to return the results.
	*/
	Offset *int64

	// PartNumber.
	PartNumber *string

	// PartNumberIc.
	PartNumberIc *string

	// PartNumberIe.
	PartNumberIe *string

	// PartNumberIew.
	PartNumberIew *string

	// PartNumberIsw.
	PartNumberIsw *string

	// PartNumbern.
	PartNumbern *string

	// PartNumberNic.
	PartNumberNic *string

	// PartNumberNie.
	PartNumberNie *string

	// PartNumberNiew.
	PartNumberNiew *string

	// PartNumberNisw.
	PartNumberNisw *string

	// PassThroughPorts.
	PassThroughPorts *string

	// PowerOutlets.
	PowerOutlets *string

	// PowerPorts.
	PowerPorts *string

	// Q.
	Q *string

	// Tag.
	Tag *string

	// Tagn.
	Tagn *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the dcim module types list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DcimModuleTypesListParams) WithDefaults() *DcimModuleTypesListParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the dcim module types list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DcimModuleTypesListParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the dcim module types list params
func (o *DcimModuleTypesListParams) WithTimeout(timeout time.Duration) *DcimModuleTypesListParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the dcim module types list params
func (o *DcimModuleTypesListParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the dcim module types list params
func (o *DcimModuleTypesListParams) WithContext(ctx context.Context) *DcimModuleTypesListParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the dcim module types list params
func (o *DcimModuleTypesListParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the dcim module types list params
func (o *DcimModuleTypesListParams) WithHTTPClient(client *http.Client) *DcimModuleTypesListParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the dcim module types list params
func (o *DcimModuleTypesListParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithConsolePorts adds the consolePorts to the dcim module types list params
func (o *DcimModuleTypesListParams) WithConsolePorts(consolePorts *string) *DcimModuleTypesListParams {
	o.SetConsolePorts(consolePorts)
	return o
}

// SetConsolePorts adds the consolePorts to the dcim module types list params
func (o *DcimModuleTypesListParams) SetConsolePorts(consolePorts *string) {
	o.ConsolePorts = consolePorts
}

// WithConsoleServerPorts adds the consoleServerPorts to the dcim module types list params
func (o *DcimModuleTypesListParams) WithConsoleServerPorts(consoleServerPorts *string) *DcimModuleTypesListParams {
	o.SetConsoleServerPorts(consoleServerPorts)
	return o
}

// SetConsoleServerPorts adds the consoleServerPorts to the dcim module types list params
func (o *DcimModuleTypesListParams) SetConsoleServerPorts(consoleServerPorts *string) {
	o.ConsoleServerPorts = consoleServerPorts
}

// WithCreated adds the created to the dcim module types list params
func (o *DcimModuleTypesListParams) WithCreated(created *string) *DcimModuleTypesListParams {
	o.SetCreated(created)
	return o
}

// SetCreated adds the created to the dcim module types list params
func (o *DcimModuleTypesListParams) SetCreated(created *string) {
	o.Created = created
}

// WithCreatedGte adds the createdGte to the dcim module types list params
func (o *DcimModuleTypesListParams) WithCreatedGte(createdGte *string) *DcimModuleTypesListParams {
	o.SetCreatedGte(createdGte)
	return o
}

// SetCreatedGte adds the createdGte to the dcim module types list params
func (o *DcimModuleTypesListParams) SetCreatedGte(createdGte *string) {
	o.CreatedGte = createdGte
}

// WithCreatedLte adds the createdLte to the dcim module types list params
func (o *DcimModuleTypesListParams) WithCreatedLte(createdLte *string) *DcimModuleTypesListParams {
	o.SetCreatedLte(createdLte)
	return o
}

// SetCreatedLte adds the createdLte to the dcim module types list params
func (o *DcimModuleTypesListParams) SetCreatedLte(createdLte *string) {
	o.CreatedLte = createdLte
}

// WithID adds the id to the dcim module types list params
func (o *DcimModuleTypesListParams) WithID(id *string) *DcimModuleTypesListParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the dcim module types list params
func (o *DcimModuleTypesListParams) SetID(id *string) {
	o.ID = id
}

// WithIDGt adds the iDGt to the dcim module types list params
func (o *DcimModuleTypesListParams) WithIDGt(iDGt *string) *DcimModuleTypesListParams {
	o.SetIDGt(iDGt)
	return o
}

// SetIDGt adds the idGt to the dcim module types list params
func (o *DcimModuleTypesListParams) SetIDGt(iDGt *string) {
	o.IDGt = iDGt
}

// WithIDGte adds the iDGte to the dcim module types list params
func (o *DcimModuleTypesListParams) WithIDGte(iDGte *string) *DcimModuleTypesListParams {
	o.SetIDGte(iDGte)
	return o
}

// SetIDGte adds the idGte to the dcim module types list params
func (o *DcimModuleTypesListParams) SetIDGte(iDGte *string) {
	o.IDGte = iDGte
}

// WithIDLt adds the iDLt to the dcim module types list params
func (o *DcimModuleTypesListParams) WithIDLt(iDLt *string) *DcimModuleTypesListParams {
	o.SetIDLt(iDLt)
	return o
}

// SetIDLt adds the idLt to the dcim module types list params
func (o *DcimModuleTypesListParams) SetIDLt(iDLt *string) {
	o.IDLt = iDLt
}

// WithIDLte adds the iDLte to the dcim module types list params
func (o *DcimModuleTypesListParams) WithIDLte(iDLte *string) *DcimModuleTypesListParams {
	o.SetIDLte(iDLte)
	return o
}

// SetIDLte adds the idLte to the dcim module types list params
func (o *DcimModuleTypesListParams) SetIDLte(iDLte *string) {
	o.IDLte = iDLte
}

// WithIDn adds the iDn to the dcim module types list params
func (o *DcimModuleTypesListParams) WithIDn(iDn *string) *DcimModuleTypesListParams {
	o.SetIDn(iDn)
	return o
}

// SetIDn adds the idN to the dcim module types list params
func (o *DcimModuleTypesListParams) SetIDn(iDn *string) {
	o.IDn = iDn
}

// WithInterfaces adds the interfaces to the dcim module types list params
func (o *DcimModuleTypesListParams) WithInterfaces(interfaces *string) *DcimModuleTypesListParams {
	o.SetInterfaces(interfaces)
	return o
}

// SetInterfaces adds the interfaces to the dcim module types list params
func (o *DcimModuleTypesListParams) SetInterfaces(interfaces *string) {
	o.Interfaces = interfaces
}

// WithLastUpdated adds the lastUpdated to the dcim module types list params
func (o *DcimModuleTypesListParams) WithLastUpdated(lastUpdated *string) *DcimModuleTypesListParams {
	o.SetLastUpdated(lastUpdated)
	return o
}

// SetLastUpdated adds the lastUpdated to the dcim module types list params
func (o *DcimModuleTypesListParams) SetLastUpdated(lastUpdated *string) {
	o.LastUpdated = lastUpdated
}

// WithLastUpdatedGte adds the lastUpdatedGte to the dcim module types list params
func (o *DcimModuleTypesListParams) WithLastUpdatedGte(lastUpdatedGte *string) *DcimModuleTypesListParams {
	o.SetLastUpdatedGte(lastUpdatedGte)
	return o
}

// SetLastUpdatedGte adds the lastUpdatedGte to the dcim module types list params
func (o *DcimModuleTypesListParams) SetLastUpdatedGte(lastUpdatedGte *string) {
	o.LastUpdatedGte = lastUpdatedGte
}

// WithLastUpdatedLte adds the lastUpdatedLte to the dcim module types list params
func (o *DcimModuleTypesListParams) WithLastUpdatedLte(lastUpdatedLte *string) *DcimModuleTypesListParams {
	o.SetLastUpdatedLte(lastUpdatedLte)
	return o
}

// SetLastUpdatedLte adds the lastUpdatedLte to the dcim module types list params
func (o *DcimModuleTypesListParams) SetLastUpdatedLte(lastUpdatedLte *string) {
	o.LastUpdatedLte = lastUpdatedLte
}

// WithLimit adds the limit to the dcim module types list params
func (o *DcimModuleTypesListParams) WithLimit(limit *int64) *DcimModuleTypesListParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the dcim module types list params
func (o *DcimModuleTypesListParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithManufacturer adds the manufacturer to the dcim module types list params
func (o *DcimModuleTypesListParams) WithManufacturer(manufacturer *string) *DcimModuleTypesListParams {
	o.SetManufacturer(manufacturer)
	return o
}

// SetManufacturer adds the manufacturer to the dcim module types list params
func (o *DcimModuleTypesListParams) SetManufacturer(manufacturer *string) {
	o.Manufacturer = manufacturer
}

// WithManufacturern adds the manufacturern to the dcim module types list params
func (o *DcimModuleTypesListParams) WithManufacturern(manufacturern *string) *DcimModuleTypesListParams {
	o.SetManufacturern(manufacturern)
	return o
}

// SetManufacturern adds the manufacturerN to the dcim module types list params
func (o *DcimModuleTypesListParams) SetManufacturern(manufacturern *string) {
	o.Manufacturern = manufacturern
}

// WithManufacturerID adds the manufacturerID to the dcim module types list params
func (o *DcimModuleTypesListParams) WithManufacturerID(manufacturerID *string) *DcimModuleTypesListParams {
	o.SetManufacturerID(manufacturerID)
	return o
}

// SetManufacturerID adds the manufacturerId to the dcim module types list params
func (o *DcimModuleTypesListParams) SetManufacturerID(manufacturerID *string) {
	o.ManufacturerID = manufacturerID
}

// WithManufacturerIDn adds the manufacturerIDn to the dcim module types list params
func (o *DcimModuleTypesListParams) WithManufacturerIDn(manufacturerIDn *string) *DcimModuleTypesListParams {
	o.SetManufacturerIDn(manufacturerIDn)
	return o
}

// SetManufacturerIDn adds the manufacturerIdN to the dcim module types list params
func (o *DcimModuleTypesListParams) SetManufacturerIDn(manufacturerIDn *string) {
	o.ManufacturerIDn = manufacturerIDn
}

// WithModel adds the model to the dcim module types list params
func (o *DcimModuleTypesListParams) WithModel(model *string) *DcimModuleTypesListParams {
	o.SetModel(model)
	return o
}

// SetModel adds the model to the dcim module types list params
func (o *DcimModuleTypesListParams) SetModel(model *string) {
	o.Model = model
}

// WithModelIc adds the modelIc to the dcim module types list params
func (o *DcimModuleTypesListParams) WithModelIc(modelIc *string) *DcimModuleTypesListParams {
	o.SetModelIc(modelIc)
	return o
}

// SetModelIc adds the modelIc to the dcim module types list params
func (o *DcimModuleTypesListParams) SetModelIc(modelIc *string) {
	o.ModelIc = modelIc
}

// WithModelIe adds the modelIe to the dcim module types list params
func (o *DcimModuleTypesListParams) WithModelIe(modelIe *string) *DcimModuleTypesListParams {
	o.SetModelIe(modelIe)
	return o
}

// SetModelIe adds the modelIe to the dcim module types list params
func (o *DcimModuleTypesListParams) SetModelIe(modelIe *string) {
	o.ModelIe = modelIe
}

// WithModelIew adds the modelIew to the dcim module types list params
func (o *DcimModuleTypesListParams) WithModelIew(modelIew *string) *DcimModuleTypesListParams {
	o.SetModelIew(modelIew)
	return o
}

// SetModelIew adds the modelIew to the dcim module types list params
func (o *DcimModuleTypesListParams) SetModelIew(modelIew *string) {
	o.ModelIew = modelIew
}

// WithModelIsw adds the modelIsw to the dcim module types list params
func (o *DcimModuleTypesListParams) WithModelIsw(modelIsw *string) *DcimModuleTypesListParams {
	o.SetModelIsw(modelIsw)
	return o
}

// SetModelIsw adds the modelIsw to the dcim module types list params
func (o *DcimModuleTypesListParams) SetModelIsw(modelIsw *string) {
	o.ModelIsw = modelIsw
}

// WithModeln adds the modeln to the dcim module types list params
func (o *DcimModuleTypesListParams) WithModeln(modeln *string) *DcimModuleTypesListParams {
	o.SetModeln(modeln)
	return o
}

// SetModeln adds the modelN to the dcim module types list params
func (o *DcimModuleTypesListParams) SetModeln(modeln *string) {
	o.Modeln = modeln
}

// WithModelNic adds the modelNic to the dcim module types list params
func (o *DcimModuleTypesListParams) WithModelNic(modelNic *string) *DcimModuleTypesListParams {
	o.SetModelNic(modelNic)
	return o
}

// SetModelNic adds the modelNic to the dcim module types list params
func (o *DcimModuleTypesListParams) SetModelNic(modelNic *string) {
	o.ModelNic = modelNic
}

// WithModelNie adds the modelNie to the dcim module types list params
func (o *DcimModuleTypesListParams) WithModelNie(modelNie *string) *DcimModuleTypesListParams {
	o.SetModelNie(modelNie)
	return o
}

// SetModelNie adds the modelNie to the dcim module types list params
func (o *DcimModuleTypesListParams) SetModelNie(modelNie *string) {
	o.ModelNie = modelNie
}

// WithModelNiew adds the modelNiew to the dcim module types list params
func (o *DcimModuleTypesListParams) WithModelNiew(modelNiew *string) *DcimModuleTypesListParams {
	o.SetModelNiew(modelNiew)
	return o
}

// SetModelNiew adds the modelNiew to the dcim module types list params
func (o *DcimModuleTypesListParams) SetModelNiew(modelNiew *string) {
	o.ModelNiew = modelNiew
}

// WithModelNisw adds the modelNisw to the dcim module types list params
func (o *DcimModuleTypesListParams) WithModelNisw(modelNisw *string) *DcimModuleTypesListParams {
	o.SetModelNisw(modelNisw)
	return o
}

// SetModelNisw adds the modelNisw to the dcim module types list params
func (o *DcimModuleTypesListParams) SetModelNisw(modelNisw *string) {
	o.ModelNisw = modelNisw
}

// WithOffset adds the offset to the dcim module types list params
func (o *DcimModuleTypesListParams) WithOffset(offset *int64) *DcimModuleTypesListParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the dcim module types list params
func (o *DcimModuleTypesListParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithPartNumber adds the partNumber to the dcim module types list params
func (o *DcimModuleTypesListParams) WithPartNumber(partNumber *string) *DcimModuleTypesListParams {
	o.SetPartNumber(partNumber)
	return o
}

// SetPartNumber adds the partNumber to the dcim module types list params
func (o *DcimModuleTypesListParams) SetPartNumber(partNumber *string) {
	o.PartNumber = partNumber
}

// WithPartNumberIc adds the partNumberIc to the dcim module types list params
func (o *DcimModuleTypesListParams) WithPartNumberIc(partNumberIc *string) *DcimModuleTypesListParams {
	o.SetPartNumberIc(partNumberIc)
	return o
}

// SetPartNumberIc adds the partNumberIc to the dcim module types list params
func (o *DcimModuleTypesListParams) SetPartNumberIc(partNumberIc *string) {
	o.PartNumberIc = partNumberIc
}

// WithPartNumberIe adds the partNumberIe to the dcim module types list params
func (o *DcimModuleTypesListParams) WithPartNumberIe(partNumberIe *string) *DcimModuleTypesListParams {
	o.SetPartNumberIe(partNumberIe)
	return o
}

// SetPartNumberIe adds the partNumberIe to the dcim module types list params
func (o *DcimModuleTypesListParams) SetPartNumberIe(partNumberIe *string) {
	o.PartNumberIe = partNumberIe
}

// WithPartNumberIew adds the partNumberIew to the dcim module types list params
func (o *DcimModuleTypesListParams) WithPartNumberIew(partNumberIew *string) *DcimModuleTypesListParams {
	o.SetPartNumberIew(partNumberIew)
	return o
}

// SetPartNumberIew adds the partNumberIew to the dcim module types list params
func (o *DcimModuleTypesListParams) SetPartNumberIew(partNumberIew *string) {
	o.PartNumberIew = partNumberIew
}

// WithPartNumberIsw adds the partNumberIsw to the dcim module types list params
func (o *DcimModuleTypesListParams) WithPartNumberIsw(partNumberIsw *string) *DcimModuleTypesListParams {
	o.SetPartNumberIsw(partNumberIsw)
	return o
}

// SetPartNumberIsw adds the partNumberIsw to the dcim module types list params
func (o *DcimModuleTypesListParams) SetPartNumberIsw(partNumberIsw *string) {
	o.PartNumberIsw = partNumberIsw
}

// WithPartNumbern adds the partNumbern to the dcim module types list params
func (o *DcimModuleTypesListParams) WithPartNumbern(partNumbern *string) *DcimModuleTypesListParams {
	o.SetPartNumbern(partNumbern)
	return o
}

// SetPartNumbern adds the partNumberN to the dcim module types list params
func (o *DcimModuleTypesListParams) SetPartNumbern(partNumbern *string) {
	o.PartNumbern = partNumbern
}

// WithPartNumberNic adds the partNumberNic to the dcim module types list params
func (o *DcimModuleTypesListParams) WithPartNumberNic(partNumberNic *string) *DcimModuleTypesListParams {
	o.SetPartNumberNic(partNumberNic)
	return o
}

// SetPartNumberNic adds the partNumberNic to the dcim module types list params
func (o *DcimModuleTypesListParams) SetPartNumberNic(partNumberNic *string) {
	o.PartNumberNic = partNumberNic
}

// WithPartNumberNie adds the partNumberNie to the dcim module types list params
func (o *DcimModuleTypesListParams) WithPartNumberNie(partNumberNie *string) *DcimModuleTypesListParams {
	o.SetPartNumberNie(partNumberNie)
	return o
}

// SetPartNumberNie adds the partNumberNie to the dcim module types list params
func (o *DcimModuleTypesListParams) SetPartNumberNie(partNumberNie *string) {
	o.PartNumberNie = partNumberNie
}

// WithPartNumberNiew adds the partNumberNiew to the dcim module types list params
func (o *DcimModuleTypesListParams) WithPartNumberNiew(partNumberNiew *string) *DcimModuleTypesListParams {
	o.SetPartNumberNiew(partNumberNiew)
	return o
}

// SetPartNumberNiew adds the partNumberNiew to the dcim module types list params
func (o *DcimModuleTypesListParams) SetPartNumberNiew(partNumberNiew *string) {
	o.PartNumberNiew = partNumberNiew
}

// WithPartNumberNisw adds the partNumberNisw to the dcim module types list params
func (o *DcimModuleTypesListParams) WithPartNumberNisw(partNumberNisw *string) *DcimModuleTypesListParams {
	o.SetPartNumberNisw(partNumberNisw)
	return o
}

// SetPartNumberNisw adds the partNumberNisw to the dcim module types list params
func (o *DcimModuleTypesListParams) SetPartNumberNisw(partNumberNisw *string) {
	o.PartNumberNisw = partNumberNisw
}

// WithPassThroughPorts adds the passThroughPorts to the dcim module types list params
func (o *DcimModuleTypesListParams) WithPassThroughPorts(passThroughPorts *string) *DcimModuleTypesListParams {
	o.SetPassThroughPorts(passThroughPorts)
	return o
}

// SetPassThroughPorts adds the passThroughPorts to the dcim module types list params
func (o *DcimModuleTypesListParams) SetPassThroughPorts(passThroughPorts *string) {
	o.PassThroughPorts = passThroughPorts
}

// WithPowerOutlets adds the powerOutlets to the dcim module types list params
func (o *DcimModuleTypesListParams) WithPowerOutlets(powerOutlets *string) *DcimModuleTypesListParams {
	o.SetPowerOutlets(powerOutlets)
	return o
}

// SetPowerOutlets adds the powerOutlets to the dcim module types list params
func (o *DcimModuleTypesListParams) SetPowerOutlets(powerOutlets *string) {
	o.PowerOutlets = powerOutlets
}

// WithPowerPorts adds the powerPorts to the dcim module types list params
func (o *DcimModuleTypesListParams) WithPowerPorts(powerPorts *string) *DcimModuleTypesListParams {
	o.SetPowerPorts(powerPorts)
	return o
}

// SetPowerPorts adds the powerPorts to the dcim module types list params
func (o *DcimModuleTypesListParams) SetPowerPorts(powerPorts *string) {
	o.PowerPorts = powerPorts
}

// WithQ adds the q to the dcim module types list params
func (o *DcimModuleTypesListParams) WithQ(q *string) *DcimModuleTypesListParams {
	o.SetQ(q)
	return o
}

// SetQ adds the q to the dcim module types list params
func (o *DcimModuleTypesListParams) SetQ(q *string) {
	o.Q = q
}

// WithTag adds the tag to the dcim module types list params
func (o *DcimModuleTypesListParams) WithTag(tag *string) *DcimModuleTypesListParams {
	o.SetTag(tag)
	return o
}

// SetTag adds the tag to the dcim module types list params
func (o *DcimModuleTypesListParams) SetTag(tag *string) {
	o.Tag = tag
}

// WithTagn adds the tagn to the dcim module types list params
func (o *DcimModuleTypesListParams) WithTagn(tagn *string) *DcimModuleTypesListParams {
	o.SetTagn(tagn)
	return o
}

// SetTagn adds the tagN to the dcim module types list params
func (o *DcimModuleTypesListParams) SetTagn(tagn *string) {
	o.Tagn = tagn
}

// WriteToRequest writes these params to a swagger request
func (o *DcimModuleTypesListParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.ConsolePorts != nil {

		// query param console_ports
		var qrConsolePorts string

		if o.ConsolePorts != nil {
			qrConsolePorts = *o.ConsolePorts
		}
		qConsolePorts := qrConsolePorts
		if qConsolePorts != "" {

			if err := r.SetQueryParam("console_ports", qConsolePorts); err != nil {
				return err
			}
		}
	}

	if o.ConsoleServerPorts != nil {

		// query param console_server_ports
		var qrConsoleServerPorts string

		if o.ConsoleServerPorts != nil {
			qrConsoleServerPorts = *o.ConsoleServerPorts
		}
		qConsoleServerPorts := qrConsoleServerPorts
		if qConsoleServerPorts != "" {

			if err := r.SetQueryParam("console_server_ports", qConsoleServerPorts); err != nil {
				return err
			}
		}
	}

	if o.Created != nil {

		// query param created
		var qrCreated string

		if o.Created != nil {
			qrCreated = *o.Created
		}
		qCreated := qrCreated
		if qCreated != "" {

			if err := r.SetQueryParam("created", qCreated); err != nil {
				return err
			}
		}
	}

	if o.CreatedGte != nil {

		// query param created__gte
		var qrCreatedGte string

		if o.CreatedGte != nil {
			qrCreatedGte = *o.CreatedGte
		}
		qCreatedGte := qrCreatedGte
		if qCreatedGte != "" {

			if err := r.SetQueryParam("created__gte", qCreatedGte); err != nil {
				return err
			}
		}
	}

	if o.CreatedLte != nil {

		// query param created__lte
		var qrCreatedLte string

		if o.CreatedLte != nil {
			qrCreatedLte = *o.CreatedLte
		}
		qCreatedLte := qrCreatedLte
		if qCreatedLte != "" {

			if err := r.SetQueryParam("created__lte", qCreatedLte); err != nil {
				return err
			}
		}
	}

	if o.ID != nil {

		// query param id
		var qrID string

		if o.ID != nil {
			qrID = *o.ID
		}
		qID := qrID
		if qID != "" {

			if err := r.SetQueryParam("id", qID); err != nil {
				return err
			}
		}
	}

	if o.IDGt != nil {

		// query param id__gt
		var qrIDGt string

		if o.IDGt != nil {
			qrIDGt = *o.IDGt
		}
		qIDGt := qrIDGt
		if qIDGt != "" {

			if err := r.SetQueryParam("id__gt", qIDGt); err != nil {
				return err
			}
		}
	}

	if o.IDGte != nil {

		// query param id__gte
		var qrIDGte string

		if o.IDGte != nil {
			qrIDGte = *o.IDGte
		}
		qIDGte := qrIDGte
		if qIDGte != "" {

			if err := r.SetQueryParam("id__gte", qIDGte); err != nil {
				return err
			}
		}
	}

	if o.IDLt != nil {

		// query param id__lt
		var qrIDLt string

		if o.IDLt != nil {
			qrIDLt = *o.IDLt
		}
		qIDLt := qrIDLt
		if qIDLt != "" {

			if err := r.SetQueryParam("id__lt", qIDLt); err != nil {
				return err
			}
		}
	}

	if o.IDLte != nil {

		// query param id__lte
		var qrIDLte string

		if o.IDLte != nil {
			qrIDLte = *o.IDLte
		}
		qIDLte := qrIDLte
		if qIDLte != "" {

			if err := r.SetQueryParam("id__lte", qIDLte); err != nil {
				return err
			}
		}
	}

	if o.IDn != nil {

		// query param id__n
		var qrIDn string

		if o.IDn != nil {
			qrIDn = *o.IDn
		}
		qIDn := qrIDn
		if qIDn != "" {

			if err := r.SetQueryParam("id__n", qIDn); err != nil {
				return err
			}
		}
	}

	if o.Interfaces != nil {

		// query param interfaces
		var qrInterfaces string

		if o.Interfaces != nil {
			qrInterfaces = *o.Interfaces
		}
		qInterfaces := qrInterfaces
		if qInterfaces != "" {

			if err := r.SetQueryParam("interfaces", qInterfaces); err != nil {
				return err
			}
		}
	}

	if o.LastUpdated != nil {

		// query param last_updated
		var qrLastUpdated string

		if o.LastUpdated != nil {
			qrLastUpdated = *o.LastUpdated
		}
		qLastUpdated := qrLastUpdated
		if qLastUpdated != "" {

			if err := r.SetQueryParam("last_updated", qLastUpdated); err != nil {
				return err
			}
		}
	}

	if o.LastUpdatedGte != nil {

		// query param last_updated__gte
		var qrLastUpdatedGte string

		if o.LastUpdatedGte != nil {
			qrLastUpdatedGte = *o.LastUpdatedGte
		}
		qLastUpdatedGte := qrLastUpdatedGte
		if qLastUpdatedGte != "" {

			if err := r.SetQueryParam("last_updated__gte", qLastUpdatedGte); err != nil {
				return err
			}
		}
	}

	if o.LastUpdatedLte != nil {

		// query param last_updated__lte
		var qrLastUpdatedLte string

		if o.LastUpdatedLte != nil {
			qrLastUpdatedLte = *o.LastUpdatedLte
		}
		qLastUpdatedLte := qrLastUpdatedLte
		if qLastUpdatedLte != "" {

			if err := r.SetQueryParam("last_updated__lte", qLastUpdatedLte); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Manufacturer != nil {

		// query param manufacturer
		var qrManufacturer string

		if o.Manufacturer != nil {
			qrManufacturer = *o.Manufacturer
		}
		qManufacturer := qrManufacturer
		if qManufacturer != "" {

			if err := r.SetQueryParam("manufacturer", qManufacturer); err != nil {
				return err
			}
		}
	}

	if o.Manufacturern != nil {

		// query param manufacturer__n
		var qrManufacturern string

		if o.Manufacturern != nil {
			qrManufacturern = *o.Manufacturern
		}
		qManufacturern := qrManufacturern
		if qManufacturern != "" {

			if err := r.SetQueryParam("manufacturer__n", qManufacturern); err != nil {
				return err
			}
		}
	}

	if o.ManufacturerID != nil {

		// query param manufacturer_id
		var qrManufacturerID string

		if o.ManufacturerID != nil {
			qrManufacturerID = *o.ManufacturerID
		}
		qManufacturerID := qrManufacturerID
		if qManufacturerID != "" {

			if err := r.SetQueryParam("manufacturer_id", qManufacturerID); err != nil {
				return err
			}
		}
	}

	if o.ManufacturerIDn != nil {

		// query param manufacturer_id__n
		var qrManufacturerIDn string

		if o.ManufacturerIDn != nil {
			qrManufacturerIDn = *o.ManufacturerIDn
		}
		qManufacturerIDn := qrManufacturerIDn
		if qManufacturerIDn != "" {

			if err := r.SetQueryParam("manufacturer_id__n", qManufacturerIDn); err != nil {
				return err
			}
		}
	}

	if o.Model != nil {

		// query param model
		var qrModel string

		if o.Model != nil {
			qrModel = *o.Model
		}
		qModel := qrModel
		if qModel != "" {

			if err := r.SetQueryParam("model", qModel); err != nil {
				return err
			}
		}
	}

	if o.ModelIc != nil {

		// query param model__ic
		var qrModelIc string

		if o.ModelIc != nil {
			qrModelIc = *o.ModelIc
		}
		qModelIc := qrModelIc
		if qModelIc != "" {

			if err := r.SetQueryParam("model__ic", qModelIc); err != nil {
				return err
			}
		}
	}

	if o.ModelIe != nil {

		// query param model__ie
		var qrModelIe string

		if o.ModelIe != nil {
			qrModelIe = *o.ModelIe
		}
		qModelIe := qrModelIe
		if qModelIe != "" {

			if err := r.SetQueryParam("model__ie", qModelIe); err != nil {
				return err
			}
		}
	}

	if o.ModelIew != nil {

		// query param model__iew
		var qrModelIew string

		if o.ModelIew != nil {
			qrModelIew = *o.ModelIew
		}
		qModelIew := qrModelIew
		if qModelIew != "" {

			if err := r.SetQueryParam("model__iew", qModelIew); err != nil {
				return err
			}
		}
	}

	if o.ModelIsw != nil {

		// query param model__isw
		var qrModelIsw string

		if o.ModelIsw != nil {
			qrModelIsw = *o.ModelIsw
		}
		qModelIsw := qrModelIsw
		if qModelIsw != "" {

			if err := r.SetQueryParam("model__isw", qModelIsw); err != nil {
				return err
			}
		}
	}

	if o.Modeln != nil {

		// query param model__n
		var qrModeln string

		if o.Modeln != nil {
			qrModeln = *o.Modeln
		}
		qModeln := qrModeln
		if qModeln != "" {

			if err := r.SetQueryParam("model__n", qModeln); err != nil {
				return err
			}
		}
	}

	if o.ModelNic != nil {

		// query param model__nic
		var qrModelNic string

		if o.ModelNic != nil {
			qrModelNic = *o.ModelNic
		}
		qModelNic := qrModelNic
		if qModelNic != "" {

			if err := r.SetQueryParam("model__nic", qModelNic); err != nil {
				return err
			}
		}
	}

	if o.ModelNie != nil {

		// query param model__nie
		var qrModelNie string

		if o.ModelNie != nil {
			qrModelNie = *o.ModelNie
		}
		qModelNie := qrModelNie
		if qModelNie != "" {

			if err := r.SetQueryParam("model__nie", qModelNie); err != nil {
				return err
			}
		}
	}

	if o.ModelNiew != nil {

		// query param model__niew
		var qrModelNiew string

		if o.ModelNiew != nil {
			qrModelNiew = *o.ModelNiew
		}
		qModelNiew := qrModelNiew
		if qModelNiew != "" {

			if err := r.SetQueryParam("model__niew", qModelNiew); err != nil {
				return err
			}
		}
	}

	if o.ModelNisw != nil {

		// query param model__nisw
		var qrModelNisw string

		if o.ModelNisw != nil {
			qrModelNisw = *o.ModelNisw
		}
		qModelNisw := qrModelNisw
		if qModelNisw != "" {

			if err := r.SetQueryParam("model__nisw", qModelNisw); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if o.PartNumber != nil {

		// query param part_number
		var qrPartNumber string

		if o.PartNumber != nil {
			qrPartNumber = *o.PartNumber
		}
		qPartNumber := qrPartNumber
		if qPartNumber != "" {

			if err := r.SetQueryParam("part_number", qPartNumber); err != nil {
				return err
			}
		}
	}

	if o.PartNumberIc != nil {

		// query param part_number__ic
		var qrPartNumberIc string

		if o.PartNumberIc != nil {
			qrPartNumberIc = *o.PartNumberIc
		}
		qPartNumberIc := qrPartNumberIc
		if qPartNumberIc != "" {

			if err := r.SetQueryParam("part_number__ic", qPartNumberIc); err != nil {
				return err
			}
		}
	}

	if o.PartNumberIe != nil {

		// query param part_number__ie
		var qrPartNumberIe string

		if o.PartNumberIe != nil {
			qrPartNumberIe = *o.PartNumberIe
		}
		qPartNumberIe := qrPartNumberIe
		if qPartNumberIe != "" {

			if err := r.SetQueryParam("part_number__ie", qPartNumberIe); err != nil {
				return err
			}
		}
	}

	if o.PartNumberIew != nil {

		// query param part_number__iew
		var qrPartNumberIew string

		if o.PartNumberIew != nil {
			qrPartNumberIew = *o.PartNumberIew
		}
		qPartNumberIew := qrPartNumberIew
		if qPartNumberIew != "" {

			if err := r.SetQueryParam("part_number__iew", qPartNumberIew); err != nil {
				return err
			}
		}
	}

	if o.PartNumberIsw != nil {

		// query param part_number__isw
		var qrPartNumberIsw string

		if o.PartNumberIsw != nil {
			qrPartNumberIsw = *o.PartNumberIsw
		}
		qPartNumberIsw := qrPartNumberIsw
		if qPartNumberIsw != "" {

			if err := r.SetQueryParam("part_number__isw", qPartNumberIsw); err != nil {
				return err
			}
		}
	}

	if o.PartNumbern != nil {

		// query param part_number__n
		var qrPartNumbern string

		if o.PartNumbern != nil {
			qrPartNumbern = *o.PartNumbern
		}
		qPartNumbern := qrPartNumbern
		if qPartNumbern != "" {

			if err := r.SetQueryParam("part_number__n", qPartNumbern); err != nil {
				return err
			}
		}
	}

	if o.PartNumberNic != nil {

		// query param part_number__nic
		var qrPartNumberNic string

		if o.PartNumberNic != nil {
			qrPartNumberNic = *o.PartNumberNic
		}
		qPartNumberNic := qrPartNumberNic
		if qPartNumberNic != "" {

			if err := r.SetQueryParam("part_number__nic", qPartNumberNic); err != nil {
				return err
			}
		}
	}

	if o.PartNumberNie != nil {

		// query param part_number__nie
		var qrPartNumberNie string

		if o.PartNumberNie != nil {
			qrPartNumberNie = *o.PartNumberNie
		}
		qPartNumberNie := qrPartNumberNie
		if qPartNumberNie != "" {

			if err := r.SetQueryParam("part_number__nie", qPartNumberNie); err != nil {
				return err
			}
		}
	}

	if o.PartNumberNiew != nil {

		// query param part_number__niew
		var qrPartNumberNiew string

		if o.PartNumberNiew != nil {
			qrPartNumberNiew = *o.PartNumberNiew
		}
		qPartNumberNiew := qrPartNumberNiew
		if qPartNumberNiew != "" {

			if err := r.SetQueryParam("part_number__niew", qPartNumberNiew); err != nil {
				return err
			}
		}
	}

	if o.PartNumberNisw != nil {

		// query param part_number__nisw
		var qrPartNumberNisw string

		if o.PartNumberNisw != nil {
			qrPartNumberNisw = *o.PartNumberNisw
		}
		qPartNumberNisw := qrPartNumberNisw
		if qPartNumberNisw != "" {

			if err := r.SetQueryParam("part_number__nisw", qPartNumberNisw); err != nil {
				return err
			}
		}
	}

	if o.PassThroughPorts != nil {

		// query param pass_through_ports
		var qrPassThroughPorts string

		if o.PassThroughPorts != nil {
			qrPassThroughPorts = *o.PassThroughPorts
		}
		qPassThroughPorts := qrPassThroughPorts
		if qPassThroughPorts != "" {

			if err := r.SetQueryParam("pass_through_ports", qPassThroughPorts); err != nil {
				return err
			}
		}
	}

	if o.PowerOutlets != nil {

		// query param power_outlets
		var qrPowerOutlets string

		if o.PowerOutlets != nil {
			qrPowerOutlets = *o.PowerOutlets
		}
		qPowerOutlets := qrPowerOutlets
		if qPowerOutlets != "" {

			if err := r.SetQueryParam("power_outlets", qPowerOutlets); err != nil {
				return err
			}
		}
	}

	if o.PowerPorts != nil {

		// query param power_ports
		var qrPowerPorts string

		if o.PowerPorts != nil {
			qrPowerPorts = *o.PowerPorts
		}
		qPowerPorts := qrPowerPorts
		if qPowerPorts != "" {

			if err := r.SetQueryParam("power_ports", qPowerPorts); err != nil {
				return err
			}
		}
	}

	if o.Q != nil {

		// query param q
		var qrQ string

		if o.Q != nil {
			qrQ = *o.Q
		}
		qQ := qrQ
		if qQ != "" {

			if err := r.SetQueryParam("q", qQ); err != nil {
				return err
			}
		}
	}

	if o.Tag != nil {

		// query param tag
		var qrTag string

		if o.Tag != nil {
			qrTag = *o.Tag
		}
		qTag := qrTag
		if qTag != "" {

			if err := r.SetQueryParam("tag", qTag); err != nil {
				return err
			}
		}
	}

	if o.Tagn != nil {

		// query param tag__n
		var qrTagn string

		if o.Tagn != nil {
			qrTagn = *o.Tagn
		}
		qTagn := qrTagn
		if qTagn != "" {

			if err := r.SetQueryParam("tag__n", qTagn); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
