// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2020 The go-netbox Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package dcim

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewDcimModulesListParams creates a new DcimModulesListParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDcimModulesListParams() *DcimModulesListParams {
	return &DcimModulesListParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDcimModulesListParamsWithTimeout creates a new DcimModulesListParams object
// with the ability to set a timeout on a request.
func NewDcimModulesListParamsWithTimeout(timeout time.Duration) *DcimModulesListParams {
	return &DcimModulesListParams{
		timeout: timeout,
	}
}

// NewDcimModulesListParamsWithContext creates a new DcimModulesListParams object
// with the ability to set a context for a request.
func NewDcimModulesListParamsWithContext(ctx context.Context) *DcimModulesListParams {
	return &DcimModulesListParams{
		Context: ctx,
	}
}

// NewDcimModulesListParamsWithHTTPClient creates a new DcimModulesListParams object
// with the ability to set a custom HTTPClient for a request.
func NewDcimModulesListParamsWithHTTPClient(client *http.Client) *DcimModulesListParams {
	return &DcimModulesListParams{
		HTTPClient: client,
	}
}

/* DcimModulesListParams contains all the parameters to send to the API endpoint
   for the dcim modules list operation.

   Typically these are written to a http.Request.
*/
type DcimModulesListParams struct {

	// AssetTag.
	AssetTag *string

	// AssetTagIc.
	AssetTagIc *string

	// AssetTagIe.
	AssetTagIe *string

	// AssetTagIew.
	AssetTagIew *string

	// AssetTagIsw.
	AssetTagIsw *string

	// AssetTagn.
	AssetTagn *string

	// AssetTagNic.
	AssetTagNic *string

	// AssetTagNie.
	AssetTagNie *string

	// AssetTagNiew.
	AssetTagNiew *string

	// AssetTagNisw.
	AssetTagNisw *string

	// Created.
	Created *string

	// CreatedGte.
	CreatedGte *string

	// CreatedLte.
	CreatedLte *string

	// DeviceID.
	DeviceID *string

	// DeviceIDn.
	DeviceIDn *string

	// ID.
	ID *string

	// IDGt.
	IDGt *string

	// IDGte.
	IDGte *string

	// IDLt.
	IDLt *string

	// IDLte.
	IDLte *string

	// IDn.
	IDn *string

	// LastUpdated.
	LastUpdated *string

	// LastUpdatedGte.
	LastUpdatedGte *string

	// LastUpdatedLte.
	LastUpdatedLte *string

	/* Limit.

	   Number of results to return per page.
	*/
	Limit *int64

	// Manufacturer.
	Manufacturer *string

	// Manufacturern.
	Manufacturern *string

	// ManufacturerID.
	ManufacturerID *string

	// ManufacturerIDn.
	ManufacturerIDn *string

	// ModuleType.
	ModuleType *string

	// ModuleTypen.
	ModuleTypen *string

	// ModuleTypeID.
	ModuleTypeID *string

	// ModuleTypeIDn.
	ModuleTypeIDn *string

	/* Offset.

	   The initial index from which to return the results.
	*/
	Offset *int64

	// Q.
	Q *string

	// Serial.
	Serial *string

	// SerialIc.
	SerialIc *string

	// SerialIe.
	SerialIe *string

	// SerialIew.
	SerialIew *string

	// SerialIsw.
	SerialIsw *string

	// Serialn.
	Serialn *string

	// SerialNic.
	SerialNic *string

	// SerialNie.
	SerialNie *string

	// SerialNiew.
	SerialNiew *string

	// SerialNisw.
	SerialNisw *string

	// Tag.
	Tag *string

	// Tagn.
	Tagn *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the dcim modules list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DcimModulesListParams) WithDefaults() *DcimModulesListParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the dcim modules list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DcimModulesListParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the dcim modules list params
func (o *DcimModulesListParams) WithTimeout(timeout time.Duration) *DcimModulesListParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the dcim modules list params
func (o *DcimModulesListParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the dcim modules list params
func (o *DcimModulesListParams) WithContext(ctx context.Context) *DcimModulesListParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the dcim modules list params
func (o *DcimModulesListParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the dcim modules list params
func (o *DcimModulesListParams) WithHTTPClient(client *http.Client) *DcimModulesListParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the dcim modules list params
func (o *DcimModulesListParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAssetTag adds the assetTag to the dcim modules list params
func (o *DcimModulesListParams) WithAssetTag(assetTag *string) *DcimModulesListParams {
	o.SetAssetTag(assetTag)
	return o
}

// SetAssetTag adds the assetTag to the dcim modules list params
func (o *DcimModulesListParams) SetAssetTag(assetTag *string) {
	o.AssetTag = assetTag
}

// WithAssetTagIc adds the assetTagIc to the dcim modules list params
func (o *DcimModulesListParams) WithAssetTagIc(assetTagIc *string) *DcimModulesListParams {
	o.SetAssetTagIc(assetTagIc)
	return o
}

// SetAssetTagIc adds the assetTagIc to the dcim modules list params
func (o *DcimModulesListParams) SetAssetTagIc(assetTagIc *string) {
	o.AssetTagIc = assetTagIc
}

// WithAssetTagIe adds the assetTagIe to the dcim modules list params
func (o *DcimModulesListParams) WithAssetTagIe(assetTagIe *string) *DcimModulesListParams {
	o.SetAssetTagIe(assetTagIe)
	return o
}

// SetAssetTagIe adds the assetTagIe to the dcim modules list params
func (o *DcimModulesListParams) SetAssetTagIe(assetTagIe *string) {
	o.AssetTagIe = assetTagIe
}

// WithAssetTagIew adds the assetTagIew to the dcim modules list params
func (o *DcimModulesListParams) WithAssetTagIew(assetTagIew *string) *DcimModulesListParams {
	o.SetAssetTagIew(assetTagIew)
	return o
}

// SetAssetTagIew adds the assetTagIew to the dcim modules list params
func (o *DcimModulesListParams) SetAssetTagIew(assetTagIew *string) {
	o.AssetTagIew = assetTagIew
}

// WithAssetTagIsw adds the assetTagIsw to the dcim modules list params
func (o *DcimModulesListParams) WithAssetTagIsw(assetTagIsw *string) *DcimModulesListParams {
	o.SetAssetTagIsw(assetTagIsw)
	return o
}

// SetAssetTagIsw adds the assetTagIsw to the dcim modules list params
func (o *DcimModulesListParams) SetAssetTagIsw(assetTagIsw *string) {
	o.AssetTagIsw = assetTagIsw
}

// WithAssetTagn adds the assetTagn to the dcim modules list params
func (o *DcimModulesListParams) WithAssetTagn(assetTagn *string) *DcimModulesListParams {
	o.SetAssetTagn(assetTagn)
	return o
}

// SetAssetTagn adds the assetTagN to the dcim modules list params
func (o *DcimModulesListParams) SetAssetTagn(assetTagn *string) {
	o.AssetTagn = assetTagn
}

// WithAssetTagNic adds the assetTagNic to the dcim modules list params
func (o *DcimModulesListParams) WithAssetTagNic(assetTagNic *string) *DcimModulesListParams {
	o.SetAssetTagNic(assetTagNic)
	return o
}

// SetAssetTagNic adds the assetTagNic to the dcim modules list params
func (o *DcimModulesListParams) SetAssetTagNic(assetTagNic *string) {
	o.AssetTagNic = assetTagNic
}

// WithAssetTagNie adds the assetTagNie to the dcim modules list params
func (o *DcimModulesListParams) WithAssetTagNie(assetTagNie *string) *DcimModulesListParams {
	o.SetAssetTagNie(assetTagNie)
	return o
}

// SetAssetTagNie adds the assetTagNie to the dcim modules list params
func (o *DcimModulesListParams) SetAssetTagNie(assetTagNie *string) {
	o.AssetTagNie = assetTagNie
}

// WithAssetTagNiew adds the assetTagNiew to the dcim modules list params
func (o *DcimModulesListParams) WithAssetTagNiew(assetTagNiew *string) *DcimModulesListParams {
	o.SetAssetTagNiew(assetTagNiew)
	return o
}

// SetAssetTagNiew adds the assetTagNiew to the dcim modules list params
func (o *DcimModulesListParams) SetAssetTagNiew(assetTagNiew *string) {
	o.AssetTagNiew = assetTagNiew
}

// WithAssetTagNisw adds the assetTagNisw to the dcim modules list params
func (o *DcimModulesListParams) WithAssetTagNisw(assetTagNisw *string) *DcimModulesListParams {
	o.SetAssetTagNisw(assetTagNisw)
	return o
}

// SetAssetTagNisw adds the assetTagNisw to the dcim modules list params
func (o *DcimModulesListParams) SetAssetTagNisw(assetTagNisw *string) {
	o.AssetTagNisw = assetTagNisw
}

// WithCreated adds the created to the dcim modules list params
func (o *DcimModulesListParams) WithCreated(created *string) *DcimModulesListParams {
	o.SetCreated(created)
	return o
}

// SetCreated adds the created to the dcim modules list params
func (o *DcimModulesListParams) SetCreated(created *string) {
	o.Created = created
}

// WithCreatedGte adds the createdGte to the dcim modules list params
func (o *DcimModulesListParams) WithCreatedGte(createdGte *string) *DcimModulesListParams {
	o.SetCreatedGte(createdGte)
	return o
}

// SetCreatedGte adds the createdGte to the dcim modules list params
func (o *DcimModulesListParams) SetCreatedGte(createdGte *string) {
	o.CreatedGte = createdGte
}

// WithCreatedLte adds the createdLte to the dcim modules list params
func (o *DcimModulesListParams) WithCreatedLte(createdLte *string) *DcimModulesListParams {
	o.SetCreatedLte(createdLte)
	return o
}

// SetCreatedLte adds the createdLte to the dcim modules list params
func (o *DcimModulesListParams) SetCreatedLte(createdLte *string) {
	o.CreatedLte = createdLte
}

// WithDeviceID adds the deviceID to the dcim modules list params
func (o *DcimModulesListParams) WithDeviceID(deviceID *string) *DcimModulesListParams {
	o.SetDeviceID(deviceID)
	return o
}

// SetDeviceID adds the deviceId to the dcim modules list params
func (o *DcimModulesListParams) SetDeviceID(deviceID *string) {
	o.DeviceID = deviceID
}

// WithDeviceIDn adds the deviceIDn to the dcim modules list params
func (o *DcimModulesListParams) WithDeviceIDn(deviceIDn *string) *DcimModulesListParams {
	o.SetDeviceIDn(deviceIDn)
	return o
}

// SetDeviceIDn adds the deviceIdN to the dcim modules list params
func (o *DcimModulesListParams) SetDeviceIDn(deviceIDn *string) {
	o.DeviceIDn = deviceIDn
}

// WithID adds the id to the dcim modules list params
func (o *DcimModulesListParams) WithID(id *string) *DcimModulesListParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the dcim modules list params
func (o *DcimModulesListParams) SetID(id *string) {
	o.ID = id
}

// WithIDGt adds the iDGt to the dcim modules list params
func (o *DcimModulesListParams) WithIDGt(iDGt *string) *DcimModulesListParams {
	o.SetIDGt(iDGt)
	return o
}

// SetIDGt adds the idGt to the dcim modules list params
func (o *DcimModulesListParams) SetIDGt(iDGt *string) {
	o.IDGt = iDGt
}

// WithIDGte adds the iDGte to the dcim modules list params
func (o *DcimModulesListParams) WithIDGte(iDGte *string) *DcimModulesListParams {
	o.SetIDGte(iDGte)
	return o
}

// SetIDGte adds the idGte to the dcim modules list params
func (o *DcimModulesListParams) SetIDGte(iDGte *string) {
	o.IDGte = iDGte
}

// WithIDLt adds the iDLt to the dcim modules list params
func (o *DcimModulesListParams) WithIDLt(iDLt *string) *DcimModulesListParams {
	o.SetIDLt(iDLt)
	return o
}

// SetIDLt adds the idLt to the dcim modules list params
func (o *DcimModulesListParams) SetIDLt(iDLt *string) {
	o.IDLt = iDLt
}

// WithIDLte adds the iDLte to the dcim modules list params
func (o *DcimModulesListParams) WithIDLte(iDLte *string) *DcimModulesListParams {
	o.SetIDLte(iDLte)
	return o
}

// SetIDLte adds the idLte to the dcim modules list params
func (o *DcimModulesListParams) SetIDLte(iDLte *string) {
	o.IDLte = iDLte
}

// WithIDn adds the iDn to the dcim modules list params
func (o *DcimModulesListParams) WithIDn(iDn *string) *DcimModulesListParams {
	o.SetIDn(iDn)
	return o
}

// SetIDn adds the idN to the dcim modules list params
func (o *DcimModulesListParams) SetIDn(iDn *string) {
	o.IDn = iDn
}

// WithLastUpdated adds the lastUpdated to the dcim modules list params
func (o *DcimModulesListParams) WithLastUpdated(lastUpdated *string) *DcimModulesListParams {
	o.SetLastUpdated(lastUpdated)
	return o
}

// SetLastUpdated adds the lastUpdated to the dcim modules list params
func (o *DcimModulesListParams) SetLastUpdated(lastUpdated *string) {
	o.LastUpdated = lastUpdated
}

// WithLastUpdatedGte adds the lastUpdatedGte to the dcim modules list params
func (o *DcimModulesListParams) WithLastUpdatedGte(lastUpdatedGte *string) *DcimModulesListParams {
	o.SetLastUpdatedGte(lastUpdatedGte)
	return o
}

// SetLastUpdatedGte adds the lastUpdatedGte to the dcim modules list params
func (o *DcimModulesListParams) SetLastUpdatedGte(lastUpdatedGte *string) {
	o.LastUpdatedGte = lastUpdatedGte
}

// WithLastUpdatedLte adds the lastUpdatedLte to the dcim modules list params
func (o *DcimModulesListParams) WithLastUpdatedLte(lastUpdatedLte *string) *DcimModulesListParams {
	o.SetLastUpdatedLte(lastUpdatedLte)
	return o
}

// SetLastUpdatedLte adds the lastUpdatedLte to the dcim modules list params
func (o *DcimModulesListParams) SetLastUpdatedLte(lastUpdatedLte *string) {
	o.LastUpdatedLte = lastUpdatedLte
}

// WithLimit adds the limit to the dcim modules list params
func (o *DcimModulesListParams) WithLimit(limit *int64) *DcimModulesListParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the dcim modules list params
func (o *DcimModulesListParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithManufacturer adds the manufacturer to the dcim modules list params
func (o *DcimModulesListParams) WithManufacturer(manufacturer *string) *DcimModulesListParams {
	o.SetManufacturer(manufacturer)
	return o
}

// SetManufacturer adds the manufacturer to the dcim modules list params
func (o *DcimModulesListParams) SetManufacturer(manufacturer *string) {
	o.Manufacturer = manufacturer
}

// WithManufacturern adds the manufacturern to the dcim modules list params
func (o *DcimModulesListParams) WithManufacturern(manufacturern *string) *DcimModulesListParams {
	o.SetManufacturern(manufacturern)
	return o
}

// SetManufacturern adds the manufacturerN to the dcim modules list params
func (o *DcimModulesListParams) SetManufacturern(manufacturern *string) {
	o.Manufacturern = manufacturern
}

// WithManufacturerID adds the manufacturerID to the dcim modules list params
func (o *DcimModulesListParams) WithManufacturerID(manufacturerID *string) *DcimModulesListParams {
	o.SetManufacturerID(manufacturerID)
	return o
}

// SetManufacturerID adds the manufacturerId to the dcim modules list params
func (o *DcimModulesListParams) SetManufacturerID(manufacturerID *string) {
	o.ManufacturerID = manufacturerID
}

// WithManufacturerIDn adds the manufacturerIDn to the dcim modules list params
func (o *DcimModulesListParams) WithManufacturerIDn(manufacturerIDn *string) *DcimModulesListParams {
	o.SetManufacturerIDn(manufacturerIDn)
	return o
}

// SetManufacturerIDn adds the manufacturerIdN to the dcim modules list params
func (o *DcimModulesListParams) SetManufacturerIDn(manufacturerIDn *string) {
	o.ManufacturerIDn = manufacturerIDn
}

// WithModuleType adds the moduleType to the dcim modules list params
func (o *DcimModulesListParams) WithModuleType(moduleType *string) *DcimModulesListParams {
	o.SetModuleType(moduleType)
	return o
}

// SetModuleType adds the moduleType to the dcim modules list params
func (o *DcimModulesListParams) SetModuleType(moduleType *string) {
	o.ModuleType = moduleType
}

// WithModuleTypen adds the moduleTypen to the dcim modules list params
func (o *DcimModulesListParams) WithModuleTypen(moduleTypen *string) *DcimModulesListParams {
	o.SetModuleTypen(moduleTypen)
	return o
}

// SetModuleTypen adds the moduleTypeN to the dcim modules list params
func (o *DcimModulesListParams) SetModuleTypen(moduleTypen *string) {
	o.ModuleTypen = moduleTypen
}

// WithModuleTypeID adds the moduleTypeID to the dcim modules list params
func (o *DcimModulesListParams) WithModuleTypeID(moduleTypeID *string) *DcimModulesListParams {
	o.SetModuleTypeID(moduleTypeID)
	return o
}

// SetModuleTypeID adds the moduleTypeId to the dcim modules list params
func (o *DcimModulesListParams) SetModuleTypeID(moduleTypeID *string) {
	o.ModuleTypeID = moduleTypeID
}

// WithModuleTypeIDn adds the moduleTypeIDn to the dcim modules list params
func (o *DcimModulesListParams) WithModuleTypeIDn(moduleTypeIDn *string) *DcimModulesListParams {
	o.SetModuleTypeIDn(moduleTypeIDn)
	return o
}

// SetModuleTypeIDn adds the moduleTypeIdN to the dcim modules list params
func (o *DcimModulesListParams) SetModuleTypeIDn(moduleTypeIDn *string) {
	o.ModuleTypeIDn = moduleTypeIDn
}

// WithOffset adds the offset to the dcim modules list params
func (o *DcimModulesListParams) WithOffset(offset *int64) *DcimModulesListParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the dcim modules list params
func (o *DcimModulesListParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithQ adds the q to the dcim modules list params
func (o *DcimModulesListParams) WithQ(q *string) *DcimModulesListParams {
	o.SetQ(q)
	return o
}

// SetQ adds the q to the dcim modules list params
func (o *DcimModulesListParams) SetQ(q *string) {
	o.Q = q
}

// WithSerial adds the serial to the dcim modules list params
func (o *DcimModulesListParams) WithSerial(serial *string) *DcimModulesListParams {
	o.SetSerial(serial)
	return o
}

// SetSerial adds the serial to the dcim modules list params
func (o *DcimModulesListParams) SetSerial(serial *string) {
	o.Serial = serial
}

// WithSerialIc adds the serialIc to the dcim modules list params
func (o *DcimModulesListParams) WithSerialIc(serialIc *string) *DcimModulesListParams {
	o.SetSerialIc(serialIc)
	return o
}

// SetSerialIc adds the serialIc to the dcim modules list params
func (o *DcimModulesListParams) SetSerialIc(serialIc *string) {
	o.SerialIc = serialIc
}

// WithSerialIe adds the serialIe to the dcim modules list params
func (o *DcimModulesListParams) WithSerialIe(serialIe *string) *DcimModulesListParams {
	o.SetSerialIe(serialIe)
	return o
}

// SetSerialIe adds the serialIe to the dcim modules list params
func (o *DcimModulesListParams) SetSerialIe(serialIe *string) {
	o.SerialIe = serialIe
}

// WithSerialIew adds the serialIew to the dcim modules list params
func (o *DcimModulesListParams) WithSerialIew(serialIew *string) *DcimModulesListParams {
	o.SetSerialIew(serialIew)
	return o
}

// SetSerialIew adds the serialIew to the dcim modules list params
func (o *DcimModulesListParams) SetSerialIew(serialIew *string) {
	o.SerialIew = serialIew
}

// WithSerialIsw adds the serialIsw to the dcim modules list params
func (o *DcimModulesListParams) WithSerialIsw(serialIsw *string) *DcimModulesListParams {
	o.SetSerialIsw(serialIsw)
	return o
}

// SetSerialIsw adds the serialIsw to the dcim modules list params
func (o *DcimModulesListParams) SetSerialIsw(serialIsw *string) {
	o.SerialIsw = serialIsw
}

// WithSerialn adds the serialn to the dcim modules list params
func (o *DcimModulesListParams) WithSerialn(serialn *string) *DcimModulesListParams {
	o.SetSerialn(serialn)
	return o
}

// SetSerialn adds the serialN to the dcim modules list params
func (o *DcimModulesListParams) SetSerialn(serialn *string) {
	o.Serialn = serialn
}

// WithSerialNic adds the serialNic to the dcim modules list params
func (o *DcimModulesListParams) WithSerialNic(serialNic *string) *DcimModulesListParams {
	o.SetSerialNic(serialNic)
	return o
}

// SetSerialNic adds the serialNic to the dcim modules list params
func (o *DcimModulesListParams) SetSerialNic(serialNic *string) {
	o.SerialNic = serialNic
}

// WithSerialNie adds the serialNie to the dcim modules list params
func (o *DcimModulesListParams) WithSerialNie(serialNie *string) *DcimModulesListParams {
	o.SetSerialNie(serialNie)
	return o
}

// SetSerialNie adds the serialNie to the dcim modules list params
func (o *DcimModulesListParams) SetSerialNie(serialNie *string) {
	o.SerialNie = serialNie
}

// WithSerialNiew adds the serialNiew to the dcim modules list params
func (o *DcimModulesListParams) WithSerialNiew(serialNiew *string) *DcimModulesListParams {
	o.SetSerialNiew(serialNiew)
	return o
}

// SetSerialNiew adds the serialNiew to the dcim modules list params
func (o *DcimModulesListParams) SetSerialNiew(serialNiew *string) {
	o.SerialNiew = serialNiew
}

// WithSerialNisw adds the serialNisw to the dcim modules list params
func (o *DcimModulesListParams) WithSerialNisw(serialNisw *string) *DcimModulesListParams {
	o.SetSerialNisw(serialNisw)
	return o
}

// SetSerialNisw adds the serialNisw to the dcim modules list params
func (o *DcimModulesListParams) SetSerialNisw(serialNisw *string) {
	o.SerialNisw = serialNisw
}

// WithTag adds the tag to the dcim modules list params
func (o *DcimModulesListParams) WithTag(tag *string) *DcimModulesListParams {
	o.SetTag(tag)
	return o
}

// SetTag adds the tag to the dcim modules list params
func (o *DcimModulesListParams) SetTag(tag *string) {
	o.Tag = tag
}

// WithTagn adds the tagn to the dcim modules list params
func (o *DcimModulesListParams) WithTagn(tagn *string) *DcimModulesListParams {
	o.SetTagn(tagn)
	return o
}

// SetTagn adds the tagN to the dcim modules list params
func (o *DcimModulesListParams) SetTagn(tagn *string) {
	o.Tagn = tagn
}

// WriteToRequest writes these params to a swagger request
func (o *DcimModulesListParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AssetTag != nil {

		// query param asset_tag
		var qrAssetTag string

		if o.AssetTag != nil {
			qrAssetTag = *o.AssetTag
		}
		qAssetTag := qrAssetTag
		if qAssetTag != "" {

			if err := r.SetQueryParam("asset_tag", qAssetTag); err != nil {
				return err
			}
		}
	}

	if o.AssetTagIc != nil {

		// query param asset_tag__ic
		var qrAssetTagIc string

		if o.AssetTagIc != nil {
			qrAssetTagIc = *o.AssetTagIc
		}
		qAssetTagIc := qrAssetTagIc
		if qAssetTagIc != "" {

			if err := r.SetQueryParam("asset_tag__ic", qAssetTagIc); err != nil {
				return err
			}
		}
	}

	if o.AssetTagIe != nil {

		// query param asset_tag__ie
		var qrAssetTagIe string

		if o.AssetTagIe != nil {
			qrAssetTagIe = *o.AssetTagIe
		}
		qAssetTagIe := qrAssetTagIe
		if qAssetTagIe != "" {

			if err := r.SetQueryParam("asset_tag__ie", qAssetTagIe); err != nil {
				return err
			}
		}
	}

	if o.AssetTagIew != nil {

		// query param asset_tag__iew
		var qrAssetTagIew string

		if o.AssetTagIew != nil {
			qrAssetTagIew = *o.AssetTagIew
		}
		qAssetTagIew := qrAssetTagIew
		if qAssetTagIew != "" {

			if err := r.SetQueryParam("asset_tag__iew", qAssetTagIew); err != nil {
				return err
			}
		}
	}

	if o.AssetTagIsw != nil {

		// query param asset_tag__isw
		var qrAssetTagIsw string

		if o.AssetTagIsw != nil {
			qrAssetTagIsw = *o.AssetTagIsw
		}
		qAssetTagIsw := qrAssetTagIsw
		if qAssetTagIsw != "" {

			if err := r.SetQueryParam("asset_tag__isw", qAssetTagIsw); err != nil {
				return err
			}
		}
	}

	if o.AssetTagn != nil {

		// query param asset_tag__n
		var qrAssetTagn string

		if o.AssetTagn != nil {
			qrAssetTagn = *o.AssetTagn
		}
		qAssetTagn := qrAssetTagn
		if qAssetTagn != "" {

			if err := r.SetQueryParam("asset_tag__n", qAssetTagn); err != nil {
				return err
			}
		}
	}

	if o.AssetTagNic != nil {

		// query param asset_tag__nic
		var qrAssetTagNic string

		if o.AssetTagNic != nil {
			qrAssetTagNic = *o.AssetTagNic
		}
		qAssetTagNic := qrAssetTagNic
		if qAssetTagNic != "" {

			if err := r.SetQueryParam("asset_tag__nic", qAssetTagNic); err != nil {
				return err
			}
		}
	}

	if o.AssetTagNie != nil {

		// query param asset_tag__nie
		var qrAssetTagNie string

		if o.AssetTagNie != nil {
			qrAssetTagNie = *o.AssetTagNie
		}
		qAssetTagNie := qrAssetTagNie
		if qAssetTagNie != "" {

			if err := r.SetQueryParam("asset_tag__nie", qAssetTagNie); err != nil {
				return err
			}
		}
	}

	if o.AssetTagNiew != nil {

		// query param asset_tag__niew
		var qrAssetTagNiew string

		if o.AssetTagNiew != nil {
			qrAssetTagNiew = *o.AssetTagNiew
		}
		qAssetTagNiew := qrAssetTagNiew
		if qAssetTagNiew != "" {

			if err := r.SetQueryParam("asset_tag__niew", qAssetTagNiew); err != nil {
				return err
			}
		}
	}

	if o.AssetTagNisw != nil {

		// query param asset_tag__nisw
		var qrAssetTagNisw string

		if o.AssetTagNisw != nil {
			qrAssetTagNisw = *o.AssetTagNisw
		}
		qAssetTagNisw := qrAssetTagNisw
		if qAssetTagNisw != "" {

			if err := r.SetQueryParam("asset_tag__nisw", qAssetTagNisw); err != nil {
				return err
			}
		}
	}

	if o.Created != nil {

		// query param created
		var qrCreated string

		if o.Created != nil {
			qrCreated = *o.Created
		}
		qCreated := qrCreated
		if qCreated != "" {

			if err := r.SetQueryParam("created", qCreated); err != nil {
				return err
			}
		}
	}

	if o.CreatedGte != nil {

		// query param created__gte
		var qrCreatedGte string

		if o.CreatedGte != nil {
			qrCreatedGte = *o.CreatedGte
		}
		qCreatedGte := qrCreatedGte
		if qCreatedGte != "" {

			if err := r.SetQueryParam("created__gte", qCreatedGte); err != nil {
				return err
			}
		}
	}

	if o.CreatedLte != nil {

		// query param created__lte
		var qrCreatedLte string

		if o.CreatedLte != nil {
			qrCreatedLte = *o.CreatedLte
		}
		qCreatedLte := qrCreatedLte
		if qCreatedLte != "" {

			if err := r.SetQueryParam("created__lte", qCreatedLte); err != nil {
				return err
			}
		}
	}

	if o.DeviceID != nil {

		// query param device_id
		var qrDeviceID string

		if o.DeviceID != nil {
			qrDeviceID = *o.DeviceID
		}
		qDeviceID := qrDeviceID
		if qDeviceID != "" {

			if err := r.SetQueryParam("device_id", qDeviceID); err != nil {
				return err
			}
		}
	}

	if o.DeviceIDn != nil {

		// query param device_id__n
		var qrDeviceIDn string

		if o.DeviceIDn != nil {
			qrDeviceIDn = *o.DeviceIDn
		}
		qDeviceIDn := qrDeviceIDn
		if qDeviceIDn != "" {

			if err := r.SetQueryParam("device_id__n", qDeviceIDn); err != nil {
				return err
			}
		}
	}

	if o.ID != nil {

		// query param id
		var qrID string

		if o.ID != nil {
			qrID = *o.ID
		}
		qID := qrID
		if qID != "" {

			if err := r.SetQueryParam("id", qID); err != nil {
				return err
			}
		}
	}

	if o.IDGt != nil {

		// query param id__gt
		var qrIDGt string

		if o.IDGt != nil {
			qrIDGt = *o.IDGt
		}
		qIDGt := qrIDGt
		if qIDGt != "" {

			if err := r.SetQueryParam("id__gt", qIDGt); err != nil {
				return err
			}
		}
	}

	if o.IDGte != nil {

		// query param id__gte
		var qrIDGte string

		if o.IDGte != nil {
			qrIDGte = *o.IDGte
		}
		qIDGte := qrIDGte
		if qIDGte != "" {

			if err := r.SetQueryParam("id__gte", qIDGte); err != nil {
				return err
			}
		}
	}

	if o.IDLt != nil {

		// query param id__lt
		var qrIDLt string

		if o.IDLt != nil {
			qrIDLt = *o.IDLt
		}
		qIDLt := qrIDLt
		if qIDLt != "" {

			if err := r.SetQueryParam("id__lt", qIDLt); err != nil {
				return err
			}
		}
	}

	if o.IDLte != nil {

		// query param id__lte
		var qrIDLte string

		if o.IDLte != nil {
			qrIDLte = *o.IDLte
		}
		qIDLte := qrIDLte
		if qIDLte != "" {

			if err := r.SetQueryParam("id__lte", qIDLte); err != nil {
				return err
			}
		}
	}

	if o.IDn != nil {

		// query param id__n
		var qrIDn string

		if o.IDn != nil {
			qrIDn = *o.IDn
		}
		qIDn := qrIDn
		if qIDn != "" {

			if err := r.SetQueryParam("id__n", qIDn); err != nil {
				return err
			}
		}
	}

	if o.LastUpdated != nil {

		// query param last_updated
		var qrLastUpdated string

		if o.LastUpdated != nil {
			qrLastUpdated = *o.LastUpdated
		}
		qLastUpdated := qrLastUpdated
		if qLastUpdated != "" {

			if err := r.SetQueryParam("last_updated", qLastUpdated); err != nil {
				return err
			}
		}
	}

	if o.LastUpdatedGte != nil {

		// query param last_updated__gte
		var qrLastUpdatedGte string

		if o.LastUpdatedGte != nil {
			qrLastUpdatedGte = *o.LastUpdatedGte
		}
		qLastUpdatedGte := qrLastUpdatedGte
		if qLastUpdatedGte != "" {

			if err := r.SetQueryParam("last_updated__gte", qLastUpdatedGte); err != nil {
				return err
			}
		}
	}

	if o.LastUpdatedLte != nil {

		// query param last_updated__lte
		var qrLastUpdatedLte string

		if o.LastUpdatedLte != nil {
			qrLastUpdatedLte = *o.LastUpdatedLte
		}
		qLastUpdatedLte := qrLastUpdatedLte
		if qLastUpdatedLte != "" {

			if err := r.SetQueryParam("last_updated__lte", qLastUpdatedLte); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Manufacturer != nil {

		// query param manufacturer
		var qrManufacturer string

		if o.Manufacturer != nil {
			qrManufacturer = *o.Manufacturer
		}
		qManufacturer := qrManufacturer
		if qManufacturer != "" {

			if err := r.SetQueryParam("manufacturer", qManufacturer); err != nil {
				return err
			}
		}
	}

	if o.Manufacturern != nil {

		// query param manufacturer__n
		var qrManufacturern string

		if o.Manufacturern != nil {
			qrManufacturern = *o.Manufacturern
		}
		qManufacturern := qrManufacturern
		if qManufacturern != "" {

			if err := r.SetQueryParam("manufacturer__n", qManufacturern); err != nil {
				return err
			}
		}
	}

	if o.ManufacturerID != nil {

		// query param manufacturer_id
		var qrManufacturerID string

		if o.ManufacturerID != nil {
			qrManufacturerID = *o.ManufacturerID
		}
		qManufacturerID := qrManufacturerID
		if qManufacturerID != "" {

			if err := r.SetQueryParam("manufacturer_id", qManufacturerID); err != nil {
				return err
			}
		}
	}

	if o.ManufacturerIDn != nil {

		// query param manufacturer_id__n
		var qrManufacturerIDn string

		if o.ManufacturerIDn != nil {
			qrManufacturerIDn = *o.ManufacturerIDn
		}
		qManufacturerIDn := qrManufacturerIDn
		if qManufacturerIDn != "" {

			if err := r.SetQueryParam("manufacturer_id__n", qManufacturerIDn); err != nil {
				return err
			}
		}
	}

	if o.ModuleType != nil {

		// query param module_type
		var qrModuleType string

		if o.ModuleType != nil {
			qrModuleType = *o.ModuleType
		}
		qModuleType := qrModuleType
		if qModuleType != "" {

			if err := r.SetQueryParam("module_type", qModuleType); err != nil {
				return err
			}
		}
	}

	if o.ModuleTypen != nil {

		// query param module_type__n
		var qrModuleTypen string

		if o.ModuleTypen != nil {
			qrModuleTypen = *o.ModuleTypen
		}
		qModuleTypen := qrModuleTypen
		if qModuleTypen != "" {

			if err := r.SetQueryParam("module_type__n", qModuleTypen); err != nil {
				return err
			}
		}
	}

	if o.ModuleTypeID != nil {

		// query param module_type_id
		var qrModuleTypeID string

		if o.ModuleTypeID != nil {
			qrModuleTypeID = *o.ModuleTypeID
		}
		qModuleTypeID := qrModuleTypeID
		if qModuleTypeID != "" {

			if err := r.SetQueryParam("module_type_id", qModuleTypeID); err != nil {
				return err
			}
		}
	}

	if o.ModuleTypeIDn != nil {

		// query param module_type_id__n
		var qrModuleTypeIDn string

		if o.ModuleTypeIDn != nil {
			qrModuleTypeIDn = *o.ModuleTypeIDn
		}
		qModuleTypeIDn := qrModuleTypeIDn
		if qModuleTypeIDn != "" {

			if err := r.SetQueryParam("module_type_id__n", qModuleTypeIDn); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if o.Q != nil {

		// query param q
		var qrQ string

		if o.Q != nil {
			qrQ = *o.Q
		}
		qQ := qrQ
		if qQ != "" {

			if err := r.SetQueryParam("q", qQ); err != nil {
				return err
			}
		}
	}

	if o.Serial != nil {

		// query param serial
		var qrSerial string

		if o.Serial != nil {
			qrSerial = *o.Serial
		}
		qSerial := qrSerial
		if qSerial != "" {

			if err := r.SetQueryParam("serial", qSerial); err != nil {
				return err
			}
		}
	}

	if o.SerialIc != nil {

		// query param serial__ic
		var qrSerialIc string

		if o.SerialIc != nil {
			qrSerialIc = *o.SerialIc
		}
		qSerialIc := qrSerialIc
		if qSerialIc != "" {

			if err := r.SetQueryParam("serial__ic", qSerialIc); err != nil {
				return err
			}
		}
	}

	if o.SerialIe != nil {

		// query param serial__ie
		var qrSerialIe string

		if o.SerialIe != nil {
			qrSerialIe = *o.SerialIe
		}
		qSerialIe := qrSerialIe
		if qSerialIe != "" {

			if err := r.SetQueryParam("serial__ie", qSerialIe); err != nil {
				return err
			}
		}
	}

	if o.SerialIew != nil {

		// query param serial__iew
		var qrSerialIew string

		if o.SerialIew != nil {
			qrSerialIew = *o.SerialIew
		}
		qSerialIew := qrSerialIew
		if qSerialIew != "" {

			if err := r.SetQueryParam("serial__iew", qSerialIew); err != nil {
				return err
			}
		}
	}

	if o.SerialIsw != nil {

		// query param serial__isw
		var qrSerialIsw string

		if o.SerialIsw != nil {
			qrSerialIsw = *o.SerialIsw
		}
		qSerialIsw := qrSerialIsw
		if qSerialIsw != "" {

			if err := r.SetQueryParam("serial__isw", qSerialIsw); err != nil {
				return err
			}
		}
	}

	if o.Serialn != nil {

		// query param serial__n
		var qrSerialn string

		if o.Serialn != nil {
			qrSerialn = *o.Serialn
		}
		qSerialn := qrSerialn
		if qSerialn != "" {

			if err := r.SetQueryParam("serial__n", qSerialn); err != nil {
				return err
			}
		}
	}

	if o.SerialNic != nil {

		// query param serial__nic
		var qrSerialNic string

		if o.SerialNic != nil {
			qrSerialNic = *o.SerialNic
		}
		qSerialNic := qrSerialNic
		if qSerialNic != "" {

			if err := r.SetQueryParam("serial__nic", qSerialNic); err != nil {
				return err
			}
		}
	}

	if o.SerialNie != nil {

		// query param serial__nie
		var qrSerialNie string

		if o.SerialNie != nil {
			qrSerialNie = *o.SerialNie
		}
		qSerialNie := qrSerialNie
		if qSerialNie != "" {

			if err := r.SetQueryParam("serial__nie", qSerialNie); err != nil {
				return err
			}
		}
	}

	if o.SerialNiew != nil {

		// query param serial__niew
		var qrSerialNiew string

		if o.SerialNiew != nil {
			qrSerialNiew = *o.SerialNiew
		}
		qSerialNiew := qrSerialNiew
		if qSerialNiew != "" {

			if err := r.SetQueryParam("serial__niew", qSerialNiew); err != nil {
				return err
			}
		}
	}

	if o.SerialNisw != nil {

		// query param serial__nisw
		var qrSerialNisw string

		if o.SerialNisw != nil {
			qrSerialNisw = *o.SerialNisw
		}
		qSerialNisw := qrSerialNisw
		if qSerialNisw != "" {

			if err := r.SetQueryParam("serial__nisw", qSerialNisw); err != nil {
				return err
			}
		}
	}

	if o.Tag != nil {

		// query param tag
		var qrTag string

		if o.Tag != nil {
			qrTag = *o.Tag
		}
		qTag := qrTag
		if qTag != "" {

			if err := r.SetQueryParam("tag", qTag); err != nil {
				return err
			}
		}
	}

	if o.Tagn != nil {

		// query param tag__n
		var qrTagn string

		if o.Tagn != nil {
			qrTagn = *o.Tagn
		}
		qTagn := qrTagn
		if qTagn != "" {

			if err := r.SetQueryParam("tag__n", qTagn); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
