// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2020 The go-netbox Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package dcim

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewDcimSitesListParams creates a new DcimSitesListParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDcimSitesListParams() *DcimSitesListParams {
	return &DcimSitesListParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDcimSitesListParamsWithTimeout creates a new DcimSitesListParams object
// with the ability to set a timeout on a request.
func NewDcimSitesListParamsWithTimeout(timeout time.Duration) *DcimSitesListParams {
	return &DcimSitesListParams{
		timeout: timeout,
	}
}

// NewDcimSitesListParamsWithContext creates a new DcimSitesListParams object
// with the ability to set a context for a request.
func NewDcimSitesListParamsWithContext(ctx context.Context) *DcimSitesListParams {
	return &DcimSitesListParams{
		Context: ctx,
	}
}

// NewDcimSitesListParamsWithHTTPClient creates a new DcimSitesListParams object
// with the ability to set a custom HTTPClient for a request.
func NewDcimSitesListParamsWithHTTPClient(client *http.Client) *DcimSitesListParams {
	return &DcimSitesListParams{
		HTTPClient: client,
	}
}

/* DcimSitesListParams contains all the parameters to send to the API endpoint
   for the dcim sites list operation.

   Typically these are written to a http.Request.
*/
type DcimSitesListParams struct {

	// Asn.
	Asn *string

	// Asnn.
	Asnn *string

	// AsnID.
	AsnID *string

	// AsnIDn.
	AsnIDn *string

	// Contact.
	Contact *string

	// Contactn.
	Contactn *string

	// ContactRole.
	ContactRole *string

	// ContactRolen.
	ContactRolen *string

	// Created.
	Created *string

	// CreatedGte.
	CreatedGte *string

	// CreatedLte.
	CreatedLte *string

	// Description.
	Description *string

	// DescriptionIc.
	DescriptionIc *string

	// DescriptionIe.
	DescriptionIe *string

	// DescriptionIew.
	DescriptionIew *string

	// DescriptionIsw.
	DescriptionIsw *string

	// Descriptionn.
	Descriptionn *string

	// DescriptionNic.
	DescriptionNic *string

	// DescriptionNie.
	DescriptionNie *string

	// DescriptionNiew.
	DescriptionNiew *string

	// DescriptionNisw.
	DescriptionNisw *string

	// Facility.
	Facility *string

	// FacilityIc.
	FacilityIc *string

	// FacilityIe.
	FacilityIe *string

	// FacilityIew.
	FacilityIew *string

	// FacilityIsw.
	FacilityIsw *string

	// Facilityn.
	Facilityn *string

	// FacilityNic.
	FacilityNic *string

	// FacilityNie.
	FacilityNie *string

	// FacilityNiew.
	FacilityNiew *string

	// FacilityNisw.
	FacilityNisw *string

	// Group.
	Group *string

	// Groupn.
	Groupn *string

	// GroupID.
	GroupID *string

	// GroupIDn.
	GroupIDn *string

	// ID.
	ID *string

	// IDGt.
	IDGt *string

	// IDGte.
	IDGte *string

	// IDLt.
	IDLt *string

	// IDLte.
	IDLte *string

	// IDn.
	IDn *string

	// LastUpdated.
	LastUpdated *string

	// LastUpdatedGte.
	LastUpdatedGte *string

	// LastUpdatedLte.
	LastUpdatedLte *string

	// Latitude.
	Latitude *string

	// LatitudeGt.
	LatitudeGt *string

	// LatitudeGte.
	LatitudeGte *string

	// LatitudeLt.
	LatitudeLt *string

	// LatitudeLte.
	LatitudeLte *string

	// Latituden.
	Latituden *string

	/* Limit.

	   Number of results to return per page.
	*/
	Limit *int64

	// Longitude.
	Longitude *string

	// LongitudeGt.
	LongitudeGt *string

	// LongitudeGte.
	LongitudeGte *string

	// LongitudeLt.
	LongitudeLt *string

	// LongitudeLte.
	LongitudeLte *string

	// Longituden.
	Longituden *string

	// Name.
	Name *string

	// NameIc.
	NameIc *string

	// NameIe.
	NameIe *string

	// NameIew.
	NameIew *string

	// NameIsw.
	NameIsw *string

	// Namen.
	Namen *string

	// NameNic.
	NameNic *string

	// NameNie.
	NameNie *string

	// NameNiew.
	NameNiew *string

	// NameNisw.
	NameNisw *string

	/* Offset.

	   The initial index from which to return the results.
	*/
	Offset *int64

	// Q.
	Q *string

	// Region.
	Region *string

	// Regionn.
	Regionn *string

	// RegionID.
	RegionID *string

	// RegionIDn.
	RegionIDn *string

	// Slug.
	Slug *string

	// SlugIc.
	SlugIc *string

	// SlugIe.
	SlugIe *string

	// SlugIew.
	SlugIew *string

	// SlugIsw.
	SlugIsw *string

	// Slugn.
	Slugn *string

	// SlugNic.
	SlugNic *string

	// SlugNie.
	SlugNie *string

	// SlugNiew.
	SlugNiew *string

	// SlugNisw.
	SlugNisw *string

	// Status.
	Status *string

	// Statusn.
	Statusn *string

	// Tag.
	Tag *string

	// Tagn.
	Tagn *string

	// Tenant.
	Tenant *string

	// Tenantn.
	Tenantn *string

	// TenantGroup.
	TenantGroup *string

	// TenantGroupn.
	TenantGroupn *string

	// TenantGroupID.
	TenantGroupID *string

	// TenantGroupIDn.
	TenantGroupIDn *string

	// TenantID.
	TenantID *string

	// TenantIDn.
	TenantIDn *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the dcim sites list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DcimSitesListParams) WithDefaults() *DcimSitesListParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the dcim sites list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DcimSitesListParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the dcim sites list params
func (o *DcimSitesListParams) WithTimeout(timeout time.Duration) *DcimSitesListParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the dcim sites list params
func (o *DcimSitesListParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the dcim sites list params
func (o *DcimSitesListParams) WithContext(ctx context.Context) *DcimSitesListParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the dcim sites list params
func (o *DcimSitesListParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the dcim sites list params
func (o *DcimSitesListParams) WithHTTPClient(client *http.Client) *DcimSitesListParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the dcim sites list params
func (o *DcimSitesListParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAsn adds the asn to the dcim sites list params
func (o *DcimSitesListParams) WithAsn(asn *string) *DcimSitesListParams {
	o.SetAsn(asn)
	return o
}

// SetAsn adds the asn to the dcim sites list params
func (o *DcimSitesListParams) SetAsn(asn *string) {
	o.Asn = asn
}

// WithAsnn adds the asnn to the dcim sites list params
func (o *DcimSitesListParams) WithAsnn(asnn *string) *DcimSitesListParams {
	o.SetAsnn(asnn)
	return o
}

// SetAsnn adds the asnN to the dcim sites list params
func (o *DcimSitesListParams) SetAsnn(asnn *string) {
	o.Asnn = asnn
}

// WithAsnID adds the asnID to the dcim sites list params
func (o *DcimSitesListParams) WithAsnID(asnID *string) *DcimSitesListParams {
	o.SetAsnID(asnID)
	return o
}

// SetAsnID adds the asnId to the dcim sites list params
func (o *DcimSitesListParams) SetAsnID(asnID *string) {
	o.AsnID = asnID
}

// WithAsnIDn adds the asnIDn to the dcim sites list params
func (o *DcimSitesListParams) WithAsnIDn(asnIDn *string) *DcimSitesListParams {
	o.SetAsnIDn(asnIDn)
	return o
}

// SetAsnIDn adds the asnIdN to the dcim sites list params
func (o *DcimSitesListParams) SetAsnIDn(asnIDn *string) {
	o.AsnIDn = asnIDn
}

// WithContact adds the contact to the dcim sites list params
func (o *DcimSitesListParams) WithContact(contact *string) *DcimSitesListParams {
	o.SetContact(contact)
	return o
}

// SetContact adds the contact to the dcim sites list params
func (o *DcimSitesListParams) SetContact(contact *string) {
	o.Contact = contact
}

// WithContactn adds the contactn to the dcim sites list params
func (o *DcimSitesListParams) WithContactn(contactn *string) *DcimSitesListParams {
	o.SetContactn(contactn)
	return o
}

// SetContactn adds the contactN to the dcim sites list params
func (o *DcimSitesListParams) SetContactn(contactn *string) {
	o.Contactn = contactn
}

// WithContactRole adds the contactRole to the dcim sites list params
func (o *DcimSitesListParams) WithContactRole(contactRole *string) *DcimSitesListParams {
	o.SetContactRole(contactRole)
	return o
}

// SetContactRole adds the contactRole to the dcim sites list params
func (o *DcimSitesListParams) SetContactRole(contactRole *string) {
	o.ContactRole = contactRole
}

// WithContactRolen adds the contactRolen to the dcim sites list params
func (o *DcimSitesListParams) WithContactRolen(contactRolen *string) *DcimSitesListParams {
	o.SetContactRolen(contactRolen)
	return o
}

// SetContactRolen adds the contactRoleN to the dcim sites list params
func (o *DcimSitesListParams) SetContactRolen(contactRolen *string) {
	o.ContactRolen = contactRolen
}

// WithCreated adds the created to the dcim sites list params
func (o *DcimSitesListParams) WithCreated(created *string) *DcimSitesListParams {
	o.SetCreated(created)
	return o
}

// SetCreated adds the created to the dcim sites list params
func (o *DcimSitesListParams) SetCreated(created *string) {
	o.Created = created
}

// WithCreatedGte adds the createdGte to the dcim sites list params
func (o *DcimSitesListParams) WithCreatedGte(createdGte *string) *DcimSitesListParams {
	o.SetCreatedGte(createdGte)
	return o
}

// SetCreatedGte adds the createdGte to the dcim sites list params
func (o *DcimSitesListParams) SetCreatedGte(createdGte *string) {
	o.CreatedGte = createdGte
}

// WithCreatedLte adds the createdLte to the dcim sites list params
func (o *DcimSitesListParams) WithCreatedLte(createdLte *string) *DcimSitesListParams {
	o.SetCreatedLte(createdLte)
	return o
}

// SetCreatedLte adds the createdLte to the dcim sites list params
func (o *DcimSitesListParams) SetCreatedLte(createdLte *string) {
	o.CreatedLte = createdLte
}

// WithDescription adds the description to the dcim sites list params
func (o *DcimSitesListParams) WithDescription(description *string) *DcimSitesListParams {
	o.SetDescription(description)
	return o
}

// SetDescription adds the description to the dcim sites list params
func (o *DcimSitesListParams) SetDescription(description *string) {
	o.Description = description
}

// WithDescriptionIc adds the descriptionIc to the dcim sites list params
func (o *DcimSitesListParams) WithDescriptionIc(descriptionIc *string) *DcimSitesListParams {
	o.SetDescriptionIc(descriptionIc)
	return o
}

// SetDescriptionIc adds the descriptionIc to the dcim sites list params
func (o *DcimSitesListParams) SetDescriptionIc(descriptionIc *string) {
	o.DescriptionIc = descriptionIc
}

// WithDescriptionIe adds the descriptionIe to the dcim sites list params
func (o *DcimSitesListParams) WithDescriptionIe(descriptionIe *string) *DcimSitesListParams {
	o.SetDescriptionIe(descriptionIe)
	return o
}

// SetDescriptionIe adds the descriptionIe to the dcim sites list params
func (o *DcimSitesListParams) SetDescriptionIe(descriptionIe *string) {
	o.DescriptionIe = descriptionIe
}

// WithDescriptionIew adds the descriptionIew to the dcim sites list params
func (o *DcimSitesListParams) WithDescriptionIew(descriptionIew *string) *DcimSitesListParams {
	o.SetDescriptionIew(descriptionIew)
	return o
}

// SetDescriptionIew adds the descriptionIew to the dcim sites list params
func (o *DcimSitesListParams) SetDescriptionIew(descriptionIew *string) {
	o.DescriptionIew = descriptionIew
}

// WithDescriptionIsw adds the descriptionIsw to the dcim sites list params
func (o *DcimSitesListParams) WithDescriptionIsw(descriptionIsw *string) *DcimSitesListParams {
	o.SetDescriptionIsw(descriptionIsw)
	return o
}

// SetDescriptionIsw adds the descriptionIsw to the dcim sites list params
func (o *DcimSitesListParams) SetDescriptionIsw(descriptionIsw *string) {
	o.DescriptionIsw = descriptionIsw
}

// WithDescriptionn adds the descriptionn to the dcim sites list params
func (o *DcimSitesListParams) WithDescriptionn(descriptionn *string) *DcimSitesListParams {
	o.SetDescriptionn(descriptionn)
	return o
}

// SetDescriptionn adds the descriptionN to the dcim sites list params
func (o *DcimSitesListParams) SetDescriptionn(descriptionn *string) {
	o.Descriptionn = descriptionn
}

// WithDescriptionNic adds the descriptionNic to the dcim sites list params
func (o *DcimSitesListParams) WithDescriptionNic(descriptionNic *string) *DcimSitesListParams {
	o.SetDescriptionNic(descriptionNic)
	return o
}

// SetDescriptionNic adds the descriptionNic to the dcim sites list params
func (o *DcimSitesListParams) SetDescriptionNic(descriptionNic *string) {
	o.DescriptionNic = descriptionNic
}

// WithDescriptionNie adds the descriptionNie to the dcim sites list params
func (o *DcimSitesListParams) WithDescriptionNie(descriptionNie *string) *DcimSitesListParams {
	o.SetDescriptionNie(descriptionNie)
	return o
}

// SetDescriptionNie adds the descriptionNie to the dcim sites list params
func (o *DcimSitesListParams) SetDescriptionNie(descriptionNie *string) {
	o.DescriptionNie = descriptionNie
}

// WithDescriptionNiew adds the descriptionNiew to the dcim sites list params
func (o *DcimSitesListParams) WithDescriptionNiew(descriptionNiew *string) *DcimSitesListParams {
	o.SetDescriptionNiew(descriptionNiew)
	return o
}

// SetDescriptionNiew adds the descriptionNiew to the dcim sites list params
func (o *DcimSitesListParams) SetDescriptionNiew(descriptionNiew *string) {
	o.DescriptionNiew = descriptionNiew
}

// WithDescriptionNisw adds the descriptionNisw to the dcim sites list params
func (o *DcimSitesListParams) WithDescriptionNisw(descriptionNisw *string) *DcimSitesListParams {
	o.SetDescriptionNisw(descriptionNisw)
	return o
}

// SetDescriptionNisw adds the descriptionNisw to the dcim sites list params
func (o *DcimSitesListParams) SetDescriptionNisw(descriptionNisw *string) {
	o.DescriptionNisw = descriptionNisw
}

// WithFacility adds the facility to the dcim sites list params
func (o *DcimSitesListParams) WithFacility(facility *string) *DcimSitesListParams {
	o.SetFacility(facility)
	return o
}

// SetFacility adds the facility to the dcim sites list params
func (o *DcimSitesListParams) SetFacility(facility *string) {
	o.Facility = facility
}

// WithFacilityIc adds the facilityIc to the dcim sites list params
func (o *DcimSitesListParams) WithFacilityIc(facilityIc *string) *DcimSitesListParams {
	o.SetFacilityIc(facilityIc)
	return o
}

// SetFacilityIc adds the facilityIc to the dcim sites list params
func (o *DcimSitesListParams) SetFacilityIc(facilityIc *string) {
	o.FacilityIc = facilityIc
}

// WithFacilityIe adds the facilityIe to the dcim sites list params
func (o *DcimSitesListParams) WithFacilityIe(facilityIe *string) *DcimSitesListParams {
	o.SetFacilityIe(facilityIe)
	return o
}

// SetFacilityIe adds the facilityIe to the dcim sites list params
func (o *DcimSitesListParams) SetFacilityIe(facilityIe *string) {
	o.FacilityIe = facilityIe
}

// WithFacilityIew adds the facilityIew to the dcim sites list params
func (o *DcimSitesListParams) WithFacilityIew(facilityIew *string) *DcimSitesListParams {
	o.SetFacilityIew(facilityIew)
	return o
}

// SetFacilityIew adds the facilityIew to the dcim sites list params
func (o *DcimSitesListParams) SetFacilityIew(facilityIew *string) {
	o.FacilityIew = facilityIew
}

// WithFacilityIsw adds the facilityIsw to the dcim sites list params
func (o *DcimSitesListParams) WithFacilityIsw(facilityIsw *string) *DcimSitesListParams {
	o.SetFacilityIsw(facilityIsw)
	return o
}

// SetFacilityIsw adds the facilityIsw to the dcim sites list params
func (o *DcimSitesListParams) SetFacilityIsw(facilityIsw *string) {
	o.FacilityIsw = facilityIsw
}

// WithFacilityn adds the facilityn to the dcim sites list params
func (o *DcimSitesListParams) WithFacilityn(facilityn *string) *DcimSitesListParams {
	o.SetFacilityn(facilityn)
	return o
}

// SetFacilityn adds the facilityN to the dcim sites list params
func (o *DcimSitesListParams) SetFacilityn(facilityn *string) {
	o.Facilityn = facilityn
}

// WithFacilityNic adds the facilityNic to the dcim sites list params
func (o *DcimSitesListParams) WithFacilityNic(facilityNic *string) *DcimSitesListParams {
	o.SetFacilityNic(facilityNic)
	return o
}

// SetFacilityNic adds the facilityNic to the dcim sites list params
func (o *DcimSitesListParams) SetFacilityNic(facilityNic *string) {
	o.FacilityNic = facilityNic
}

// WithFacilityNie adds the facilityNie to the dcim sites list params
func (o *DcimSitesListParams) WithFacilityNie(facilityNie *string) *DcimSitesListParams {
	o.SetFacilityNie(facilityNie)
	return o
}

// SetFacilityNie adds the facilityNie to the dcim sites list params
func (o *DcimSitesListParams) SetFacilityNie(facilityNie *string) {
	o.FacilityNie = facilityNie
}

// WithFacilityNiew adds the facilityNiew to the dcim sites list params
func (o *DcimSitesListParams) WithFacilityNiew(facilityNiew *string) *DcimSitesListParams {
	o.SetFacilityNiew(facilityNiew)
	return o
}

// SetFacilityNiew adds the facilityNiew to the dcim sites list params
func (o *DcimSitesListParams) SetFacilityNiew(facilityNiew *string) {
	o.FacilityNiew = facilityNiew
}

// WithFacilityNisw adds the facilityNisw to the dcim sites list params
func (o *DcimSitesListParams) WithFacilityNisw(facilityNisw *string) *DcimSitesListParams {
	o.SetFacilityNisw(facilityNisw)
	return o
}

// SetFacilityNisw adds the facilityNisw to the dcim sites list params
func (o *DcimSitesListParams) SetFacilityNisw(facilityNisw *string) {
	o.FacilityNisw = facilityNisw
}

// WithGroup adds the group to the dcim sites list params
func (o *DcimSitesListParams) WithGroup(group *string) *DcimSitesListParams {
	o.SetGroup(group)
	return o
}

// SetGroup adds the group to the dcim sites list params
func (o *DcimSitesListParams) SetGroup(group *string) {
	o.Group = group
}

// WithGroupn adds the groupn to the dcim sites list params
func (o *DcimSitesListParams) WithGroupn(groupn *string) *DcimSitesListParams {
	o.SetGroupn(groupn)
	return o
}

// SetGroupn adds the groupN to the dcim sites list params
func (o *DcimSitesListParams) SetGroupn(groupn *string) {
	o.Groupn = groupn
}

// WithGroupID adds the groupID to the dcim sites list params
func (o *DcimSitesListParams) WithGroupID(groupID *string) *DcimSitesListParams {
	o.SetGroupID(groupID)
	return o
}

// SetGroupID adds the groupId to the dcim sites list params
func (o *DcimSitesListParams) SetGroupID(groupID *string) {
	o.GroupID = groupID
}

// WithGroupIDn adds the groupIDn to the dcim sites list params
func (o *DcimSitesListParams) WithGroupIDn(groupIDn *string) *DcimSitesListParams {
	o.SetGroupIDn(groupIDn)
	return o
}

// SetGroupIDn adds the groupIdN to the dcim sites list params
func (o *DcimSitesListParams) SetGroupIDn(groupIDn *string) {
	o.GroupIDn = groupIDn
}

// WithID adds the id to the dcim sites list params
func (o *DcimSitesListParams) WithID(id *string) *DcimSitesListParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the dcim sites list params
func (o *DcimSitesListParams) SetID(id *string) {
	o.ID = id
}

// WithIDGt adds the iDGt to the dcim sites list params
func (o *DcimSitesListParams) WithIDGt(iDGt *string) *DcimSitesListParams {
	o.SetIDGt(iDGt)
	return o
}

// SetIDGt adds the idGt to the dcim sites list params
func (o *DcimSitesListParams) SetIDGt(iDGt *string) {
	o.IDGt = iDGt
}

// WithIDGte adds the iDGte to the dcim sites list params
func (o *DcimSitesListParams) WithIDGte(iDGte *string) *DcimSitesListParams {
	o.SetIDGte(iDGte)
	return o
}

// SetIDGte adds the idGte to the dcim sites list params
func (o *DcimSitesListParams) SetIDGte(iDGte *string) {
	o.IDGte = iDGte
}

// WithIDLt adds the iDLt to the dcim sites list params
func (o *DcimSitesListParams) WithIDLt(iDLt *string) *DcimSitesListParams {
	o.SetIDLt(iDLt)
	return o
}

// SetIDLt adds the idLt to the dcim sites list params
func (o *DcimSitesListParams) SetIDLt(iDLt *string) {
	o.IDLt = iDLt
}

// WithIDLte adds the iDLte to the dcim sites list params
func (o *DcimSitesListParams) WithIDLte(iDLte *string) *DcimSitesListParams {
	o.SetIDLte(iDLte)
	return o
}

// SetIDLte adds the idLte to the dcim sites list params
func (o *DcimSitesListParams) SetIDLte(iDLte *string) {
	o.IDLte = iDLte
}

// WithIDn adds the iDn to the dcim sites list params
func (o *DcimSitesListParams) WithIDn(iDn *string) *DcimSitesListParams {
	o.SetIDn(iDn)
	return o
}

// SetIDn adds the idN to the dcim sites list params
func (o *DcimSitesListParams) SetIDn(iDn *string) {
	o.IDn = iDn
}

// WithLastUpdated adds the lastUpdated to the dcim sites list params
func (o *DcimSitesListParams) WithLastUpdated(lastUpdated *string) *DcimSitesListParams {
	o.SetLastUpdated(lastUpdated)
	return o
}

// SetLastUpdated adds the lastUpdated to the dcim sites list params
func (o *DcimSitesListParams) SetLastUpdated(lastUpdated *string) {
	o.LastUpdated = lastUpdated
}

// WithLastUpdatedGte adds the lastUpdatedGte to the dcim sites list params
func (o *DcimSitesListParams) WithLastUpdatedGte(lastUpdatedGte *string) *DcimSitesListParams {
	o.SetLastUpdatedGte(lastUpdatedGte)
	return o
}

// SetLastUpdatedGte adds the lastUpdatedGte to the dcim sites list params
func (o *DcimSitesListParams) SetLastUpdatedGte(lastUpdatedGte *string) {
	o.LastUpdatedGte = lastUpdatedGte
}

// WithLastUpdatedLte adds the lastUpdatedLte to the dcim sites list params
func (o *DcimSitesListParams) WithLastUpdatedLte(lastUpdatedLte *string) *DcimSitesListParams {
	o.SetLastUpdatedLte(lastUpdatedLte)
	return o
}

// SetLastUpdatedLte adds the lastUpdatedLte to the dcim sites list params
func (o *DcimSitesListParams) SetLastUpdatedLte(lastUpdatedLte *string) {
	o.LastUpdatedLte = lastUpdatedLte
}

// WithLatitude adds the latitude to the dcim sites list params
func (o *DcimSitesListParams) WithLatitude(latitude *string) *DcimSitesListParams {
	o.SetLatitude(latitude)
	return o
}

// SetLatitude adds the latitude to the dcim sites list params
func (o *DcimSitesListParams) SetLatitude(latitude *string) {
	o.Latitude = latitude
}

// WithLatitudeGt adds the latitudeGt to the dcim sites list params
func (o *DcimSitesListParams) WithLatitudeGt(latitudeGt *string) *DcimSitesListParams {
	o.SetLatitudeGt(latitudeGt)
	return o
}

// SetLatitudeGt adds the latitudeGt to the dcim sites list params
func (o *DcimSitesListParams) SetLatitudeGt(latitudeGt *string) {
	o.LatitudeGt = latitudeGt
}

// WithLatitudeGte adds the latitudeGte to the dcim sites list params
func (o *DcimSitesListParams) WithLatitudeGte(latitudeGte *string) *DcimSitesListParams {
	o.SetLatitudeGte(latitudeGte)
	return o
}

// SetLatitudeGte adds the latitudeGte to the dcim sites list params
func (o *DcimSitesListParams) SetLatitudeGte(latitudeGte *string) {
	o.LatitudeGte = latitudeGte
}

// WithLatitudeLt adds the latitudeLt to the dcim sites list params
func (o *DcimSitesListParams) WithLatitudeLt(latitudeLt *string) *DcimSitesListParams {
	o.SetLatitudeLt(latitudeLt)
	return o
}

// SetLatitudeLt adds the latitudeLt to the dcim sites list params
func (o *DcimSitesListParams) SetLatitudeLt(latitudeLt *string) {
	o.LatitudeLt = latitudeLt
}

// WithLatitudeLte adds the latitudeLte to the dcim sites list params
func (o *DcimSitesListParams) WithLatitudeLte(latitudeLte *string) *DcimSitesListParams {
	o.SetLatitudeLte(latitudeLte)
	return o
}

// SetLatitudeLte adds the latitudeLte to the dcim sites list params
func (o *DcimSitesListParams) SetLatitudeLte(latitudeLte *string) {
	o.LatitudeLte = latitudeLte
}

// WithLatituden adds the latituden to the dcim sites list params
func (o *DcimSitesListParams) WithLatituden(latituden *string) *DcimSitesListParams {
	o.SetLatituden(latituden)
	return o
}

// SetLatituden adds the latitudeN to the dcim sites list params
func (o *DcimSitesListParams) SetLatituden(latituden *string) {
	o.Latituden = latituden
}

// WithLimit adds the limit to the dcim sites list params
func (o *DcimSitesListParams) WithLimit(limit *int64) *DcimSitesListParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the dcim sites list params
func (o *DcimSitesListParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithLongitude adds the longitude to the dcim sites list params
func (o *DcimSitesListParams) WithLongitude(longitude *string) *DcimSitesListParams {
	o.SetLongitude(longitude)
	return o
}

// SetLongitude adds the longitude to the dcim sites list params
func (o *DcimSitesListParams) SetLongitude(longitude *string) {
	o.Longitude = longitude
}

// WithLongitudeGt adds the longitudeGt to the dcim sites list params
func (o *DcimSitesListParams) WithLongitudeGt(longitudeGt *string) *DcimSitesListParams {
	o.SetLongitudeGt(longitudeGt)
	return o
}

// SetLongitudeGt adds the longitudeGt to the dcim sites list params
func (o *DcimSitesListParams) SetLongitudeGt(longitudeGt *string) {
	o.LongitudeGt = longitudeGt
}

// WithLongitudeGte adds the longitudeGte to the dcim sites list params
func (o *DcimSitesListParams) WithLongitudeGte(longitudeGte *string) *DcimSitesListParams {
	o.SetLongitudeGte(longitudeGte)
	return o
}

// SetLongitudeGte adds the longitudeGte to the dcim sites list params
func (o *DcimSitesListParams) SetLongitudeGte(longitudeGte *string) {
	o.LongitudeGte = longitudeGte
}

// WithLongitudeLt adds the longitudeLt to the dcim sites list params
func (o *DcimSitesListParams) WithLongitudeLt(longitudeLt *string) *DcimSitesListParams {
	o.SetLongitudeLt(longitudeLt)
	return o
}

// SetLongitudeLt adds the longitudeLt to the dcim sites list params
func (o *DcimSitesListParams) SetLongitudeLt(longitudeLt *string) {
	o.LongitudeLt = longitudeLt
}

// WithLongitudeLte adds the longitudeLte to the dcim sites list params
func (o *DcimSitesListParams) WithLongitudeLte(longitudeLte *string) *DcimSitesListParams {
	o.SetLongitudeLte(longitudeLte)
	return o
}

// SetLongitudeLte adds the longitudeLte to the dcim sites list params
func (o *DcimSitesListParams) SetLongitudeLte(longitudeLte *string) {
	o.LongitudeLte = longitudeLte
}

// WithLongituden adds the longituden to the dcim sites list params
func (o *DcimSitesListParams) WithLongituden(longituden *string) *DcimSitesListParams {
	o.SetLongituden(longituden)
	return o
}

// SetLongituden adds the longitudeN to the dcim sites list params
func (o *DcimSitesListParams) SetLongituden(longituden *string) {
	o.Longituden = longituden
}

// WithName adds the name to the dcim sites list params
func (o *DcimSitesListParams) WithName(name *string) *DcimSitesListParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the dcim sites list params
func (o *DcimSitesListParams) SetName(name *string) {
	o.Name = name
}

// WithNameIc adds the nameIc to the dcim sites list params
func (o *DcimSitesListParams) WithNameIc(nameIc *string) *DcimSitesListParams {
	o.SetNameIc(nameIc)
	return o
}

// SetNameIc adds the nameIc to the dcim sites list params
func (o *DcimSitesListParams) SetNameIc(nameIc *string) {
	o.NameIc = nameIc
}

// WithNameIe adds the nameIe to the dcim sites list params
func (o *DcimSitesListParams) WithNameIe(nameIe *string) *DcimSitesListParams {
	o.SetNameIe(nameIe)
	return o
}

// SetNameIe adds the nameIe to the dcim sites list params
func (o *DcimSitesListParams) SetNameIe(nameIe *string) {
	o.NameIe = nameIe
}

// WithNameIew adds the nameIew to the dcim sites list params
func (o *DcimSitesListParams) WithNameIew(nameIew *string) *DcimSitesListParams {
	o.SetNameIew(nameIew)
	return o
}

// SetNameIew adds the nameIew to the dcim sites list params
func (o *DcimSitesListParams) SetNameIew(nameIew *string) {
	o.NameIew = nameIew
}

// WithNameIsw adds the nameIsw to the dcim sites list params
func (o *DcimSitesListParams) WithNameIsw(nameIsw *string) *DcimSitesListParams {
	o.SetNameIsw(nameIsw)
	return o
}

// SetNameIsw adds the nameIsw to the dcim sites list params
func (o *DcimSitesListParams) SetNameIsw(nameIsw *string) {
	o.NameIsw = nameIsw
}

// WithNamen adds the namen to the dcim sites list params
func (o *DcimSitesListParams) WithNamen(namen *string) *DcimSitesListParams {
	o.SetNamen(namen)
	return o
}

// SetNamen adds the nameN to the dcim sites list params
func (o *DcimSitesListParams) SetNamen(namen *string) {
	o.Namen = namen
}

// WithNameNic adds the nameNic to the dcim sites list params
func (o *DcimSitesListParams) WithNameNic(nameNic *string) *DcimSitesListParams {
	o.SetNameNic(nameNic)
	return o
}

// SetNameNic adds the nameNic to the dcim sites list params
func (o *DcimSitesListParams) SetNameNic(nameNic *string) {
	o.NameNic = nameNic
}

// WithNameNie adds the nameNie to the dcim sites list params
func (o *DcimSitesListParams) WithNameNie(nameNie *string) *DcimSitesListParams {
	o.SetNameNie(nameNie)
	return o
}

// SetNameNie adds the nameNie to the dcim sites list params
func (o *DcimSitesListParams) SetNameNie(nameNie *string) {
	o.NameNie = nameNie
}

// WithNameNiew adds the nameNiew to the dcim sites list params
func (o *DcimSitesListParams) WithNameNiew(nameNiew *string) *DcimSitesListParams {
	o.SetNameNiew(nameNiew)
	return o
}

// SetNameNiew adds the nameNiew to the dcim sites list params
func (o *DcimSitesListParams) SetNameNiew(nameNiew *string) {
	o.NameNiew = nameNiew
}

// WithNameNisw adds the nameNisw to the dcim sites list params
func (o *DcimSitesListParams) WithNameNisw(nameNisw *string) *DcimSitesListParams {
	o.SetNameNisw(nameNisw)
	return o
}

// SetNameNisw adds the nameNisw to the dcim sites list params
func (o *DcimSitesListParams) SetNameNisw(nameNisw *string) {
	o.NameNisw = nameNisw
}

// WithOffset adds the offset to the dcim sites list params
func (o *DcimSitesListParams) WithOffset(offset *int64) *DcimSitesListParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the dcim sites list params
func (o *DcimSitesListParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithQ adds the q to the dcim sites list params
func (o *DcimSitesListParams) WithQ(q *string) *DcimSitesListParams {
	o.SetQ(q)
	return o
}

// SetQ adds the q to the dcim sites list params
func (o *DcimSitesListParams) SetQ(q *string) {
	o.Q = q
}

// WithRegion adds the region to the dcim sites list params
func (o *DcimSitesListParams) WithRegion(region *string) *DcimSitesListParams {
	o.SetRegion(region)
	return o
}

// SetRegion adds the region to the dcim sites list params
func (o *DcimSitesListParams) SetRegion(region *string) {
	o.Region = region
}

// WithRegionn adds the regionn to the dcim sites list params
func (o *DcimSitesListParams) WithRegionn(regionn *string) *DcimSitesListParams {
	o.SetRegionn(regionn)
	return o
}

// SetRegionn adds the regionN to the dcim sites list params
func (o *DcimSitesListParams) SetRegionn(regionn *string) {
	o.Regionn = regionn
}

// WithRegionID adds the regionID to the dcim sites list params
func (o *DcimSitesListParams) WithRegionID(regionID *string) *DcimSitesListParams {
	o.SetRegionID(regionID)
	return o
}

// SetRegionID adds the regionId to the dcim sites list params
func (o *DcimSitesListParams) SetRegionID(regionID *string) {
	o.RegionID = regionID
}

// WithRegionIDn adds the regionIDn to the dcim sites list params
func (o *DcimSitesListParams) WithRegionIDn(regionIDn *string) *DcimSitesListParams {
	o.SetRegionIDn(regionIDn)
	return o
}

// SetRegionIDn adds the regionIdN to the dcim sites list params
func (o *DcimSitesListParams) SetRegionIDn(regionIDn *string) {
	o.RegionIDn = regionIDn
}

// WithSlug adds the slug to the dcim sites list params
func (o *DcimSitesListParams) WithSlug(slug *string) *DcimSitesListParams {
	o.SetSlug(slug)
	return o
}

// SetSlug adds the slug to the dcim sites list params
func (o *DcimSitesListParams) SetSlug(slug *string) {
	o.Slug = slug
}

// WithSlugIc adds the slugIc to the dcim sites list params
func (o *DcimSitesListParams) WithSlugIc(slugIc *string) *DcimSitesListParams {
	o.SetSlugIc(slugIc)
	return o
}

// SetSlugIc adds the slugIc to the dcim sites list params
func (o *DcimSitesListParams) SetSlugIc(slugIc *string) {
	o.SlugIc = slugIc
}

// WithSlugIe adds the slugIe to the dcim sites list params
func (o *DcimSitesListParams) WithSlugIe(slugIe *string) *DcimSitesListParams {
	o.SetSlugIe(slugIe)
	return o
}

// SetSlugIe adds the slugIe to the dcim sites list params
func (o *DcimSitesListParams) SetSlugIe(slugIe *string) {
	o.SlugIe = slugIe
}

// WithSlugIew adds the slugIew to the dcim sites list params
func (o *DcimSitesListParams) WithSlugIew(slugIew *string) *DcimSitesListParams {
	o.SetSlugIew(slugIew)
	return o
}

// SetSlugIew adds the slugIew to the dcim sites list params
func (o *DcimSitesListParams) SetSlugIew(slugIew *string) {
	o.SlugIew = slugIew
}

// WithSlugIsw adds the slugIsw to the dcim sites list params
func (o *DcimSitesListParams) WithSlugIsw(slugIsw *string) *DcimSitesListParams {
	o.SetSlugIsw(slugIsw)
	return o
}

// SetSlugIsw adds the slugIsw to the dcim sites list params
func (o *DcimSitesListParams) SetSlugIsw(slugIsw *string) {
	o.SlugIsw = slugIsw
}

// WithSlugn adds the slugn to the dcim sites list params
func (o *DcimSitesListParams) WithSlugn(slugn *string) *DcimSitesListParams {
	o.SetSlugn(slugn)
	return o
}

// SetSlugn adds the slugN to the dcim sites list params
func (o *DcimSitesListParams) SetSlugn(slugn *string) {
	o.Slugn = slugn
}

// WithSlugNic adds the slugNic to the dcim sites list params
func (o *DcimSitesListParams) WithSlugNic(slugNic *string) *DcimSitesListParams {
	o.SetSlugNic(slugNic)
	return o
}

// SetSlugNic adds the slugNic to the dcim sites list params
func (o *DcimSitesListParams) SetSlugNic(slugNic *string) {
	o.SlugNic = slugNic
}

// WithSlugNie adds the slugNie to the dcim sites list params
func (o *DcimSitesListParams) WithSlugNie(slugNie *string) *DcimSitesListParams {
	o.SetSlugNie(slugNie)
	return o
}

// SetSlugNie adds the slugNie to the dcim sites list params
func (o *DcimSitesListParams) SetSlugNie(slugNie *string) {
	o.SlugNie = slugNie
}

// WithSlugNiew adds the slugNiew to the dcim sites list params
func (o *DcimSitesListParams) WithSlugNiew(slugNiew *string) *DcimSitesListParams {
	o.SetSlugNiew(slugNiew)
	return o
}

// SetSlugNiew adds the slugNiew to the dcim sites list params
func (o *DcimSitesListParams) SetSlugNiew(slugNiew *string) {
	o.SlugNiew = slugNiew
}

// WithSlugNisw adds the slugNisw to the dcim sites list params
func (o *DcimSitesListParams) WithSlugNisw(slugNisw *string) *DcimSitesListParams {
	o.SetSlugNisw(slugNisw)
	return o
}

// SetSlugNisw adds the slugNisw to the dcim sites list params
func (o *DcimSitesListParams) SetSlugNisw(slugNisw *string) {
	o.SlugNisw = slugNisw
}

// WithStatus adds the status to the dcim sites list params
func (o *DcimSitesListParams) WithStatus(status *string) *DcimSitesListParams {
	o.SetStatus(status)
	return o
}

// SetStatus adds the status to the dcim sites list params
func (o *DcimSitesListParams) SetStatus(status *string) {
	o.Status = status
}

// WithStatusn adds the statusn to the dcim sites list params
func (o *DcimSitesListParams) WithStatusn(statusn *string) *DcimSitesListParams {
	o.SetStatusn(statusn)
	return o
}

// SetStatusn adds the statusN to the dcim sites list params
func (o *DcimSitesListParams) SetStatusn(statusn *string) {
	o.Statusn = statusn
}

// WithTag adds the tag to the dcim sites list params
func (o *DcimSitesListParams) WithTag(tag *string) *DcimSitesListParams {
	o.SetTag(tag)
	return o
}

// SetTag adds the tag to the dcim sites list params
func (o *DcimSitesListParams) SetTag(tag *string) {
	o.Tag = tag
}

// WithTagn adds the tagn to the dcim sites list params
func (o *DcimSitesListParams) WithTagn(tagn *string) *DcimSitesListParams {
	o.SetTagn(tagn)
	return o
}

// SetTagn adds the tagN to the dcim sites list params
func (o *DcimSitesListParams) SetTagn(tagn *string) {
	o.Tagn = tagn
}

// WithTenant adds the tenant to the dcim sites list params
func (o *DcimSitesListParams) WithTenant(tenant *string) *DcimSitesListParams {
	o.SetTenant(tenant)
	return o
}

// SetTenant adds the tenant to the dcim sites list params
func (o *DcimSitesListParams) SetTenant(tenant *string) {
	o.Tenant = tenant
}

// WithTenantn adds the tenantn to the dcim sites list params
func (o *DcimSitesListParams) WithTenantn(tenantn *string) *DcimSitesListParams {
	o.SetTenantn(tenantn)
	return o
}

// SetTenantn adds the tenantN to the dcim sites list params
func (o *DcimSitesListParams) SetTenantn(tenantn *string) {
	o.Tenantn = tenantn
}

// WithTenantGroup adds the tenantGroup to the dcim sites list params
func (o *DcimSitesListParams) WithTenantGroup(tenantGroup *string) *DcimSitesListParams {
	o.SetTenantGroup(tenantGroup)
	return o
}

// SetTenantGroup adds the tenantGroup to the dcim sites list params
func (o *DcimSitesListParams) SetTenantGroup(tenantGroup *string) {
	o.TenantGroup = tenantGroup
}

// WithTenantGroupn adds the tenantGroupn to the dcim sites list params
func (o *DcimSitesListParams) WithTenantGroupn(tenantGroupn *string) *DcimSitesListParams {
	o.SetTenantGroupn(tenantGroupn)
	return o
}

// SetTenantGroupn adds the tenantGroupN to the dcim sites list params
func (o *DcimSitesListParams) SetTenantGroupn(tenantGroupn *string) {
	o.TenantGroupn = tenantGroupn
}

// WithTenantGroupID adds the tenantGroupID to the dcim sites list params
func (o *DcimSitesListParams) WithTenantGroupID(tenantGroupID *string) *DcimSitesListParams {
	o.SetTenantGroupID(tenantGroupID)
	return o
}

// SetTenantGroupID adds the tenantGroupId to the dcim sites list params
func (o *DcimSitesListParams) SetTenantGroupID(tenantGroupID *string) {
	o.TenantGroupID = tenantGroupID
}

// WithTenantGroupIDn adds the tenantGroupIDn to the dcim sites list params
func (o *DcimSitesListParams) WithTenantGroupIDn(tenantGroupIDn *string) *DcimSitesListParams {
	o.SetTenantGroupIDn(tenantGroupIDn)
	return o
}

// SetTenantGroupIDn adds the tenantGroupIdN to the dcim sites list params
func (o *DcimSitesListParams) SetTenantGroupIDn(tenantGroupIDn *string) {
	o.TenantGroupIDn = tenantGroupIDn
}

// WithTenantID adds the tenantID to the dcim sites list params
func (o *DcimSitesListParams) WithTenantID(tenantID *string) *DcimSitesListParams {
	o.SetTenantID(tenantID)
	return o
}

// SetTenantID adds the tenantId to the dcim sites list params
func (o *DcimSitesListParams) SetTenantID(tenantID *string) {
	o.TenantID = tenantID
}

// WithTenantIDn adds the tenantIDn to the dcim sites list params
func (o *DcimSitesListParams) WithTenantIDn(tenantIDn *string) *DcimSitesListParams {
	o.SetTenantIDn(tenantIDn)
	return o
}

// SetTenantIDn adds the tenantIdN to the dcim sites list params
func (o *DcimSitesListParams) SetTenantIDn(tenantIDn *string) {
	o.TenantIDn = tenantIDn
}

// WriteToRequest writes these params to a swagger request
func (o *DcimSitesListParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Asn != nil {

		// query param asn
		var qrAsn string

		if o.Asn != nil {
			qrAsn = *o.Asn
		}
		qAsn := qrAsn
		if qAsn != "" {

			if err := r.SetQueryParam("asn", qAsn); err != nil {
				return err
			}
		}
	}

	if o.Asnn != nil {

		// query param asn__n
		var qrAsnn string

		if o.Asnn != nil {
			qrAsnn = *o.Asnn
		}
		qAsnn := qrAsnn
		if qAsnn != "" {

			if err := r.SetQueryParam("asn__n", qAsnn); err != nil {
				return err
			}
		}
	}

	if o.AsnID != nil {

		// query param asn_id
		var qrAsnID string

		if o.AsnID != nil {
			qrAsnID = *o.AsnID
		}
		qAsnID := qrAsnID
		if qAsnID != "" {

			if err := r.SetQueryParam("asn_id", qAsnID); err != nil {
				return err
			}
		}
	}

	if o.AsnIDn != nil {

		// query param asn_id__n
		var qrAsnIDn string

		if o.AsnIDn != nil {
			qrAsnIDn = *o.AsnIDn
		}
		qAsnIDn := qrAsnIDn
		if qAsnIDn != "" {

			if err := r.SetQueryParam("asn_id__n", qAsnIDn); err != nil {
				return err
			}
		}
	}

	if o.Contact != nil {

		// query param contact
		var qrContact string

		if o.Contact != nil {
			qrContact = *o.Contact
		}
		qContact := qrContact
		if qContact != "" {

			if err := r.SetQueryParam("contact", qContact); err != nil {
				return err
			}
		}
	}

	if o.Contactn != nil {

		// query param contact__n
		var qrContactn string

		if o.Contactn != nil {
			qrContactn = *o.Contactn
		}
		qContactn := qrContactn
		if qContactn != "" {

			if err := r.SetQueryParam("contact__n", qContactn); err != nil {
				return err
			}
		}
	}

	if o.ContactRole != nil {

		// query param contact_role
		var qrContactRole string

		if o.ContactRole != nil {
			qrContactRole = *o.ContactRole
		}
		qContactRole := qrContactRole
		if qContactRole != "" {

			if err := r.SetQueryParam("contact_role", qContactRole); err != nil {
				return err
			}
		}
	}

	if o.ContactRolen != nil {

		// query param contact_role__n
		var qrContactRolen string

		if o.ContactRolen != nil {
			qrContactRolen = *o.ContactRolen
		}
		qContactRolen := qrContactRolen
		if qContactRolen != "" {

			if err := r.SetQueryParam("contact_role__n", qContactRolen); err != nil {
				return err
			}
		}
	}

	if o.Created != nil {

		// query param created
		var qrCreated string

		if o.Created != nil {
			qrCreated = *o.Created
		}
		qCreated := qrCreated
		if qCreated != "" {

			if err := r.SetQueryParam("created", qCreated); err != nil {
				return err
			}
		}
	}

	if o.CreatedGte != nil {

		// query param created__gte
		var qrCreatedGte string

		if o.CreatedGte != nil {
			qrCreatedGte = *o.CreatedGte
		}
		qCreatedGte := qrCreatedGte
		if qCreatedGte != "" {

			if err := r.SetQueryParam("created__gte", qCreatedGte); err != nil {
				return err
			}
		}
	}

	if o.CreatedLte != nil {

		// query param created__lte
		var qrCreatedLte string

		if o.CreatedLte != nil {
			qrCreatedLte = *o.CreatedLte
		}
		qCreatedLte := qrCreatedLte
		if qCreatedLte != "" {

			if err := r.SetQueryParam("created__lte", qCreatedLte); err != nil {
				return err
			}
		}
	}

	if o.Description != nil {

		// query param description
		var qrDescription string

		if o.Description != nil {
			qrDescription = *o.Description
		}
		qDescription := qrDescription
		if qDescription != "" {

			if err := r.SetQueryParam("description", qDescription); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIc != nil {

		// query param description__ic
		var qrDescriptionIc string

		if o.DescriptionIc != nil {
			qrDescriptionIc = *o.DescriptionIc
		}
		qDescriptionIc := qrDescriptionIc
		if qDescriptionIc != "" {

			if err := r.SetQueryParam("description__ic", qDescriptionIc); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIe != nil {

		// query param description__ie
		var qrDescriptionIe string

		if o.DescriptionIe != nil {
			qrDescriptionIe = *o.DescriptionIe
		}
		qDescriptionIe := qrDescriptionIe
		if qDescriptionIe != "" {

			if err := r.SetQueryParam("description__ie", qDescriptionIe); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIew != nil {

		// query param description__iew
		var qrDescriptionIew string

		if o.DescriptionIew != nil {
			qrDescriptionIew = *o.DescriptionIew
		}
		qDescriptionIew := qrDescriptionIew
		if qDescriptionIew != "" {

			if err := r.SetQueryParam("description__iew", qDescriptionIew); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIsw != nil {

		// query param description__isw
		var qrDescriptionIsw string

		if o.DescriptionIsw != nil {
			qrDescriptionIsw = *o.DescriptionIsw
		}
		qDescriptionIsw := qrDescriptionIsw
		if qDescriptionIsw != "" {

			if err := r.SetQueryParam("description__isw", qDescriptionIsw); err != nil {
				return err
			}
		}
	}

	if o.Descriptionn != nil {

		// query param description__n
		var qrDescriptionn string

		if o.Descriptionn != nil {
			qrDescriptionn = *o.Descriptionn
		}
		qDescriptionn := qrDescriptionn
		if qDescriptionn != "" {

			if err := r.SetQueryParam("description__n", qDescriptionn); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNic != nil {

		// query param description__nic
		var qrDescriptionNic string

		if o.DescriptionNic != nil {
			qrDescriptionNic = *o.DescriptionNic
		}
		qDescriptionNic := qrDescriptionNic
		if qDescriptionNic != "" {

			if err := r.SetQueryParam("description__nic", qDescriptionNic); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNie != nil {

		// query param description__nie
		var qrDescriptionNie string

		if o.DescriptionNie != nil {
			qrDescriptionNie = *o.DescriptionNie
		}
		qDescriptionNie := qrDescriptionNie
		if qDescriptionNie != "" {

			if err := r.SetQueryParam("description__nie", qDescriptionNie); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNiew != nil {

		// query param description__niew
		var qrDescriptionNiew string

		if o.DescriptionNiew != nil {
			qrDescriptionNiew = *o.DescriptionNiew
		}
		qDescriptionNiew := qrDescriptionNiew
		if qDescriptionNiew != "" {

			if err := r.SetQueryParam("description__niew", qDescriptionNiew); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNisw != nil {

		// query param description__nisw
		var qrDescriptionNisw string

		if o.DescriptionNisw != nil {
			qrDescriptionNisw = *o.DescriptionNisw
		}
		qDescriptionNisw := qrDescriptionNisw
		if qDescriptionNisw != "" {

			if err := r.SetQueryParam("description__nisw", qDescriptionNisw); err != nil {
				return err
			}
		}
	}

	if o.Facility != nil {

		// query param facility
		var qrFacility string

		if o.Facility != nil {
			qrFacility = *o.Facility
		}
		qFacility := qrFacility
		if qFacility != "" {

			if err := r.SetQueryParam("facility", qFacility); err != nil {
				return err
			}
		}
	}

	if o.FacilityIc != nil {

		// query param facility__ic
		var qrFacilityIc string

		if o.FacilityIc != nil {
			qrFacilityIc = *o.FacilityIc
		}
		qFacilityIc := qrFacilityIc
		if qFacilityIc != "" {

			if err := r.SetQueryParam("facility__ic", qFacilityIc); err != nil {
				return err
			}
		}
	}

	if o.FacilityIe != nil {

		// query param facility__ie
		var qrFacilityIe string

		if o.FacilityIe != nil {
			qrFacilityIe = *o.FacilityIe
		}
		qFacilityIe := qrFacilityIe
		if qFacilityIe != "" {

			if err := r.SetQueryParam("facility__ie", qFacilityIe); err != nil {
				return err
			}
		}
	}

	if o.FacilityIew != nil {

		// query param facility__iew
		var qrFacilityIew string

		if o.FacilityIew != nil {
			qrFacilityIew = *o.FacilityIew
		}
		qFacilityIew := qrFacilityIew
		if qFacilityIew != "" {

			if err := r.SetQueryParam("facility__iew", qFacilityIew); err != nil {
				return err
			}
		}
	}

	if o.FacilityIsw != nil {

		// query param facility__isw
		var qrFacilityIsw string

		if o.FacilityIsw != nil {
			qrFacilityIsw = *o.FacilityIsw
		}
		qFacilityIsw := qrFacilityIsw
		if qFacilityIsw != "" {

			if err := r.SetQueryParam("facility__isw", qFacilityIsw); err != nil {
				return err
			}
		}
	}

	if o.Facilityn != nil {

		// query param facility__n
		var qrFacilityn string

		if o.Facilityn != nil {
			qrFacilityn = *o.Facilityn
		}
		qFacilityn := qrFacilityn
		if qFacilityn != "" {

			if err := r.SetQueryParam("facility__n", qFacilityn); err != nil {
				return err
			}
		}
	}

	if o.FacilityNic != nil {

		// query param facility__nic
		var qrFacilityNic string

		if o.FacilityNic != nil {
			qrFacilityNic = *o.FacilityNic
		}
		qFacilityNic := qrFacilityNic
		if qFacilityNic != "" {

			if err := r.SetQueryParam("facility__nic", qFacilityNic); err != nil {
				return err
			}
		}
	}

	if o.FacilityNie != nil {

		// query param facility__nie
		var qrFacilityNie string

		if o.FacilityNie != nil {
			qrFacilityNie = *o.FacilityNie
		}
		qFacilityNie := qrFacilityNie
		if qFacilityNie != "" {

			if err := r.SetQueryParam("facility__nie", qFacilityNie); err != nil {
				return err
			}
		}
	}

	if o.FacilityNiew != nil {

		// query param facility__niew
		var qrFacilityNiew string

		if o.FacilityNiew != nil {
			qrFacilityNiew = *o.FacilityNiew
		}
		qFacilityNiew := qrFacilityNiew
		if qFacilityNiew != "" {

			if err := r.SetQueryParam("facility__niew", qFacilityNiew); err != nil {
				return err
			}
		}
	}

	if o.FacilityNisw != nil {

		// query param facility__nisw
		var qrFacilityNisw string

		if o.FacilityNisw != nil {
			qrFacilityNisw = *o.FacilityNisw
		}
		qFacilityNisw := qrFacilityNisw
		if qFacilityNisw != "" {

			if err := r.SetQueryParam("facility__nisw", qFacilityNisw); err != nil {
				return err
			}
		}
	}

	if o.Group != nil {

		// query param group
		var qrGroup string

		if o.Group != nil {
			qrGroup = *o.Group
		}
		qGroup := qrGroup
		if qGroup != "" {

			if err := r.SetQueryParam("group", qGroup); err != nil {
				return err
			}
		}
	}

	if o.Groupn != nil {

		// query param group__n
		var qrGroupn string

		if o.Groupn != nil {
			qrGroupn = *o.Groupn
		}
		qGroupn := qrGroupn
		if qGroupn != "" {

			if err := r.SetQueryParam("group__n", qGroupn); err != nil {
				return err
			}
		}
	}

	if o.GroupID != nil {

		// query param group_id
		var qrGroupID string

		if o.GroupID != nil {
			qrGroupID = *o.GroupID
		}
		qGroupID := qrGroupID
		if qGroupID != "" {

			if err := r.SetQueryParam("group_id", qGroupID); err != nil {
				return err
			}
		}
	}

	if o.GroupIDn != nil {

		// query param group_id__n
		var qrGroupIDn string

		if o.GroupIDn != nil {
			qrGroupIDn = *o.GroupIDn
		}
		qGroupIDn := qrGroupIDn
		if qGroupIDn != "" {

			if err := r.SetQueryParam("group_id__n", qGroupIDn); err != nil {
				return err
			}
		}
	}

	if o.ID != nil {

		// query param id
		var qrID string

		if o.ID != nil {
			qrID = *o.ID
		}
		qID := qrID
		if qID != "" {

			if err := r.SetQueryParam("id", qID); err != nil {
				return err
			}
		}
	}

	if o.IDGt != nil {

		// query param id__gt
		var qrIDGt string

		if o.IDGt != nil {
			qrIDGt = *o.IDGt
		}
		qIDGt := qrIDGt
		if qIDGt != "" {

			if err := r.SetQueryParam("id__gt", qIDGt); err != nil {
				return err
			}
		}
	}

	if o.IDGte != nil {

		// query param id__gte
		var qrIDGte string

		if o.IDGte != nil {
			qrIDGte = *o.IDGte
		}
		qIDGte := qrIDGte
		if qIDGte != "" {

			if err := r.SetQueryParam("id__gte", qIDGte); err != nil {
				return err
			}
		}
	}

	if o.IDLt != nil {

		// query param id__lt
		var qrIDLt string

		if o.IDLt != nil {
			qrIDLt = *o.IDLt
		}
		qIDLt := qrIDLt
		if qIDLt != "" {

			if err := r.SetQueryParam("id__lt", qIDLt); err != nil {
				return err
			}
		}
	}

	if o.IDLte != nil {

		// query param id__lte
		var qrIDLte string

		if o.IDLte != nil {
			qrIDLte = *o.IDLte
		}
		qIDLte := qrIDLte
		if qIDLte != "" {

			if err := r.SetQueryParam("id__lte", qIDLte); err != nil {
				return err
			}
		}
	}

	if o.IDn != nil {

		// query param id__n
		var qrIDn string

		if o.IDn != nil {
			qrIDn = *o.IDn
		}
		qIDn := qrIDn
		if qIDn != "" {

			if err := r.SetQueryParam("id__n", qIDn); err != nil {
				return err
			}
		}
	}

	if o.LastUpdated != nil {

		// query param last_updated
		var qrLastUpdated string

		if o.LastUpdated != nil {
			qrLastUpdated = *o.LastUpdated
		}
		qLastUpdated := qrLastUpdated
		if qLastUpdated != "" {

			if err := r.SetQueryParam("last_updated", qLastUpdated); err != nil {
				return err
			}
		}
	}

	if o.LastUpdatedGte != nil {

		// query param last_updated__gte
		var qrLastUpdatedGte string

		if o.LastUpdatedGte != nil {
			qrLastUpdatedGte = *o.LastUpdatedGte
		}
		qLastUpdatedGte := qrLastUpdatedGte
		if qLastUpdatedGte != "" {

			if err := r.SetQueryParam("last_updated__gte", qLastUpdatedGte); err != nil {
				return err
			}
		}
	}

	if o.LastUpdatedLte != nil {

		// query param last_updated__lte
		var qrLastUpdatedLte string

		if o.LastUpdatedLte != nil {
			qrLastUpdatedLte = *o.LastUpdatedLte
		}
		qLastUpdatedLte := qrLastUpdatedLte
		if qLastUpdatedLte != "" {

			if err := r.SetQueryParam("last_updated__lte", qLastUpdatedLte); err != nil {
				return err
			}
		}
	}

	if o.Latitude != nil {

		// query param latitude
		var qrLatitude string

		if o.Latitude != nil {
			qrLatitude = *o.Latitude
		}
		qLatitude := qrLatitude
		if qLatitude != "" {

			if err := r.SetQueryParam("latitude", qLatitude); err != nil {
				return err
			}
		}
	}

	if o.LatitudeGt != nil {

		// query param latitude__gt
		var qrLatitudeGt string

		if o.LatitudeGt != nil {
			qrLatitudeGt = *o.LatitudeGt
		}
		qLatitudeGt := qrLatitudeGt
		if qLatitudeGt != "" {

			if err := r.SetQueryParam("latitude__gt", qLatitudeGt); err != nil {
				return err
			}
		}
	}

	if o.LatitudeGte != nil {

		// query param latitude__gte
		var qrLatitudeGte string

		if o.LatitudeGte != nil {
			qrLatitudeGte = *o.LatitudeGte
		}
		qLatitudeGte := qrLatitudeGte
		if qLatitudeGte != "" {

			if err := r.SetQueryParam("latitude__gte", qLatitudeGte); err != nil {
				return err
			}
		}
	}

	if o.LatitudeLt != nil {

		// query param latitude__lt
		var qrLatitudeLt string

		if o.LatitudeLt != nil {
			qrLatitudeLt = *o.LatitudeLt
		}
		qLatitudeLt := qrLatitudeLt
		if qLatitudeLt != "" {

			if err := r.SetQueryParam("latitude__lt", qLatitudeLt); err != nil {
				return err
			}
		}
	}

	if o.LatitudeLte != nil {

		// query param latitude__lte
		var qrLatitudeLte string

		if o.LatitudeLte != nil {
			qrLatitudeLte = *o.LatitudeLte
		}
		qLatitudeLte := qrLatitudeLte
		if qLatitudeLte != "" {

			if err := r.SetQueryParam("latitude__lte", qLatitudeLte); err != nil {
				return err
			}
		}
	}

	if o.Latituden != nil {

		// query param latitude__n
		var qrLatituden string

		if o.Latituden != nil {
			qrLatituden = *o.Latituden
		}
		qLatituden := qrLatituden
		if qLatituden != "" {

			if err := r.SetQueryParam("latitude__n", qLatituden); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Longitude != nil {

		// query param longitude
		var qrLongitude string

		if o.Longitude != nil {
			qrLongitude = *o.Longitude
		}
		qLongitude := qrLongitude
		if qLongitude != "" {

			if err := r.SetQueryParam("longitude", qLongitude); err != nil {
				return err
			}
		}
	}

	if o.LongitudeGt != nil {

		// query param longitude__gt
		var qrLongitudeGt string

		if o.LongitudeGt != nil {
			qrLongitudeGt = *o.LongitudeGt
		}
		qLongitudeGt := qrLongitudeGt
		if qLongitudeGt != "" {

			if err := r.SetQueryParam("longitude__gt", qLongitudeGt); err != nil {
				return err
			}
		}
	}

	if o.LongitudeGte != nil {

		// query param longitude__gte
		var qrLongitudeGte string

		if o.LongitudeGte != nil {
			qrLongitudeGte = *o.LongitudeGte
		}
		qLongitudeGte := qrLongitudeGte
		if qLongitudeGte != "" {

			if err := r.SetQueryParam("longitude__gte", qLongitudeGte); err != nil {
				return err
			}
		}
	}

	if o.LongitudeLt != nil {

		// query param longitude__lt
		var qrLongitudeLt string

		if o.LongitudeLt != nil {
			qrLongitudeLt = *o.LongitudeLt
		}
		qLongitudeLt := qrLongitudeLt
		if qLongitudeLt != "" {

			if err := r.SetQueryParam("longitude__lt", qLongitudeLt); err != nil {
				return err
			}
		}
	}

	if o.LongitudeLte != nil {

		// query param longitude__lte
		var qrLongitudeLte string

		if o.LongitudeLte != nil {
			qrLongitudeLte = *o.LongitudeLte
		}
		qLongitudeLte := qrLongitudeLte
		if qLongitudeLte != "" {

			if err := r.SetQueryParam("longitude__lte", qLongitudeLte); err != nil {
				return err
			}
		}
	}

	if o.Longituden != nil {

		// query param longitude__n
		var qrLongituden string

		if o.Longituden != nil {
			qrLongituden = *o.Longituden
		}
		qLongituden := qrLongituden
		if qLongituden != "" {

			if err := r.SetQueryParam("longitude__n", qLongituden); err != nil {
				return err
			}
		}
	}

	if o.Name != nil {

		// query param name
		var qrName string

		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.NameIc != nil {

		// query param name__ic
		var qrNameIc string

		if o.NameIc != nil {
			qrNameIc = *o.NameIc
		}
		qNameIc := qrNameIc
		if qNameIc != "" {

			if err := r.SetQueryParam("name__ic", qNameIc); err != nil {
				return err
			}
		}
	}

	if o.NameIe != nil {

		// query param name__ie
		var qrNameIe string

		if o.NameIe != nil {
			qrNameIe = *o.NameIe
		}
		qNameIe := qrNameIe
		if qNameIe != "" {

			if err := r.SetQueryParam("name__ie", qNameIe); err != nil {
				return err
			}
		}
	}

	if o.NameIew != nil {

		// query param name__iew
		var qrNameIew string

		if o.NameIew != nil {
			qrNameIew = *o.NameIew
		}
		qNameIew := qrNameIew
		if qNameIew != "" {

			if err := r.SetQueryParam("name__iew", qNameIew); err != nil {
				return err
			}
		}
	}

	if o.NameIsw != nil {

		// query param name__isw
		var qrNameIsw string

		if o.NameIsw != nil {
			qrNameIsw = *o.NameIsw
		}
		qNameIsw := qrNameIsw
		if qNameIsw != "" {

			if err := r.SetQueryParam("name__isw", qNameIsw); err != nil {
				return err
			}
		}
	}

	if o.Namen != nil {

		// query param name__n
		var qrNamen string

		if o.Namen != nil {
			qrNamen = *o.Namen
		}
		qNamen := qrNamen
		if qNamen != "" {

			if err := r.SetQueryParam("name__n", qNamen); err != nil {
				return err
			}
		}
	}

	if o.NameNic != nil {

		// query param name__nic
		var qrNameNic string

		if o.NameNic != nil {
			qrNameNic = *o.NameNic
		}
		qNameNic := qrNameNic
		if qNameNic != "" {

			if err := r.SetQueryParam("name__nic", qNameNic); err != nil {
				return err
			}
		}
	}

	if o.NameNie != nil {

		// query param name__nie
		var qrNameNie string

		if o.NameNie != nil {
			qrNameNie = *o.NameNie
		}
		qNameNie := qrNameNie
		if qNameNie != "" {

			if err := r.SetQueryParam("name__nie", qNameNie); err != nil {
				return err
			}
		}
	}

	if o.NameNiew != nil {

		// query param name__niew
		var qrNameNiew string

		if o.NameNiew != nil {
			qrNameNiew = *o.NameNiew
		}
		qNameNiew := qrNameNiew
		if qNameNiew != "" {

			if err := r.SetQueryParam("name__niew", qNameNiew); err != nil {
				return err
			}
		}
	}

	if o.NameNisw != nil {

		// query param name__nisw
		var qrNameNisw string

		if o.NameNisw != nil {
			qrNameNisw = *o.NameNisw
		}
		qNameNisw := qrNameNisw
		if qNameNisw != "" {

			if err := r.SetQueryParam("name__nisw", qNameNisw); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if o.Q != nil {

		// query param q
		var qrQ string

		if o.Q != nil {
			qrQ = *o.Q
		}
		qQ := qrQ
		if qQ != "" {

			if err := r.SetQueryParam("q", qQ); err != nil {
				return err
			}
		}
	}

	if o.Region != nil {

		// query param region
		var qrRegion string

		if o.Region != nil {
			qrRegion = *o.Region
		}
		qRegion := qrRegion
		if qRegion != "" {

			if err := r.SetQueryParam("region", qRegion); err != nil {
				return err
			}
		}
	}

	if o.Regionn != nil {

		// query param region__n
		var qrRegionn string

		if o.Regionn != nil {
			qrRegionn = *o.Regionn
		}
		qRegionn := qrRegionn
		if qRegionn != "" {

			if err := r.SetQueryParam("region__n", qRegionn); err != nil {
				return err
			}
		}
	}

	if o.RegionID != nil {

		// query param region_id
		var qrRegionID string

		if o.RegionID != nil {
			qrRegionID = *o.RegionID
		}
		qRegionID := qrRegionID
		if qRegionID != "" {

			if err := r.SetQueryParam("region_id", qRegionID); err != nil {
				return err
			}
		}
	}

	if o.RegionIDn != nil {

		// query param region_id__n
		var qrRegionIDn string

		if o.RegionIDn != nil {
			qrRegionIDn = *o.RegionIDn
		}
		qRegionIDn := qrRegionIDn
		if qRegionIDn != "" {

			if err := r.SetQueryParam("region_id__n", qRegionIDn); err != nil {
				return err
			}
		}
	}

	if o.Slug != nil {

		// query param slug
		var qrSlug string

		if o.Slug != nil {
			qrSlug = *o.Slug
		}
		qSlug := qrSlug
		if qSlug != "" {

			if err := r.SetQueryParam("slug", qSlug); err != nil {
				return err
			}
		}
	}

	if o.SlugIc != nil {

		// query param slug__ic
		var qrSlugIc string

		if o.SlugIc != nil {
			qrSlugIc = *o.SlugIc
		}
		qSlugIc := qrSlugIc
		if qSlugIc != "" {

			if err := r.SetQueryParam("slug__ic", qSlugIc); err != nil {
				return err
			}
		}
	}

	if o.SlugIe != nil {

		// query param slug__ie
		var qrSlugIe string

		if o.SlugIe != nil {
			qrSlugIe = *o.SlugIe
		}
		qSlugIe := qrSlugIe
		if qSlugIe != "" {

			if err := r.SetQueryParam("slug__ie", qSlugIe); err != nil {
				return err
			}
		}
	}

	if o.SlugIew != nil {

		// query param slug__iew
		var qrSlugIew string

		if o.SlugIew != nil {
			qrSlugIew = *o.SlugIew
		}
		qSlugIew := qrSlugIew
		if qSlugIew != "" {

			if err := r.SetQueryParam("slug__iew", qSlugIew); err != nil {
				return err
			}
		}
	}

	if o.SlugIsw != nil {

		// query param slug__isw
		var qrSlugIsw string

		if o.SlugIsw != nil {
			qrSlugIsw = *o.SlugIsw
		}
		qSlugIsw := qrSlugIsw
		if qSlugIsw != "" {

			if err := r.SetQueryParam("slug__isw", qSlugIsw); err != nil {
				return err
			}
		}
	}

	if o.Slugn != nil {

		// query param slug__n
		var qrSlugn string

		if o.Slugn != nil {
			qrSlugn = *o.Slugn
		}
		qSlugn := qrSlugn
		if qSlugn != "" {

			if err := r.SetQueryParam("slug__n", qSlugn); err != nil {
				return err
			}
		}
	}

	if o.SlugNic != nil {

		// query param slug__nic
		var qrSlugNic string

		if o.SlugNic != nil {
			qrSlugNic = *o.SlugNic
		}
		qSlugNic := qrSlugNic
		if qSlugNic != "" {

			if err := r.SetQueryParam("slug__nic", qSlugNic); err != nil {
				return err
			}
		}
	}

	if o.SlugNie != nil {

		// query param slug__nie
		var qrSlugNie string

		if o.SlugNie != nil {
			qrSlugNie = *o.SlugNie
		}
		qSlugNie := qrSlugNie
		if qSlugNie != "" {

			if err := r.SetQueryParam("slug__nie", qSlugNie); err != nil {
				return err
			}
		}
	}

	if o.SlugNiew != nil {

		// query param slug__niew
		var qrSlugNiew string

		if o.SlugNiew != nil {
			qrSlugNiew = *o.SlugNiew
		}
		qSlugNiew := qrSlugNiew
		if qSlugNiew != "" {

			if err := r.SetQueryParam("slug__niew", qSlugNiew); err != nil {
				return err
			}
		}
	}

	if o.SlugNisw != nil {

		// query param slug__nisw
		var qrSlugNisw string

		if o.SlugNisw != nil {
			qrSlugNisw = *o.SlugNisw
		}
		qSlugNisw := qrSlugNisw
		if qSlugNisw != "" {

			if err := r.SetQueryParam("slug__nisw", qSlugNisw); err != nil {
				return err
			}
		}
	}

	if o.Status != nil {

		// query param status
		var qrStatus string

		if o.Status != nil {
			qrStatus = *o.Status
		}
		qStatus := qrStatus
		if qStatus != "" {

			if err := r.SetQueryParam("status", qStatus); err != nil {
				return err
			}
		}
	}

	if o.Statusn != nil {

		// query param status__n
		var qrStatusn string

		if o.Statusn != nil {
			qrStatusn = *o.Statusn
		}
		qStatusn := qrStatusn
		if qStatusn != "" {

			if err := r.SetQueryParam("status__n", qStatusn); err != nil {
				return err
			}
		}
	}

	if o.Tag != nil {

		// query param tag
		var qrTag string

		if o.Tag != nil {
			qrTag = *o.Tag
		}
		qTag := qrTag
		if qTag != "" {

			if err := r.SetQueryParam("tag", qTag); err != nil {
				return err
			}
		}
	}

	if o.Tagn != nil {

		// query param tag__n
		var qrTagn string

		if o.Tagn != nil {
			qrTagn = *o.Tagn
		}
		qTagn := qrTagn
		if qTagn != "" {

			if err := r.SetQueryParam("tag__n", qTagn); err != nil {
				return err
			}
		}
	}

	if o.Tenant != nil {

		// query param tenant
		var qrTenant string

		if o.Tenant != nil {
			qrTenant = *o.Tenant
		}
		qTenant := qrTenant
		if qTenant != "" {

			if err := r.SetQueryParam("tenant", qTenant); err != nil {
				return err
			}
		}
	}

	if o.Tenantn != nil {

		// query param tenant__n
		var qrTenantn string

		if o.Tenantn != nil {
			qrTenantn = *o.Tenantn
		}
		qTenantn := qrTenantn
		if qTenantn != "" {

			if err := r.SetQueryParam("tenant__n", qTenantn); err != nil {
				return err
			}
		}
	}

	if o.TenantGroup != nil {

		// query param tenant_group
		var qrTenantGroup string

		if o.TenantGroup != nil {
			qrTenantGroup = *o.TenantGroup
		}
		qTenantGroup := qrTenantGroup
		if qTenantGroup != "" {

			if err := r.SetQueryParam("tenant_group", qTenantGroup); err != nil {
				return err
			}
		}
	}

	if o.TenantGroupn != nil {

		// query param tenant_group__n
		var qrTenantGroupn string

		if o.TenantGroupn != nil {
			qrTenantGroupn = *o.TenantGroupn
		}
		qTenantGroupn := qrTenantGroupn
		if qTenantGroupn != "" {

			if err := r.SetQueryParam("tenant_group__n", qTenantGroupn); err != nil {
				return err
			}
		}
	}

	if o.TenantGroupID != nil {

		// query param tenant_group_id
		var qrTenantGroupID string

		if o.TenantGroupID != nil {
			qrTenantGroupID = *o.TenantGroupID
		}
		qTenantGroupID := qrTenantGroupID
		if qTenantGroupID != "" {

			if err := r.SetQueryParam("tenant_group_id", qTenantGroupID); err != nil {
				return err
			}
		}
	}

	if o.TenantGroupIDn != nil {

		// query param tenant_group_id__n
		var qrTenantGroupIDn string

		if o.TenantGroupIDn != nil {
			qrTenantGroupIDn = *o.TenantGroupIDn
		}
		qTenantGroupIDn := qrTenantGroupIDn
		if qTenantGroupIDn != "" {

			if err := r.SetQueryParam("tenant_group_id__n", qTenantGroupIDn); err != nil {
				return err
			}
		}
	}

	if o.TenantID != nil {

		// query param tenant_id
		var qrTenantID string

		if o.TenantID != nil {
			qrTenantID = *o.TenantID
		}
		qTenantID := qrTenantID
		if qTenantID != "" {

			if err := r.SetQueryParam("tenant_id", qTenantID); err != nil {
				return err
			}
		}
	}

	if o.TenantIDn != nil {

		// query param tenant_id__n
		var qrTenantIDn string

		if o.TenantIDn != nil {
			qrTenantIDn = *o.TenantIDn
		}
		qTenantIDn := qrTenantIDn
		if qTenantIDn != "" {

			if err := r.SetQueryParam("tenant_id__n", qTenantIDn); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
