// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2020 The go-netbox Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package extras

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewExtrasCustomFieldsListParams creates a new ExtrasCustomFieldsListParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewExtrasCustomFieldsListParams() *ExtrasCustomFieldsListParams {
	return &ExtrasCustomFieldsListParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewExtrasCustomFieldsListParamsWithTimeout creates a new ExtrasCustomFieldsListParams object
// with the ability to set a timeout on a request.
func NewExtrasCustomFieldsListParamsWithTimeout(timeout time.Duration) *ExtrasCustomFieldsListParams {
	return &ExtrasCustomFieldsListParams{
		timeout: timeout,
	}
}

// NewExtrasCustomFieldsListParamsWithContext creates a new ExtrasCustomFieldsListParams object
// with the ability to set a context for a request.
func NewExtrasCustomFieldsListParamsWithContext(ctx context.Context) *ExtrasCustomFieldsListParams {
	return &ExtrasCustomFieldsListParams{
		Context: ctx,
	}
}

// NewExtrasCustomFieldsListParamsWithHTTPClient creates a new ExtrasCustomFieldsListParams object
// with the ability to set a custom HTTPClient for a request.
func NewExtrasCustomFieldsListParamsWithHTTPClient(client *http.Client) *ExtrasCustomFieldsListParams {
	return &ExtrasCustomFieldsListParams{
		HTTPClient: client,
	}
}

/* ExtrasCustomFieldsListParams contains all the parameters to send to the API endpoint
   for the extras custom fields list operation.

   Typically these are written to a http.Request.
*/
type ExtrasCustomFieldsListParams struct {

	// ContentTypes.
	ContentTypes *string

	// ContentTypesIc.
	ContentTypesIc *string

	// ContentTypesIe.
	ContentTypesIe *string

	// ContentTypesIew.
	ContentTypesIew *string

	// ContentTypesIsw.
	ContentTypesIsw *string

	// ContentTypesn.
	ContentTypesn *string

	// ContentTypesNic.
	ContentTypesNic *string

	// ContentTypesNie.
	ContentTypesNie *string

	// ContentTypesNiew.
	ContentTypesNiew *string

	// ContentTypesNisw.
	ContentTypesNisw *string

	// Description.
	Description *string

	// DescriptionIc.
	DescriptionIc *string

	// DescriptionIe.
	DescriptionIe *string

	// DescriptionIew.
	DescriptionIew *string

	// DescriptionIsw.
	DescriptionIsw *string

	// Descriptionn.
	Descriptionn *string

	// DescriptionNic.
	DescriptionNic *string

	// DescriptionNie.
	DescriptionNie *string

	// DescriptionNiew.
	DescriptionNiew *string

	// DescriptionNisw.
	DescriptionNisw *string

	// FilterLogic.
	FilterLogic *string

	// FilterLogicn.
	FilterLogicn *string

	// ID.
	ID *string

	// IDGt.
	IDGt *string

	// IDGte.
	IDGte *string

	// IDLt.
	IDLt *string

	// IDLte.
	IDLte *string

	// IDn.
	IDn *string

	/* Limit.

	   Number of results to return per page.
	*/
	Limit *int64

	// Name.
	Name *string

	// NameIc.
	NameIc *string

	// NameIe.
	NameIe *string

	// NameIew.
	NameIew *string

	// NameIsw.
	NameIsw *string

	// Namen.
	Namen *string

	// NameNic.
	NameNic *string

	// NameNie.
	NameNie *string

	// NameNiew.
	NameNiew *string

	// NameNisw.
	NameNisw *string

	/* Offset.

	   The initial index from which to return the results.
	*/
	Offset *int64

	// Q.
	Q *string

	// Required.
	Required *string

	// Weight.
	Weight *string

	// WeightGt.
	WeightGt *string

	// WeightGte.
	WeightGte *string

	// WeightLt.
	WeightLt *string

	// WeightLte.
	WeightLte *string

	// Weightn.
	Weightn *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the extras custom fields list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ExtrasCustomFieldsListParams) WithDefaults() *ExtrasCustomFieldsListParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the extras custom fields list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ExtrasCustomFieldsListParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithTimeout(timeout time.Duration) *ExtrasCustomFieldsListParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithContext(ctx context.Context) *ExtrasCustomFieldsListParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithHTTPClient(client *http.Client) *ExtrasCustomFieldsListParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithContentTypes adds the contentTypes to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithContentTypes(contentTypes *string) *ExtrasCustomFieldsListParams {
	o.SetContentTypes(contentTypes)
	return o
}

// SetContentTypes adds the contentTypes to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetContentTypes(contentTypes *string) {
	o.ContentTypes = contentTypes
}

// WithContentTypesIc adds the contentTypesIc to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithContentTypesIc(contentTypesIc *string) *ExtrasCustomFieldsListParams {
	o.SetContentTypesIc(contentTypesIc)
	return o
}

// SetContentTypesIc adds the contentTypesIc to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetContentTypesIc(contentTypesIc *string) {
	o.ContentTypesIc = contentTypesIc
}

// WithContentTypesIe adds the contentTypesIe to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithContentTypesIe(contentTypesIe *string) *ExtrasCustomFieldsListParams {
	o.SetContentTypesIe(contentTypesIe)
	return o
}

// SetContentTypesIe adds the contentTypesIe to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetContentTypesIe(contentTypesIe *string) {
	o.ContentTypesIe = contentTypesIe
}

// WithContentTypesIew adds the contentTypesIew to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithContentTypesIew(contentTypesIew *string) *ExtrasCustomFieldsListParams {
	o.SetContentTypesIew(contentTypesIew)
	return o
}

// SetContentTypesIew adds the contentTypesIew to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetContentTypesIew(contentTypesIew *string) {
	o.ContentTypesIew = contentTypesIew
}

// WithContentTypesIsw adds the contentTypesIsw to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithContentTypesIsw(contentTypesIsw *string) *ExtrasCustomFieldsListParams {
	o.SetContentTypesIsw(contentTypesIsw)
	return o
}

// SetContentTypesIsw adds the contentTypesIsw to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetContentTypesIsw(contentTypesIsw *string) {
	o.ContentTypesIsw = contentTypesIsw
}

// WithContentTypesn adds the contentTypesn to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithContentTypesn(contentTypesn *string) *ExtrasCustomFieldsListParams {
	o.SetContentTypesn(contentTypesn)
	return o
}

// SetContentTypesn adds the contentTypesN to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetContentTypesn(contentTypesn *string) {
	o.ContentTypesn = contentTypesn
}

// WithContentTypesNic adds the contentTypesNic to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithContentTypesNic(contentTypesNic *string) *ExtrasCustomFieldsListParams {
	o.SetContentTypesNic(contentTypesNic)
	return o
}

// SetContentTypesNic adds the contentTypesNic to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetContentTypesNic(contentTypesNic *string) {
	o.ContentTypesNic = contentTypesNic
}

// WithContentTypesNie adds the contentTypesNie to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithContentTypesNie(contentTypesNie *string) *ExtrasCustomFieldsListParams {
	o.SetContentTypesNie(contentTypesNie)
	return o
}

// SetContentTypesNie adds the contentTypesNie to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetContentTypesNie(contentTypesNie *string) {
	o.ContentTypesNie = contentTypesNie
}

// WithContentTypesNiew adds the contentTypesNiew to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithContentTypesNiew(contentTypesNiew *string) *ExtrasCustomFieldsListParams {
	o.SetContentTypesNiew(contentTypesNiew)
	return o
}

// SetContentTypesNiew adds the contentTypesNiew to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetContentTypesNiew(contentTypesNiew *string) {
	o.ContentTypesNiew = contentTypesNiew
}

// WithContentTypesNisw adds the contentTypesNisw to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithContentTypesNisw(contentTypesNisw *string) *ExtrasCustomFieldsListParams {
	o.SetContentTypesNisw(contentTypesNisw)
	return o
}

// SetContentTypesNisw adds the contentTypesNisw to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetContentTypesNisw(contentTypesNisw *string) {
	o.ContentTypesNisw = contentTypesNisw
}

// WithDescription adds the description to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithDescription(description *string) *ExtrasCustomFieldsListParams {
	o.SetDescription(description)
	return o
}

// SetDescription adds the description to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetDescription(description *string) {
	o.Description = description
}

// WithDescriptionIc adds the descriptionIc to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithDescriptionIc(descriptionIc *string) *ExtrasCustomFieldsListParams {
	o.SetDescriptionIc(descriptionIc)
	return o
}

// SetDescriptionIc adds the descriptionIc to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetDescriptionIc(descriptionIc *string) {
	o.DescriptionIc = descriptionIc
}

// WithDescriptionIe adds the descriptionIe to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithDescriptionIe(descriptionIe *string) *ExtrasCustomFieldsListParams {
	o.SetDescriptionIe(descriptionIe)
	return o
}

// SetDescriptionIe adds the descriptionIe to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetDescriptionIe(descriptionIe *string) {
	o.DescriptionIe = descriptionIe
}

// WithDescriptionIew adds the descriptionIew to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithDescriptionIew(descriptionIew *string) *ExtrasCustomFieldsListParams {
	o.SetDescriptionIew(descriptionIew)
	return o
}

// SetDescriptionIew adds the descriptionIew to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetDescriptionIew(descriptionIew *string) {
	o.DescriptionIew = descriptionIew
}

// WithDescriptionIsw adds the descriptionIsw to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithDescriptionIsw(descriptionIsw *string) *ExtrasCustomFieldsListParams {
	o.SetDescriptionIsw(descriptionIsw)
	return o
}

// SetDescriptionIsw adds the descriptionIsw to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetDescriptionIsw(descriptionIsw *string) {
	o.DescriptionIsw = descriptionIsw
}

// WithDescriptionn adds the descriptionn to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithDescriptionn(descriptionn *string) *ExtrasCustomFieldsListParams {
	o.SetDescriptionn(descriptionn)
	return o
}

// SetDescriptionn adds the descriptionN to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetDescriptionn(descriptionn *string) {
	o.Descriptionn = descriptionn
}

// WithDescriptionNic adds the descriptionNic to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithDescriptionNic(descriptionNic *string) *ExtrasCustomFieldsListParams {
	o.SetDescriptionNic(descriptionNic)
	return o
}

// SetDescriptionNic adds the descriptionNic to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetDescriptionNic(descriptionNic *string) {
	o.DescriptionNic = descriptionNic
}

// WithDescriptionNie adds the descriptionNie to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithDescriptionNie(descriptionNie *string) *ExtrasCustomFieldsListParams {
	o.SetDescriptionNie(descriptionNie)
	return o
}

// SetDescriptionNie adds the descriptionNie to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetDescriptionNie(descriptionNie *string) {
	o.DescriptionNie = descriptionNie
}

// WithDescriptionNiew adds the descriptionNiew to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithDescriptionNiew(descriptionNiew *string) *ExtrasCustomFieldsListParams {
	o.SetDescriptionNiew(descriptionNiew)
	return o
}

// SetDescriptionNiew adds the descriptionNiew to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetDescriptionNiew(descriptionNiew *string) {
	o.DescriptionNiew = descriptionNiew
}

// WithDescriptionNisw adds the descriptionNisw to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithDescriptionNisw(descriptionNisw *string) *ExtrasCustomFieldsListParams {
	o.SetDescriptionNisw(descriptionNisw)
	return o
}

// SetDescriptionNisw adds the descriptionNisw to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetDescriptionNisw(descriptionNisw *string) {
	o.DescriptionNisw = descriptionNisw
}

// WithFilterLogic adds the filterLogic to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithFilterLogic(filterLogic *string) *ExtrasCustomFieldsListParams {
	o.SetFilterLogic(filterLogic)
	return o
}

// SetFilterLogic adds the filterLogic to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetFilterLogic(filterLogic *string) {
	o.FilterLogic = filterLogic
}

// WithFilterLogicn adds the filterLogicn to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithFilterLogicn(filterLogicn *string) *ExtrasCustomFieldsListParams {
	o.SetFilterLogicn(filterLogicn)
	return o
}

// SetFilterLogicn adds the filterLogicN to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetFilterLogicn(filterLogicn *string) {
	o.FilterLogicn = filterLogicn
}

// WithID adds the id to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithID(id *string) *ExtrasCustomFieldsListParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetID(id *string) {
	o.ID = id
}

// WithIDGt adds the iDGt to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithIDGt(iDGt *string) *ExtrasCustomFieldsListParams {
	o.SetIDGt(iDGt)
	return o
}

// SetIDGt adds the idGt to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetIDGt(iDGt *string) {
	o.IDGt = iDGt
}

// WithIDGte adds the iDGte to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithIDGte(iDGte *string) *ExtrasCustomFieldsListParams {
	o.SetIDGte(iDGte)
	return o
}

// SetIDGte adds the idGte to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetIDGte(iDGte *string) {
	o.IDGte = iDGte
}

// WithIDLt adds the iDLt to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithIDLt(iDLt *string) *ExtrasCustomFieldsListParams {
	o.SetIDLt(iDLt)
	return o
}

// SetIDLt adds the idLt to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetIDLt(iDLt *string) {
	o.IDLt = iDLt
}

// WithIDLte adds the iDLte to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithIDLte(iDLte *string) *ExtrasCustomFieldsListParams {
	o.SetIDLte(iDLte)
	return o
}

// SetIDLte adds the idLte to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetIDLte(iDLte *string) {
	o.IDLte = iDLte
}

// WithIDn adds the iDn to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithIDn(iDn *string) *ExtrasCustomFieldsListParams {
	o.SetIDn(iDn)
	return o
}

// SetIDn adds the idN to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetIDn(iDn *string) {
	o.IDn = iDn
}

// WithLimit adds the limit to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithLimit(limit *int64) *ExtrasCustomFieldsListParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithName adds the name to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithName(name *string) *ExtrasCustomFieldsListParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetName(name *string) {
	o.Name = name
}

// WithNameIc adds the nameIc to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithNameIc(nameIc *string) *ExtrasCustomFieldsListParams {
	o.SetNameIc(nameIc)
	return o
}

// SetNameIc adds the nameIc to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetNameIc(nameIc *string) {
	o.NameIc = nameIc
}

// WithNameIe adds the nameIe to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithNameIe(nameIe *string) *ExtrasCustomFieldsListParams {
	o.SetNameIe(nameIe)
	return o
}

// SetNameIe adds the nameIe to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetNameIe(nameIe *string) {
	o.NameIe = nameIe
}

// WithNameIew adds the nameIew to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithNameIew(nameIew *string) *ExtrasCustomFieldsListParams {
	o.SetNameIew(nameIew)
	return o
}

// SetNameIew adds the nameIew to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetNameIew(nameIew *string) {
	o.NameIew = nameIew
}

// WithNameIsw adds the nameIsw to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithNameIsw(nameIsw *string) *ExtrasCustomFieldsListParams {
	o.SetNameIsw(nameIsw)
	return o
}

// SetNameIsw adds the nameIsw to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetNameIsw(nameIsw *string) {
	o.NameIsw = nameIsw
}

// WithNamen adds the namen to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithNamen(namen *string) *ExtrasCustomFieldsListParams {
	o.SetNamen(namen)
	return o
}

// SetNamen adds the nameN to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetNamen(namen *string) {
	o.Namen = namen
}

// WithNameNic adds the nameNic to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithNameNic(nameNic *string) *ExtrasCustomFieldsListParams {
	o.SetNameNic(nameNic)
	return o
}

// SetNameNic adds the nameNic to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetNameNic(nameNic *string) {
	o.NameNic = nameNic
}

// WithNameNie adds the nameNie to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithNameNie(nameNie *string) *ExtrasCustomFieldsListParams {
	o.SetNameNie(nameNie)
	return o
}

// SetNameNie adds the nameNie to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetNameNie(nameNie *string) {
	o.NameNie = nameNie
}

// WithNameNiew adds the nameNiew to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithNameNiew(nameNiew *string) *ExtrasCustomFieldsListParams {
	o.SetNameNiew(nameNiew)
	return o
}

// SetNameNiew adds the nameNiew to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetNameNiew(nameNiew *string) {
	o.NameNiew = nameNiew
}

// WithNameNisw adds the nameNisw to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithNameNisw(nameNisw *string) *ExtrasCustomFieldsListParams {
	o.SetNameNisw(nameNisw)
	return o
}

// SetNameNisw adds the nameNisw to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetNameNisw(nameNisw *string) {
	o.NameNisw = nameNisw
}

// WithOffset adds the offset to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithOffset(offset *int64) *ExtrasCustomFieldsListParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithQ adds the q to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithQ(q *string) *ExtrasCustomFieldsListParams {
	o.SetQ(q)
	return o
}

// SetQ adds the q to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetQ(q *string) {
	o.Q = q
}

// WithRequired adds the required to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithRequired(required *string) *ExtrasCustomFieldsListParams {
	o.SetRequired(required)
	return o
}

// SetRequired adds the required to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetRequired(required *string) {
	o.Required = required
}

// WithWeight adds the weight to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithWeight(weight *string) *ExtrasCustomFieldsListParams {
	o.SetWeight(weight)
	return o
}

// SetWeight adds the weight to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetWeight(weight *string) {
	o.Weight = weight
}

// WithWeightGt adds the weightGt to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithWeightGt(weightGt *string) *ExtrasCustomFieldsListParams {
	o.SetWeightGt(weightGt)
	return o
}

// SetWeightGt adds the weightGt to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetWeightGt(weightGt *string) {
	o.WeightGt = weightGt
}

// WithWeightGte adds the weightGte to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithWeightGte(weightGte *string) *ExtrasCustomFieldsListParams {
	o.SetWeightGte(weightGte)
	return o
}

// SetWeightGte adds the weightGte to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetWeightGte(weightGte *string) {
	o.WeightGte = weightGte
}

// WithWeightLt adds the weightLt to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithWeightLt(weightLt *string) *ExtrasCustomFieldsListParams {
	o.SetWeightLt(weightLt)
	return o
}

// SetWeightLt adds the weightLt to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetWeightLt(weightLt *string) {
	o.WeightLt = weightLt
}

// WithWeightLte adds the weightLte to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithWeightLte(weightLte *string) *ExtrasCustomFieldsListParams {
	o.SetWeightLte(weightLte)
	return o
}

// SetWeightLte adds the weightLte to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetWeightLte(weightLte *string) {
	o.WeightLte = weightLte
}

// WithWeightn adds the weightn to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) WithWeightn(weightn *string) *ExtrasCustomFieldsListParams {
	o.SetWeightn(weightn)
	return o
}

// SetWeightn adds the weightN to the extras custom fields list params
func (o *ExtrasCustomFieldsListParams) SetWeightn(weightn *string) {
	o.Weightn = weightn
}

// WriteToRequest writes these params to a swagger request
func (o *ExtrasCustomFieldsListParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.ContentTypes != nil {

		// query param content_types
		var qrContentTypes string

		if o.ContentTypes != nil {
			qrContentTypes = *o.ContentTypes
		}
		qContentTypes := qrContentTypes
		if qContentTypes != "" {

			if err := r.SetQueryParam("content_types", qContentTypes); err != nil {
				return err
			}
		}
	}

	if o.ContentTypesIc != nil {

		// query param content_types__ic
		var qrContentTypesIc string

		if o.ContentTypesIc != nil {
			qrContentTypesIc = *o.ContentTypesIc
		}
		qContentTypesIc := qrContentTypesIc
		if qContentTypesIc != "" {

			if err := r.SetQueryParam("content_types__ic", qContentTypesIc); err != nil {
				return err
			}
		}
	}

	if o.ContentTypesIe != nil {

		// query param content_types__ie
		var qrContentTypesIe string

		if o.ContentTypesIe != nil {
			qrContentTypesIe = *o.ContentTypesIe
		}
		qContentTypesIe := qrContentTypesIe
		if qContentTypesIe != "" {

			if err := r.SetQueryParam("content_types__ie", qContentTypesIe); err != nil {
				return err
			}
		}
	}

	if o.ContentTypesIew != nil {

		// query param content_types__iew
		var qrContentTypesIew string

		if o.ContentTypesIew != nil {
			qrContentTypesIew = *o.ContentTypesIew
		}
		qContentTypesIew := qrContentTypesIew
		if qContentTypesIew != "" {

			if err := r.SetQueryParam("content_types__iew", qContentTypesIew); err != nil {
				return err
			}
		}
	}

	if o.ContentTypesIsw != nil {

		// query param content_types__isw
		var qrContentTypesIsw string

		if o.ContentTypesIsw != nil {
			qrContentTypesIsw = *o.ContentTypesIsw
		}
		qContentTypesIsw := qrContentTypesIsw
		if qContentTypesIsw != "" {

			if err := r.SetQueryParam("content_types__isw", qContentTypesIsw); err != nil {
				return err
			}
		}
	}

	if o.ContentTypesn != nil {

		// query param content_types__n
		var qrContentTypesn string

		if o.ContentTypesn != nil {
			qrContentTypesn = *o.ContentTypesn
		}
		qContentTypesn := qrContentTypesn
		if qContentTypesn != "" {

			if err := r.SetQueryParam("content_types__n", qContentTypesn); err != nil {
				return err
			}
		}
	}

	if o.ContentTypesNic != nil {

		// query param content_types__nic
		var qrContentTypesNic string

		if o.ContentTypesNic != nil {
			qrContentTypesNic = *o.ContentTypesNic
		}
		qContentTypesNic := qrContentTypesNic
		if qContentTypesNic != "" {

			if err := r.SetQueryParam("content_types__nic", qContentTypesNic); err != nil {
				return err
			}
		}
	}

	if o.ContentTypesNie != nil {

		// query param content_types__nie
		var qrContentTypesNie string

		if o.ContentTypesNie != nil {
			qrContentTypesNie = *o.ContentTypesNie
		}
		qContentTypesNie := qrContentTypesNie
		if qContentTypesNie != "" {

			if err := r.SetQueryParam("content_types__nie", qContentTypesNie); err != nil {
				return err
			}
		}
	}

	if o.ContentTypesNiew != nil {

		// query param content_types__niew
		var qrContentTypesNiew string

		if o.ContentTypesNiew != nil {
			qrContentTypesNiew = *o.ContentTypesNiew
		}
		qContentTypesNiew := qrContentTypesNiew
		if qContentTypesNiew != "" {

			if err := r.SetQueryParam("content_types__niew", qContentTypesNiew); err != nil {
				return err
			}
		}
	}

	if o.ContentTypesNisw != nil {

		// query param content_types__nisw
		var qrContentTypesNisw string

		if o.ContentTypesNisw != nil {
			qrContentTypesNisw = *o.ContentTypesNisw
		}
		qContentTypesNisw := qrContentTypesNisw
		if qContentTypesNisw != "" {

			if err := r.SetQueryParam("content_types__nisw", qContentTypesNisw); err != nil {
				return err
			}
		}
	}

	if o.Description != nil {

		// query param description
		var qrDescription string

		if o.Description != nil {
			qrDescription = *o.Description
		}
		qDescription := qrDescription
		if qDescription != "" {

			if err := r.SetQueryParam("description", qDescription); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIc != nil {

		// query param description__ic
		var qrDescriptionIc string

		if o.DescriptionIc != nil {
			qrDescriptionIc = *o.DescriptionIc
		}
		qDescriptionIc := qrDescriptionIc
		if qDescriptionIc != "" {

			if err := r.SetQueryParam("description__ic", qDescriptionIc); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIe != nil {

		// query param description__ie
		var qrDescriptionIe string

		if o.DescriptionIe != nil {
			qrDescriptionIe = *o.DescriptionIe
		}
		qDescriptionIe := qrDescriptionIe
		if qDescriptionIe != "" {

			if err := r.SetQueryParam("description__ie", qDescriptionIe); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIew != nil {

		// query param description__iew
		var qrDescriptionIew string

		if o.DescriptionIew != nil {
			qrDescriptionIew = *o.DescriptionIew
		}
		qDescriptionIew := qrDescriptionIew
		if qDescriptionIew != "" {

			if err := r.SetQueryParam("description__iew", qDescriptionIew); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIsw != nil {

		// query param description__isw
		var qrDescriptionIsw string

		if o.DescriptionIsw != nil {
			qrDescriptionIsw = *o.DescriptionIsw
		}
		qDescriptionIsw := qrDescriptionIsw
		if qDescriptionIsw != "" {

			if err := r.SetQueryParam("description__isw", qDescriptionIsw); err != nil {
				return err
			}
		}
	}

	if o.Descriptionn != nil {

		// query param description__n
		var qrDescriptionn string

		if o.Descriptionn != nil {
			qrDescriptionn = *o.Descriptionn
		}
		qDescriptionn := qrDescriptionn
		if qDescriptionn != "" {

			if err := r.SetQueryParam("description__n", qDescriptionn); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNic != nil {

		// query param description__nic
		var qrDescriptionNic string

		if o.DescriptionNic != nil {
			qrDescriptionNic = *o.DescriptionNic
		}
		qDescriptionNic := qrDescriptionNic
		if qDescriptionNic != "" {

			if err := r.SetQueryParam("description__nic", qDescriptionNic); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNie != nil {

		// query param description__nie
		var qrDescriptionNie string

		if o.DescriptionNie != nil {
			qrDescriptionNie = *o.DescriptionNie
		}
		qDescriptionNie := qrDescriptionNie
		if qDescriptionNie != "" {

			if err := r.SetQueryParam("description__nie", qDescriptionNie); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNiew != nil {

		// query param description__niew
		var qrDescriptionNiew string

		if o.DescriptionNiew != nil {
			qrDescriptionNiew = *o.DescriptionNiew
		}
		qDescriptionNiew := qrDescriptionNiew
		if qDescriptionNiew != "" {

			if err := r.SetQueryParam("description__niew", qDescriptionNiew); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNisw != nil {

		// query param description__nisw
		var qrDescriptionNisw string

		if o.DescriptionNisw != nil {
			qrDescriptionNisw = *o.DescriptionNisw
		}
		qDescriptionNisw := qrDescriptionNisw
		if qDescriptionNisw != "" {

			if err := r.SetQueryParam("description__nisw", qDescriptionNisw); err != nil {
				return err
			}
		}
	}

	if o.FilterLogic != nil {

		// query param filter_logic
		var qrFilterLogic string

		if o.FilterLogic != nil {
			qrFilterLogic = *o.FilterLogic
		}
		qFilterLogic := qrFilterLogic
		if qFilterLogic != "" {

			if err := r.SetQueryParam("filter_logic", qFilterLogic); err != nil {
				return err
			}
		}
	}

	if o.FilterLogicn != nil {

		// query param filter_logic__n
		var qrFilterLogicn string

		if o.FilterLogicn != nil {
			qrFilterLogicn = *o.FilterLogicn
		}
		qFilterLogicn := qrFilterLogicn
		if qFilterLogicn != "" {

			if err := r.SetQueryParam("filter_logic__n", qFilterLogicn); err != nil {
				return err
			}
		}
	}

	if o.ID != nil {

		// query param id
		var qrID string

		if o.ID != nil {
			qrID = *o.ID
		}
		qID := qrID
		if qID != "" {

			if err := r.SetQueryParam("id", qID); err != nil {
				return err
			}
		}
	}

	if o.IDGt != nil {

		// query param id__gt
		var qrIDGt string

		if o.IDGt != nil {
			qrIDGt = *o.IDGt
		}
		qIDGt := qrIDGt
		if qIDGt != "" {

			if err := r.SetQueryParam("id__gt", qIDGt); err != nil {
				return err
			}
		}
	}

	if o.IDGte != nil {

		// query param id__gte
		var qrIDGte string

		if o.IDGte != nil {
			qrIDGte = *o.IDGte
		}
		qIDGte := qrIDGte
		if qIDGte != "" {

			if err := r.SetQueryParam("id__gte", qIDGte); err != nil {
				return err
			}
		}
	}

	if o.IDLt != nil {

		// query param id__lt
		var qrIDLt string

		if o.IDLt != nil {
			qrIDLt = *o.IDLt
		}
		qIDLt := qrIDLt
		if qIDLt != "" {

			if err := r.SetQueryParam("id__lt", qIDLt); err != nil {
				return err
			}
		}
	}

	if o.IDLte != nil {

		// query param id__lte
		var qrIDLte string

		if o.IDLte != nil {
			qrIDLte = *o.IDLte
		}
		qIDLte := qrIDLte
		if qIDLte != "" {

			if err := r.SetQueryParam("id__lte", qIDLte); err != nil {
				return err
			}
		}
	}

	if o.IDn != nil {

		// query param id__n
		var qrIDn string

		if o.IDn != nil {
			qrIDn = *o.IDn
		}
		qIDn := qrIDn
		if qIDn != "" {

			if err := r.SetQueryParam("id__n", qIDn); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Name != nil {

		// query param name
		var qrName string

		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.NameIc != nil {

		// query param name__ic
		var qrNameIc string

		if o.NameIc != nil {
			qrNameIc = *o.NameIc
		}
		qNameIc := qrNameIc
		if qNameIc != "" {

			if err := r.SetQueryParam("name__ic", qNameIc); err != nil {
				return err
			}
		}
	}

	if o.NameIe != nil {

		// query param name__ie
		var qrNameIe string

		if o.NameIe != nil {
			qrNameIe = *o.NameIe
		}
		qNameIe := qrNameIe
		if qNameIe != "" {

			if err := r.SetQueryParam("name__ie", qNameIe); err != nil {
				return err
			}
		}
	}

	if o.NameIew != nil {

		// query param name__iew
		var qrNameIew string

		if o.NameIew != nil {
			qrNameIew = *o.NameIew
		}
		qNameIew := qrNameIew
		if qNameIew != "" {

			if err := r.SetQueryParam("name__iew", qNameIew); err != nil {
				return err
			}
		}
	}

	if o.NameIsw != nil {

		// query param name__isw
		var qrNameIsw string

		if o.NameIsw != nil {
			qrNameIsw = *o.NameIsw
		}
		qNameIsw := qrNameIsw
		if qNameIsw != "" {

			if err := r.SetQueryParam("name__isw", qNameIsw); err != nil {
				return err
			}
		}
	}

	if o.Namen != nil {

		// query param name__n
		var qrNamen string

		if o.Namen != nil {
			qrNamen = *o.Namen
		}
		qNamen := qrNamen
		if qNamen != "" {

			if err := r.SetQueryParam("name__n", qNamen); err != nil {
				return err
			}
		}
	}

	if o.NameNic != nil {

		// query param name__nic
		var qrNameNic string

		if o.NameNic != nil {
			qrNameNic = *o.NameNic
		}
		qNameNic := qrNameNic
		if qNameNic != "" {

			if err := r.SetQueryParam("name__nic", qNameNic); err != nil {
				return err
			}
		}
	}

	if o.NameNie != nil {

		// query param name__nie
		var qrNameNie string

		if o.NameNie != nil {
			qrNameNie = *o.NameNie
		}
		qNameNie := qrNameNie
		if qNameNie != "" {

			if err := r.SetQueryParam("name__nie", qNameNie); err != nil {
				return err
			}
		}
	}

	if o.NameNiew != nil {

		// query param name__niew
		var qrNameNiew string

		if o.NameNiew != nil {
			qrNameNiew = *o.NameNiew
		}
		qNameNiew := qrNameNiew
		if qNameNiew != "" {

			if err := r.SetQueryParam("name__niew", qNameNiew); err != nil {
				return err
			}
		}
	}

	if o.NameNisw != nil {

		// query param name__nisw
		var qrNameNisw string

		if o.NameNisw != nil {
			qrNameNisw = *o.NameNisw
		}
		qNameNisw := qrNameNisw
		if qNameNisw != "" {

			if err := r.SetQueryParam("name__nisw", qNameNisw); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if o.Q != nil {

		// query param q
		var qrQ string

		if o.Q != nil {
			qrQ = *o.Q
		}
		qQ := qrQ
		if qQ != "" {

			if err := r.SetQueryParam("q", qQ); err != nil {
				return err
			}
		}
	}

	if o.Required != nil {

		// query param required
		var qrRequired string

		if o.Required != nil {
			qrRequired = *o.Required
		}
		qRequired := qrRequired
		if qRequired != "" {

			if err := r.SetQueryParam("required", qRequired); err != nil {
				return err
			}
		}
	}

	if o.Weight != nil {

		// query param weight
		var qrWeight string

		if o.Weight != nil {
			qrWeight = *o.Weight
		}
		qWeight := qrWeight
		if qWeight != "" {

			if err := r.SetQueryParam("weight", qWeight); err != nil {
				return err
			}
		}
	}

	if o.WeightGt != nil {

		// query param weight__gt
		var qrWeightGt string

		if o.WeightGt != nil {
			qrWeightGt = *o.WeightGt
		}
		qWeightGt := qrWeightGt
		if qWeightGt != "" {

			if err := r.SetQueryParam("weight__gt", qWeightGt); err != nil {
				return err
			}
		}
	}

	if o.WeightGte != nil {

		// query param weight__gte
		var qrWeightGte string

		if o.WeightGte != nil {
			qrWeightGte = *o.WeightGte
		}
		qWeightGte := qrWeightGte
		if qWeightGte != "" {

			if err := r.SetQueryParam("weight__gte", qWeightGte); err != nil {
				return err
			}
		}
	}

	if o.WeightLt != nil {

		// query param weight__lt
		var qrWeightLt string

		if o.WeightLt != nil {
			qrWeightLt = *o.WeightLt
		}
		qWeightLt := qrWeightLt
		if qWeightLt != "" {

			if err := r.SetQueryParam("weight__lt", qWeightLt); err != nil {
				return err
			}
		}
	}

	if o.WeightLte != nil {

		// query param weight__lte
		var qrWeightLte string

		if o.WeightLte != nil {
			qrWeightLte = *o.WeightLte
		}
		qWeightLte := qrWeightLte
		if qWeightLte != "" {

			if err := r.SetQueryParam("weight__lte", qWeightLte); err != nil {
				return err
			}
		}
	}

	if o.Weightn != nil {

		// query param weight__n
		var qrWeightn string

		if o.Weightn != nil {
			qrWeightn = *o.Weightn
		}
		qWeightn := qrWeightn
		if qWeightn != "" {

			if err := r.SetQueryParam("weight__n", qWeightn); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
