// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2020 The go-netbox Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package extras

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewExtrasCustomLinksListParams creates a new ExtrasCustomLinksListParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewExtrasCustomLinksListParams() *ExtrasCustomLinksListParams {
	return &ExtrasCustomLinksListParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewExtrasCustomLinksListParamsWithTimeout creates a new ExtrasCustomLinksListParams object
// with the ability to set a timeout on a request.
func NewExtrasCustomLinksListParamsWithTimeout(timeout time.Duration) *ExtrasCustomLinksListParams {
	return &ExtrasCustomLinksListParams{
		timeout: timeout,
	}
}

// NewExtrasCustomLinksListParamsWithContext creates a new ExtrasCustomLinksListParams object
// with the ability to set a context for a request.
func NewExtrasCustomLinksListParamsWithContext(ctx context.Context) *ExtrasCustomLinksListParams {
	return &ExtrasCustomLinksListParams{
		Context: ctx,
	}
}

// NewExtrasCustomLinksListParamsWithHTTPClient creates a new ExtrasCustomLinksListParams object
// with the ability to set a custom HTTPClient for a request.
func NewExtrasCustomLinksListParamsWithHTTPClient(client *http.Client) *ExtrasCustomLinksListParams {
	return &ExtrasCustomLinksListParams{
		HTTPClient: client,
	}
}

/* ExtrasCustomLinksListParams contains all the parameters to send to the API endpoint
   for the extras custom links list operation.

   Typically these are written to a http.Request.
*/
type ExtrasCustomLinksListParams struct {

	// ContentType.
	ContentType *string

	// ContentTypen.
	ContentTypen *string

	// Enabled.
	Enabled *string

	// GroupName.
	GroupName *string

	// GroupNameIc.
	GroupNameIc *string

	// GroupNameIe.
	GroupNameIe *string

	// GroupNameIew.
	GroupNameIew *string

	// GroupNameIsw.
	GroupNameIsw *string

	// GroupNamen.
	GroupNamen *string

	// GroupNameNic.
	GroupNameNic *string

	// GroupNameNie.
	GroupNameNie *string

	// GroupNameNiew.
	GroupNameNiew *string

	// GroupNameNisw.
	GroupNameNisw *string

	// ID.
	ID *string

	// IDGt.
	IDGt *string

	// IDGte.
	IDGte *string

	// IDLt.
	IDLt *string

	// IDLte.
	IDLte *string

	// IDn.
	IDn *string

	/* Limit.

	   Number of results to return per page.
	*/
	Limit *int64

	// LinkText.
	LinkText *string

	// LinkTextIc.
	LinkTextIc *string

	// LinkTextIe.
	LinkTextIe *string

	// LinkTextIew.
	LinkTextIew *string

	// LinkTextIsw.
	LinkTextIsw *string

	// LinkTextn.
	LinkTextn *string

	// LinkTextNic.
	LinkTextNic *string

	// LinkTextNie.
	LinkTextNie *string

	// LinkTextNiew.
	LinkTextNiew *string

	// LinkTextNisw.
	LinkTextNisw *string

	// LinkURL.
	LinkURL *string

	// LinkURLIc.
	LinkURLIc *string

	// LinkURLIe.
	LinkURLIe *string

	// LinkURLIew.
	LinkURLIew *string

	// LinkURLIsw.
	LinkURLIsw *string

	// LinkURLn.
	LinkURLn *string

	// LinkURLNic.
	LinkURLNic *string

	// LinkURLNie.
	LinkURLNie *string

	// LinkURLNiew.
	LinkURLNiew *string

	// LinkURLNisw.
	LinkURLNisw *string

	// Name.
	Name *string

	// NameIc.
	NameIc *string

	// NameIe.
	NameIe *string

	// NameIew.
	NameIew *string

	// NameIsw.
	NameIsw *string

	// Namen.
	Namen *string

	// NameNic.
	NameNic *string

	// NameNie.
	NameNie *string

	// NameNiew.
	NameNiew *string

	// NameNisw.
	NameNisw *string

	// NewWindow.
	NewWindow *string

	/* Offset.

	   The initial index from which to return the results.
	*/
	Offset *int64

	// Q.
	Q *string

	// Weight.
	Weight *string

	// WeightGt.
	WeightGt *string

	// WeightGte.
	WeightGte *string

	// WeightLt.
	WeightLt *string

	// WeightLte.
	WeightLte *string

	// Weightn.
	Weightn *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the extras custom links list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ExtrasCustomLinksListParams) WithDefaults() *ExtrasCustomLinksListParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the extras custom links list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ExtrasCustomLinksListParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithTimeout(timeout time.Duration) *ExtrasCustomLinksListParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithContext(ctx context.Context) *ExtrasCustomLinksListParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithHTTPClient(client *http.Client) *ExtrasCustomLinksListParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithContentType adds the contentType to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithContentType(contentType *string) *ExtrasCustomLinksListParams {
	o.SetContentType(contentType)
	return o
}

// SetContentType adds the contentType to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetContentType(contentType *string) {
	o.ContentType = contentType
}

// WithContentTypen adds the contentTypen to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithContentTypen(contentTypen *string) *ExtrasCustomLinksListParams {
	o.SetContentTypen(contentTypen)
	return o
}

// SetContentTypen adds the contentTypeN to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetContentTypen(contentTypen *string) {
	o.ContentTypen = contentTypen
}

// WithEnabled adds the enabled to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithEnabled(enabled *string) *ExtrasCustomLinksListParams {
	o.SetEnabled(enabled)
	return o
}

// SetEnabled adds the enabled to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetEnabled(enabled *string) {
	o.Enabled = enabled
}

// WithGroupName adds the groupName to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithGroupName(groupName *string) *ExtrasCustomLinksListParams {
	o.SetGroupName(groupName)
	return o
}

// SetGroupName adds the groupName to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetGroupName(groupName *string) {
	o.GroupName = groupName
}

// WithGroupNameIc adds the groupNameIc to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithGroupNameIc(groupNameIc *string) *ExtrasCustomLinksListParams {
	o.SetGroupNameIc(groupNameIc)
	return o
}

// SetGroupNameIc adds the groupNameIc to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetGroupNameIc(groupNameIc *string) {
	o.GroupNameIc = groupNameIc
}

// WithGroupNameIe adds the groupNameIe to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithGroupNameIe(groupNameIe *string) *ExtrasCustomLinksListParams {
	o.SetGroupNameIe(groupNameIe)
	return o
}

// SetGroupNameIe adds the groupNameIe to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetGroupNameIe(groupNameIe *string) {
	o.GroupNameIe = groupNameIe
}

// WithGroupNameIew adds the groupNameIew to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithGroupNameIew(groupNameIew *string) *ExtrasCustomLinksListParams {
	o.SetGroupNameIew(groupNameIew)
	return o
}

// SetGroupNameIew adds the groupNameIew to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetGroupNameIew(groupNameIew *string) {
	o.GroupNameIew = groupNameIew
}

// WithGroupNameIsw adds the groupNameIsw to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithGroupNameIsw(groupNameIsw *string) *ExtrasCustomLinksListParams {
	o.SetGroupNameIsw(groupNameIsw)
	return o
}

// SetGroupNameIsw adds the groupNameIsw to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetGroupNameIsw(groupNameIsw *string) {
	o.GroupNameIsw = groupNameIsw
}

// WithGroupNamen adds the groupNamen to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithGroupNamen(groupNamen *string) *ExtrasCustomLinksListParams {
	o.SetGroupNamen(groupNamen)
	return o
}

// SetGroupNamen adds the groupNameN to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetGroupNamen(groupNamen *string) {
	o.GroupNamen = groupNamen
}

// WithGroupNameNic adds the groupNameNic to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithGroupNameNic(groupNameNic *string) *ExtrasCustomLinksListParams {
	o.SetGroupNameNic(groupNameNic)
	return o
}

// SetGroupNameNic adds the groupNameNic to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetGroupNameNic(groupNameNic *string) {
	o.GroupNameNic = groupNameNic
}

// WithGroupNameNie adds the groupNameNie to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithGroupNameNie(groupNameNie *string) *ExtrasCustomLinksListParams {
	o.SetGroupNameNie(groupNameNie)
	return o
}

// SetGroupNameNie adds the groupNameNie to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetGroupNameNie(groupNameNie *string) {
	o.GroupNameNie = groupNameNie
}

// WithGroupNameNiew adds the groupNameNiew to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithGroupNameNiew(groupNameNiew *string) *ExtrasCustomLinksListParams {
	o.SetGroupNameNiew(groupNameNiew)
	return o
}

// SetGroupNameNiew adds the groupNameNiew to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetGroupNameNiew(groupNameNiew *string) {
	o.GroupNameNiew = groupNameNiew
}

// WithGroupNameNisw adds the groupNameNisw to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithGroupNameNisw(groupNameNisw *string) *ExtrasCustomLinksListParams {
	o.SetGroupNameNisw(groupNameNisw)
	return o
}

// SetGroupNameNisw adds the groupNameNisw to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetGroupNameNisw(groupNameNisw *string) {
	o.GroupNameNisw = groupNameNisw
}

// WithID adds the id to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithID(id *string) *ExtrasCustomLinksListParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetID(id *string) {
	o.ID = id
}

// WithIDGt adds the iDGt to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithIDGt(iDGt *string) *ExtrasCustomLinksListParams {
	o.SetIDGt(iDGt)
	return o
}

// SetIDGt adds the idGt to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetIDGt(iDGt *string) {
	o.IDGt = iDGt
}

// WithIDGte adds the iDGte to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithIDGte(iDGte *string) *ExtrasCustomLinksListParams {
	o.SetIDGte(iDGte)
	return o
}

// SetIDGte adds the idGte to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetIDGte(iDGte *string) {
	o.IDGte = iDGte
}

// WithIDLt adds the iDLt to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithIDLt(iDLt *string) *ExtrasCustomLinksListParams {
	o.SetIDLt(iDLt)
	return o
}

// SetIDLt adds the idLt to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetIDLt(iDLt *string) {
	o.IDLt = iDLt
}

// WithIDLte adds the iDLte to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithIDLte(iDLte *string) *ExtrasCustomLinksListParams {
	o.SetIDLte(iDLte)
	return o
}

// SetIDLte adds the idLte to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetIDLte(iDLte *string) {
	o.IDLte = iDLte
}

// WithIDn adds the iDn to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithIDn(iDn *string) *ExtrasCustomLinksListParams {
	o.SetIDn(iDn)
	return o
}

// SetIDn adds the idN to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetIDn(iDn *string) {
	o.IDn = iDn
}

// WithLimit adds the limit to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithLimit(limit *int64) *ExtrasCustomLinksListParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithLinkText adds the linkText to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithLinkText(linkText *string) *ExtrasCustomLinksListParams {
	o.SetLinkText(linkText)
	return o
}

// SetLinkText adds the linkText to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetLinkText(linkText *string) {
	o.LinkText = linkText
}

// WithLinkTextIc adds the linkTextIc to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithLinkTextIc(linkTextIc *string) *ExtrasCustomLinksListParams {
	o.SetLinkTextIc(linkTextIc)
	return o
}

// SetLinkTextIc adds the linkTextIc to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetLinkTextIc(linkTextIc *string) {
	o.LinkTextIc = linkTextIc
}

// WithLinkTextIe adds the linkTextIe to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithLinkTextIe(linkTextIe *string) *ExtrasCustomLinksListParams {
	o.SetLinkTextIe(linkTextIe)
	return o
}

// SetLinkTextIe adds the linkTextIe to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetLinkTextIe(linkTextIe *string) {
	o.LinkTextIe = linkTextIe
}

// WithLinkTextIew adds the linkTextIew to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithLinkTextIew(linkTextIew *string) *ExtrasCustomLinksListParams {
	o.SetLinkTextIew(linkTextIew)
	return o
}

// SetLinkTextIew adds the linkTextIew to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetLinkTextIew(linkTextIew *string) {
	o.LinkTextIew = linkTextIew
}

// WithLinkTextIsw adds the linkTextIsw to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithLinkTextIsw(linkTextIsw *string) *ExtrasCustomLinksListParams {
	o.SetLinkTextIsw(linkTextIsw)
	return o
}

// SetLinkTextIsw adds the linkTextIsw to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetLinkTextIsw(linkTextIsw *string) {
	o.LinkTextIsw = linkTextIsw
}

// WithLinkTextn adds the linkTextn to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithLinkTextn(linkTextn *string) *ExtrasCustomLinksListParams {
	o.SetLinkTextn(linkTextn)
	return o
}

// SetLinkTextn adds the linkTextN to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetLinkTextn(linkTextn *string) {
	o.LinkTextn = linkTextn
}

// WithLinkTextNic adds the linkTextNic to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithLinkTextNic(linkTextNic *string) *ExtrasCustomLinksListParams {
	o.SetLinkTextNic(linkTextNic)
	return o
}

// SetLinkTextNic adds the linkTextNic to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetLinkTextNic(linkTextNic *string) {
	o.LinkTextNic = linkTextNic
}

// WithLinkTextNie adds the linkTextNie to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithLinkTextNie(linkTextNie *string) *ExtrasCustomLinksListParams {
	o.SetLinkTextNie(linkTextNie)
	return o
}

// SetLinkTextNie adds the linkTextNie to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetLinkTextNie(linkTextNie *string) {
	o.LinkTextNie = linkTextNie
}

// WithLinkTextNiew adds the linkTextNiew to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithLinkTextNiew(linkTextNiew *string) *ExtrasCustomLinksListParams {
	o.SetLinkTextNiew(linkTextNiew)
	return o
}

// SetLinkTextNiew adds the linkTextNiew to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetLinkTextNiew(linkTextNiew *string) {
	o.LinkTextNiew = linkTextNiew
}

// WithLinkTextNisw adds the linkTextNisw to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithLinkTextNisw(linkTextNisw *string) *ExtrasCustomLinksListParams {
	o.SetLinkTextNisw(linkTextNisw)
	return o
}

// SetLinkTextNisw adds the linkTextNisw to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetLinkTextNisw(linkTextNisw *string) {
	o.LinkTextNisw = linkTextNisw
}

// WithLinkURL adds the linkURL to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithLinkURL(linkURL *string) *ExtrasCustomLinksListParams {
	o.SetLinkURL(linkURL)
	return o
}

// SetLinkURL adds the linkUrl to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetLinkURL(linkURL *string) {
	o.LinkURL = linkURL
}

// WithLinkURLIc adds the linkURLIc to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithLinkURLIc(linkURLIc *string) *ExtrasCustomLinksListParams {
	o.SetLinkURLIc(linkURLIc)
	return o
}

// SetLinkURLIc adds the linkUrlIc to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetLinkURLIc(linkURLIc *string) {
	o.LinkURLIc = linkURLIc
}

// WithLinkURLIe adds the linkURLIe to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithLinkURLIe(linkURLIe *string) *ExtrasCustomLinksListParams {
	o.SetLinkURLIe(linkURLIe)
	return o
}

// SetLinkURLIe adds the linkUrlIe to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetLinkURLIe(linkURLIe *string) {
	o.LinkURLIe = linkURLIe
}

// WithLinkURLIew adds the linkURLIew to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithLinkURLIew(linkURLIew *string) *ExtrasCustomLinksListParams {
	o.SetLinkURLIew(linkURLIew)
	return o
}

// SetLinkURLIew adds the linkUrlIew to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetLinkURLIew(linkURLIew *string) {
	o.LinkURLIew = linkURLIew
}

// WithLinkURLIsw adds the linkURLIsw to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithLinkURLIsw(linkURLIsw *string) *ExtrasCustomLinksListParams {
	o.SetLinkURLIsw(linkURLIsw)
	return o
}

// SetLinkURLIsw adds the linkUrlIsw to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetLinkURLIsw(linkURLIsw *string) {
	o.LinkURLIsw = linkURLIsw
}

// WithLinkURLn adds the linkURLn to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithLinkURLn(linkURLn *string) *ExtrasCustomLinksListParams {
	o.SetLinkURLn(linkURLn)
	return o
}

// SetLinkURLn adds the linkUrlN to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetLinkURLn(linkURLn *string) {
	o.LinkURLn = linkURLn
}

// WithLinkURLNic adds the linkURLNic to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithLinkURLNic(linkURLNic *string) *ExtrasCustomLinksListParams {
	o.SetLinkURLNic(linkURLNic)
	return o
}

// SetLinkURLNic adds the linkUrlNic to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetLinkURLNic(linkURLNic *string) {
	o.LinkURLNic = linkURLNic
}

// WithLinkURLNie adds the linkURLNie to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithLinkURLNie(linkURLNie *string) *ExtrasCustomLinksListParams {
	o.SetLinkURLNie(linkURLNie)
	return o
}

// SetLinkURLNie adds the linkUrlNie to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetLinkURLNie(linkURLNie *string) {
	o.LinkURLNie = linkURLNie
}

// WithLinkURLNiew adds the linkURLNiew to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithLinkURLNiew(linkURLNiew *string) *ExtrasCustomLinksListParams {
	o.SetLinkURLNiew(linkURLNiew)
	return o
}

// SetLinkURLNiew adds the linkUrlNiew to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetLinkURLNiew(linkURLNiew *string) {
	o.LinkURLNiew = linkURLNiew
}

// WithLinkURLNisw adds the linkURLNisw to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithLinkURLNisw(linkURLNisw *string) *ExtrasCustomLinksListParams {
	o.SetLinkURLNisw(linkURLNisw)
	return o
}

// SetLinkURLNisw adds the linkUrlNisw to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetLinkURLNisw(linkURLNisw *string) {
	o.LinkURLNisw = linkURLNisw
}

// WithName adds the name to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithName(name *string) *ExtrasCustomLinksListParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetName(name *string) {
	o.Name = name
}

// WithNameIc adds the nameIc to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithNameIc(nameIc *string) *ExtrasCustomLinksListParams {
	o.SetNameIc(nameIc)
	return o
}

// SetNameIc adds the nameIc to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetNameIc(nameIc *string) {
	o.NameIc = nameIc
}

// WithNameIe adds the nameIe to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithNameIe(nameIe *string) *ExtrasCustomLinksListParams {
	o.SetNameIe(nameIe)
	return o
}

// SetNameIe adds the nameIe to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetNameIe(nameIe *string) {
	o.NameIe = nameIe
}

// WithNameIew adds the nameIew to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithNameIew(nameIew *string) *ExtrasCustomLinksListParams {
	o.SetNameIew(nameIew)
	return o
}

// SetNameIew adds the nameIew to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetNameIew(nameIew *string) {
	o.NameIew = nameIew
}

// WithNameIsw adds the nameIsw to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithNameIsw(nameIsw *string) *ExtrasCustomLinksListParams {
	o.SetNameIsw(nameIsw)
	return o
}

// SetNameIsw adds the nameIsw to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetNameIsw(nameIsw *string) {
	o.NameIsw = nameIsw
}

// WithNamen adds the namen to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithNamen(namen *string) *ExtrasCustomLinksListParams {
	o.SetNamen(namen)
	return o
}

// SetNamen adds the nameN to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetNamen(namen *string) {
	o.Namen = namen
}

// WithNameNic adds the nameNic to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithNameNic(nameNic *string) *ExtrasCustomLinksListParams {
	o.SetNameNic(nameNic)
	return o
}

// SetNameNic adds the nameNic to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetNameNic(nameNic *string) {
	o.NameNic = nameNic
}

// WithNameNie adds the nameNie to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithNameNie(nameNie *string) *ExtrasCustomLinksListParams {
	o.SetNameNie(nameNie)
	return o
}

// SetNameNie adds the nameNie to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetNameNie(nameNie *string) {
	o.NameNie = nameNie
}

// WithNameNiew adds the nameNiew to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithNameNiew(nameNiew *string) *ExtrasCustomLinksListParams {
	o.SetNameNiew(nameNiew)
	return o
}

// SetNameNiew adds the nameNiew to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetNameNiew(nameNiew *string) {
	o.NameNiew = nameNiew
}

// WithNameNisw adds the nameNisw to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithNameNisw(nameNisw *string) *ExtrasCustomLinksListParams {
	o.SetNameNisw(nameNisw)
	return o
}

// SetNameNisw adds the nameNisw to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetNameNisw(nameNisw *string) {
	o.NameNisw = nameNisw
}

// WithNewWindow adds the newWindow to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithNewWindow(newWindow *string) *ExtrasCustomLinksListParams {
	o.SetNewWindow(newWindow)
	return o
}

// SetNewWindow adds the newWindow to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetNewWindow(newWindow *string) {
	o.NewWindow = newWindow
}

// WithOffset adds the offset to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithOffset(offset *int64) *ExtrasCustomLinksListParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithQ adds the q to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithQ(q *string) *ExtrasCustomLinksListParams {
	o.SetQ(q)
	return o
}

// SetQ adds the q to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetQ(q *string) {
	o.Q = q
}

// WithWeight adds the weight to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithWeight(weight *string) *ExtrasCustomLinksListParams {
	o.SetWeight(weight)
	return o
}

// SetWeight adds the weight to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetWeight(weight *string) {
	o.Weight = weight
}

// WithWeightGt adds the weightGt to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithWeightGt(weightGt *string) *ExtrasCustomLinksListParams {
	o.SetWeightGt(weightGt)
	return o
}

// SetWeightGt adds the weightGt to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetWeightGt(weightGt *string) {
	o.WeightGt = weightGt
}

// WithWeightGte adds the weightGte to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithWeightGte(weightGte *string) *ExtrasCustomLinksListParams {
	o.SetWeightGte(weightGte)
	return o
}

// SetWeightGte adds the weightGte to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetWeightGte(weightGte *string) {
	o.WeightGte = weightGte
}

// WithWeightLt adds the weightLt to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithWeightLt(weightLt *string) *ExtrasCustomLinksListParams {
	o.SetWeightLt(weightLt)
	return o
}

// SetWeightLt adds the weightLt to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetWeightLt(weightLt *string) {
	o.WeightLt = weightLt
}

// WithWeightLte adds the weightLte to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithWeightLte(weightLte *string) *ExtrasCustomLinksListParams {
	o.SetWeightLte(weightLte)
	return o
}

// SetWeightLte adds the weightLte to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetWeightLte(weightLte *string) {
	o.WeightLte = weightLte
}

// WithWeightn adds the weightn to the extras custom links list params
func (o *ExtrasCustomLinksListParams) WithWeightn(weightn *string) *ExtrasCustomLinksListParams {
	o.SetWeightn(weightn)
	return o
}

// SetWeightn adds the weightN to the extras custom links list params
func (o *ExtrasCustomLinksListParams) SetWeightn(weightn *string) {
	o.Weightn = weightn
}

// WriteToRequest writes these params to a swagger request
func (o *ExtrasCustomLinksListParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.ContentType != nil {

		// query param content_type
		var qrContentType string

		if o.ContentType != nil {
			qrContentType = *o.ContentType
		}
		qContentType := qrContentType
		if qContentType != "" {

			if err := r.SetQueryParam("content_type", qContentType); err != nil {
				return err
			}
		}
	}

	if o.ContentTypen != nil {

		// query param content_type__n
		var qrContentTypen string

		if o.ContentTypen != nil {
			qrContentTypen = *o.ContentTypen
		}
		qContentTypen := qrContentTypen
		if qContentTypen != "" {

			if err := r.SetQueryParam("content_type__n", qContentTypen); err != nil {
				return err
			}
		}
	}

	if o.Enabled != nil {

		// query param enabled
		var qrEnabled string

		if o.Enabled != nil {
			qrEnabled = *o.Enabled
		}
		qEnabled := qrEnabled
		if qEnabled != "" {

			if err := r.SetQueryParam("enabled", qEnabled); err != nil {
				return err
			}
		}
	}

	if o.GroupName != nil {

		// query param group_name
		var qrGroupName string

		if o.GroupName != nil {
			qrGroupName = *o.GroupName
		}
		qGroupName := qrGroupName
		if qGroupName != "" {

			if err := r.SetQueryParam("group_name", qGroupName); err != nil {
				return err
			}
		}
	}

	if o.GroupNameIc != nil {

		// query param group_name__ic
		var qrGroupNameIc string

		if o.GroupNameIc != nil {
			qrGroupNameIc = *o.GroupNameIc
		}
		qGroupNameIc := qrGroupNameIc
		if qGroupNameIc != "" {

			if err := r.SetQueryParam("group_name__ic", qGroupNameIc); err != nil {
				return err
			}
		}
	}

	if o.GroupNameIe != nil {

		// query param group_name__ie
		var qrGroupNameIe string

		if o.GroupNameIe != nil {
			qrGroupNameIe = *o.GroupNameIe
		}
		qGroupNameIe := qrGroupNameIe
		if qGroupNameIe != "" {

			if err := r.SetQueryParam("group_name__ie", qGroupNameIe); err != nil {
				return err
			}
		}
	}

	if o.GroupNameIew != nil {

		// query param group_name__iew
		var qrGroupNameIew string

		if o.GroupNameIew != nil {
			qrGroupNameIew = *o.GroupNameIew
		}
		qGroupNameIew := qrGroupNameIew
		if qGroupNameIew != "" {

			if err := r.SetQueryParam("group_name__iew", qGroupNameIew); err != nil {
				return err
			}
		}
	}

	if o.GroupNameIsw != nil {

		// query param group_name__isw
		var qrGroupNameIsw string

		if o.GroupNameIsw != nil {
			qrGroupNameIsw = *o.GroupNameIsw
		}
		qGroupNameIsw := qrGroupNameIsw
		if qGroupNameIsw != "" {

			if err := r.SetQueryParam("group_name__isw", qGroupNameIsw); err != nil {
				return err
			}
		}
	}

	if o.GroupNamen != nil {

		// query param group_name__n
		var qrGroupNamen string

		if o.GroupNamen != nil {
			qrGroupNamen = *o.GroupNamen
		}
		qGroupNamen := qrGroupNamen
		if qGroupNamen != "" {

			if err := r.SetQueryParam("group_name__n", qGroupNamen); err != nil {
				return err
			}
		}
	}

	if o.GroupNameNic != nil {

		// query param group_name__nic
		var qrGroupNameNic string

		if o.GroupNameNic != nil {
			qrGroupNameNic = *o.GroupNameNic
		}
		qGroupNameNic := qrGroupNameNic
		if qGroupNameNic != "" {

			if err := r.SetQueryParam("group_name__nic", qGroupNameNic); err != nil {
				return err
			}
		}
	}

	if o.GroupNameNie != nil {

		// query param group_name__nie
		var qrGroupNameNie string

		if o.GroupNameNie != nil {
			qrGroupNameNie = *o.GroupNameNie
		}
		qGroupNameNie := qrGroupNameNie
		if qGroupNameNie != "" {

			if err := r.SetQueryParam("group_name__nie", qGroupNameNie); err != nil {
				return err
			}
		}
	}

	if o.GroupNameNiew != nil {

		// query param group_name__niew
		var qrGroupNameNiew string

		if o.GroupNameNiew != nil {
			qrGroupNameNiew = *o.GroupNameNiew
		}
		qGroupNameNiew := qrGroupNameNiew
		if qGroupNameNiew != "" {

			if err := r.SetQueryParam("group_name__niew", qGroupNameNiew); err != nil {
				return err
			}
		}
	}

	if o.GroupNameNisw != nil {

		// query param group_name__nisw
		var qrGroupNameNisw string

		if o.GroupNameNisw != nil {
			qrGroupNameNisw = *o.GroupNameNisw
		}
		qGroupNameNisw := qrGroupNameNisw
		if qGroupNameNisw != "" {

			if err := r.SetQueryParam("group_name__nisw", qGroupNameNisw); err != nil {
				return err
			}
		}
	}

	if o.ID != nil {

		// query param id
		var qrID string

		if o.ID != nil {
			qrID = *o.ID
		}
		qID := qrID
		if qID != "" {

			if err := r.SetQueryParam("id", qID); err != nil {
				return err
			}
		}
	}

	if o.IDGt != nil {

		// query param id__gt
		var qrIDGt string

		if o.IDGt != nil {
			qrIDGt = *o.IDGt
		}
		qIDGt := qrIDGt
		if qIDGt != "" {

			if err := r.SetQueryParam("id__gt", qIDGt); err != nil {
				return err
			}
		}
	}

	if o.IDGte != nil {

		// query param id__gte
		var qrIDGte string

		if o.IDGte != nil {
			qrIDGte = *o.IDGte
		}
		qIDGte := qrIDGte
		if qIDGte != "" {

			if err := r.SetQueryParam("id__gte", qIDGte); err != nil {
				return err
			}
		}
	}

	if o.IDLt != nil {

		// query param id__lt
		var qrIDLt string

		if o.IDLt != nil {
			qrIDLt = *o.IDLt
		}
		qIDLt := qrIDLt
		if qIDLt != "" {

			if err := r.SetQueryParam("id__lt", qIDLt); err != nil {
				return err
			}
		}
	}

	if o.IDLte != nil {

		// query param id__lte
		var qrIDLte string

		if o.IDLte != nil {
			qrIDLte = *o.IDLte
		}
		qIDLte := qrIDLte
		if qIDLte != "" {

			if err := r.SetQueryParam("id__lte", qIDLte); err != nil {
				return err
			}
		}
	}

	if o.IDn != nil {

		// query param id__n
		var qrIDn string

		if o.IDn != nil {
			qrIDn = *o.IDn
		}
		qIDn := qrIDn
		if qIDn != "" {

			if err := r.SetQueryParam("id__n", qIDn); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.LinkText != nil {

		// query param link_text
		var qrLinkText string

		if o.LinkText != nil {
			qrLinkText = *o.LinkText
		}
		qLinkText := qrLinkText
		if qLinkText != "" {

			if err := r.SetQueryParam("link_text", qLinkText); err != nil {
				return err
			}
		}
	}

	if o.LinkTextIc != nil {

		// query param link_text__ic
		var qrLinkTextIc string

		if o.LinkTextIc != nil {
			qrLinkTextIc = *o.LinkTextIc
		}
		qLinkTextIc := qrLinkTextIc
		if qLinkTextIc != "" {

			if err := r.SetQueryParam("link_text__ic", qLinkTextIc); err != nil {
				return err
			}
		}
	}

	if o.LinkTextIe != nil {

		// query param link_text__ie
		var qrLinkTextIe string

		if o.LinkTextIe != nil {
			qrLinkTextIe = *o.LinkTextIe
		}
		qLinkTextIe := qrLinkTextIe
		if qLinkTextIe != "" {

			if err := r.SetQueryParam("link_text__ie", qLinkTextIe); err != nil {
				return err
			}
		}
	}

	if o.LinkTextIew != nil {

		// query param link_text__iew
		var qrLinkTextIew string

		if o.LinkTextIew != nil {
			qrLinkTextIew = *o.LinkTextIew
		}
		qLinkTextIew := qrLinkTextIew
		if qLinkTextIew != "" {

			if err := r.SetQueryParam("link_text__iew", qLinkTextIew); err != nil {
				return err
			}
		}
	}

	if o.LinkTextIsw != nil {

		// query param link_text__isw
		var qrLinkTextIsw string

		if o.LinkTextIsw != nil {
			qrLinkTextIsw = *o.LinkTextIsw
		}
		qLinkTextIsw := qrLinkTextIsw
		if qLinkTextIsw != "" {

			if err := r.SetQueryParam("link_text__isw", qLinkTextIsw); err != nil {
				return err
			}
		}
	}

	if o.LinkTextn != nil {

		// query param link_text__n
		var qrLinkTextn string

		if o.LinkTextn != nil {
			qrLinkTextn = *o.LinkTextn
		}
		qLinkTextn := qrLinkTextn
		if qLinkTextn != "" {

			if err := r.SetQueryParam("link_text__n", qLinkTextn); err != nil {
				return err
			}
		}
	}

	if o.LinkTextNic != nil {

		// query param link_text__nic
		var qrLinkTextNic string

		if o.LinkTextNic != nil {
			qrLinkTextNic = *o.LinkTextNic
		}
		qLinkTextNic := qrLinkTextNic
		if qLinkTextNic != "" {

			if err := r.SetQueryParam("link_text__nic", qLinkTextNic); err != nil {
				return err
			}
		}
	}

	if o.LinkTextNie != nil {

		// query param link_text__nie
		var qrLinkTextNie string

		if o.LinkTextNie != nil {
			qrLinkTextNie = *o.LinkTextNie
		}
		qLinkTextNie := qrLinkTextNie
		if qLinkTextNie != "" {

			if err := r.SetQueryParam("link_text__nie", qLinkTextNie); err != nil {
				return err
			}
		}
	}

	if o.LinkTextNiew != nil {

		// query param link_text__niew
		var qrLinkTextNiew string

		if o.LinkTextNiew != nil {
			qrLinkTextNiew = *o.LinkTextNiew
		}
		qLinkTextNiew := qrLinkTextNiew
		if qLinkTextNiew != "" {

			if err := r.SetQueryParam("link_text__niew", qLinkTextNiew); err != nil {
				return err
			}
		}
	}

	if o.LinkTextNisw != nil {

		// query param link_text__nisw
		var qrLinkTextNisw string

		if o.LinkTextNisw != nil {
			qrLinkTextNisw = *o.LinkTextNisw
		}
		qLinkTextNisw := qrLinkTextNisw
		if qLinkTextNisw != "" {

			if err := r.SetQueryParam("link_text__nisw", qLinkTextNisw); err != nil {
				return err
			}
		}
	}

	if o.LinkURL != nil {

		// query param link_url
		var qrLinkURL string

		if o.LinkURL != nil {
			qrLinkURL = *o.LinkURL
		}
		qLinkURL := qrLinkURL
		if qLinkURL != "" {

			if err := r.SetQueryParam("link_url", qLinkURL); err != nil {
				return err
			}
		}
	}

	if o.LinkURLIc != nil {

		// query param link_url__ic
		var qrLinkURLIc string

		if o.LinkURLIc != nil {
			qrLinkURLIc = *o.LinkURLIc
		}
		qLinkURLIc := qrLinkURLIc
		if qLinkURLIc != "" {

			if err := r.SetQueryParam("link_url__ic", qLinkURLIc); err != nil {
				return err
			}
		}
	}

	if o.LinkURLIe != nil {

		// query param link_url__ie
		var qrLinkURLIe string

		if o.LinkURLIe != nil {
			qrLinkURLIe = *o.LinkURLIe
		}
		qLinkURLIe := qrLinkURLIe
		if qLinkURLIe != "" {

			if err := r.SetQueryParam("link_url__ie", qLinkURLIe); err != nil {
				return err
			}
		}
	}

	if o.LinkURLIew != nil {

		// query param link_url__iew
		var qrLinkURLIew string

		if o.LinkURLIew != nil {
			qrLinkURLIew = *o.LinkURLIew
		}
		qLinkURLIew := qrLinkURLIew
		if qLinkURLIew != "" {

			if err := r.SetQueryParam("link_url__iew", qLinkURLIew); err != nil {
				return err
			}
		}
	}

	if o.LinkURLIsw != nil {

		// query param link_url__isw
		var qrLinkURLIsw string

		if o.LinkURLIsw != nil {
			qrLinkURLIsw = *o.LinkURLIsw
		}
		qLinkURLIsw := qrLinkURLIsw
		if qLinkURLIsw != "" {

			if err := r.SetQueryParam("link_url__isw", qLinkURLIsw); err != nil {
				return err
			}
		}
	}

	if o.LinkURLn != nil {

		// query param link_url__n
		var qrLinkURLn string

		if o.LinkURLn != nil {
			qrLinkURLn = *o.LinkURLn
		}
		qLinkURLn := qrLinkURLn
		if qLinkURLn != "" {

			if err := r.SetQueryParam("link_url__n", qLinkURLn); err != nil {
				return err
			}
		}
	}

	if o.LinkURLNic != nil {

		// query param link_url__nic
		var qrLinkURLNic string

		if o.LinkURLNic != nil {
			qrLinkURLNic = *o.LinkURLNic
		}
		qLinkURLNic := qrLinkURLNic
		if qLinkURLNic != "" {

			if err := r.SetQueryParam("link_url__nic", qLinkURLNic); err != nil {
				return err
			}
		}
	}

	if o.LinkURLNie != nil {

		// query param link_url__nie
		var qrLinkURLNie string

		if o.LinkURLNie != nil {
			qrLinkURLNie = *o.LinkURLNie
		}
		qLinkURLNie := qrLinkURLNie
		if qLinkURLNie != "" {

			if err := r.SetQueryParam("link_url__nie", qLinkURLNie); err != nil {
				return err
			}
		}
	}

	if o.LinkURLNiew != nil {

		// query param link_url__niew
		var qrLinkURLNiew string

		if o.LinkURLNiew != nil {
			qrLinkURLNiew = *o.LinkURLNiew
		}
		qLinkURLNiew := qrLinkURLNiew
		if qLinkURLNiew != "" {

			if err := r.SetQueryParam("link_url__niew", qLinkURLNiew); err != nil {
				return err
			}
		}
	}

	if o.LinkURLNisw != nil {

		// query param link_url__nisw
		var qrLinkURLNisw string

		if o.LinkURLNisw != nil {
			qrLinkURLNisw = *o.LinkURLNisw
		}
		qLinkURLNisw := qrLinkURLNisw
		if qLinkURLNisw != "" {

			if err := r.SetQueryParam("link_url__nisw", qLinkURLNisw); err != nil {
				return err
			}
		}
	}

	if o.Name != nil {

		// query param name
		var qrName string

		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.NameIc != nil {

		// query param name__ic
		var qrNameIc string

		if o.NameIc != nil {
			qrNameIc = *o.NameIc
		}
		qNameIc := qrNameIc
		if qNameIc != "" {

			if err := r.SetQueryParam("name__ic", qNameIc); err != nil {
				return err
			}
		}
	}

	if o.NameIe != nil {

		// query param name__ie
		var qrNameIe string

		if o.NameIe != nil {
			qrNameIe = *o.NameIe
		}
		qNameIe := qrNameIe
		if qNameIe != "" {

			if err := r.SetQueryParam("name__ie", qNameIe); err != nil {
				return err
			}
		}
	}

	if o.NameIew != nil {

		// query param name__iew
		var qrNameIew string

		if o.NameIew != nil {
			qrNameIew = *o.NameIew
		}
		qNameIew := qrNameIew
		if qNameIew != "" {

			if err := r.SetQueryParam("name__iew", qNameIew); err != nil {
				return err
			}
		}
	}

	if o.NameIsw != nil {

		// query param name__isw
		var qrNameIsw string

		if o.NameIsw != nil {
			qrNameIsw = *o.NameIsw
		}
		qNameIsw := qrNameIsw
		if qNameIsw != "" {

			if err := r.SetQueryParam("name__isw", qNameIsw); err != nil {
				return err
			}
		}
	}

	if o.Namen != nil {

		// query param name__n
		var qrNamen string

		if o.Namen != nil {
			qrNamen = *o.Namen
		}
		qNamen := qrNamen
		if qNamen != "" {

			if err := r.SetQueryParam("name__n", qNamen); err != nil {
				return err
			}
		}
	}

	if o.NameNic != nil {

		// query param name__nic
		var qrNameNic string

		if o.NameNic != nil {
			qrNameNic = *o.NameNic
		}
		qNameNic := qrNameNic
		if qNameNic != "" {

			if err := r.SetQueryParam("name__nic", qNameNic); err != nil {
				return err
			}
		}
	}

	if o.NameNie != nil {

		// query param name__nie
		var qrNameNie string

		if o.NameNie != nil {
			qrNameNie = *o.NameNie
		}
		qNameNie := qrNameNie
		if qNameNie != "" {

			if err := r.SetQueryParam("name__nie", qNameNie); err != nil {
				return err
			}
		}
	}

	if o.NameNiew != nil {

		// query param name__niew
		var qrNameNiew string

		if o.NameNiew != nil {
			qrNameNiew = *o.NameNiew
		}
		qNameNiew := qrNameNiew
		if qNameNiew != "" {

			if err := r.SetQueryParam("name__niew", qNameNiew); err != nil {
				return err
			}
		}
	}

	if o.NameNisw != nil {

		// query param name__nisw
		var qrNameNisw string

		if o.NameNisw != nil {
			qrNameNisw = *o.NameNisw
		}
		qNameNisw := qrNameNisw
		if qNameNisw != "" {

			if err := r.SetQueryParam("name__nisw", qNameNisw); err != nil {
				return err
			}
		}
	}

	if o.NewWindow != nil {

		// query param new_window
		var qrNewWindow string

		if o.NewWindow != nil {
			qrNewWindow = *o.NewWindow
		}
		qNewWindow := qrNewWindow
		if qNewWindow != "" {

			if err := r.SetQueryParam("new_window", qNewWindow); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if o.Q != nil {

		// query param q
		var qrQ string

		if o.Q != nil {
			qrQ = *o.Q
		}
		qQ := qrQ
		if qQ != "" {

			if err := r.SetQueryParam("q", qQ); err != nil {
				return err
			}
		}
	}

	if o.Weight != nil {

		// query param weight
		var qrWeight string

		if o.Weight != nil {
			qrWeight = *o.Weight
		}
		qWeight := qrWeight
		if qWeight != "" {

			if err := r.SetQueryParam("weight", qWeight); err != nil {
				return err
			}
		}
	}

	if o.WeightGt != nil {

		// query param weight__gt
		var qrWeightGt string

		if o.WeightGt != nil {
			qrWeightGt = *o.WeightGt
		}
		qWeightGt := qrWeightGt
		if qWeightGt != "" {

			if err := r.SetQueryParam("weight__gt", qWeightGt); err != nil {
				return err
			}
		}
	}

	if o.WeightGte != nil {

		// query param weight__gte
		var qrWeightGte string

		if o.WeightGte != nil {
			qrWeightGte = *o.WeightGte
		}
		qWeightGte := qrWeightGte
		if qWeightGte != "" {

			if err := r.SetQueryParam("weight__gte", qWeightGte); err != nil {
				return err
			}
		}
	}

	if o.WeightLt != nil {

		// query param weight__lt
		var qrWeightLt string

		if o.WeightLt != nil {
			qrWeightLt = *o.WeightLt
		}
		qWeightLt := qrWeightLt
		if qWeightLt != "" {

			if err := r.SetQueryParam("weight__lt", qWeightLt); err != nil {
				return err
			}
		}
	}

	if o.WeightLte != nil {

		// query param weight__lte
		var qrWeightLte string

		if o.WeightLte != nil {
			qrWeightLte = *o.WeightLte
		}
		qWeightLte := qrWeightLte
		if qWeightLte != "" {

			if err := r.SetQueryParam("weight__lte", qWeightLte); err != nil {
				return err
			}
		}
	}

	if o.Weightn != nil {

		// query param weight__n
		var qrWeightn string

		if o.Weightn != nil {
			qrWeightn = *o.Weightn
		}
		qWeightn := qrWeightn
		if qWeightn != "" {

			if err := r.SetQueryParam("weight__n", qWeightn); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
