// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2020 The go-netbox Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package extras

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewExtrasWebhooksListParams creates a new ExtrasWebhooksListParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewExtrasWebhooksListParams() *ExtrasWebhooksListParams {
	return &ExtrasWebhooksListParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewExtrasWebhooksListParamsWithTimeout creates a new ExtrasWebhooksListParams object
// with the ability to set a timeout on a request.
func NewExtrasWebhooksListParamsWithTimeout(timeout time.Duration) *ExtrasWebhooksListParams {
	return &ExtrasWebhooksListParams{
		timeout: timeout,
	}
}

// NewExtrasWebhooksListParamsWithContext creates a new ExtrasWebhooksListParams object
// with the ability to set a context for a request.
func NewExtrasWebhooksListParamsWithContext(ctx context.Context) *ExtrasWebhooksListParams {
	return &ExtrasWebhooksListParams{
		Context: ctx,
	}
}

// NewExtrasWebhooksListParamsWithHTTPClient creates a new ExtrasWebhooksListParams object
// with the ability to set a custom HTTPClient for a request.
func NewExtrasWebhooksListParamsWithHTTPClient(client *http.Client) *ExtrasWebhooksListParams {
	return &ExtrasWebhooksListParams{
		HTTPClient: client,
	}
}

/* ExtrasWebhooksListParams contains all the parameters to send to the API endpoint
   for the extras webhooks list operation.

   Typically these are written to a http.Request.
*/
type ExtrasWebhooksListParams struct {

	// CaFilePath.
	CaFilePath *string

	// CaFilePathIc.
	CaFilePathIc *string

	// CaFilePathIe.
	CaFilePathIe *string

	// CaFilePathIew.
	CaFilePathIew *string

	// CaFilePathIsw.
	CaFilePathIsw *string

	// CaFilePathn.
	CaFilePathn *string

	// CaFilePathNic.
	CaFilePathNic *string

	// CaFilePathNie.
	CaFilePathNie *string

	// CaFilePathNiew.
	CaFilePathNiew *string

	// CaFilePathNisw.
	CaFilePathNisw *string

	// ContentTypes.
	ContentTypes *string

	// ContentTypesIc.
	ContentTypesIc *string

	// ContentTypesIe.
	ContentTypesIe *string

	// ContentTypesIew.
	ContentTypesIew *string

	// ContentTypesIsw.
	ContentTypesIsw *string

	// ContentTypesn.
	ContentTypesn *string

	// ContentTypesNic.
	ContentTypesNic *string

	// ContentTypesNie.
	ContentTypesNie *string

	// ContentTypesNiew.
	ContentTypesNiew *string

	// ContentTypesNisw.
	ContentTypesNisw *string

	// Enabled.
	Enabled *string

	// HTTPContentType.
	HTTPContentType *string

	// HTTPContentTypeIc.
	HTTPContentTypeIc *string

	// HTTPContentTypeIe.
	HTTPContentTypeIe *string

	// HTTPContentTypeIew.
	HTTPContentTypeIew *string

	// HTTPContentTypeIsw.
	HTTPContentTypeIsw *string

	// HTTPContentTypen.
	HTTPContentTypen *string

	// HTTPContentTypeNic.
	HTTPContentTypeNic *string

	// HTTPContentTypeNie.
	HTTPContentTypeNie *string

	// HTTPContentTypeNiew.
	HTTPContentTypeNiew *string

	// HTTPContentTypeNisw.
	HTTPContentTypeNisw *string

	// HTTPMethod.
	HTTPMethod *string

	// HTTPMethodn.
	HTTPMethodn *string

	// ID.
	ID *string

	// IDGt.
	IDGt *string

	// IDGte.
	IDGte *string

	// IDLt.
	IDLt *string

	// IDLte.
	IDLte *string

	// IDn.
	IDn *string

	/* Limit.

	   Number of results to return per page.
	*/
	Limit *int64

	// Name.
	Name *string

	// NameIc.
	NameIc *string

	// NameIe.
	NameIe *string

	// NameIew.
	NameIew *string

	// NameIsw.
	NameIsw *string

	// Namen.
	Namen *string

	// NameNic.
	NameNic *string

	// NameNie.
	NameNie *string

	// NameNiew.
	NameNiew *string

	// NameNisw.
	NameNisw *string

	/* Offset.

	   The initial index from which to return the results.
	*/
	Offset *int64

	// PayloadURL.
	PayloadURL *string

	// PayloadURLIc.
	PayloadURLIc *string

	// PayloadURLIe.
	PayloadURLIe *string

	// PayloadURLIew.
	PayloadURLIew *string

	// PayloadURLIsw.
	PayloadURLIsw *string

	// PayloadURLn.
	PayloadURLn *string

	// PayloadURLNic.
	PayloadURLNic *string

	// PayloadURLNie.
	PayloadURLNie *string

	// PayloadURLNiew.
	PayloadURLNiew *string

	// PayloadURLNisw.
	PayloadURLNisw *string

	// Q.
	Q *string

	// Secret.
	Secret *string

	// SecretIc.
	SecretIc *string

	// SecretIe.
	SecretIe *string

	// SecretIew.
	SecretIew *string

	// SecretIsw.
	SecretIsw *string

	// Secretn.
	Secretn *string

	// SecretNic.
	SecretNic *string

	// SecretNie.
	SecretNie *string

	// SecretNiew.
	SecretNiew *string

	// SecretNisw.
	SecretNisw *string

	// SslVerification.
	SslVerification *string

	// TypeCreate.
	TypeCreate *string

	// TypeDelete.
	TypeDelete *string

	// TypeUpdate.
	TypeUpdate *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the extras webhooks list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ExtrasWebhooksListParams) WithDefaults() *ExtrasWebhooksListParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the extras webhooks list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ExtrasWebhooksListParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithTimeout(timeout time.Duration) *ExtrasWebhooksListParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithContext(ctx context.Context) *ExtrasWebhooksListParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithHTTPClient(client *http.Client) *ExtrasWebhooksListParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCaFilePath adds the caFilePath to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithCaFilePath(caFilePath *string) *ExtrasWebhooksListParams {
	o.SetCaFilePath(caFilePath)
	return o
}

// SetCaFilePath adds the caFilePath to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetCaFilePath(caFilePath *string) {
	o.CaFilePath = caFilePath
}

// WithCaFilePathIc adds the caFilePathIc to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithCaFilePathIc(caFilePathIc *string) *ExtrasWebhooksListParams {
	o.SetCaFilePathIc(caFilePathIc)
	return o
}

// SetCaFilePathIc adds the caFilePathIc to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetCaFilePathIc(caFilePathIc *string) {
	o.CaFilePathIc = caFilePathIc
}

// WithCaFilePathIe adds the caFilePathIe to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithCaFilePathIe(caFilePathIe *string) *ExtrasWebhooksListParams {
	o.SetCaFilePathIe(caFilePathIe)
	return o
}

// SetCaFilePathIe adds the caFilePathIe to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetCaFilePathIe(caFilePathIe *string) {
	o.CaFilePathIe = caFilePathIe
}

// WithCaFilePathIew adds the caFilePathIew to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithCaFilePathIew(caFilePathIew *string) *ExtrasWebhooksListParams {
	o.SetCaFilePathIew(caFilePathIew)
	return o
}

// SetCaFilePathIew adds the caFilePathIew to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetCaFilePathIew(caFilePathIew *string) {
	o.CaFilePathIew = caFilePathIew
}

// WithCaFilePathIsw adds the caFilePathIsw to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithCaFilePathIsw(caFilePathIsw *string) *ExtrasWebhooksListParams {
	o.SetCaFilePathIsw(caFilePathIsw)
	return o
}

// SetCaFilePathIsw adds the caFilePathIsw to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetCaFilePathIsw(caFilePathIsw *string) {
	o.CaFilePathIsw = caFilePathIsw
}

// WithCaFilePathn adds the caFilePathn to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithCaFilePathn(caFilePathn *string) *ExtrasWebhooksListParams {
	o.SetCaFilePathn(caFilePathn)
	return o
}

// SetCaFilePathn adds the caFilePathN to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetCaFilePathn(caFilePathn *string) {
	o.CaFilePathn = caFilePathn
}

// WithCaFilePathNic adds the caFilePathNic to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithCaFilePathNic(caFilePathNic *string) *ExtrasWebhooksListParams {
	o.SetCaFilePathNic(caFilePathNic)
	return o
}

// SetCaFilePathNic adds the caFilePathNic to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetCaFilePathNic(caFilePathNic *string) {
	o.CaFilePathNic = caFilePathNic
}

// WithCaFilePathNie adds the caFilePathNie to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithCaFilePathNie(caFilePathNie *string) *ExtrasWebhooksListParams {
	o.SetCaFilePathNie(caFilePathNie)
	return o
}

// SetCaFilePathNie adds the caFilePathNie to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetCaFilePathNie(caFilePathNie *string) {
	o.CaFilePathNie = caFilePathNie
}

// WithCaFilePathNiew adds the caFilePathNiew to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithCaFilePathNiew(caFilePathNiew *string) *ExtrasWebhooksListParams {
	o.SetCaFilePathNiew(caFilePathNiew)
	return o
}

// SetCaFilePathNiew adds the caFilePathNiew to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetCaFilePathNiew(caFilePathNiew *string) {
	o.CaFilePathNiew = caFilePathNiew
}

// WithCaFilePathNisw adds the caFilePathNisw to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithCaFilePathNisw(caFilePathNisw *string) *ExtrasWebhooksListParams {
	o.SetCaFilePathNisw(caFilePathNisw)
	return o
}

// SetCaFilePathNisw adds the caFilePathNisw to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetCaFilePathNisw(caFilePathNisw *string) {
	o.CaFilePathNisw = caFilePathNisw
}

// WithContentTypes adds the contentTypes to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithContentTypes(contentTypes *string) *ExtrasWebhooksListParams {
	o.SetContentTypes(contentTypes)
	return o
}

// SetContentTypes adds the contentTypes to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetContentTypes(contentTypes *string) {
	o.ContentTypes = contentTypes
}

// WithContentTypesIc adds the contentTypesIc to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithContentTypesIc(contentTypesIc *string) *ExtrasWebhooksListParams {
	o.SetContentTypesIc(contentTypesIc)
	return o
}

// SetContentTypesIc adds the contentTypesIc to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetContentTypesIc(contentTypesIc *string) {
	o.ContentTypesIc = contentTypesIc
}

// WithContentTypesIe adds the contentTypesIe to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithContentTypesIe(contentTypesIe *string) *ExtrasWebhooksListParams {
	o.SetContentTypesIe(contentTypesIe)
	return o
}

// SetContentTypesIe adds the contentTypesIe to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetContentTypesIe(contentTypesIe *string) {
	o.ContentTypesIe = contentTypesIe
}

// WithContentTypesIew adds the contentTypesIew to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithContentTypesIew(contentTypesIew *string) *ExtrasWebhooksListParams {
	o.SetContentTypesIew(contentTypesIew)
	return o
}

// SetContentTypesIew adds the contentTypesIew to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetContentTypesIew(contentTypesIew *string) {
	o.ContentTypesIew = contentTypesIew
}

// WithContentTypesIsw adds the contentTypesIsw to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithContentTypesIsw(contentTypesIsw *string) *ExtrasWebhooksListParams {
	o.SetContentTypesIsw(contentTypesIsw)
	return o
}

// SetContentTypesIsw adds the contentTypesIsw to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetContentTypesIsw(contentTypesIsw *string) {
	o.ContentTypesIsw = contentTypesIsw
}

// WithContentTypesn adds the contentTypesn to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithContentTypesn(contentTypesn *string) *ExtrasWebhooksListParams {
	o.SetContentTypesn(contentTypesn)
	return o
}

// SetContentTypesn adds the contentTypesN to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetContentTypesn(contentTypesn *string) {
	o.ContentTypesn = contentTypesn
}

// WithContentTypesNic adds the contentTypesNic to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithContentTypesNic(contentTypesNic *string) *ExtrasWebhooksListParams {
	o.SetContentTypesNic(contentTypesNic)
	return o
}

// SetContentTypesNic adds the contentTypesNic to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetContentTypesNic(contentTypesNic *string) {
	o.ContentTypesNic = contentTypesNic
}

// WithContentTypesNie adds the contentTypesNie to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithContentTypesNie(contentTypesNie *string) *ExtrasWebhooksListParams {
	o.SetContentTypesNie(contentTypesNie)
	return o
}

// SetContentTypesNie adds the contentTypesNie to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetContentTypesNie(contentTypesNie *string) {
	o.ContentTypesNie = contentTypesNie
}

// WithContentTypesNiew adds the contentTypesNiew to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithContentTypesNiew(contentTypesNiew *string) *ExtrasWebhooksListParams {
	o.SetContentTypesNiew(contentTypesNiew)
	return o
}

// SetContentTypesNiew adds the contentTypesNiew to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetContentTypesNiew(contentTypesNiew *string) {
	o.ContentTypesNiew = contentTypesNiew
}

// WithContentTypesNisw adds the contentTypesNisw to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithContentTypesNisw(contentTypesNisw *string) *ExtrasWebhooksListParams {
	o.SetContentTypesNisw(contentTypesNisw)
	return o
}

// SetContentTypesNisw adds the contentTypesNisw to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetContentTypesNisw(contentTypesNisw *string) {
	o.ContentTypesNisw = contentTypesNisw
}

// WithEnabled adds the enabled to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithEnabled(enabled *string) *ExtrasWebhooksListParams {
	o.SetEnabled(enabled)
	return o
}

// SetEnabled adds the enabled to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetEnabled(enabled *string) {
	o.Enabled = enabled
}

// WithHTTPContentType adds the hTTPContentType to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithHTTPContentType(hTTPContentType *string) *ExtrasWebhooksListParams {
	o.SetHTTPContentType(hTTPContentType)
	return o
}

// SetHTTPContentType adds the httpContentType to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetHTTPContentType(hTTPContentType *string) {
	o.HTTPContentType = hTTPContentType
}

// WithHTTPContentTypeIc adds the hTTPContentTypeIc to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithHTTPContentTypeIc(hTTPContentTypeIc *string) *ExtrasWebhooksListParams {
	o.SetHTTPContentTypeIc(hTTPContentTypeIc)
	return o
}

// SetHTTPContentTypeIc adds the httpContentTypeIc to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetHTTPContentTypeIc(hTTPContentTypeIc *string) {
	o.HTTPContentTypeIc = hTTPContentTypeIc
}

// WithHTTPContentTypeIe adds the hTTPContentTypeIe to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithHTTPContentTypeIe(hTTPContentTypeIe *string) *ExtrasWebhooksListParams {
	o.SetHTTPContentTypeIe(hTTPContentTypeIe)
	return o
}

// SetHTTPContentTypeIe adds the httpContentTypeIe to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetHTTPContentTypeIe(hTTPContentTypeIe *string) {
	o.HTTPContentTypeIe = hTTPContentTypeIe
}

// WithHTTPContentTypeIew adds the hTTPContentTypeIew to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithHTTPContentTypeIew(hTTPContentTypeIew *string) *ExtrasWebhooksListParams {
	o.SetHTTPContentTypeIew(hTTPContentTypeIew)
	return o
}

// SetHTTPContentTypeIew adds the httpContentTypeIew to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetHTTPContentTypeIew(hTTPContentTypeIew *string) {
	o.HTTPContentTypeIew = hTTPContentTypeIew
}

// WithHTTPContentTypeIsw adds the hTTPContentTypeIsw to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithHTTPContentTypeIsw(hTTPContentTypeIsw *string) *ExtrasWebhooksListParams {
	o.SetHTTPContentTypeIsw(hTTPContentTypeIsw)
	return o
}

// SetHTTPContentTypeIsw adds the httpContentTypeIsw to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetHTTPContentTypeIsw(hTTPContentTypeIsw *string) {
	o.HTTPContentTypeIsw = hTTPContentTypeIsw
}

// WithHTTPContentTypen adds the hTTPContentTypen to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithHTTPContentTypen(hTTPContentTypen *string) *ExtrasWebhooksListParams {
	o.SetHTTPContentTypen(hTTPContentTypen)
	return o
}

// SetHTTPContentTypen adds the httpContentTypeN to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetHTTPContentTypen(hTTPContentTypen *string) {
	o.HTTPContentTypen = hTTPContentTypen
}

// WithHTTPContentTypeNic adds the hTTPContentTypeNic to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithHTTPContentTypeNic(hTTPContentTypeNic *string) *ExtrasWebhooksListParams {
	o.SetHTTPContentTypeNic(hTTPContentTypeNic)
	return o
}

// SetHTTPContentTypeNic adds the httpContentTypeNic to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetHTTPContentTypeNic(hTTPContentTypeNic *string) {
	o.HTTPContentTypeNic = hTTPContentTypeNic
}

// WithHTTPContentTypeNie adds the hTTPContentTypeNie to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithHTTPContentTypeNie(hTTPContentTypeNie *string) *ExtrasWebhooksListParams {
	o.SetHTTPContentTypeNie(hTTPContentTypeNie)
	return o
}

// SetHTTPContentTypeNie adds the httpContentTypeNie to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetHTTPContentTypeNie(hTTPContentTypeNie *string) {
	o.HTTPContentTypeNie = hTTPContentTypeNie
}

// WithHTTPContentTypeNiew adds the hTTPContentTypeNiew to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithHTTPContentTypeNiew(hTTPContentTypeNiew *string) *ExtrasWebhooksListParams {
	o.SetHTTPContentTypeNiew(hTTPContentTypeNiew)
	return o
}

// SetHTTPContentTypeNiew adds the httpContentTypeNiew to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetHTTPContentTypeNiew(hTTPContentTypeNiew *string) {
	o.HTTPContentTypeNiew = hTTPContentTypeNiew
}

// WithHTTPContentTypeNisw adds the hTTPContentTypeNisw to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithHTTPContentTypeNisw(hTTPContentTypeNisw *string) *ExtrasWebhooksListParams {
	o.SetHTTPContentTypeNisw(hTTPContentTypeNisw)
	return o
}

// SetHTTPContentTypeNisw adds the httpContentTypeNisw to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetHTTPContentTypeNisw(hTTPContentTypeNisw *string) {
	o.HTTPContentTypeNisw = hTTPContentTypeNisw
}

// WithHTTPMethod adds the hTTPMethod to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithHTTPMethod(hTTPMethod *string) *ExtrasWebhooksListParams {
	o.SetHTTPMethod(hTTPMethod)
	return o
}

// SetHTTPMethod adds the httpMethod to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetHTTPMethod(hTTPMethod *string) {
	o.HTTPMethod = hTTPMethod
}

// WithHTTPMethodn adds the hTTPMethodn to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithHTTPMethodn(hTTPMethodn *string) *ExtrasWebhooksListParams {
	o.SetHTTPMethodn(hTTPMethodn)
	return o
}

// SetHTTPMethodn adds the httpMethodN to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetHTTPMethodn(hTTPMethodn *string) {
	o.HTTPMethodn = hTTPMethodn
}

// WithID adds the id to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithID(id *string) *ExtrasWebhooksListParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetID(id *string) {
	o.ID = id
}

// WithIDGt adds the iDGt to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithIDGt(iDGt *string) *ExtrasWebhooksListParams {
	o.SetIDGt(iDGt)
	return o
}

// SetIDGt adds the idGt to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetIDGt(iDGt *string) {
	o.IDGt = iDGt
}

// WithIDGte adds the iDGte to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithIDGte(iDGte *string) *ExtrasWebhooksListParams {
	o.SetIDGte(iDGte)
	return o
}

// SetIDGte adds the idGte to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetIDGte(iDGte *string) {
	o.IDGte = iDGte
}

// WithIDLt adds the iDLt to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithIDLt(iDLt *string) *ExtrasWebhooksListParams {
	o.SetIDLt(iDLt)
	return o
}

// SetIDLt adds the idLt to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetIDLt(iDLt *string) {
	o.IDLt = iDLt
}

// WithIDLte adds the iDLte to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithIDLte(iDLte *string) *ExtrasWebhooksListParams {
	o.SetIDLte(iDLte)
	return o
}

// SetIDLte adds the idLte to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetIDLte(iDLte *string) {
	o.IDLte = iDLte
}

// WithIDn adds the iDn to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithIDn(iDn *string) *ExtrasWebhooksListParams {
	o.SetIDn(iDn)
	return o
}

// SetIDn adds the idN to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetIDn(iDn *string) {
	o.IDn = iDn
}

// WithLimit adds the limit to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithLimit(limit *int64) *ExtrasWebhooksListParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithName adds the name to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithName(name *string) *ExtrasWebhooksListParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetName(name *string) {
	o.Name = name
}

// WithNameIc adds the nameIc to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithNameIc(nameIc *string) *ExtrasWebhooksListParams {
	o.SetNameIc(nameIc)
	return o
}

// SetNameIc adds the nameIc to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetNameIc(nameIc *string) {
	o.NameIc = nameIc
}

// WithNameIe adds the nameIe to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithNameIe(nameIe *string) *ExtrasWebhooksListParams {
	o.SetNameIe(nameIe)
	return o
}

// SetNameIe adds the nameIe to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetNameIe(nameIe *string) {
	o.NameIe = nameIe
}

// WithNameIew adds the nameIew to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithNameIew(nameIew *string) *ExtrasWebhooksListParams {
	o.SetNameIew(nameIew)
	return o
}

// SetNameIew adds the nameIew to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetNameIew(nameIew *string) {
	o.NameIew = nameIew
}

// WithNameIsw adds the nameIsw to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithNameIsw(nameIsw *string) *ExtrasWebhooksListParams {
	o.SetNameIsw(nameIsw)
	return o
}

// SetNameIsw adds the nameIsw to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetNameIsw(nameIsw *string) {
	o.NameIsw = nameIsw
}

// WithNamen adds the namen to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithNamen(namen *string) *ExtrasWebhooksListParams {
	o.SetNamen(namen)
	return o
}

// SetNamen adds the nameN to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetNamen(namen *string) {
	o.Namen = namen
}

// WithNameNic adds the nameNic to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithNameNic(nameNic *string) *ExtrasWebhooksListParams {
	o.SetNameNic(nameNic)
	return o
}

// SetNameNic adds the nameNic to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetNameNic(nameNic *string) {
	o.NameNic = nameNic
}

// WithNameNie adds the nameNie to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithNameNie(nameNie *string) *ExtrasWebhooksListParams {
	o.SetNameNie(nameNie)
	return o
}

// SetNameNie adds the nameNie to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetNameNie(nameNie *string) {
	o.NameNie = nameNie
}

// WithNameNiew adds the nameNiew to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithNameNiew(nameNiew *string) *ExtrasWebhooksListParams {
	o.SetNameNiew(nameNiew)
	return o
}

// SetNameNiew adds the nameNiew to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetNameNiew(nameNiew *string) {
	o.NameNiew = nameNiew
}

// WithNameNisw adds the nameNisw to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithNameNisw(nameNisw *string) *ExtrasWebhooksListParams {
	o.SetNameNisw(nameNisw)
	return o
}

// SetNameNisw adds the nameNisw to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetNameNisw(nameNisw *string) {
	o.NameNisw = nameNisw
}

// WithOffset adds the offset to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithOffset(offset *int64) *ExtrasWebhooksListParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithPayloadURL adds the payloadURL to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithPayloadURL(payloadURL *string) *ExtrasWebhooksListParams {
	o.SetPayloadURL(payloadURL)
	return o
}

// SetPayloadURL adds the payloadUrl to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetPayloadURL(payloadURL *string) {
	o.PayloadURL = payloadURL
}

// WithPayloadURLIc adds the payloadURLIc to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithPayloadURLIc(payloadURLIc *string) *ExtrasWebhooksListParams {
	o.SetPayloadURLIc(payloadURLIc)
	return o
}

// SetPayloadURLIc adds the payloadUrlIc to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetPayloadURLIc(payloadURLIc *string) {
	o.PayloadURLIc = payloadURLIc
}

// WithPayloadURLIe adds the payloadURLIe to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithPayloadURLIe(payloadURLIe *string) *ExtrasWebhooksListParams {
	o.SetPayloadURLIe(payloadURLIe)
	return o
}

// SetPayloadURLIe adds the payloadUrlIe to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetPayloadURLIe(payloadURLIe *string) {
	o.PayloadURLIe = payloadURLIe
}

// WithPayloadURLIew adds the payloadURLIew to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithPayloadURLIew(payloadURLIew *string) *ExtrasWebhooksListParams {
	o.SetPayloadURLIew(payloadURLIew)
	return o
}

// SetPayloadURLIew adds the payloadUrlIew to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetPayloadURLIew(payloadURLIew *string) {
	o.PayloadURLIew = payloadURLIew
}

// WithPayloadURLIsw adds the payloadURLIsw to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithPayloadURLIsw(payloadURLIsw *string) *ExtrasWebhooksListParams {
	o.SetPayloadURLIsw(payloadURLIsw)
	return o
}

// SetPayloadURLIsw adds the payloadUrlIsw to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetPayloadURLIsw(payloadURLIsw *string) {
	o.PayloadURLIsw = payloadURLIsw
}

// WithPayloadURLn adds the payloadURLn to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithPayloadURLn(payloadURLn *string) *ExtrasWebhooksListParams {
	o.SetPayloadURLn(payloadURLn)
	return o
}

// SetPayloadURLn adds the payloadUrlN to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetPayloadURLn(payloadURLn *string) {
	o.PayloadURLn = payloadURLn
}

// WithPayloadURLNic adds the payloadURLNic to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithPayloadURLNic(payloadURLNic *string) *ExtrasWebhooksListParams {
	o.SetPayloadURLNic(payloadURLNic)
	return o
}

// SetPayloadURLNic adds the payloadUrlNic to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetPayloadURLNic(payloadURLNic *string) {
	o.PayloadURLNic = payloadURLNic
}

// WithPayloadURLNie adds the payloadURLNie to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithPayloadURLNie(payloadURLNie *string) *ExtrasWebhooksListParams {
	o.SetPayloadURLNie(payloadURLNie)
	return o
}

// SetPayloadURLNie adds the payloadUrlNie to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetPayloadURLNie(payloadURLNie *string) {
	o.PayloadURLNie = payloadURLNie
}

// WithPayloadURLNiew adds the payloadURLNiew to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithPayloadURLNiew(payloadURLNiew *string) *ExtrasWebhooksListParams {
	o.SetPayloadURLNiew(payloadURLNiew)
	return o
}

// SetPayloadURLNiew adds the payloadUrlNiew to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetPayloadURLNiew(payloadURLNiew *string) {
	o.PayloadURLNiew = payloadURLNiew
}

// WithPayloadURLNisw adds the payloadURLNisw to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithPayloadURLNisw(payloadURLNisw *string) *ExtrasWebhooksListParams {
	o.SetPayloadURLNisw(payloadURLNisw)
	return o
}

// SetPayloadURLNisw adds the payloadUrlNisw to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetPayloadURLNisw(payloadURLNisw *string) {
	o.PayloadURLNisw = payloadURLNisw
}

// WithQ adds the q to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithQ(q *string) *ExtrasWebhooksListParams {
	o.SetQ(q)
	return o
}

// SetQ adds the q to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetQ(q *string) {
	o.Q = q
}

// WithSecret adds the secret to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithSecret(secret *string) *ExtrasWebhooksListParams {
	o.SetSecret(secret)
	return o
}

// SetSecret adds the secret to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetSecret(secret *string) {
	o.Secret = secret
}

// WithSecretIc adds the secretIc to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithSecretIc(secretIc *string) *ExtrasWebhooksListParams {
	o.SetSecretIc(secretIc)
	return o
}

// SetSecretIc adds the secretIc to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetSecretIc(secretIc *string) {
	o.SecretIc = secretIc
}

// WithSecretIe adds the secretIe to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithSecretIe(secretIe *string) *ExtrasWebhooksListParams {
	o.SetSecretIe(secretIe)
	return o
}

// SetSecretIe adds the secretIe to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetSecretIe(secretIe *string) {
	o.SecretIe = secretIe
}

// WithSecretIew adds the secretIew to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithSecretIew(secretIew *string) *ExtrasWebhooksListParams {
	o.SetSecretIew(secretIew)
	return o
}

// SetSecretIew adds the secretIew to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetSecretIew(secretIew *string) {
	o.SecretIew = secretIew
}

// WithSecretIsw adds the secretIsw to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithSecretIsw(secretIsw *string) *ExtrasWebhooksListParams {
	o.SetSecretIsw(secretIsw)
	return o
}

// SetSecretIsw adds the secretIsw to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetSecretIsw(secretIsw *string) {
	o.SecretIsw = secretIsw
}

// WithSecretn adds the secretn to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithSecretn(secretn *string) *ExtrasWebhooksListParams {
	o.SetSecretn(secretn)
	return o
}

// SetSecretn adds the secretN to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetSecretn(secretn *string) {
	o.Secretn = secretn
}

// WithSecretNic adds the secretNic to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithSecretNic(secretNic *string) *ExtrasWebhooksListParams {
	o.SetSecretNic(secretNic)
	return o
}

// SetSecretNic adds the secretNic to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetSecretNic(secretNic *string) {
	o.SecretNic = secretNic
}

// WithSecretNie adds the secretNie to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithSecretNie(secretNie *string) *ExtrasWebhooksListParams {
	o.SetSecretNie(secretNie)
	return o
}

// SetSecretNie adds the secretNie to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetSecretNie(secretNie *string) {
	o.SecretNie = secretNie
}

// WithSecretNiew adds the secretNiew to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithSecretNiew(secretNiew *string) *ExtrasWebhooksListParams {
	o.SetSecretNiew(secretNiew)
	return o
}

// SetSecretNiew adds the secretNiew to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetSecretNiew(secretNiew *string) {
	o.SecretNiew = secretNiew
}

// WithSecretNisw adds the secretNisw to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithSecretNisw(secretNisw *string) *ExtrasWebhooksListParams {
	o.SetSecretNisw(secretNisw)
	return o
}

// SetSecretNisw adds the secretNisw to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetSecretNisw(secretNisw *string) {
	o.SecretNisw = secretNisw
}

// WithSslVerification adds the sslVerification to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithSslVerification(sslVerification *string) *ExtrasWebhooksListParams {
	o.SetSslVerification(sslVerification)
	return o
}

// SetSslVerification adds the sslVerification to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetSslVerification(sslVerification *string) {
	o.SslVerification = sslVerification
}

// WithTypeCreate adds the typeCreate to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithTypeCreate(typeCreate *string) *ExtrasWebhooksListParams {
	o.SetTypeCreate(typeCreate)
	return o
}

// SetTypeCreate adds the typeCreate to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetTypeCreate(typeCreate *string) {
	o.TypeCreate = typeCreate
}

// WithTypeDelete adds the typeDelete to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithTypeDelete(typeDelete *string) *ExtrasWebhooksListParams {
	o.SetTypeDelete(typeDelete)
	return o
}

// SetTypeDelete adds the typeDelete to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetTypeDelete(typeDelete *string) {
	o.TypeDelete = typeDelete
}

// WithTypeUpdate adds the typeUpdate to the extras webhooks list params
func (o *ExtrasWebhooksListParams) WithTypeUpdate(typeUpdate *string) *ExtrasWebhooksListParams {
	o.SetTypeUpdate(typeUpdate)
	return o
}

// SetTypeUpdate adds the typeUpdate to the extras webhooks list params
func (o *ExtrasWebhooksListParams) SetTypeUpdate(typeUpdate *string) {
	o.TypeUpdate = typeUpdate
}

// WriteToRequest writes these params to a swagger request
func (o *ExtrasWebhooksListParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.CaFilePath != nil {

		// query param ca_file_path
		var qrCaFilePath string

		if o.CaFilePath != nil {
			qrCaFilePath = *o.CaFilePath
		}
		qCaFilePath := qrCaFilePath
		if qCaFilePath != "" {

			if err := r.SetQueryParam("ca_file_path", qCaFilePath); err != nil {
				return err
			}
		}
	}

	if o.CaFilePathIc != nil {

		// query param ca_file_path__ic
		var qrCaFilePathIc string

		if o.CaFilePathIc != nil {
			qrCaFilePathIc = *o.CaFilePathIc
		}
		qCaFilePathIc := qrCaFilePathIc
		if qCaFilePathIc != "" {

			if err := r.SetQueryParam("ca_file_path__ic", qCaFilePathIc); err != nil {
				return err
			}
		}
	}

	if o.CaFilePathIe != nil {

		// query param ca_file_path__ie
		var qrCaFilePathIe string

		if o.CaFilePathIe != nil {
			qrCaFilePathIe = *o.CaFilePathIe
		}
		qCaFilePathIe := qrCaFilePathIe
		if qCaFilePathIe != "" {

			if err := r.SetQueryParam("ca_file_path__ie", qCaFilePathIe); err != nil {
				return err
			}
		}
	}

	if o.CaFilePathIew != nil {

		// query param ca_file_path__iew
		var qrCaFilePathIew string

		if o.CaFilePathIew != nil {
			qrCaFilePathIew = *o.CaFilePathIew
		}
		qCaFilePathIew := qrCaFilePathIew
		if qCaFilePathIew != "" {

			if err := r.SetQueryParam("ca_file_path__iew", qCaFilePathIew); err != nil {
				return err
			}
		}
	}

	if o.CaFilePathIsw != nil {

		// query param ca_file_path__isw
		var qrCaFilePathIsw string

		if o.CaFilePathIsw != nil {
			qrCaFilePathIsw = *o.CaFilePathIsw
		}
		qCaFilePathIsw := qrCaFilePathIsw
		if qCaFilePathIsw != "" {

			if err := r.SetQueryParam("ca_file_path__isw", qCaFilePathIsw); err != nil {
				return err
			}
		}
	}

	if o.CaFilePathn != nil {

		// query param ca_file_path__n
		var qrCaFilePathn string

		if o.CaFilePathn != nil {
			qrCaFilePathn = *o.CaFilePathn
		}
		qCaFilePathn := qrCaFilePathn
		if qCaFilePathn != "" {

			if err := r.SetQueryParam("ca_file_path__n", qCaFilePathn); err != nil {
				return err
			}
		}
	}

	if o.CaFilePathNic != nil {

		// query param ca_file_path__nic
		var qrCaFilePathNic string

		if o.CaFilePathNic != nil {
			qrCaFilePathNic = *o.CaFilePathNic
		}
		qCaFilePathNic := qrCaFilePathNic
		if qCaFilePathNic != "" {

			if err := r.SetQueryParam("ca_file_path__nic", qCaFilePathNic); err != nil {
				return err
			}
		}
	}

	if o.CaFilePathNie != nil {

		// query param ca_file_path__nie
		var qrCaFilePathNie string

		if o.CaFilePathNie != nil {
			qrCaFilePathNie = *o.CaFilePathNie
		}
		qCaFilePathNie := qrCaFilePathNie
		if qCaFilePathNie != "" {

			if err := r.SetQueryParam("ca_file_path__nie", qCaFilePathNie); err != nil {
				return err
			}
		}
	}

	if o.CaFilePathNiew != nil {

		// query param ca_file_path__niew
		var qrCaFilePathNiew string

		if o.CaFilePathNiew != nil {
			qrCaFilePathNiew = *o.CaFilePathNiew
		}
		qCaFilePathNiew := qrCaFilePathNiew
		if qCaFilePathNiew != "" {

			if err := r.SetQueryParam("ca_file_path__niew", qCaFilePathNiew); err != nil {
				return err
			}
		}
	}

	if o.CaFilePathNisw != nil {

		// query param ca_file_path__nisw
		var qrCaFilePathNisw string

		if o.CaFilePathNisw != nil {
			qrCaFilePathNisw = *o.CaFilePathNisw
		}
		qCaFilePathNisw := qrCaFilePathNisw
		if qCaFilePathNisw != "" {

			if err := r.SetQueryParam("ca_file_path__nisw", qCaFilePathNisw); err != nil {
				return err
			}
		}
	}

	if o.ContentTypes != nil {

		// query param content_types
		var qrContentTypes string

		if o.ContentTypes != nil {
			qrContentTypes = *o.ContentTypes
		}
		qContentTypes := qrContentTypes
		if qContentTypes != "" {

			if err := r.SetQueryParam("content_types", qContentTypes); err != nil {
				return err
			}
		}
	}

	if o.ContentTypesIc != nil {

		// query param content_types__ic
		var qrContentTypesIc string

		if o.ContentTypesIc != nil {
			qrContentTypesIc = *o.ContentTypesIc
		}
		qContentTypesIc := qrContentTypesIc
		if qContentTypesIc != "" {

			if err := r.SetQueryParam("content_types__ic", qContentTypesIc); err != nil {
				return err
			}
		}
	}

	if o.ContentTypesIe != nil {

		// query param content_types__ie
		var qrContentTypesIe string

		if o.ContentTypesIe != nil {
			qrContentTypesIe = *o.ContentTypesIe
		}
		qContentTypesIe := qrContentTypesIe
		if qContentTypesIe != "" {

			if err := r.SetQueryParam("content_types__ie", qContentTypesIe); err != nil {
				return err
			}
		}
	}

	if o.ContentTypesIew != nil {

		// query param content_types__iew
		var qrContentTypesIew string

		if o.ContentTypesIew != nil {
			qrContentTypesIew = *o.ContentTypesIew
		}
		qContentTypesIew := qrContentTypesIew
		if qContentTypesIew != "" {

			if err := r.SetQueryParam("content_types__iew", qContentTypesIew); err != nil {
				return err
			}
		}
	}

	if o.ContentTypesIsw != nil {

		// query param content_types__isw
		var qrContentTypesIsw string

		if o.ContentTypesIsw != nil {
			qrContentTypesIsw = *o.ContentTypesIsw
		}
		qContentTypesIsw := qrContentTypesIsw
		if qContentTypesIsw != "" {

			if err := r.SetQueryParam("content_types__isw", qContentTypesIsw); err != nil {
				return err
			}
		}
	}

	if o.ContentTypesn != nil {

		// query param content_types__n
		var qrContentTypesn string

		if o.ContentTypesn != nil {
			qrContentTypesn = *o.ContentTypesn
		}
		qContentTypesn := qrContentTypesn
		if qContentTypesn != "" {

			if err := r.SetQueryParam("content_types__n", qContentTypesn); err != nil {
				return err
			}
		}
	}

	if o.ContentTypesNic != nil {

		// query param content_types__nic
		var qrContentTypesNic string

		if o.ContentTypesNic != nil {
			qrContentTypesNic = *o.ContentTypesNic
		}
		qContentTypesNic := qrContentTypesNic
		if qContentTypesNic != "" {

			if err := r.SetQueryParam("content_types__nic", qContentTypesNic); err != nil {
				return err
			}
		}
	}

	if o.ContentTypesNie != nil {

		// query param content_types__nie
		var qrContentTypesNie string

		if o.ContentTypesNie != nil {
			qrContentTypesNie = *o.ContentTypesNie
		}
		qContentTypesNie := qrContentTypesNie
		if qContentTypesNie != "" {

			if err := r.SetQueryParam("content_types__nie", qContentTypesNie); err != nil {
				return err
			}
		}
	}

	if o.ContentTypesNiew != nil {

		// query param content_types__niew
		var qrContentTypesNiew string

		if o.ContentTypesNiew != nil {
			qrContentTypesNiew = *o.ContentTypesNiew
		}
		qContentTypesNiew := qrContentTypesNiew
		if qContentTypesNiew != "" {

			if err := r.SetQueryParam("content_types__niew", qContentTypesNiew); err != nil {
				return err
			}
		}
	}

	if o.ContentTypesNisw != nil {

		// query param content_types__nisw
		var qrContentTypesNisw string

		if o.ContentTypesNisw != nil {
			qrContentTypesNisw = *o.ContentTypesNisw
		}
		qContentTypesNisw := qrContentTypesNisw
		if qContentTypesNisw != "" {

			if err := r.SetQueryParam("content_types__nisw", qContentTypesNisw); err != nil {
				return err
			}
		}
	}

	if o.Enabled != nil {

		// query param enabled
		var qrEnabled string

		if o.Enabled != nil {
			qrEnabled = *o.Enabled
		}
		qEnabled := qrEnabled
		if qEnabled != "" {

			if err := r.SetQueryParam("enabled", qEnabled); err != nil {
				return err
			}
		}
	}

	if o.HTTPContentType != nil {

		// query param http_content_type
		var qrHTTPContentType string

		if o.HTTPContentType != nil {
			qrHTTPContentType = *o.HTTPContentType
		}
		qHTTPContentType := qrHTTPContentType
		if qHTTPContentType != "" {

			if err := r.SetQueryParam("http_content_type", qHTTPContentType); err != nil {
				return err
			}
		}
	}

	if o.HTTPContentTypeIc != nil {

		// query param http_content_type__ic
		var qrHTTPContentTypeIc string

		if o.HTTPContentTypeIc != nil {
			qrHTTPContentTypeIc = *o.HTTPContentTypeIc
		}
		qHTTPContentTypeIc := qrHTTPContentTypeIc
		if qHTTPContentTypeIc != "" {

			if err := r.SetQueryParam("http_content_type__ic", qHTTPContentTypeIc); err != nil {
				return err
			}
		}
	}

	if o.HTTPContentTypeIe != nil {

		// query param http_content_type__ie
		var qrHTTPContentTypeIe string

		if o.HTTPContentTypeIe != nil {
			qrHTTPContentTypeIe = *o.HTTPContentTypeIe
		}
		qHTTPContentTypeIe := qrHTTPContentTypeIe
		if qHTTPContentTypeIe != "" {

			if err := r.SetQueryParam("http_content_type__ie", qHTTPContentTypeIe); err != nil {
				return err
			}
		}
	}

	if o.HTTPContentTypeIew != nil {

		// query param http_content_type__iew
		var qrHTTPContentTypeIew string

		if o.HTTPContentTypeIew != nil {
			qrHTTPContentTypeIew = *o.HTTPContentTypeIew
		}
		qHTTPContentTypeIew := qrHTTPContentTypeIew
		if qHTTPContentTypeIew != "" {

			if err := r.SetQueryParam("http_content_type__iew", qHTTPContentTypeIew); err != nil {
				return err
			}
		}
	}

	if o.HTTPContentTypeIsw != nil {

		// query param http_content_type__isw
		var qrHTTPContentTypeIsw string

		if o.HTTPContentTypeIsw != nil {
			qrHTTPContentTypeIsw = *o.HTTPContentTypeIsw
		}
		qHTTPContentTypeIsw := qrHTTPContentTypeIsw
		if qHTTPContentTypeIsw != "" {

			if err := r.SetQueryParam("http_content_type__isw", qHTTPContentTypeIsw); err != nil {
				return err
			}
		}
	}

	if o.HTTPContentTypen != nil {

		// query param http_content_type__n
		var qrHTTPContentTypen string

		if o.HTTPContentTypen != nil {
			qrHTTPContentTypen = *o.HTTPContentTypen
		}
		qHTTPContentTypen := qrHTTPContentTypen
		if qHTTPContentTypen != "" {

			if err := r.SetQueryParam("http_content_type__n", qHTTPContentTypen); err != nil {
				return err
			}
		}
	}

	if o.HTTPContentTypeNic != nil {

		// query param http_content_type__nic
		var qrHTTPContentTypeNic string

		if o.HTTPContentTypeNic != nil {
			qrHTTPContentTypeNic = *o.HTTPContentTypeNic
		}
		qHTTPContentTypeNic := qrHTTPContentTypeNic
		if qHTTPContentTypeNic != "" {

			if err := r.SetQueryParam("http_content_type__nic", qHTTPContentTypeNic); err != nil {
				return err
			}
		}
	}

	if o.HTTPContentTypeNie != nil {

		// query param http_content_type__nie
		var qrHTTPContentTypeNie string

		if o.HTTPContentTypeNie != nil {
			qrHTTPContentTypeNie = *o.HTTPContentTypeNie
		}
		qHTTPContentTypeNie := qrHTTPContentTypeNie
		if qHTTPContentTypeNie != "" {

			if err := r.SetQueryParam("http_content_type__nie", qHTTPContentTypeNie); err != nil {
				return err
			}
		}
	}

	if o.HTTPContentTypeNiew != nil {

		// query param http_content_type__niew
		var qrHTTPContentTypeNiew string

		if o.HTTPContentTypeNiew != nil {
			qrHTTPContentTypeNiew = *o.HTTPContentTypeNiew
		}
		qHTTPContentTypeNiew := qrHTTPContentTypeNiew
		if qHTTPContentTypeNiew != "" {

			if err := r.SetQueryParam("http_content_type__niew", qHTTPContentTypeNiew); err != nil {
				return err
			}
		}
	}

	if o.HTTPContentTypeNisw != nil {

		// query param http_content_type__nisw
		var qrHTTPContentTypeNisw string

		if o.HTTPContentTypeNisw != nil {
			qrHTTPContentTypeNisw = *o.HTTPContentTypeNisw
		}
		qHTTPContentTypeNisw := qrHTTPContentTypeNisw
		if qHTTPContentTypeNisw != "" {

			if err := r.SetQueryParam("http_content_type__nisw", qHTTPContentTypeNisw); err != nil {
				return err
			}
		}
	}

	if o.HTTPMethod != nil {

		// query param http_method
		var qrHTTPMethod string

		if o.HTTPMethod != nil {
			qrHTTPMethod = *o.HTTPMethod
		}
		qHTTPMethod := qrHTTPMethod
		if qHTTPMethod != "" {

			if err := r.SetQueryParam("http_method", qHTTPMethod); err != nil {
				return err
			}
		}
	}

	if o.HTTPMethodn != nil {

		// query param http_method__n
		var qrHTTPMethodn string

		if o.HTTPMethodn != nil {
			qrHTTPMethodn = *o.HTTPMethodn
		}
		qHTTPMethodn := qrHTTPMethodn
		if qHTTPMethodn != "" {

			if err := r.SetQueryParam("http_method__n", qHTTPMethodn); err != nil {
				return err
			}
		}
	}

	if o.ID != nil {

		// query param id
		var qrID string

		if o.ID != nil {
			qrID = *o.ID
		}
		qID := qrID
		if qID != "" {

			if err := r.SetQueryParam("id", qID); err != nil {
				return err
			}
		}
	}

	if o.IDGt != nil {

		// query param id__gt
		var qrIDGt string

		if o.IDGt != nil {
			qrIDGt = *o.IDGt
		}
		qIDGt := qrIDGt
		if qIDGt != "" {

			if err := r.SetQueryParam("id__gt", qIDGt); err != nil {
				return err
			}
		}
	}

	if o.IDGte != nil {

		// query param id__gte
		var qrIDGte string

		if o.IDGte != nil {
			qrIDGte = *o.IDGte
		}
		qIDGte := qrIDGte
		if qIDGte != "" {

			if err := r.SetQueryParam("id__gte", qIDGte); err != nil {
				return err
			}
		}
	}

	if o.IDLt != nil {

		// query param id__lt
		var qrIDLt string

		if o.IDLt != nil {
			qrIDLt = *o.IDLt
		}
		qIDLt := qrIDLt
		if qIDLt != "" {

			if err := r.SetQueryParam("id__lt", qIDLt); err != nil {
				return err
			}
		}
	}

	if o.IDLte != nil {

		// query param id__lte
		var qrIDLte string

		if o.IDLte != nil {
			qrIDLte = *o.IDLte
		}
		qIDLte := qrIDLte
		if qIDLte != "" {

			if err := r.SetQueryParam("id__lte", qIDLte); err != nil {
				return err
			}
		}
	}

	if o.IDn != nil {

		// query param id__n
		var qrIDn string

		if o.IDn != nil {
			qrIDn = *o.IDn
		}
		qIDn := qrIDn
		if qIDn != "" {

			if err := r.SetQueryParam("id__n", qIDn); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Name != nil {

		// query param name
		var qrName string

		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.NameIc != nil {

		// query param name__ic
		var qrNameIc string

		if o.NameIc != nil {
			qrNameIc = *o.NameIc
		}
		qNameIc := qrNameIc
		if qNameIc != "" {

			if err := r.SetQueryParam("name__ic", qNameIc); err != nil {
				return err
			}
		}
	}

	if o.NameIe != nil {

		// query param name__ie
		var qrNameIe string

		if o.NameIe != nil {
			qrNameIe = *o.NameIe
		}
		qNameIe := qrNameIe
		if qNameIe != "" {

			if err := r.SetQueryParam("name__ie", qNameIe); err != nil {
				return err
			}
		}
	}

	if o.NameIew != nil {

		// query param name__iew
		var qrNameIew string

		if o.NameIew != nil {
			qrNameIew = *o.NameIew
		}
		qNameIew := qrNameIew
		if qNameIew != "" {

			if err := r.SetQueryParam("name__iew", qNameIew); err != nil {
				return err
			}
		}
	}

	if o.NameIsw != nil {

		// query param name__isw
		var qrNameIsw string

		if o.NameIsw != nil {
			qrNameIsw = *o.NameIsw
		}
		qNameIsw := qrNameIsw
		if qNameIsw != "" {

			if err := r.SetQueryParam("name__isw", qNameIsw); err != nil {
				return err
			}
		}
	}

	if o.Namen != nil {

		// query param name__n
		var qrNamen string

		if o.Namen != nil {
			qrNamen = *o.Namen
		}
		qNamen := qrNamen
		if qNamen != "" {

			if err := r.SetQueryParam("name__n", qNamen); err != nil {
				return err
			}
		}
	}

	if o.NameNic != nil {

		// query param name__nic
		var qrNameNic string

		if o.NameNic != nil {
			qrNameNic = *o.NameNic
		}
		qNameNic := qrNameNic
		if qNameNic != "" {

			if err := r.SetQueryParam("name__nic", qNameNic); err != nil {
				return err
			}
		}
	}

	if o.NameNie != nil {

		// query param name__nie
		var qrNameNie string

		if o.NameNie != nil {
			qrNameNie = *o.NameNie
		}
		qNameNie := qrNameNie
		if qNameNie != "" {

			if err := r.SetQueryParam("name__nie", qNameNie); err != nil {
				return err
			}
		}
	}

	if o.NameNiew != nil {

		// query param name__niew
		var qrNameNiew string

		if o.NameNiew != nil {
			qrNameNiew = *o.NameNiew
		}
		qNameNiew := qrNameNiew
		if qNameNiew != "" {

			if err := r.SetQueryParam("name__niew", qNameNiew); err != nil {
				return err
			}
		}
	}

	if o.NameNisw != nil {

		// query param name__nisw
		var qrNameNisw string

		if o.NameNisw != nil {
			qrNameNisw = *o.NameNisw
		}
		qNameNisw := qrNameNisw
		if qNameNisw != "" {

			if err := r.SetQueryParam("name__nisw", qNameNisw); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if o.PayloadURL != nil {

		// query param payload_url
		var qrPayloadURL string

		if o.PayloadURL != nil {
			qrPayloadURL = *o.PayloadURL
		}
		qPayloadURL := qrPayloadURL
		if qPayloadURL != "" {

			if err := r.SetQueryParam("payload_url", qPayloadURL); err != nil {
				return err
			}
		}
	}

	if o.PayloadURLIc != nil {

		// query param payload_url__ic
		var qrPayloadURLIc string

		if o.PayloadURLIc != nil {
			qrPayloadURLIc = *o.PayloadURLIc
		}
		qPayloadURLIc := qrPayloadURLIc
		if qPayloadURLIc != "" {

			if err := r.SetQueryParam("payload_url__ic", qPayloadURLIc); err != nil {
				return err
			}
		}
	}

	if o.PayloadURLIe != nil {

		// query param payload_url__ie
		var qrPayloadURLIe string

		if o.PayloadURLIe != nil {
			qrPayloadURLIe = *o.PayloadURLIe
		}
		qPayloadURLIe := qrPayloadURLIe
		if qPayloadURLIe != "" {

			if err := r.SetQueryParam("payload_url__ie", qPayloadURLIe); err != nil {
				return err
			}
		}
	}

	if o.PayloadURLIew != nil {

		// query param payload_url__iew
		var qrPayloadURLIew string

		if o.PayloadURLIew != nil {
			qrPayloadURLIew = *o.PayloadURLIew
		}
		qPayloadURLIew := qrPayloadURLIew
		if qPayloadURLIew != "" {

			if err := r.SetQueryParam("payload_url__iew", qPayloadURLIew); err != nil {
				return err
			}
		}
	}

	if o.PayloadURLIsw != nil {

		// query param payload_url__isw
		var qrPayloadURLIsw string

		if o.PayloadURLIsw != nil {
			qrPayloadURLIsw = *o.PayloadURLIsw
		}
		qPayloadURLIsw := qrPayloadURLIsw
		if qPayloadURLIsw != "" {

			if err := r.SetQueryParam("payload_url__isw", qPayloadURLIsw); err != nil {
				return err
			}
		}
	}

	if o.PayloadURLn != nil {

		// query param payload_url__n
		var qrPayloadURLn string

		if o.PayloadURLn != nil {
			qrPayloadURLn = *o.PayloadURLn
		}
		qPayloadURLn := qrPayloadURLn
		if qPayloadURLn != "" {

			if err := r.SetQueryParam("payload_url__n", qPayloadURLn); err != nil {
				return err
			}
		}
	}

	if o.PayloadURLNic != nil {

		// query param payload_url__nic
		var qrPayloadURLNic string

		if o.PayloadURLNic != nil {
			qrPayloadURLNic = *o.PayloadURLNic
		}
		qPayloadURLNic := qrPayloadURLNic
		if qPayloadURLNic != "" {

			if err := r.SetQueryParam("payload_url__nic", qPayloadURLNic); err != nil {
				return err
			}
		}
	}

	if o.PayloadURLNie != nil {

		// query param payload_url__nie
		var qrPayloadURLNie string

		if o.PayloadURLNie != nil {
			qrPayloadURLNie = *o.PayloadURLNie
		}
		qPayloadURLNie := qrPayloadURLNie
		if qPayloadURLNie != "" {

			if err := r.SetQueryParam("payload_url__nie", qPayloadURLNie); err != nil {
				return err
			}
		}
	}

	if o.PayloadURLNiew != nil {

		// query param payload_url__niew
		var qrPayloadURLNiew string

		if o.PayloadURLNiew != nil {
			qrPayloadURLNiew = *o.PayloadURLNiew
		}
		qPayloadURLNiew := qrPayloadURLNiew
		if qPayloadURLNiew != "" {

			if err := r.SetQueryParam("payload_url__niew", qPayloadURLNiew); err != nil {
				return err
			}
		}
	}

	if o.PayloadURLNisw != nil {

		// query param payload_url__nisw
		var qrPayloadURLNisw string

		if o.PayloadURLNisw != nil {
			qrPayloadURLNisw = *o.PayloadURLNisw
		}
		qPayloadURLNisw := qrPayloadURLNisw
		if qPayloadURLNisw != "" {

			if err := r.SetQueryParam("payload_url__nisw", qPayloadURLNisw); err != nil {
				return err
			}
		}
	}

	if o.Q != nil {

		// query param q
		var qrQ string

		if o.Q != nil {
			qrQ = *o.Q
		}
		qQ := qrQ
		if qQ != "" {

			if err := r.SetQueryParam("q", qQ); err != nil {
				return err
			}
		}
	}

	if o.Secret != nil {

		// query param secret
		var qrSecret string

		if o.Secret != nil {
			qrSecret = *o.Secret
		}
		qSecret := qrSecret
		if qSecret != "" {

			if err := r.SetQueryParam("secret", qSecret); err != nil {
				return err
			}
		}
	}

	if o.SecretIc != nil {

		// query param secret__ic
		var qrSecretIc string

		if o.SecretIc != nil {
			qrSecretIc = *o.SecretIc
		}
		qSecretIc := qrSecretIc
		if qSecretIc != "" {

			if err := r.SetQueryParam("secret__ic", qSecretIc); err != nil {
				return err
			}
		}
	}

	if o.SecretIe != nil {

		// query param secret__ie
		var qrSecretIe string

		if o.SecretIe != nil {
			qrSecretIe = *o.SecretIe
		}
		qSecretIe := qrSecretIe
		if qSecretIe != "" {

			if err := r.SetQueryParam("secret__ie", qSecretIe); err != nil {
				return err
			}
		}
	}

	if o.SecretIew != nil {

		// query param secret__iew
		var qrSecretIew string

		if o.SecretIew != nil {
			qrSecretIew = *o.SecretIew
		}
		qSecretIew := qrSecretIew
		if qSecretIew != "" {

			if err := r.SetQueryParam("secret__iew", qSecretIew); err != nil {
				return err
			}
		}
	}

	if o.SecretIsw != nil {

		// query param secret__isw
		var qrSecretIsw string

		if o.SecretIsw != nil {
			qrSecretIsw = *o.SecretIsw
		}
		qSecretIsw := qrSecretIsw
		if qSecretIsw != "" {

			if err := r.SetQueryParam("secret__isw", qSecretIsw); err != nil {
				return err
			}
		}
	}

	if o.Secretn != nil {

		// query param secret__n
		var qrSecretn string

		if o.Secretn != nil {
			qrSecretn = *o.Secretn
		}
		qSecretn := qrSecretn
		if qSecretn != "" {

			if err := r.SetQueryParam("secret__n", qSecretn); err != nil {
				return err
			}
		}
	}

	if o.SecretNic != nil {

		// query param secret__nic
		var qrSecretNic string

		if o.SecretNic != nil {
			qrSecretNic = *o.SecretNic
		}
		qSecretNic := qrSecretNic
		if qSecretNic != "" {

			if err := r.SetQueryParam("secret__nic", qSecretNic); err != nil {
				return err
			}
		}
	}

	if o.SecretNie != nil {

		// query param secret__nie
		var qrSecretNie string

		if o.SecretNie != nil {
			qrSecretNie = *o.SecretNie
		}
		qSecretNie := qrSecretNie
		if qSecretNie != "" {

			if err := r.SetQueryParam("secret__nie", qSecretNie); err != nil {
				return err
			}
		}
	}

	if o.SecretNiew != nil {

		// query param secret__niew
		var qrSecretNiew string

		if o.SecretNiew != nil {
			qrSecretNiew = *o.SecretNiew
		}
		qSecretNiew := qrSecretNiew
		if qSecretNiew != "" {

			if err := r.SetQueryParam("secret__niew", qSecretNiew); err != nil {
				return err
			}
		}
	}

	if o.SecretNisw != nil {

		// query param secret__nisw
		var qrSecretNisw string

		if o.SecretNisw != nil {
			qrSecretNisw = *o.SecretNisw
		}
		qSecretNisw := qrSecretNisw
		if qSecretNisw != "" {

			if err := r.SetQueryParam("secret__nisw", qSecretNisw); err != nil {
				return err
			}
		}
	}

	if o.SslVerification != nil {

		// query param ssl_verification
		var qrSslVerification string

		if o.SslVerification != nil {
			qrSslVerification = *o.SslVerification
		}
		qSslVerification := qrSslVerification
		if qSslVerification != "" {

			if err := r.SetQueryParam("ssl_verification", qSslVerification); err != nil {
				return err
			}
		}
	}

	if o.TypeCreate != nil {

		// query param type_create
		var qrTypeCreate string

		if o.TypeCreate != nil {
			qrTypeCreate = *o.TypeCreate
		}
		qTypeCreate := qrTypeCreate
		if qTypeCreate != "" {

			if err := r.SetQueryParam("type_create", qTypeCreate); err != nil {
				return err
			}
		}
	}

	if o.TypeDelete != nil {

		// query param type_delete
		var qrTypeDelete string

		if o.TypeDelete != nil {
			qrTypeDelete = *o.TypeDelete
		}
		qTypeDelete := qrTypeDelete
		if qTypeDelete != "" {

			if err := r.SetQueryParam("type_delete", qTypeDelete); err != nil {
				return err
			}
		}
	}

	if o.TypeUpdate != nil {

		// query param type_update
		var qrTypeUpdate string

		if o.TypeUpdate != nil {
			qrTypeUpdate = *o.TypeUpdate
		}
		qTypeUpdate := qrTypeUpdate
		if qTypeUpdate != "" {

			if err := r.SetQueryParam("type_update", qTypeUpdate); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
