// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2020 The go-netbox Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package ipam

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewIpamAsnsListParams creates a new IpamAsnsListParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIpamAsnsListParams() *IpamAsnsListParams {
	return &IpamAsnsListParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIpamAsnsListParamsWithTimeout creates a new IpamAsnsListParams object
// with the ability to set a timeout on a request.
func NewIpamAsnsListParamsWithTimeout(timeout time.Duration) *IpamAsnsListParams {
	return &IpamAsnsListParams{
		timeout: timeout,
	}
}

// NewIpamAsnsListParamsWithContext creates a new IpamAsnsListParams object
// with the ability to set a context for a request.
func NewIpamAsnsListParamsWithContext(ctx context.Context) *IpamAsnsListParams {
	return &IpamAsnsListParams{
		Context: ctx,
	}
}

// NewIpamAsnsListParamsWithHTTPClient creates a new IpamAsnsListParams object
// with the ability to set a custom HTTPClient for a request.
func NewIpamAsnsListParamsWithHTTPClient(client *http.Client) *IpamAsnsListParams {
	return &IpamAsnsListParams{
		HTTPClient: client,
	}
}

/* IpamAsnsListParams contains all the parameters to send to the API endpoint
   for the ipam asns list operation.

   Typically these are written to a http.Request.
*/
type IpamAsnsListParams struct {

	// Asn.
	Asn *string

	// AsnGt.
	AsnGt *string

	// AsnGte.
	AsnGte *string

	// AsnLt.
	AsnLt *string

	// AsnLte.
	AsnLte *string

	// Asnn.
	Asnn *string

	// Created.
	Created *string

	// CreatedGte.
	CreatedGte *string

	// CreatedLte.
	CreatedLte *string

	// Description.
	Description *string

	// DescriptionIc.
	DescriptionIc *string

	// DescriptionIe.
	DescriptionIe *string

	// DescriptionIew.
	DescriptionIew *string

	// DescriptionIsw.
	DescriptionIsw *string

	// Descriptionn.
	Descriptionn *string

	// DescriptionNic.
	DescriptionNic *string

	// DescriptionNie.
	DescriptionNie *string

	// DescriptionNiew.
	DescriptionNiew *string

	// DescriptionNisw.
	DescriptionNisw *string

	// ID.
	ID *string

	// IDGt.
	IDGt *string

	// IDGte.
	IDGte *string

	// IDLt.
	IDLt *string

	// IDLte.
	IDLte *string

	// IDn.
	IDn *string

	// LastUpdated.
	LastUpdated *string

	// LastUpdatedGte.
	LastUpdatedGte *string

	// LastUpdatedLte.
	LastUpdatedLte *string

	/* Limit.

	   Number of results to return per page.
	*/
	Limit *int64

	/* Offset.

	   The initial index from which to return the results.
	*/
	Offset *int64

	// Q.
	Q *string

	// Rir.
	Rir *string

	// Rirn.
	Rirn *string

	// RirID.
	RirID *string

	// RirIDn.
	RirIDn *string

	// Site.
	Site *string

	// Siten.
	Siten *string

	// SiteID.
	SiteID *string

	// SiteIDn.
	SiteIDn *string

	// Tag.
	Tag *string

	// Tagn.
	Tagn *string

	// Tenant.
	Tenant *string

	// Tenantn.
	Tenantn *string

	// TenantGroup.
	TenantGroup *string

	// TenantGroupn.
	TenantGroupn *string

	// TenantGroupID.
	TenantGroupID *string

	// TenantGroupIDn.
	TenantGroupIDn *string

	// TenantID.
	TenantID *string

	// TenantIDn.
	TenantIDn *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the ipam asns list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IpamAsnsListParams) WithDefaults() *IpamAsnsListParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the ipam asns list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IpamAsnsListParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the ipam asns list params
func (o *IpamAsnsListParams) WithTimeout(timeout time.Duration) *IpamAsnsListParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the ipam asns list params
func (o *IpamAsnsListParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the ipam asns list params
func (o *IpamAsnsListParams) WithContext(ctx context.Context) *IpamAsnsListParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the ipam asns list params
func (o *IpamAsnsListParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the ipam asns list params
func (o *IpamAsnsListParams) WithHTTPClient(client *http.Client) *IpamAsnsListParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the ipam asns list params
func (o *IpamAsnsListParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAsn adds the asn to the ipam asns list params
func (o *IpamAsnsListParams) WithAsn(asn *string) *IpamAsnsListParams {
	o.SetAsn(asn)
	return o
}

// SetAsn adds the asn to the ipam asns list params
func (o *IpamAsnsListParams) SetAsn(asn *string) {
	o.Asn = asn
}

// WithAsnGt adds the asnGt to the ipam asns list params
func (o *IpamAsnsListParams) WithAsnGt(asnGt *string) *IpamAsnsListParams {
	o.SetAsnGt(asnGt)
	return o
}

// SetAsnGt adds the asnGt to the ipam asns list params
func (o *IpamAsnsListParams) SetAsnGt(asnGt *string) {
	o.AsnGt = asnGt
}

// WithAsnGte adds the asnGte to the ipam asns list params
func (o *IpamAsnsListParams) WithAsnGte(asnGte *string) *IpamAsnsListParams {
	o.SetAsnGte(asnGte)
	return o
}

// SetAsnGte adds the asnGte to the ipam asns list params
func (o *IpamAsnsListParams) SetAsnGte(asnGte *string) {
	o.AsnGte = asnGte
}

// WithAsnLt adds the asnLt to the ipam asns list params
func (o *IpamAsnsListParams) WithAsnLt(asnLt *string) *IpamAsnsListParams {
	o.SetAsnLt(asnLt)
	return o
}

// SetAsnLt adds the asnLt to the ipam asns list params
func (o *IpamAsnsListParams) SetAsnLt(asnLt *string) {
	o.AsnLt = asnLt
}

// WithAsnLte adds the asnLte to the ipam asns list params
func (o *IpamAsnsListParams) WithAsnLte(asnLte *string) *IpamAsnsListParams {
	o.SetAsnLte(asnLte)
	return o
}

// SetAsnLte adds the asnLte to the ipam asns list params
func (o *IpamAsnsListParams) SetAsnLte(asnLte *string) {
	o.AsnLte = asnLte
}

// WithAsnn adds the asnn to the ipam asns list params
func (o *IpamAsnsListParams) WithAsnn(asnn *string) *IpamAsnsListParams {
	o.SetAsnn(asnn)
	return o
}

// SetAsnn adds the asnN to the ipam asns list params
func (o *IpamAsnsListParams) SetAsnn(asnn *string) {
	o.Asnn = asnn
}

// WithCreated adds the created to the ipam asns list params
func (o *IpamAsnsListParams) WithCreated(created *string) *IpamAsnsListParams {
	o.SetCreated(created)
	return o
}

// SetCreated adds the created to the ipam asns list params
func (o *IpamAsnsListParams) SetCreated(created *string) {
	o.Created = created
}

// WithCreatedGte adds the createdGte to the ipam asns list params
func (o *IpamAsnsListParams) WithCreatedGte(createdGte *string) *IpamAsnsListParams {
	o.SetCreatedGte(createdGte)
	return o
}

// SetCreatedGte adds the createdGte to the ipam asns list params
func (o *IpamAsnsListParams) SetCreatedGte(createdGte *string) {
	o.CreatedGte = createdGte
}

// WithCreatedLte adds the createdLte to the ipam asns list params
func (o *IpamAsnsListParams) WithCreatedLte(createdLte *string) *IpamAsnsListParams {
	o.SetCreatedLte(createdLte)
	return o
}

// SetCreatedLte adds the createdLte to the ipam asns list params
func (o *IpamAsnsListParams) SetCreatedLte(createdLte *string) {
	o.CreatedLte = createdLte
}

// WithDescription adds the description to the ipam asns list params
func (o *IpamAsnsListParams) WithDescription(description *string) *IpamAsnsListParams {
	o.SetDescription(description)
	return o
}

// SetDescription adds the description to the ipam asns list params
func (o *IpamAsnsListParams) SetDescription(description *string) {
	o.Description = description
}

// WithDescriptionIc adds the descriptionIc to the ipam asns list params
func (o *IpamAsnsListParams) WithDescriptionIc(descriptionIc *string) *IpamAsnsListParams {
	o.SetDescriptionIc(descriptionIc)
	return o
}

// SetDescriptionIc adds the descriptionIc to the ipam asns list params
func (o *IpamAsnsListParams) SetDescriptionIc(descriptionIc *string) {
	o.DescriptionIc = descriptionIc
}

// WithDescriptionIe adds the descriptionIe to the ipam asns list params
func (o *IpamAsnsListParams) WithDescriptionIe(descriptionIe *string) *IpamAsnsListParams {
	o.SetDescriptionIe(descriptionIe)
	return o
}

// SetDescriptionIe adds the descriptionIe to the ipam asns list params
func (o *IpamAsnsListParams) SetDescriptionIe(descriptionIe *string) {
	o.DescriptionIe = descriptionIe
}

// WithDescriptionIew adds the descriptionIew to the ipam asns list params
func (o *IpamAsnsListParams) WithDescriptionIew(descriptionIew *string) *IpamAsnsListParams {
	o.SetDescriptionIew(descriptionIew)
	return o
}

// SetDescriptionIew adds the descriptionIew to the ipam asns list params
func (o *IpamAsnsListParams) SetDescriptionIew(descriptionIew *string) {
	o.DescriptionIew = descriptionIew
}

// WithDescriptionIsw adds the descriptionIsw to the ipam asns list params
func (o *IpamAsnsListParams) WithDescriptionIsw(descriptionIsw *string) *IpamAsnsListParams {
	o.SetDescriptionIsw(descriptionIsw)
	return o
}

// SetDescriptionIsw adds the descriptionIsw to the ipam asns list params
func (o *IpamAsnsListParams) SetDescriptionIsw(descriptionIsw *string) {
	o.DescriptionIsw = descriptionIsw
}

// WithDescriptionn adds the descriptionn to the ipam asns list params
func (o *IpamAsnsListParams) WithDescriptionn(descriptionn *string) *IpamAsnsListParams {
	o.SetDescriptionn(descriptionn)
	return o
}

// SetDescriptionn adds the descriptionN to the ipam asns list params
func (o *IpamAsnsListParams) SetDescriptionn(descriptionn *string) {
	o.Descriptionn = descriptionn
}

// WithDescriptionNic adds the descriptionNic to the ipam asns list params
func (o *IpamAsnsListParams) WithDescriptionNic(descriptionNic *string) *IpamAsnsListParams {
	o.SetDescriptionNic(descriptionNic)
	return o
}

// SetDescriptionNic adds the descriptionNic to the ipam asns list params
func (o *IpamAsnsListParams) SetDescriptionNic(descriptionNic *string) {
	o.DescriptionNic = descriptionNic
}

// WithDescriptionNie adds the descriptionNie to the ipam asns list params
func (o *IpamAsnsListParams) WithDescriptionNie(descriptionNie *string) *IpamAsnsListParams {
	o.SetDescriptionNie(descriptionNie)
	return o
}

// SetDescriptionNie adds the descriptionNie to the ipam asns list params
func (o *IpamAsnsListParams) SetDescriptionNie(descriptionNie *string) {
	o.DescriptionNie = descriptionNie
}

// WithDescriptionNiew adds the descriptionNiew to the ipam asns list params
func (o *IpamAsnsListParams) WithDescriptionNiew(descriptionNiew *string) *IpamAsnsListParams {
	o.SetDescriptionNiew(descriptionNiew)
	return o
}

// SetDescriptionNiew adds the descriptionNiew to the ipam asns list params
func (o *IpamAsnsListParams) SetDescriptionNiew(descriptionNiew *string) {
	o.DescriptionNiew = descriptionNiew
}

// WithDescriptionNisw adds the descriptionNisw to the ipam asns list params
func (o *IpamAsnsListParams) WithDescriptionNisw(descriptionNisw *string) *IpamAsnsListParams {
	o.SetDescriptionNisw(descriptionNisw)
	return o
}

// SetDescriptionNisw adds the descriptionNisw to the ipam asns list params
func (o *IpamAsnsListParams) SetDescriptionNisw(descriptionNisw *string) {
	o.DescriptionNisw = descriptionNisw
}

// WithID adds the id to the ipam asns list params
func (o *IpamAsnsListParams) WithID(id *string) *IpamAsnsListParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the ipam asns list params
func (o *IpamAsnsListParams) SetID(id *string) {
	o.ID = id
}

// WithIDGt adds the iDGt to the ipam asns list params
func (o *IpamAsnsListParams) WithIDGt(iDGt *string) *IpamAsnsListParams {
	o.SetIDGt(iDGt)
	return o
}

// SetIDGt adds the idGt to the ipam asns list params
func (o *IpamAsnsListParams) SetIDGt(iDGt *string) {
	o.IDGt = iDGt
}

// WithIDGte adds the iDGte to the ipam asns list params
func (o *IpamAsnsListParams) WithIDGte(iDGte *string) *IpamAsnsListParams {
	o.SetIDGte(iDGte)
	return o
}

// SetIDGte adds the idGte to the ipam asns list params
func (o *IpamAsnsListParams) SetIDGte(iDGte *string) {
	o.IDGte = iDGte
}

// WithIDLt adds the iDLt to the ipam asns list params
func (o *IpamAsnsListParams) WithIDLt(iDLt *string) *IpamAsnsListParams {
	o.SetIDLt(iDLt)
	return o
}

// SetIDLt adds the idLt to the ipam asns list params
func (o *IpamAsnsListParams) SetIDLt(iDLt *string) {
	o.IDLt = iDLt
}

// WithIDLte adds the iDLte to the ipam asns list params
func (o *IpamAsnsListParams) WithIDLte(iDLte *string) *IpamAsnsListParams {
	o.SetIDLte(iDLte)
	return o
}

// SetIDLte adds the idLte to the ipam asns list params
func (o *IpamAsnsListParams) SetIDLte(iDLte *string) {
	o.IDLte = iDLte
}

// WithIDn adds the iDn to the ipam asns list params
func (o *IpamAsnsListParams) WithIDn(iDn *string) *IpamAsnsListParams {
	o.SetIDn(iDn)
	return o
}

// SetIDn adds the idN to the ipam asns list params
func (o *IpamAsnsListParams) SetIDn(iDn *string) {
	o.IDn = iDn
}

// WithLastUpdated adds the lastUpdated to the ipam asns list params
func (o *IpamAsnsListParams) WithLastUpdated(lastUpdated *string) *IpamAsnsListParams {
	o.SetLastUpdated(lastUpdated)
	return o
}

// SetLastUpdated adds the lastUpdated to the ipam asns list params
func (o *IpamAsnsListParams) SetLastUpdated(lastUpdated *string) {
	o.LastUpdated = lastUpdated
}

// WithLastUpdatedGte adds the lastUpdatedGte to the ipam asns list params
func (o *IpamAsnsListParams) WithLastUpdatedGte(lastUpdatedGte *string) *IpamAsnsListParams {
	o.SetLastUpdatedGte(lastUpdatedGte)
	return o
}

// SetLastUpdatedGte adds the lastUpdatedGte to the ipam asns list params
func (o *IpamAsnsListParams) SetLastUpdatedGte(lastUpdatedGte *string) {
	o.LastUpdatedGte = lastUpdatedGte
}

// WithLastUpdatedLte adds the lastUpdatedLte to the ipam asns list params
func (o *IpamAsnsListParams) WithLastUpdatedLte(lastUpdatedLte *string) *IpamAsnsListParams {
	o.SetLastUpdatedLte(lastUpdatedLte)
	return o
}

// SetLastUpdatedLte adds the lastUpdatedLte to the ipam asns list params
func (o *IpamAsnsListParams) SetLastUpdatedLte(lastUpdatedLte *string) {
	o.LastUpdatedLte = lastUpdatedLte
}

// WithLimit adds the limit to the ipam asns list params
func (o *IpamAsnsListParams) WithLimit(limit *int64) *IpamAsnsListParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the ipam asns list params
func (o *IpamAsnsListParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the ipam asns list params
func (o *IpamAsnsListParams) WithOffset(offset *int64) *IpamAsnsListParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the ipam asns list params
func (o *IpamAsnsListParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithQ adds the q to the ipam asns list params
func (o *IpamAsnsListParams) WithQ(q *string) *IpamAsnsListParams {
	o.SetQ(q)
	return o
}

// SetQ adds the q to the ipam asns list params
func (o *IpamAsnsListParams) SetQ(q *string) {
	o.Q = q
}

// WithRir adds the rir to the ipam asns list params
func (o *IpamAsnsListParams) WithRir(rir *string) *IpamAsnsListParams {
	o.SetRir(rir)
	return o
}

// SetRir adds the rir to the ipam asns list params
func (o *IpamAsnsListParams) SetRir(rir *string) {
	o.Rir = rir
}

// WithRirn adds the rirn to the ipam asns list params
func (o *IpamAsnsListParams) WithRirn(rirn *string) *IpamAsnsListParams {
	o.SetRirn(rirn)
	return o
}

// SetRirn adds the rirN to the ipam asns list params
func (o *IpamAsnsListParams) SetRirn(rirn *string) {
	o.Rirn = rirn
}

// WithRirID adds the rirID to the ipam asns list params
func (o *IpamAsnsListParams) WithRirID(rirID *string) *IpamAsnsListParams {
	o.SetRirID(rirID)
	return o
}

// SetRirID adds the rirId to the ipam asns list params
func (o *IpamAsnsListParams) SetRirID(rirID *string) {
	o.RirID = rirID
}

// WithRirIDn adds the rirIDn to the ipam asns list params
func (o *IpamAsnsListParams) WithRirIDn(rirIDn *string) *IpamAsnsListParams {
	o.SetRirIDn(rirIDn)
	return o
}

// SetRirIDn adds the rirIdN to the ipam asns list params
func (o *IpamAsnsListParams) SetRirIDn(rirIDn *string) {
	o.RirIDn = rirIDn
}

// WithSite adds the site to the ipam asns list params
func (o *IpamAsnsListParams) WithSite(site *string) *IpamAsnsListParams {
	o.SetSite(site)
	return o
}

// SetSite adds the site to the ipam asns list params
func (o *IpamAsnsListParams) SetSite(site *string) {
	o.Site = site
}

// WithSiten adds the siten to the ipam asns list params
func (o *IpamAsnsListParams) WithSiten(siten *string) *IpamAsnsListParams {
	o.SetSiten(siten)
	return o
}

// SetSiten adds the siteN to the ipam asns list params
func (o *IpamAsnsListParams) SetSiten(siten *string) {
	o.Siten = siten
}

// WithSiteID adds the siteID to the ipam asns list params
func (o *IpamAsnsListParams) WithSiteID(siteID *string) *IpamAsnsListParams {
	o.SetSiteID(siteID)
	return o
}

// SetSiteID adds the siteId to the ipam asns list params
func (o *IpamAsnsListParams) SetSiteID(siteID *string) {
	o.SiteID = siteID
}

// WithSiteIDn adds the siteIDn to the ipam asns list params
func (o *IpamAsnsListParams) WithSiteIDn(siteIDn *string) *IpamAsnsListParams {
	o.SetSiteIDn(siteIDn)
	return o
}

// SetSiteIDn adds the siteIdN to the ipam asns list params
func (o *IpamAsnsListParams) SetSiteIDn(siteIDn *string) {
	o.SiteIDn = siteIDn
}

// WithTag adds the tag to the ipam asns list params
func (o *IpamAsnsListParams) WithTag(tag *string) *IpamAsnsListParams {
	o.SetTag(tag)
	return o
}

// SetTag adds the tag to the ipam asns list params
func (o *IpamAsnsListParams) SetTag(tag *string) {
	o.Tag = tag
}

// WithTagn adds the tagn to the ipam asns list params
func (o *IpamAsnsListParams) WithTagn(tagn *string) *IpamAsnsListParams {
	o.SetTagn(tagn)
	return o
}

// SetTagn adds the tagN to the ipam asns list params
func (o *IpamAsnsListParams) SetTagn(tagn *string) {
	o.Tagn = tagn
}

// WithTenant adds the tenant to the ipam asns list params
func (o *IpamAsnsListParams) WithTenant(tenant *string) *IpamAsnsListParams {
	o.SetTenant(tenant)
	return o
}

// SetTenant adds the tenant to the ipam asns list params
func (o *IpamAsnsListParams) SetTenant(tenant *string) {
	o.Tenant = tenant
}

// WithTenantn adds the tenantn to the ipam asns list params
func (o *IpamAsnsListParams) WithTenantn(tenantn *string) *IpamAsnsListParams {
	o.SetTenantn(tenantn)
	return o
}

// SetTenantn adds the tenantN to the ipam asns list params
func (o *IpamAsnsListParams) SetTenantn(tenantn *string) {
	o.Tenantn = tenantn
}

// WithTenantGroup adds the tenantGroup to the ipam asns list params
func (o *IpamAsnsListParams) WithTenantGroup(tenantGroup *string) *IpamAsnsListParams {
	o.SetTenantGroup(tenantGroup)
	return o
}

// SetTenantGroup adds the tenantGroup to the ipam asns list params
func (o *IpamAsnsListParams) SetTenantGroup(tenantGroup *string) {
	o.TenantGroup = tenantGroup
}

// WithTenantGroupn adds the tenantGroupn to the ipam asns list params
func (o *IpamAsnsListParams) WithTenantGroupn(tenantGroupn *string) *IpamAsnsListParams {
	o.SetTenantGroupn(tenantGroupn)
	return o
}

// SetTenantGroupn adds the tenantGroupN to the ipam asns list params
func (o *IpamAsnsListParams) SetTenantGroupn(tenantGroupn *string) {
	o.TenantGroupn = tenantGroupn
}

// WithTenantGroupID adds the tenantGroupID to the ipam asns list params
func (o *IpamAsnsListParams) WithTenantGroupID(tenantGroupID *string) *IpamAsnsListParams {
	o.SetTenantGroupID(tenantGroupID)
	return o
}

// SetTenantGroupID adds the tenantGroupId to the ipam asns list params
func (o *IpamAsnsListParams) SetTenantGroupID(tenantGroupID *string) {
	o.TenantGroupID = tenantGroupID
}

// WithTenantGroupIDn adds the tenantGroupIDn to the ipam asns list params
func (o *IpamAsnsListParams) WithTenantGroupIDn(tenantGroupIDn *string) *IpamAsnsListParams {
	o.SetTenantGroupIDn(tenantGroupIDn)
	return o
}

// SetTenantGroupIDn adds the tenantGroupIdN to the ipam asns list params
func (o *IpamAsnsListParams) SetTenantGroupIDn(tenantGroupIDn *string) {
	o.TenantGroupIDn = tenantGroupIDn
}

// WithTenantID adds the tenantID to the ipam asns list params
func (o *IpamAsnsListParams) WithTenantID(tenantID *string) *IpamAsnsListParams {
	o.SetTenantID(tenantID)
	return o
}

// SetTenantID adds the tenantId to the ipam asns list params
func (o *IpamAsnsListParams) SetTenantID(tenantID *string) {
	o.TenantID = tenantID
}

// WithTenantIDn adds the tenantIDn to the ipam asns list params
func (o *IpamAsnsListParams) WithTenantIDn(tenantIDn *string) *IpamAsnsListParams {
	o.SetTenantIDn(tenantIDn)
	return o
}

// SetTenantIDn adds the tenantIdN to the ipam asns list params
func (o *IpamAsnsListParams) SetTenantIDn(tenantIDn *string) {
	o.TenantIDn = tenantIDn
}

// WriteToRequest writes these params to a swagger request
func (o *IpamAsnsListParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Asn != nil {

		// query param asn
		var qrAsn string

		if o.Asn != nil {
			qrAsn = *o.Asn
		}
		qAsn := qrAsn
		if qAsn != "" {

			if err := r.SetQueryParam("asn", qAsn); err != nil {
				return err
			}
		}
	}

	if o.AsnGt != nil {

		// query param asn__gt
		var qrAsnGt string

		if o.AsnGt != nil {
			qrAsnGt = *o.AsnGt
		}
		qAsnGt := qrAsnGt
		if qAsnGt != "" {

			if err := r.SetQueryParam("asn__gt", qAsnGt); err != nil {
				return err
			}
		}
	}

	if o.AsnGte != nil {

		// query param asn__gte
		var qrAsnGte string

		if o.AsnGte != nil {
			qrAsnGte = *o.AsnGte
		}
		qAsnGte := qrAsnGte
		if qAsnGte != "" {

			if err := r.SetQueryParam("asn__gte", qAsnGte); err != nil {
				return err
			}
		}
	}

	if o.AsnLt != nil {

		// query param asn__lt
		var qrAsnLt string

		if o.AsnLt != nil {
			qrAsnLt = *o.AsnLt
		}
		qAsnLt := qrAsnLt
		if qAsnLt != "" {

			if err := r.SetQueryParam("asn__lt", qAsnLt); err != nil {
				return err
			}
		}
	}

	if o.AsnLte != nil {

		// query param asn__lte
		var qrAsnLte string

		if o.AsnLte != nil {
			qrAsnLte = *o.AsnLte
		}
		qAsnLte := qrAsnLte
		if qAsnLte != "" {

			if err := r.SetQueryParam("asn__lte", qAsnLte); err != nil {
				return err
			}
		}
	}

	if o.Asnn != nil {

		// query param asn__n
		var qrAsnn string

		if o.Asnn != nil {
			qrAsnn = *o.Asnn
		}
		qAsnn := qrAsnn
		if qAsnn != "" {

			if err := r.SetQueryParam("asn__n", qAsnn); err != nil {
				return err
			}
		}
	}

	if o.Created != nil {

		// query param created
		var qrCreated string

		if o.Created != nil {
			qrCreated = *o.Created
		}
		qCreated := qrCreated
		if qCreated != "" {

			if err := r.SetQueryParam("created", qCreated); err != nil {
				return err
			}
		}
	}

	if o.CreatedGte != nil {

		// query param created__gte
		var qrCreatedGte string

		if o.CreatedGte != nil {
			qrCreatedGte = *o.CreatedGte
		}
		qCreatedGte := qrCreatedGte
		if qCreatedGte != "" {

			if err := r.SetQueryParam("created__gte", qCreatedGte); err != nil {
				return err
			}
		}
	}

	if o.CreatedLte != nil {

		// query param created__lte
		var qrCreatedLte string

		if o.CreatedLte != nil {
			qrCreatedLte = *o.CreatedLte
		}
		qCreatedLte := qrCreatedLte
		if qCreatedLte != "" {

			if err := r.SetQueryParam("created__lte", qCreatedLte); err != nil {
				return err
			}
		}
	}

	if o.Description != nil {

		// query param description
		var qrDescription string

		if o.Description != nil {
			qrDescription = *o.Description
		}
		qDescription := qrDescription
		if qDescription != "" {

			if err := r.SetQueryParam("description", qDescription); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIc != nil {

		// query param description__ic
		var qrDescriptionIc string

		if o.DescriptionIc != nil {
			qrDescriptionIc = *o.DescriptionIc
		}
		qDescriptionIc := qrDescriptionIc
		if qDescriptionIc != "" {

			if err := r.SetQueryParam("description__ic", qDescriptionIc); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIe != nil {

		// query param description__ie
		var qrDescriptionIe string

		if o.DescriptionIe != nil {
			qrDescriptionIe = *o.DescriptionIe
		}
		qDescriptionIe := qrDescriptionIe
		if qDescriptionIe != "" {

			if err := r.SetQueryParam("description__ie", qDescriptionIe); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIew != nil {

		// query param description__iew
		var qrDescriptionIew string

		if o.DescriptionIew != nil {
			qrDescriptionIew = *o.DescriptionIew
		}
		qDescriptionIew := qrDescriptionIew
		if qDescriptionIew != "" {

			if err := r.SetQueryParam("description__iew", qDescriptionIew); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIsw != nil {

		// query param description__isw
		var qrDescriptionIsw string

		if o.DescriptionIsw != nil {
			qrDescriptionIsw = *o.DescriptionIsw
		}
		qDescriptionIsw := qrDescriptionIsw
		if qDescriptionIsw != "" {

			if err := r.SetQueryParam("description__isw", qDescriptionIsw); err != nil {
				return err
			}
		}
	}

	if o.Descriptionn != nil {

		// query param description__n
		var qrDescriptionn string

		if o.Descriptionn != nil {
			qrDescriptionn = *o.Descriptionn
		}
		qDescriptionn := qrDescriptionn
		if qDescriptionn != "" {

			if err := r.SetQueryParam("description__n", qDescriptionn); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNic != nil {

		// query param description__nic
		var qrDescriptionNic string

		if o.DescriptionNic != nil {
			qrDescriptionNic = *o.DescriptionNic
		}
		qDescriptionNic := qrDescriptionNic
		if qDescriptionNic != "" {

			if err := r.SetQueryParam("description__nic", qDescriptionNic); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNie != nil {

		// query param description__nie
		var qrDescriptionNie string

		if o.DescriptionNie != nil {
			qrDescriptionNie = *o.DescriptionNie
		}
		qDescriptionNie := qrDescriptionNie
		if qDescriptionNie != "" {

			if err := r.SetQueryParam("description__nie", qDescriptionNie); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNiew != nil {

		// query param description__niew
		var qrDescriptionNiew string

		if o.DescriptionNiew != nil {
			qrDescriptionNiew = *o.DescriptionNiew
		}
		qDescriptionNiew := qrDescriptionNiew
		if qDescriptionNiew != "" {

			if err := r.SetQueryParam("description__niew", qDescriptionNiew); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNisw != nil {

		// query param description__nisw
		var qrDescriptionNisw string

		if o.DescriptionNisw != nil {
			qrDescriptionNisw = *o.DescriptionNisw
		}
		qDescriptionNisw := qrDescriptionNisw
		if qDescriptionNisw != "" {

			if err := r.SetQueryParam("description__nisw", qDescriptionNisw); err != nil {
				return err
			}
		}
	}

	if o.ID != nil {

		// query param id
		var qrID string

		if o.ID != nil {
			qrID = *o.ID
		}
		qID := qrID
		if qID != "" {

			if err := r.SetQueryParam("id", qID); err != nil {
				return err
			}
		}
	}

	if o.IDGt != nil {

		// query param id__gt
		var qrIDGt string

		if o.IDGt != nil {
			qrIDGt = *o.IDGt
		}
		qIDGt := qrIDGt
		if qIDGt != "" {

			if err := r.SetQueryParam("id__gt", qIDGt); err != nil {
				return err
			}
		}
	}

	if o.IDGte != nil {

		// query param id__gte
		var qrIDGte string

		if o.IDGte != nil {
			qrIDGte = *o.IDGte
		}
		qIDGte := qrIDGte
		if qIDGte != "" {

			if err := r.SetQueryParam("id__gte", qIDGte); err != nil {
				return err
			}
		}
	}

	if o.IDLt != nil {

		// query param id__lt
		var qrIDLt string

		if o.IDLt != nil {
			qrIDLt = *o.IDLt
		}
		qIDLt := qrIDLt
		if qIDLt != "" {

			if err := r.SetQueryParam("id__lt", qIDLt); err != nil {
				return err
			}
		}
	}

	if o.IDLte != nil {

		// query param id__lte
		var qrIDLte string

		if o.IDLte != nil {
			qrIDLte = *o.IDLte
		}
		qIDLte := qrIDLte
		if qIDLte != "" {

			if err := r.SetQueryParam("id__lte", qIDLte); err != nil {
				return err
			}
		}
	}

	if o.IDn != nil {

		// query param id__n
		var qrIDn string

		if o.IDn != nil {
			qrIDn = *o.IDn
		}
		qIDn := qrIDn
		if qIDn != "" {

			if err := r.SetQueryParam("id__n", qIDn); err != nil {
				return err
			}
		}
	}

	if o.LastUpdated != nil {

		// query param last_updated
		var qrLastUpdated string

		if o.LastUpdated != nil {
			qrLastUpdated = *o.LastUpdated
		}
		qLastUpdated := qrLastUpdated
		if qLastUpdated != "" {

			if err := r.SetQueryParam("last_updated", qLastUpdated); err != nil {
				return err
			}
		}
	}

	if o.LastUpdatedGte != nil {

		// query param last_updated__gte
		var qrLastUpdatedGte string

		if o.LastUpdatedGte != nil {
			qrLastUpdatedGte = *o.LastUpdatedGte
		}
		qLastUpdatedGte := qrLastUpdatedGte
		if qLastUpdatedGte != "" {

			if err := r.SetQueryParam("last_updated__gte", qLastUpdatedGte); err != nil {
				return err
			}
		}
	}

	if o.LastUpdatedLte != nil {

		// query param last_updated__lte
		var qrLastUpdatedLte string

		if o.LastUpdatedLte != nil {
			qrLastUpdatedLte = *o.LastUpdatedLte
		}
		qLastUpdatedLte := qrLastUpdatedLte
		if qLastUpdatedLte != "" {

			if err := r.SetQueryParam("last_updated__lte", qLastUpdatedLte); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if o.Q != nil {

		// query param q
		var qrQ string

		if o.Q != nil {
			qrQ = *o.Q
		}
		qQ := qrQ
		if qQ != "" {

			if err := r.SetQueryParam("q", qQ); err != nil {
				return err
			}
		}
	}

	if o.Rir != nil {

		// query param rir
		var qrRir string

		if o.Rir != nil {
			qrRir = *o.Rir
		}
		qRir := qrRir
		if qRir != "" {

			if err := r.SetQueryParam("rir", qRir); err != nil {
				return err
			}
		}
	}

	if o.Rirn != nil {

		// query param rir__n
		var qrRirn string

		if o.Rirn != nil {
			qrRirn = *o.Rirn
		}
		qRirn := qrRirn
		if qRirn != "" {

			if err := r.SetQueryParam("rir__n", qRirn); err != nil {
				return err
			}
		}
	}

	if o.RirID != nil {

		// query param rir_id
		var qrRirID string

		if o.RirID != nil {
			qrRirID = *o.RirID
		}
		qRirID := qrRirID
		if qRirID != "" {

			if err := r.SetQueryParam("rir_id", qRirID); err != nil {
				return err
			}
		}
	}

	if o.RirIDn != nil {

		// query param rir_id__n
		var qrRirIDn string

		if o.RirIDn != nil {
			qrRirIDn = *o.RirIDn
		}
		qRirIDn := qrRirIDn
		if qRirIDn != "" {

			if err := r.SetQueryParam("rir_id__n", qRirIDn); err != nil {
				return err
			}
		}
	}

	if o.Site != nil {

		// query param site
		var qrSite string

		if o.Site != nil {
			qrSite = *o.Site
		}
		qSite := qrSite
		if qSite != "" {

			if err := r.SetQueryParam("site", qSite); err != nil {
				return err
			}
		}
	}

	if o.Siten != nil {

		// query param site__n
		var qrSiten string

		if o.Siten != nil {
			qrSiten = *o.Siten
		}
		qSiten := qrSiten
		if qSiten != "" {

			if err := r.SetQueryParam("site__n", qSiten); err != nil {
				return err
			}
		}
	}

	if o.SiteID != nil {

		// query param site_id
		var qrSiteID string

		if o.SiteID != nil {
			qrSiteID = *o.SiteID
		}
		qSiteID := qrSiteID
		if qSiteID != "" {

			if err := r.SetQueryParam("site_id", qSiteID); err != nil {
				return err
			}
		}
	}

	if o.SiteIDn != nil {

		// query param site_id__n
		var qrSiteIDn string

		if o.SiteIDn != nil {
			qrSiteIDn = *o.SiteIDn
		}
		qSiteIDn := qrSiteIDn
		if qSiteIDn != "" {

			if err := r.SetQueryParam("site_id__n", qSiteIDn); err != nil {
				return err
			}
		}
	}

	if o.Tag != nil {

		// query param tag
		var qrTag string

		if o.Tag != nil {
			qrTag = *o.Tag
		}
		qTag := qrTag
		if qTag != "" {

			if err := r.SetQueryParam("tag", qTag); err != nil {
				return err
			}
		}
	}

	if o.Tagn != nil {

		// query param tag__n
		var qrTagn string

		if o.Tagn != nil {
			qrTagn = *o.Tagn
		}
		qTagn := qrTagn
		if qTagn != "" {

			if err := r.SetQueryParam("tag__n", qTagn); err != nil {
				return err
			}
		}
	}

	if o.Tenant != nil {

		// query param tenant
		var qrTenant string

		if o.Tenant != nil {
			qrTenant = *o.Tenant
		}
		qTenant := qrTenant
		if qTenant != "" {

			if err := r.SetQueryParam("tenant", qTenant); err != nil {
				return err
			}
		}
	}

	if o.Tenantn != nil {

		// query param tenant__n
		var qrTenantn string

		if o.Tenantn != nil {
			qrTenantn = *o.Tenantn
		}
		qTenantn := qrTenantn
		if qTenantn != "" {

			if err := r.SetQueryParam("tenant__n", qTenantn); err != nil {
				return err
			}
		}
	}

	if o.TenantGroup != nil {

		// query param tenant_group
		var qrTenantGroup string

		if o.TenantGroup != nil {
			qrTenantGroup = *o.TenantGroup
		}
		qTenantGroup := qrTenantGroup
		if qTenantGroup != "" {

			if err := r.SetQueryParam("tenant_group", qTenantGroup); err != nil {
				return err
			}
		}
	}

	if o.TenantGroupn != nil {

		// query param tenant_group__n
		var qrTenantGroupn string

		if o.TenantGroupn != nil {
			qrTenantGroupn = *o.TenantGroupn
		}
		qTenantGroupn := qrTenantGroupn
		if qTenantGroupn != "" {

			if err := r.SetQueryParam("tenant_group__n", qTenantGroupn); err != nil {
				return err
			}
		}
	}

	if o.TenantGroupID != nil {

		// query param tenant_group_id
		var qrTenantGroupID string

		if o.TenantGroupID != nil {
			qrTenantGroupID = *o.TenantGroupID
		}
		qTenantGroupID := qrTenantGroupID
		if qTenantGroupID != "" {

			if err := r.SetQueryParam("tenant_group_id", qTenantGroupID); err != nil {
				return err
			}
		}
	}

	if o.TenantGroupIDn != nil {

		// query param tenant_group_id__n
		var qrTenantGroupIDn string

		if o.TenantGroupIDn != nil {
			qrTenantGroupIDn = *o.TenantGroupIDn
		}
		qTenantGroupIDn := qrTenantGroupIDn
		if qTenantGroupIDn != "" {

			if err := r.SetQueryParam("tenant_group_id__n", qTenantGroupIDn); err != nil {
				return err
			}
		}
	}

	if o.TenantID != nil {

		// query param tenant_id
		var qrTenantID string

		if o.TenantID != nil {
			qrTenantID = *o.TenantID
		}
		qTenantID := qrTenantID
		if qTenantID != "" {

			if err := r.SetQueryParam("tenant_id", qTenantID); err != nil {
				return err
			}
		}
	}

	if o.TenantIDn != nil {

		// query param tenant_id__n
		var qrTenantIDn string

		if o.TenantIDn != nil {
			qrTenantIDn = *o.TenantIDn
		}
		qTenantIDn := qrTenantIDn
		if qTenantIDn != "" {

			if err := r.SetQueryParam("tenant_id__n", qTenantIDn); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
