// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2020 The go-netbox Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package ipam

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewIpamPrefixesListParams creates a new IpamPrefixesListParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIpamPrefixesListParams() *IpamPrefixesListParams {
	return &IpamPrefixesListParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIpamPrefixesListParamsWithTimeout creates a new IpamPrefixesListParams object
// with the ability to set a timeout on a request.
func NewIpamPrefixesListParamsWithTimeout(timeout time.Duration) *IpamPrefixesListParams {
	return &IpamPrefixesListParams{
		timeout: timeout,
	}
}

// NewIpamPrefixesListParamsWithContext creates a new IpamPrefixesListParams object
// with the ability to set a context for a request.
func NewIpamPrefixesListParamsWithContext(ctx context.Context) *IpamPrefixesListParams {
	return &IpamPrefixesListParams{
		Context: ctx,
	}
}

// NewIpamPrefixesListParamsWithHTTPClient creates a new IpamPrefixesListParams object
// with the ability to set a custom HTTPClient for a request.
func NewIpamPrefixesListParamsWithHTTPClient(client *http.Client) *IpamPrefixesListParams {
	return &IpamPrefixesListParams{
		HTTPClient: client,
	}
}

/* IpamPrefixesListParams contains all the parameters to send to the API endpoint
   for the ipam prefixes list operation.

   Typically these are written to a http.Request.
*/
type IpamPrefixesListParams struct {

	// Children.
	Children *string

	// ChildrenGt.
	ChildrenGt *string

	// ChildrenGte.
	ChildrenGte *string

	// ChildrenLt.
	ChildrenLt *string

	// ChildrenLte.
	ChildrenLte *string

	// Childrenn.
	Childrenn *string

	// Contains.
	Contains *string

	// Created.
	Created *string

	// CreatedGte.
	CreatedGte *string

	// CreatedLte.
	CreatedLte *string

	// Depth.
	Depth *string

	// DepthGt.
	DepthGt *string

	// DepthGte.
	DepthGte *string

	// DepthLt.
	DepthLt *string

	// DepthLte.
	DepthLte *string

	// Depthn.
	Depthn *string

	// Description.
	Description *string

	// DescriptionIc.
	DescriptionIc *string

	// DescriptionIe.
	DescriptionIe *string

	// DescriptionIew.
	DescriptionIew *string

	// DescriptionIsw.
	DescriptionIsw *string

	// Descriptionn.
	Descriptionn *string

	// DescriptionNic.
	DescriptionNic *string

	// DescriptionNie.
	DescriptionNie *string

	// DescriptionNiew.
	DescriptionNiew *string

	// DescriptionNisw.
	DescriptionNisw *string

	// Family.
	Family *float64

	// ID.
	ID *string

	// IDGt.
	IDGt *string

	// IDGte.
	IDGte *string

	// IDLt.
	IDLt *string

	// IDLte.
	IDLte *string

	// IDn.
	IDn *string

	// IsPool.
	IsPool *string

	// LastUpdated.
	LastUpdated *string

	// LastUpdatedGte.
	LastUpdatedGte *string

	// LastUpdatedLte.
	LastUpdatedLte *string

	/* Limit.

	   Number of results to return per page.
	*/
	Limit *int64

	// MarkUtilized.
	MarkUtilized *string

	// MaskLength.
	MaskLength *string

	// MaskLengthGte.
	MaskLengthGte *float64

	// MaskLengthLte.
	MaskLengthLte *float64

	/* Offset.

	   The initial index from which to return the results.
	*/
	Offset *int64

	// Prefix.
	Prefix *string

	// PresentInVrf.
	PresentInVrf *string

	// PresentInVrfID.
	PresentInVrfID *string

	// Q.
	Q *string

	// Region.
	Region *string

	// Regionn.
	Regionn *string

	// RegionID.
	RegionID *string

	// RegionIDn.
	RegionIDn *string

	// Role.
	Role *string

	// Rolen.
	Rolen *string

	// RoleID.
	RoleID *string

	// RoleIDn.
	RoleIDn *string

	// Site.
	Site *string

	// Siten.
	Siten *string

	// SiteGroup.
	SiteGroup *string

	// SiteGroupn.
	SiteGroupn *string

	// SiteGroupID.
	SiteGroupID *string

	// SiteGroupIDn.
	SiteGroupIDn *string

	// SiteID.
	SiteID *string

	// SiteIDn.
	SiteIDn *string

	// Status.
	Status *string

	// Statusn.
	Statusn *string

	// Tag.
	Tag *string

	// Tagn.
	Tagn *string

	// Tenant.
	Tenant *string

	// Tenantn.
	Tenantn *string

	// TenantGroup.
	TenantGroup *string

	// TenantGroupn.
	TenantGroupn *string

	// TenantGroupID.
	TenantGroupID *string

	// TenantGroupIDn.
	TenantGroupIDn *string

	// TenantID.
	TenantID *string

	// TenantIDn.
	TenantIDn *string

	// VlanID.
	VlanID *string

	// VlanIDn.
	VlanIDn *string

	// VlanVid.
	VlanVid *float64

	// VlanVidGt.
	VlanVidGt *float64

	// VlanVidGte.
	VlanVidGte *float64

	// VlanVidLt.
	VlanVidLt *float64

	// VlanVidLte.
	VlanVidLte *float64

	// VlanVidn.
	VlanVidn *float64

	// Vrf.
	Vrf *string

	// Vrfn.
	Vrfn *string

	// VrfID.
	VrfID *string

	// VrfIDn.
	VrfIDn *string

	// Within.
	Within *string

	// WithinInclude.
	WithinInclude *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the ipam prefixes list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IpamPrefixesListParams) WithDefaults() *IpamPrefixesListParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the ipam prefixes list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IpamPrefixesListParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithTimeout(timeout time.Duration) *IpamPrefixesListParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithContext(ctx context.Context) *IpamPrefixesListParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithHTTPClient(client *http.Client) *IpamPrefixesListParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithChildren adds the children to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithChildren(children *string) *IpamPrefixesListParams {
	o.SetChildren(children)
	return o
}

// SetChildren adds the children to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetChildren(children *string) {
	o.Children = children
}

// WithChildrenGt adds the childrenGt to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithChildrenGt(childrenGt *string) *IpamPrefixesListParams {
	o.SetChildrenGt(childrenGt)
	return o
}

// SetChildrenGt adds the childrenGt to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetChildrenGt(childrenGt *string) {
	o.ChildrenGt = childrenGt
}

// WithChildrenGte adds the childrenGte to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithChildrenGte(childrenGte *string) *IpamPrefixesListParams {
	o.SetChildrenGte(childrenGte)
	return o
}

// SetChildrenGte adds the childrenGte to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetChildrenGte(childrenGte *string) {
	o.ChildrenGte = childrenGte
}

// WithChildrenLt adds the childrenLt to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithChildrenLt(childrenLt *string) *IpamPrefixesListParams {
	o.SetChildrenLt(childrenLt)
	return o
}

// SetChildrenLt adds the childrenLt to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetChildrenLt(childrenLt *string) {
	o.ChildrenLt = childrenLt
}

// WithChildrenLte adds the childrenLte to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithChildrenLte(childrenLte *string) *IpamPrefixesListParams {
	o.SetChildrenLte(childrenLte)
	return o
}

// SetChildrenLte adds the childrenLte to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetChildrenLte(childrenLte *string) {
	o.ChildrenLte = childrenLte
}

// WithChildrenn adds the childrenn to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithChildrenn(childrenn *string) *IpamPrefixesListParams {
	o.SetChildrenn(childrenn)
	return o
}

// SetChildrenn adds the childrenN to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetChildrenn(childrenn *string) {
	o.Childrenn = childrenn
}

// WithContains adds the contains to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithContains(contains *string) *IpamPrefixesListParams {
	o.SetContains(contains)
	return o
}

// SetContains adds the contains to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetContains(contains *string) {
	o.Contains = contains
}

// WithCreated adds the created to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithCreated(created *string) *IpamPrefixesListParams {
	o.SetCreated(created)
	return o
}

// SetCreated adds the created to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetCreated(created *string) {
	o.Created = created
}

// WithCreatedGte adds the createdGte to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithCreatedGte(createdGte *string) *IpamPrefixesListParams {
	o.SetCreatedGte(createdGte)
	return o
}

// SetCreatedGte adds the createdGte to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetCreatedGte(createdGte *string) {
	o.CreatedGte = createdGte
}

// WithCreatedLte adds the createdLte to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithCreatedLte(createdLte *string) *IpamPrefixesListParams {
	o.SetCreatedLte(createdLte)
	return o
}

// SetCreatedLte adds the createdLte to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetCreatedLte(createdLte *string) {
	o.CreatedLte = createdLte
}

// WithDepth adds the depth to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithDepth(depth *string) *IpamPrefixesListParams {
	o.SetDepth(depth)
	return o
}

// SetDepth adds the depth to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetDepth(depth *string) {
	o.Depth = depth
}

// WithDepthGt adds the depthGt to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithDepthGt(depthGt *string) *IpamPrefixesListParams {
	o.SetDepthGt(depthGt)
	return o
}

// SetDepthGt adds the depthGt to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetDepthGt(depthGt *string) {
	o.DepthGt = depthGt
}

// WithDepthGte adds the depthGte to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithDepthGte(depthGte *string) *IpamPrefixesListParams {
	o.SetDepthGte(depthGte)
	return o
}

// SetDepthGte adds the depthGte to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetDepthGte(depthGte *string) {
	o.DepthGte = depthGte
}

// WithDepthLt adds the depthLt to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithDepthLt(depthLt *string) *IpamPrefixesListParams {
	o.SetDepthLt(depthLt)
	return o
}

// SetDepthLt adds the depthLt to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetDepthLt(depthLt *string) {
	o.DepthLt = depthLt
}

// WithDepthLte adds the depthLte to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithDepthLte(depthLte *string) *IpamPrefixesListParams {
	o.SetDepthLte(depthLte)
	return o
}

// SetDepthLte adds the depthLte to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetDepthLte(depthLte *string) {
	o.DepthLte = depthLte
}

// WithDepthn adds the depthn to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithDepthn(depthn *string) *IpamPrefixesListParams {
	o.SetDepthn(depthn)
	return o
}

// SetDepthn adds the depthN to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetDepthn(depthn *string) {
	o.Depthn = depthn
}

// WithDescription adds the description to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithDescription(description *string) *IpamPrefixesListParams {
	o.SetDescription(description)
	return o
}

// SetDescription adds the description to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetDescription(description *string) {
	o.Description = description
}

// WithDescriptionIc adds the descriptionIc to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithDescriptionIc(descriptionIc *string) *IpamPrefixesListParams {
	o.SetDescriptionIc(descriptionIc)
	return o
}

// SetDescriptionIc adds the descriptionIc to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetDescriptionIc(descriptionIc *string) {
	o.DescriptionIc = descriptionIc
}

// WithDescriptionIe adds the descriptionIe to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithDescriptionIe(descriptionIe *string) *IpamPrefixesListParams {
	o.SetDescriptionIe(descriptionIe)
	return o
}

// SetDescriptionIe adds the descriptionIe to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetDescriptionIe(descriptionIe *string) {
	o.DescriptionIe = descriptionIe
}

// WithDescriptionIew adds the descriptionIew to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithDescriptionIew(descriptionIew *string) *IpamPrefixesListParams {
	o.SetDescriptionIew(descriptionIew)
	return o
}

// SetDescriptionIew adds the descriptionIew to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetDescriptionIew(descriptionIew *string) {
	o.DescriptionIew = descriptionIew
}

// WithDescriptionIsw adds the descriptionIsw to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithDescriptionIsw(descriptionIsw *string) *IpamPrefixesListParams {
	o.SetDescriptionIsw(descriptionIsw)
	return o
}

// SetDescriptionIsw adds the descriptionIsw to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetDescriptionIsw(descriptionIsw *string) {
	o.DescriptionIsw = descriptionIsw
}

// WithDescriptionn adds the descriptionn to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithDescriptionn(descriptionn *string) *IpamPrefixesListParams {
	o.SetDescriptionn(descriptionn)
	return o
}

// SetDescriptionn adds the descriptionN to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetDescriptionn(descriptionn *string) {
	o.Descriptionn = descriptionn
}

// WithDescriptionNic adds the descriptionNic to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithDescriptionNic(descriptionNic *string) *IpamPrefixesListParams {
	o.SetDescriptionNic(descriptionNic)
	return o
}

// SetDescriptionNic adds the descriptionNic to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetDescriptionNic(descriptionNic *string) {
	o.DescriptionNic = descriptionNic
}

// WithDescriptionNie adds the descriptionNie to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithDescriptionNie(descriptionNie *string) *IpamPrefixesListParams {
	o.SetDescriptionNie(descriptionNie)
	return o
}

// SetDescriptionNie adds the descriptionNie to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetDescriptionNie(descriptionNie *string) {
	o.DescriptionNie = descriptionNie
}

// WithDescriptionNiew adds the descriptionNiew to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithDescriptionNiew(descriptionNiew *string) *IpamPrefixesListParams {
	o.SetDescriptionNiew(descriptionNiew)
	return o
}

// SetDescriptionNiew adds the descriptionNiew to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetDescriptionNiew(descriptionNiew *string) {
	o.DescriptionNiew = descriptionNiew
}

// WithDescriptionNisw adds the descriptionNisw to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithDescriptionNisw(descriptionNisw *string) *IpamPrefixesListParams {
	o.SetDescriptionNisw(descriptionNisw)
	return o
}

// SetDescriptionNisw adds the descriptionNisw to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetDescriptionNisw(descriptionNisw *string) {
	o.DescriptionNisw = descriptionNisw
}

// WithFamily adds the family to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithFamily(family *float64) *IpamPrefixesListParams {
	o.SetFamily(family)
	return o
}

// SetFamily adds the family to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetFamily(family *float64) {
	o.Family = family
}

// WithID adds the id to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithID(id *string) *IpamPrefixesListParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetID(id *string) {
	o.ID = id
}

// WithIDGt adds the iDGt to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithIDGt(iDGt *string) *IpamPrefixesListParams {
	o.SetIDGt(iDGt)
	return o
}

// SetIDGt adds the idGt to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetIDGt(iDGt *string) {
	o.IDGt = iDGt
}

// WithIDGte adds the iDGte to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithIDGte(iDGte *string) *IpamPrefixesListParams {
	o.SetIDGte(iDGte)
	return o
}

// SetIDGte adds the idGte to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetIDGte(iDGte *string) {
	o.IDGte = iDGte
}

// WithIDLt adds the iDLt to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithIDLt(iDLt *string) *IpamPrefixesListParams {
	o.SetIDLt(iDLt)
	return o
}

// SetIDLt adds the idLt to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetIDLt(iDLt *string) {
	o.IDLt = iDLt
}

// WithIDLte adds the iDLte to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithIDLte(iDLte *string) *IpamPrefixesListParams {
	o.SetIDLte(iDLte)
	return o
}

// SetIDLte adds the idLte to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetIDLte(iDLte *string) {
	o.IDLte = iDLte
}

// WithIDn adds the iDn to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithIDn(iDn *string) *IpamPrefixesListParams {
	o.SetIDn(iDn)
	return o
}

// SetIDn adds the idN to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetIDn(iDn *string) {
	o.IDn = iDn
}

// WithIsPool adds the isPool to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithIsPool(isPool *string) *IpamPrefixesListParams {
	o.SetIsPool(isPool)
	return o
}

// SetIsPool adds the isPool to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetIsPool(isPool *string) {
	o.IsPool = isPool
}

// WithLastUpdated adds the lastUpdated to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithLastUpdated(lastUpdated *string) *IpamPrefixesListParams {
	o.SetLastUpdated(lastUpdated)
	return o
}

// SetLastUpdated adds the lastUpdated to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetLastUpdated(lastUpdated *string) {
	o.LastUpdated = lastUpdated
}

// WithLastUpdatedGte adds the lastUpdatedGte to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithLastUpdatedGte(lastUpdatedGte *string) *IpamPrefixesListParams {
	o.SetLastUpdatedGte(lastUpdatedGte)
	return o
}

// SetLastUpdatedGte adds the lastUpdatedGte to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetLastUpdatedGte(lastUpdatedGte *string) {
	o.LastUpdatedGte = lastUpdatedGte
}

// WithLastUpdatedLte adds the lastUpdatedLte to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithLastUpdatedLte(lastUpdatedLte *string) *IpamPrefixesListParams {
	o.SetLastUpdatedLte(lastUpdatedLte)
	return o
}

// SetLastUpdatedLte adds the lastUpdatedLte to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetLastUpdatedLte(lastUpdatedLte *string) {
	o.LastUpdatedLte = lastUpdatedLte
}

// WithLimit adds the limit to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithLimit(limit *int64) *IpamPrefixesListParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithMarkUtilized adds the markUtilized to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithMarkUtilized(markUtilized *string) *IpamPrefixesListParams {
	o.SetMarkUtilized(markUtilized)
	return o
}

// SetMarkUtilized adds the markUtilized to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetMarkUtilized(markUtilized *string) {
	o.MarkUtilized = markUtilized
}

// WithMaskLength adds the maskLength to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithMaskLength(maskLength *string) *IpamPrefixesListParams {
	o.SetMaskLength(maskLength)
	return o
}

// SetMaskLength adds the maskLength to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetMaskLength(maskLength *string) {
	o.MaskLength = maskLength
}

// WithMaskLengthGte adds the maskLengthGte to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithMaskLengthGte(maskLengthGte *float64) *IpamPrefixesListParams {
	o.SetMaskLengthGte(maskLengthGte)
	return o
}

// SetMaskLengthGte adds the maskLengthGte to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetMaskLengthGte(maskLengthGte *float64) {
	o.MaskLengthGte = maskLengthGte
}

// WithMaskLengthLte adds the maskLengthLte to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithMaskLengthLte(maskLengthLte *float64) *IpamPrefixesListParams {
	o.SetMaskLengthLte(maskLengthLte)
	return o
}

// SetMaskLengthLte adds the maskLengthLte to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetMaskLengthLte(maskLengthLte *float64) {
	o.MaskLengthLte = maskLengthLte
}

// WithOffset adds the offset to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithOffset(offset *int64) *IpamPrefixesListParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithPrefix adds the prefix to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithPrefix(prefix *string) *IpamPrefixesListParams {
	o.SetPrefix(prefix)
	return o
}

// SetPrefix adds the prefix to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetPrefix(prefix *string) {
	o.Prefix = prefix
}

// WithPresentInVrf adds the presentInVrf to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithPresentInVrf(presentInVrf *string) *IpamPrefixesListParams {
	o.SetPresentInVrf(presentInVrf)
	return o
}

// SetPresentInVrf adds the presentInVrf to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetPresentInVrf(presentInVrf *string) {
	o.PresentInVrf = presentInVrf
}

// WithPresentInVrfID adds the presentInVrfID to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithPresentInVrfID(presentInVrfID *string) *IpamPrefixesListParams {
	o.SetPresentInVrfID(presentInVrfID)
	return o
}

// SetPresentInVrfID adds the presentInVrfId to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetPresentInVrfID(presentInVrfID *string) {
	o.PresentInVrfID = presentInVrfID
}

// WithQ adds the q to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithQ(q *string) *IpamPrefixesListParams {
	o.SetQ(q)
	return o
}

// SetQ adds the q to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetQ(q *string) {
	o.Q = q
}

// WithRegion adds the region to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithRegion(region *string) *IpamPrefixesListParams {
	o.SetRegion(region)
	return o
}

// SetRegion adds the region to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetRegion(region *string) {
	o.Region = region
}

// WithRegionn adds the regionn to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithRegionn(regionn *string) *IpamPrefixesListParams {
	o.SetRegionn(regionn)
	return o
}

// SetRegionn adds the regionN to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetRegionn(regionn *string) {
	o.Regionn = regionn
}

// WithRegionID adds the regionID to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithRegionID(regionID *string) *IpamPrefixesListParams {
	o.SetRegionID(regionID)
	return o
}

// SetRegionID adds the regionId to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetRegionID(regionID *string) {
	o.RegionID = regionID
}

// WithRegionIDn adds the regionIDn to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithRegionIDn(regionIDn *string) *IpamPrefixesListParams {
	o.SetRegionIDn(regionIDn)
	return o
}

// SetRegionIDn adds the regionIdN to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetRegionIDn(regionIDn *string) {
	o.RegionIDn = regionIDn
}

// WithRole adds the role to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithRole(role *string) *IpamPrefixesListParams {
	o.SetRole(role)
	return o
}

// SetRole adds the role to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetRole(role *string) {
	o.Role = role
}

// WithRolen adds the rolen to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithRolen(rolen *string) *IpamPrefixesListParams {
	o.SetRolen(rolen)
	return o
}

// SetRolen adds the roleN to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetRolen(rolen *string) {
	o.Rolen = rolen
}

// WithRoleID adds the roleID to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithRoleID(roleID *string) *IpamPrefixesListParams {
	o.SetRoleID(roleID)
	return o
}

// SetRoleID adds the roleId to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetRoleID(roleID *string) {
	o.RoleID = roleID
}

// WithRoleIDn adds the roleIDn to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithRoleIDn(roleIDn *string) *IpamPrefixesListParams {
	o.SetRoleIDn(roleIDn)
	return o
}

// SetRoleIDn adds the roleIdN to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetRoleIDn(roleIDn *string) {
	o.RoleIDn = roleIDn
}

// WithSite adds the site to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithSite(site *string) *IpamPrefixesListParams {
	o.SetSite(site)
	return o
}

// SetSite adds the site to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetSite(site *string) {
	o.Site = site
}

// WithSiten adds the siten to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithSiten(siten *string) *IpamPrefixesListParams {
	o.SetSiten(siten)
	return o
}

// SetSiten adds the siteN to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetSiten(siten *string) {
	o.Siten = siten
}

// WithSiteGroup adds the siteGroup to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithSiteGroup(siteGroup *string) *IpamPrefixesListParams {
	o.SetSiteGroup(siteGroup)
	return o
}

// SetSiteGroup adds the siteGroup to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetSiteGroup(siteGroup *string) {
	o.SiteGroup = siteGroup
}

// WithSiteGroupn adds the siteGroupn to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithSiteGroupn(siteGroupn *string) *IpamPrefixesListParams {
	o.SetSiteGroupn(siteGroupn)
	return o
}

// SetSiteGroupn adds the siteGroupN to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetSiteGroupn(siteGroupn *string) {
	o.SiteGroupn = siteGroupn
}

// WithSiteGroupID adds the siteGroupID to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithSiteGroupID(siteGroupID *string) *IpamPrefixesListParams {
	o.SetSiteGroupID(siteGroupID)
	return o
}

// SetSiteGroupID adds the siteGroupId to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetSiteGroupID(siteGroupID *string) {
	o.SiteGroupID = siteGroupID
}

// WithSiteGroupIDn adds the siteGroupIDn to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithSiteGroupIDn(siteGroupIDn *string) *IpamPrefixesListParams {
	o.SetSiteGroupIDn(siteGroupIDn)
	return o
}

// SetSiteGroupIDn adds the siteGroupIdN to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetSiteGroupIDn(siteGroupIDn *string) {
	o.SiteGroupIDn = siteGroupIDn
}

// WithSiteID adds the siteID to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithSiteID(siteID *string) *IpamPrefixesListParams {
	o.SetSiteID(siteID)
	return o
}

// SetSiteID adds the siteId to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetSiteID(siteID *string) {
	o.SiteID = siteID
}

// WithSiteIDn adds the siteIDn to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithSiteIDn(siteIDn *string) *IpamPrefixesListParams {
	o.SetSiteIDn(siteIDn)
	return o
}

// SetSiteIDn adds the siteIdN to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetSiteIDn(siteIDn *string) {
	o.SiteIDn = siteIDn
}

// WithStatus adds the status to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithStatus(status *string) *IpamPrefixesListParams {
	o.SetStatus(status)
	return o
}

// SetStatus adds the status to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetStatus(status *string) {
	o.Status = status
}

// WithStatusn adds the statusn to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithStatusn(statusn *string) *IpamPrefixesListParams {
	o.SetStatusn(statusn)
	return o
}

// SetStatusn adds the statusN to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetStatusn(statusn *string) {
	o.Statusn = statusn
}

// WithTag adds the tag to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithTag(tag *string) *IpamPrefixesListParams {
	o.SetTag(tag)
	return o
}

// SetTag adds the tag to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetTag(tag *string) {
	o.Tag = tag
}

// WithTagn adds the tagn to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithTagn(tagn *string) *IpamPrefixesListParams {
	o.SetTagn(tagn)
	return o
}

// SetTagn adds the tagN to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetTagn(tagn *string) {
	o.Tagn = tagn
}

// WithTenant adds the tenant to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithTenant(tenant *string) *IpamPrefixesListParams {
	o.SetTenant(tenant)
	return o
}

// SetTenant adds the tenant to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetTenant(tenant *string) {
	o.Tenant = tenant
}

// WithTenantn adds the tenantn to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithTenantn(tenantn *string) *IpamPrefixesListParams {
	o.SetTenantn(tenantn)
	return o
}

// SetTenantn adds the tenantN to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetTenantn(tenantn *string) {
	o.Tenantn = tenantn
}

// WithTenantGroup adds the tenantGroup to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithTenantGroup(tenantGroup *string) *IpamPrefixesListParams {
	o.SetTenantGroup(tenantGroup)
	return o
}

// SetTenantGroup adds the tenantGroup to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetTenantGroup(tenantGroup *string) {
	o.TenantGroup = tenantGroup
}

// WithTenantGroupn adds the tenantGroupn to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithTenantGroupn(tenantGroupn *string) *IpamPrefixesListParams {
	o.SetTenantGroupn(tenantGroupn)
	return o
}

// SetTenantGroupn adds the tenantGroupN to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetTenantGroupn(tenantGroupn *string) {
	o.TenantGroupn = tenantGroupn
}

// WithTenantGroupID adds the tenantGroupID to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithTenantGroupID(tenantGroupID *string) *IpamPrefixesListParams {
	o.SetTenantGroupID(tenantGroupID)
	return o
}

// SetTenantGroupID adds the tenantGroupId to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetTenantGroupID(tenantGroupID *string) {
	o.TenantGroupID = tenantGroupID
}

// WithTenantGroupIDn adds the tenantGroupIDn to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithTenantGroupIDn(tenantGroupIDn *string) *IpamPrefixesListParams {
	o.SetTenantGroupIDn(tenantGroupIDn)
	return o
}

// SetTenantGroupIDn adds the tenantGroupIdN to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetTenantGroupIDn(tenantGroupIDn *string) {
	o.TenantGroupIDn = tenantGroupIDn
}

// WithTenantID adds the tenantID to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithTenantID(tenantID *string) *IpamPrefixesListParams {
	o.SetTenantID(tenantID)
	return o
}

// SetTenantID adds the tenantId to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetTenantID(tenantID *string) {
	o.TenantID = tenantID
}

// WithTenantIDn adds the tenantIDn to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithTenantIDn(tenantIDn *string) *IpamPrefixesListParams {
	o.SetTenantIDn(tenantIDn)
	return o
}

// SetTenantIDn adds the tenantIdN to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetTenantIDn(tenantIDn *string) {
	o.TenantIDn = tenantIDn
}

// WithVlanID adds the vlanID to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithVlanID(vlanID *string) *IpamPrefixesListParams {
	o.SetVlanID(vlanID)
	return o
}

// SetVlanID adds the vlanId to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetVlanID(vlanID *string) {
	o.VlanID = vlanID
}

// WithVlanIDn adds the vlanIDn to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithVlanIDn(vlanIDn *string) *IpamPrefixesListParams {
	o.SetVlanIDn(vlanIDn)
	return o
}

// SetVlanIDn adds the vlanIdN to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetVlanIDn(vlanIDn *string) {
	o.VlanIDn = vlanIDn
}

// WithVlanVid adds the vlanVid to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithVlanVid(vlanVid *float64) *IpamPrefixesListParams {
	o.SetVlanVid(vlanVid)
	return o
}

// SetVlanVid adds the vlanVid to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetVlanVid(vlanVid *float64) {
	o.VlanVid = vlanVid
}

// WithVlanVidGt adds the vlanVidGt to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithVlanVidGt(vlanVidGt *float64) *IpamPrefixesListParams {
	o.SetVlanVidGt(vlanVidGt)
	return o
}

// SetVlanVidGt adds the vlanVidGt to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetVlanVidGt(vlanVidGt *float64) {
	o.VlanVidGt = vlanVidGt
}

// WithVlanVidGte adds the vlanVidGte to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithVlanVidGte(vlanVidGte *float64) *IpamPrefixesListParams {
	o.SetVlanVidGte(vlanVidGte)
	return o
}

// SetVlanVidGte adds the vlanVidGte to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetVlanVidGte(vlanVidGte *float64) {
	o.VlanVidGte = vlanVidGte
}

// WithVlanVidLt adds the vlanVidLt to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithVlanVidLt(vlanVidLt *float64) *IpamPrefixesListParams {
	o.SetVlanVidLt(vlanVidLt)
	return o
}

// SetVlanVidLt adds the vlanVidLt to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetVlanVidLt(vlanVidLt *float64) {
	o.VlanVidLt = vlanVidLt
}

// WithVlanVidLte adds the vlanVidLte to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithVlanVidLte(vlanVidLte *float64) *IpamPrefixesListParams {
	o.SetVlanVidLte(vlanVidLte)
	return o
}

// SetVlanVidLte adds the vlanVidLte to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetVlanVidLte(vlanVidLte *float64) {
	o.VlanVidLte = vlanVidLte
}

// WithVlanVidn adds the vlanVidn to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithVlanVidn(vlanVidn *float64) *IpamPrefixesListParams {
	o.SetVlanVidn(vlanVidn)
	return o
}

// SetVlanVidn adds the vlanVidN to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetVlanVidn(vlanVidn *float64) {
	o.VlanVidn = vlanVidn
}

// WithVrf adds the vrf to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithVrf(vrf *string) *IpamPrefixesListParams {
	o.SetVrf(vrf)
	return o
}

// SetVrf adds the vrf to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetVrf(vrf *string) {
	o.Vrf = vrf
}

// WithVrfn adds the vrfn to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithVrfn(vrfn *string) *IpamPrefixesListParams {
	o.SetVrfn(vrfn)
	return o
}

// SetVrfn adds the vrfN to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetVrfn(vrfn *string) {
	o.Vrfn = vrfn
}

// WithVrfID adds the vrfID to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithVrfID(vrfID *string) *IpamPrefixesListParams {
	o.SetVrfID(vrfID)
	return o
}

// SetVrfID adds the vrfId to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetVrfID(vrfID *string) {
	o.VrfID = vrfID
}

// WithVrfIDn adds the vrfIDn to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithVrfIDn(vrfIDn *string) *IpamPrefixesListParams {
	o.SetVrfIDn(vrfIDn)
	return o
}

// SetVrfIDn adds the vrfIdN to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetVrfIDn(vrfIDn *string) {
	o.VrfIDn = vrfIDn
}

// WithWithin adds the within to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithWithin(within *string) *IpamPrefixesListParams {
	o.SetWithin(within)
	return o
}

// SetWithin adds the within to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetWithin(within *string) {
	o.Within = within
}

// WithWithinInclude adds the withinInclude to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithWithinInclude(withinInclude *string) *IpamPrefixesListParams {
	o.SetWithinInclude(withinInclude)
	return o
}

// SetWithinInclude adds the withinInclude to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetWithinInclude(withinInclude *string) {
	o.WithinInclude = withinInclude
}

// WriteToRequest writes these params to a swagger request
func (o *IpamPrefixesListParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Children != nil {

		// query param children
		var qrChildren string

		if o.Children != nil {
			qrChildren = *o.Children
		}
		qChildren := qrChildren
		if qChildren != "" {

			if err := r.SetQueryParam("children", qChildren); err != nil {
				return err
			}
		}
	}

	if o.ChildrenGt != nil {

		// query param children__gt
		var qrChildrenGt string

		if o.ChildrenGt != nil {
			qrChildrenGt = *o.ChildrenGt
		}
		qChildrenGt := qrChildrenGt
		if qChildrenGt != "" {

			if err := r.SetQueryParam("children__gt", qChildrenGt); err != nil {
				return err
			}
		}
	}

	if o.ChildrenGte != nil {

		// query param children__gte
		var qrChildrenGte string

		if o.ChildrenGte != nil {
			qrChildrenGte = *o.ChildrenGte
		}
		qChildrenGte := qrChildrenGte
		if qChildrenGte != "" {

			if err := r.SetQueryParam("children__gte", qChildrenGte); err != nil {
				return err
			}
		}
	}

	if o.ChildrenLt != nil {

		// query param children__lt
		var qrChildrenLt string

		if o.ChildrenLt != nil {
			qrChildrenLt = *o.ChildrenLt
		}
		qChildrenLt := qrChildrenLt
		if qChildrenLt != "" {

			if err := r.SetQueryParam("children__lt", qChildrenLt); err != nil {
				return err
			}
		}
	}

	if o.ChildrenLte != nil {

		// query param children__lte
		var qrChildrenLte string

		if o.ChildrenLte != nil {
			qrChildrenLte = *o.ChildrenLte
		}
		qChildrenLte := qrChildrenLte
		if qChildrenLte != "" {

			if err := r.SetQueryParam("children__lte", qChildrenLte); err != nil {
				return err
			}
		}
	}

	if o.Childrenn != nil {

		// query param children__n
		var qrChildrenn string

		if o.Childrenn != nil {
			qrChildrenn = *o.Childrenn
		}
		qChildrenn := qrChildrenn
		if qChildrenn != "" {

			if err := r.SetQueryParam("children__n", qChildrenn); err != nil {
				return err
			}
		}
	}

	if o.Contains != nil {

		// query param contains
		var qrContains string

		if o.Contains != nil {
			qrContains = *o.Contains
		}
		qContains := qrContains
		if qContains != "" {

			if err := r.SetQueryParam("contains", qContains); err != nil {
				return err
			}
		}
	}

	if o.Created != nil {

		// query param created
		var qrCreated string

		if o.Created != nil {
			qrCreated = *o.Created
		}
		qCreated := qrCreated
		if qCreated != "" {

			if err := r.SetQueryParam("created", qCreated); err != nil {
				return err
			}
		}
	}

	if o.CreatedGte != nil {

		// query param created__gte
		var qrCreatedGte string

		if o.CreatedGte != nil {
			qrCreatedGte = *o.CreatedGte
		}
		qCreatedGte := qrCreatedGte
		if qCreatedGte != "" {

			if err := r.SetQueryParam("created__gte", qCreatedGte); err != nil {
				return err
			}
		}
	}

	if o.CreatedLte != nil {

		// query param created__lte
		var qrCreatedLte string

		if o.CreatedLte != nil {
			qrCreatedLte = *o.CreatedLte
		}
		qCreatedLte := qrCreatedLte
		if qCreatedLte != "" {

			if err := r.SetQueryParam("created__lte", qCreatedLte); err != nil {
				return err
			}
		}
	}

	if o.Depth != nil {

		// query param depth
		var qrDepth string

		if o.Depth != nil {
			qrDepth = *o.Depth
		}
		qDepth := qrDepth
		if qDepth != "" {

			if err := r.SetQueryParam("depth", qDepth); err != nil {
				return err
			}
		}
	}

	if o.DepthGt != nil {

		// query param depth__gt
		var qrDepthGt string

		if o.DepthGt != nil {
			qrDepthGt = *o.DepthGt
		}
		qDepthGt := qrDepthGt
		if qDepthGt != "" {

			if err := r.SetQueryParam("depth__gt", qDepthGt); err != nil {
				return err
			}
		}
	}

	if o.DepthGte != nil {

		// query param depth__gte
		var qrDepthGte string

		if o.DepthGte != nil {
			qrDepthGte = *o.DepthGte
		}
		qDepthGte := qrDepthGte
		if qDepthGte != "" {

			if err := r.SetQueryParam("depth__gte", qDepthGte); err != nil {
				return err
			}
		}
	}

	if o.DepthLt != nil {

		// query param depth__lt
		var qrDepthLt string

		if o.DepthLt != nil {
			qrDepthLt = *o.DepthLt
		}
		qDepthLt := qrDepthLt
		if qDepthLt != "" {

			if err := r.SetQueryParam("depth__lt", qDepthLt); err != nil {
				return err
			}
		}
	}

	if o.DepthLte != nil {

		// query param depth__lte
		var qrDepthLte string

		if o.DepthLte != nil {
			qrDepthLte = *o.DepthLte
		}
		qDepthLte := qrDepthLte
		if qDepthLte != "" {

			if err := r.SetQueryParam("depth__lte", qDepthLte); err != nil {
				return err
			}
		}
	}

	if o.Depthn != nil {

		// query param depth__n
		var qrDepthn string

		if o.Depthn != nil {
			qrDepthn = *o.Depthn
		}
		qDepthn := qrDepthn
		if qDepthn != "" {

			if err := r.SetQueryParam("depth__n", qDepthn); err != nil {
				return err
			}
		}
	}

	if o.Description != nil {

		// query param description
		var qrDescription string

		if o.Description != nil {
			qrDescription = *o.Description
		}
		qDescription := qrDescription
		if qDescription != "" {

			if err := r.SetQueryParam("description", qDescription); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIc != nil {

		// query param description__ic
		var qrDescriptionIc string

		if o.DescriptionIc != nil {
			qrDescriptionIc = *o.DescriptionIc
		}
		qDescriptionIc := qrDescriptionIc
		if qDescriptionIc != "" {

			if err := r.SetQueryParam("description__ic", qDescriptionIc); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIe != nil {

		// query param description__ie
		var qrDescriptionIe string

		if o.DescriptionIe != nil {
			qrDescriptionIe = *o.DescriptionIe
		}
		qDescriptionIe := qrDescriptionIe
		if qDescriptionIe != "" {

			if err := r.SetQueryParam("description__ie", qDescriptionIe); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIew != nil {

		// query param description__iew
		var qrDescriptionIew string

		if o.DescriptionIew != nil {
			qrDescriptionIew = *o.DescriptionIew
		}
		qDescriptionIew := qrDescriptionIew
		if qDescriptionIew != "" {

			if err := r.SetQueryParam("description__iew", qDescriptionIew); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIsw != nil {

		// query param description__isw
		var qrDescriptionIsw string

		if o.DescriptionIsw != nil {
			qrDescriptionIsw = *o.DescriptionIsw
		}
		qDescriptionIsw := qrDescriptionIsw
		if qDescriptionIsw != "" {

			if err := r.SetQueryParam("description__isw", qDescriptionIsw); err != nil {
				return err
			}
		}
	}

	if o.Descriptionn != nil {

		// query param description__n
		var qrDescriptionn string

		if o.Descriptionn != nil {
			qrDescriptionn = *o.Descriptionn
		}
		qDescriptionn := qrDescriptionn
		if qDescriptionn != "" {

			if err := r.SetQueryParam("description__n", qDescriptionn); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNic != nil {

		// query param description__nic
		var qrDescriptionNic string

		if o.DescriptionNic != nil {
			qrDescriptionNic = *o.DescriptionNic
		}
		qDescriptionNic := qrDescriptionNic
		if qDescriptionNic != "" {

			if err := r.SetQueryParam("description__nic", qDescriptionNic); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNie != nil {

		// query param description__nie
		var qrDescriptionNie string

		if o.DescriptionNie != nil {
			qrDescriptionNie = *o.DescriptionNie
		}
		qDescriptionNie := qrDescriptionNie
		if qDescriptionNie != "" {

			if err := r.SetQueryParam("description__nie", qDescriptionNie); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNiew != nil {

		// query param description__niew
		var qrDescriptionNiew string

		if o.DescriptionNiew != nil {
			qrDescriptionNiew = *o.DescriptionNiew
		}
		qDescriptionNiew := qrDescriptionNiew
		if qDescriptionNiew != "" {

			if err := r.SetQueryParam("description__niew", qDescriptionNiew); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNisw != nil {

		// query param description__nisw
		var qrDescriptionNisw string

		if o.DescriptionNisw != nil {
			qrDescriptionNisw = *o.DescriptionNisw
		}
		qDescriptionNisw := qrDescriptionNisw
		if qDescriptionNisw != "" {

			if err := r.SetQueryParam("description__nisw", qDescriptionNisw); err != nil {
				return err
			}
		}
	}

	if o.Family != nil {

		// query param family
		var qrFamily float64

		if o.Family != nil {
			qrFamily = *o.Family
		}
		qFamily := swag.FormatFloat64(qrFamily)
		if qFamily != "" {

			if err := r.SetQueryParam("family", qFamily); err != nil {
				return err
			}
		}
	}

	if o.ID != nil {

		// query param id
		var qrID string

		if o.ID != nil {
			qrID = *o.ID
		}
		qID := qrID
		if qID != "" {

			if err := r.SetQueryParam("id", qID); err != nil {
				return err
			}
		}
	}

	if o.IDGt != nil {

		// query param id__gt
		var qrIDGt string

		if o.IDGt != nil {
			qrIDGt = *o.IDGt
		}
		qIDGt := qrIDGt
		if qIDGt != "" {

			if err := r.SetQueryParam("id__gt", qIDGt); err != nil {
				return err
			}
		}
	}

	if o.IDGte != nil {

		// query param id__gte
		var qrIDGte string

		if o.IDGte != nil {
			qrIDGte = *o.IDGte
		}
		qIDGte := qrIDGte
		if qIDGte != "" {

			if err := r.SetQueryParam("id__gte", qIDGte); err != nil {
				return err
			}
		}
	}

	if o.IDLt != nil {

		// query param id__lt
		var qrIDLt string

		if o.IDLt != nil {
			qrIDLt = *o.IDLt
		}
		qIDLt := qrIDLt
		if qIDLt != "" {

			if err := r.SetQueryParam("id__lt", qIDLt); err != nil {
				return err
			}
		}
	}

	if o.IDLte != nil {

		// query param id__lte
		var qrIDLte string

		if o.IDLte != nil {
			qrIDLte = *o.IDLte
		}
		qIDLte := qrIDLte
		if qIDLte != "" {

			if err := r.SetQueryParam("id__lte", qIDLte); err != nil {
				return err
			}
		}
	}

	if o.IDn != nil {

		// query param id__n
		var qrIDn string

		if o.IDn != nil {
			qrIDn = *o.IDn
		}
		qIDn := qrIDn
		if qIDn != "" {

			if err := r.SetQueryParam("id__n", qIDn); err != nil {
				return err
			}
		}
	}

	if o.IsPool != nil {

		// query param is_pool
		var qrIsPool string

		if o.IsPool != nil {
			qrIsPool = *o.IsPool
		}
		qIsPool := qrIsPool
		if qIsPool != "" {

			if err := r.SetQueryParam("is_pool", qIsPool); err != nil {
				return err
			}
		}
	}

	if o.LastUpdated != nil {

		// query param last_updated
		var qrLastUpdated string

		if o.LastUpdated != nil {
			qrLastUpdated = *o.LastUpdated
		}
		qLastUpdated := qrLastUpdated
		if qLastUpdated != "" {

			if err := r.SetQueryParam("last_updated", qLastUpdated); err != nil {
				return err
			}
		}
	}

	if o.LastUpdatedGte != nil {

		// query param last_updated__gte
		var qrLastUpdatedGte string

		if o.LastUpdatedGte != nil {
			qrLastUpdatedGte = *o.LastUpdatedGte
		}
		qLastUpdatedGte := qrLastUpdatedGte
		if qLastUpdatedGte != "" {

			if err := r.SetQueryParam("last_updated__gte", qLastUpdatedGte); err != nil {
				return err
			}
		}
	}

	if o.LastUpdatedLte != nil {

		// query param last_updated__lte
		var qrLastUpdatedLte string

		if o.LastUpdatedLte != nil {
			qrLastUpdatedLte = *o.LastUpdatedLte
		}
		qLastUpdatedLte := qrLastUpdatedLte
		if qLastUpdatedLte != "" {

			if err := r.SetQueryParam("last_updated__lte", qLastUpdatedLte); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.MarkUtilized != nil {

		// query param mark_utilized
		var qrMarkUtilized string

		if o.MarkUtilized != nil {
			qrMarkUtilized = *o.MarkUtilized
		}
		qMarkUtilized := qrMarkUtilized
		if qMarkUtilized != "" {

			if err := r.SetQueryParam("mark_utilized", qMarkUtilized); err != nil {
				return err
			}
		}
	}

	if o.MaskLength != nil {

		// query param mask_length
		var qrMaskLength string

		if o.MaskLength != nil {
			qrMaskLength = *o.MaskLength
		}
		qMaskLength := qrMaskLength
		if qMaskLength != "" {

			if err := r.SetQueryParam("mask_length", qMaskLength); err != nil {
				return err
			}
		}
	}

	if o.MaskLengthGte != nil {

		// query param mask_length__gte
		var qrMaskLengthGte float64

		if o.MaskLengthGte != nil {
			qrMaskLengthGte = *o.MaskLengthGte
		}
		qMaskLengthGte := swag.FormatFloat64(qrMaskLengthGte)
		if qMaskLengthGte != "" {

			if err := r.SetQueryParam("mask_length__gte", qMaskLengthGte); err != nil {
				return err
			}
		}
	}

	if o.MaskLengthLte != nil {

		// query param mask_length__lte
		var qrMaskLengthLte float64

		if o.MaskLengthLte != nil {
			qrMaskLengthLte = *o.MaskLengthLte
		}
		qMaskLengthLte := swag.FormatFloat64(qrMaskLengthLte)
		if qMaskLengthLte != "" {

			if err := r.SetQueryParam("mask_length__lte", qMaskLengthLte); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if o.Prefix != nil {

		// query param prefix
		var qrPrefix string

		if o.Prefix != nil {
			qrPrefix = *o.Prefix
		}
		qPrefix := qrPrefix
		if qPrefix != "" {

			if err := r.SetQueryParam("prefix", qPrefix); err != nil {
				return err
			}
		}
	}

	if o.PresentInVrf != nil {

		// query param present_in_vrf
		var qrPresentInVrf string

		if o.PresentInVrf != nil {
			qrPresentInVrf = *o.PresentInVrf
		}
		qPresentInVrf := qrPresentInVrf
		if qPresentInVrf != "" {

			if err := r.SetQueryParam("present_in_vrf", qPresentInVrf); err != nil {
				return err
			}
		}
	}

	if o.PresentInVrfID != nil {

		// query param present_in_vrf_id
		var qrPresentInVrfID string

		if o.PresentInVrfID != nil {
			qrPresentInVrfID = *o.PresentInVrfID
		}
		qPresentInVrfID := qrPresentInVrfID
		if qPresentInVrfID != "" {

			if err := r.SetQueryParam("present_in_vrf_id", qPresentInVrfID); err != nil {
				return err
			}
		}
	}

	if o.Q != nil {

		// query param q
		var qrQ string

		if o.Q != nil {
			qrQ = *o.Q
		}
		qQ := qrQ
		if qQ != "" {

			if err := r.SetQueryParam("q", qQ); err != nil {
				return err
			}
		}
	}

	if o.Region != nil {

		// query param region
		var qrRegion string

		if o.Region != nil {
			qrRegion = *o.Region
		}
		qRegion := qrRegion
		if qRegion != "" {

			if err := r.SetQueryParam("region", qRegion); err != nil {
				return err
			}
		}
	}

	if o.Regionn != nil {

		// query param region__n
		var qrRegionn string

		if o.Regionn != nil {
			qrRegionn = *o.Regionn
		}
		qRegionn := qrRegionn
		if qRegionn != "" {

			if err := r.SetQueryParam("region__n", qRegionn); err != nil {
				return err
			}
		}
	}

	if o.RegionID != nil {

		// query param region_id
		var qrRegionID string

		if o.RegionID != nil {
			qrRegionID = *o.RegionID
		}
		qRegionID := qrRegionID
		if qRegionID != "" {

			if err := r.SetQueryParam("region_id", qRegionID); err != nil {
				return err
			}
		}
	}

	if o.RegionIDn != nil {

		// query param region_id__n
		var qrRegionIDn string

		if o.RegionIDn != nil {
			qrRegionIDn = *o.RegionIDn
		}
		qRegionIDn := qrRegionIDn
		if qRegionIDn != "" {

			if err := r.SetQueryParam("region_id__n", qRegionIDn); err != nil {
				return err
			}
		}
	}

	if o.Role != nil {

		// query param role
		var qrRole string

		if o.Role != nil {
			qrRole = *o.Role
		}
		qRole := qrRole
		if qRole != "" {

			if err := r.SetQueryParam("role", qRole); err != nil {
				return err
			}
		}
	}

	if o.Rolen != nil {

		// query param role__n
		var qrRolen string

		if o.Rolen != nil {
			qrRolen = *o.Rolen
		}
		qRolen := qrRolen
		if qRolen != "" {

			if err := r.SetQueryParam("role__n", qRolen); err != nil {
				return err
			}
		}
	}

	if o.RoleID != nil {

		// query param role_id
		var qrRoleID string

		if o.RoleID != nil {
			qrRoleID = *o.RoleID
		}
		qRoleID := qrRoleID
		if qRoleID != "" {

			if err := r.SetQueryParam("role_id", qRoleID); err != nil {
				return err
			}
		}
	}

	if o.RoleIDn != nil {

		// query param role_id__n
		var qrRoleIDn string

		if o.RoleIDn != nil {
			qrRoleIDn = *o.RoleIDn
		}
		qRoleIDn := qrRoleIDn
		if qRoleIDn != "" {

			if err := r.SetQueryParam("role_id__n", qRoleIDn); err != nil {
				return err
			}
		}
	}

	if o.Site != nil {

		// query param site
		var qrSite string

		if o.Site != nil {
			qrSite = *o.Site
		}
		qSite := qrSite
		if qSite != "" {

			if err := r.SetQueryParam("site", qSite); err != nil {
				return err
			}
		}
	}

	if o.Siten != nil {

		// query param site__n
		var qrSiten string

		if o.Siten != nil {
			qrSiten = *o.Siten
		}
		qSiten := qrSiten
		if qSiten != "" {

			if err := r.SetQueryParam("site__n", qSiten); err != nil {
				return err
			}
		}
	}

	if o.SiteGroup != nil {

		// query param site_group
		var qrSiteGroup string

		if o.SiteGroup != nil {
			qrSiteGroup = *o.SiteGroup
		}
		qSiteGroup := qrSiteGroup
		if qSiteGroup != "" {

			if err := r.SetQueryParam("site_group", qSiteGroup); err != nil {
				return err
			}
		}
	}

	if o.SiteGroupn != nil {

		// query param site_group__n
		var qrSiteGroupn string

		if o.SiteGroupn != nil {
			qrSiteGroupn = *o.SiteGroupn
		}
		qSiteGroupn := qrSiteGroupn
		if qSiteGroupn != "" {

			if err := r.SetQueryParam("site_group__n", qSiteGroupn); err != nil {
				return err
			}
		}
	}

	if o.SiteGroupID != nil {

		// query param site_group_id
		var qrSiteGroupID string

		if o.SiteGroupID != nil {
			qrSiteGroupID = *o.SiteGroupID
		}
		qSiteGroupID := qrSiteGroupID
		if qSiteGroupID != "" {

			if err := r.SetQueryParam("site_group_id", qSiteGroupID); err != nil {
				return err
			}
		}
	}

	if o.SiteGroupIDn != nil {

		// query param site_group_id__n
		var qrSiteGroupIDn string

		if o.SiteGroupIDn != nil {
			qrSiteGroupIDn = *o.SiteGroupIDn
		}
		qSiteGroupIDn := qrSiteGroupIDn
		if qSiteGroupIDn != "" {

			if err := r.SetQueryParam("site_group_id__n", qSiteGroupIDn); err != nil {
				return err
			}
		}
	}

	if o.SiteID != nil {

		// query param site_id
		var qrSiteID string

		if o.SiteID != nil {
			qrSiteID = *o.SiteID
		}
		qSiteID := qrSiteID
		if qSiteID != "" {

			if err := r.SetQueryParam("site_id", qSiteID); err != nil {
				return err
			}
		}
	}

	if o.SiteIDn != nil {

		// query param site_id__n
		var qrSiteIDn string

		if o.SiteIDn != nil {
			qrSiteIDn = *o.SiteIDn
		}
		qSiteIDn := qrSiteIDn
		if qSiteIDn != "" {

			if err := r.SetQueryParam("site_id__n", qSiteIDn); err != nil {
				return err
			}
		}
	}

	if o.Status != nil {

		// query param status
		var qrStatus string

		if o.Status != nil {
			qrStatus = *o.Status
		}
		qStatus := qrStatus
		if qStatus != "" {

			if err := r.SetQueryParam("status", qStatus); err != nil {
				return err
			}
		}
	}

	if o.Statusn != nil {

		// query param status__n
		var qrStatusn string

		if o.Statusn != nil {
			qrStatusn = *o.Statusn
		}
		qStatusn := qrStatusn
		if qStatusn != "" {

			if err := r.SetQueryParam("status__n", qStatusn); err != nil {
				return err
			}
		}
	}

	if o.Tag != nil {

		// query param tag
		var qrTag string

		if o.Tag != nil {
			qrTag = *o.Tag
		}
		qTag := qrTag
		if qTag != "" {

			if err := r.SetQueryParam("tag", qTag); err != nil {
				return err
			}
		}
	}

	if o.Tagn != nil {

		// query param tag__n
		var qrTagn string

		if o.Tagn != nil {
			qrTagn = *o.Tagn
		}
		qTagn := qrTagn
		if qTagn != "" {

			if err := r.SetQueryParam("tag__n", qTagn); err != nil {
				return err
			}
		}
	}

	if o.Tenant != nil {

		// query param tenant
		var qrTenant string

		if o.Tenant != nil {
			qrTenant = *o.Tenant
		}
		qTenant := qrTenant
		if qTenant != "" {

			if err := r.SetQueryParam("tenant", qTenant); err != nil {
				return err
			}
		}
	}

	if o.Tenantn != nil {

		// query param tenant__n
		var qrTenantn string

		if o.Tenantn != nil {
			qrTenantn = *o.Tenantn
		}
		qTenantn := qrTenantn
		if qTenantn != "" {

			if err := r.SetQueryParam("tenant__n", qTenantn); err != nil {
				return err
			}
		}
	}

	if o.TenantGroup != nil {

		// query param tenant_group
		var qrTenantGroup string

		if o.TenantGroup != nil {
			qrTenantGroup = *o.TenantGroup
		}
		qTenantGroup := qrTenantGroup
		if qTenantGroup != "" {

			if err := r.SetQueryParam("tenant_group", qTenantGroup); err != nil {
				return err
			}
		}
	}

	if o.TenantGroupn != nil {

		// query param tenant_group__n
		var qrTenantGroupn string

		if o.TenantGroupn != nil {
			qrTenantGroupn = *o.TenantGroupn
		}
		qTenantGroupn := qrTenantGroupn
		if qTenantGroupn != "" {

			if err := r.SetQueryParam("tenant_group__n", qTenantGroupn); err != nil {
				return err
			}
		}
	}

	if o.TenantGroupID != nil {

		// query param tenant_group_id
		var qrTenantGroupID string

		if o.TenantGroupID != nil {
			qrTenantGroupID = *o.TenantGroupID
		}
		qTenantGroupID := qrTenantGroupID
		if qTenantGroupID != "" {

			if err := r.SetQueryParam("tenant_group_id", qTenantGroupID); err != nil {
				return err
			}
		}
	}

	if o.TenantGroupIDn != nil {

		// query param tenant_group_id__n
		var qrTenantGroupIDn string

		if o.TenantGroupIDn != nil {
			qrTenantGroupIDn = *o.TenantGroupIDn
		}
		qTenantGroupIDn := qrTenantGroupIDn
		if qTenantGroupIDn != "" {

			if err := r.SetQueryParam("tenant_group_id__n", qTenantGroupIDn); err != nil {
				return err
			}
		}
	}

	if o.TenantID != nil {

		// query param tenant_id
		var qrTenantID string

		if o.TenantID != nil {
			qrTenantID = *o.TenantID
		}
		qTenantID := qrTenantID
		if qTenantID != "" {

			if err := r.SetQueryParam("tenant_id", qTenantID); err != nil {
				return err
			}
		}
	}

	if o.TenantIDn != nil {

		// query param tenant_id__n
		var qrTenantIDn string

		if o.TenantIDn != nil {
			qrTenantIDn = *o.TenantIDn
		}
		qTenantIDn := qrTenantIDn
		if qTenantIDn != "" {

			if err := r.SetQueryParam("tenant_id__n", qTenantIDn); err != nil {
				return err
			}
		}
	}

	if o.VlanID != nil {

		// query param vlan_id
		var qrVlanID string

		if o.VlanID != nil {
			qrVlanID = *o.VlanID
		}
		qVlanID := qrVlanID
		if qVlanID != "" {

			if err := r.SetQueryParam("vlan_id", qVlanID); err != nil {
				return err
			}
		}
	}

	if o.VlanIDn != nil {

		// query param vlan_id__n
		var qrVlanIDn string

		if o.VlanIDn != nil {
			qrVlanIDn = *o.VlanIDn
		}
		qVlanIDn := qrVlanIDn
		if qVlanIDn != "" {

			if err := r.SetQueryParam("vlan_id__n", qVlanIDn); err != nil {
				return err
			}
		}
	}

	if o.VlanVid != nil {

		// query param vlan_vid
		var qrVlanVid float64

		if o.VlanVid != nil {
			qrVlanVid = *o.VlanVid
		}
		qVlanVid := swag.FormatFloat64(qrVlanVid)
		if qVlanVid != "" {

			if err := r.SetQueryParam("vlan_vid", qVlanVid); err != nil {
				return err
			}
		}
	}

	if o.VlanVidGt != nil {

		// query param vlan_vid__gt
		var qrVlanVidGt float64

		if o.VlanVidGt != nil {
			qrVlanVidGt = *o.VlanVidGt
		}
		qVlanVidGt := swag.FormatFloat64(qrVlanVidGt)
		if qVlanVidGt != "" {

			if err := r.SetQueryParam("vlan_vid__gt", qVlanVidGt); err != nil {
				return err
			}
		}
	}

	if o.VlanVidGte != nil {

		// query param vlan_vid__gte
		var qrVlanVidGte float64

		if o.VlanVidGte != nil {
			qrVlanVidGte = *o.VlanVidGte
		}
		qVlanVidGte := swag.FormatFloat64(qrVlanVidGte)
		if qVlanVidGte != "" {

			if err := r.SetQueryParam("vlan_vid__gte", qVlanVidGte); err != nil {
				return err
			}
		}
	}

	if o.VlanVidLt != nil {

		// query param vlan_vid__lt
		var qrVlanVidLt float64

		if o.VlanVidLt != nil {
			qrVlanVidLt = *o.VlanVidLt
		}
		qVlanVidLt := swag.FormatFloat64(qrVlanVidLt)
		if qVlanVidLt != "" {

			if err := r.SetQueryParam("vlan_vid__lt", qVlanVidLt); err != nil {
				return err
			}
		}
	}

	if o.VlanVidLte != nil {

		// query param vlan_vid__lte
		var qrVlanVidLte float64

		if o.VlanVidLte != nil {
			qrVlanVidLte = *o.VlanVidLte
		}
		qVlanVidLte := swag.FormatFloat64(qrVlanVidLte)
		if qVlanVidLte != "" {

			if err := r.SetQueryParam("vlan_vid__lte", qVlanVidLte); err != nil {
				return err
			}
		}
	}

	if o.VlanVidn != nil {

		// query param vlan_vid__n
		var qrVlanVidn float64

		if o.VlanVidn != nil {
			qrVlanVidn = *o.VlanVidn
		}
		qVlanVidn := swag.FormatFloat64(qrVlanVidn)
		if qVlanVidn != "" {

			if err := r.SetQueryParam("vlan_vid__n", qVlanVidn); err != nil {
				return err
			}
		}
	}

	if o.Vrf != nil {

		// query param vrf
		var qrVrf string

		if o.Vrf != nil {
			qrVrf = *o.Vrf
		}
		qVrf := qrVrf
		if qVrf != "" {

			if err := r.SetQueryParam("vrf", qVrf); err != nil {
				return err
			}
		}
	}

	if o.Vrfn != nil {

		// query param vrf__n
		var qrVrfn string

		if o.Vrfn != nil {
			qrVrfn = *o.Vrfn
		}
		qVrfn := qrVrfn
		if qVrfn != "" {

			if err := r.SetQueryParam("vrf__n", qVrfn); err != nil {
				return err
			}
		}
	}

	if o.VrfID != nil {

		// query param vrf_id
		var qrVrfID string

		if o.VrfID != nil {
			qrVrfID = *o.VrfID
		}
		qVrfID := qrVrfID
		if qVrfID != "" {

			if err := r.SetQueryParam("vrf_id", qVrfID); err != nil {
				return err
			}
		}
	}

	if o.VrfIDn != nil {

		// query param vrf_id__n
		var qrVrfIDn string

		if o.VrfIDn != nil {
			qrVrfIDn = *o.VrfIDn
		}
		qVrfIDn := qrVrfIDn
		if qVrfIDn != "" {

			if err := r.SetQueryParam("vrf_id__n", qVrfIDn); err != nil {
				return err
			}
		}
	}

	if o.Within != nil {

		// query param within
		var qrWithin string

		if o.Within != nil {
			qrWithin = *o.Within
		}
		qWithin := qrWithin
		if qWithin != "" {

			if err := r.SetQueryParam("within", qWithin); err != nil {
				return err
			}
		}
	}

	if o.WithinInclude != nil {

		// query param within_include
		var qrWithinInclude string

		if o.WithinInclude != nil {
			qrWithinInclude = *o.WithinInclude
		}
		qWithinInclude := qrWithinInclude
		if qWithinInclude != "" {

			if err := r.SetQueryParam("within_include", qWithinInclude); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
