// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2020 The go-netbox Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package ipam

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewIpamVlanGroupsListParams creates a new IpamVlanGroupsListParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIpamVlanGroupsListParams() *IpamVlanGroupsListParams {
	return &IpamVlanGroupsListParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIpamVlanGroupsListParamsWithTimeout creates a new IpamVlanGroupsListParams object
// with the ability to set a timeout on a request.
func NewIpamVlanGroupsListParamsWithTimeout(timeout time.Duration) *IpamVlanGroupsListParams {
	return &IpamVlanGroupsListParams{
		timeout: timeout,
	}
}

// NewIpamVlanGroupsListParamsWithContext creates a new IpamVlanGroupsListParams object
// with the ability to set a context for a request.
func NewIpamVlanGroupsListParamsWithContext(ctx context.Context) *IpamVlanGroupsListParams {
	return &IpamVlanGroupsListParams{
		Context: ctx,
	}
}

// NewIpamVlanGroupsListParamsWithHTTPClient creates a new IpamVlanGroupsListParams object
// with the ability to set a custom HTTPClient for a request.
func NewIpamVlanGroupsListParamsWithHTTPClient(client *http.Client) *IpamVlanGroupsListParams {
	return &IpamVlanGroupsListParams{
		HTTPClient: client,
	}
}

/* IpamVlanGroupsListParams contains all the parameters to send to the API endpoint
   for the ipam vlan groups list operation.

   Typically these are written to a http.Request.
*/
type IpamVlanGroupsListParams struct {

	// Cluster.
	Cluster *float64

	// Clustergroup.
	Clustergroup *float64

	// Created.
	Created *string

	// CreatedGte.
	CreatedGte *string

	// CreatedLte.
	CreatedLte *string

	// Description.
	Description *string

	// DescriptionIc.
	DescriptionIc *string

	// DescriptionIe.
	DescriptionIe *string

	// DescriptionIew.
	DescriptionIew *string

	// DescriptionIsw.
	DescriptionIsw *string

	// Descriptionn.
	Descriptionn *string

	// DescriptionNic.
	DescriptionNic *string

	// DescriptionNie.
	DescriptionNie *string

	// DescriptionNiew.
	DescriptionNiew *string

	// DescriptionNisw.
	DescriptionNisw *string

	// ID.
	ID *string

	// IDGt.
	IDGt *string

	// IDGte.
	IDGte *string

	// IDLt.
	IDLt *string

	// IDLte.
	IDLte *string

	// IDn.
	IDn *string

	// LastUpdated.
	LastUpdated *string

	// LastUpdatedGte.
	LastUpdatedGte *string

	// LastUpdatedLte.
	LastUpdatedLte *string

	/* Limit.

	   Number of results to return per page.
	*/
	Limit *int64

	// Location.
	Location *float64

	// MaxVid.
	MaxVid *string

	// MaxVidGt.
	MaxVidGt *string

	// MaxVidGte.
	MaxVidGte *string

	// MaxVidLt.
	MaxVidLt *string

	// MaxVidLte.
	MaxVidLte *string

	// MaxVidn.
	MaxVidn *string

	// MinVid.
	MinVid *string

	// MinVidGt.
	MinVidGt *string

	// MinVidGte.
	MinVidGte *string

	// MinVidLt.
	MinVidLt *string

	// MinVidLte.
	MinVidLte *string

	// MinVidn.
	MinVidn *string

	// Name.
	Name *string

	// NameIc.
	NameIc *string

	// NameIe.
	NameIe *string

	// NameIew.
	NameIew *string

	// NameIsw.
	NameIsw *string

	// Namen.
	Namen *string

	// NameNic.
	NameNic *string

	// NameNie.
	NameNie *string

	// NameNiew.
	NameNiew *string

	// NameNisw.
	NameNisw *string

	/* Offset.

	   The initial index from which to return the results.
	*/
	Offset *int64

	// Q.
	Q *string

	// Rack.
	Rack *float64

	// Region.
	Region *float64

	// ScopeID.
	ScopeID *string

	// ScopeIDGt.
	ScopeIDGt *string

	// ScopeIDGte.
	ScopeIDGte *string

	// ScopeIDLt.
	ScopeIDLt *string

	// ScopeIDLte.
	ScopeIDLte *string

	// ScopeIDn.
	ScopeIDn *string

	// ScopeType.
	ScopeType *string

	// ScopeTypen.
	ScopeTypen *string

	// Site.
	Site *float64

	// Sitegroup.
	Sitegroup *float64

	// Slug.
	Slug *string

	// SlugIc.
	SlugIc *string

	// SlugIe.
	SlugIe *string

	// SlugIew.
	SlugIew *string

	// SlugIsw.
	SlugIsw *string

	// Slugn.
	Slugn *string

	// SlugNic.
	SlugNic *string

	// SlugNie.
	SlugNie *string

	// SlugNiew.
	SlugNiew *string

	// SlugNisw.
	SlugNisw *string

	// Tag.
	Tag *string

	// Tagn.
	Tagn *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the ipam vlan groups list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IpamVlanGroupsListParams) WithDefaults() *IpamVlanGroupsListParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the ipam vlan groups list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IpamVlanGroupsListParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithTimeout(timeout time.Duration) *IpamVlanGroupsListParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithContext(ctx context.Context) *IpamVlanGroupsListParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithHTTPClient(client *http.Client) *IpamVlanGroupsListParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCluster adds the cluster to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithCluster(cluster *float64) *IpamVlanGroupsListParams {
	o.SetCluster(cluster)
	return o
}

// SetCluster adds the cluster to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetCluster(cluster *float64) {
	o.Cluster = cluster
}

// WithClustergroup adds the clustergroup to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithClustergroup(clustergroup *float64) *IpamVlanGroupsListParams {
	o.SetClustergroup(clustergroup)
	return o
}

// SetClustergroup adds the clustergroup to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetClustergroup(clustergroup *float64) {
	o.Clustergroup = clustergroup
}

// WithCreated adds the created to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithCreated(created *string) *IpamVlanGroupsListParams {
	o.SetCreated(created)
	return o
}

// SetCreated adds the created to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetCreated(created *string) {
	o.Created = created
}

// WithCreatedGte adds the createdGte to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithCreatedGte(createdGte *string) *IpamVlanGroupsListParams {
	o.SetCreatedGte(createdGte)
	return o
}

// SetCreatedGte adds the createdGte to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetCreatedGte(createdGte *string) {
	o.CreatedGte = createdGte
}

// WithCreatedLte adds the createdLte to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithCreatedLte(createdLte *string) *IpamVlanGroupsListParams {
	o.SetCreatedLte(createdLte)
	return o
}

// SetCreatedLte adds the createdLte to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetCreatedLte(createdLte *string) {
	o.CreatedLte = createdLte
}

// WithDescription adds the description to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithDescription(description *string) *IpamVlanGroupsListParams {
	o.SetDescription(description)
	return o
}

// SetDescription adds the description to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetDescription(description *string) {
	o.Description = description
}

// WithDescriptionIc adds the descriptionIc to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithDescriptionIc(descriptionIc *string) *IpamVlanGroupsListParams {
	o.SetDescriptionIc(descriptionIc)
	return o
}

// SetDescriptionIc adds the descriptionIc to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetDescriptionIc(descriptionIc *string) {
	o.DescriptionIc = descriptionIc
}

// WithDescriptionIe adds the descriptionIe to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithDescriptionIe(descriptionIe *string) *IpamVlanGroupsListParams {
	o.SetDescriptionIe(descriptionIe)
	return o
}

// SetDescriptionIe adds the descriptionIe to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetDescriptionIe(descriptionIe *string) {
	o.DescriptionIe = descriptionIe
}

// WithDescriptionIew adds the descriptionIew to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithDescriptionIew(descriptionIew *string) *IpamVlanGroupsListParams {
	o.SetDescriptionIew(descriptionIew)
	return o
}

// SetDescriptionIew adds the descriptionIew to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetDescriptionIew(descriptionIew *string) {
	o.DescriptionIew = descriptionIew
}

// WithDescriptionIsw adds the descriptionIsw to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithDescriptionIsw(descriptionIsw *string) *IpamVlanGroupsListParams {
	o.SetDescriptionIsw(descriptionIsw)
	return o
}

// SetDescriptionIsw adds the descriptionIsw to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetDescriptionIsw(descriptionIsw *string) {
	o.DescriptionIsw = descriptionIsw
}

// WithDescriptionn adds the descriptionn to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithDescriptionn(descriptionn *string) *IpamVlanGroupsListParams {
	o.SetDescriptionn(descriptionn)
	return o
}

// SetDescriptionn adds the descriptionN to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetDescriptionn(descriptionn *string) {
	o.Descriptionn = descriptionn
}

// WithDescriptionNic adds the descriptionNic to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithDescriptionNic(descriptionNic *string) *IpamVlanGroupsListParams {
	o.SetDescriptionNic(descriptionNic)
	return o
}

// SetDescriptionNic adds the descriptionNic to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetDescriptionNic(descriptionNic *string) {
	o.DescriptionNic = descriptionNic
}

// WithDescriptionNie adds the descriptionNie to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithDescriptionNie(descriptionNie *string) *IpamVlanGroupsListParams {
	o.SetDescriptionNie(descriptionNie)
	return o
}

// SetDescriptionNie adds the descriptionNie to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetDescriptionNie(descriptionNie *string) {
	o.DescriptionNie = descriptionNie
}

// WithDescriptionNiew adds the descriptionNiew to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithDescriptionNiew(descriptionNiew *string) *IpamVlanGroupsListParams {
	o.SetDescriptionNiew(descriptionNiew)
	return o
}

// SetDescriptionNiew adds the descriptionNiew to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetDescriptionNiew(descriptionNiew *string) {
	o.DescriptionNiew = descriptionNiew
}

// WithDescriptionNisw adds the descriptionNisw to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithDescriptionNisw(descriptionNisw *string) *IpamVlanGroupsListParams {
	o.SetDescriptionNisw(descriptionNisw)
	return o
}

// SetDescriptionNisw adds the descriptionNisw to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetDescriptionNisw(descriptionNisw *string) {
	o.DescriptionNisw = descriptionNisw
}

// WithID adds the id to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithID(id *string) *IpamVlanGroupsListParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetID(id *string) {
	o.ID = id
}

// WithIDGt adds the iDGt to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithIDGt(iDGt *string) *IpamVlanGroupsListParams {
	o.SetIDGt(iDGt)
	return o
}

// SetIDGt adds the idGt to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetIDGt(iDGt *string) {
	o.IDGt = iDGt
}

// WithIDGte adds the iDGte to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithIDGte(iDGte *string) *IpamVlanGroupsListParams {
	o.SetIDGte(iDGte)
	return o
}

// SetIDGte adds the idGte to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetIDGte(iDGte *string) {
	o.IDGte = iDGte
}

// WithIDLt adds the iDLt to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithIDLt(iDLt *string) *IpamVlanGroupsListParams {
	o.SetIDLt(iDLt)
	return o
}

// SetIDLt adds the idLt to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetIDLt(iDLt *string) {
	o.IDLt = iDLt
}

// WithIDLte adds the iDLte to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithIDLte(iDLte *string) *IpamVlanGroupsListParams {
	o.SetIDLte(iDLte)
	return o
}

// SetIDLte adds the idLte to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetIDLte(iDLte *string) {
	o.IDLte = iDLte
}

// WithIDn adds the iDn to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithIDn(iDn *string) *IpamVlanGroupsListParams {
	o.SetIDn(iDn)
	return o
}

// SetIDn adds the idN to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetIDn(iDn *string) {
	o.IDn = iDn
}

// WithLastUpdated adds the lastUpdated to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithLastUpdated(lastUpdated *string) *IpamVlanGroupsListParams {
	o.SetLastUpdated(lastUpdated)
	return o
}

// SetLastUpdated adds the lastUpdated to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetLastUpdated(lastUpdated *string) {
	o.LastUpdated = lastUpdated
}

// WithLastUpdatedGte adds the lastUpdatedGte to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithLastUpdatedGte(lastUpdatedGte *string) *IpamVlanGroupsListParams {
	o.SetLastUpdatedGte(lastUpdatedGte)
	return o
}

// SetLastUpdatedGte adds the lastUpdatedGte to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetLastUpdatedGte(lastUpdatedGte *string) {
	o.LastUpdatedGte = lastUpdatedGte
}

// WithLastUpdatedLte adds the lastUpdatedLte to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithLastUpdatedLte(lastUpdatedLte *string) *IpamVlanGroupsListParams {
	o.SetLastUpdatedLte(lastUpdatedLte)
	return o
}

// SetLastUpdatedLte adds the lastUpdatedLte to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetLastUpdatedLte(lastUpdatedLte *string) {
	o.LastUpdatedLte = lastUpdatedLte
}

// WithLimit adds the limit to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithLimit(limit *int64) *IpamVlanGroupsListParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithLocation adds the location to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithLocation(location *float64) *IpamVlanGroupsListParams {
	o.SetLocation(location)
	return o
}

// SetLocation adds the location to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetLocation(location *float64) {
	o.Location = location
}

// WithMaxVid adds the maxVid to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithMaxVid(maxVid *string) *IpamVlanGroupsListParams {
	o.SetMaxVid(maxVid)
	return o
}

// SetMaxVid adds the maxVid to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetMaxVid(maxVid *string) {
	o.MaxVid = maxVid
}

// WithMaxVidGt adds the maxVidGt to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithMaxVidGt(maxVidGt *string) *IpamVlanGroupsListParams {
	o.SetMaxVidGt(maxVidGt)
	return o
}

// SetMaxVidGt adds the maxVidGt to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetMaxVidGt(maxVidGt *string) {
	o.MaxVidGt = maxVidGt
}

// WithMaxVidGte adds the maxVidGte to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithMaxVidGte(maxVidGte *string) *IpamVlanGroupsListParams {
	o.SetMaxVidGte(maxVidGte)
	return o
}

// SetMaxVidGte adds the maxVidGte to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetMaxVidGte(maxVidGte *string) {
	o.MaxVidGte = maxVidGte
}

// WithMaxVidLt adds the maxVidLt to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithMaxVidLt(maxVidLt *string) *IpamVlanGroupsListParams {
	o.SetMaxVidLt(maxVidLt)
	return o
}

// SetMaxVidLt adds the maxVidLt to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetMaxVidLt(maxVidLt *string) {
	o.MaxVidLt = maxVidLt
}

// WithMaxVidLte adds the maxVidLte to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithMaxVidLte(maxVidLte *string) *IpamVlanGroupsListParams {
	o.SetMaxVidLte(maxVidLte)
	return o
}

// SetMaxVidLte adds the maxVidLte to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetMaxVidLte(maxVidLte *string) {
	o.MaxVidLte = maxVidLte
}

// WithMaxVidn adds the maxVidn to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithMaxVidn(maxVidn *string) *IpamVlanGroupsListParams {
	o.SetMaxVidn(maxVidn)
	return o
}

// SetMaxVidn adds the maxVidN to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetMaxVidn(maxVidn *string) {
	o.MaxVidn = maxVidn
}

// WithMinVid adds the minVid to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithMinVid(minVid *string) *IpamVlanGroupsListParams {
	o.SetMinVid(minVid)
	return o
}

// SetMinVid adds the minVid to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetMinVid(minVid *string) {
	o.MinVid = minVid
}

// WithMinVidGt adds the minVidGt to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithMinVidGt(minVidGt *string) *IpamVlanGroupsListParams {
	o.SetMinVidGt(minVidGt)
	return o
}

// SetMinVidGt adds the minVidGt to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetMinVidGt(minVidGt *string) {
	o.MinVidGt = minVidGt
}

// WithMinVidGte adds the minVidGte to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithMinVidGte(minVidGte *string) *IpamVlanGroupsListParams {
	o.SetMinVidGte(minVidGte)
	return o
}

// SetMinVidGte adds the minVidGte to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetMinVidGte(minVidGte *string) {
	o.MinVidGte = minVidGte
}

// WithMinVidLt adds the minVidLt to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithMinVidLt(minVidLt *string) *IpamVlanGroupsListParams {
	o.SetMinVidLt(minVidLt)
	return o
}

// SetMinVidLt adds the minVidLt to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetMinVidLt(minVidLt *string) {
	o.MinVidLt = minVidLt
}

// WithMinVidLte adds the minVidLte to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithMinVidLte(minVidLte *string) *IpamVlanGroupsListParams {
	o.SetMinVidLte(minVidLte)
	return o
}

// SetMinVidLte adds the minVidLte to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetMinVidLte(minVidLte *string) {
	o.MinVidLte = minVidLte
}

// WithMinVidn adds the minVidn to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithMinVidn(minVidn *string) *IpamVlanGroupsListParams {
	o.SetMinVidn(minVidn)
	return o
}

// SetMinVidn adds the minVidN to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetMinVidn(minVidn *string) {
	o.MinVidn = minVidn
}

// WithName adds the name to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithName(name *string) *IpamVlanGroupsListParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetName(name *string) {
	o.Name = name
}

// WithNameIc adds the nameIc to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithNameIc(nameIc *string) *IpamVlanGroupsListParams {
	o.SetNameIc(nameIc)
	return o
}

// SetNameIc adds the nameIc to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetNameIc(nameIc *string) {
	o.NameIc = nameIc
}

// WithNameIe adds the nameIe to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithNameIe(nameIe *string) *IpamVlanGroupsListParams {
	o.SetNameIe(nameIe)
	return o
}

// SetNameIe adds the nameIe to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetNameIe(nameIe *string) {
	o.NameIe = nameIe
}

// WithNameIew adds the nameIew to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithNameIew(nameIew *string) *IpamVlanGroupsListParams {
	o.SetNameIew(nameIew)
	return o
}

// SetNameIew adds the nameIew to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetNameIew(nameIew *string) {
	o.NameIew = nameIew
}

// WithNameIsw adds the nameIsw to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithNameIsw(nameIsw *string) *IpamVlanGroupsListParams {
	o.SetNameIsw(nameIsw)
	return o
}

// SetNameIsw adds the nameIsw to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetNameIsw(nameIsw *string) {
	o.NameIsw = nameIsw
}

// WithNamen adds the namen to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithNamen(namen *string) *IpamVlanGroupsListParams {
	o.SetNamen(namen)
	return o
}

// SetNamen adds the nameN to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetNamen(namen *string) {
	o.Namen = namen
}

// WithNameNic adds the nameNic to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithNameNic(nameNic *string) *IpamVlanGroupsListParams {
	o.SetNameNic(nameNic)
	return o
}

// SetNameNic adds the nameNic to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetNameNic(nameNic *string) {
	o.NameNic = nameNic
}

// WithNameNie adds the nameNie to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithNameNie(nameNie *string) *IpamVlanGroupsListParams {
	o.SetNameNie(nameNie)
	return o
}

// SetNameNie adds the nameNie to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetNameNie(nameNie *string) {
	o.NameNie = nameNie
}

// WithNameNiew adds the nameNiew to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithNameNiew(nameNiew *string) *IpamVlanGroupsListParams {
	o.SetNameNiew(nameNiew)
	return o
}

// SetNameNiew adds the nameNiew to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetNameNiew(nameNiew *string) {
	o.NameNiew = nameNiew
}

// WithNameNisw adds the nameNisw to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithNameNisw(nameNisw *string) *IpamVlanGroupsListParams {
	o.SetNameNisw(nameNisw)
	return o
}

// SetNameNisw adds the nameNisw to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetNameNisw(nameNisw *string) {
	o.NameNisw = nameNisw
}

// WithOffset adds the offset to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithOffset(offset *int64) *IpamVlanGroupsListParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithQ adds the q to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithQ(q *string) *IpamVlanGroupsListParams {
	o.SetQ(q)
	return o
}

// SetQ adds the q to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetQ(q *string) {
	o.Q = q
}

// WithRack adds the rack to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithRack(rack *float64) *IpamVlanGroupsListParams {
	o.SetRack(rack)
	return o
}

// SetRack adds the rack to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetRack(rack *float64) {
	o.Rack = rack
}

// WithRegion adds the region to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithRegion(region *float64) *IpamVlanGroupsListParams {
	o.SetRegion(region)
	return o
}

// SetRegion adds the region to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetRegion(region *float64) {
	o.Region = region
}

// WithScopeID adds the scopeID to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithScopeID(scopeID *string) *IpamVlanGroupsListParams {
	o.SetScopeID(scopeID)
	return o
}

// SetScopeID adds the scopeId to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetScopeID(scopeID *string) {
	o.ScopeID = scopeID
}

// WithScopeIDGt adds the scopeIDGt to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithScopeIDGt(scopeIDGt *string) *IpamVlanGroupsListParams {
	o.SetScopeIDGt(scopeIDGt)
	return o
}

// SetScopeIDGt adds the scopeIdGt to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetScopeIDGt(scopeIDGt *string) {
	o.ScopeIDGt = scopeIDGt
}

// WithScopeIDGte adds the scopeIDGte to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithScopeIDGte(scopeIDGte *string) *IpamVlanGroupsListParams {
	o.SetScopeIDGte(scopeIDGte)
	return o
}

// SetScopeIDGte adds the scopeIdGte to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetScopeIDGte(scopeIDGte *string) {
	o.ScopeIDGte = scopeIDGte
}

// WithScopeIDLt adds the scopeIDLt to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithScopeIDLt(scopeIDLt *string) *IpamVlanGroupsListParams {
	o.SetScopeIDLt(scopeIDLt)
	return o
}

// SetScopeIDLt adds the scopeIdLt to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetScopeIDLt(scopeIDLt *string) {
	o.ScopeIDLt = scopeIDLt
}

// WithScopeIDLte adds the scopeIDLte to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithScopeIDLte(scopeIDLte *string) *IpamVlanGroupsListParams {
	o.SetScopeIDLte(scopeIDLte)
	return o
}

// SetScopeIDLte adds the scopeIdLte to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetScopeIDLte(scopeIDLte *string) {
	o.ScopeIDLte = scopeIDLte
}

// WithScopeIDn adds the scopeIDn to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithScopeIDn(scopeIDn *string) *IpamVlanGroupsListParams {
	o.SetScopeIDn(scopeIDn)
	return o
}

// SetScopeIDn adds the scopeIdN to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetScopeIDn(scopeIDn *string) {
	o.ScopeIDn = scopeIDn
}

// WithScopeType adds the scopeType to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithScopeType(scopeType *string) *IpamVlanGroupsListParams {
	o.SetScopeType(scopeType)
	return o
}

// SetScopeType adds the scopeType to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetScopeType(scopeType *string) {
	o.ScopeType = scopeType
}

// WithScopeTypen adds the scopeTypen to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithScopeTypen(scopeTypen *string) *IpamVlanGroupsListParams {
	o.SetScopeTypen(scopeTypen)
	return o
}

// SetScopeTypen adds the scopeTypeN to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetScopeTypen(scopeTypen *string) {
	o.ScopeTypen = scopeTypen
}

// WithSite adds the site to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithSite(site *float64) *IpamVlanGroupsListParams {
	o.SetSite(site)
	return o
}

// SetSite adds the site to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetSite(site *float64) {
	o.Site = site
}

// WithSitegroup adds the sitegroup to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithSitegroup(sitegroup *float64) *IpamVlanGroupsListParams {
	o.SetSitegroup(sitegroup)
	return o
}

// SetSitegroup adds the sitegroup to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetSitegroup(sitegroup *float64) {
	o.Sitegroup = sitegroup
}

// WithSlug adds the slug to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithSlug(slug *string) *IpamVlanGroupsListParams {
	o.SetSlug(slug)
	return o
}

// SetSlug adds the slug to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetSlug(slug *string) {
	o.Slug = slug
}

// WithSlugIc adds the slugIc to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithSlugIc(slugIc *string) *IpamVlanGroupsListParams {
	o.SetSlugIc(slugIc)
	return o
}

// SetSlugIc adds the slugIc to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetSlugIc(slugIc *string) {
	o.SlugIc = slugIc
}

// WithSlugIe adds the slugIe to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithSlugIe(slugIe *string) *IpamVlanGroupsListParams {
	o.SetSlugIe(slugIe)
	return o
}

// SetSlugIe adds the slugIe to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetSlugIe(slugIe *string) {
	o.SlugIe = slugIe
}

// WithSlugIew adds the slugIew to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithSlugIew(slugIew *string) *IpamVlanGroupsListParams {
	o.SetSlugIew(slugIew)
	return o
}

// SetSlugIew adds the slugIew to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetSlugIew(slugIew *string) {
	o.SlugIew = slugIew
}

// WithSlugIsw adds the slugIsw to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithSlugIsw(slugIsw *string) *IpamVlanGroupsListParams {
	o.SetSlugIsw(slugIsw)
	return o
}

// SetSlugIsw adds the slugIsw to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetSlugIsw(slugIsw *string) {
	o.SlugIsw = slugIsw
}

// WithSlugn adds the slugn to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithSlugn(slugn *string) *IpamVlanGroupsListParams {
	o.SetSlugn(slugn)
	return o
}

// SetSlugn adds the slugN to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetSlugn(slugn *string) {
	o.Slugn = slugn
}

// WithSlugNic adds the slugNic to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithSlugNic(slugNic *string) *IpamVlanGroupsListParams {
	o.SetSlugNic(slugNic)
	return o
}

// SetSlugNic adds the slugNic to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetSlugNic(slugNic *string) {
	o.SlugNic = slugNic
}

// WithSlugNie adds the slugNie to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithSlugNie(slugNie *string) *IpamVlanGroupsListParams {
	o.SetSlugNie(slugNie)
	return o
}

// SetSlugNie adds the slugNie to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetSlugNie(slugNie *string) {
	o.SlugNie = slugNie
}

// WithSlugNiew adds the slugNiew to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithSlugNiew(slugNiew *string) *IpamVlanGroupsListParams {
	o.SetSlugNiew(slugNiew)
	return o
}

// SetSlugNiew adds the slugNiew to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetSlugNiew(slugNiew *string) {
	o.SlugNiew = slugNiew
}

// WithSlugNisw adds the slugNisw to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithSlugNisw(slugNisw *string) *IpamVlanGroupsListParams {
	o.SetSlugNisw(slugNisw)
	return o
}

// SetSlugNisw adds the slugNisw to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetSlugNisw(slugNisw *string) {
	o.SlugNisw = slugNisw
}

// WithTag adds the tag to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithTag(tag *string) *IpamVlanGroupsListParams {
	o.SetTag(tag)
	return o
}

// SetTag adds the tag to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetTag(tag *string) {
	o.Tag = tag
}

// WithTagn adds the tagn to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) WithTagn(tagn *string) *IpamVlanGroupsListParams {
	o.SetTagn(tagn)
	return o
}

// SetTagn adds the tagN to the ipam vlan groups list params
func (o *IpamVlanGroupsListParams) SetTagn(tagn *string) {
	o.Tagn = tagn
}

// WriteToRequest writes these params to a swagger request
func (o *IpamVlanGroupsListParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Cluster != nil {

		// query param cluster
		var qrCluster float64

		if o.Cluster != nil {
			qrCluster = *o.Cluster
		}
		qCluster := swag.FormatFloat64(qrCluster)
		if qCluster != "" {

			if err := r.SetQueryParam("cluster", qCluster); err != nil {
				return err
			}
		}
	}

	if o.Clustergroup != nil {

		// query param clustergroup
		var qrClustergroup float64

		if o.Clustergroup != nil {
			qrClustergroup = *o.Clustergroup
		}
		qClustergroup := swag.FormatFloat64(qrClustergroup)
		if qClustergroup != "" {

			if err := r.SetQueryParam("clustergroup", qClustergroup); err != nil {
				return err
			}
		}
	}

	if o.Created != nil {

		// query param created
		var qrCreated string

		if o.Created != nil {
			qrCreated = *o.Created
		}
		qCreated := qrCreated
		if qCreated != "" {

			if err := r.SetQueryParam("created", qCreated); err != nil {
				return err
			}
		}
	}

	if o.CreatedGte != nil {

		// query param created__gte
		var qrCreatedGte string

		if o.CreatedGte != nil {
			qrCreatedGte = *o.CreatedGte
		}
		qCreatedGte := qrCreatedGte
		if qCreatedGte != "" {

			if err := r.SetQueryParam("created__gte", qCreatedGte); err != nil {
				return err
			}
		}
	}

	if o.CreatedLte != nil {

		// query param created__lte
		var qrCreatedLte string

		if o.CreatedLte != nil {
			qrCreatedLte = *o.CreatedLte
		}
		qCreatedLte := qrCreatedLte
		if qCreatedLte != "" {

			if err := r.SetQueryParam("created__lte", qCreatedLte); err != nil {
				return err
			}
		}
	}

	if o.Description != nil {

		// query param description
		var qrDescription string

		if o.Description != nil {
			qrDescription = *o.Description
		}
		qDescription := qrDescription
		if qDescription != "" {

			if err := r.SetQueryParam("description", qDescription); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIc != nil {

		// query param description__ic
		var qrDescriptionIc string

		if o.DescriptionIc != nil {
			qrDescriptionIc = *o.DescriptionIc
		}
		qDescriptionIc := qrDescriptionIc
		if qDescriptionIc != "" {

			if err := r.SetQueryParam("description__ic", qDescriptionIc); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIe != nil {

		// query param description__ie
		var qrDescriptionIe string

		if o.DescriptionIe != nil {
			qrDescriptionIe = *o.DescriptionIe
		}
		qDescriptionIe := qrDescriptionIe
		if qDescriptionIe != "" {

			if err := r.SetQueryParam("description__ie", qDescriptionIe); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIew != nil {

		// query param description__iew
		var qrDescriptionIew string

		if o.DescriptionIew != nil {
			qrDescriptionIew = *o.DescriptionIew
		}
		qDescriptionIew := qrDescriptionIew
		if qDescriptionIew != "" {

			if err := r.SetQueryParam("description__iew", qDescriptionIew); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIsw != nil {

		// query param description__isw
		var qrDescriptionIsw string

		if o.DescriptionIsw != nil {
			qrDescriptionIsw = *o.DescriptionIsw
		}
		qDescriptionIsw := qrDescriptionIsw
		if qDescriptionIsw != "" {

			if err := r.SetQueryParam("description__isw", qDescriptionIsw); err != nil {
				return err
			}
		}
	}

	if o.Descriptionn != nil {

		// query param description__n
		var qrDescriptionn string

		if o.Descriptionn != nil {
			qrDescriptionn = *o.Descriptionn
		}
		qDescriptionn := qrDescriptionn
		if qDescriptionn != "" {

			if err := r.SetQueryParam("description__n", qDescriptionn); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNic != nil {

		// query param description__nic
		var qrDescriptionNic string

		if o.DescriptionNic != nil {
			qrDescriptionNic = *o.DescriptionNic
		}
		qDescriptionNic := qrDescriptionNic
		if qDescriptionNic != "" {

			if err := r.SetQueryParam("description__nic", qDescriptionNic); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNie != nil {

		// query param description__nie
		var qrDescriptionNie string

		if o.DescriptionNie != nil {
			qrDescriptionNie = *o.DescriptionNie
		}
		qDescriptionNie := qrDescriptionNie
		if qDescriptionNie != "" {

			if err := r.SetQueryParam("description__nie", qDescriptionNie); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNiew != nil {

		// query param description__niew
		var qrDescriptionNiew string

		if o.DescriptionNiew != nil {
			qrDescriptionNiew = *o.DescriptionNiew
		}
		qDescriptionNiew := qrDescriptionNiew
		if qDescriptionNiew != "" {

			if err := r.SetQueryParam("description__niew", qDescriptionNiew); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNisw != nil {

		// query param description__nisw
		var qrDescriptionNisw string

		if o.DescriptionNisw != nil {
			qrDescriptionNisw = *o.DescriptionNisw
		}
		qDescriptionNisw := qrDescriptionNisw
		if qDescriptionNisw != "" {

			if err := r.SetQueryParam("description__nisw", qDescriptionNisw); err != nil {
				return err
			}
		}
	}

	if o.ID != nil {

		// query param id
		var qrID string

		if o.ID != nil {
			qrID = *o.ID
		}
		qID := qrID
		if qID != "" {

			if err := r.SetQueryParam("id", qID); err != nil {
				return err
			}
		}
	}

	if o.IDGt != nil {

		// query param id__gt
		var qrIDGt string

		if o.IDGt != nil {
			qrIDGt = *o.IDGt
		}
		qIDGt := qrIDGt
		if qIDGt != "" {

			if err := r.SetQueryParam("id__gt", qIDGt); err != nil {
				return err
			}
		}
	}

	if o.IDGte != nil {

		// query param id__gte
		var qrIDGte string

		if o.IDGte != nil {
			qrIDGte = *o.IDGte
		}
		qIDGte := qrIDGte
		if qIDGte != "" {

			if err := r.SetQueryParam("id__gte", qIDGte); err != nil {
				return err
			}
		}
	}

	if o.IDLt != nil {

		// query param id__lt
		var qrIDLt string

		if o.IDLt != nil {
			qrIDLt = *o.IDLt
		}
		qIDLt := qrIDLt
		if qIDLt != "" {

			if err := r.SetQueryParam("id__lt", qIDLt); err != nil {
				return err
			}
		}
	}

	if o.IDLte != nil {

		// query param id__lte
		var qrIDLte string

		if o.IDLte != nil {
			qrIDLte = *o.IDLte
		}
		qIDLte := qrIDLte
		if qIDLte != "" {

			if err := r.SetQueryParam("id__lte", qIDLte); err != nil {
				return err
			}
		}
	}

	if o.IDn != nil {

		// query param id__n
		var qrIDn string

		if o.IDn != nil {
			qrIDn = *o.IDn
		}
		qIDn := qrIDn
		if qIDn != "" {

			if err := r.SetQueryParam("id__n", qIDn); err != nil {
				return err
			}
		}
	}

	if o.LastUpdated != nil {

		// query param last_updated
		var qrLastUpdated string

		if o.LastUpdated != nil {
			qrLastUpdated = *o.LastUpdated
		}
		qLastUpdated := qrLastUpdated
		if qLastUpdated != "" {

			if err := r.SetQueryParam("last_updated", qLastUpdated); err != nil {
				return err
			}
		}
	}

	if o.LastUpdatedGte != nil {

		// query param last_updated__gte
		var qrLastUpdatedGte string

		if o.LastUpdatedGte != nil {
			qrLastUpdatedGte = *o.LastUpdatedGte
		}
		qLastUpdatedGte := qrLastUpdatedGte
		if qLastUpdatedGte != "" {

			if err := r.SetQueryParam("last_updated__gte", qLastUpdatedGte); err != nil {
				return err
			}
		}
	}

	if o.LastUpdatedLte != nil {

		// query param last_updated__lte
		var qrLastUpdatedLte string

		if o.LastUpdatedLte != nil {
			qrLastUpdatedLte = *o.LastUpdatedLte
		}
		qLastUpdatedLte := qrLastUpdatedLte
		if qLastUpdatedLte != "" {

			if err := r.SetQueryParam("last_updated__lte", qLastUpdatedLte); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Location != nil {

		// query param location
		var qrLocation float64

		if o.Location != nil {
			qrLocation = *o.Location
		}
		qLocation := swag.FormatFloat64(qrLocation)
		if qLocation != "" {

			if err := r.SetQueryParam("location", qLocation); err != nil {
				return err
			}
		}
	}

	if o.MaxVid != nil {

		// query param max_vid
		var qrMaxVid string

		if o.MaxVid != nil {
			qrMaxVid = *o.MaxVid
		}
		qMaxVid := qrMaxVid
		if qMaxVid != "" {

			if err := r.SetQueryParam("max_vid", qMaxVid); err != nil {
				return err
			}
		}
	}

	if o.MaxVidGt != nil {

		// query param max_vid__gt
		var qrMaxVidGt string

		if o.MaxVidGt != nil {
			qrMaxVidGt = *o.MaxVidGt
		}
		qMaxVidGt := qrMaxVidGt
		if qMaxVidGt != "" {

			if err := r.SetQueryParam("max_vid__gt", qMaxVidGt); err != nil {
				return err
			}
		}
	}

	if o.MaxVidGte != nil {

		// query param max_vid__gte
		var qrMaxVidGte string

		if o.MaxVidGte != nil {
			qrMaxVidGte = *o.MaxVidGte
		}
		qMaxVidGte := qrMaxVidGte
		if qMaxVidGte != "" {

			if err := r.SetQueryParam("max_vid__gte", qMaxVidGte); err != nil {
				return err
			}
		}
	}

	if o.MaxVidLt != nil {

		// query param max_vid__lt
		var qrMaxVidLt string

		if o.MaxVidLt != nil {
			qrMaxVidLt = *o.MaxVidLt
		}
		qMaxVidLt := qrMaxVidLt
		if qMaxVidLt != "" {

			if err := r.SetQueryParam("max_vid__lt", qMaxVidLt); err != nil {
				return err
			}
		}
	}

	if o.MaxVidLte != nil {

		// query param max_vid__lte
		var qrMaxVidLte string

		if o.MaxVidLte != nil {
			qrMaxVidLte = *o.MaxVidLte
		}
		qMaxVidLte := qrMaxVidLte
		if qMaxVidLte != "" {

			if err := r.SetQueryParam("max_vid__lte", qMaxVidLte); err != nil {
				return err
			}
		}
	}

	if o.MaxVidn != nil {

		// query param max_vid__n
		var qrMaxVidn string

		if o.MaxVidn != nil {
			qrMaxVidn = *o.MaxVidn
		}
		qMaxVidn := qrMaxVidn
		if qMaxVidn != "" {

			if err := r.SetQueryParam("max_vid__n", qMaxVidn); err != nil {
				return err
			}
		}
	}

	if o.MinVid != nil {

		// query param min_vid
		var qrMinVid string

		if o.MinVid != nil {
			qrMinVid = *o.MinVid
		}
		qMinVid := qrMinVid
		if qMinVid != "" {

			if err := r.SetQueryParam("min_vid", qMinVid); err != nil {
				return err
			}
		}
	}

	if o.MinVidGt != nil {

		// query param min_vid__gt
		var qrMinVidGt string

		if o.MinVidGt != nil {
			qrMinVidGt = *o.MinVidGt
		}
		qMinVidGt := qrMinVidGt
		if qMinVidGt != "" {

			if err := r.SetQueryParam("min_vid__gt", qMinVidGt); err != nil {
				return err
			}
		}
	}

	if o.MinVidGte != nil {

		// query param min_vid__gte
		var qrMinVidGte string

		if o.MinVidGte != nil {
			qrMinVidGte = *o.MinVidGte
		}
		qMinVidGte := qrMinVidGte
		if qMinVidGte != "" {

			if err := r.SetQueryParam("min_vid__gte", qMinVidGte); err != nil {
				return err
			}
		}
	}

	if o.MinVidLt != nil {

		// query param min_vid__lt
		var qrMinVidLt string

		if o.MinVidLt != nil {
			qrMinVidLt = *o.MinVidLt
		}
		qMinVidLt := qrMinVidLt
		if qMinVidLt != "" {

			if err := r.SetQueryParam("min_vid__lt", qMinVidLt); err != nil {
				return err
			}
		}
	}

	if o.MinVidLte != nil {

		// query param min_vid__lte
		var qrMinVidLte string

		if o.MinVidLte != nil {
			qrMinVidLte = *o.MinVidLte
		}
		qMinVidLte := qrMinVidLte
		if qMinVidLte != "" {

			if err := r.SetQueryParam("min_vid__lte", qMinVidLte); err != nil {
				return err
			}
		}
	}

	if o.MinVidn != nil {

		// query param min_vid__n
		var qrMinVidn string

		if o.MinVidn != nil {
			qrMinVidn = *o.MinVidn
		}
		qMinVidn := qrMinVidn
		if qMinVidn != "" {

			if err := r.SetQueryParam("min_vid__n", qMinVidn); err != nil {
				return err
			}
		}
	}

	if o.Name != nil {

		// query param name
		var qrName string

		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.NameIc != nil {

		// query param name__ic
		var qrNameIc string

		if o.NameIc != nil {
			qrNameIc = *o.NameIc
		}
		qNameIc := qrNameIc
		if qNameIc != "" {

			if err := r.SetQueryParam("name__ic", qNameIc); err != nil {
				return err
			}
		}
	}

	if o.NameIe != nil {

		// query param name__ie
		var qrNameIe string

		if o.NameIe != nil {
			qrNameIe = *o.NameIe
		}
		qNameIe := qrNameIe
		if qNameIe != "" {

			if err := r.SetQueryParam("name__ie", qNameIe); err != nil {
				return err
			}
		}
	}

	if o.NameIew != nil {

		// query param name__iew
		var qrNameIew string

		if o.NameIew != nil {
			qrNameIew = *o.NameIew
		}
		qNameIew := qrNameIew
		if qNameIew != "" {

			if err := r.SetQueryParam("name__iew", qNameIew); err != nil {
				return err
			}
		}
	}

	if o.NameIsw != nil {

		// query param name__isw
		var qrNameIsw string

		if o.NameIsw != nil {
			qrNameIsw = *o.NameIsw
		}
		qNameIsw := qrNameIsw
		if qNameIsw != "" {

			if err := r.SetQueryParam("name__isw", qNameIsw); err != nil {
				return err
			}
		}
	}

	if o.Namen != nil {

		// query param name__n
		var qrNamen string

		if o.Namen != nil {
			qrNamen = *o.Namen
		}
		qNamen := qrNamen
		if qNamen != "" {

			if err := r.SetQueryParam("name__n", qNamen); err != nil {
				return err
			}
		}
	}

	if o.NameNic != nil {

		// query param name__nic
		var qrNameNic string

		if o.NameNic != nil {
			qrNameNic = *o.NameNic
		}
		qNameNic := qrNameNic
		if qNameNic != "" {

			if err := r.SetQueryParam("name__nic", qNameNic); err != nil {
				return err
			}
		}
	}

	if o.NameNie != nil {

		// query param name__nie
		var qrNameNie string

		if o.NameNie != nil {
			qrNameNie = *o.NameNie
		}
		qNameNie := qrNameNie
		if qNameNie != "" {

			if err := r.SetQueryParam("name__nie", qNameNie); err != nil {
				return err
			}
		}
	}

	if o.NameNiew != nil {

		// query param name__niew
		var qrNameNiew string

		if o.NameNiew != nil {
			qrNameNiew = *o.NameNiew
		}
		qNameNiew := qrNameNiew
		if qNameNiew != "" {

			if err := r.SetQueryParam("name__niew", qNameNiew); err != nil {
				return err
			}
		}
	}

	if o.NameNisw != nil {

		// query param name__nisw
		var qrNameNisw string

		if o.NameNisw != nil {
			qrNameNisw = *o.NameNisw
		}
		qNameNisw := qrNameNisw
		if qNameNisw != "" {

			if err := r.SetQueryParam("name__nisw", qNameNisw); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if o.Q != nil {

		// query param q
		var qrQ string

		if o.Q != nil {
			qrQ = *o.Q
		}
		qQ := qrQ
		if qQ != "" {

			if err := r.SetQueryParam("q", qQ); err != nil {
				return err
			}
		}
	}

	if o.Rack != nil {

		// query param rack
		var qrRack float64

		if o.Rack != nil {
			qrRack = *o.Rack
		}
		qRack := swag.FormatFloat64(qrRack)
		if qRack != "" {

			if err := r.SetQueryParam("rack", qRack); err != nil {
				return err
			}
		}
	}

	if o.Region != nil {

		// query param region
		var qrRegion float64

		if o.Region != nil {
			qrRegion = *o.Region
		}
		qRegion := swag.FormatFloat64(qrRegion)
		if qRegion != "" {

			if err := r.SetQueryParam("region", qRegion); err != nil {
				return err
			}
		}
	}

	if o.ScopeID != nil {

		// query param scope_id
		var qrScopeID string

		if o.ScopeID != nil {
			qrScopeID = *o.ScopeID
		}
		qScopeID := qrScopeID
		if qScopeID != "" {

			if err := r.SetQueryParam("scope_id", qScopeID); err != nil {
				return err
			}
		}
	}

	if o.ScopeIDGt != nil {

		// query param scope_id__gt
		var qrScopeIDGt string

		if o.ScopeIDGt != nil {
			qrScopeIDGt = *o.ScopeIDGt
		}
		qScopeIDGt := qrScopeIDGt
		if qScopeIDGt != "" {

			if err := r.SetQueryParam("scope_id__gt", qScopeIDGt); err != nil {
				return err
			}
		}
	}

	if o.ScopeIDGte != nil {

		// query param scope_id__gte
		var qrScopeIDGte string

		if o.ScopeIDGte != nil {
			qrScopeIDGte = *o.ScopeIDGte
		}
		qScopeIDGte := qrScopeIDGte
		if qScopeIDGte != "" {

			if err := r.SetQueryParam("scope_id__gte", qScopeIDGte); err != nil {
				return err
			}
		}
	}

	if o.ScopeIDLt != nil {

		// query param scope_id__lt
		var qrScopeIDLt string

		if o.ScopeIDLt != nil {
			qrScopeIDLt = *o.ScopeIDLt
		}
		qScopeIDLt := qrScopeIDLt
		if qScopeIDLt != "" {

			if err := r.SetQueryParam("scope_id__lt", qScopeIDLt); err != nil {
				return err
			}
		}
	}

	if o.ScopeIDLte != nil {

		// query param scope_id__lte
		var qrScopeIDLte string

		if o.ScopeIDLte != nil {
			qrScopeIDLte = *o.ScopeIDLte
		}
		qScopeIDLte := qrScopeIDLte
		if qScopeIDLte != "" {

			if err := r.SetQueryParam("scope_id__lte", qScopeIDLte); err != nil {
				return err
			}
		}
	}

	if o.ScopeIDn != nil {

		// query param scope_id__n
		var qrScopeIDn string

		if o.ScopeIDn != nil {
			qrScopeIDn = *o.ScopeIDn
		}
		qScopeIDn := qrScopeIDn
		if qScopeIDn != "" {

			if err := r.SetQueryParam("scope_id__n", qScopeIDn); err != nil {
				return err
			}
		}
	}

	if o.ScopeType != nil {

		// query param scope_type
		var qrScopeType string

		if o.ScopeType != nil {
			qrScopeType = *o.ScopeType
		}
		qScopeType := qrScopeType
		if qScopeType != "" {

			if err := r.SetQueryParam("scope_type", qScopeType); err != nil {
				return err
			}
		}
	}

	if o.ScopeTypen != nil {

		// query param scope_type__n
		var qrScopeTypen string

		if o.ScopeTypen != nil {
			qrScopeTypen = *o.ScopeTypen
		}
		qScopeTypen := qrScopeTypen
		if qScopeTypen != "" {

			if err := r.SetQueryParam("scope_type__n", qScopeTypen); err != nil {
				return err
			}
		}
	}

	if o.Site != nil {

		// query param site
		var qrSite float64

		if o.Site != nil {
			qrSite = *o.Site
		}
		qSite := swag.FormatFloat64(qrSite)
		if qSite != "" {

			if err := r.SetQueryParam("site", qSite); err != nil {
				return err
			}
		}
	}

	if o.Sitegroup != nil {

		// query param sitegroup
		var qrSitegroup float64

		if o.Sitegroup != nil {
			qrSitegroup = *o.Sitegroup
		}
		qSitegroup := swag.FormatFloat64(qrSitegroup)
		if qSitegroup != "" {

			if err := r.SetQueryParam("sitegroup", qSitegroup); err != nil {
				return err
			}
		}
	}

	if o.Slug != nil {

		// query param slug
		var qrSlug string

		if o.Slug != nil {
			qrSlug = *o.Slug
		}
		qSlug := qrSlug
		if qSlug != "" {

			if err := r.SetQueryParam("slug", qSlug); err != nil {
				return err
			}
		}
	}

	if o.SlugIc != nil {

		// query param slug__ic
		var qrSlugIc string

		if o.SlugIc != nil {
			qrSlugIc = *o.SlugIc
		}
		qSlugIc := qrSlugIc
		if qSlugIc != "" {

			if err := r.SetQueryParam("slug__ic", qSlugIc); err != nil {
				return err
			}
		}
	}

	if o.SlugIe != nil {

		// query param slug__ie
		var qrSlugIe string

		if o.SlugIe != nil {
			qrSlugIe = *o.SlugIe
		}
		qSlugIe := qrSlugIe
		if qSlugIe != "" {

			if err := r.SetQueryParam("slug__ie", qSlugIe); err != nil {
				return err
			}
		}
	}

	if o.SlugIew != nil {

		// query param slug__iew
		var qrSlugIew string

		if o.SlugIew != nil {
			qrSlugIew = *o.SlugIew
		}
		qSlugIew := qrSlugIew
		if qSlugIew != "" {

			if err := r.SetQueryParam("slug__iew", qSlugIew); err != nil {
				return err
			}
		}
	}

	if o.SlugIsw != nil {

		// query param slug__isw
		var qrSlugIsw string

		if o.SlugIsw != nil {
			qrSlugIsw = *o.SlugIsw
		}
		qSlugIsw := qrSlugIsw
		if qSlugIsw != "" {

			if err := r.SetQueryParam("slug__isw", qSlugIsw); err != nil {
				return err
			}
		}
	}

	if o.Slugn != nil {

		// query param slug__n
		var qrSlugn string

		if o.Slugn != nil {
			qrSlugn = *o.Slugn
		}
		qSlugn := qrSlugn
		if qSlugn != "" {

			if err := r.SetQueryParam("slug__n", qSlugn); err != nil {
				return err
			}
		}
	}

	if o.SlugNic != nil {

		// query param slug__nic
		var qrSlugNic string

		if o.SlugNic != nil {
			qrSlugNic = *o.SlugNic
		}
		qSlugNic := qrSlugNic
		if qSlugNic != "" {

			if err := r.SetQueryParam("slug__nic", qSlugNic); err != nil {
				return err
			}
		}
	}

	if o.SlugNie != nil {

		// query param slug__nie
		var qrSlugNie string

		if o.SlugNie != nil {
			qrSlugNie = *o.SlugNie
		}
		qSlugNie := qrSlugNie
		if qSlugNie != "" {

			if err := r.SetQueryParam("slug__nie", qSlugNie); err != nil {
				return err
			}
		}
	}

	if o.SlugNiew != nil {

		// query param slug__niew
		var qrSlugNiew string

		if o.SlugNiew != nil {
			qrSlugNiew = *o.SlugNiew
		}
		qSlugNiew := qrSlugNiew
		if qSlugNiew != "" {

			if err := r.SetQueryParam("slug__niew", qSlugNiew); err != nil {
				return err
			}
		}
	}

	if o.SlugNisw != nil {

		// query param slug__nisw
		var qrSlugNisw string

		if o.SlugNisw != nil {
			qrSlugNisw = *o.SlugNisw
		}
		qSlugNisw := qrSlugNisw
		if qSlugNisw != "" {

			if err := r.SetQueryParam("slug__nisw", qSlugNisw); err != nil {
				return err
			}
		}
	}

	if o.Tag != nil {

		// query param tag
		var qrTag string

		if o.Tag != nil {
			qrTag = *o.Tag
		}
		qTag := qrTag
		if qTag != "" {

			if err := r.SetQueryParam("tag", qTag); err != nil {
				return err
			}
		}
	}

	if o.Tagn != nil {

		// query param tag__n
		var qrTagn string

		if o.Tagn != nil {
			qrTagn = *o.Tagn
		}
		qTagn := qrTagn
		if qTagn != "" {

			if err := r.SetQueryParam("tag__n", qTagn); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
