// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2020 The go-netbox Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package tenancy

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewTenancyContactsListParams creates a new TenancyContactsListParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewTenancyContactsListParams() *TenancyContactsListParams {
	return &TenancyContactsListParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewTenancyContactsListParamsWithTimeout creates a new TenancyContactsListParams object
// with the ability to set a timeout on a request.
func NewTenancyContactsListParamsWithTimeout(timeout time.Duration) *TenancyContactsListParams {
	return &TenancyContactsListParams{
		timeout: timeout,
	}
}

// NewTenancyContactsListParamsWithContext creates a new TenancyContactsListParams object
// with the ability to set a context for a request.
func NewTenancyContactsListParamsWithContext(ctx context.Context) *TenancyContactsListParams {
	return &TenancyContactsListParams{
		Context: ctx,
	}
}

// NewTenancyContactsListParamsWithHTTPClient creates a new TenancyContactsListParams object
// with the ability to set a custom HTTPClient for a request.
func NewTenancyContactsListParamsWithHTTPClient(client *http.Client) *TenancyContactsListParams {
	return &TenancyContactsListParams{
		HTTPClient: client,
	}
}

/* TenancyContactsListParams contains all the parameters to send to the API endpoint
   for the tenancy contacts list operation.

   Typically these are written to a http.Request.
*/
type TenancyContactsListParams struct {

	// Address.
	Address *string

	// AddressIc.
	AddressIc *string

	// AddressIe.
	AddressIe *string

	// AddressIew.
	AddressIew *string

	// AddressIsw.
	AddressIsw *string

	// Addressn.
	Addressn *string

	// AddressNic.
	AddressNic *string

	// AddressNie.
	AddressNie *string

	// AddressNiew.
	AddressNiew *string

	// AddressNisw.
	AddressNisw *string

	// Created.
	Created *string

	// CreatedGte.
	CreatedGte *string

	// CreatedLte.
	CreatedLte *string

	// Email.
	Email *string

	// EmailIc.
	EmailIc *string

	// EmailIe.
	EmailIe *string

	// EmailIew.
	EmailIew *string

	// EmailIsw.
	EmailIsw *string

	// Emailn.
	Emailn *string

	// EmailNic.
	EmailNic *string

	// EmailNie.
	EmailNie *string

	// EmailNiew.
	EmailNiew *string

	// EmailNisw.
	EmailNisw *string

	// Group.
	Group *string

	// Groupn.
	Groupn *string

	// GroupID.
	GroupID *string

	// GroupIDn.
	GroupIDn *string

	// ID.
	ID *string

	// IDGt.
	IDGt *string

	// IDGte.
	IDGte *string

	// IDLt.
	IDLt *string

	// IDLte.
	IDLte *string

	// IDn.
	IDn *string

	// LastUpdated.
	LastUpdated *string

	// LastUpdatedGte.
	LastUpdatedGte *string

	// LastUpdatedLte.
	LastUpdatedLte *string

	/* Limit.

	   Number of results to return per page.
	*/
	Limit *int64

	// Link.
	Link *string

	// LinkIc.
	LinkIc *string

	// LinkIe.
	LinkIe *string

	// LinkIew.
	LinkIew *string

	// LinkIsw.
	LinkIsw *string

	// Linkn.
	Linkn *string

	// LinkNic.
	LinkNic *string

	// LinkNie.
	LinkNie *string

	// LinkNiew.
	LinkNiew *string

	// LinkNisw.
	LinkNisw *string

	// Name.
	Name *string

	// NameIc.
	NameIc *string

	// NameIe.
	NameIe *string

	// NameIew.
	NameIew *string

	// NameIsw.
	NameIsw *string

	// Namen.
	Namen *string

	// NameNic.
	NameNic *string

	// NameNie.
	NameNie *string

	// NameNiew.
	NameNiew *string

	// NameNisw.
	NameNisw *string

	/* Offset.

	   The initial index from which to return the results.
	*/
	Offset *int64

	// Phone.
	Phone *string

	// PhoneIc.
	PhoneIc *string

	// PhoneIe.
	PhoneIe *string

	// PhoneIew.
	PhoneIew *string

	// PhoneIsw.
	PhoneIsw *string

	// Phonen.
	Phonen *string

	// PhoneNic.
	PhoneNic *string

	// PhoneNie.
	PhoneNie *string

	// PhoneNiew.
	PhoneNiew *string

	// PhoneNisw.
	PhoneNisw *string

	// Q.
	Q *string

	// Tag.
	Tag *string

	// Tagn.
	Tagn *string

	// Title.
	Title *string

	// TitleIc.
	TitleIc *string

	// TitleIe.
	TitleIe *string

	// TitleIew.
	TitleIew *string

	// TitleIsw.
	TitleIsw *string

	// Titlen.
	Titlen *string

	// TitleNic.
	TitleNic *string

	// TitleNie.
	TitleNie *string

	// TitleNiew.
	TitleNiew *string

	// TitleNisw.
	TitleNisw *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the tenancy contacts list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *TenancyContactsListParams) WithDefaults() *TenancyContactsListParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the tenancy contacts list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *TenancyContactsListParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the tenancy contacts list params
func (o *TenancyContactsListParams) WithTimeout(timeout time.Duration) *TenancyContactsListParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the tenancy contacts list params
func (o *TenancyContactsListParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the tenancy contacts list params
func (o *TenancyContactsListParams) WithContext(ctx context.Context) *TenancyContactsListParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the tenancy contacts list params
func (o *TenancyContactsListParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the tenancy contacts list params
func (o *TenancyContactsListParams) WithHTTPClient(client *http.Client) *TenancyContactsListParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the tenancy contacts list params
func (o *TenancyContactsListParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAddress adds the address to the tenancy contacts list params
func (o *TenancyContactsListParams) WithAddress(address *string) *TenancyContactsListParams {
	o.SetAddress(address)
	return o
}

// SetAddress adds the address to the tenancy contacts list params
func (o *TenancyContactsListParams) SetAddress(address *string) {
	o.Address = address
}

// WithAddressIc adds the addressIc to the tenancy contacts list params
func (o *TenancyContactsListParams) WithAddressIc(addressIc *string) *TenancyContactsListParams {
	o.SetAddressIc(addressIc)
	return o
}

// SetAddressIc adds the addressIc to the tenancy contacts list params
func (o *TenancyContactsListParams) SetAddressIc(addressIc *string) {
	o.AddressIc = addressIc
}

// WithAddressIe adds the addressIe to the tenancy contacts list params
func (o *TenancyContactsListParams) WithAddressIe(addressIe *string) *TenancyContactsListParams {
	o.SetAddressIe(addressIe)
	return o
}

// SetAddressIe adds the addressIe to the tenancy contacts list params
func (o *TenancyContactsListParams) SetAddressIe(addressIe *string) {
	o.AddressIe = addressIe
}

// WithAddressIew adds the addressIew to the tenancy contacts list params
func (o *TenancyContactsListParams) WithAddressIew(addressIew *string) *TenancyContactsListParams {
	o.SetAddressIew(addressIew)
	return o
}

// SetAddressIew adds the addressIew to the tenancy contacts list params
func (o *TenancyContactsListParams) SetAddressIew(addressIew *string) {
	o.AddressIew = addressIew
}

// WithAddressIsw adds the addressIsw to the tenancy contacts list params
func (o *TenancyContactsListParams) WithAddressIsw(addressIsw *string) *TenancyContactsListParams {
	o.SetAddressIsw(addressIsw)
	return o
}

// SetAddressIsw adds the addressIsw to the tenancy contacts list params
func (o *TenancyContactsListParams) SetAddressIsw(addressIsw *string) {
	o.AddressIsw = addressIsw
}

// WithAddressn adds the addressn to the tenancy contacts list params
func (o *TenancyContactsListParams) WithAddressn(addressn *string) *TenancyContactsListParams {
	o.SetAddressn(addressn)
	return o
}

// SetAddressn adds the addressN to the tenancy contacts list params
func (o *TenancyContactsListParams) SetAddressn(addressn *string) {
	o.Addressn = addressn
}

// WithAddressNic adds the addressNic to the tenancy contacts list params
func (o *TenancyContactsListParams) WithAddressNic(addressNic *string) *TenancyContactsListParams {
	o.SetAddressNic(addressNic)
	return o
}

// SetAddressNic adds the addressNic to the tenancy contacts list params
func (o *TenancyContactsListParams) SetAddressNic(addressNic *string) {
	o.AddressNic = addressNic
}

// WithAddressNie adds the addressNie to the tenancy contacts list params
func (o *TenancyContactsListParams) WithAddressNie(addressNie *string) *TenancyContactsListParams {
	o.SetAddressNie(addressNie)
	return o
}

// SetAddressNie adds the addressNie to the tenancy contacts list params
func (o *TenancyContactsListParams) SetAddressNie(addressNie *string) {
	o.AddressNie = addressNie
}

// WithAddressNiew adds the addressNiew to the tenancy contacts list params
func (o *TenancyContactsListParams) WithAddressNiew(addressNiew *string) *TenancyContactsListParams {
	o.SetAddressNiew(addressNiew)
	return o
}

// SetAddressNiew adds the addressNiew to the tenancy contacts list params
func (o *TenancyContactsListParams) SetAddressNiew(addressNiew *string) {
	o.AddressNiew = addressNiew
}

// WithAddressNisw adds the addressNisw to the tenancy contacts list params
func (o *TenancyContactsListParams) WithAddressNisw(addressNisw *string) *TenancyContactsListParams {
	o.SetAddressNisw(addressNisw)
	return o
}

// SetAddressNisw adds the addressNisw to the tenancy contacts list params
func (o *TenancyContactsListParams) SetAddressNisw(addressNisw *string) {
	o.AddressNisw = addressNisw
}

// WithCreated adds the created to the tenancy contacts list params
func (o *TenancyContactsListParams) WithCreated(created *string) *TenancyContactsListParams {
	o.SetCreated(created)
	return o
}

// SetCreated adds the created to the tenancy contacts list params
func (o *TenancyContactsListParams) SetCreated(created *string) {
	o.Created = created
}

// WithCreatedGte adds the createdGte to the tenancy contacts list params
func (o *TenancyContactsListParams) WithCreatedGte(createdGte *string) *TenancyContactsListParams {
	o.SetCreatedGte(createdGte)
	return o
}

// SetCreatedGte adds the createdGte to the tenancy contacts list params
func (o *TenancyContactsListParams) SetCreatedGte(createdGte *string) {
	o.CreatedGte = createdGte
}

// WithCreatedLte adds the createdLte to the tenancy contacts list params
func (o *TenancyContactsListParams) WithCreatedLte(createdLte *string) *TenancyContactsListParams {
	o.SetCreatedLte(createdLte)
	return o
}

// SetCreatedLte adds the createdLte to the tenancy contacts list params
func (o *TenancyContactsListParams) SetCreatedLte(createdLte *string) {
	o.CreatedLte = createdLte
}

// WithEmail adds the email to the tenancy contacts list params
func (o *TenancyContactsListParams) WithEmail(email *string) *TenancyContactsListParams {
	o.SetEmail(email)
	return o
}

// SetEmail adds the email to the tenancy contacts list params
func (o *TenancyContactsListParams) SetEmail(email *string) {
	o.Email = email
}

// WithEmailIc adds the emailIc to the tenancy contacts list params
func (o *TenancyContactsListParams) WithEmailIc(emailIc *string) *TenancyContactsListParams {
	o.SetEmailIc(emailIc)
	return o
}

// SetEmailIc adds the emailIc to the tenancy contacts list params
func (o *TenancyContactsListParams) SetEmailIc(emailIc *string) {
	o.EmailIc = emailIc
}

// WithEmailIe adds the emailIe to the tenancy contacts list params
func (o *TenancyContactsListParams) WithEmailIe(emailIe *string) *TenancyContactsListParams {
	o.SetEmailIe(emailIe)
	return o
}

// SetEmailIe adds the emailIe to the tenancy contacts list params
func (o *TenancyContactsListParams) SetEmailIe(emailIe *string) {
	o.EmailIe = emailIe
}

// WithEmailIew adds the emailIew to the tenancy contacts list params
func (o *TenancyContactsListParams) WithEmailIew(emailIew *string) *TenancyContactsListParams {
	o.SetEmailIew(emailIew)
	return o
}

// SetEmailIew adds the emailIew to the tenancy contacts list params
func (o *TenancyContactsListParams) SetEmailIew(emailIew *string) {
	o.EmailIew = emailIew
}

// WithEmailIsw adds the emailIsw to the tenancy contacts list params
func (o *TenancyContactsListParams) WithEmailIsw(emailIsw *string) *TenancyContactsListParams {
	o.SetEmailIsw(emailIsw)
	return o
}

// SetEmailIsw adds the emailIsw to the tenancy contacts list params
func (o *TenancyContactsListParams) SetEmailIsw(emailIsw *string) {
	o.EmailIsw = emailIsw
}

// WithEmailn adds the emailn to the tenancy contacts list params
func (o *TenancyContactsListParams) WithEmailn(emailn *string) *TenancyContactsListParams {
	o.SetEmailn(emailn)
	return o
}

// SetEmailn adds the emailN to the tenancy contacts list params
func (o *TenancyContactsListParams) SetEmailn(emailn *string) {
	o.Emailn = emailn
}

// WithEmailNic adds the emailNic to the tenancy contacts list params
func (o *TenancyContactsListParams) WithEmailNic(emailNic *string) *TenancyContactsListParams {
	o.SetEmailNic(emailNic)
	return o
}

// SetEmailNic adds the emailNic to the tenancy contacts list params
func (o *TenancyContactsListParams) SetEmailNic(emailNic *string) {
	o.EmailNic = emailNic
}

// WithEmailNie adds the emailNie to the tenancy contacts list params
func (o *TenancyContactsListParams) WithEmailNie(emailNie *string) *TenancyContactsListParams {
	o.SetEmailNie(emailNie)
	return o
}

// SetEmailNie adds the emailNie to the tenancy contacts list params
func (o *TenancyContactsListParams) SetEmailNie(emailNie *string) {
	o.EmailNie = emailNie
}

// WithEmailNiew adds the emailNiew to the tenancy contacts list params
func (o *TenancyContactsListParams) WithEmailNiew(emailNiew *string) *TenancyContactsListParams {
	o.SetEmailNiew(emailNiew)
	return o
}

// SetEmailNiew adds the emailNiew to the tenancy contacts list params
func (o *TenancyContactsListParams) SetEmailNiew(emailNiew *string) {
	o.EmailNiew = emailNiew
}

// WithEmailNisw adds the emailNisw to the tenancy contacts list params
func (o *TenancyContactsListParams) WithEmailNisw(emailNisw *string) *TenancyContactsListParams {
	o.SetEmailNisw(emailNisw)
	return o
}

// SetEmailNisw adds the emailNisw to the tenancy contacts list params
func (o *TenancyContactsListParams) SetEmailNisw(emailNisw *string) {
	o.EmailNisw = emailNisw
}

// WithGroup adds the group to the tenancy contacts list params
func (o *TenancyContactsListParams) WithGroup(group *string) *TenancyContactsListParams {
	o.SetGroup(group)
	return o
}

// SetGroup adds the group to the tenancy contacts list params
func (o *TenancyContactsListParams) SetGroup(group *string) {
	o.Group = group
}

// WithGroupn adds the groupn to the tenancy contacts list params
func (o *TenancyContactsListParams) WithGroupn(groupn *string) *TenancyContactsListParams {
	o.SetGroupn(groupn)
	return o
}

// SetGroupn adds the groupN to the tenancy contacts list params
func (o *TenancyContactsListParams) SetGroupn(groupn *string) {
	o.Groupn = groupn
}

// WithGroupID adds the groupID to the tenancy contacts list params
func (o *TenancyContactsListParams) WithGroupID(groupID *string) *TenancyContactsListParams {
	o.SetGroupID(groupID)
	return o
}

// SetGroupID adds the groupId to the tenancy contacts list params
func (o *TenancyContactsListParams) SetGroupID(groupID *string) {
	o.GroupID = groupID
}

// WithGroupIDn adds the groupIDn to the tenancy contacts list params
func (o *TenancyContactsListParams) WithGroupIDn(groupIDn *string) *TenancyContactsListParams {
	o.SetGroupIDn(groupIDn)
	return o
}

// SetGroupIDn adds the groupIdN to the tenancy contacts list params
func (o *TenancyContactsListParams) SetGroupIDn(groupIDn *string) {
	o.GroupIDn = groupIDn
}

// WithID adds the id to the tenancy contacts list params
func (o *TenancyContactsListParams) WithID(id *string) *TenancyContactsListParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the tenancy contacts list params
func (o *TenancyContactsListParams) SetID(id *string) {
	o.ID = id
}

// WithIDGt adds the iDGt to the tenancy contacts list params
func (o *TenancyContactsListParams) WithIDGt(iDGt *string) *TenancyContactsListParams {
	o.SetIDGt(iDGt)
	return o
}

// SetIDGt adds the idGt to the tenancy contacts list params
func (o *TenancyContactsListParams) SetIDGt(iDGt *string) {
	o.IDGt = iDGt
}

// WithIDGte adds the iDGte to the tenancy contacts list params
func (o *TenancyContactsListParams) WithIDGte(iDGte *string) *TenancyContactsListParams {
	o.SetIDGte(iDGte)
	return o
}

// SetIDGte adds the idGte to the tenancy contacts list params
func (o *TenancyContactsListParams) SetIDGte(iDGte *string) {
	o.IDGte = iDGte
}

// WithIDLt adds the iDLt to the tenancy contacts list params
func (o *TenancyContactsListParams) WithIDLt(iDLt *string) *TenancyContactsListParams {
	o.SetIDLt(iDLt)
	return o
}

// SetIDLt adds the idLt to the tenancy contacts list params
func (o *TenancyContactsListParams) SetIDLt(iDLt *string) {
	o.IDLt = iDLt
}

// WithIDLte adds the iDLte to the tenancy contacts list params
func (o *TenancyContactsListParams) WithIDLte(iDLte *string) *TenancyContactsListParams {
	o.SetIDLte(iDLte)
	return o
}

// SetIDLte adds the idLte to the tenancy contacts list params
func (o *TenancyContactsListParams) SetIDLte(iDLte *string) {
	o.IDLte = iDLte
}

// WithIDn adds the iDn to the tenancy contacts list params
func (o *TenancyContactsListParams) WithIDn(iDn *string) *TenancyContactsListParams {
	o.SetIDn(iDn)
	return o
}

// SetIDn adds the idN to the tenancy contacts list params
func (o *TenancyContactsListParams) SetIDn(iDn *string) {
	o.IDn = iDn
}

// WithLastUpdated adds the lastUpdated to the tenancy contacts list params
func (o *TenancyContactsListParams) WithLastUpdated(lastUpdated *string) *TenancyContactsListParams {
	o.SetLastUpdated(lastUpdated)
	return o
}

// SetLastUpdated adds the lastUpdated to the tenancy contacts list params
func (o *TenancyContactsListParams) SetLastUpdated(lastUpdated *string) {
	o.LastUpdated = lastUpdated
}

// WithLastUpdatedGte adds the lastUpdatedGte to the tenancy contacts list params
func (o *TenancyContactsListParams) WithLastUpdatedGte(lastUpdatedGte *string) *TenancyContactsListParams {
	o.SetLastUpdatedGte(lastUpdatedGte)
	return o
}

// SetLastUpdatedGte adds the lastUpdatedGte to the tenancy contacts list params
func (o *TenancyContactsListParams) SetLastUpdatedGte(lastUpdatedGte *string) {
	o.LastUpdatedGte = lastUpdatedGte
}

// WithLastUpdatedLte adds the lastUpdatedLte to the tenancy contacts list params
func (o *TenancyContactsListParams) WithLastUpdatedLte(lastUpdatedLte *string) *TenancyContactsListParams {
	o.SetLastUpdatedLte(lastUpdatedLte)
	return o
}

// SetLastUpdatedLte adds the lastUpdatedLte to the tenancy contacts list params
func (o *TenancyContactsListParams) SetLastUpdatedLte(lastUpdatedLte *string) {
	o.LastUpdatedLte = lastUpdatedLte
}

// WithLimit adds the limit to the tenancy contacts list params
func (o *TenancyContactsListParams) WithLimit(limit *int64) *TenancyContactsListParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the tenancy contacts list params
func (o *TenancyContactsListParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithLink adds the link to the tenancy contacts list params
func (o *TenancyContactsListParams) WithLink(link *string) *TenancyContactsListParams {
	o.SetLink(link)
	return o
}

// SetLink adds the link to the tenancy contacts list params
func (o *TenancyContactsListParams) SetLink(link *string) {
	o.Link = link
}

// WithLinkIc adds the linkIc to the tenancy contacts list params
func (o *TenancyContactsListParams) WithLinkIc(linkIc *string) *TenancyContactsListParams {
	o.SetLinkIc(linkIc)
	return o
}

// SetLinkIc adds the linkIc to the tenancy contacts list params
func (o *TenancyContactsListParams) SetLinkIc(linkIc *string) {
	o.LinkIc = linkIc
}

// WithLinkIe adds the linkIe to the tenancy contacts list params
func (o *TenancyContactsListParams) WithLinkIe(linkIe *string) *TenancyContactsListParams {
	o.SetLinkIe(linkIe)
	return o
}

// SetLinkIe adds the linkIe to the tenancy contacts list params
func (o *TenancyContactsListParams) SetLinkIe(linkIe *string) {
	o.LinkIe = linkIe
}

// WithLinkIew adds the linkIew to the tenancy contacts list params
func (o *TenancyContactsListParams) WithLinkIew(linkIew *string) *TenancyContactsListParams {
	o.SetLinkIew(linkIew)
	return o
}

// SetLinkIew adds the linkIew to the tenancy contacts list params
func (o *TenancyContactsListParams) SetLinkIew(linkIew *string) {
	o.LinkIew = linkIew
}

// WithLinkIsw adds the linkIsw to the tenancy contacts list params
func (o *TenancyContactsListParams) WithLinkIsw(linkIsw *string) *TenancyContactsListParams {
	o.SetLinkIsw(linkIsw)
	return o
}

// SetLinkIsw adds the linkIsw to the tenancy contacts list params
func (o *TenancyContactsListParams) SetLinkIsw(linkIsw *string) {
	o.LinkIsw = linkIsw
}

// WithLinkn adds the linkn to the tenancy contacts list params
func (o *TenancyContactsListParams) WithLinkn(linkn *string) *TenancyContactsListParams {
	o.SetLinkn(linkn)
	return o
}

// SetLinkn adds the linkN to the tenancy contacts list params
func (o *TenancyContactsListParams) SetLinkn(linkn *string) {
	o.Linkn = linkn
}

// WithLinkNic adds the linkNic to the tenancy contacts list params
func (o *TenancyContactsListParams) WithLinkNic(linkNic *string) *TenancyContactsListParams {
	o.SetLinkNic(linkNic)
	return o
}

// SetLinkNic adds the linkNic to the tenancy contacts list params
func (o *TenancyContactsListParams) SetLinkNic(linkNic *string) {
	o.LinkNic = linkNic
}

// WithLinkNie adds the linkNie to the tenancy contacts list params
func (o *TenancyContactsListParams) WithLinkNie(linkNie *string) *TenancyContactsListParams {
	o.SetLinkNie(linkNie)
	return o
}

// SetLinkNie adds the linkNie to the tenancy contacts list params
func (o *TenancyContactsListParams) SetLinkNie(linkNie *string) {
	o.LinkNie = linkNie
}

// WithLinkNiew adds the linkNiew to the tenancy contacts list params
func (o *TenancyContactsListParams) WithLinkNiew(linkNiew *string) *TenancyContactsListParams {
	o.SetLinkNiew(linkNiew)
	return o
}

// SetLinkNiew adds the linkNiew to the tenancy contacts list params
func (o *TenancyContactsListParams) SetLinkNiew(linkNiew *string) {
	o.LinkNiew = linkNiew
}

// WithLinkNisw adds the linkNisw to the tenancy contacts list params
func (o *TenancyContactsListParams) WithLinkNisw(linkNisw *string) *TenancyContactsListParams {
	o.SetLinkNisw(linkNisw)
	return o
}

// SetLinkNisw adds the linkNisw to the tenancy contacts list params
func (o *TenancyContactsListParams) SetLinkNisw(linkNisw *string) {
	o.LinkNisw = linkNisw
}

// WithName adds the name to the tenancy contacts list params
func (o *TenancyContactsListParams) WithName(name *string) *TenancyContactsListParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the tenancy contacts list params
func (o *TenancyContactsListParams) SetName(name *string) {
	o.Name = name
}

// WithNameIc adds the nameIc to the tenancy contacts list params
func (o *TenancyContactsListParams) WithNameIc(nameIc *string) *TenancyContactsListParams {
	o.SetNameIc(nameIc)
	return o
}

// SetNameIc adds the nameIc to the tenancy contacts list params
func (o *TenancyContactsListParams) SetNameIc(nameIc *string) {
	o.NameIc = nameIc
}

// WithNameIe adds the nameIe to the tenancy contacts list params
func (o *TenancyContactsListParams) WithNameIe(nameIe *string) *TenancyContactsListParams {
	o.SetNameIe(nameIe)
	return o
}

// SetNameIe adds the nameIe to the tenancy contacts list params
func (o *TenancyContactsListParams) SetNameIe(nameIe *string) {
	o.NameIe = nameIe
}

// WithNameIew adds the nameIew to the tenancy contacts list params
func (o *TenancyContactsListParams) WithNameIew(nameIew *string) *TenancyContactsListParams {
	o.SetNameIew(nameIew)
	return o
}

// SetNameIew adds the nameIew to the tenancy contacts list params
func (o *TenancyContactsListParams) SetNameIew(nameIew *string) {
	o.NameIew = nameIew
}

// WithNameIsw adds the nameIsw to the tenancy contacts list params
func (o *TenancyContactsListParams) WithNameIsw(nameIsw *string) *TenancyContactsListParams {
	o.SetNameIsw(nameIsw)
	return o
}

// SetNameIsw adds the nameIsw to the tenancy contacts list params
func (o *TenancyContactsListParams) SetNameIsw(nameIsw *string) {
	o.NameIsw = nameIsw
}

// WithNamen adds the namen to the tenancy contacts list params
func (o *TenancyContactsListParams) WithNamen(namen *string) *TenancyContactsListParams {
	o.SetNamen(namen)
	return o
}

// SetNamen adds the nameN to the tenancy contacts list params
func (o *TenancyContactsListParams) SetNamen(namen *string) {
	o.Namen = namen
}

// WithNameNic adds the nameNic to the tenancy contacts list params
func (o *TenancyContactsListParams) WithNameNic(nameNic *string) *TenancyContactsListParams {
	o.SetNameNic(nameNic)
	return o
}

// SetNameNic adds the nameNic to the tenancy contacts list params
func (o *TenancyContactsListParams) SetNameNic(nameNic *string) {
	o.NameNic = nameNic
}

// WithNameNie adds the nameNie to the tenancy contacts list params
func (o *TenancyContactsListParams) WithNameNie(nameNie *string) *TenancyContactsListParams {
	o.SetNameNie(nameNie)
	return o
}

// SetNameNie adds the nameNie to the tenancy contacts list params
func (o *TenancyContactsListParams) SetNameNie(nameNie *string) {
	o.NameNie = nameNie
}

// WithNameNiew adds the nameNiew to the tenancy contacts list params
func (o *TenancyContactsListParams) WithNameNiew(nameNiew *string) *TenancyContactsListParams {
	o.SetNameNiew(nameNiew)
	return o
}

// SetNameNiew adds the nameNiew to the tenancy contacts list params
func (o *TenancyContactsListParams) SetNameNiew(nameNiew *string) {
	o.NameNiew = nameNiew
}

// WithNameNisw adds the nameNisw to the tenancy contacts list params
func (o *TenancyContactsListParams) WithNameNisw(nameNisw *string) *TenancyContactsListParams {
	o.SetNameNisw(nameNisw)
	return o
}

// SetNameNisw adds the nameNisw to the tenancy contacts list params
func (o *TenancyContactsListParams) SetNameNisw(nameNisw *string) {
	o.NameNisw = nameNisw
}

// WithOffset adds the offset to the tenancy contacts list params
func (o *TenancyContactsListParams) WithOffset(offset *int64) *TenancyContactsListParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the tenancy contacts list params
func (o *TenancyContactsListParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithPhone adds the phone to the tenancy contacts list params
func (o *TenancyContactsListParams) WithPhone(phone *string) *TenancyContactsListParams {
	o.SetPhone(phone)
	return o
}

// SetPhone adds the phone to the tenancy contacts list params
func (o *TenancyContactsListParams) SetPhone(phone *string) {
	o.Phone = phone
}

// WithPhoneIc adds the phoneIc to the tenancy contacts list params
func (o *TenancyContactsListParams) WithPhoneIc(phoneIc *string) *TenancyContactsListParams {
	o.SetPhoneIc(phoneIc)
	return o
}

// SetPhoneIc adds the phoneIc to the tenancy contacts list params
func (o *TenancyContactsListParams) SetPhoneIc(phoneIc *string) {
	o.PhoneIc = phoneIc
}

// WithPhoneIe adds the phoneIe to the tenancy contacts list params
func (o *TenancyContactsListParams) WithPhoneIe(phoneIe *string) *TenancyContactsListParams {
	o.SetPhoneIe(phoneIe)
	return o
}

// SetPhoneIe adds the phoneIe to the tenancy contacts list params
func (o *TenancyContactsListParams) SetPhoneIe(phoneIe *string) {
	o.PhoneIe = phoneIe
}

// WithPhoneIew adds the phoneIew to the tenancy contacts list params
func (o *TenancyContactsListParams) WithPhoneIew(phoneIew *string) *TenancyContactsListParams {
	o.SetPhoneIew(phoneIew)
	return o
}

// SetPhoneIew adds the phoneIew to the tenancy contacts list params
func (o *TenancyContactsListParams) SetPhoneIew(phoneIew *string) {
	o.PhoneIew = phoneIew
}

// WithPhoneIsw adds the phoneIsw to the tenancy contacts list params
func (o *TenancyContactsListParams) WithPhoneIsw(phoneIsw *string) *TenancyContactsListParams {
	o.SetPhoneIsw(phoneIsw)
	return o
}

// SetPhoneIsw adds the phoneIsw to the tenancy contacts list params
func (o *TenancyContactsListParams) SetPhoneIsw(phoneIsw *string) {
	o.PhoneIsw = phoneIsw
}

// WithPhonen adds the phonen to the tenancy contacts list params
func (o *TenancyContactsListParams) WithPhonen(phonen *string) *TenancyContactsListParams {
	o.SetPhonen(phonen)
	return o
}

// SetPhonen adds the phoneN to the tenancy contacts list params
func (o *TenancyContactsListParams) SetPhonen(phonen *string) {
	o.Phonen = phonen
}

// WithPhoneNic adds the phoneNic to the tenancy contacts list params
func (o *TenancyContactsListParams) WithPhoneNic(phoneNic *string) *TenancyContactsListParams {
	o.SetPhoneNic(phoneNic)
	return o
}

// SetPhoneNic adds the phoneNic to the tenancy contacts list params
func (o *TenancyContactsListParams) SetPhoneNic(phoneNic *string) {
	o.PhoneNic = phoneNic
}

// WithPhoneNie adds the phoneNie to the tenancy contacts list params
func (o *TenancyContactsListParams) WithPhoneNie(phoneNie *string) *TenancyContactsListParams {
	o.SetPhoneNie(phoneNie)
	return o
}

// SetPhoneNie adds the phoneNie to the tenancy contacts list params
func (o *TenancyContactsListParams) SetPhoneNie(phoneNie *string) {
	o.PhoneNie = phoneNie
}

// WithPhoneNiew adds the phoneNiew to the tenancy contacts list params
func (o *TenancyContactsListParams) WithPhoneNiew(phoneNiew *string) *TenancyContactsListParams {
	o.SetPhoneNiew(phoneNiew)
	return o
}

// SetPhoneNiew adds the phoneNiew to the tenancy contacts list params
func (o *TenancyContactsListParams) SetPhoneNiew(phoneNiew *string) {
	o.PhoneNiew = phoneNiew
}

// WithPhoneNisw adds the phoneNisw to the tenancy contacts list params
func (o *TenancyContactsListParams) WithPhoneNisw(phoneNisw *string) *TenancyContactsListParams {
	o.SetPhoneNisw(phoneNisw)
	return o
}

// SetPhoneNisw adds the phoneNisw to the tenancy contacts list params
func (o *TenancyContactsListParams) SetPhoneNisw(phoneNisw *string) {
	o.PhoneNisw = phoneNisw
}

// WithQ adds the q to the tenancy contacts list params
func (o *TenancyContactsListParams) WithQ(q *string) *TenancyContactsListParams {
	o.SetQ(q)
	return o
}

// SetQ adds the q to the tenancy contacts list params
func (o *TenancyContactsListParams) SetQ(q *string) {
	o.Q = q
}

// WithTag adds the tag to the tenancy contacts list params
func (o *TenancyContactsListParams) WithTag(tag *string) *TenancyContactsListParams {
	o.SetTag(tag)
	return o
}

// SetTag adds the tag to the tenancy contacts list params
func (o *TenancyContactsListParams) SetTag(tag *string) {
	o.Tag = tag
}

// WithTagn adds the tagn to the tenancy contacts list params
func (o *TenancyContactsListParams) WithTagn(tagn *string) *TenancyContactsListParams {
	o.SetTagn(tagn)
	return o
}

// SetTagn adds the tagN to the tenancy contacts list params
func (o *TenancyContactsListParams) SetTagn(tagn *string) {
	o.Tagn = tagn
}

// WithTitle adds the title to the tenancy contacts list params
func (o *TenancyContactsListParams) WithTitle(title *string) *TenancyContactsListParams {
	o.SetTitle(title)
	return o
}

// SetTitle adds the title to the tenancy contacts list params
func (o *TenancyContactsListParams) SetTitle(title *string) {
	o.Title = title
}

// WithTitleIc adds the titleIc to the tenancy contacts list params
func (o *TenancyContactsListParams) WithTitleIc(titleIc *string) *TenancyContactsListParams {
	o.SetTitleIc(titleIc)
	return o
}

// SetTitleIc adds the titleIc to the tenancy contacts list params
func (o *TenancyContactsListParams) SetTitleIc(titleIc *string) {
	o.TitleIc = titleIc
}

// WithTitleIe adds the titleIe to the tenancy contacts list params
func (o *TenancyContactsListParams) WithTitleIe(titleIe *string) *TenancyContactsListParams {
	o.SetTitleIe(titleIe)
	return o
}

// SetTitleIe adds the titleIe to the tenancy contacts list params
func (o *TenancyContactsListParams) SetTitleIe(titleIe *string) {
	o.TitleIe = titleIe
}

// WithTitleIew adds the titleIew to the tenancy contacts list params
func (o *TenancyContactsListParams) WithTitleIew(titleIew *string) *TenancyContactsListParams {
	o.SetTitleIew(titleIew)
	return o
}

// SetTitleIew adds the titleIew to the tenancy contacts list params
func (o *TenancyContactsListParams) SetTitleIew(titleIew *string) {
	o.TitleIew = titleIew
}

// WithTitleIsw adds the titleIsw to the tenancy contacts list params
func (o *TenancyContactsListParams) WithTitleIsw(titleIsw *string) *TenancyContactsListParams {
	o.SetTitleIsw(titleIsw)
	return o
}

// SetTitleIsw adds the titleIsw to the tenancy contacts list params
func (o *TenancyContactsListParams) SetTitleIsw(titleIsw *string) {
	o.TitleIsw = titleIsw
}

// WithTitlen adds the titlen to the tenancy contacts list params
func (o *TenancyContactsListParams) WithTitlen(titlen *string) *TenancyContactsListParams {
	o.SetTitlen(titlen)
	return o
}

// SetTitlen adds the titleN to the tenancy contacts list params
func (o *TenancyContactsListParams) SetTitlen(titlen *string) {
	o.Titlen = titlen
}

// WithTitleNic adds the titleNic to the tenancy contacts list params
func (o *TenancyContactsListParams) WithTitleNic(titleNic *string) *TenancyContactsListParams {
	o.SetTitleNic(titleNic)
	return o
}

// SetTitleNic adds the titleNic to the tenancy contacts list params
func (o *TenancyContactsListParams) SetTitleNic(titleNic *string) {
	o.TitleNic = titleNic
}

// WithTitleNie adds the titleNie to the tenancy contacts list params
func (o *TenancyContactsListParams) WithTitleNie(titleNie *string) *TenancyContactsListParams {
	o.SetTitleNie(titleNie)
	return o
}

// SetTitleNie adds the titleNie to the tenancy contacts list params
func (o *TenancyContactsListParams) SetTitleNie(titleNie *string) {
	o.TitleNie = titleNie
}

// WithTitleNiew adds the titleNiew to the tenancy contacts list params
func (o *TenancyContactsListParams) WithTitleNiew(titleNiew *string) *TenancyContactsListParams {
	o.SetTitleNiew(titleNiew)
	return o
}

// SetTitleNiew adds the titleNiew to the tenancy contacts list params
func (o *TenancyContactsListParams) SetTitleNiew(titleNiew *string) {
	o.TitleNiew = titleNiew
}

// WithTitleNisw adds the titleNisw to the tenancy contacts list params
func (o *TenancyContactsListParams) WithTitleNisw(titleNisw *string) *TenancyContactsListParams {
	o.SetTitleNisw(titleNisw)
	return o
}

// SetTitleNisw adds the titleNisw to the tenancy contacts list params
func (o *TenancyContactsListParams) SetTitleNisw(titleNisw *string) {
	o.TitleNisw = titleNisw
}

// WriteToRequest writes these params to a swagger request
func (o *TenancyContactsListParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Address != nil {

		// query param address
		var qrAddress string

		if o.Address != nil {
			qrAddress = *o.Address
		}
		qAddress := qrAddress
		if qAddress != "" {

			if err := r.SetQueryParam("address", qAddress); err != nil {
				return err
			}
		}
	}

	if o.AddressIc != nil {

		// query param address__ic
		var qrAddressIc string

		if o.AddressIc != nil {
			qrAddressIc = *o.AddressIc
		}
		qAddressIc := qrAddressIc
		if qAddressIc != "" {

			if err := r.SetQueryParam("address__ic", qAddressIc); err != nil {
				return err
			}
		}
	}

	if o.AddressIe != nil {

		// query param address__ie
		var qrAddressIe string

		if o.AddressIe != nil {
			qrAddressIe = *o.AddressIe
		}
		qAddressIe := qrAddressIe
		if qAddressIe != "" {

			if err := r.SetQueryParam("address__ie", qAddressIe); err != nil {
				return err
			}
		}
	}

	if o.AddressIew != nil {

		// query param address__iew
		var qrAddressIew string

		if o.AddressIew != nil {
			qrAddressIew = *o.AddressIew
		}
		qAddressIew := qrAddressIew
		if qAddressIew != "" {

			if err := r.SetQueryParam("address__iew", qAddressIew); err != nil {
				return err
			}
		}
	}

	if o.AddressIsw != nil {

		// query param address__isw
		var qrAddressIsw string

		if o.AddressIsw != nil {
			qrAddressIsw = *o.AddressIsw
		}
		qAddressIsw := qrAddressIsw
		if qAddressIsw != "" {

			if err := r.SetQueryParam("address__isw", qAddressIsw); err != nil {
				return err
			}
		}
	}

	if o.Addressn != nil {

		// query param address__n
		var qrAddressn string

		if o.Addressn != nil {
			qrAddressn = *o.Addressn
		}
		qAddressn := qrAddressn
		if qAddressn != "" {

			if err := r.SetQueryParam("address__n", qAddressn); err != nil {
				return err
			}
		}
	}

	if o.AddressNic != nil {

		// query param address__nic
		var qrAddressNic string

		if o.AddressNic != nil {
			qrAddressNic = *o.AddressNic
		}
		qAddressNic := qrAddressNic
		if qAddressNic != "" {

			if err := r.SetQueryParam("address__nic", qAddressNic); err != nil {
				return err
			}
		}
	}

	if o.AddressNie != nil {

		// query param address__nie
		var qrAddressNie string

		if o.AddressNie != nil {
			qrAddressNie = *o.AddressNie
		}
		qAddressNie := qrAddressNie
		if qAddressNie != "" {

			if err := r.SetQueryParam("address__nie", qAddressNie); err != nil {
				return err
			}
		}
	}

	if o.AddressNiew != nil {

		// query param address__niew
		var qrAddressNiew string

		if o.AddressNiew != nil {
			qrAddressNiew = *o.AddressNiew
		}
		qAddressNiew := qrAddressNiew
		if qAddressNiew != "" {

			if err := r.SetQueryParam("address__niew", qAddressNiew); err != nil {
				return err
			}
		}
	}

	if o.AddressNisw != nil {

		// query param address__nisw
		var qrAddressNisw string

		if o.AddressNisw != nil {
			qrAddressNisw = *o.AddressNisw
		}
		qAddressNisw := qrAddressNisw
		if qAddressNisw != "" {

			if err := r.SetQueryParam("address__nisw", qAddressNisw); err != nil {
				return err
			}
		}
	}

	if o.Created != nil {

		// query param created
		var qrCreated string

		if o.Created != nil {
			qrCreated = *o.Created
		}
		qCreated := qrCreated
		if qCreated != "" {

			if err := r.SetQueryParam("created", qCreated); err != nil {
				return err
			}
		}
	}

	if o.CreatedGte != nil {

		// query param created__gte
		var qrCreatedGte string

		if o.CreatedGte != nil {
			qrCreatedGte = *o.CreatedGte
		}
		qCreatedGte := qrCreatedGte
		if qCreatedGte != "" {

			if err := r.SetQueryParam("created__gte", qCreatedGte); err != nil {
				return err
			}
		}
	}

	if o.CreatedLte != nil {

		// query param created__lte
		var qrCreatedLte string

		if o.CreatedLte != nil {
			qrCreatedLte = *o.CreatedLte
		}
		qCreatedLte := qrCreatedLte
		if qCreatedLte != "" {

			if err := r.SetQueryParam("created__lte", qCreatedLte); err != nil {
				return err
			}
		}
	}

	if o.Email != nil {

		// query param email
		var qrEmail string

		if o.Email != nil {
			qrEmail = *o.Email
		}
		qEmail := qrEmail
		if qEmail != "" {

			if err := r.SetQueryParam("email", qEmail); err != nil {
				return err
			}
		}
	}

	if o.EmailIc != nil {

		// query param email__ic
		var qrEmailIc string

		if o.EmailIc != nil {
			qrEmailIc = *o.EmailIc
		}
		qEmailIc := qrEmailIc
		if qEmailIc != "" {

			if err := r.SetQueryParam("email__ic", qEmailIc); err != nil {
				return err
			}
		}
	}

	if o.EmailIe != nil {

		// query param email__ie
		var qrEmailIe string

		if o.EmailIe != nil {
			qrEmailIe = *o.EmailIe
		}
		qEmailIe := qrEmailIe
		if qEmailIe != "" {

			if err := r.SetQueryParam("email__ie", qEmailIe); err != nil {
				return err
			}
		}
	}

	if o.EmailIew != nil {

		// query param email__iew
		var qrEmailIew string

		if o.EmailIew != nil {
			qrEmailIew = *o.EmailIew
		}
		qEmailIew := qrEmailIew
		if qEmailIew != "" {

			if err := r.SetQueryParam("email__iew", qEmailIew); err != nil {
				return err
			}
		}
	}

	if o.EmailIsw != nil {

		// query param email__isw
		var qrEmailIsw string

		if o.EmailIsw != nil {
			qrEmailIsw = *o.EmailIsw
		}
		qEmailIsw := qrEmailIsw
		if qEmailIsw != "" {

			if err := r.SetQueryParam("email__isw", qEmailIsw); err != nil {
				return err
			}
		}
	}

	if o.Emailn != nil {

		// query param email__n
		var qrEmailn string

		if o.Emailn != nil {
			qrEmailn = *o.Emailn
		}
		qEmailn := qrEmailn
		if qEmailn != "" {

			if err := r.SetQueryParam("email__n", qEmailn); err != nil {
				return err
			}
		}
	}

	if o.EmailNic != nil {

		// query param email__nic
		var qrEmailNic string

		if o.EmailNic != nil {
			qrEmailNic = *o.EmailNic
		}
		qEmailNic := qrEmailNic
		if qEmailNic != "" {

			if err := r.SetQueryParam("email__nic", qEmailNic); err != nil {
				return err
			}
		}
	}

	if o.EmailNie != nil {

		// query param email__nie
		var qrEmailNie string

		if o.EmailNie != nil {
			qrEmailNie = *o.EmailNie
		}
		qEmailNie := qrEmailNie
		if qEmailNie != "" {

			if err := r.SetQueryParam("email__nie", qEmailNie); err != nil {
				return err
			}
		}
	}

	if o.EmailNiew != nil {

		// query param email__niew
		var qrEmailNiew string

		if o.EmailNiew != nil {
			qrEmailNiew = *o.EmailNiew
		}
		qEmailNiew := qrEmailNiew
		if qEmailNiew != "" {

			if err := r.SetQueryParam("email__niew", qEmailNiew); err != nil {
				return err
			}
		}
	}

	if o.EmailNisw != nil {

		// query param email__nisw
		var qrEmailNisw string

		if o.EmailNisw != nil {
			qrEmailNisw = *o.EmailNisw
		}
		qEmailNisw := qrEmailNisw
		if qEmailNisw != "" {

			if err := r.SetQueryParam("email__nisw", qEmailNisw); err != nil {
				return err
			}
		}
	}

	if o.Group != nil {

		// query param group
		var qrGroup string

		if o.Group != nil {
			qrGroup = *o.Group
		}
		qGroup := qrGroup
		if qGroup != "" {

			if err := r.SetQueryParam("group", qGroup); err != nil {
				return err
			}
		}
	}

	if o.Groupn != nil {

		// query param group__n
		var qrGroupn string

		if o.Groupn != nil {
			qrGroupn = *o.Groupn
		}
		qGroupn := qrGroupn
		if qGroupn != "" {

			if err := r.SetQueryParam("group__n", qGroupn); err != nil {
				return err
			}
		}
	}

	if o.GroupID != nil {

		// query param group_id
		var qrGroupID string

		if o.GroupID != nil {
			qrGroupID = *o.GroupID
		}
		qGroupID := qrGroupID
		if qGroupID != "" {

			if err := r.SetQueryParam("group_id", qGroupID); err != nil {
				return err
			}
		}
	}

	if o.GroupIDn != nil {

		// query param group_id__n
		var qrGroupIDn string

		if o.GroupIDn != nil {
			qrGroupIDn = *o.GroupIDn
		}
		qGroupIDn := qrGroupIDn
		if qGroupIDn != "" {

			if err := r.SetQueryParam("group_id__n", qGroupIDn); err != nil {
				return err
			}
		}
	}

	if o.ID != nil {

		// query param id
		var qrID string

		if o.ID != nil {
			qrID = *o.ID
		}
		qID := qrID
		if qID != "" {

			if err := r.SetQueryParam("id", qID); err != nil {
				return err
			}
		}
	}

	if o.IDGt != nil {

		// query param id__gt
		var qrIDGt string

		if o.IDGt != nil {
			qrIDGt = *o.IDGt
		}
		qIDGt := qrIDGt
		if qIDGt != "" {

			if err := r.SetQueryParam("id__gt", qIDGt); err != nil {
				return err
			}
		}
	}

	if o.IDGte != nil {

		// query param id__gte
		var qrIDGte string

		if o.IDGte != nil {
			qrIDGte = *o.IDGte
		}
		qIDGte := qrIDGte
		if qIDGte != "" {

			if err := r.SetQueryParam("id__gte", qIDGte); err != nil {
				return err
			}
		}
	}

	if o.IDLt != nil {

		// query param id__lt
		var qrIDLt string

		if o.IDLt != nil {
			qrIDLt = *o.IDLt
		}
		qIDLt := qrIDLt
		if qIDLt != "" {

			if err := r.SetQueryParam("id__lt", qIDLt); err != nil {
				return err
			}
		}
	}

	if o.IDLte != nil {

		// query param id__lte
		var qrIDLte string

		if o.IDLte != nil {
			qrIDLte = *o.IDLte
		}
		qIDLte := qrIDLte
		if qIDLte != "" {

			if err := r.SetQueryParam("id__lte", qIDLte); err != nil {
				return err
			}
		}
	}

	if o.IDn != nil {

		// query param id__n
		var qrIDn string

		if o.IDn != nil {
			qrIDn = *o.IDn
		}
		qIDn := qrIDn
		if qIDn != "" {

			if err := r.SetQueryParam("id__n", qIDn); err != nil {
				return err
			}
		}
	}

	if o.LastUpdated != nil {

		// query param last_updated
		var qrLastUpdated string

		if o.LastUpdated != nil {
			qrLastUpdated = *o.LastUpdated
		}
		qLastUpdated := qrLastUpdated
		if qLastUpdated != "" {

			if err := r.SetQueryParam("last_updated", qLastUpdated); err != nil {
				return err
			}
		}
	}

	if o.LastUpdatedGte != nil {

		// query param last_updated__gte
		var qrLastUpdatedGte string

		if o.LastUpdatedGte != nil {
			qrLastUpdatedGte = *o.LastUpdatedGte
		}
		qLastUpdatedGte := qrLastUpdatedGte
		if qLastUpdatedGte != "" {

			if err := r.SetQueryParam("last_updated__gte", qLastUpdatedGte); err != nil {
				return err
			}
		}
	}

	if o.LastUpdatedLte != nil {

		// query param last_updated__lte
		var qrLastUpdatedLte string

		if o.LastUpdatedLte != nil {
			qrLastUpdatedLte = *o.LastUpdatedLte
		}
		qLastUpdatedLte := qrLastUpdatedLte
		if qLastUpdatedLte != "" {

			if err := r.SetQueryParam("last_updated__lte", qLastUpdatedLte); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Link != nil {

		// query param link
		var qrLink string

		if o.Link != nil {
			qrLink = *o.Link
		}
		qLink := qrLink
		if qLink != "" {

			if err := r.SetQueryParam("link", qLink); err != nil {
				return err
			}
		}
	}

	if o.LinkIc != nil {

		// query param link__ic
		var qrLinkIc string

		if o.LinkIc != nil {
			qrLinkIc = *o.LinkIc
		}
		qLinkIc := qrLinkIc
		if qLinkIc != "" {

			if err := r.SetQueryParam("link__ic", qLinkIc); err != nil {
				return err
			}
		}
	}

	if o.LinkIe != nil {

		// query param link__ie
		var qrLinkIe string

		if o.LinkIe != nil {
			qrLinkIe = *o.LinkIe
		}
		qLinkIe := qrLinkIe
		if qLinkIe != "" {

			if err := r.SetQueryParam("link__ie", qLinkIe); err != nil {
				return err
			}
		}
	}

	if o.LinkIew != nil {

		// query param link__iew
		var qrLinkIew string

		if o.LinkIew != nil {
			qrLinkIew = *o.LinkIew
		}
		qLinkIew := qrLinkIew
		if qLinkIew != "" {

			if err := r.SetQueryParam("link__iew", qLinkIew); err != nil {
				return err
			}
		}
	}

	if o.LinkIsw != nil {

		// query param link__isw
		var qrLinkIsw string

		if o.LinkIsw != nil {
			qrLinkIsw = *o.LinkIsw
		}
		qLinkIsw := qrLinkIsw
		if qLinkIsw != "" {

			if err := r.SetQueryParam("link__isw", qLinkIsw); err != nil {
				return err
			}
		}
	}

	if o.Linkn != nil {

		// query param link__n
		var qrLinkn string

		if o.Linkn != nil {
			qrLinkn = *o.Linkn
		}
		qLinkn := qrLinkn
		if qLinkn != "" {

			if err := r.SetQueryParam("link__n", qLinkn); err != nil {
				return err
			}
		}
	}

	if o.LinkNic != nil {

		// query param link__nic
		var qrLinkNic string

		if o.LinkNic != nil {
			qrLinkNic = *o.LinkNic
		}
		qLinkNic := qrLinkNic
		if qLinkNic != "" {

			if err := r.SetQueryParam("link__nic", qLinkNic); err != nil {
				return err
			}
		}
	}

	if o.LinkNie != nil {

		// query param link__nie
		var qrLinkNie string

		if o.LinkNie != nil {
			qrLinkNie = *o.LinkNie
		}
		qLinkNie := qrLinkNie
		if qLinkNie != "" {

			if err := r.SetQueryParam("link__nie", qLinkNie); err != nil {
				return err
			}
		}
	}

	if o.LinkNiew != nil {

		// query param link__niew
		var qrLinkNiew string

		if o.LinkNiew != nil {
			qrLinkNiew = *o.LinkNiew
		}
		qLinkNiew := qrLinkNiew
		if qLinkNiew != "" {

			if err := r.SetQueryParam("link__niew", qLinkNiew); err != nil {
				return err
			}
		}
	}

	if o.LinkNisw != nil {

		// query param link__nisw
		var qrLinkNisw string

		if o.LinkNisw != nil {
			qrLinkNisw = *o.LinkNisw
		}
		qLinkNisw := qrLinkNisw
		if qLinkNisw != "" {

			if err := r.SetQueryParam("link__nisw", qLinkNisw); err != nil {
				return err
			}
		}
	}

	if o.Name != nil {

		// query param name
		var qrName string

		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.NameIc != nil {

		// query param name__ic
		var qrNameIc string

		if o.NameIc != nil {
			qrNameIc = *o.NameIc
		}
		qNameIc := qrNameIc
		if qNameIc != "" {

			if err := r.SetQueryParam("name__ic", qNameIc); err != nil {
				return err
			}
		}
	}

	if o.NameIe != nil {

		// query param name__ie
		var qrNameIe string

		if o.NameIe != nil {
			qrNameIe = *o.NameIe
		}
		qNameIe := qrNameIe
		if qNameIe != "" {

			if err := r.SetQueryParam("name__ie", qNameIe); err != nil {
				return err
			}
		}
	}

	if o.NameIew != nil {

		// query param name__iew
		var qrNameIew string

		if o.NameIew != nil {
			qrNameIew = *o.NameIew
		}
		qNameIew := qrNameIew
		if qNameIew != "" {

			if err := r.SetQueryParam("name__iew", qNameIew); err != nil {
				return err
			}
		}
	}

	if o.NameIsw != nil {

		// query param name__isw
		var qrNameIsw string

		if o.NameIsw != nil {
			qrNameIsw = *o.NameIsw
		}
		qNameIsw := qrNameIsw
		if qNameIsw != "" {

			if err := r.SetQueryParam("name__isw", qNameIsw); err != nil {
				return err
			}
		}
	}

	if o.Namen != nil {

		// query param name__n
		var qrNamen string

		if o.Namen != nil {
			qrNamen = *o.Namen
		}
		qNamen := qrNamen
		if qNamen != "" {

			if err := r.SetQueryParam("name__n", qNamen); err != nil {
				return err
			}
		}
	}

	if o.NameNic != nil {

		// query param name__nic
		var qrNameNic string

		if o.NameNic != nil {
			qrNameNic = *o.NameNic
		}
		qNameNic := qrNameNic
		if qNameNic != "" {

			if err := r.SetQueryParam("name__nic", qNameNic); err != nil {
				return err
			}
		}
	}

	if o.NameNie != nil {

		// query param name__nie
		var qrNameNie string

		if o.NameNie != nil {
			qrNameNie = *o.NameNie
		}
		qNameNie := qrNameNie
		if qNameNie != "" {

			if err := r.SetQueryParam("name__nie", qNameNie); err != nil {
				return err
			}
		}
	}

	if o.NameNiew != nil {

		// query param name__niew
		var qrNameNiew string

		if o.NameNiew != nil {
			qrNameNiew = *o.NameNiew
		}
		qNameNiew := qrNameNiew
		if qNameNiew != "" {

			if err := r.SetQueryParam("name__niew", qNameNiew); err != nil {
				return err
			}
		}
	}

	if o.NameNisw != nil {

		// query param name__nisw
		var qrNameNisw string

		if o.NameNisw != nil {
			qrNameNisw = *o.NameNisw
		}
		qNameNisw := qrNameNisw
		if qNameNisw != "" {

			if err := r.SetQueryParam("name__nisw", qNameNisw); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if o.Phone != nil {

		// query param phone
		var qrPhone string

		if o.Phone != nil {
			qrPhone = *o.Phone
		}
		qPhone := qrPhone
		if qPhone != "" {

			if err := r.SetQueryParam("phone", qPhone); err != nil {
				return err
			}
		}
	}

	if o.PhoneIc != nil {

		// query param phone__ic
		var qrPhoneIc string

		if o.PhoneIc != nil {
			qrPhoneIc = *o.PhoneIc
		}
		qPhoneIc := qrPhoneIc
		if qPhoneIc != "" {

			if err := r.SetQueryParam("phone__ic", qPhoneIc); err != nil {
				return err
			}
		}
	}

	if o.PhoneIe != nil {

		// query param phone__ie
		var qrPhoneIe string

		if o.PhoneIe != nil {
			qrPhoneIe = *o.PhoneIe
		}
		qPhoneIe := qrPhoneIe
		if qPhoneIe != "" {

			if err := r.SetQueryParam("phone__ie", qPhoneIe); err != nil {
				return err
			}
		}
	}

	if o.PhoneIew != nil {

		// query param phone__iew
		var qrPhoneIew string

		if o.PhoneIew != nil {
			qrPhoneIew = *o.PhoneIew
		}
		qPhoneIew := qrPhoneIew
		if qPhoneIew != "" {

			if err := r.SetQueryParam("phone__iew", qPhoneIew); err != nil {
				return err
			}
		}
	}

	if o.PhoneIsw != nil {

		// query param phone__isw
		var qrPhoneIsw string

		if o.PhoneIsw != nil {
			qrPhoneIsw = *o.PhoneIsw
		}
		qPhoneIsw := qrPhoneIsw
		if qPhoneIsw != "" {

			if err := r.SetQueryParam("phone__isw", qPhoneIsw); err != nil {
				return err
			}
		}
	}

	if o.Phonen != nil {

		// query param phone__n
		var qrPhonen string

		if o.Phonen != nil {
			qrPhonen = *o.Phonen
		}
		qPhonen := qrPhonen
		if qPhonen != "" {

			if err := r.SetQueryParam("phone__n", qPhonen); err != nil {
				return err
			}
		}
	}

	if o.PhoneNic != nil {

		// query param phone__nic
		var qrPhoneNic string

		if o.PhoneNic != nil {
			qrPhoneNic = *o.PhoneNic
		}
		qPhoneNic := qrPhoneNic
		if qPhoneNic != "" {

			if err := r.SetQueryParam("phone__nic", qPhoneNic); err != nil {
				return err
			}
		}
	}

	if o.PhoneNie != nil {

		// query param phone__nie
		var qrPhoneNie string

		if o.PhoneNie != nil {
			qrPhoneNie = *o.PhoneNie
		}
		qPhoneNie := qrPhoneNie
		if qPhoneNie != "" {

			if err := r.SetQueryParam("phone__nie", qPhoneNie); err != nil {
				return err
			}
		}
	}

	if o.PhoneNiew != nil {

		// query param phone__niew
		var qrPhoneNiew string

		if o.PhoneNiew != nil {
			qrPhoneNiew = *o.PhoneNiew
		}
		qPhoneNiew := qrPhoneNiew
		if qPhoneNiew != "" {

			if err := r.SetQueryParam("phone__niew", qPhoneNiew); err != nil {
				return err
			}
		}
	}

	if o.PhoneNisw != nil {

		// query param phone__nisw
		var qrPhoneNisw string

		if o.PhoneNisw != nil {
			qrPhoneNisw = *o.PhoneNisw
		}
		qPhoneNisw := qrPhoneNisw
		if qPhoneNisw != "" {

			if err := r.SetQueryParam("phone__nisw", qPhoneNisw); err != nil {
				return err
			}
		}
	}

	if o.Q != nil {

		// query param q
		var qrQ string

		if o.Q != nil {
			qrQ = *o.Q
		}
		qQ := qrQ
		if qQ != "" {

			if err := r.SetQueryParam("q", qQ); err != nil {
				return err
			}
		}
	}

	if o.Tag != nil {

		// query param tag
		var qrTag string

		if o.Tag != nil {
			qrTag = *o.Tag
		}
		qTag := qrTag
		if qTag != "" {

			if err := r.SetQueryParam("tag", qTag); err != nil {
				return err
			}
		}
	}

	if o.Tagn != nil {

		// query param tag__n
		var qrTagn string

		if o.Tagn != nil {
			qrTagn = *o.Tagn
		}
		qTagn := qrTagn
		if qTagn != "" {

			if err := r.SetQueryParam("tag__n", qTagn); err != nil {
				return err
			}
		}
	}

	if o.Title != nil {

		// query param title
		var qrTitle string

		if o.Title != nil {
			qrTitle = *o.Title
		}
		qTitle := qrTitle
		if qTitle != "" {

			if err := r.SetQueryParam("title", qTitle); err != nil {
				return err
			}
		}
	}

	if o.TitleIc != nil {

		// query param title__ic
		var qrTitleIc string

		if o.TitleIc != nil {
			qrTitleIc = *o.TitleIc
		}
		qTitleIc := qrTitleIc
		if qTitleIc != "" {

			if err := r.SetQueryParam("title__ic", qTitleIc); err != nil {
				return err
			}
		}
	}

	if o.TitleIe != nil {

		// query param title__ie
		var qrTitleIe string

		if o.TitleIe != nil {
			qrTitleIe = *o.TitleIe
		}
		qTitleIe := qrTitleIe
		if qTitleIe != "" {

			if err := r.SetQueryParam("title__ie", qTitleIe); err != nil {
				return err
			}
		}
	}

	if o.TitleIew != nil {

		// query param title__iew
		var qrTitleIew string

		if o.TitleIew != nil {
			qrTitleIew = *o.TitleIew
		}
		qTitleIew := qrTitleIew
		if qTitleIew != "" {

			if err := r.SetQueryParam("title__iew", qTitleIew); err != nil {
				return err
			}
		}
	}

	if o.TitleIsw != nil {

		// query param title__isw
		var qrTitleIsw string

		if o.TitleIsw != nil {
			qrTitleIsw = *o.TitleIsw
		}
		qTitleIsw := qrTitleIsw
		if qTitleIsw != "" {

			if err := r.SetQueryParam("title__isw", qTitleIsw); err != nil {
				return err
			}
		}
	}

	if o.Titlen != nil {

		// query param title__n
		var qrTitlen string

		if o.Titlen != nil {
			qrTitlen = *o.Titlen
		}
		qTitlen := qrTitlen
		if qTitlen != "" {

			if err := r.SetQueryParam("title__n", qTitlen); err != nil {
				return err
			}
		}
	}

	if o.TitleNic != nil {

		// query param title__nic
		var qrTitleNic string

		if o.TitleNic != nil {
			qrTitleNic = *o.TitleNic
		}
		qTitleNic := qrTitleNic
		if qTitleNic != "" {

			if err := r.SetQueryParam("title__nic", qTitleNic); err != nil {
				return err
			}
		}
	}

	if o.TitleNie != nil {

		// query param title__nie
		var qrTitleNie string

		if o.TitleNie != nil {
			qrTitleNie = *o.TitleNie
		}
		qTitleNie := qrTitleNie
		if qTitleNie != "" {

			if err := r.SetQueryParam("title__nie", qTitleNie); err != nil {
				return err
			}
		}
	}

	if o.TitleNiew != nil {

		// query param title__niew
		var qrTitleNiew string

		if o.TitleNiew != nil {
			qrTitleNiew = *o.TitleNiew
		}
		qTitleNiew := qrTitleNiew
		if qTitleNiew != "" {

			if err := r.SetQueryParam("title__niew", qTitleNiew); err != nil {
				return err
			}
		}
	}

	if o.TitleNisw != nil {

		// query param title__nisw
		var qrTitleNisw string

		if o.TitleNisw != nil {
			qrTitleNisw = *o.TitleNisw
		}
		qTitleNisw := qrTitleNisw
		if qTitleNisw != "" {

			if err := r.SetQueryParam("title__nisw", qTitleNisw); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
