// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2020 The go-netbox Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package virtualization

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewVirtualizationInterfacesListParams creates a new VirtualizationInterfacesListParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewVirtualizationInterfacesListParams() *VirtualizationInterfacesListParams {
	return &VirtualizationInterfacesListParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewVirtualizationInterfacesListParamsWithTimeout creates a new VirtualizationInterfacesListParams object
// with the ability to set a timeout on a request.
func NewVirtualizationInterfacesListParamsWithTimeout(timeout time.Duration) *VirtualizationInterfacesListParams {
	return &VirtualizationInterfacesListParams{
		timeout: timeout,
	}
}

// NewVirtualizationInterfacesListParamsWithContext creates a new VirtualizationInterfacesListParams object
// with the ability to set a context for a request.
func NewVirtualizationInterfacesListParamsWithContext(ctx context.Context) *VirtualizationInterfacesListParams {
	return &VirtualizationInterfacesListParams{
		Context: ctx,
	}
}

// NewVirtualizationInterfacesListParamsWithHTTPClient creates a new VirtualizationInterfacesListParams object
// with the ability to set a custom HTTPClient for a request.
func NewVirtualizationInterfacesListParamsWithHTTPClient(client *http.Client) *VirtualizationInterfacesListParams {
	return &VirtualizationInterfacesListParams{
		HTTPClient: client,
	}
}

/* VirtualizationInterfacesListParams contains all the parameters to send to the API endpoint
   for the virtualization interfaces list operation.

   Typically these are written to a http.Request.
*/
type VirtualizationInterfacesListParams struct {

	// BridgeID.
	BridgeID *string

	// BridgeIDn.
	BridgeIDn *string

	// Cluster.
	Cluster *string

	// Clustern.
	Clustern *string

	// ClusterID.
	ClusterID *string

	// ClusterIDn.
	ClusterIDn *string

	// Created.
	Created *string

	// CreatedGte.
	CreatedGte *string

	// CreatedLte.
	CreatedLte *string

	// Description.
	Description *string

	// DescriptionIc.
	DescriptionIc *string

	// DescriptionIe.
	DescriptionIe *string

	// DescriptionIew.
	DescriptionIew *string

	// DescriptionIsw.
	DescriptionIsw *string

	// Descriptionn.
	Descriptionn *string

	// DescriptionNic.
	DescriptionNic *string

	// DescriptionNie.
	DescriptionNie *string

	// DescriptionNiew.
	DescriptionNiew *string

	// DescriptionNisw.
	DescriptionNisw *string

	// Enabled.
	Enabled *string

	// ID.
	ID *string

	// IDGt.
	IDGt *string

	// IDGte.
	IDGte *string

	// IDLt.
	IDLt *string

	// IDLte.
	IDLte *string

	// IDn.
	IDn *string

	// LastUpdated.
	LastUpdated *string

	// LastUpdatedGte.
	LastUpdatedGte *string

	// LastUpdatedLte.
	LastUpdatedLte *string

	/* Limit.

	   Number of results to return per page.
	*/
	Limit *int64

	// MacAddress.
	MacAddress *string

	// MacAddressIc.
	MacAddressIc *string

	// MacAddressIe.
	MacAddressIe *string

	// MacAddressIew.
	MacAddressIew *string

	// MacAddressIsw.
	MacAddressIsw *string

	// MacAddressn.
	MacAddressn *string

	// MacAddressNic.
	MacAddressNic *string

	// MacAddressNie.
	MacAddressNie *string

	// MacAddressNiew.
	MacAddressNiew *string

	// MacAddressNisw.
	MacAddressNisw *string

	// Mtu.
	Mtu *string

	// MtuGt.
	MtuGt *string

	// MtuGte.
	MtuGte *string

	// MtuLt.
	MtuLt *string

	// MtuLte.
	MtuLte *string

	// Mtun.
	Mtun *string

	// Name.
	Name *string

	// NameIc.
	NameIc *string

	// NameIe.
	NameIe *string

	// NameIew.
	NameIew *string

	// NameIsw.
	NameIsw *string

	// Namen.
	Namen *string

	// NameNic.
	NameNic *string

	// NameNie.
	NameNie *string

	// NameNiew.
	NameNiew *string

	// NameNisw.
	NameNisw *string

	/* Offset.

	   The initial index from which to return the results.
	*/
	Offset *int64

	// ParentID.
	ParentID *string

	// ParentIDn.
	ParentIDn *string

	// Q.
	Q *string

	// Tag.
	Tag *string

	// Tagn.
	Tagn *string

	// VirtualMachine.
	VirtualMachine *string

	// VirtualMachinen.
	VirtualMachinen *string

	// VirtualMachineID.
	VirtualMachineID *string

	// VirtualMachineIDn.
	VirtualMachineIDn *string

	// Vrf.
	Vrf *string

	// Vrfn.
	Vrfn *string

	// VrfID.
	VrfID *string

	// VrfIDn.
	VrfIDn *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the virtualization interfaces list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *VirtualizationInterfacesListParams) WithDefaults() *VirtualizationInterfacesListParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the virtualization interfaces list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *VirtualizationInterfacesListParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithTimeout(timeout time.Duration) *VirtualizationInterfacesListParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithContext(ctx context.Context) *VirtualizationInterfacesListParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithHTTPClient(client *http.Client) *VirtualizationInterfacesListParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBridgeID adds the bridgeID to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithBridgeID(bridgeID *string) *VirtualizationInterfacesListParams {
	o.SetBridgeID(bridgeID)
	return o
}

// SetBridgeID adds the bridgeId to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetBridgeID(bridgeID *string) {
	o.BridgeID = bridgeID
}

// WithBridgeIDn adds the bridgeIDn to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithBridgeIDn(bridgeIDn *string) *VirtualizationInterfacesListParams {
	o.SetBridgeIDn(bridgeIDn)
	return o
}

// SetBridgeIDn adds the bridgeIdN to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetBridgeIDn(bridgeIDn *string) {
	o.BridgeIDn = bridgeIDn
}

// WithCluster adds the cluster to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithCluster(cluster *string) *VirtualizationInterfacesListParams {
	o.SetCluster(cluster)
	return o
}

// SetCluster adds the cluster to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetCluster(cluster *string) {
	o.Cluster = cluster
}

// WithClustern adds the clustern to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithClustern(clustern *string) *VirtualizationInterfacesListParams {
	o.SetClustern(clustern)
	return o
}

// SetClustern adds the clusterN to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetClustern(clustern *string) {
	o.Clustern = clustern
}

// WithClusterID adds the clusterID to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithClusterID(clusterID *string) *VirtualizationInterfacesListParams {
	o.SetClusterID(clusterID)
	return o
}

// SetClusterID adds the clusterId to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetClusterID(clusterID *string) {
	o.ClusterID = clusterID
}

// WithClusterIDn adds the clusterIDn to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithClusterIDn(clusterIDn *string) *VirtualizationInterfacesListParams {
	o.SetClusterIDn(clusterIDn)
	return o
}

// SetClusterIDn adds the clusterIdN to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetClusterIDn(clusterIDn *string) {
	o.ClusterIDn = clusterIDn
}

// WithCreated adds the created to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithCreated(created *string) *VirtualizationInterfacesListParams {
	o.SetCreated(created)
	return o
}

// SetCreated adds the created to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetCreated(created *string) {
	o.Created = created
}

// WithCreatedGte adds the createdGte to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithCreatedGte(createdGte *string) *VirtualizationInterfacesListParams {
	o.SetCreatedGte(createdGte)
	return o
}

// SetCreatedGte adds the createdGte to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetCreatedGte(createdGte *string) {
	o.CreatedGte = createdGte
}

// WithCreatedLte adds the createdLte to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithCreatedLte(createdLte *string) *VirtualizationInterfacesListParams {
	o.SetCreatedLte(createdLte)
	return o
}

// SetCreatedLte adds the createdLte to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetCreatedLte(createdLte *string) {
	o.CreatedLte = createdLte
}

// WithDescription adds the description to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithDescription(description *string) *VirtualizationInterfacesListParams {
	o.SetDescription(description)
	return o
}

// SetDescription adds the description to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetDescription(description *string) {
	o.Description = description
}

// WithDescriptionIc adds the descriptionIc to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithDescriptionIc(descriptionIc *string) *VirtualizationInterfacesListParams {
	o.SetDescriptionIc(descriptionIc)
	return o
}

// SetDescriptionIc adds the descriptionIc to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetDescriptionIc(descriptionIc *string) {
	o.DescriptionIc = descriptionIc
}

// WithDescriptionIe adds the descriptionIe to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithDescriptionIe(descriptionIe *string) *VirtualizationInterfacesListParams {
	o.SetDescriptionIe(descriptionIe)
	return o
}

// SetDescriptionIe adds the descriptionIe to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetDescriptionIe(descriptionIe *string) {
	o.DescriptionIe = descriptionIe
}

// WithDescriptionIew adds the descriptionIew to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithDescriptionIew(descriptionIew *string) *VirtualizationInterfacesListParams {
	o.SetDescriptionIew(descriptionIew)
	return o
}

// SetDescriptionIew adds the descriptionIew to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetDescriptionIew(descriptionIew *string) {
	o.DescriptionIew = descriptionIew
}

// WithDescriptionIsw adds the descriptionIsw to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithDescriptionIsw(descriptionIsw *string) *VirtualizationInterfacesListParams {
	o.SetDescriptionIsw(descriptionIsw)
	return o
}

// SetDescriptionIsw adds the descriptionIsw to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetDescriptionIsw(descriptionIsw *string) {
	o.DescriptionIsw = descriptionIsw
}

// WithDescriptionn adds the descriptionn to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithDescriptionn(descriptionn *string) *VirtualizationInterfacesListParams {
	o.SetDescriptionn(descriptionn)
	return o
}

// SetDescriptionn adds the descriptionN to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetDescriptionn(descriptionn *string) {
	o.Descriptionn = descriptionn
}

// WithDescriptionNic adds the descriptionNic to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithDescriptionNic(descriptionNic *string) *VirtualizationInterfacesListParams {
	o.SetDescriptionNic(descriptionNic)
	return o
}

// SetDescriptionNic adds the descriptionNic to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetDescriptionNic(descriptionNic *string) {
	o.DescriptionNic = descriptionNic
}

// WithDescriptionNie adds the descriptionNie to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithDescriptionNie(descriptionNie *string) *VirtualizationInterfacesListParams {
	o.SetDescriptionNie(descriptionNie)
	return o
}

// SetDescriptionNie adds the descriptionNie to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetDescriptionNie(descriptionNie *string) {
	o.DescriptionNie = descriptionNie
}

// WithDescriptionNiew adds the descriptionNiew to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithDescriptionNiew(descriptionNiew *string) *VirtualizationInterfacesListParams {
	o.SetDescriptionNiew(descriptionNiew)
	return o
}

// SetDescriptionNiew adds the descriptionNiew to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetDescriptionNiew(descriptionNiew *string) {
	o.DescriptionNiew = descriptionNiew
}

// WithDescriptionNisw adds the descriptionNisw to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithDescriptionNisw(descriptionNisw *string) *VirtualizationInterfacesListParams {
	o.SetDescriptionNisw(descriptionNisw)
	return o
}

// SetDescriptionNisw adds the descriptionNisw to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetDescriptionNisw(descriptionNisw *string) {
	o.DescriptionNisw = descriptionNisw
}

// WithEnabled adds the enabled to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithEnabled(enabled *string) *VirtualizationInterfacesListParams {
	o.SetEnabled(enabled)
	return o
}

// SetEnabled adds the enabled to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetEnabled(enabled *string) {
	o.Enabled = enabled
}

// WithID adds the id to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithID(id *string) *VirtualizationInterfacesListParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetID(id *string) {
	o.ID = id
}

// WithIDGt adds the iDGt to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithIDGt(iDGt *string) *VirtualizationInterfacesListParams {
	o.SetIDGt(iDGt)
	return o
}

// SetIDGt adds the idGt to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetIDGt(iDGt *string) {
	o.IDGt = iDGt
}

// WithIDGte adds the iDGte to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithIDGte(iDGte *string) *VirtualizationInterfacesListParams {
	o.SetIDGte(iDGte)
	return o
}

// SetIDGte adds the idGte to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetIDGte(iDGte *string) {
	o.IDGte = iDGte
}

// WithIDLt adds the iDLt to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithIDLt(iDLt *string) *VirtualizationInterfacesListParams {
	o.SetIDLt(iDLt)
	return o
}

// SetIDLt adds the idLt to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetIDLt(iDLt *string) {
	o.IDLt = iDLt
}

// WithIDLte adds the iDLte to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithIDLte(iDLte *string) *VirtualizationInterfacesListParams {
	o.SetIDLte(iDLte)
	return o
}

// SetIDLte adds the idLte to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetIDLte(iDLte *string) {
	o.IDLte = iDLte
}

// WithIDn adds the iDn to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithIDn(iDn *string) *VirtualizationInterfacesListParams {
	o.SetIDn(iDn)
	return o
}

// SetIDn adds the idN to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetIDn(iDn *string) {
	o.IDn = iDn
}

// WithLastUpdated adds the lastUpdated to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithLastUpdated(lastUpdated *string) *VirtualizationInterfacesListParams {
	o.SetLastUpdated(lastUpdated)
	return o
}

// SetLastUpdated adds the lastUpdated to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetLastUpdated(lastUpdated *string) {
	o.LastUpdated = lastUpdated
}

// WithLastUpdatedGte adds the lastUpdatedGte to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithLastUpdatedGte(lastUpdatedGte *string) *VirtualizationInterfacesListParams {
	o.SetLastUpdatedGte(lastUpdatedGte)
	return o
}

// SetLastUpdatedGte adds the lastUpdatedGte to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetLastUpdatedGte(lastUpdatedGte *string) {
	o.LastUpdatedGte = lastUpdatedGte
}

// WithLastUpdatedLte adds the lastUpdatedLte to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithLastUpdatedLte(lastUpdatedLte *string) *VirtualizationInterfacesListParams {
	o.SetLastUpdatedLte(lastUpdatedLte)
	return o
}

// SetLastUpdatedLte adds the lastUpdatedLte to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetLastUpdatedLte(lastUpdatedLte *string) {
	o.LastUpdatedLte = lastUpdatedLte
}

// WithLimit adds the limit to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithLimit(limit *int64) *VirtualizationInterfacesListParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithMacAddress adds the macAddress to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithMacAddress(macAddress *string) *VirtualizationInterfacesListParams {
	o.SetMacAddress(macAddress)
	return o
}

// SetMacAddress adds the macAddress to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetMacAddress(macAddress *string) {
	o.MacAddress = macAddress
}

// WithMacAddressIc adds the macAddressIc to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithMacAddressIc(macAddressIc *string) *VirtualizationInterfacesListParams {
	o.SetMacAddressIc(macAddressIc)
	return o
}

// SetMacAddressIc adds the macAddressIc to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetMacAddressIc(macAddressIc *string) {
	o.MacAddressIc = macAddressIc
}

// WithMacAddressIe adds the macAddressIe to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithMacAddressIe(macAddressIe *string) *VirtualizationInterfacesListParams {
	o.SetMacAddressIe(macAddressIe)
	return o
}

// SetMacAddressIe adds the macAddressIe to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetMacAddressIe(macAddressIe *string) {
	o.MacAddressIe = macAddressIe
}

// WithMacAddressIew adds the macAddressIew to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithMacAddressIew(macAddressIew *string) *VirtualizationInterfacesListParams {
	o.SetMacAddressIew(macAddressIew)
	return o
}

// SetMacAddressIew adds the macAddressIew to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetMacAddressIew(macAddressIew *string) {
	o.MacAddressIew = macAddressIew
}

// WithMacAddressIsw adds the macAddressIsw to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithMacAddressIsw(macAddressIsw *string) *VirtualizationInterfacesListParams {
	o.SetMacAddressIsw(macAddressIsw)
	return o
}

// SetMacAddressIsw adds the macAddressIsw to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetMacAddressIsw(macAddressIsw *string) {
	o.MacAddressIsw = macAddressIsw
}

// WithMacAddressn adds the macAddressn to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithMacAddressn(macAddressn *string) *VirtualizationInterfacesListParams {
	o.SetMacAddressn(macAddressn)
	return o
}

// SetMacAddressn adds the macAddressN to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetMacAddressn(macAddressn *string) {
	o.MacAddressn = macAddressn
}

// WithMacAddressNic adds the macAddressNic to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithMacAddressNic(macAddressNic *string) *VirtualizationInterfacesListParams {
	o.SetMacAddressNic(macAddressNic)
	return o
}

// SetMacAddressNic adds the macAddressNic to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetMacAddressNic(macAddressNic *string) {
	o.MacAddressNic = macAddressNic
}

// WithMacAddressNie adds the macAddressNie to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithMacAddressNie(macAddressNie *string) *VirtualizationInterfacesListParams {
	o.SetMacAddressNie(macAddressNie)
	return o
}

// SetMacAddressNie adds the macAddressNie to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetMacAddressNie(macAddressNie *string) {
	o.MacAddressNie = macAddressNie
}

// WithMacAddressNiew adds the macAddressNiew to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithMacAddressNiew(macAddressNiew *string) *VirtualizationInterfacesListParams {
	o.SetMacAddressNiew(macAddressNiew)
	return o
}

// SetMacAddressNiew adds the macAddressNiew to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetMacAddressNiew(macAddressNiew *string) {
	o.MacAddressNiew = macAddressNiew
}

// WithMacAddressNisw adds the macAddressNisw to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithMacAddressNisw(macAddressNisw *string) *VirtualizationInterfacesListParams {
	o.SetMacAddressNisw(macAddressNisw)
	return o
}

// SetMacAddressNisw adds the macAddressNisw to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetMacAddressNisw(macAddressNisw *string) {
	o.MacAddressNisw = macAddressNisw
}

// WithMtu adds the mtu to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithMtu(mtu *string) *VirtualizationInterfacesListParams {
	o.SetMtu(mtu)
	return o
}

// SetMtu adds the mtu to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetMtu(mtu *string) {
	o.Mtu = mtu
}

// WithMtuGt adds the mtuGt to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithMtuGt(mtuGt *string) *VirtualizationInterfacesListParams {
	o.SetMtuGt(mtuGt)
	return o
}

// SetMtuGt adds the mtuGt to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetMtuGt(mtuGt *string) {
	o.MtuGt = mtuGt
}

// WithMtuGte adds the mtuGte to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithMtuGte(mtuGte *string) *VirtualizationInterfacesListParams {
	o.SetMtuGte(mtuGte)
	return o
}

// SetMtuGte adds the mtuGte to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetMtuGte(mtuGte *string) {
	o.MtuGte = mtuGte
}

// WithMtuLt adds the mtuLt to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithMtuLt(mtuLt *string) *VirtualizationInterfacesListParams {
	o.SetMtuLt(mtuLt)
	return o
}

// SetMtuLt adds the mtuLt to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetMtuLt(mtuLt *string) {
	o.MtuLt = mtuLt
}

// WithMtuLte adds the mtuLte to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithMtuLte(mtuLte *string) *VirtualizationInterfacesListParams {
	o.SetMtuLte(mtuLte)
	return o
}

// SetMtuLte adds the mtuLte to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetMtuLte(mtuLte *string) {
	o.MtuLte = mtuLte
}

// WithMtun adds the mtun to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithMtun(mtun *string) *VirtualizationInterfacesListParams {
	o.SetMtun(mtun)
	return o
}

// SetMtun adds the mtuN to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetMtun(mtun *string) {
	o.Mtun = mtun
}

// WithName adds the name to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithName(name *string) *VirtualizationInterfacesListParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetName(name *string) {
	o.Name = name
}

// WithNameIc adds the nameIc to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithNameIc(nameIc *string) *VirtualizationInterfacesListParams {
	o.SetNameIc(nameIc)
	return o
}

// SetNameIc adds the nameIc to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetNameIc(nameIc *string) {
	o.NameIc = nameIc
}

// WithNameIe adds the nameIe to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithNameIe(nameIe *string) *VirtualizationInterfacesListParams {
	o.SetNameIe(nameIe)
	return o
}

// SetNameIe adds the nameIe to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetNameIe(nameIe *string) {
	o.NameIe = nameIe
}

// WithNameIew adds the nameIew to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithNameIew(nameIew *string) *VirtualizationInterfacesListParams {
	o.SetNameIew(nameIew)
	return o
}

// SetNameIew adds the nameIew to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetNameIew(nameIew *string) {
	o.NameIew = nameIew
}

// WithNameIsw adds the nameIsw to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithNameIsw(nameIsw *string) *VirtualizationInterfacesListParams {
	o.SetNameIsw(nameIsw)
	return o
}

// SetNameIsw adds the nameIsw to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetNameIsw(nameIsw *string) {
	o.NameIsw = nameIsw
}

// WithNamen adds the namen to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithNamen(namen *string) *VirtualizationInterfacesListParams {
	o.SetNamen(namen)
	return o
}

// SetNamen adds the nameN to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetNamen(namen *string) {
	o.Namen = namen
}

// WithNameNic adds the nameNic to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithNameNic(nameNic *string) *VirtualizationInterfacesListParams {
	o.SetNameNic(nameNic)
	return o
}

// SetNameNic adds the nameNic to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetNameNic(nameNic *string) {
	o.NameNic = nameNic
}

// WithNameNie adds the nameNie to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithNameNie(nameNie *string) *VirtualizationInterfacesListParams {
	o.SetNameNie(nameNie)
	return o
}

// SetNameNie adds the nameNie to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetNameNie(nameNie *string) {
	o.NameNie = nameNie
}

// WithNameNiew adds the nameNiew to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithNameNiew(nameNiew *string) *VirtualizationInterfacesListParams {
	o.SetNameNiew(nameNiew)
	return o
}

// SetNameNiew adds the nameNiew to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetNameNiew(nameNiew *string) {
	o.NameNiew = nameNiew
}

// WithNameNisw adds the nameNisw to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithNameNisw(nameNisw *string) *VirtualizationInterfacesListParams {
	o.SetNameNisw(nameNisw)
	return o
}

// SetNameNisw adds the nameNisw to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetNameNisw(nameNisw *string) {
	o.NameNisw = nameNisw
}

// WithOffset adds the offset to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithOffset(offset *int64) *VirtualizationInterfacesListParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithParentID adds the parentID to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithParentID(parentID *string) *VirtualizationInterfacesListParams {
	o.SetParentID(parentID)
	return o
}

// SetParentID adds the parentId to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetParentID(parentID *string) {
	o.ParentID = parentID
}

// WithParentIDn adds the parentIDn to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithParentIDn(parentIDn *string) *VirtualizationInterfacesListParams {
	o.SetParentIDn(parentIDn)
	return o
}

// SetParentIDn adds the parentIdN to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetParentIDn(parentIDn *string) {
	o.ParentIDn = parentIDn
}

// WithQ adds the q to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithQ(q *string) *VirtualizationInterfacesListParams {
	o.SetQ(q)
	return o
}

// SetQ adds the q to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetQ(q *string) {
	o.Q = q
}

// WithTag adds the tag to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithTag(tag *string) *VirtualizationInterfacesListParams {
	o.SetTag(tag)
	return o
}

// SetTag adds the tag to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetTag(tag *string) {
	o.Tag = tag
}

// WithTagn adds the tagn to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithTagn(tagn *string) *VirtualizationInterfacesListParams {
	o.SetTagn(tagn)
	return o
}

// SetTagn adds the tagN to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetTagn(tagn *string) {
	o.Tagn = tagn
}

// WithVirtualMachine adds the virtualMachine to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithVirtualMachine(virtualMachine *string) *VirtualizationInterfacesListParams {
	o.SetVirtualMachine(virtualMachine)
	return o
}

// SetVirtualMachine adds the virtualMachine to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetVirtualMachine(virtualMachine *string) {
	o.VirtualMachine = virtualMachine
}

// WithVirtualMachinen adds the virtualMachinen to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithVirtualMachinen(virtualMachinen *string) *VirtualizationInterfacesListParams {
	o.SetVirtualMachinen(virtualMachinen)
	return o
}

// SetVirtualMachinen adds the virtualMachineN to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetVirtualMachinen(virtualMachinen *string) {
	o.VirtualMachinen = virtualMachinen
}

// WithVirtualMachineID adds the virtualMachineID to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithVirtualMachineID(virtualMachineID *string) *VirtualizationInterfacesListParams {
	o.SetVirtualMachineID(virtualMachineID)
	return o
}

// SetVirtualMachineID adds the virtualMachineId to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetVirtualMachineID(virtualMachineID *string) {
	o.VirtualMachineID = virtualMachineID
}

// WithVirtualMachineIDn adds the virtualMachineIDn to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithVirtualMachineIDn(virtualMachineIDn *string) *VirtualizationInterfacesListParams {
	o.SetVirtualMachineIDn(virtualMachineIDn)
	return o
}

// SetVirtualMachineIDn adds the virtualMachineIdN to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetVirtualMachineIDn(virtualMachineIDn *string) {
	o.VirtualMachineIDn = virtualMachineIDn
}

// WithVrf adds the vrf to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithVrf(vrf *string) *VirtualizationInterfacesListParams {
	o.SetVrf(vrf)
	return o
}

// SetVrf adds the vrf to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetVrf(vrf *string) {
	o.Vrf = vrf
}

// WithVrfn adds the vrfn to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithVrfn(vrfn *string) *VirtualizationInterfacesListParams {
	o.SetVrfn(vrfn)
	return o
}

// SetVrfn adds the vrfN to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetVrfn(vrfn *string) {
	o.Vrfn = vrfn
}

// WithVrfID adds the vrfID to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithVrfID(vrfID *string) *VirtualizationInterfacesListParams {
	o.SetVrfID(vrfID)
	return o
}

// SetVrfID adds the vrfId to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetVrfID(vrfID *string) {
	o.VrfID = vrfID
}

// WithVrfIDn adds the vrfIDn to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) WithVrfIDn(vrfIDn *string) *VirtualizationInterfacesListParams {
	o.SetVrfIDn(vrfIDn)
	return o
}

// SetVrfIDn adds the vrfIdN to the virtualization interfaces list params
func (o *VirtualizationInterfacesListParams) SetVrfIDn(vrfIDn *string) {
	o.VrfIDn = vrfIDn
}

// WriteToRequest writes these params to a swagger request
func (o *VirtualizationInterfacesListParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.BridgeID != nil {

		// query param bridge_id
		var qrBridgeID string

		if o.BridgeID != nil {
			qrBridgeID = *o.BridgeID
		}
		qBridgeID := qrBridgeID
		if qBridgeID != "" {

			if err := r.SetQueryParam("bridge_id", qBridgeID); err != nil {
				return err
			}
		}
	}

	if o.BridgeIDn != nil {

		// query param bridge_id__n
		var qrBridgeIDn string

		if o.BridgeIDn != nil {
			qrBridgeIDn = *o.BridgeIDn
		}
		qBridgeIDn := qrBridgeIDn
		if qBridgeIDn != "" {

			if err := r.SetQueryParam("bridge_id__n", qBridgeIDn); err != nil {
				return err
			}
		}
	}

	if o.Cluster != nil {

		// query param cluster
		var qrCluster string

		if o.Cluster != nil {
			qrCluster = *o.Cluster
		}
		qCluster := qrCluster
		if qCluster != "" {

			if err := r.SetQueryParam("cluster", qCluster); err != nil {
				return err
			}
		}
	}

	if o.Clustern != nil {

		// query param cluster__n
		var qrClustern string

		if o.Clustern != nil {
			qrClustern = *o.Clustern
		}
		qClustern := qrClustern
		if qClustern != "" {

			if err := r.SetQueryParam("cluster__n", qClustern); err != nil {
				return err
			}
		}
	}

	if o.ClusterID != nil {

		// query param cluster_id
		var qrClusterID string

		if o.ClusterID != nil {
			qrClusterID = *o.ClusterID
		}
		qClusterID := qrClusterID
		if qClusterID != "" {

			if err := r.SetQueryParam("cluster_id", qClusterID); err != nil {
				return err
			}
		}
	}

	if o.ClusterIDn != nil {

		// query param cluster_id__n
		var qrClusterIDn string

		if o.ClusterIDn != nil {
			qrClusterIDn = *o.ClusterIDn
		}
		qClusterIDn := qrClusterIDn
		if qClusterIDn != "" {

			if err := r.SetQueryParam("cluster_id__n", qClusterIDn); err != nil {
				return err
			}
		}
	}

	if o.Created != nil {

		// query param created
		var qrCreated string

		if o.Created != nil {
			qrCreated = *o.Created
		}
		qCreated := qrCreated
		if qCreated != "" {

			if err := r.SetQueryParam("created", qCreated); err != nil {
				return err
			}
		}
	}

	if o.CreatedGte != nil {

		// query param created__gte
		var qrCreatedGte string

		if o.CreatedGte != nil {
			qrCreatedGte = *o.CreatedGte
		}
		qCreatedGte := qrCreatedGte
		if qCreatedGte != "" {

			if err := r.SetQueryParam("created__gte", qCreatedGte); err != nil {
				return err
			}
		}
	}

	if o.CreatedLte != nil {

		// query param created__lte
		var qrCreatedLte string

		if o.CreatedLte != nil {
			qrCreatedLte = *o.CreatedLte
		}
		qCreatedLte := qrCreatedLte
		if qCreatedLte != "" {

			if err := r.SetQueryParam("created__lte", qCreatedLte); err != nil {
				return err
			}
		}
	}

	if o.Description != nil {

		// query param description
		var qrDescription string

		if o.Description != nil {
			qrDescription = *o.Description
		}
		qDescription := qrDescription
		if qDescription != "" {

			if err := r.SetQueryParam("description", qDescription); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIc != nil {

		// query param description__ic
		var qrDescriptionIc string

		if o.DescriptionIc != nil {
			qrDescriptionIc = *o.DescriptionIc
		}
		qDescriptionIc := qrDescriptionIc
		if qDescriptionIc != "" {

			if err := r.SetQueryParam("description__ic", qDescriptionIc); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIe != nil {

		// query param description__ie
		var qrDescriptionIe string

		if o.DescriptionIe != nil {
			qrDescriptionIe = *o.DescriptionIe
		}
		qDescriptionIe := qrDescriptionIe
		if qDescriptionIe != "" {

			if err := r.SetQueryParam("description__ie", qDescriptionIe); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIew != nil {

		// query param description__iew
		var qrDescriptionIew string

		if o.DescriptionIew != nil {
			qrDescriptionIew = *o.DescriptionIew
		}
		qDescriptionIew := qrDescriptionIew
		if qDescriptionIew != "" {

			if err := r.SetQueryParam("description__iew", qDescriptionIew); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIsw != nil {

		// query param description__isw
		var qrDescriptionIsw string

		if o.DescriptionIsw != nil {
			qrDescriptionIsw = *o.DescriptionIsw
		}
		qDescriptionIsw := qrDescriptionIsw
		if qDescriptionIsw != "" {

			if err := r.SetQueryParam("description__isw", qDescriptionIsw); err != nil {
				return err
			}
		}
	}

	if o.Descriptionn != nil {

		// query param description__n
		var qrDescriptionn string

		if o.Descriptionn != nil {
			qrDescriptionn = *o.Descriptionn
		}
		qDescriptionn := qrDescriptionn
		if qDescriptionn != "" {

			if err := r.SetQueryParam("description__n", qDescriptionn); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNic != nil {

		// query param description__nic
		var qrDescriptionNic string

		if o.DescriptionNic != nil {
			qrDescriptionNic = *o.DescriptionNic
		}
		qDescriptionNic := qrDescriptionNic
		if qDescriptionNic != "" {

			if err := r.SetQueryParam("description__nic", qDescriptionNic); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNie != nil {

		// query param description__nie
		var qrDescriptionNie string

		if o.DescriptionNie != nil {
			qrDescriptionNie = *o.DescriptionNie
		}
		qDescriptionNie := qrDescriptionNie
		if qDescriptionNie != "" {

			if err := r.SetQueryParam("description__nie", qDescriptionNie); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNiew != nil {

		// query param description__niew
		var qrDescriptionNiew string

		if o.DescriptionNiew != nil {
			qrDescriptionNiew = *o.DescriptionNiew
		}
		qDescriptionNiew := qrDescriptionNiew
		if qDescriptionNiew != "" {

			if err := r.SetQueryParam("description__niew", qDescriptionNiew); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNisw != nil {

		// query param description__nisw
		var qrDescriptionNisw string

		if o.DescriptionNisw != nil {
			qrDescriptionNisw = *o.DescriptionNisw
		}
		qDescriptionNisw := qrDescriptionNisw
		if qDescriptionNisw != "" {

			if err := r.SetQueryParam("description__nisw", qDescriptionNisw); err != nil {
				return err
			}
		}
	}

	if o.Enabled != nil {

		// query param enabled
		var qrEnabled string

		if o.Enabled != nil {
			qrEnabled = *o.Enabled
		}
		qEnabled := qrEnabled
		if qEnabled != "" {

			if err := r.SetQueryParam("enabled", qEnabled); err != nil {
				return err
			}
		}
	}

	if o.ID != nil {

		// query param id
		var qrID string

		if o.ID != nil {
			qrID = *o.ID
		}
		qID := qrID
		if qID != "" {

			if err := r.SetQueryParam("id", qID); err != nil {
				return err
			}
		}
	}

	if o.IDGt != nil {

		// query param id__gt
		var qrIDGt string

		if o.IDGt != nil {
			qrIDGt = *o.IDGt
		}
		qIDGt := qrIDGt
		if qIDGt != "" {

			if err := r.SetQueryParam("id__gt", qIDGt); err != nil {
				return err
			}
		}
	}

	if o.IDGte != nil {

		// query param id__gte
		var qrIDGte string

		if o.IDGte != nil {
			qrIDGte = *o.IDGte
		}
		qIDGte := qrIDGte
		if qIDGte != "" {

			if err := r.SetQueryParam("id__gte", qIDGte); err != nil {
				return err
			}
		}
	}

	if o.IDLt != nil {

		// query param id__lt
		var qrIDLt string

		if o.IDLt != nil {
			qrIDLt = *o.IDLt
		}
		qIDLt := qrIDLt
		if qIDLt != "" {

			if err := r.SetQueryParam("id__lt", qIDLt); err != nil {
				return err
			}
		}
	}

	if o.IDLte != nil {

		// query param id__lte
		var qrIDLte string

		if o.IDLte != nil {
			qrIDLte = *o.IDLte
		}
		qIDLte := qrIDLte
		if qIDLte != "" {

			if err := r.SetQueryParam("id__lte", qIDLte); err != nil {
				return err
			}
		}
	}

	if o.IDn != nil {

		// query param id__n
		var qrIDn string

		if o.IDn != nil {
			qrIDn = *o.IDn
		}
		qIDn := qrIDn
		if qIDn != "" {

			if err := r.SetQueryParam("id__n", qIDn); err != nil {
				return err
			}
		}
	}

	if o.LastUpdated != nil {

		// query param last_updated
		var qrLastUpdated string

		if o.LastUpdated != nil {
			qrLastUpdated = *o.LastUpdated
		}
		qLastUpdated := qrLastUpdated
		if qLastUpdated != "" {

			if err := r.SetQueryParam("last_updated", qLastUpdated); err != nil {
				return err
			}
		}
	}

	if o.LastUpdatedGte != nil {

		// query param last_updated__gte
		var qrLastUpdatedGte string

		if o.LastUpdatedGte != nil {
			qrLastUpdatedGte = *o.LastUpdatedGte
		}
		qLastUpdatedGte := qrLastUpdatedGte
		if qLastUpdatedGte != "" {

			if err := r.SetQueryParam("last_updated__gte", qLastUpdatedGte); err != nil {
				return err
			}
		}
	}

	if o.LastUpdatedLte != nil {

		// query param last_updated__lte
		var qrLastUpdatedLte string

		if o.LastUpdatedLte != nil {
			qrLastUpdatedLte = *o.LastUpdatedLte
		}
		qLastUpdatedLte := qrLastUpdatedLte
		if qLastUpdatedLte != "" {

			if err := r.SetQueryParam("last_updated__lte", qLastUpdatedLte); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.MacAddress != nil {

		// query param mac_address
		var qrMacAddress string

		if o.MacAddress != nil {
			qrMacAddress = *o.MacAddress
		}
		qMacAddress := qrMacAddress
		if qMacAddress != "" {

			if err := r.SetQueryParam("mac_address", qMacAddress); err != nil {
				return err
			}
		}
	}

	if o.MacAddressIc != nil {

		// query param mac_address__ic
		var qrMacAddressIc string

		if o.MacAddressIc != nil {
			qrMacAddressIc = *o.MacAddressIc
		}
		qMacAddressIc := qrMacAddressIc
		if qMacAddressIc != "" {

			if err := r.SetQueryParam("mac_address__ic", qMacAddressIc); err != nil {
				return err
			}
		}
	}

	if o.MacAddressIe != nil {

		// query param mac_address__ie
		var qrMacAddressIe string

		if o.MacAddressIe != nil {
			qrMacAddressIe = *o.MacAddressIe
		}
		qMacAddressIe := qrMacAddressIe
		if qMacAddressIe != "" {

			if err := r.SetQueryParam("mac_address__ie", qMacAddressIe); err != nil {
				return err
			}
		}
	}

	if o.MacAddressIew != nil {

		// query param mac_address__iew
		var qrMacAddressIew string

		if o.MacAddressIew != nil {
			qrMacAddressIew = *o.MacAddressIew
		}
		qMacAddressIew := qrMacAddressIew
		if qMacAddressIew != "" {

			if err := r.SetQueryParam("mac_address__iew", qMacAddressIew); err != nil {
				return err
			}
		}
	}

	if o.MacAddressIsw != nil {

		// query param mac_address__isw
		var qrMacAddressIsw string

		if o.MacAddressIsw != nil {
			qrMacAddressIsw = *o.MacAddressIsw
		}
		qMacAddressIsw := qrMacAddressIsw
		if qMacAddressIsw != "" {

			if err := r.SetQueryParam("mac_address__isw", qMacAddressIsw); err != nil {
				return err
			}
		}
	}

	if o.MacAddressn != nil {

		// query param mac_address__n
		var qrMacAddressn string

		if o.MacAddressn != nil {
			qrMacAddressn = *o.MacAddressn
		}
		qMacAddressn := qrMacAddressn
		if qMacAddressn != "" {

			if err := r.SetQueryParam("mac_address__n", qMacAddressn); err != nil {
				return err
			}
		}
	}

	if o.MacAddressNic != nil {

		// query param mac_address__nic
		var qrMacAddressNic string

		if o.MacAddressNic != nil {
			qrMacAddressNic = *o.MacAddressNic
		}
		qMacAddressNic := qrMacAddressNic
		if qMacAddressNic != "" {

			if err := r.SetQueryParam("mac_address__nic", qMacAddressNic); err != nil {
				return err
			}
		}
	}

	if o.MacAddressNie != nil {

		// query param mac_address__nie
		var qrMacAddressNie string

		if o.MacAddressNie != nil {
			qrMacAddressNie = *o.MacAddressNie
		}
		qMacAddressNie := qrMacAddressNie
		if qMacAddressNie != "" {

			if err := r.SetQueryParam("mac_address__nie", qMacAddressNie); err != nil {
				return err
			}
		}
	}

	if o.MacAddressNiew != nil {

		// query param mac_address__niew
		var qrMacAddressNiew string

		if o.MacAddressNiew != nil {
			qrMacAddressNiew = *o.MacAddressNiew
		}
		qMacAddressNiew := qrMacAddressNiew
		if qMacAddressNiew != "" {

			if err := r.SetQueryParam("mac_address__niew", qMacAddressNiew); err != nil {
				return err
			}
		}
	}

	if o.MacAddressNisw != nil {

		// query param mac_address__nisw
		var qrMacAddressNisw string

		if o.MacAddressNisw != nil {
			qrMacAddressNisw = *o.MacAddressNisw
		}
		qMacAddressNisw := qrMacAddressNisw
		if qMacAddressNisw != "" {

			if err := r.SetQueryParam("mac_address__nisw", qMacAddressNisw); err != nil {
				return err
			}
		}
	}

	if o.Mtu != nil {

		// query param mtu
		var qrMtu string

		if o.Mtu != nil {
			qrMtu = *o.Mtu
		}
		qMtu := qrMtu
		if qMtu != "" {

			if err := r.SetQueryParam("mtu", qMtu); err != nil {
				return err
			}
		}
	}

	if o.MtuGt != nil {

		// query param mtu__gt
		var qrMtuGt string

		if o.MtuGt != nil {
			qrMtuGt = *o.MtuGt
		}
		qMtuGt := qrMtuGt
		if qMtuGt != "" {

			if err := r.SetQueryParam("mtu__gt", qMtuGt); err != nil {
				return err
			}
		}
	}

	if o.MtuGte != nil {

		// query param mtu__gte
		var qrMtuGte string

		if o.MtuGte != nil {
			qrMtuGte = *o.MtuGte
		}
		qMtuGte := qrMtuGte
		if qMtuGte != "" {

			if err := r.SetQueryParam("mtu__gte", qMtuGte); err != nil {
				return err
			}
		}
	}

	if o.MtuLt != nil {

		// query param mtu__lt
		var qrMtuLt string

		if o.MtuLt != nil {
			qrMtuLt = *o.MtuLt
		}
		qMtuLt := qrMtuLt
		if qMtuLt != "" {

			if err := r.SetQueryParam("mtu__lt", qMtuLt); err != nil {
				return err
			}
		}
	}

	if o.MtuLte != nil {

		// query param mtu__lte
		var qrMtuLte string

		if o.MtuLte != nil {
			qrMtuLte = *o.MtuLte
		}
		qMtuLte := qrMtuLte
		if qMtuLte != "" {

			if err := r.SetQueryParam("mtu__lte", qMtuLte); err != nil {
				return err
			}
		}
	}

	if o.Mtun != nil {

		// query param mtu__n
		var qrMtun string

		if o.Mtun != nil {
			qrMtun = *o.Mtun
		}
		qMtun := qrMtun
		if qMtun != "" {

			if err := r.SetQueryParam("mtu__n", qMtun); err != nil {
				return err
			}
		}
	}

	if o.Name != nil {

		// query param name
		var qrName string

		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.NameIc != nil {

		// query param name__ic
		var qrNameIc string

		if o.NameIc != nil {
			qrNameIc = *o.NameIc
		}
		qNameIc := qrNameIc
		if qNameIc != "" {

			if err := r.SetQueryParam("name__ic", qNameIc); err != nil {
				return err
			}
		}
	}

	if o.NameIe != nil {

		// query param name__ie
		var qrNameIe string

		if o.NameIe != nil {
			qrNameIe = *o.NameIe
		}
		qNameIe := qrNameIe
		if qNameIe != "" {

			if err := r.SetQueryParam("name__ie", qNameIe); err != nil {
				return err
			}
		}
	}

	if o.NameIew != nil {

		// query param name__iew
		var qrNameIew string

		if o.NameIew != nil {
			qrNameIew = *o.NameIew
		}
		qNameIew := qrNameIew
		if qNameIew != "" {

			if err := r.SetQueryParam("name__iew", qNameIew); err != nil {
				return err
			}
		}
	}

	if o.NameIsw != nil {

		// query param name__isw
		var qrNameIsw string

		if o.NameIsw != nil {
			qrNameIsw = *o.NameIsw
		}
		qNameIsw := qrNameIsw
		if qNameIsw != "" {

			if err := r.SetQueryParam("name__isw", qNameIsw); err != nil {
				return err
			}
		}
	}

	if o.Namen != nil {

		// query param name__n
		var qrNamen string

		if o.Namen != nil {
			qrNamen = *o.Namen
		}
		qNamen := qrNamen
		if qNamen != "" {

			if err := r.SetQueryParam("name__n", qNamen); err != nil {
				return err
			}
		}
	}

	if o.NameNic != nil {

		// query param name__nic
		var qrNameNic string

		if o.NameNic != nil {
			qrNameNic = *o.NameNic
		}
		qNameNic := qrNameNic
		if qNameNic != "" {

			if err := r.SetQueryParam("name__nic", qNameNic); err != nil {
				return err
			}
		}
	}

	if o.NameNie != nil {

		// query param name__nie
		var qrNameNie string

		if o.NameNie != nil {
			qrNameNie = *o.NameNie
		}
		qNameNie := qrNameNie
		if qNameNie != "" {

			if err := r.SetQueryParam("name__nie", qNameNie); err != nil {
				return err
			}
		}
	}

	if o.NameNiew != nil {

		// query param name__niew
		var qrNameNiew string

		if o.NameNiew != nil {
			qrNameNiew = *o.NameNiew
		}
		qNameNiew := qrNameNiew
		if qNameNiew != "" {

			if err := r.SetQueryParam("name__niew", qNameNiew); err != nil {
				return err
			}
		}
	}

	if o.NameNisw != nil {

		// query param name__nisw
		var qrNameNisw string

		if o.NameNisw != nil {
			qrNameNisw = *o.NameNisw
		}
		qNameNisw := qrNameNisw
		if qNameNisw != "" {

			if err := r.SetQueryParam("name__nisw", qNameNisw); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if o.ParentID != nil {

		// query param parent_id
		var qrParentID string

		if o.ParentID != nil {
			qrParentID = *o.ParentID
		}
		qParentID := qrParentID
		if qParentID != "" {

			if err := r.SetQueryParam("parent_id", qParentID); err != nil {
				return err
			}
		}
	}

	if o.ParentIDn != nil {

		// query param parent_id__n
		var qrParentIDn string

		if o.ParentIDn != nil {
			qrParentIDn = *o.ParentIDn
		}
		qParentIDn := qrParentIDn
		if qParentIDn != "" {

			if err := r.SetQueryParam("parent_id__n", qParentIDn); err != nil {
				return err
			}
		}
	}

	if o.Q != nil {

		// query param q
		var qrQ string

		if o.Q != nil {
			qrQ = *o.Q
		}
		qQ := qrQ
		if qQ != "" {

			if err := r.SetQueryParam("q", qQ); err != nil {
				return err
			}
		}
	}

	if o.Tag != nil {

		// query param tag
		var qrTag string

		if o.Tag != nil {
			qrTag = *o.Tag
		}
		qTag := qrTag
		if qTag != "" {

			if err := r.SetQueryParam("tag", qTag); err != nil {
				return err
			}
		}
	}

	if o.Tagn != nil {

		// query param tag__n
		var qrTagn string

		if o.Tagn != nil {
			qrTagn = *o.Tagn
		}
		qTagn := qrTagn
		if qTagn != "" {

			if err := r.SetQueryParam("tag__n", qTagn); err != nil {
				return err
			}
		}
	}

	if o.VirtualMachine != nil {

		// query param virtual_machine
		var qrVirtualMachine string

		if o.VirtualMachine != nil {
			qrVirtualMachine = *o.VirtualMachine
		}
		qVirtualMachine := qrVirtualMachine
		if qVirtualMachine != "" {

			if err := r.SetQueryParam("virtual_machine", qVirtualMachine); err != nil {
				return err
			}
		}
	}

	if o.VirtualMachinen != nil {

		// query param virtual_machine__n
		var qrVirtualMachinen string

		if o.VirtualMachinen != nil {
			qrVirtualMachinen = *o.VirtualMachinen
		}
		qVirtualMachinen := qrVirtualMachinen
		if qVirtualMachinen != "" {

			if err := r.SetQueryParam("virtual_machine__n", qVirtualMachinen); err != nil {
				return err
			}
		}
	}

	if o.VirtualMachineID != nil {

		// query param virtual_machine_id
		var qrVirtualMachineID string

		if o.VirtualMachineID != nil {
			qrVirtualMachineID = *o.VirtualMachineID
		}
		qVirtualMachineID := qrVirtualMachineID
		if qVirtualMachineID != "" {

			if err := r.SetQueryParam("virtual_machine_id", qVirtualMachineID); err != nil {
				return err
			}
		}
	}

	if o.VirtualMachineIDn != nil {

		// query param virtual_machine_id__n
		var qrVirtualMachineIDn string

		if o.VirtualMachineIDn != nil {
			qrVirtualMachineIDn = *o.VirtualMachineIDn
		}
		qVirtualMachineIDn := qrVirtualMachineIDn
		if qVirtualMachineIDn != "" {

			if err := r.SetQueryParam("virtual_machine_id__n", qVirtualMachineIDn); err != nil {
				return err
			}
		}
	}

	if o.Vrf != nil {

		// query param vrf
		var qrVrf string

		if o.Vrf != nil {
			qrVrf = *o.Vrf
		}
		qVrf := qrVrf
		if qVrf != "" {

			if err := r.SetQueryParam("vrf", qVrf); err != nil {
				return err
			}
		}
	}

	if o.Vrfn != nil {

		// query param vrf__n
		var qrVrfn string

		if o.Vrfn != nil {
			qrVrfn = *o.Vrfn
		}
		qVrfn := qrVrfn
		if qVrfn != "" {

			if err := r.SetQueryParam("vrf__n", qVrfn); err != nil {
				return err
			}
		}
	}

	if o.VrfID != nil {

		// query param vrf_id
		var qrVrfID string

		if o.VrfID != nil {
			qrVrfID = *o.VrfID
		}
		qVrfID := qrVrfID
		if qVrfID != "" {

			if err := r.SetQueryParam("vrf_id", qVrfID); err != nil {
				return err
			}
		}
	}

	if o.VrfIDn != nil {

		// query param vrf_id__n
		var qrVrfIDn string

		if o.VrfIDn != nil {
			qrVrfIDn = *o.VrfIDn
		}
		qVrfIDn := qrVrfIDn
		if qVrfIDn != "" {

			if err := r.SetQueryParam("vrf_id__n", qVrfIDn); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
