// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2020 The go-netbox Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package wireless

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewWirelessWirelessLinksListParams creates a new WirelessWirelessLinksListParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewWirelessWirelessLinksListParams() *WirelessWirelessLinksListParams {
	return &WirelessWirelessLinksListParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewWirelessWirelessLinksListParamsWithTimeout creates a new WirelessWirelessLinksListParams object
// with the ability to set a timeout on a request.
func NewWirelessWirelessLinksListParamsWithTimeout(timeout time.Duration) *WirelessWirelessLinksListParams {
	return &WirelessWirelessLinksListParams{
		timeout: timeout,
	}
}

// NewWirelessWirelessLinksListParamsWithContext creates a new WirelessWirelessLinksListParams object
// with the ability to set a context for a request.
func NewWirelessWirelessLinksListParamsWithContext(ctx context.Context) *WirelessWirelessLinksListParams {
	return &WirelessWirelessLinksListParams{
		Context: ctx,
	}
}

// NewWirelessWirelessLinksListParamsWithHTTPClient creates a new WirelessWirelessLinksListParams object
// with the ability to set a custom HTTPClient for a request.
func NewWirelessWirelessLinksListParamsWithHTTPClient(client *http.Client) *WirelessWirelessLinksListParams {
	return &WirelessWirelessLinksListParams{
		HTTPClient: client,
	}
}

/* WirelessWirelessLinksListParams contains all the parameters to send to the API endpoint
   for the wireless wireless links list operation.

   Typically these are written to a http.Request.
*/
type WirelessWirelessLinksListParams struct {

	// AuthCipher.
	AuthCipher *string

	// AuthCiphern.
	AuthCiphern *string

	// AuthPsk.
	AuthPsk *string

	// AuthPskEmpty.
	AuthPskEmpty *string

	// AuthPskIc.
	AuthPskIc *string

	// AuthPskIe.
	AuthPskIe *string

	// AuthPskIew.
	AuthPskIew *string

	// AuthPskIsw.
	AuthPskIsw *string

	// AuthPskn.
	AuthPskn *string

	// AuthPskNic.
	AuthPskNic *string

	// AuthPskNie.
	AuthPskNie *string

	// AuthPskNiew.
	AuthPskNiew *string

	// AuthPskNisw.
	AuthPskNisw *string

	// AuthType.
	AuthType *string

	// AuthTypen.
	AuthTypen *string

	// Created.
	Created *string

	// CreatedGte.
	CreatedGte *string

	// CreatedLte.
	CreatedLte *string

	// Description.
	Description *string

	// DescriptionEmpty.
	DescriptionEmpty *string

	// DescriptionIc.
	DescriptionIc *string

	// DescriptionIe.
	DescriptionIe *string

	// DescriptionIew.
	DescriptionIew *string

	// DescriptionIsw.
	DescriptionIsw *string

	// Descriptionn.
	Descriptionn *string

	// DescriptionNic.
	DescriptionNic *string

	// DescriptionNie.
	DescriptionNie *string

	// DescriptionNiew.
	DescriptionNiew *string

	// DescriptionNisw.
	DescriptionNisw *string

	// ID.
	ID *string

	// IDGt.
	IDGt *string

	// IDGte.
	IDGte *string

	// IDLt.
	IDLt *string

	// IDLte.
	IDLte *string

	// IDn.
	IDn *string

	// InterfaceaID.
	InterfaceaID *string

	// InterfaceaIDGt.
	InterfaceaIDGt *string

	// InterfaceaIDGte.
	InterfaceaIDGte *string

	// InterfaceaIDLt.
	InterfaceaIDLt *string

	// InterfaceaIDLte.
	InterfaceaIDLte *string

	// InterfaceaIDn.
	InterfaceaIDn *string

	// InterfacebID.
	InterfacebID *string

	// InterfacebIDGt.
	InterfacebIDGt *string

	// InterfacebIDGte.
	InterfacebIDGte *string

	// InterfacebIDLt.
	InterfacebIDLt *string

	// InterfacebIDLte.
	InterfacebIDLte *string

	// InterfacebIDn.
	InterfacebIDn *string

	// LastUpdated.
	LastUpdated *string

	// LastUpdatedGte.
	LastUpdatedGte *string

	// LastUpdatedLte.
	LastUpdatedLte *string

	/* Limit.

	   Number of results to return per page.
	*/
	Limit *int64

	/* Offset.

	   The initial index from which to return the results.
	*/
	Offset *int64

	// Q.
	Q *string

	// Ssid.
	Ssid *string

	// SsidEmpty.
	SsidEmpty *string

	// SsidIc.
	SsidIc *string

	// SsidIe.
	SsidIe *string

	// SsidIew.
	SsidIew *string

	// SsidIsw.
	SsidIsw *string

	// Ssidn.
	Ssidn *string

	// SsidNic.
	SsidNic *string

	// SsidNie.
	SsidNie *string

	// SsidNiew.
	SsidNiew *string

	// SsidNisw.
	SsidNisw *string

	// Status.
	Status *string

	// Statusn.
	Statusn *string

	// Tag.
	Tag *string

	// Tagn.
	Tagn *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the wireless wireless links list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WirelessWirelessLinksListParams) WithDefaults() *WirelessWirelessLinksListParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the wireless wireless links list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WirelessWirelessLinksListParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithTimeout(timeout time.Duration) *WirelessWirelessLinksListParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithContext(ctx context.Context) *WirelessWirelessLinksListParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithHTTPClient(client *http.Client) *WirelessWirelessLinksListParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAuthCipher adds the authCipher to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithAuthCipher(authCipher *string) *WirelessWirelessLinksListParams {
	o.SetAuthCipher(authCipher)
	return o
}

// SetAuthCipher adds the authCipher to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetAuthCipher(authCipher *string) {
	o.AuthCipher = authCipher
}

// WithAuthCiphern adds the authCiphern to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithAuthCiphern(authCiphern *string) *WirelessWirelessLinksListParams {
	o.SetAuthCiphern(authCiphern)
	return o
}

// SetAuthCiphern adds the authCipherN to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetAuthCiphern(authCiphern *string) {
	o.AuthCiphern = authCiphern
}

// WithAuthPsk adds the authPsk to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithAuthPsk(authPsk *string) *WirelessWirelessLinksListParams {
	o.SetAuthPsk(authPsk)
	return o
}

// SetAuthPsk adds the authPsk to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetAuthPsk(authPsk *string) {
	o.AuthPsk = authPsk
}

// WithAuthPskEmpty adds the authPskEmpty to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithAuthPskEmpty(authPskEmpty *string) *WirelessWirelessLinksListParams {
	o.SetAuthPskEmpty(authPskEmpty)
	return o
}

// SetAuthPskEmpty adds the authPskEmpty to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetAuthPskEmpty(authPskEmpty *string) {
	o.AuthPskEmpty = authPskEmpty
}

// WithAuthPskIc adds the authPskIc to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithAuthPskIc(authPskIc *string) *WirelessWirelessLinksListParams {
	o.SetAuthPskIc(authPskIc)
	return o
}

// SetAuthPskIc adds the authPskIc to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetAuthPskIc(authPskIc *string) {
	o.AuthPskIc = authPskIc
}

// WithAuthPskIe adds the authPskIe to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithAuthPskIe(authPskIe *string) *WirelessWirelessLinksListParams {
	o.SetAuthPskIe(authPskIe)
	return o
}

// SetAuthPskIe adds the authPskIe to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetAuthPskIe(authPskIe *string) {
	o.AuthPskIe = authPskIe
}

// WithAuthPskIew adds the authPskIew to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithAuthPskIew(authPskIew *string) *WirelessWirelessLinksListParams {
	o.SetAuthPskIew(authPskIew)
	return o
}

// SetAuthPskIew adds the authPskIew to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetAuthPskIew(authPskIew *string) {
	o.AuthPskIew = authPskIew
}

// WithAuthPskIsw adds the authPskIsw to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithAuthPskIsw(authPskIsw *string) *WirelessWirelessLinksListParams {
	o.SetAuthPskIsw(authPskIsw)
	return o
}

// SetAuthPskIsw adds the authPskIsw to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetAuthPskIsw(authPskIsw *string) {
	o.AuthPskIsw = authPskIsw
}

// WithAuthPskn adds the authPskn to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithAuthPskn(authPskn *string) *WirelessWirelessLinksListParams {
	o.SetAuthPskn(authPskn)
	return o
}

// SetAuthPskn adds the authPskN to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetAuthPskn(authPskn *string) {
	o.AuthPskn = authPskn
}

// WithAuthPskNic adds the authPskNic to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithAuthPskNic(authPskNic *string) *WirelessWirelessLinksListParams {
	o.SetAuthPskNic(authPskNic)
	return o
}

// SetAuthPskNic adds the authPskNic to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetAuthPskNic(authPskNic *string) {
	o.AuthPskNic = authPskNic
}

// WithAuthPskNie adds the authPskNie to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithAuthPskNie(authPskNie *string) *WirelessWirelessLinksListParams {
	o.SetAuthPskNie(authPskNie)
	return o
}

// SetAuthPskNie adds the authPskNie to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetAuthPskNie(authPskNie *string) {
	o.AuthPskNie = authPskNie
}

// WithAuthPskNiew adds the authPskNiew to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithAuthPskNiew(authPskNiew *string) *WirelessWirelessLinksListParams {
	o.SetAuthPskNiew(authPskNiew)
	return o
}

// SetAuthPskNiew adds the authPskNiew to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetAuthPskNiew(authPskNiew *string) {
	o.AuthPskNiew = authPskNiew
}

// WithAuthPskNisw adds the authPskNisw to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithAuthPskNisw(authPskNisw *string) *WirelessWirelessLinksListParams {
	o.SetAuthPskNisw(authPskNisw)
	return o
}

// SetAuthPskNisw adds the authPskNisw to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetAuthPskNisw(authPskNisw *string) {
	o.AuthPskNisw = authPskNisw
}

// WithAuthType adds the authType to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithAuthType(authType *string) *WirelessWirelessLinksListParams {
	o.SetAuthType(authType)
	return o
}

// SetAuthType adds the authType to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetAuthType(authType *string) {
	o.AuthType = authType
}

// WithAuthTypen adds the authTypen to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithAuthTypen(authTypen *string) *WirelessWirelessLinksListParams {
	o.SetAuthTypen(authTypen)
	return o
}

// SetAuthTypen adds the authTypeN to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetAuthTypen(authTypen *string) {
	o.AuthTypen = authTypen
}

// WithCreated adds the created to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithCreated(created *string) *WirelessWirelessLinksListParams {
	o.SetCreated(created)
	return o
}

// SetCreated adds the created to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetCreated(created *string) {
	o.Created = created
}

// WithCreatedGte adds the createdGte to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithCreatedGte(createdGte *string) *WirelessWirelessLinksListParams {
	o.SetCreatedGte(createdGte)
	return o
}

// SetCreatedGte adds the createdGte to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetCreatedGte(createdGte *string) {
	o.CreatedGte = createdGte
}

// WithCreatedLte adds the createdLte to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithCreatedLte(createdLte *string) *WirelessWirelessLinksListParams {
	o.SetCreatedLte(createdLte)
	return o
}

// SetCreatedLte adds the createdLte to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetCreatedLte(createdLte *string) {
	o.CreatedLte = createdLte
}

// WithDescription adds the description to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithDescription(description *string) *WirelessWirelessLinksListParams {
	o.SetDescription(description)
	return o
}

// SetDescription adds the description to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetDescription(description *string) {
	o.Description = description
}

// WithDescriptionEmpty adds the descriptionEmpty to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithDescriptionEmpty(descriptionEmpty *string) *WirelessWirelessLinksListParams {
	o.SetDescriptionEmpty(descriptionEmpty)
	return o
}

// SetDescriptionEmpty adds the descriptionEmpty to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetDescriptionEmpty(descriptionEmpty *string) {
	o.DescriptionEmpty = descriptionEmpty
}

// WithDescriptionIc adds the descriptionIc to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithDescriptionIc(descriptionIc *string) *WirelessWirelessLinksListParams {
	o.SetDescriptionIc(descriptionIc)
	return o
}

// SetDescriptionIc adds the descriptionIc to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetDescriptionIc(descriptionIc *string) {
	o.DescriptionIc = descriptionIc
}

// WithDescriptionIe adds the descriptionIe to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithDescriptionIe(descriptionIe *string) *WirelessWirelessLinksListParams {
	o.SetDescriptionIe(descriptionIe)
	return o
}

// SetDescriptionIe adds the descriptionIe to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetDescriptionIe(descriptionIe *string) {
	o.DescriptionIe = descriptionIe
}

// WithDescriptionIew adds the descriptionIew to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithDescriptionIew(descriptionIew *string) *WirelessWirelessLinksListParams {
	o.SetDescriptionIew(descriptionIew)
	return o
}

// SetDescriptionIew adds the descriptionIew to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetDescriptionIew(descriptionIew *string) {
	o.DescriptionIew = descriptionIew
}

// WithDescriptionIsw adds the descriptionIsw to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithDescriptionIsw(descriptionIsw *string) *WirelessWirelessLinksListParams {
	o.SetDescriptionIsw(descriptionIsw)
	return o
}

// SetDescriptionIsw adds the descriptionIsw to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetDescriptionIsw(descriptionIsw *string) {
	o.DescriptionIsw = descriptionIsw
}

// WithDescriptionn adds the descriptionn to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithDescriptionn(descriptionn *string) *WirelessWirelessLinksListParams {
	o.SetDescriptionn(descriptionn)
	return o
}

// SetDescriptionn adds the descriptionN to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetDescriptionn(descriptionn *string) {
	o.Descriptionn = descriptionn
}

// WithDescriptionNic adds the descriptionNic to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithDescriptionNic(descriptionNic *string) *WirelessWirelessLinksListParams {
	o.SetDescriptionNic(descriptionNic)
	return o
}

// SetDescriptionNic adds the descriptionNic to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetDescriptionNic(descriptionNic *string) {
	o.DescriptionNic = descriptionNic
}

// WithDescriptionNie adds the descriptionNie to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithDescriptionNie(descriptionNie *string) *WirelessWirelessLinksListParams {
	o.SetDescriptionNie(descriptionNie)
	return o
}

// SetDescriptionNie adds the descriptionNie to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetDescriptionNie(descriptionNie *string) {
	o.DescriptionNie = descriptionNie
}

// WithDescriptionNiew adds the descriptionNiew to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithDescriptionNiew(descriptionNiew *string) *WirelessWirelessLinksListParams {
	o.SetDescriptionNiew(descriptionNiew)
	return o
}

// SetDescriptionNiew adds the descriptionNiew to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetDescriptionNiew(descriptionNiew *string) {
	o.DescriptionNiew = descriptionNiew
}

// WithDescriptionNisw adds the descriptionNisw to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithDescriptionNisw(descriptionNisw *string) *WirelessWirelessLinksListParams {
	o.SetDescriptionNisw(descriptionNisw)
	return o
}

// SetDescriptionNisw adds the descriptionNisw to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetDescriptionNisw(descriptionNisw *string) {
	o.DescriptionNisw = descriptionNisw
}

// WithID adds the id to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithID(id *string) *WirelessWirelessLinksListParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetID(id *string) {
	o.ID = id
}

// WithIDGt adds the iDGt to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithIDGt(iDGt *string) *WirelessWirelessLinksListParams {
	o.SetIDGt(iDGt)
	return o
}

// SetIDGt adds the idGt to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetIDGt(iDGt *string) {
	o.IDGt = iDGt
}

// WithIDGte adds the iDGte to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithIDGte(iDGte *string) *WirelessWirelessLinksListParams {
	o.SetIDGte(iDGte)
	return o
}

// SetIDGte adds the idGte to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetIDGte(iDGte *string) {
	o.IDGte = iDGte
}

// WithIDLt adds the iDLt to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithIDLt(iDLt *string) *WirelessWirelessLinksListParams {
	o.SetIDLt(iDLt)
	return o
}

// SetIDLt adds the idLt to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetIDLt(iDLt *string) {
	o.IDLt = iDLt
}

// WithIDLte adds the iDLte to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithIDLte(iDLte *string) *WirelessWirelessLinksListParams {
	o.SetIDLte(iDLte)
	return o
}

// SetIDLte adds the idLte to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetIDLte(iDLte *string) {
	o.IDLte = iDLte
}

// WithIDn adds the iDn to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithIDn(iDn *string) *WirelessWirelessLinksListParams {
	o.SetIDn(iDn)
	return o
}

// SetIDn adds the idN to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetIDn(iDn *string) {
	o.IDn = iDn
}

// WithInterfaceaID adds the interfaceaID to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithInterfaceaID(interfaceaID *string) *WirelessWirelessLinksListParams {
	o.SetInterfaceaID(interfaceaID)
	return o
}

// SetInterfaceaID adds the interfaceAId to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetInterfaceaID(interfaceaID *string) {
	o.InterfaceaID = interfaceaID
}

// WithInterfaceaIDGt adds the interfaceaIDGt to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithInterfaceaIDGt(interfaceaIDGt *string) *WirelessWirelessLinksListParams {
	o.SetInterfaceaIDGt(interfaceaIDGt)
	return o
}

// SetInterfaceaIDGt adds the interfaceAIdGt to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetInterfaceaIDGt(interfaceaIDGt *string) {
	o.InterfaceaIDGt = interfaceaIDGt
}

// WithInterfaceaIDGte adds the interfaceaIDGte to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithInterfaceaIDGte(interfaceaIDGte *string) *WirelessWirelessLinksListParams {
	o.SetInterfaceaIDGte(interfaceaIDGte)
	return o
}

// SetInterfaceaIDGte adds the interfaceAIdGte to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetInterfaceaIDGte(interfaceaIDGte *string) {
	o.InterfaceaIDGte = interfaceaIDGte
}

// WithInterfaceaIDLt adds the interfaceaIDLt to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithInterfaceaIDLt(interfaceaIDLt *string) *WirelessWirelessLinksListParams {
	o.SetInterfaceaIDLt(interfaceaIDLt)
	return o
}

// SetInterfaceaIDLt adds the interfaceAIdLt to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetInterfaceaIDLt(interfaceaIDLt *string) {
	o.InterfaceaIDLt = interfaceaIDLt
}

// WithInterfaceaIDLte adds the interfaceaIDLte to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithInterfaceaIDLte(interfaceaIDLte *string) *WirelessWirelessLinksListParams {
	o.SetInterfaceaIDLte(interfaceaIDLte)
	return o
}

// SetInterfaceaIDLte adds the interfaceAIdLte to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetInterfaceaIDLte(interfaceaIDLte *string) {
	o.InterfaceaIDLte = interfaceaIDLte
}

// WithInterfaceaIDn adds the interfaceaIDn to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithInterfaceaIDn(interfaceaIDn *string) *WirelessWirelessLinksListParams {
	o.SetInterfaceaIDn(interfaceaIDn)
	return o
}

// SetInterfaceaIDn adds the interfaceAIdN to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetInterfaceaIDn(interfaceaIDn *string) {
	o.InterfaceaIDn = interfaceaIDn
}

// WithInterfacebID adds the interfacebID to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithInterfacebID(interfacebID *string) *WirelessWirelessLinksListParams {
	o.SetInterfacebID(interfacebID)
	return o
}

// SetInterfacebID adds the interfaceBId to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetInterfacebID(interfacebID *string) {
	o.InterfacebID = interfacebID
}

// WithInterfacebIDGt adds the interfacebIDGt to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithInterfacebIDGt(interfacebIDGt *string) *WirelessWirelessLinksListParams {
	o.SetInterfacebIDGt(interfacebIDGt)
	return o
}

// SetInterfacebIDGt adds the interfaceBIdGt to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetInterfacebIDGt(interfacebIDGt *string) {
	o.InterfacebIDGt = interfacebIDGt
}

// WithInterfacebIDGte adds the interfacebIDGte to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithInterfacebIDGte(interfacebIDGte *string) *WirelessWirelessLinksListParams {
	o.SetInterfacebIDGte(interfacebIDGte)
	return o
}

// SetInterfacebIDGte adds the interfaceBIdGte to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetInterfacebIDGte(interfacebIDGte *string) {
	o.InterfacebIDGte = interfacebIDGte
}

// WithInterfacebIDLt adds the interfacebIDLt to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithInterfacebIDLt(interfacebIDLt *string) *WirelessWirelessLinksListParams {
	o.SetInterfacebIDLt(interfacebIDLt)
	return o
}

// SetInterfacebIDLt adds the interfaceBIdLt to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetInterfacebIDLt(interfacebIDLt *string) {
	o.InterfacebIDLt = interfacebIDLt
}

// WithInterfacebIDLte adds the interfacebIDLte to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithInterfacebIDLte(interfacebIDLte *string) *WirelessWirelessLinksListParams {
	o.SetInterfacebIDLte(interfacebIDLte)
	return o
}

// SetInterfacebIDLte adds the interfaceBIdLte to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetInterfacebIDLte(interfacebIDLte *string) {
	o.InterfacebIDLte = interfacebIDLte
}

// WithInterfacebIDn adds the interfacebIDn to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithInterfacebIDn(interfacebIDn *string) *WirelessWirelessLinksListParams {
	o.SetInterfacebIDn(interfacebIDn)
	return o
}

// SetInterfacebIDn adds the interfaceBIdN to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetInterfacebIDn(interfacebIDn *string) {
	o.InterfacebIDn = interfacebIDn
}

// WithLastUpdated adds the lastUpdated to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithLastUpdated(lastUpdated *string) *WirelessWirelessLinksListParams {
	o.SetLastUpdated(lastUpdated)
	return o
}

// SetLastUpdated adds the lastUpdated to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetLastUpdated(lastUpdated *string) {
	o.LastUpdated = lastUpdated
}

// WithLastUpdatedGte adds the lastUpdatedGte to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithLastUpdatedGte(lastUpdatedGte *string) *WirelessWirelessLinksListParams {
	o.SetLastUpdatedGte(lastUpdatedGte)
	return o
}

// SetLastUpdatedGte adds the lastUpdatedGte to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetLastUpdatedGte(lastUpdatedGte *string) {
	o.LastUpdatedGte = lastUpdatedGte
}

// WithLastUpdatedLte adds the lastUpdatedLte to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithLastUpdatedLte(lastUpdatedLte *string) *WirelessWirelessLinksListParams {
	o.SetLastUpdatedLte(lastUpdatedLte)
	return o
}

// SetLastUpdatedLte adds the lastUpdatedLte to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetLastUpdatedLte(lastUpdatedLte *string) {
	o.LastUpdatedLte = lastUpdatedLte
}

// WithLimit adds the limit to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithLimit(limit *int64) *WirelessWirelessLinksListParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithOffset(offset *int64) *WirelessWirelessLinksListParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithQ adds the q to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithQ(q *string) *WirelessWirelessLinksListParams {
	o.SetQ(q)
	return o
}

// SetQ adds the q to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetQ(q *string) {
	o.Q = q
}

// WithSsid adds the ssid to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithSsid(ssid *string) *WirelessWirelessLinksListParams {
	o.SetSsid(ssid)
	return o
}

// SetSsid adds the ssid to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetSsid(ssid *string) {
	o.Ssid = ssid
}

// WithSsidEmpty adds the ssidEmpty to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithSsidEmpty(ssidEmpty *string) *WirelessWirelessLinksListParams {
	o.SetSsidEmpty(ssidEmpty)
	return o
}

// SetSsidEmpty adds the ssidEmpty to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetSsidEmpty(ssidEmpty *string) {
	o.SsidEmpty = ssidEmpty
}

// WithSsidIc adds the ssidIc to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithSsidIc(ssidIc *string) *WirelessWirelessLinksListParams {
	o.SetSsidIc(ssidIc)
	return o
}

// SetSsidIc adds the ssidIc to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetSsidIc(ssidIc *string) {
	o.SsidIc = ssidIc
}

// WithSsidIe adds the ssidIe to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithSsidIe(ssidIe *string) *WirelessWirelessLinksListParams {
	o.SetSsidIe(ssidIe)
	return o
}

// SetSsidIe adds the ssidIe to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetSsidIe(ssidIe *string) {
	o.SsidIe = ssidIe
}

// WithSsidIew adds the ssidIew to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithSsidIew(ssidIew *string) *WirelessWirelessLinksListParams {
	o.SetSsidIew(ssidIew)
	return o
}

// SetSsidIew adds the ssidIew to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetSsidIew(ssidIew *string) {
	o.SsidIew = ssidIew
}

// WithSsidIsw adds the ssidIsw to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithSsidIsw(ssidIsw *string) *WirelessWirelessLinksListParams {
	o.SetSsidIsw(ssidIsw)
	return o
}

// SetSsidIsw adds the ssidIsw to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetSsidIsw(ssidIsw *string) {
	o.SsidIsw = ssidIsw
}

// WithSsidn adds the ssidn to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithSsidn(ssidn *string) *WirelessWirelessLinksListParams {
	o.SetSsidn(ssidn)
	return o
}

// SetSsidn adds the ssidN to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetSsidn(ssidn *string) {
	o.Ssidn = ssidn
}

// WithSsidNic adds the ssidNic to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithSsidNic(ssidNic *string) *WirelessWirelessLinksListParams {
	o.SetSsidNic(ssidNic)
	return o
}

// SetSsidNic adds the ssidNic to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetSsidNic(ssidNic *string) {
	o.SsidNic = ssidNic
}

// WithSsidNie adds the ssidNie to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithSsidNie(ssidNie *string) *WirelessWirelessLinksListParams {
	o.SetSsidNie(ssidNie)
	return o
}

// SetSsidNie adds the ssidNie to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetSsidNie(ssidNie *string) {
	o.SsidNie = ssidNie
}

// WithSsidNiew adds the ssidNiew to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithSsidNiew(ssidNiew *string) *WirelessWirelessLinksListParams {
	o.SetSsidNiew(ssidNiew)
	return o
}

// SetSsidNiew adds the ssidNiew to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetSsidNiew(ssidNiew *string) {
	o.SsidNiew = ssidNiew
}

// WithSsidNisw adds the ssidNisw to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithSsidNisw(ssidNisw *string) *WirelessWirelessLinksListParams {
	o.SetSsidNisw(ssidNisw)
	return o
}

// SetSsidNisw adds the ssidNisw to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetSsidNisw(ssidNisw *string) {
	o.SsidNisw = ssidNisw
}

// WithStatus adds the status to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithStatus(status *string) *WirelessWirelessLinksListParams {
	o.SetStatus(status)
	return o
}

// SetStatus adds the status to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetStatus(status *string) {
	o.Status = status
}

// WithStatusn adds the statusn to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithStatusn(statusn *string) *WirelessWirelessLinksListParams {
	o.SetStatusn(statusn)
	return o
}

// SetStatusn adds the statusN to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetStatusn(statusn *string) {
	o.Statusn = statusn
}

// WithTag adds the tag to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithTag(tag *string) *WirelessWirelessLinksListParams {
	o.SetTag(tag)
	return o
}

// SetTag adds the tag to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetTag(tag *string) {
	o.Tag = tag
}

// WithTagn adds the tagn to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) WithTagn(tagn *string) *WirelessWirelessLinksListParams {
	o.SetTagn(tagn)
	return o
}

// SetTagn adds the tagN to the wireless wireless links list params
func (o *WirelessWirelessLinksListParams) SetTagn(tagn *string) {
	o.Tagn = tagn
}

// WriteToRequest writes these params to a swagger request
func (o *WirelessWirelessLinksListParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AuthCipher != nil {

		// query param auth_cipher
		var qrAuthCipher string

		if o.AuthCipher != nil {
			qrAuthCipher = *o.AuthCipher
		}
		qAuthCipher := qrAuthCipher
		if qAuthCipher != "" {

			if err := r.SetQueryParam("auth_cipher", qAuthCipher); err != nil {
				return err
			}
		}
	}

	if o.AuthCiphern != nil {

		// query param auth_cipher__n
		var qrAuthCiphern string

		if o.AuthCiphern != nil {
			qrAuthCiphern = *o.AuthCiphern
		}
		qAuthCiphern := qrAuthCiphern
		if qAuthCiphern != "" {

			if err := r.SetQueryParam("auth_cipher__n", qAuthCiphern); err != nil {
				return err
			}
		}
	}

	if o.AuthPsk != nil {

		// query param auth_psk
		var qrAuthPsk string

		if o.AuthPsk != nil {
			qrAuthPsk = *o.AuthPsk
		}
		qAuthPsk := qrAuthPsk
		if qAuthPsk != "" {

			if err := r.SetQueryParam("auth_psk", qAuthPsk); err != nil {
				return err
			}
		}
	}

	if o.AuthPskEmpty != nil {

		// query param auth_psk__empty
		var qrAuthPskEmpty string

		if o.AuthPskEmpty != nil {
			qrAuthPskEmpty = *o.AuthPskEmpty
		}
		qAuthPskEmpty := qrAuthPskEmpty
		if qAuthPskEmpty != "" {

			if err := r.SetQueryParam("auth_psk__empty", qAuthPskEmpty); err != nil {
				return err
			}
		}
	}

	if o.AuthPskIc != nil {

		// query param auth_psk__ic
		var qrAuthPskIc string

		if o.AuthPskIc != nil {
			qrAuthPskIc = *o.AuthPskIc
		}
		qAuthPskIc := qrAuthPskIc
		if qAuthPskIc != "" {

			if err := r.SetQueryParam("auth_psk__ic", qAuthPskIc); err != nil {
				return err
			}
		}
	}

	if o.AuthPskIe != nil {

		// query param auth_psk__ie
		var qrAuthPskIe string

		if o.AuthPskIe != nil {
			qrAuthPskIe = *o.AuthPskIe
		}
		qAuthPskIe := qrAuthPskIe
		if qAuthPskIe != "" {

			if err := r.SetQueryParam("auth_psk__ie", qAuthPskIe); err != nil {
				return err
			}
		}
	}

	if o.AuthPskIew != nil {

		// query param auth_psk__iew
		var qrAuthPskIew string

		if o.AuthPskIew != nil {
			qrAuthPskIew = *o.AuthPskIew
		}
		qAuthPskIew := qrAuthPskIew
		if qAuthPskIew != "" {

			if err := r.SetQueryParam("auth_psk__iew", qAuthPskIew); err != nil {
				return err
			}
		}
	}

	if o.AuthPskIsw != nil {

		// query param auth_psk__isw
		var qrAuthPskIsw string

		if o.AuthPskIsw != nil {
			qrAuthPskIsw = *o.AuthPskIsw
		}
		qAuthPskIsw := qrAuthPskIsw
		if qAuthPskIsw != "" {

			if err := r.SetQueryParam("auth_psk__isw", qAuthPskIsw); err != nil {
				return err
			}
		}
	}

	if o.AuthPskn != nil {

		// query param auth_psk__n
		var qrAuthPskn string

		if o.AuthPskn != nil {
			qrAuthPskn = *o.AuthPskn
		}
		qAuthPskn := qrAuthPskn
		if qAuthPskn != "" {

			if err := r.SetQueryParam("auth_psk__n", qAuthPskn); err != nil {
				return err
			}
		}
	}

	if o.AuthPskNic != nil {

		// query param auth_psk__nic
		var qrAuthPskNic string

		if o.AuthPskNic != nil {
			qrAuthPskNic = *o.AuthPskNic
		}
		qAuthPskNic := qrAuthPskNic
		if qAuthPskNic != "" {

			if err := r.SetQueryParam("auth_psk__nic", qAuthPskNic); err != nil {
				return err
			}
		}
	}

	if o.AuthPskNie != nil {

		// query param auth_psk__nie
		var qrAuthPskNie string

		if o.AuthPskNie != nil {
			qrAuthPskNie = *o.AuthPskNie
		}
		qAuthPskNie := qrAuthPskNie
		if qAuthPskNie != "" {

			if err := r.SetQueryParam("auth_psk__nie", qAuthPskNie); err != nil {
				return err
			}
		}
	}

	if o.AuthPskNiew != nil {

		// query param auth_psk__niew
		var qrAuthPskNiew string

		if o.AuthPskNiew != nil {
			qrAuthPskNiew = *o.AuthPskNiew
		}
		qAuthPskNiew := qrAuthPskNiew
		if qAuthPskNiew != "" {

			if err := r.SetQueryParam("auth_psk__niew", qAuthPskNiew); err != nil {
				return err
			}
		}
	}

	if o.AuthPskNisw != nil {

		// query param auth_psk__nisw
		var qrAuthPskNisw string

		if o.AuthPskNisw != nil {
			qrAuthPskNisw = *o.AuthPskNisw
		}
		qAuthPskNisw := qrAuthPskNisw
		if qAuthPskNisw != "" {

			if err := r.SetQueryParam("auth_psk__nisw", qAuthPskNisw); err != nil {
				return err
			}
		}
	}

	if o.AuthType != nil {

		// query param auth_type
		var qrAuthType string

		if o.AuthType != nil {
			qrAuthType = *o.AuthType
		}
		qAuthType := qrAuthType
		if qAuthType != "" {

			if err := r.SetQueryParam("auth_type", qAuthType); err != nil {
				return err
			}
		}
	}

	if o.AuthTypen != nil {

		// query param auth_type__n
		var qrAuthTypen string

		if o.AuthTypen != nil {
			qrAuthTypen = *o.AuthTypen
		}
		qAuthTypen := qrAuthTypen
		if qAuthTypen != "" {

			if err := r.SetQueryParam("auth_type__n", qAuthTypen); err != nil {
				return err
			}
		}
	}

	if o.Created != nil {

		// query param created
		var qrCreated string

		if o.Created != nil {
			qrCreated = *o.Created
		}
		qCreated := qrCreated
		if qCreated != "" {

			if err := r.SetQueryParam("created", qCreated); err != nil {
				return err
			}
		}
	}

	if o.CreatedGte != nil {

		// query param created__gte
		var qrCreatedGte string

		if o.CreatedGte != nil {
			qrCreatedGte = *o.CreatedGte
		}
		qCreatedGte := qrCreatedGte
		if qCreatedGte != "" {

			if err := r.SetQueryParam("created__gte", qCreatedGte); err != nil {
				return err
			}
		}
	}

	if o.CreatedLte != nil {

		// query param created__lte
		var qrCreatedLte string

		if o.CreatedLte != nil {
			qrCreatedLte = *o.CreatedLte
		}
		qCreatedLte := qrCreatedLte
		if qCreatedLte != "" {

			if err := r.SetQueryParam("created__lte", qCreatedLte); err != nil {
				return err
			}
		}
	}

	if o.Description != nil {

		// query param description
		var qrDescription string

		if o.Description != nil {
			qrDescription = *o.Description
		}
		qDescription := qrDescription
		if qDescription != "" {

			if err := r.SetQueryParam("description", qDescription); err != nil {
				return err
			}
		}
	}

	if o.DescriptionEmpty != nil {

		// query param description__empty
		var qrDescriptionEmpty string

		if o.DescriptionEmpty != nil {
			qrDescriptionEmpty = *o.DescriptionEmpty
		}
		qDescriptionEmpty := qrDescriptionEmpty
		if qDescriptionEmpty != "" {

			if err := r.SetQueryParam("description__empty", qDescriptionEmpty); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIc != nil {

		// query param description__ic
		var qrDescriptionIc string

		if o.DescriptionIc != nil {
			qrDescriptionIc = *o.DescriptionIc
		}
		qDescriptionIc := qrDescriptionIc
		if qDescriptionIc != "" {

			if err := r.SetQueryParam("description__ic", qDescriptionIc); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIe != nil {

		// query param description__ie
		var qrDescriptionIe string

		if o.DescriptionIe != nil {
			qrDescriptionIe = *o.DescriptionIe
		}
		qDescriptionIe := qrDescriptionIe
		if qDescriptionIe != "" {

			if err := r.SetQueryParam("description__ie", qDescriptionIe); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIew != nil {

		// query param description__iew
		var qrDescriptionIew string

		if o.DescriptionIew != nil {
			qrDescriptionIew = *o.DescriptionIew
		}
		qDescriptionIew := qrDescriptionIew
		if qDescriptionIew != "" {

			if err := r.SetQueryParam("description__iew", qDescriptionIew); err != nil {
				return err
			}
		}
	}

	if o.DescriptionIsw != nil {

		// query param description__isw
		var qrDescriptionIsw string

		if o.DescriptionIsw != nil {
			qrDescriptionIsw = *o.DescriptionIsw
		}
		qDescriptionIsw := qrDescriptionIsw
		if qDescriptionIsw != "" {

			if err := r.SetQueryParam("description__isw", qDescriptionIsw); err != nil {
				return err
			}
		}
	}

	if o.Descriptionn != nil {

		// query param description__n
		var qrDescriptionn string

		if o.Descriptionn != nil {
			qrDescriptionn = *o.Descriptionn
		}
		qDescriptionn := qrDescriptionn
		if qDescriptionn != "" {

			if err := r.SetQueryParam("description__n", qDescriptionn); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNic != nil {

		// query param description__nic
		var qrDescriptionNic string

		if o.DescriptionNic != nil {
			qrDescriptionNic = *o.DescriptionNic
		}
		qDescriptionNic := qrDescriptionNic
		if qDescriptionNic != "" {

			if err := r.SetQueryParam("description__nic", qDescriptionNic); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNie != nil {

		// query param description__nie
		var qrDescriptionNie string

		if o.DescriptionNie != nil {
			qrDescriptionNie = *o.DescriptionNie
		}
		qDescriptionNie := qrDescriptionNie
		if qDescriptionNie != "" {

			if err := r.SetQueryParam("description__nie", qDescriptionNie); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNiew != nil {

		// query param description__niew
		var qrDescriptionNiew string

		if o.DescriptionNiew != nil {
			qrDescriptionNiew = *o.DescriptionNiew
		}
		qDescriptionNiew := qrDescriptionNiew
		if qDescriptionNiew != "" {

			if err := r.SetQueryParam("description__niew", qDescriptionNiew); err != nil {
				return err
			}
		}
	}

	if o.DescriptionNisw != nil {

		// query param description__nisw
		var qrDescriptionNisw string

		if o.DescriptionNisw != nil {
			qrDescriptionNisw = *o.DescriptionNisw
		}
		qDescriptionNisw := qrDescriptionNisw
		if qDescriptionNisw != "" {

			if err := r.SetQueryParam("description__nisw", qDescriptionNisw); err != nil {
				return err
			}
		}
	}

	if o.ID != nil {

		// query param id
		var qrID string

		if o.ID != nil {
			qrID = *o.ID
		}
		qID := qrID
		if qID != "" {

			if err := r.SetQueryParam("id", qID); err != nil {
				return err
			}
		}
	}

	if o.IDGt != nil {

		// query param id__gt
		var qrIDGt string

		if o.IDGt != nil {
			qrIDGt = *o.IDGt
		}
		qIDGt := qrIDGt
		if qIDGt != "" {

			if err := r.SetQueryParam("id__gt", qIDGt); err != nil {
				return err
			}
		}
	}

	if o.IDGte != nil {

		// query param id__gte
		var qrIDGte string

		if o.IDGte != nil {
			qrIDGte = *o.IDGte
		}
		qIDGte := qrIDGte
		if qIDGte != "" {

			if err := r.SetQueryParam("id__gte", qIDGte); err != nil {
				return err
			}
		}
	}

	if o.IDLt != nil {

		// query param id__lt
		var qrIDLt string

		if o.IDLt != nil {
			qrIDLt = *o.IDLt
		}
		qIDLt := qrIDLt
		if qIDLt != "" {

			if err := r.SetQueryParam("id__lt", qIDLt); err != nil {
				return err
			}
		}
	}

	if o.IDLte != nil {

		// query param id__lte
		var qrIDLte string

		if o.IDLte != nil {
			qrIDLte = *o.IDLte
		}
		qIDLte := qrIDLte
		if qIDLte != "" {

			if err := r.SetQueryParam("id__lte", qIDLte); err != nil {
				return err
			}
		}
	}

	if o.IDn != nil {

		// query param id__n
		var qrIDn string

		if o.IDn != nil {
			qrIDn = *o.IDn
		}
		qIDn := qrIDn
		if qIDn != "" {

			if err := r.SetQueryParam("id__n", qIDn); err != nil {
				return err
			}
		}
	}

	if o.InterfaceaID != nil {

		// query param interface_a_id
		var qrInterfaceaID string

		if o.InterfaceaID != nil {
			qrInterfaceaID = *o.InterfaceaID
		}
		qInterfaceaID := qrInterfaceaID
		if qInterfaceaID != "" {

			if err := r.SetQueryParam("interface_a_id", qInterfaceaID); err != nil {
				return err
			}
		}
	}

	if o.InterfaceaIDGt != nil {

		// query param interface_a_id__gt
		var qrInterfaceaIDGt string

		if o.InterfaceaIDGt != nil {
			qrInterfaceaIDGt = *o.InterfaceaIDGt
		}
		qInterfaceaIDGt := qrInterfaceaIDGt
		if qInterfaceaIDGt != "" {

			if err := r.SetQueryParam("interface_a_id__gt", qInterfaceaIDGt); err != nil {
				return err
			}
		}
	}

	if o.InterfaceaIDGte != nil {

		// query param interface_a_id__gte
		var qrInterfaceaIDGte string

		if o.InterfaceaIDGte != nil {
			qrInterfaceaIDGte = *o.InterfaceaIDGte
		}
		qInterfaceaIDGte := qrInterfaceaIDGte
		if qInterfaceaIDGte != "" {

			if err := r.SetQueryParam("interface_a_id__gte", qInterfaceaIDGte); err != nil {
				return err
			}
		}
	}

	if o.InterfaceaIDLt != nil {

		// query param interface_a_id__lt
		var qrInterfaceaIDLt string

		if o.InterfaceaIDLt != nil {
			qrInterfaceaIDLt = *o.InterfaceaIDLt
		}
		qInterfaceaIDLt := qrInterfaceaIDLt
		if qInterfaceaIDLt != "" {

			if err := r.SetQueryParam("interface_a_id__lt", qInterfaceaIDLt); err != nil {
				return err
			}
		}
	}

	if o.InterfaceaIDLte != nil {

		// query param interface_a_id__lte
		var qrInterfaceaIDLte string

		if o.InterfaceaIDLte != nil {
			qrInterfaceaIDLte = *o.InterfaceaIDLte
		}
		qInterfaceaIDLte := qrInterfaceaIDLte
		if qInterfaceaIDLte != "" {

			if err := r.SetQueryParam("interface_a_id__lte", qInterfaceaIDLte); err != nil {
				return err
			}
		}
	}

	if o.InterfaceaIDn != nil {

		// query param interface_a_id__n
		var qrInterfaceaIDn string

		if o.InterfaceaIDn != nil {
			qrInterfaceaIDn = *o.InterfaceaIDn
		}
		qInterfaceaIDn := qrInterfaceaIDn
		if qInterfaceaIDn != "" {

			if err := r.SetQueryParam("interface_a_id__n", qInterfaceaIDn); err != nil {
				return err
			}
		}
	}

	if o.InterfacebID != nil {

		// query param interface_b_id
		var qrInterfacebID string

		if o.InterfacebID != nil {
			qrInterfacebID = *o.InterfacebID
		}
		qInterfacebID := qrInterfacebID
		if qInterfacebID != "" {

			if err := r.SetQueryParam("interface_b_id", qInterfacebID); err != nil {
				return err
			}
		}
	}

	if o.InterfacebIDGt != nil {

		// query param interface_b_id__gt
		var qrInterfacebIDGt string

		if o.InterfacebIDGt != nil {
			qrInterfacebIDGt = *o.InterfacebIDGt
		}
		qInterfacebIDGt := qrInterfacebIDGt
		if qInterfacebIDGt != "" {

			if err := r.SetQueryParam("interface_b_id__gt", qInterfacebIDGt); err != nil {
				return err
			}
		}
	}

	if o.InterfacebIDGte != nil {

		// query param interface_b_id__gte
		var qrInterfacebIDGte string

		if o.InterfacebIDGte != nil {
			qrInterfacebIDGte = *o.InterfacebIDGte
		}
		qInterfacebIDGte := qrInterfacebIDGte
		if qInterfacebIDGte != "" {

			if err := r.SetQueryParam("interface_b_id__gte", qInterfacebIDGte); err != nil {
				return err
			}
		}
	}

	if o.InterfacebIDLt != nil {

		// query param interface_b_id__lt
		var qrInterfacebIDLt string

		if o.InterfacebIDLt != nil {
			qrInterfacebIDLt = *o.InterfacebIDLt
		}
		qInterfacebIDLt := qrInterfacebIDLt
		if qInterfacebIDLt != "" {

			if err := r.SetQueryParam("interface_b_id__lt", qInterfacebIDLt); err != nil {
				return err
			}
		}
	}

	if o.InterfacebIDLte != nil {

		// query param interface_b_id__lte
		var qrInterfacebIDLte string

		if o.InterfacebIDLte != nil {
			qrInterfacebIDLte = *o.InterfacebIDLte
		}
		qInterfacebIDLte := qrInterfacebIDLte
		if qInterfacebIDLte != "" {

			if err := r.SetQueryParam("interface_b_id__lte", qInterfacebIDLte); err != nil {
				return err
			}
		}
	}

	if o.InterfacebIDn != nil {

		// query param interface_b_id__n
		var qrInterfacebIDn string

		if o.InterfacebIDn != nil {
			qrInterfacebIDn = *o.InterfacebIDn
		}
		qInterfacebIDn := qrInterfacebIDn
		if qInterfacebIDn != "" {

			if err := r.SetQueryParam("interface_b_id__n", qInterfacebIDn); err != nil {
				return err
			}
		}
	}

	if o.LastUpdated != nil {

		// query param last_updated
		var qrLastUpdated string

		if o.LastUpdated != nil {
			qrLastUpdated = *o.LastUpdated
		}
		qLastUpdated := qrLastUpdated
		if qLastUpdated != "" {

			if err := r.SetQueryParam("last_updated", qLastUpdated); err != nil {
				return err
			}
		}
	}

	if o.LastUpdatedGte != nil {

		// query param last_updated__gte
		var qrLastUpdatedGte string

		if o.LastUpdatedGte != nil {
			qrLastUpdatedGte = *o.LastUpdatedGte
		}
		qLastUpdatedGte := qrLastUpdatedGte
		if qLastUpdatedGte != "" {

			if err := r.SetQueryParam("last_updated__gte", qLastUpdatedGte); err != nil {
				return err
			}
		}
	}

	if o.LastUpdatedLte != nil {

		// query param last_updated__lte
		var qrLastUpdatedLte string

		if o.LastUpdatedLte != nil {
			qrLastUpdatedLte = *o.LastUpdatedLte
		}
		qLastUpdatedLte := qrLastUpdatedLte
		if qLastUpdatedLte != "" {

			if err := r.SetQueryParam("last_updated__lte", qLastUpdatedLte); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if o.Q != nil {

		// query param q
		var qrQ string

		if o.Q != nil {
			qrQ = *o.Q
		}
		qQ := qrQ
		if qQ != "" {

			if err := r.SetQueryParam("q", qQ); err != nil {
				return err
			}
		}
	}

	if o.Ssid != nil {

		// query param ssid
		var qrSsid string

		if o.Ssid != nil {
			qrSsid = *o.Ssid
		}
		qSsid := qrSsid
		if qSsid != "" {

			if err := r.SetQueryParam("ssid", qSsid); err != nil {
				return err
			}
		}
	}

	if o.SsidEmpty != nil {

		// query param ssid__empty
		var qrSsidEmpty string

		if o.SsidEmpty != nil {
			qrSsidEmpty = *o.SsidEmpty
		}
		qSsidEmpty := qrSsidEmpty
		if qSsidEmpty != "" {

			if err := r.SetQueryParam("ssid__empty", qSsidEmpty); err != nil {
				return err
			}
		}
	}

	if o.SsidIc != nil {

		// query param ssid__ic
		var qrSsidIc string

		if o.SsidIc != nil {
			qrSsidIc = *o.SsidIc
		}
		qSsidIc := qrSsidIc
		if qSsidIc != "" {

			if err := r.SetQueryParam("ssid__ic", qSsidIc); err != nil {
				return err
			}
		}
	}

	if o.SsidIe != nil {

		// query param ssid__ie
		var qrSsidIe string

		if o.SsidIe != nil {
			qrSsidIe = *o.SsidIe
		}
		qSsidIe := qrSsidIe
		if qSsidIe != "" {

			if err := r.SetQueryParam("ssid__ie", qSsidIe); err != nil {
				return err
			}
		}
	}

	if o.SsidIew != nil {

		// query param ssid__iew
		var qrSsidIew string

		if o.SsidIew != nil {
			qrSsidIew = *o.SsidIew
		}
		qSsidIew := qrSsidIew
		if qSsidIew != "" {

			if err := r.SetQueryParam("ssid__iew", qSsidIew); err != nil {
				return err
			}
		}
	}

	if o.SsidIsw != nil {

		// query param ssid__isw
		var qrSsidIsw string

		if o.SsidIsw != nil {
			qrSsidIsw = *o.SsidIsw
		}
		qSsidIsw := qrSsidIsw
		if qSsidIsw != "" {

			if err := r.SetQueryParam("ssid__isw", qSsidIsw); err != nil {
				return err
			}
		}
	}

	if o.Ssidn != nil {

		// query param ssid__n
		var qrSsidn string

		if o.Ssidn != nil {
			qrSsidn = *o.Ssidn
		}
		qSsidn := qrSsidn
		if qSsidn != "" {

			if err := r.SetQueryParam("ssid__n", qSsidn); err != nil {
				return err
			}
		}
	}

	if o.SsidNic != nil {

		// query param ssid__nic
		var qrSsidNic string

		if o.SsidNic != nil {
			qrSsidNic = *o.SsidNic
		}
		qSsidNic := qrSsidNic
		if qSsidNic != "" {

			if err := r.SetQueryParam("ssid__nic", qSsidNic); err != nil {
				return err
			}
		}
	}

	if o.SsidNie != nil {

		// query param ssid__nie
		var qrSsidNie string

		if o.SsidNie != nil {
			qrSsidNie = *o.SsidNie
		}
		qSsidNie := qrSsidNie
		if qSsidNie != "" {

			if err := r.SetQueryParam("ssid__nie", qSsidNie); err != nil {
				return err
			}
		}
	}

	if o.SsidNiew != nil {

		// query param ssid__niew
		var qrSsidNiew string

		if o.SsidNiew != nil {
			qrSsidNiew = *o.SsidNiew
		}
		qSsidNiew := qrSsidNiew
		if qSsidNiew != "" {

			if err := r.SetQueryParam("ssid__niew", qSsidNiew); err != nil {
				return err
			}
		}
	}

	if o.SsidNisw != nil {

		// query param ssid__nisw
		var qrSsidNisw string

		if o.SsidNisw != nil {
			qrSsidNisw = *o.SsidNisw
		}
		qSsidNisw := qrSsidNisw
		if qSsidNisw != "" {

			if err := r.SetQueryParam("ssid__nisw", qSsidNisw); err != nil {
				return err
			}
		}
	}

	if o.Status != nil {

		// query param status
		var qrStatus string

		if o.Status != nil {
			qrStatus = *o.Status
		}
		qStatus := qrStatus
		if qStatus != "" {

			if err := r.SetQueryParam("status", qStatus); err != nil {
				return err
			}
		}
	}

	if o.Statusn != nil {

		// query param status__n
		var qrStatusn string

		if o.Statusn != nil {
			qrStatusn = *o.Statusn
		}
		qStatusn := qrStatusn
		if qStatusn != "" {

			if err := r.SetQueryParam("status__n", qStatusn); err != nil {
				return err
			}
		}
	}

	if o.Tag != nil {

		// query param tag
		var qrTag string

		if o.Tag != nil {
			qrTag = *o.Tag
		}
		qTag := qrTag
		if qTag != "" {

			if err := r.SetQueryParam("tag", qTag); err != nil {
				return err
			}
		}
	}

	if o.Tagn != nil {

		// query param tag__n
		var qrTagn string

		if o.Tagn != nil {
			qrTagn = *o.Tagn
		}
		qTagn := qrTagn
		if qTagn != "" {

			if err := r.SetQueryParam("tag__n", qTagn); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
